SystemOrganization addCategory: #'XML-Parser'!
SystemOrganization addCategory: 'XML-Parser-DOM'!
SystemOrganization addCategory: 'XML-Parser-DTD'!
SystemOrganization addCategory: 'XML-Parser-DTD-Standalone'!
SystemOrganization addCategory: 'XML-Parser-Drivers'!
SystemOrganization addCategory: 'XML-Parser-Exceptions'!
SystemOrganization addCategory: 'XML-Parser-Files'!
SystemOrganization addCategory: 'XML-Parser-HTTP'!
SystemOrganization addCategory: 'XML-Parser-Namespaces'!
SystemOrganization addCategory: 'XML-Parser-Streams'!
SystemOrganization addCategory: 'XML-Parser-URI'!
SystemOrganization addCategory: 'XML-Parser-Utils'!
SystemOrganization addCategory: 'XML-Parser-Validation'!
SystemOrganization addCategory: 'XML-Parser-Validation-DFA'!
SystemOrganization addCategory: 'XML-Parser-Validation-Standalone'!

!Collection methodsFor: '*XML-Parser' stamp: 'monty 6/30/2017 22:47'!
asXMLAttributeDictionary
	^ XMLAttributeDictionary newFrom: self! !

!Collection methodsFor: '*XML-Parser' stamp: 'monty 8/26/2016 02:16'!
asXMLAttributeSpec
	^ XMLBasicAttributeSpec attributes: self! !

!Collection methodsFor: '*XML-Parser' stamp: 'monty 4/15/2016 02:07'!
includesXMLName: aName
	"optimized with do: instead of anySatisfy:"
	self do: [:each |
		(aName isXMLQualifiedOrLocalName: each)
			ifTrue: [^ true]].
	^ false.! !

Collection subclass: #XMLLazyAttributeDictionary
	instanceVariableNames: 'attributeDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

XMLLazyAttributeDictionary class
	instanceVariableNames: 'emptyAttributeDictionary'!

!XMLLazyAttributeDictionary commentStamp: 'monty 9/20/2017 09:07' prior: 0!
A lazy version of XMLAttributeDictionary that uses less memory until it's modified.!

XMLLazyAttributeDictionary class
	instanceVariableNames: 'emptyAttributeDictionary'!

!XMLLazyAttributeDictionary class methodsFor: 'private' stamp: 'monty 9/9/2017 01:32'!
emptyAttributeDictionary
	^ emptyAttributeDictionary! !

!XMLLazyAttributeDictionary class methodsFor: 'private' stamp: 'monty 6/26/2017 00:28'!
emptyAttributeDictionaryClass
	^ XMLAttributeDictionary! !

!XMLLazyAttributeDictionary class methodsFor: 'class initialization' stamp: 'monty 9/9/2017 01:37'!
initialize
	"self initialize"

	self initializeEmptyAttributeDictionary! !

XMLLazyAttributeDictionary initialize!

!XMLLazyAttributeDictionary class methodsFor: 'class initialization' stamp: 'monty 9/9/2017 01:40'!
initializeEmptyAttributeDictionary
	"explictly initialized class inst vars are used for the empty
	dictionaries to simplify class initialization (on GS) and to
	speed up lazy dictionary instance creation"
	emptyAttributeDictionary := self emptyAttributeDictionaryClass new! !

!XMLLazyAttributeDictionary class methodsFor: 'instance creation' stamp: 'monty 9/9/2017 01:33'!
new
	^ self basicNew setAttributeDictionary: emptyAttributeDictionary! !

!XMLLazyAttributeDictionary class methodsFor: 'instance creation' stamp: 'monty 6/26/2017 00:15'!
new: aCapacity
	^ self new! !

!XMLLazyAttributeDictionary class methodsFor: 'instance creation' stamp: 'monty 6/26/2017 00:20'!
newFrom: anAssociationCollection
	^ self basicNew setAttributeDictionary:
		(self emptyAttributeDictionaryClass newFrom:
			anAssociationCollection)! !

!XMLLazyAttributeDictionary class methodsFor: 'instance creation' stamp: 'monty 6/26/2017 00:20'!
newFromPairs: aSequenceableCollection
	^ self basicNew setAttributeDictionary:
		(self emptyAttributeDictionaryClass newFromPairs:
			aSequenceableCollection)! !

!XMLLazyAttributeDictionary methodsFor: 'comparing' stamp: 'monty 6/26/2017 00:20'!
= anObject
	^ attributeDictionary = anObject! !

!XMLLazyAttributeDictionary methodsFor: 'adding' stamp: 'monty 6/26/2017 00:19'!
add: anAssociation
	^ self copiedAttributeDictionary add: anAssociation! !

!XMLLazyAttributeDictionary methodsFor: 'adding' stamp: 'monty 6/26/2017 00:19'!
addAll: anAssociationCollection
	^ self copiedAttributeDictionary addAll: anAssociationCollection! !

!XMLLazyAttributeDictionary methodsFor: 'converting' stamp: 'monty 6/30/2017 22:46'!
asXMLAttributeDictionary
	^ self! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
associationAt: aKey
	^ attributeDictionary associationAt: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
associationAt: aKey ifAbsent: aBlock
	^ attributeDictionary
		associationAt: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
associationAt: aKey ifPresent: aBlock
	^ attributeDictionary
		associationAt: aKey
		ifPresent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/25/2017 10:53'!
associationAtName: aQualifiedOrLocalName
	^ attributeDictionary associationAtName: aQualifiedOrLocalName! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/25/2017 10:53'!
associationAtName: aKey ifAbsent: aBlock
	^ attributeDictionary
		associationAtName: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 7/12/2017 10:14'!
associationAtName: aQualifiedOrLocalName namespaceURI: aURI
	^ attributeDictionary
		associationAtName: aQualifiedOrLocalName
		namespaceURI: aURI! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 7/12/2017 10:14'!
associationAtName: aKey namespaceURI: aURI ifAbsent: aBlock
	^ attributeDictionary
		associationAtName: aKey
		namespaceURI: aURI
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
associations
	^ attributeDictionary associations! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
associationsDo: aBlock
	attributeDictionary associationsDo: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
associationsSelect: aBlock
	^ self copyEmpty setAttributeDictionary:
		(attributeDictionary associationsSelect: aBlock)! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
at: aKey
	^ attributeDictionary at: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
at: aKey ifAbsent: aBlock
	^ attributeDictionary
		at: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:19'!
at: aKey ifAbsentPut: aBlock
	^ self copiedAttributeDictionary
		at: aKey
		ifAbsentPut: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
at: aKey ifPresent: aBlock
	^ attributeDictionary
		at: aKey
		ifPresent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
at: aKey ifPresent: aPresentBlock ifAbsent: anAbsentBlock
	^ attributeDictionary
		at: aKey
		ifPresent: aPresentBlock
		ifAbsent: anAbsentBlock! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 7/10/2017 06:23'!
at: aKey newPut: aValue
	"added to be consistent with XMLAttributeDictionary,
	but it shouldn't be needed"
	^ self copiedAttributeDictionary
		at: aKey
		newPut: aValue! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:19'!
at: aKey put: aValue
	^ self copiedAttributeDictionary
		at: aKey
		put: aValue! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/25/2017 10:53'!
atName: aQualifiedOrLocalName
	^ attributeDictionary atName: aQualifiedOrLocalName! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/25/2017 10:53'!
atName: aQualifiedOrLocalName ifAbsent: aBlock
	^ attributeDictionary
		atName: aQualifiedOrLocalName
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/27/2017 06:14'!
atName: aQualifiedOrLocalName namespaceURI: aURI
	^ attributeDictionary
		atName: aQualifiedOrLocalName
		namespaceURI: aURI! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/27/2017 06:14'!
atName: aQualifiedOrLocalName namespaceURI: aURI ifAbsent: aBlock
	^ attributeDictionary
		atName: aQualifiedOrLocalName
		namespaceURI: aURI
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/26/2017 00:20'!
attributeDictionary
	^ attributeDictionary! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
capacity
	^ attributeDictionary capacity! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
collect: aBlock
	^ self copyEmpty setAttributeDictionary:
		(attributeDictionary collect: aBlock)! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/27/2017 06:33'!
copiedAttributeDictionary
	"replaces the shared, empty order-preserving dictionary with a new
	mutable one ready for modification"
	^ attributeDictionary == self emptyAttributeDictionary
		ifTrue: [attributeDictionary := self copyEmptyAttributeDictionary]
		ifFalse: [attributeDictionary]! !

!XMLLazyAttributeDictionary methodsFor: 'copying' stamp: 'monty 6/26/2017 00:18'!
copyEmpty
	"Squeak and GS don't have Collection>>#copyEmpty:, so it is
	reimplemented for portability"
	^ self species new! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/27/2017 06:33'!
copyEmptyAttributeDictionary
	^ attributeDictionary copy! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/26/2017 00:20'!
dictionary
	^ attributeDictionary dictionary! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
dictionaryClass
	^ attributeDictionary dictionaryClass! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
do: aBlock
	attributeDictionary do: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/26/2017 00:18'!
emptyAttributeDictionary
	^ self class emptyAttributeDictionary! !

!XMLLazyAttributeDictionary methodsFor: 'comparing' stamp: 'monty 6/26/2017 00:20'!
hash
	^ attributeDictionary hash! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
identityIndexOfKey: aKey
	^ attributeDictionary identityIndexOfKey: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
identityIndexOfKey: aKey ifAbsent: aBlock
	^ attributeDictionary
		identityIndexOfKey: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:20'!
includesAssociation: anAssociation
	^ attributeDictionary includesAssociation: anAssociation! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:20'!
includesIdentity: anObject
	^ attributeDictionary includesIdentity: anObject! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:20'!
includesKey: aKey
	^ attributeDictionary includesKey: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
indexOfKey: aKey
	^ attributeDictionary indexOfKey: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
indexOfKey: aKey ifAbsent: aBlock
	^ attributeDictionary
		indexOfKey: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:19'!
isDictionary
	^ true! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:20'!
isEmpty
	"Squeak's Collection>>#isEmpty is inefficient"
	^ attributeDictionary isEmpty! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:20'!
isIdentityDictionary
	^ attributeDictionary isIdentityDictionary! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 6/26/2017 00:19'!
isOrderPreservingDictionary
	^ true! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtIdentityValue: aValue
	^ attributeDictionary keyAtIdentityValue: aValue! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtIdentityValue: aValue ifAbsent: aBlock
	^ attributeDictionary
		keyAtIdentityValue: aValue
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtIndex: anIndex
	^ attributeDictionary keyAtIndex: anIndex! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtIndex: anIndex ifAbsent: aBlock
	^ attributeDictionary
		keyAtIndex: anIndex
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtValue: anObject
	^ attributeDictionary keyAtValue: anObject! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyAtValue: anObject ifAbsent: aBlock
	^ attributeDictionary
		keyAtValue: anObject
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keyForIdentity: anObject
	^ attributeDictionary keyForIdentity: anObject! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keys
	^ attributeDictionary keys! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
keysAndValuesDo: aBlock
	attributeDictionary keysAndValuesDo: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:19'!
keysAndValuesRemove: aTwoArgumentBlock
	self copiedAttributeDictionary keysAndValuesRemove: aTwoArgumentBlock! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
keysDo: aBlock
	attributeDictionary keysDo: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
keysSortedSafely
	^ attributeDictionary keysSortedSafely! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/27/2017 06:15'!
namespaceScope
	^ attributeDictionary namespaceScope! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/28/2017 22:39'!
namespaceURIOf: aKey
	^ attributeDictionary namespaceURIOf: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 6/26/2017 00:20'!
orderedKeys
	^ attributeDictionary orderedKeys! !

!XMLLazyAttributeDictionary methodsFor: 'copying' stamp: 'monty 6/26/2017 00:20'!
postCopy
	attributeDictionary == self emptyAttributeDictionary
		ifFalse: [attributeDictionary := attributeDictionary copy]! !

!XMLLazyAttributeDictionary methodsFor: 'printing' stamp: 'monty 6/26/2017 00:20'!
printElementsOn: aStream
	attributeDictionary printElementsOn: aStream! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:18'!
remove: anObject ifAbsent: aBlock
	self shouldNotImplement! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:20'!
removeAll
	attributeDictionary := self emptyAttributeDictionary! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:19'!
removeKey: aKey
	^ self copiedAttributeDictionary removeKey: aKey! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:19'!
removeKey: aKey ifAbsent: aBlock
	^ self copiedAttributeDictionary
		removeKey: aKey
		ifAbsent: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'removing' stamp: 'monty 6/26/2017 00:19'!
removeKeys: aKeyCollection
	self copiedAttributeDictionary removeKeys: aKeyCollection! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:32'!
resolvePrefix: aPrefix
	^ attributeDictionary resolvePrefix: aPrefix! !

!XMLLazyAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:32'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	^ attributeDictionary
		resolvePrefix: aPrefix
		ifUnresolvable: aBlock! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
select: aBlock
	^ self copyEmpty setAttributeDictionary:
		(attributeDictionary select: aBlock)! !

!XMLLazyAttributeDictionary methodsFor: 'initialization' stamp: 'monty 6/26/2017 00:20'!
setAttributeDictionary: anAttributeDictionary
	attributeDictionary := anAttributeDictionary! !

!XMLLazyAttributeDictionary methodsFor: 'initialization' stamp: 'monty 7/2/2017 02:06'!
setNamespaceScope: aNamespaceScope! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
size
	^ attributeDictionary size! !

!XMLLazyAttributeDictionary methodsFor: 'testing' stamp: 'monty 10/2/2017 17:31'!
usesNamespaces
	^ attributeDictionary usesNamespaces! !

!XMLLazyAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:20'!
values
	^ attributeDictionary values! !

!XMLLazyAttributeDictionary methodsFor: 'enumerating' stamp: 'monty 6/26/2017 00:20'!
valuesDo: aBlock
	attributeDictionary valuesDo: aBlock! !

XMLLazyAttributeDictionary subclass: #XMLLazyNamespacedAttributeDictionary
	instanceVariableNames: 'namespaceScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLLazyNamespacedAttributeDictionary commentStamp: 'monty 9/20/2017 09:07' prior: 0!
A lazy version of XMLNamespacedAttributeDictionary that uses less memory until it's modified.!

!XMLLazyNamespacedAttributeDictionary class methodsFor: 'private' stamp: 'monty 6/26/2017 00:29'!
emptyAttributeDictionaryClass
	^ XMLNamespacedAttributeDictionary! !

!XMLLazyNamespacedAttributeDictionary class methodsFor: 'class initialization' stamp: 'monty 9/9/2017 01:37'!
initialize
	"self initialize"

	self initializeEmptyAttributeDictionary! !

XMLLazyNamespacedAttributeDictionary initialize!

!XMLLazyNamespacedAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:42'!
copyEmptyAttributeDictionary
	^ super copyEmptyAttributeDictionary setNamespaceScope: self namespaceScope! !

!XMLLazyNamespacedAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:36'!
namespaceScope
	^ namespaceScope
		ifNil: [
			namespaceScope :=
				attributeDictionary == self emptyAttributeDictionary
					ifTrue: [XMLNamespaceScope new]
					ifFalse: [attributeDictionary namespaceScope]]! !

!XMLLazyNamespacedAttributeDictionary methodsFor: 'initialization' stamp: 'monty 7/2/2017 02:06'!
setNamespaceScope: aNamespaceScope
	namespaceScope := aNamespaceScope! !

Collection subclass: #XMLNFAStateSet
	instanceVariableNames: 'set isAccepting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFAStateSet commentStamp: 'monty 1/24/2014 22:44' prior: 0!
This class is a set of NFA states. It wraps an IdentitySet and keeps track of if any of its states is accepting.!

!XMLNFAStateSet class methodsFor: 'instance creation' stamp: 'monty 12/11/2014 05:39'!
new
	^ self new: 5! !

!XMLNFAStateSet class methodsFor: 'instance creation' stamp: 'monty 12/11/2014 05:39'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XMLNFAStateSet class methodsFor: 'instance creation' stamp: 'monty 3/29/2016 07:11'!
newFrom: aCollection
	"for GS portability"
	^ self withAll: aCollection! !

!XMLNFAStateSet methodsFor: 'copying' stamp: 'monty 9/28/2016 22:38'!
, aCollection
	"GS doesn't define #, for non-Sequenceable collections"
	^ self copy
		addAll: aCollection;
		yourself! !

!XMLNFAStateSet methodsFor: 'comparing' stamp: 'monty 3/29/2016 06:53'!
= anObject
	self == anObject
		ifTrue: [^ true].

	(self species == anObject species
		and: [self size = anObject size])
		ifFalse: [^ false].

	"avoid allSatisfy: for speed"
	self do: [:each |
		(anObject includes: each)
			ifFalse: [^ false]].
	^ true.! !

!XMLNFAStateSet methodsFor: 'adding' stamp: 'monty 12/28/2013 18:52'!
add: aState
	isAccepting
		ifFalse: [isAccepting := aState isAccepting].

	^ set add: aState.! !

!XMLNFAStateSet methodsFor: 'converting' stamp: 'monty 4/25/2015 15:15'!
asDFAState
	^ self asDFAStateWithStateCache: nil! !

!XMLNFAStateSet methodsFor: 'converting' stamp: 'monty 4/16/2015 01:12'!
asDFAStateWithStateCache: aDFAStateCache
	^ XMLDFAState
		nfaStates: self
		dfaStateCache: aDFAStateCache! !

!XMLNFAStateSet methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:17'!
capacity
	^ set capacity! !

!XMLNFAStateSet methodsFor: 'enumerating' stamp: 'monty 12/28/2013 18:47'!
do: aBlock
	set do: aBlock! !

!XMLNFAStateSet methodsFor: 'comparing' stamp: 'monty 3/29/2016 07:00'!
hash
	| hash |

	hash := self species hash.
	self size > 5
		ifFalse: [
			self do: [:each | hash := hash bitXor: each hash]].
	^ hash bitXor: self size hash.! !

!XMLNFAStateSet methodsFor: 'testing' stamp: 'monty 12/28/2013 18:48'!
includes: aState
	^ set includes: aState! !

!XMLNFAStateSet methodsFor: 'initialization' stamp: 'monty 12/11/2014 05:39'!
initialize: aCapacity
	set := IdentitySet new: aCapacity.
	isAccepting := false.! !

!XMLNFAStateSet methodsFor: 'testing' stamp: 'monty 12/28/2013 18:53'!
isAccepting
	^ isAccepting! !

!XMLNFAStateSet methodsFor: 'testing' stamp: 'monty 2/14/2017 01:28'!
isEmpty
	"Squeak's Collection>>#isEmpty is inefficient"
	^ self size = 0! !

!XMLNFAStateSet methodsFor: 'copying' stamp: 'monty 3/29/2016 08:09'!
postCopy
	set := set copy! !

!XMLNFAStateSet methodsFor: 'removing' stamp: 'monty 3/29/2016 08:28'!
remove: aState ifAbsent: aBlock
	set
		remove: aState
		ifAbsent: [^ aBlock value].

	isAccepting
		ifTrue: [isAccepting := set anySatisfy: [:each | each isAccepting]].

	^ aState.! !

!XMLNFAStateSet methodsFor: 'removing' stamp: 'monty 2/26/2017 09:30'!
removeAll
	"Redefined because Collection>>#removeAll assumes the collection can
	be safely modified while iterating it with #do:, and 'set removeAll'
	is not used because GS's Set/IdentitySet don't implement it"

	self initialize: self capacity! !

!XMLNFAStateSet methodsFor: 'private' stamp: 'monty 12/28/2013 18:50'!
set
	^ set! !

!XMLNFAStateSet methodsFor: 'accessing' stamp: 'monty 12/28/2013 19:01'!
size
	^ set size! !

Collection subclass: #XMLOrderedList
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLOrderedList commentStamp: 'monty 6/15/2015 22:15' prior: 0!
This class functions as an OrderedCollection that will not raise exceptions when attempts are made to access absent objects. This means messages like #at:, #after:, and #first will return nil when the requested object cannot be retrieved. Messages that modify the collection will still raise exceptions as usual.

!

XMLOrderedList subclass: #XMLObservableList
	instanceVariableNames: 'observer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLObservableList commentStamp: 'monty 3/29/2016 06:02' prior: 0!
This class is an ordered list that sends notifications to an observer when objects are added to it or removed from it. Subclasses should override the #beforeAdding:, #afterAdding:at:, #afterAddingLast: and #afterRemoving: messages to send custom notifications.!

XMLObservableList subclass: #XMLAttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLAttributeList commentStamp: 'monty 9/8/2016 12:04' prior: 0!
This class represents an ordered list of attribute nodes. It is not the default attribute list class, but it can be used by injecting it into a DOM parser before parsing:
	(parser := XMLDOMParser on: xmlSource)
		nodeFactory:
			(XMLPluggableNodeFactory new
				attributeListClass: XMLAttributeList);
		parseDocument.

It should be used over the default class when you want to reduce memory use at the cost of slower attribute lookup.!

!XMLAttributeList class methodsFor: 'instance creation' stamp: 'monty 4/16/2015 01:05'!
new
	^ self new: 5! !

!XMLAttributeList methodsFor: 'adding' stamp: 'monty 3/2/2016 15:53'!
addAttributeAssociation: anAssociation
	^ self
		addAttributeName: anAssociation key
		value: anAssociation value! !

!XMLAttributeList methodsFor: 'adding' stamp: 'monty 3/2/2016 15:51'!
addAttributeName: aName value: aValue
	^ self addLast:
		(self attributeClass
			name: aName
			value: aValue)! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	(self
		removeDuplicateOf: aNode
		notAt: anIndex)
		ifNotNil: [:duplicate |
			duplicate = aNode
				ifTrue: [^ self]].
	observer
		ifNotNil: [observer addedAttribute: aNode].! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	(self
		removeDuplicateOf: aNode
		notAt: self size)
		ifNotNil: [:duplicate |
			duplicate = aNode
				ifTrue: [^ self]].
	observer
		ifNotNil: [observer addedAttribute: aNode].! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/21/2017 00:17'!
afterAddingToCopyLast: aNode
	observer
		ifNotNil: [observer addedAttribute: aNode]! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 9/2/2016 06:03'!
afterRemoving: aNode
	observer
		ifNotNil: [observer removedAttribute: aNode].! !

!XMLAttributeList methodsFor: 'converting' stamp: 'monty 4/6/2016 22:33'!
asDictionary
	^ self attributes! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 11/6/2014 15:43'!
attributeAssociations
	^ self collect: [:each | each name -> each value]! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/6/2016 22:47'!
attributeAt: aName
	^ self attributeValueAt: aName! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/6/2016 22:47'!
attributeAt: aName ifAbsent: aBlock
	^ self
		attributeValueAt: aName
		ifAbsent: aBlock! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/6/2016 22:47'!
attributeAt: aName ifAbsentPut: aBlock
	^ self
		attributeValueAt: aName
		ifAbsentPut: aBlock! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/6/2016 22:47'!
attributeAt: aName put: aValue
	^ self
		attributeValueAt: aName
		put: aValue! !

!XMLAttributeList methodsFor: 'defaults' stamp: 'monty 8/27/2016 18:55'!
attributeClass
	"Can be overridden in subclasses to use a custom attribute class"

	^ XMLAttribute
! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 10/28/2014 14:14'!
attributeNames
	^ self collect: [:each | each name]! !

!XMLAttributeList methodsFor: 'enumerating' stamp: 'monty 3/2/2016 18:21'!
attributeNamesAndValuesDo: aTwoArgumentBlock
	self do: [:each |
		aTwoArgumentBlock
			value: each name
			value: each value]! !

!XMLAttributeList methodsFor: 'enumerating' stamp: 'monty 10/28/2014 14:15'!
attributeNamesDo: aBlock
	self do: [:each | aBlock value: each name]! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 3/2/2016 18:21'!
attributeNodeAt: aName
	^ self
		attributeNodeAt: aName
		ifAbsent: [self defaultValue]! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/18/2016 09:02'!
attributeNodeAt: aName ifAbsent: aBlock
	self do: [:each |
		(each isNamed: aName)
			ifTrue: [^ each]].
	^ aBlock value.! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/6/2016 21:53'!
attributeNodeAt: aName namespaceURI: aURI
	^ self
		attributeNodeAt: aName
		namespaceURI: aURI
		ifAbsent: [self defaultValue]! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 4/18/2016 09:04'!
attributeNodeAt: aName namespaceURI: aURI ifAbsent: aBlock
	self do: [:each |
		((each isNamed: aName)
			and: [each namespaceURI = aURI])
			ifTrue: [^ each]].
	^ aBlock value.! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 4/6/2016 22:45'!
attributeValueAt: aName
	^ self
		attributeValueAt: aName
		ifAbsent: ['']! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/11/2018 15:33'!
attributeValueAt: aName ifAbsent: aBlock
	| i |

	^ (i := self indexOfAttribute: aName) > 0
		ifTrue: [(self at: i) value]
		ifFalse: [aBlock value]! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/12/2018 00:52'!
attributeValueAt: aName ifAbsentPut: aBlock
	^ self
		attributeValueAt: aName
		ifAbsent: [
			"use #addToCopyLast:, since we know it's not in the collection"
			(self addToCopyLast:
				(self attributeClass
					name: aName
					value: aBlock value)) value]! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/12/2018 10:47'!
attributeValueAt: aName put: aValue
	| i |

	(i := self indexOfAttribute: aName) > 0
		ifTrue: [(self at: i) value: aValue]
		ifFalse: [
			"use #addToCopyLast: since we know it's not already in the collection"
			self addToCopyLast:
				(self attributeClass
					name: aName
					value: aValue)].
	^ aValue.! !

!XMLAttributeList methodsFor: 'accessing' stamp: 'monty 8/27/2016 18:53'!
attributes
	| dictionary |

	dictionary := self attributesClass new: self size.
	self do: [:each |
		dictionary
			at: each name
			put: each value].
	^ dictionary.! !

!XMLAttributeList methodsFor: 'defaults' stamp: 'monty 7/2/2017 02:09'!
attributesClass
	"Can be overridden in subclasses to use a custom collection
	class for #attributes to use when returning attribute associations"

	^ OrderPreservingStringDictionary! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
duplicateIndexOf: aNode notAt: anIndex
	"like the superclass version, but it considers nodes with
	the same name to be duplicates"
	1 to: anIndex - 1 do: [:i | | node |
		(node := collection at: i) name = aNode name
			ifTrue: [^ i]].

	anIndex + 1 to: collection size do: [:i | | node |
		(node := collection at: i) name = aNode name
			ifTrue: [^ i]].

	^ 0.! !

!XMLAttributeList methodsFor: 'testing' stamp: 'monty 9/5/2016 07:13'!
includesAttribute: aName
	^ (self indexOfAttribute: aName) > 0! !

!XMLAttributeList methodsFor: 'testing' stamp: 'monty 4/19/2016 10:33'!
includesAttributeNode: aName
	self
		attributeNodeAt: aName
		ifAbsent: [^ false].
	^ true.! !

!XMLAttributeList methodsFor: 'testing' stamp: 'monty 4/19/2016 10:34'!
includesAttributeNode: aName namespaceURI: aURI
	self
		attributeNodeAt: aName
		namespaceURI: aURI
		ifAbsent: [^ false].
	^ true.! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/12/2018 10:26'!
indexOfAttribute: aName
	"Returns the index of the attribute with the exact name of aName"

	"to:do: for speed, because this is used for attribute lookup"
	1 to: collection size do: [:i | | node |
		(node := collection at: i) name = aName
			ifTrue: [^ i]].
	^ 0.! !

!XMLAttributeList methodsFor: 'removing' stamp: 'monty 9/2/2016 06:17'!
removeAttribute: aName
	^ (self removeAt: (self indexOfAttribute: aName)) value! !

!XMLAttributeList methodsFor: 'removing' stamp: 'monty 9/2/2016 06:18'!
removeAttribute: aName ifAbsent: aBlock
	| i |

	(i := self indexOfAttribute: aName) > 0
		ifTrue: [^ (self removeAt: i) value]
		ifFalse: [^ aBlock value].! !

!XMLAttributeList methodsFor: 'notifying' stamp: 'monty 9/6/2016 00:04'!
renamedAttribute: anAttribute from: anOldName to: aNewName
	self
		removeDuplicateOf: anAttribute
		notAt: (self indexOf: anAttribute)! !

!XMLAttributeList methodsFor: 'initialization' stamp: 'monty 4/6/2016 22:35'!
setAttributes: anAssociationCollection
	self removeAll.
	anAssociationCollection associationsDo: [:each |
		self addAttributeAssociation: each].! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:58'!
setAttributesFromOrderPreservingDictionary: anOrderPreservingDictionary
	"This should only be sent by DOM parsers/builders, not public API users"
	| orderedKeys |

	"Add the XMLAttributes in order directly to the collection to avoid
	sending notifications that would do unneeded, costly namespace prefix
	revalidation.
	Use the internal #orderedKeys with #to:do: to create an inlined #keysDo:
	without block closure overhead."
	orderedKeys := anOrderPreservingDictionary orderedKeys.
	1 to: anOrderPreservingDictionary size do: [:i | | key |
		key := orderedKeys at: i.
		collection addLast: 
			(self attributeClass new
				setName: key
				value:
					"use dictionary at:ifAbsent: for speed over at:"
					(anOrderPreservingDictionary
						at: key
						ifAbsent: nil)
				element: observer)].! !

!XMLAttributeList methodsFor: 'sorting' stamp: 'monty 12/2/2014 23:05'!
sort
	self sort: [:a :b | a sortKey <= b sortKey]! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 4/7/2017 22:51'!
writeAttributesOn: aWriter
	"use #to:do: with direct access for fast writing"
	1 to: collection size do: [:i | | attribute |
		attribute := collection at: i.
		aWriter
			writeAttributeName: attribute name
			value: attribute value]! !

!XMLAttributeList methodsFor: 'private' stamp: 'monty 2/25/2017 03:29'!
writeCanonicalAttributesOn: aWriter
	| sortedAttributes |

	(sortedAttributes := self asArray) sort: [:a :b | | prefixOfA prefixOfB |
		prefixOfA := a prefix.
		prefixOfB := b prefix.
		prefixOfA = prefixOfB
			ifTrue: [
				(a name xmlLocalNameAfterPrefix: prefixOfA)
					<= (b name xmlLocalNameAfterPrefix: prefixOfB)]
			ifFalse: [| uriOfA uriOfB |
				"the namespace URI is the primary key and
				the local name is the secondary key"
				uriOfA := a resolvePrefix: prefixOfA.
				uriOfB := b resolvePrefix: prefixOfB.
				uriOfA < uriOfB
					or: [
						uriOfA = uriOfB
							and: [
								(a name xmlLocalNameAfterPrefix: prefixOfA)
									<= (b name xmlLocalNameAfterPrefix: prefixOfB)]]]].

	"use to:do: for fast writing"
	1 to: sortedAttributes size do: [:i | | attribute |
		attribute := sortedAttributes at: i.
		aWriter
			writeAttributeName: attribute name
			value: attribute value].! !

XMLAttributeList subclass: #XMLCachingAttributeList
	instanceVariableNames: 'attributeNodesByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLCachingAttributeList commentStamp: 'monty 9/8/2016 11:57' prior: 0!
This class represents an ordered list of attribute nodes that also keeps a dictionary mapping attribute names to nodes for faster lookup.

This is the default attribute list class.!

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	self attributeNodesByName
		at: aNode name ifPresent: [:duplicate |
			self
				removeDuplicateOf: aNode
				notAt: anIndex.
			duplicate = aNode
				ifTrue: [^ self]];
		at: aNode name put: aNode.
	observer
		ifNotNil: [observer addedAttribute: aNode].! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	self attributeNodesByName
		at: aNode name ifPresent: [:duplicate |
			self
				removeDuplicateOf: aNode
				notAt: self size.
			duplicate = aNode
				ifTrue: [^ self]];
		at: aNode name put: aNode.
	observer
		ifNotNil: [observer addedAttribute: aNode].! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 2/21/2017 00:18'!
afterAddingToCopyLast: aNode
	self attributeNodesByName
		at: aNode name
		put: aNode.
	observer
		ifNotNil: [observer addedAttribute: aNode].! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/2/2016 05:47'!
afterRemoving: aNode
	self attributeNodesByName removeKey: aNode name.
	observer
		ifNotNil: [observer removedAttribute: aNode].! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/2/2016 05:46'!
attributeNodesByName
	^ attributeNodesByName
		ifNil: [attributeNodesByName := Dictionary new: self capacity]! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/2/2016 05:48'!
attributeValueAt: aName ifAbsent: aBlock
	^ (self attributeNodesByName
		at: aName
		ifAbsent: [^ aBlock value]) value! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 2/12/2018 00:57'!
attributeValueAt: aName put: aValue
	(self attributeNodesByName
		at: aName
		ifAbsent: [
			"use #addToCopyLast: since we know it's not already in the collection"
			self addToCopyLast:
				(self attributeClass
					name: aName
					value: aValue).
			^ aValue]) value: aValue.
	^ aValue.! !

!XMLCachingAttributeList methodsFor: 'defaults' stamp: 'monty 2/26/2017 09:28'!
copyClass
	"use the non-caching superclass for copies for performance"
	^ XMLAttributeList! !

!XMLCachingAttributeList methodsFor: 'testing' stamp: 'monty 9/2/2016 05:48'!
includes: aNode
	^ aNode isAttribute
		and: [
			(self attributeNodesByName
				at: aNode name
				ifAbsent: [^ false]) = aNode]! !

!XMLCachingAttributeList methodsFor: 'testing' stamp: 'monty 9/2/2016 05:48'!
includesAttribute: aName
	^ self attributeNodesByName includesKey: aName! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 2/11/2018 15:39'!
indexOfAttribute: aName
	^ (self attributeNodesByName includesKey: aName)
		ifTrue: [super indexOfAttribute: aName]
		ifFalse: [0]! !

!XMLCachingAttributeList methodsFor: 'removing' stamp: 'monty 9/2/2016 05:48'!
removeAttribute: aName
	^ (self remove: (self attributeNodesByName at: aName)) value! !

!XMLCachingAttributeList methodsFor: 'removing' stamp: 'monty 9/2/2016 05:48'!
removeAttribute: aName ifAbsent: aBlock
	^ (self remove:
		(self attributeNodesByName
			at: aName
			ifAbsent: [^ aBlock value])) value! !

!XMLCachingAttributeList methodsFor: 'notifying' stamp: 'monty 9/6/2016 00:04'!
renamedAttribute: anAttribute from: anOldName to: aNewName
	self attributeNodesByName
		removeKey: anOldName;
		at: aNewName ifPresent: [:duplicate |
			self
				removeDuplicateOf: anAttribute
				notAt: (self indexOf: anAttribute)];
		at: aNewName put: anAttribute! !

!XMLCachingAttributeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:59'!
setAttributesFromOrderPreservingDictionary: anOrderPreservingDictionary
	"This should only be sent by DOM parsers/builders, not public API users"
	| orderedKeys |

	"Hack to reuse its internal dictionary for speed, which we will
	modify the association values of. This is safe because the DOM
	parser/builder will never use it again."
	attributeNodesByName := anOrderPreservingDictionary dictionary.

	"Add the XMLAttributes in order directly to the collection to avoid
	sending notifications that would do unneeded, costly namespace prefix
	revalidation and also replace the value in the attributeNodesByName
	association with the new XMLAttribute.
	Use the internal #orderedKeys with #to:do: to create an inlined #keysDo:
	without block closure overhead."
	orderedKeys := anOrderPreservingDictionary orderedKeys.
	1 to: anOrderPreservingDictionary size do: [:i | | key association |
		key := orderedKeys at: i.
		"use associationAt:ifAbsent: for speed over associationAt:"
		association :=
			attributeNodesByName
				associationAt: key
				ifAbsent: nil.
		"replace its string value with the new XMLAttribute"
		association value:
			(collection addLast: 
				(self attributeClass new
					setName: key
					value: association value
					element: observer))].! !

XMLObservableList subclass: #XMLInternalSubsetList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLInternalSubsetList commentStamp: 'JAAyer 7/27/2010 12:45' prior: 0!
This class represents the list of nodes that comprise a document's internal DTD subset.!

!XMLInternalSubsetList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: anIndex]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLInternalSubsetList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: self size]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLInternalSubsetList methodsFor: 'private' stamp: 'monty 2/21/2017 00:40'!
afterAddingToCopyLast: aNode
	observer
		ifNotNil: [observer addedNode: aNode]! !

!XMLInternalSubsetList methodsFor: 'private' stamp: 'monty 10/18/2014 00:54'!
afterRemoving: aNode
	observer ifNotNil: [observer removedNode: aNode]! !

!XMLInternalSubsetList methodsFor: 'sorting' stamp: 'monty 1/18/2015 09:31'!
sort
	self sort: [:a :b | a sortKey <= b sortKey]! !

XMLObservableList subclass: #XMLNodeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNodeList commentStamp: 'monty 6/16/2015 02:17' prior: 0!
This class represents an ordered list of child nodes for an XML document or element. Non-modifying accessing messages like #first and #last return nil instead of raising exceptions.!

XMLNodeList subclass: #XMLCachingNodeList
	instanceVariableNames: 'cachedElements cachedElementsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLCachingNodeList commentStamp: 'monty 9/8/2016 11:57' prior: 0!
This is a node list that caches child elements by name, keeping both an ordered list of elements and a dictionary that allows for faster retrieval of elements by qualified or local name. To use it, inject it into a DOM parser before parsing:
	(parser := XMLDOMParser on: xmlSource)
		nodeFactory:
			(XMLPluggableNodeFactory new
				nodeListClass: XMLCachingNodeList);
		parseDocument.

It should only be used when you know the DOM tree will be queried much more often than parsed or modified and the extra memory use is OK.!

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: anIndex.
			aNode isElement
				ifTrue: [self rebuildCachedElements]]
		ifFalse: [
			aNode isElement
				ifTrue: [
					self
						cacheElement: aNode
						addedAt: anIndex].
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: self size.
			aNode isElement
				ifTrue: [self rebuildCachedElements]]
		ifFalse: [
			aNode isElement
				ifTrue: [self cacheElementAddedLast: aNode].
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/21/2017 00:19'!
afterAddingToCopyLast: aNode
	aNode isElement
		ifTrue: [self cacheElementAddedLast: aNode].
	observer
		ifNotNil: [observer addedNode: aNode].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 8/31/2016 06:38'!
afterRemoving: aNode
	aNode isElement
		ifTrue: [self uncacheElement: aNode].
	observer
		ifNotNil: [observer removedNode: aNode].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 8/31/2016 19:24'!
cacheElement: anElement addedAt: anIndex
	anIndex = self size
		ifTrue: [^ self cacheElementAddedLast: anElement].

	(self findElementAfterIndex: anIndex)
		ifNil: [self cachedElements addLast: anElement]
		ifNotNil: [:elementAfter |
			self cachedElements
				add: anElement
				before: elementAfter].
	self
		cachedElementsByNameAt: anElement name
		add: anElement
		beforeNextAfterIndex: anIndex.
	anElement hasPrefix
		ifTrue: [
			self
				cachedElementsByNameAt: anElement localName
				add: anElement
				beforeNextAfterIndex: anIndex].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/9/2015 06:00'!
cacheElementAddedLast: anElement
	self cachedElements addLast: anElement.
	self
		cachedElementsByNameAt: anElement name
		addLast: anElement.
	anElement hasPrefix
		ifTrue: [
			self
				cachedElementsByNameAt: anElement localName
				addLast: anElement].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 1/16/2015 13:46'!
cachedElements
	^ cachedElements ifNil: [cachedElements := OrderedCollection new]! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 1/16/2015 13:50'!
cachedElementsByName
	^ cachedElementsByName ifNil: [cachedElementsByName := Dictionary new]! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/9/2015 06:06'!
cachedElementsByNameAt: aName add: anElement beforeNextAfterIndex: anIndex
	| elementAfter elementsWithName |

	(elementAfter :=
		self
			findElementAfterIndex: anIndex
			named: aName)
		ifNil: [
			^ self
				cachedElementsByNameAt: aName
				addLast: anElement].

	(elementsWithName := self cachedElementsByName at: aName) isCollection
		ifTrue: [elementsWithName add: anElement before: elementAfter]
		ifFalse: [
			self cachedElementsByName
				at: aName
				put: (OrderedCollection with: anElement with: elementAfter)].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/9/2015 06:08'!
cachedElementsByNameAt: aName addLast: anElement
	| elementsWithName |

	elementsWithName :=
		self cachedElementsByName
			at: aName
			ifAbsent: [
				self cachedElementsByName at: aName put: anElement.
				^ self].

	 elementsWithName isCollection
		ifTrue: [elementsWithName addLast: anElement]
		ifFalse: [
			self cachedElementsByName
				at: aName
				put: (OrderedCollection with: elementsWithName with: anElement)].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/9/2015 06:01'!
cachedElementsByNameAt: aName remove: anElement
	| elementsWithName |

	(elementsWithName := self cachedElementsByName at: aName) isCollection
		ifTrue: [
			elementsWithName remove: anElement.
			elementsWithName isEmpty
				ifTrue: [self cachedElementsByName removeKey: aName]]
		ifFalse: [self cachedElementsByName removeKey: aName]! !

!XMLCachingNodeList methodsFor: 'defaults' stamp: 'monty 2/26/2017 09:28'!
copyClass
	"use the non-caching superclass for copies for performance"
	^ XMLNodeList! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 1/17/2015 08:18'!
elementAt: aName ifAbsent: aBlock
	| elementsWithName |

	(elementsWithName :=
		self cachedElementsByName
			at: aName
			ifAbsent: [^ aBlock value]) isCollection
		ifTrue: [^ elementsWithName first]
		ifFalse: [^ elementsWithName]! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 1/16/2015 13:43'!
elements
	^ self copyEmpty
		addAll: self cachedElements;
		yourself! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 2/21/2017 00:31'!
elementsAt: aName
	| elementsWithName copiedElements |

	copiedElements := self copyEmpty.
	(elementsWithName :=
		self cachedElementsByName
			at: aName
			ifAbsent: [^ copiedElements]) isCollection
		ifTrue: [
			elementsWithName do: [:each |
				copiedElements addToCopyLast: each]]
		ifFalse: [
			copiedElements addToCopyLast: elementsWithName].
	^ copiedElements.! !

!XMLCachingNodeList methodsFor: 'enumerating' stamp: 'monty 9/1/2016 09:03'!
elementsAt: aName do: aBlock
	| elementsWithName |

	(elementsWithName :=
		self cachedElementsByName
			at: aName
			ifAbsent: [^ self]) isCollection
		ifTrue: [elementsWithName do: aBlock]
		ifFalse: [aBlock value: elementsWithName]! !

!XMLCachingNodeList methodsFor: 'enumerating' stamp: 'monty 1/16/2015 13:44'!
elementsDo: aBlock
	self cachedElements do: aBlock! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/2/2015 15:34'!
findElementAfterIndex: anIndex
	anIndex + 1 to: self size do: [:i | | node |
		node := self at: i.
		node isElement
			ifTrue: [^ node]].
	^ nil.! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/2/2015 00:30'!
findElementAfterIndex: anIndex named: aName
	anIndex + 1 to: self size do: [:i | | node |
		node := self at: i.
		(node isElement
			and: [node isNamed: aName])
			ifTrue: [^ node]].
	^ nil.! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 1/16/2015 13:59'!
firstElement
	^ self cachedElements
		at: 1
		ifAbsent: [self defaultValue]! !

!XMLCachingNodeList methodsFor: 'testing' stamp: 'monty 1/16/2015 13:47'!
hasElements
	^ cachedElements notNil and: [cachedElements notEmpty]! !

!XMLCachingNodeList methodsFor: 'testing' stamp: 'monty 1/16/2015 13:48'!
includesElement: aName
	^ self cachedElementsByName includesKey: aName! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 1/16/2015 14:00'!
lastElement
	^ self cachedElements
		at: self cachedElements size
		ifAbsent: [self defaultValue]! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/2/2015 02:58'!
rebuildCachedElements
	self cachedElements removeAll.
	self cachedElementsByName removeAll.
	self do: [:each |
		each isElement
			ifTrue: [self cacheElementAddedLast: each]].! !

!XMLCachingNodeList methodsFor: 'notifying' stamp: 'monty 8/31/2016 05:10'!
renamedElement: anElement from: anOldName to: aNewName
	| oldPrefix index |

	self
		cachedElementsByNameAt: anOldName
		remove: anElement.
	(oldPrefix := anOldName xmlPrefixBeforeLocalName) notEmpty
		ifTrue: [
			self
				cachedElementsByNameAt: (anOldName xmlLocalNameAfterPrefix: oldPrefix)
				remove: anElement].
	index := self indexOf: anElement.
	self
		cachedElementsByNameAt: anElement name
		add: anElement
		beforeNextAfterIndex: index.
	anElement hasPrefix
		ifTrue: [
			self
				cachedElementsByNameAt: anElement localName
				add: anElement
				beforeNextAfterIndex: index].! !

!XMLCachingNodeList methodsFor: 'sorting' stamp: 'monty 2/2/2015 01:32'!
sort: aSortBlock
	super sort: aSortBlock.

	self cachedElements sort: aSortBlock.
	self cachedElementsByName valuesDo: [:each |
		each isCollection
			ifTrue: [each sort: aSortBlock]].! !

!XMLCachingNodeList methodsFor: 'accessing' stamp: 'monty 2/2/2015 02:58'!
swap: aFirstIndex with: aSecondIndex
	super swap: aFirstIndex with: aSecondIndex.

	((self at: aFirstIndex) isElement
		or: [(self at: aSecondIndex) isElement])
		ifTrue: [self rebuildCachedElements].! !

!XMLCachingNodeList methodsFor: 'private' stamp: 'monty 2/9/2015 06:00'!
uncacheElement: anElement
	self cachedElements remove: anElement.
	self
		cachedElementsByNameAt: anElement name
		remove: anElement.
	anElement hasPrefix
		ifTrue: [
			self
				cachedElementsByNameAt: anElement localName
				remove: anElement].! !

!XMLNodeList class methodsFor: 'instance creation' stamp: 'monty 4/16/2015 01:05'!
new
	^ self new: 5! !

!XMLNodeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: anIndex]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLNodeList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	(aNode hasParentWithNodeList: self)
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: self size]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XMLNodeList methodsFor: 'private' stamp: 'monty 2/21/2017 00:17'!
afterAddingToCopyLast: aNode
	observer
		ifNotNil: [observer addedNode: aNode]! !

!XMLNodeList methodsFor: 'private' stamp: 'monty 8/30/2016 17:25'!
afterRemoving: aNode
	observer
		ifNotNil: [observer removedNode: aNode]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/25/2014 21:08'!
contentNodes
	^ self select: [:each | each isContentNode]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/20/2016 22:13'!
contentNodesDo: aBlock
	self do: [:each |
		each isContentNode
			ifTrue: [aBlock value: each]]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 4/15/2016 06:50'!
contentStringAt: aName
	^ (self
		elementAt: aName
		ifAbsent: [^ '']) contentString! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/29/2014 14:27'!
elementAfter: anElement
	| last |

	self elementsDo: [:each |
		last = anElement
			ifTrue: [^ each].
		last := each].
	^ self defaultValue.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 9/20/2016 22:17'!
elementAt: aName
	^ self
		elementAt: aName
		ifAbsent: [self defaultValue]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 9/20/2016 22:17'!
elementAt: aName ifAbsent: aBlock
	self elementsDo: [:each |
		(each isNamed: aName)
			ifTrue: [^ each]].
	^ aBlock value.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 3/21/2015 22:37'!
elementAt: aName namespaceURI: aURI
	^ self
		elementAt: aName
		namespaceURI: aURI
		ifAbsent: [self defaultValue]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 4/18/2016 09:08'!
elementAt: aName namespaceURI: aURI ifAbsent: aBlock
	self
		elementsAt: aName
		do: [:each |
			each namespaceURI = aURI
				ifTrue: [^ each]].
	^ aBlock value.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/29/2014 14:27'!
elementBefore: anElement
	| last |

	last := self defaultValue.
	self elementsDo: [:each |
		each = anElement
			ifTrue: [^ last].
		last := each].
	^ self defaultValue.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/26/2014 08:19'!
elementNames
	^ self elementsCollect: [:each | each name]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 11/26/2013 22:07'!
elements
	^ self select: [:each | each isElement]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 11/26/2013 22:12'!
elementsAt: aName
	^ self elementsSelect: [:each | each isNamed: aName]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/20/2016 22:13'!
elementsAt: aName do: aBlock
	self elementsDo: [:each |
		(each isNamed: aName)
			ifTrue: [aBlock value: each]]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 4/18/2016 09:09'!
elementsAt: aName namespaceURI: aURI
	^ self elementsSelect: [:each |
		(each isNamed: aName)
			and: [each namespaceURI = aURI]]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/21/2016 16:04'!
elementsCollect: aBlock
	| collectedElements |

	"implementing with #elementsDo: benefits the caching subclass because
	of its fast #elementsDo: implementation"
	collectedElements := self copyEmptyForCollect.
	self elementsDo: [:each |
		collectedElements addLast: (aBlock value: each)].
	^ collectedElements.! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/20/2016 22:12'!
elementsDetect: aBlock
	^ self
		elementsDetect: aBlock
		ifNone: [self defaultValue]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/21/2016 16:04'!
elementsDetect: aBlock ifNone: anExceptionBlock
	"implementing with #elementsDo: benefits the caching subclass because
	of its fast #elementsDo: implementation"
	self elementsDo: [:each |
		(aBlock value: each)
			ifTrue: [^ each]].
	^ anExceptionBlock value.! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 2/21/2017 01:51'!
elementsDo: aBlock
	"#to:do: for performance, because so many methods rely on this"
	1 to: collection size do: [:i | | node |
		(node := collection at: i) isElement
			ifTrue: [aBlock value: node]]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 2/21/2017 00:13'!
elementsSelect: aBlock
	| selectedElements |

	"implementing with #elementsDo: benefits the caching subclass because
	of its fast #elementsDo: implementation"
	selectedElements := self copyEmpty.
	self elementsDo: [:each |
		(aBlock value: each)
			ifTrue: [selectedElements addToCopyLast: each]].
	^ selectedElements.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 9/20/2016 22:19'!
firstElement
	self elementsDo: [:each | ^ each].
	^ self defaultValue.! !

!XMLNodeList methodsFor: 'testing' stamp: 'monty 10/25/2014 21:01'!
hasContentNodes
	^ self anySatisfy: [:each | each isContentNode]! !

!XMLNodeList methodsFor: 'testing' stamp: 'monty 11/26/2013 22:03'!
hasElements
	^ self anySatisfy: [:each | each isElement]! !

!XMLNodeList methodsFor: 'testing' stamp: 'monty 10/25/2014 21:01'!
hasStringNodes
	^ self anySatisfy: [:each | each isStringNode]! !

!XMLNodeList methodsFor: 'testing' stamp: 'monty 9/20/2016 22:22'!
includesElement: aName
	self
		elementAt: aName
		ifAbsent: [^ false].
	^ true.! !

!XMLNodeList methodsFor: 'testing' stamp: 'monty 4/19/2016 10:32'!
includesElement: aName namespaceURI: aURI
	self
		elementAt: aName
		namespaceURI: aURI
		ifAbsent: [^ false].
	^ true.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/29/2014 14:23'!
lastElement
	self reverseDo: [:each |
		each isElement
			ifTrue: [^ each]].
	^ self defaultValue.! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 4/15/2016 06:50'!
rawContentStringAt: aName
	^ (self
		elementAt: aName
		ifAbsent: [^ '']) rawContentString! !

!XMLNodeList methodsFor: 'notifying' stamp: 'monty 10/18/2014 01:06'!
renamedElement: anElement from: anOldName to: aNewName! !

!XMLNodeList methodsFor: 'sorting' stamp: 'monty 12/3/2014 00:45'!
sort
	self sort: [:a :b | a sortKey <= b sortKey]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/25/2014 20:59'!
stringNodes
	^ self select: [:each | each isStringNode]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 9/21/2016 16:05'!
stringNodesDo: aBlock
	self do: [:each |
		each isStringNode
			ifTrue: [aBlock value: each]]! !

!XMLNodeList methodsFor: 'accessing' stamp: 'monty 10/25/2014 21:00'!
strings
	^ self
		select: [:each | each isStringNode]
		thenCollect: [:each | each string]! !

!XMLNodeList methodsFor: 'enumerating' stamp: 'monty 10/25/2014 20:58'!
stringsDo: aBlock
	self stringNodesDo: [:each | aBlock value: each string]! !

!XMLObservableList class methodsFor: 'instance creation' stamp: 'monty 7/15/2016 07:35'!
observer: anObserver
	^ self new observer: anObserver! !

!XMLObservableList class methodsFor: 'instance creation' stamp: 'monty 1/17/2015 11:52'!
ofSize: aSize
	self shouldNotImplement! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 1/21/2015 14:53'!
add: anObject after: aPreviousObject
	^ self
		add: anObject
		afterIndex:
			(collection
				indexOf: aPreviousObject
				ifAbsent: [-1])! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 8/28/2016 06:48'!
add: anObject afterIndex: anIndex
	collection
		add: anObject
		afterIndex: anIndex.
	self
		afterAdding: anObject
		at: anIndex + 1.
	^ anObject.! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 1/21/2015 14:53'!
add: anObject before: aNextObject
	^ self
		add: anObject
		beforeIndex:
			(collection
				indexOf: aNextObject
				ifAbsent: [-1])! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 8/28/2016 06:48'!
add: anObject beforeIndex: anIndex
	collection
		add: anObject
		beforeIndex: anIndex.
	self
		afterAdding: anObject
		at: anIndex.
	^ anObject.! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 8/28/2016 06:48'!
addFirst: anObject
	collection addFirst: anObject.
	self afterAdding: anObject at: 1.
	^ anObject.! !

!XMLObservableList methodsFor: 'adding' stamp: 'monty 8/28/2016 06:48'!
addLast: anObject
	collection addLast: anObject.
	self afterAddingLast: anObject.
	^ anObject.! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 2/21/2017 00:08'!
addToCopyLast: anObject
	collection addLast: anObject.
	self afterAddingToCopyLast: anObject.
	^ anObject.! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 8/31/2016 06:39'!
afterAdding: anObject at: anIndex
	observer
		ifNotNil: [
			observer
				added: anObject
				to: self]! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 2/26/2017 12:39'!
afterAddingLast: anObject
	"can be used to handle appending separately and more efficiently than
	insertion"

	self
		afterAdding: anObject
		at: self size! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 2/26/2017 12:41'!
afterAddingToCopyLast: anObject
	"can be used to handle appending existing elements to a copy separately and
	more efficiently than #afterAddingLast: so not as much checking needs to be
	done (because no new elements are being added to the copy)"

	self afterAddingLast: anObject! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 8/31/2016 06:39'!
afterRemoving: anObject
	observer
		ifNotNil: [
			observer
				removed: anObject
				from: self]! !

!XMLObservableList methodsFor: 'accessing' stamp: 'monty 8/28/2016 06:48'!
at: anIndex put: anObject
	| oldObject |

	"Gemstone's OrderedCollection>>#at:put: allows the index to be
	just after the last, treating it like addLast:, so this is needed
	for compatbility"
	anIndex = (self size + 1)
		ifTrue: [^ self addLast: anObject].

	"this will raise an error if the index is invalid"
	oldObject := collection at: anIndex.

	"remove the old object and notify any observer"
	collection at: anIndex put: nil.
	oldObject
		ifNotNil: [self afterRemoving: oldObject].
	
	"now add the new object and notify any observer"
	collection at: anIndex put: anObject.
	self
		afterAdding: anObject
		at: anIndex.

	^ anObject.! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
duplicateIndexOf: anObject notAt: anIndex
	"to:do: for speed because some subclasses need this to be fast"
	1 to: anIndex - 1 do: [:i |
		(collection at: i) = anObject
			ifTrue: [^ i]].

	"to:do: for speed because some subclasses need this to be fast"
	anIndex + 1 to: collection size do: [:i |
		(collection at: i) = anObject
			ifTrue: [^ i]].

	^ 0.! !

!XMLObservableList methodsFor: 'observing' stamp: 'monty 10/18/2014 00:50'!
observer
	^ observer! !

!XMLObservableList methodsFor: 'observing' stamp: 'monty 10/18/2014 00:50'!
observer: anObserver
	observer := anObserver! !

!XMLObservableList methodsFor: 'removing' stamp: 'monty 1/21/2015 10:00'!
remove: anObject ifAbsent: aBlock
	collection remove: anObject ifAbsent: [^ aBlock value].
	self afterRemoving: anObject.
	^ anObject.! !

!XMLObservableList methodsFor: 'removing' stamp: 'monty 5/25/2015 20:50'!
removeAt: anIndex
	| removed |

	removed := super removeAt: anIndex.
	self afterRemoving: removed.
	^ removed.! !

!XMLObservableList methodsFor: 'private' stamp: 'monty 9/6/2016 00:41'!
removeDuplicateOf: anObject notAt: anIndex
	"Removes a duplicate of anObject at any index besides anIndex and
	returns the removed duplicate or nil if there isn't one."

	| duplicateIndex |

	(duplicateIndex := 
		self
			duplicateIndexOf: anObject
			notAt: anIndex) > 0
		ifTrue: [| duplicate |
			(duplicate := collection removeAt: duplicateIndex) = anObject
				ifFalse: [
					"subclasses may implement #duplicateIndexOf:notAt: to test
					for duplicates not with #=, so 'duplicate' can be a
					distinct object from 'anObject' that's been removed"
					self afterRemoving: duplicate].
			^ duplicate]
		ifFalse: [^ nil]! !

!XMLObservableList methodsFor: 'removing' stamp: 'monty 2/26/2017 12:37'!
reset
	| removed |

	removed := collection copy.
	collection reset.
	removed reverseDo: [:each |
		self afterRemoving: each].! !

!XMLOrderedList class methodsFor: 'private' stamp: 'monty 1/17/2015 08:28'!
collection: aCollection
	^ self basicNew setCollection: aCollection! !

!XMLOrderedList class methodsFor: 'defaults' stamp: 'monty 1/29/2014 01:12'!
collectionClass
	^ OrderedCollection! !

!XMLOrderedList class methodsFor: 'inspecting' stamp: 'monty 3/10/2016 14:28'!
inspectorClass
	"for pre-GTInspector Pharo"
	^ self collectionClass inspectorClass! !

!XMLOrderedList class methodsFor: 'instance creation' stamp: 'monty 4/16/2015 01:05'!
new
	^ self new: 10! !

!XMLOrderedList class methodsFor: 'instance creation' stamp: 'monty 1/16/2015 07:12'!
new: aCapacity
	^ self basicNew setCollection: (self collectionClass new: aCapacity)! !

!XMLOrderedList class methodsFor: 'instance creation' stamp: 'monty 1/16/2015 07:12'!
new: aSize withAll: anObject
	| newList |

	"reimplement for portability"
	newList := self new: aSize.
	1 to: aSize do: [:i | newList addLast: anObject].
	^ newList.! !

!XMLOrderedList class methodsFor: 'instance creation' stamp: 'monty 1/16/2015 07:11'!
newFrom: aCollection
	^ (self new: aCollection size)
		addAll: aCollection;
		yourself! !

!XMLOrderedList class methodsFor: 'instance creation' stamp: 'JAAyer 8/4/2010 14:43'!
ofSize: aSize
	^ self new: aSize withAll: nil! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 03:49'!
, aCollection
	"GS doesn't define #, for non-Sequenceable collections"
	^ self copy
		addAll: aCollection;
		yourself! !

!XMLOrderedList methodsFor: 'comparing' stamp: 'monty 9/18/2016 15:08'!
= anObject
	"Returns true if anObject is any kind of XMLOrderedList (not just the
	class of the receiver) and it and the receiver have the same items
	in the same order."

	self == anObject
		ifTrue: [^ true].

	(self species == anObject species
		and: [collection size = anObject size])
		ifFalse: [^ false].

	"Test each position with #= using #to:do: for speed instead of
	just 'collection = anObject collection' because that would
	make equality depend on the internal collections instead of
	just their items."
	1 to: collection size do: [:i |
		(collection at: i) = (anObject at: i)
			ifFalse: [^ false]].
	^ true.! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 15:01'!
add: anObject
	^ self addLast: anObject! !

!XMLOrderedList methodsFor: 'adding' stamp: 'monty 4/3/2016 01:52'!
add: anObject after: aPreviousObject
	^ collection add: anObject after: aPreviousObject! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 13:09'!
add: anObject afterIndex: anIndex
	^ collection add: anObject afterIndex: anIndex! !

!XMLOrderedList methodsFor: 'adding' stamp: 'monty 4/3/2016 01:52'!
add: anObject before: aNextObject
	^ collection add: anObject before: aNextObject! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 13:10'!
add: anObject beforeIndex: anIndex
	^ collection add: anObject beforeIndex: anIndex! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 15:02'!
addAll: aCollection
	^ self addAllLast: aCollection! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 15:10'!
addAllFirst: aCollection
	aCollection reverseDo: [:each | self addFirst: each].
	^ aCollection.! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 15:11'!
addAllLast: aCollection
	aCollection do: [:each | self addLast: each].
	^ aCollection.! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 13:11'!
addFirst: anObject
	^ collection addFirst: anObject! !

!XMLOrderedList methodsFor: 'adding' stamp: 'JAAyer 8/4/2010 13:12'!
addLast: anObject
	^ collection addLast: anObject! !

!XMLOrderedList methodsFor: 'private' stamp: 'monty 2/26/2017 09:45'!
addToCopyLast: anObject
	"this is used to efficiently append to copies for methods like #copy,
	#copyWithout:, #select:, and #reject: that create copies with no new elements
	(only old ones) so duplicate or other constraint checking can be skipped
	by subclasses"

	^ collection addLast: anObject! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:10'!
after: anObject
	^ self after: anObject ifAbsent: [self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:17'!
after: anObject ifAbsent: aBlock
	^ collection after: anObject ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:56'!
allButFirst
	^ self allButFirst: 1! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/23/2014 18:05'!
allButFirst: anInteger
	^ self copyFrom: anInteger + 1 to: self size! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:32'!
allButFirstDo: aBlock
	"reimplemented for portability"
	2 to: collection size do: [:i |
		aBlock value: (collection at: i)]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:56'!
allButLast
	^ self allButLast: 1! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/23/2014 18:02'!
allButLast: anInteger
	^ self copyFrom: 1 to: self size - anInteger! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:32'!
allButLastDo: aBlock
	"reimplemented for portability"
	1 to: collection size - 1 do: [:i |
		aBlock value: (collection at: i)]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:57'!
anyOne
	^ self first! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 5/7/2015 21:46'!
asArray
	"use withAll: not newFrom: for portability"
	^ Array withAll: collection! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 5/7/2015 21:46'!
asOrderedCollection
	"use withAll: not newFrom: for portability"
	^ OrderedCollection withAll: collection! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 1/16/2015 13:06'!
at: anIndex
	"optimized"
	(anIndex > 0 and: [anIndex <= collection size])
		ifTrue: [^ collection at: anIndex]
		ifFalse: [^ self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:17'!
at: anIndex ifAbsent: aBlock
	^ collection at: anIndex ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 1/18/2015 18:06'!
at: anIndex put: aValue
	"treats index = size + 1 as addLast: gemstone compatibility"
	anIndex = (collection size + 1)
		ifTrue: [^ collection addLast: aValue]
		ifFalse: [^ collection at: anIndex put: aValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'JAAyer 8/5/2010 00:55'!
atLast: anIndexFromEnd
	^ self atLast: anIndexFromEnd ifAbsent: [self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:18'!
atLast: anIndexFromEnd ifAbsent: aBlock
	^ collection atLast: anIndexFromEnd ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:11'!
before: anObject
	^ self before: anObject ifAbsent: [self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/19/2014 15:17'!
before: anObject ifAbsent: aBlock
	 ^ collection before: anObject ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'testing' stamp: 'monty 10/22/2014 16:11'!
beginsWith: aCollection
	^ collection beginsWith: aCollection! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 2/23/2016 13:36'!
capacity
	^ collection capacity! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:27'!
collect: aBlock
	| collected |

	collected := self copyEmptyForCollect.
	"use to:do: for speed"
	1 to: collection size do: [:i |
		collected addLast: (aBlock value: (collection at: i))].
	^ collected.! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:34'!
collect: aCollectBlock thenSelect: aSelectBlock
	| selected |

	selected := self copyEmpty.
	"use to:do: for speed"
	1 to: collection size do: [:i | | item |
		item := aCollectBlock value: (collection at: i).
		(aSelectBlock value: item)
			ifTrue: [selected addLast: item]].
	^ selected.! !

!XMLOrderedList methodsFor: 'private' stamp: 'JAA 3/25/2011 15:35'!
collection
	^ collection! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 03:46'!
copy
	| copy |

	copy := self copyEmpty.
	"#to:do: for speed with direct access"
	1 to: collection size do: [:i |
		copy addToCopyLast: (collection at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:10'!
copyAfter: anObject
	| copy |

	copy := self copyEmpty.
	(self
		indexOf: anObject
		ifAbsent: [^ copy]) + 1
			to: self size
			do: [:i | copy addToCopyLast: (self at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:10'!
copyAfterLast: anObject
	| copy |

	copy := self copyEmpty.
	(self
		lastIndexOf: anObject
		ifAbsent: [^ copy]) + 1
			to: self size
			do: [:i | copy addToCopyLast: (self at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'defaults' stamp: 'monty 4/7/2016 05:38'!
copyClass
	"the class to use for copies"
	^ self class! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 1/17/2015 08:28'!
copyEmpty
	^ self copyClass collection: collection copyEmpty! !

!XMLOrderedList methodsFor: 'private' stamp: 'monty 4/20/2016 11:01'!
copyEmptyForCollect
	"collect: methods return instances of the generic ordered list species class
	because a collect block can return any value, which may not be appropiate to
	store in copies of particular subclasses (like XMLNodeList)"

	^ self species new: self size! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:10'!
copyFrom: aStart to: anEnd
	| copy |

	copy := self copyEmpty.
	(aStart max: 1)
		to: (anEnd min: self size)
		do: [:i | copy addToCopyLast: (self at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:26'!
copyReplaceAll: aSearchCollection with: aReplacementCollection
	| copy index size searchCollectionSize |

	"this implementation always returns a copy, even if it doesn't replace"
	(searchCollectionSize := aSearchCollection size) > 0
		ifFalse: [^ self copy].

	copy := self copyEmpty.
	index := 1.
	size := self size.
	[index <= size]
		whileTrue: [
			(self at: index) = (aSearchCollection at: 1)
				ifTrue: [| searchCollectionIndex |
					searchCollectionIndex := 2.
					[searchCollectionIndex <= searchCollectionSize
						and: [
							(self at: index + searchCollectionIndex - 1) =
								(aSearchCollection at: searchCollectionIndex)]]
						whileTrue: [searchCollectionIndex := searchCollectionIndex + 1].
					searchCollectionIndex > searchCollectionSize
						ifTrue: [
							"found a match, add the replacement and skip the replaced"
							copy addAll: aReplacementCollection.
							index := index + searchCollectionSize]
						ifFalse: [
							copy addLast: (self at: index).
							index := index + 1]]
				ifFalse: [ 
					copy addLast: (self at: index).
					index := index + 1]].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:25'!
copyReplaceFrom: aStart to: aStop with: aReplacementCollection
	| copy start stop |

	(self size < 1
		or: [self size < aStart])
		ifTrue: [
			^ self copy
				addAll: aReplacementCollection;
				yourself].

	copy := self copyEmpty.
	start := aStart max: 1.
	stop := aStop min: self size.
	1 to: self size do: [:i |
		(i = start)
			ifTrue: [
				copy addAll: aReplacementCollection.
				start > stop
					ifTrue: [copy addLast: (self at: i)]]
			ifFalse: [
				(i > start and: [i <= stop])
					ifFalse: [copy addLast: (self at: i)]]].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:12'!
copyUpTo: anObject
	| copy |

	copy := self copyEmpty.
	1
		to:
			(self
				indexOf: anObject
				ifAbsent: [self size + 1]) - 1
		do: [:i | copy addToCopyLast: (self at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:12'!
copyUpToLast: anObject
	| copy |

	copy := self copyEmpty.
	1
		to:
			(self
				lastIndexOf: anObject
				ifAbsent: [collection size + 1]) - 1
		do: [:i | copy addToCopyLast: (self at: i)].
	^ copy.! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/21/2017 00:36'!
copyWith: anObject
	^ self copy
		addLast: anObject;
		yourself! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 1/17/2015 12:35'!
copyWithFirst: anObject
	^ self copyEmpty
		addLast: anObject;
		addAll: self;
		yourself! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/25/2017 04:15'!
copyWithout: anObject
	^ self reject: [:each | each = anObject]! !

!XMLOrderedList methodsFor: 'copying' stamp: 'monty 2/26/2017 08:33'!
copyWithoutAll: aCollection
	| rejected |

	rejected :=
		aCollection size > 5
			ifTrue: [aCollection asSet]
			ifFalse: [aCollection].
	^ self reject: [:each | rejected includes: each].! !

!XMLOrderedList methodsFor: 'defaults' stamp: 'JAAyer 3/12/2010 06:48'!
defaultValue
	^ nil! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 11/7/2014 00:21'!
detect: aBlock
	^ self detect: aBlock ifNone: [self defaultValue]! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 11/7/2014 00:21'!
detect: aBlock ifNone: anExceptionBlock
	^ collection detect: aBlock ifNone: anExceptionBlock! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 3/12/2015 20:20'!
do: aBlock
	collection do: aBlock! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 10/22/2014 16:21'!
doWithIndex: aBlock
	^ self withIndexDo: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:58'!
eighth
	^ self at: 8! !

!XMLOrderedList methodsFor: 'testing' stamp: 'monty 10/22/2014 16:11'!
endsWith: aCollection
	^ collection endsWith: aCollection! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:57'!
fifth
	^ self at: 5! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 7/15/2016 02:08'!
first
	"optimized implementation"
	^ collection size > 0
		ifTrue: [collection at: 1]
		ifFalse: [self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:54'!
first: anInteger
	^ self copyFrom: 1 to: anInteger! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:57'!
fourth
	^ self at: 4! !

!XMLOrderedList methodsFor: 'comparing' stamp: 'monty 2/21/2017 10:18'!
hash
	| hash|

	hash := self species hash.
	self size > 10
		ifFalse: [
			self do: [:each |
				hash := hash bitXor: each hash]].
	^ hash bitXor: self size hash.! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:59'!
identityIndexOf: anObject
	^ self identityIndexOf: anObject ifAbsent: [0]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:09'!
identityIndexOf: anObject ifAbsent: aBlock
	^ collection identityIndexOf: anObject ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:59'!
indexOf: anObject
	^ self indexOf: anObject ifAbsent: [0]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 4/20/2016 05:30'!
indexOf: anObject ifAbsent: aBlock
	^ collection
		indexOf: anObject
		ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 4/20/2016 05:29'!
indexOf: anObject startingAt: anIndex 
	^ self
		indexOf: anObject
		startingAt: anIndex
		ifAbsent: [0]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/23/2014 05:45'!
indexOf: anObject startingAt: anIndex ifAbsent: aBlock
	^ collection
		indexOf: anObject
		startingAt: (anIndex max: 1)
		ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 4/20/2016 05:31'!
indexOfSubCollection: aSubCollection startingAt: anIndex
	^ self
		indexOfSubCollection: aSubCollection
		startingAt: anIndex
		ifAbsent: [0]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 4/20/2016 05:31'!
indexOfSubCollection: aSubCollection startingAt: anIndex ifAbsent: aBlock
	^ collection
		indexOfSubCollection: aSubCollection
		startingAt: anIndex
		ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'inspecting' stamp: 'monty 3/10/2016 14:27'!
inspectorClass
	"for Squeak"
	^ collection inspectorClass! !

!XMLOrderedList methodsFor: 'testing' stamp: 'monty 2/14/2017 01:22'!
isEmpty
	"Squeak's Collection>>#isEmpty is inefficient"
	^ self size = 0! !

!XMLOrderedList methodsFor: 'testing' stamp: 'monty 10/22/2014 16:11'!
isSequenceable
	^ true! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 7/15/2016 02:00'!
last
	| lastIndex |

	"optimized implementation"
	^ (lastIndex := collection size) > 0
		ifTrue: [collection at: lastIndex]
		ifFalse: [self defaultValue]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:55'!
last: anInteger
	^ self copyFrom: self size - anInteger + 1 to: self size! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:06'!
lastIndexOf: anObject
	^ self lastIndexOf: anObject ifAbsent: [0]! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/23/2014 07:32'!
lastIndexOf: anObject ifAbsent: aBlock
	^ collection lastIndexOf: anObject ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:58'!
ninth
	^ self at: 9! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 10/22/2014 16:23'!
pairsDo: aBlock
	collection pairsDo: aBlock! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 2/28/2017 13:33'!
readStream
	"use #readStream to get a 0-based position stream on GS"
	^ collection readStream! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 2/21/2017 00:13'!
reject: aBlock
	| selected |

	selected := self copyEmpty.
	"use to:do: for speed"
	1 to: collection size do: [:i | | item |
		item := collection at: i.
		(aBlock value: item)
			ifFalse: [selected addToCopyLast: item]].
	^ selected.! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:31'!
reject: aRejectBlock thenCollect: aCollectBlock
	| collected |

	collected := self copyEmptyForCollect.
	"use to:do: for speed"
	1 to: collection size do: [:i | | item |
		item := collection at: i.
		(aRejectBlock value: item)
			ifFalse: [collected addLast: (aCollectBlock value: item)]].
	^ collected.! !

!XMLOrderedList methodsFor: 'removing' stamp: 'JAAyer 8/4/2010 13:33'!
remove: anObject ifAbsent: aBlock
	^ collection remove: anObject ifAbsent: aBlock! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 2/26/2017 09:30'!
removeAll
	"Redefined because Collection>>#removeAll assumes the collection can
	be safely modified while iterating it with #do:"

	self size timesRepeat: [self removeLast]! !

!XMLOrderedList methodsFor: 'removing' stamp: 'JAAyer 8/4/2010 15:46'!
removeAt: anIndex
	^ collection removeAt: anIndex! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 1/12/2014 20:25'!
removeFirst
	^ self removeAt: 1! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 1/12/2014 20:32'!
removeFirst: aNumber
	| removed |

	removed := self copyFrom: 1 to: aNumber.
	aNumber timesRepeat: [self removeFirst].
	^ removed.! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 1/12/2014 20:24'!
removeLast
	^ self removeAt: self size! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 1/12/2014 20:33'!
removeLast: aNumber
	| removed |

	removed := self copyFrom: self size - (aNumber - 1) to: self size.
	aNumber timesRepeat: [self removeLast].
	^ removed.! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:02'!
replaceFrom: aStart to: aStop with: aReplacementCollection
	^ self
		replaceFrom: aStart
		to: aStop
		with: aReplacementCollection
		startingAt: 1! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 16:04'!
replaceFrom: aStart to: aStop with: aReplacementCollection startingAt: aReplacementStart
	| offset |

	offset := 0.
	[aStart + offset <= aStop]
		whileTrue: [
			self
				at: aStart + offset
				put: (aReplacementCollection at: aReplacementStart + offset).
			offset := offset + 1].! !

!XMLOrderedList methodsFor: 'removing' stamp: 'monty 10/19/2014 06:31'!
reset
	collection reset! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 2/28/2017 05:36'!
reverse
	"returns a copy like #reversed instead of doing in-place reversal to
	be compatible with SequenceableCollection>>#reverse"

	^ self reversed! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'JAAyer 8/4/2010 13:35'!
reverseDo: aBlock
	collection reverseDo: aBlock! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 2/21/2017 00:13'!
reversed
	| reversed |

	reversed := self copyEmpty.
	self reverseDo: [:each | reversed addToCopyLast: each].
	^ reversed.! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:57'!
second
	^ self at: 2! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 2/21/2017 00:13'!
select: aBlock
	| selected |

	selected := self copyEmpty.
	"use to:do: for speed"
	1 to: collection size do: [:i | | item |
		item := collection at: i.
		(aBlock value: item)
			ifTrue: [selected addToCopyLast: item]].
	^ selected.! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:30'!
select: aSelectBlock thenCollect: aCollectBlock
	| collected |

	collected := self copyEmptyForCollect.
	"use to:do: for speed"
	1 to: collection size do: [:i | | item |
		item := collection at: i.
		(aSelectBlock value: item)
			ifTrue: [collected addLast: (aCollectBlock value: item)]].
	^ collected.! !

!XMLOrderedList methodsFor: 'private' stamp: 'JAAyer 8/4/2010 13:38'!
setCollection: aCollection
	collection := aCollection! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:58'!
seventh
	^ self at: 7! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:58'!
sixth
	^ self at: 6! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'JAAyer 8/4/2010 12:49'!
size
	^ collection size! !

!XMLOrderedList methodsFor: 'sorting' stamp: 'monty 10/22/2014 16:18'!
sort
	self sort: [:a :b | a <= b]! !

!XMLOrderedList methodsFor: 'sorting' stamp: 'monty 2/2/2015 01:33'!
sort: aSortBlock
	collection sort: aSortBlock! !

!XMLOrderedList methodsFor: 'sorting' stamp: 'monty 1/18/2015 09:31'!
sorted
	^ self copy sort! !

!XMLOrderedList methodsFor: 'sorting' stamp: 'monty 10/19/2014 08:07'!
sorted: aSortBlock
	^ self copy sort: aSortBlock! !

!XMLOrderedList methodsFor: 'private' stamp: 'monty 4/7/2016 05:39'!
species
	"this makes instances of this class and all subclasses with the same
	items in the same order be equal"
	^ XMLOrderedList! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 9/3/2017 07:44'!
swap: aFirstIndex with: aSecondIndex
	"swap positions of the objects at aFirstIndex and aSecondIndex,
	raising an error if either index is out of bounds"

	| temp |

	temp := collection at: aFirstIndex.
	collection
		at: aFirstIndex
		put: (collection at: aSecondIndex).
	collection
		at: aSecondIndex
		put: temp.! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 10/22/2014 15:57'!
third
	^ self at: 3! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:28'!
with: aCollection collect: aBlock
	| collected |

	collected := self copyEmptyForCollect.
	1 to: (collection size min: aCollection size) do: [:i |
		collected addLast:
			(aBlock
				value: (collection at: i)
				value: (aCollection at: i))].
	^ collected.! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:42'!
with: aCollection do: aBlock
	1 to: (collection size min: aCollection size) do: [:i |
		aBlock
			value: (collection at: i)
			value: (aCollection at: i)]! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 4/17/2016 08:28'!
withIndexCollect: aTwoArgumentBlock
	| collected |

	collected := self copyEmptyForCollect.
	1 to: collection size do: [:i |
		collected addLast:
			(aTwoArgumentBlock
				value: (collection at: i)
				value: i)].
	^ collected.! !

!XMLOrderedList methodsFor: 'enumerating' stamp: 'monty 10/22/2014 16:47'!
withIndexDo: aBlock
	collection withIndexDo: aBlock! !

!XMLOrderedList methodsFor: 'converting' stamp: 'monty 2/28/2017 13:35'!
writeStream
	"This is not supported because the collection already supports WriteStream
	behavior with #addLast: and the Pharo/Squeak WriteStream works by expanding
	its collection with #grownBy:, which should fill the new space with nils,
	but some subclasses cannot contain nil"

	self shouldNotImplement! !

!XMLOrderedList methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
xmlLastOrNil
	^ self last! !

!String methodsFor: '*XML-Parser' stamp: 'monty 3/13/2016 20:11'!
asXMLEscapedString
	"returns a copy of self with &, <, and > escaped with &amp;, &lt;, and &gt;"
	| stream |

	stream := (self class new: self size) writeStream.
	"to:do: for performance"
	1 to: self size do: [:i | | nextChar |
		(nextChar := self at: i) == $<
			ifTrue: [stream nextPutAll: '&lt;']
			ifFalse: [
				nextChar == $> "needed to escape ]]> in PCDATA"
					ifTrue: [stream nextPutAll: '&gt;']
					ifFalse: [
						nextChar == $&
							ifTrue: [stream nextPutAll: '&amp;']
							ifFalse: [stream nextPut: nextChar]]]].
	^ stream contents.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 2/2/2016 17:37'!
asXMLFileHandle
	^ XMLFileHandle path: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 2/13/2016 00:35'!
asXMLHTTPRequest
	^ XMLHTTPRequest url: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 3/5/2016 06:36'!
asXMLStreamConverter
	^ XMLStreamConverter newForEncoding: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 8/16/2016 21:57'!
asXMLString
	"will be deprecated; use #asXMLStringNode instead"

	^ self asXMLStringNode! !

!String methodsFor: '*XML-Parser' stamp: 'monty 8/5/2016 16:39'!
asXMLStringNode
	^ XMLString string: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 1/10/2014 00:56'!
asXMLURI
	^ XMLURI fromString: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 14:27'!
expandWithXMLNamespaceURI: aURI
	"optimized"
	aURI size == 0
		ifTrue: [^ self]
		ifFalse: [^ 'Q{', aURI, '}', self]! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:15'!
isXMLNCName
	"optimized"
	self size == 0
		ifTrue: [^ false].
	(self at: 1) isXMLNCNameStartChar
		ifFalse: [^ false].
	2 to: self size do: [:i |
		(self at: i) isXMLNCNameChar
			ifFalse: [^ false]].
	^ true.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:16'!
isXMLNSAttributeName
	"optimized"
	self size >= 5
		ifFalse: [^ false].
	(self at: 1) == $x
		ifFalse: [^ false].
	(self at: 2) == $m
		ifFalse: [^ false].
	(self at: 3) == $l
		ifFalse: [^ false].
	(self at: 4) == $n
		ifFalse: [^ false].
	(self at: 5) == $s
		ifFalse: [^ false].
	self size == 5
		ifTrue: [^ true].
	^ (self at: 6) == $:.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:16'!
isXMLName
	"optimized"
	self size == 0
		ifTrue: [^ false].
	(self at: 1) isXMLNameStartChar
		ifFalse: [^ false].
	2 to: self size do: [:i |
		(self at: i) isXMLNameChar
			ifFalse: [^ false]].
	^ true.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:16'!
isXMLNmtoken
	"optimized"
	self size == 0
		ifTrue: [^ false].
	1 to: self size do: [:i |
		(self at: i) isXMLNameChar
			ifFalse: [^ false]].
	^ true.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 9/29/2017 11:31'!
isXMLQualifiedOrLocalName: aQualifiedOrLocalName
	"returns true if self and aQualifiedOrLocalName are the
	same QName or if self is a QName and aQualifiedOrLocalName
	is the local part, or if they are the same NCName."
	| i |

	i := aQualifiedOrLocalName size.
	self size to: 1 by: -1 do: [:j |
		i == 0
			ifTrue: [^ (self at: j) == $:].
		"avoid #== for compatibility with pre-Spur VMs where wide chars
		aren't an immediate type"
		(aQualifiedOrLocalName at: i) = (self at: j)
			ifFalse: [^ false].
		i := i - 1].
	^ i == 0.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/12/2016 10:00'!
isXMLReservedAttributeName
	"optimized"
	self size > 3
		ifFalse: [^ false].
	(self at: 1) == $x
		ifFalse: [^ false].
	(self at: 2) == $m
		ifFalse: [^ false].
	^ (self at: 3) == $l.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:19'!
isXMLWhitespace
	"optimized"
	self size == 0
		ifTrue: [^ false].
	1 to: self size do: [:i |
		(self at: i) isXMLWhitespace
			ifFalse: [^ false]].
	^ true.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 10/18/2014 05:47'!
parseXML
	^ XMLDOMParser parse: self! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:19'!
qualifyWithXMLPrefix: aPrefix
	"optimized"
	aPrefix size == 0
		ifTrue: [^ self]
		ifFalse: [^ (aPrefix copyWith: $:), self]! !

!String methodsFor: '*XML-Parser' stamp: 'monty 2/6/2018 05:29'!
xmlCopyWithoutWhitespace
	^ self reject: [:each | each isXMLWhitespace]! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/1/2016 00:57'!
xmlLocalNameAfterPrefix
	^ self xmlLocalNameAfterPrefix: self xmlPrefixBeforeLocalName! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:19'!
xmlLocalNameAfterPrefix: aPrefix
	"optimized"
	| prefixSize |

	(prefixSize := aPrefix size) == 0
		ifTrue: [^ self]
		ifFalse: [^ self copyFrom: prefixSize + 2 to: self size]! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 11:21'!
xmlPrefixBeforeLocalName
	"optimized"
	| i |

	i := self size.
	[i == 0]
		whileFalse: [
			((self at: i) == $:)
				ifTrue: [^ (self copyFrom: 1 to: i - 1)].
			i := i - 1].
	^ ''.! !

!String methodsFor: '*XML-Parser' stamp: 'monty 4/1/2016 00:57'!
xmlPrefixBeforeLocalName: aLocalName
	"optimized"
	| prefixSize |

	(prefixSize := self size - aLocalName size - 1) > 0
		ifTrue: [^ self copyFrom: 1 to: prefixSize]
		ifFalse: [^ '']! !

!SequenceableCollection methodsFor: '*XML-Parser' stamp: 'monty 4/14/2016 13:04'!
includesXMLName: aName
	"optimized with to:do:"
	1 to: self size do: [:i |
		(aName isXMLQualifiedOrLocalName: (self at: i))
			ifTrue: [^ true]].
	^ false.! !

!SequenceableCollection methodsFor: '*XML-Parser' stamp: 'monty 4/1/2016 00:56'!
xmlLastOrNil
	"for speed to avoid at:ifAbsent: closure"
	| lastOrNilOffset |

	(lastOrNilOffset := self size) > 0
		ifTrue: [^ self at: lastOrNilOffset]
		ifFalse: [^ nil]! !

OrderPreservingStringDictionary subclass: #XMLAttributeDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLAttributeDictionary commentStamp: 'monty 9/21/2017 13:18' prior: 0!
This class is an OrderPreservingStringDictionary for XML attributes that returns empty strings instead of raising errors when absent keys are looked up. It has messages to lookup the namespace URI of an attribute key and to lookup an attribute value or association by local or qualified name and namespace URI.!

!XMLAttributeDictionary methodsFor: 'converting' stamp: 'monty 6/30/2017 22:46'!
asXMLAttributeDictionary
	^ self! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/22/2017 05:47'!
associationAtName: aQualifiedOrLocalName
	^ self
		associationAtName: aQualifiedOrLocalName
		ifAbsent: [nil]! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/29/2017 08:12'!
associationAtName: aQualifiedOrLocalName ifAbsent: aBlock
	^ self
		associationAt: aQualifiedOrLocalName
		ifAbsent: [
			aQualifiedOrLocalName xmlPrefixBeforeLocalName isEmpty
				ifTrue: [
					self keysDo: [:each |
						(each isXMLQualifiedOrLocalName: aQualifiedOrLocalName)
							ifTrue: [^ self associationAt: each]]].
			aBlock value]! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 7/12/2017 05:58'!
associationAtName: aQualifiedOrLocalName namespaceURI: aURI
	^ self
		associationAtName: aQualifiedOrLocalName
		namespaceURI: aURI
		ifAbsent: [nil]! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 10/2/2017 13:35'!
associationAtName: aQualifiedOrLocalName namespaceURI: aURI ifAbsent: aBlock
	| namePrefix |

	(namePrefix := aQualifiedOrLocalName xmlPrefixBeforeLocalName) isEmpty
		ifTrue: [
			"aQualifiedOrLocalName has no prefix, so check for an
			attribute with a matching local name and namespace URI"
			self keysDo: [:each |
				(each isXMLQualifiedOrLocalName: aQualifiedOrLocalName)
					ifTrue: [| keyPrefix |
						(keyPrefix := each xmlPrefixBeforeLocalName) isEmpty
							ifTrue: [
								"unprefixed attribute have no namespace URI"
								aURI isEmpty
									ifTrue: [^ self associationAt: each]]
							ifFalse: [
								(self resolvePrefix: keyPrefix) = aURI
									ifTrue: [^ self associationAt: each]]]]]
		ifFalse: [
			"aQualifiedOrLocalName is a qualified name, look it up exactly"
			(self resolvePrefix: namePrefix) = aURI
				ifTrue: [
					^ self
						associationAt: aQualifiedOrLocalName
						ifAbsent: aBlock]].

	^ aBlock value.! !

!XMLAttributeDictionary methodsFor: 'private' stamp: 'monty 6/26/2017 04:19'!
at: aKey newPut: aValue
	"should be identical to StandardOrderedDictionary>>#at:put: except
	it returns a boolean to tell if the key is new"
	| oldSize |

	oldSize := dictionary size.
	dictionary
		at: aKey
		put: aValue.
	dictionary size > oldSize
		ifTrue: [
			orderedKeys size > oldSize
				ifFalse: [self growOrderedKeys].
			orderedKeys at: oldSize + 1 put: aKey.
			^ true].
	^ false.! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/22/2017 05:47'!
atName: aQualifiedOrLocalName
	^ self
		atName: aQualifiedOrLocalName
		ifAbsent: ['']! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 9/22/2017 10:12'!
atName: aQualifiedOrLocalName ifAbsent: aBlock
	^ (self
		associationAtName: aQualifiedOrLocalName
		ifAbsent: [^ aBlock value])
		ifNil: [aBlock value]
		ifNotNil: [:association | association value]! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 6/30/2017 23:19'!
atName: aQualifiedOrLocalName namespaceURI: aURI
	^ self
		atName: aQualifiedOrLocalName
		namespaceURI: aURI
		ifAbsent: ['']! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 7/12/2017 07:00'!
atName: aQualifiedOrLocalName namespaceURI: aURI ifAbsent: aBlock
	^ (self
		associationAtName: aQualifiedOrLocalName
		namespaceURI: aURI)
		ifNil: [aBlock value]
		ifNotNil: [:association | association value]! !

!XMLAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:28'!
namespaceScope
	^ nil! !

!XMLAttributeDictionary methodsFor: 'accessing' stamp: 'monty 10/2/2017 13:35'!
namespaceURIOf: aKey
	"Returns the namespace URI of the attribute name aKey"

	| prefix |

	^ (self usesNamespaces
		and: [(prefix := aKey xmlPrefixBeforeLocalName) notEmpty])
		ifTrue: [self resolvePrefix: prefix]
		ifFalse: ['']! !

!XMLAttributeDictionary methodsFor: 'private' stamp: 'monty 8/25/2017 20:11'!
resolvePrefix: aPrefix
	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: ''! !

!XMLAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:27'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	^ aBlock value! !

!XMLAttributeDictionary methodsFor: 'initialization' stamp: 'monty 7/2/2017 02:06'!
setNamespaceScope: aNamespaceScope! !

!XMLAttributeDictionary methodsFor: 'testing' stamp: 'monty 8/25/2017 20:05'!
usesNamespaces
	^ false! !

XMLAttributeDictionary subclass: #XMLNamespacedAttributeDictionary
	instanceVariableNames: 'namespaceScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLNamespacedAttributeDictionary commentStamp: 'monty 9/20/2017 09:07' prior: 0!
This subclass is used when namespaces are enabled. It has an extra inst var for namespace scopes.!

!XMLNamespacedAttributeDictionary methodsFor: 'private' stamp: 'monty 7/5/2017 11:48'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XMLNamespacedAttributeDictionary methodsFor: 'private' stamp: 'monty 10/2/2017 17:27'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	^ self namespaceScope
		resolvePrefix: aPrefix
		ifUnresolvable: aBlock! !

!XMLNamespacedAttributeDictionary methodsFor: 'initialization' stamp: 'monty 7/2/2017 02:06'!
setNamespaceScope: aNamespaceScope
	namespaceScope := aNamespaceScope! !

!XMLNamespacedAttributeDictionary methodsFor: 'testing' stamp: 'monty 8/25/2017 20:05'!
usesNamespaces
	^ true! !

!Error methodsFor: '*XML-Parser' stamp: 'monty 9/5/2016 06:11'!
isXMLParserException
	^ false! !

Error subclass: #XMLException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLException commentStamp: 'monty 9/5/2016 06:19' prior: 0!
A generic exception class that supports message formatting. Used as a base class for exceptions in XMLParser and related packages like XPath.!

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 00:34'!
formatSignal: aString with: aFirstValue
	^ self new
		formatSignal: aString
		with: aFirstValue! !

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 00:34'!
formatSignal: aString with: aFirstValue with: aSecondValue
	^ self new
		formatSignal: aString
		with: aFirstValue
		with: aSecondValue! !

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 00:35'!
formatSignal: aString with: aFirstValue with: aSecondValue with: aThirdValue
	^ self new
		formatSignal: aString
		with: aFirstValue
		with: aSecondValue
		with: aThirdValue! !

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 00:35'!
formatSignal: aString with: aFirstValue with: aSecondValue with: aThirdValue with: aFourthValue
	^ self new
		formatSignal: aString
		with: aFirstValue
		with: aSecondValue
		with: aThirdValue
		with: aFourthValue! !

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 01:00'!
formatSignal: aString withArguments: anArray
	^ self new
		formatSignal: aString
		withArguments: anArray! !

!XMLException class methodsFor: 'signalling' stamp: 'monty 10/22/2017 01:40'!
signalMessageFrom: anException
	^ self new signalMessageFrom: anException! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 00:33'!
formatMessage: aString with: aFirstValue
	self
		formatMessage: aString
		withArguments: (Array with: aFirstValue)! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 00:33'!
formatMessage: aString with: aFirstValue with: aSecondValue
	self
		formatMessage: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue)! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 00:33'!
formatMessage: aString with: aFirstValue with: aSecondValue with: aThirdValue
	self
		formatMessage: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue
				with: aThirdValue)! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 00:32'!
formatMessage: aString with: aFirstValue with: aSecondValue with: aThirdValue with: aFourthValue
	self
		formatMessage: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue
				with: aThirdValue
				with: aFourthValue)! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 00:32'!
formatMessage: aString withArguments: anArray
	self messageText: (aString format: anArray)! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 00:38'!
formatSignal: aString with: aFirstValue
	self
		formatMessage: aString
		with: aFirstValue.
	^ self signal.! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 00:39'!
formatSignal: aString with: aFirstValue with: aSecondValue
	self
		formatMessage: aString
		with: aFirstValue
		with: aSecondValue.
	^ self signal.! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 00:39'!
formatSignal: aString with: aFirstValue with: aSecondValue with: aThirdValue
	self
		formatMessage: aString
		with: aFirstValue
		with: aSecondValue
		with: aThirdValue.
	^ self signal.! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 00:39'!
formatSignal: aString with: aFirstValue with: aSecondValue with: aThirdValue with: aFourthValue
	self
		formatMessage: aString
		with: aFirstValue
		with: aSecondValue
		with: aThirdValue
		with: aFourthValue.
	^ self signal.! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 04:39'!
formatSignal: aString withArguments: anArray
	self
		formatMessage: aString
		withArguments: anArray.
	^ self signal.! !

!XMLException methodsFor: 'accessing' stamp: 'monty 10/22/2017 04:43'!
inheritMessageFrom: anException
	self
		formatMessage: '({1}) {2}'
		with: anException class name
		with: anException messageText! !

!XMLException methodsFor: 'signaling' stamp: 'monty 10/22/2017 04:43'!
signalMessageFrom: anException
	self inheritMessageFrom: anException.
	^  self signal.! !

XMLException subclass: #XMLParserException
	instanceVariableNames: 'lineNumber columnNumber baseURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLParserException commentStamp: 'monty 3/11/2016 23:36' prior: 0!
A base class for XMLParser exceptions that supports line number error info and can be used with on:do: to catch any XMLParser-related errors.!

XMLParserException subclass: #XMLDOMException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLDOMException commentStamp: 'monty 1/16/2014 19:40' prior: 0!
Invoked when a DOM tree is manipulated wrong.!

XMLParserException subclass: #XMLEncodingException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLEncodingException commentStamp: 'monty 11/11/2014 04:38' prior: 0!
Invoked for encoding errors.!

XMLParserException subclass: #XMLFileException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLFileException commentStamp: 'monty 1/16/2014 19:40' prior: 0!
Invoked for file IO errors.!

XMLParserException subclass: #XMLHTTPException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLHTTPException commentStamp: 'monty 1/16/2014 19:40' prior: 0!
Invoked for HTTP errors.!

XMLParserException subclass: #XMLLimitException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLLimitException commentStamp: 'monty 1/25/2014 00:19' prior: 0!
Invoked when a security limit on input is exceeded. Use the messages in XMLParserLimits and DTDExternalEntityLimits to configure these limits or the removeLimits message to remove them completely.!

XMLParserException subclass: #XMLNamespaceException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLNamespaceException commentStamp: 'monty 1/16/2014 19:41' prior: 0!
Invoked when namespaces are used improperly and namespace checking is on.!

!XMLParserException methodsFor: 'accessing' stamp: 'monty 11/23/2016 17:08'!
baseURI
	^ baseURI ifNil: [baseURI := '']! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:11'!
baseURI: aURIString
	baseURI := aURIString! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 3/18/2016 01:44'!
columnNumber
	^ columnNumber! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:12'!
columnNumber: aColumnNumber
	columnNumber := aColumnNumber! !

!XMLParserException methodsFor: 'testing' stamp: 'monty 11/23/2016 17:08'!
hasBaseURI
	^ self baseURI notEmpty! !

!XMLParserException methodsFor: 'testing' stamp: 'monty 3/19/2016 16:24'!
hasColumnNumber
	^ self columnNumber notNil! !

!XMLParserException methodsFor: 'testing' stamp: 'monty 3/19/2016 16:24'!
hasLineNumber
	^ self lineNumber notNil! !

!XMLParserException methodsFor: 'testing' stamp: 'monty 9/5/2016 06:11'!
isXMLParserException
	^ true! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 4/12/2015 07:29'!
lineNumber
	^ lineNumber! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:12'!
lineNumber: aLineNumber
	lineNumber := aLineNumber! !

!XMLParserException methodsFor: 'accessing' stamp: 'monty 9/20/2017 08:02'!
messageText
	| rawMessageText messageTextStream |

	rawMessageText := super messageText.
	(self hasLineNumber
		or: [self hasBaseURI])
		ifFalse: [^ rawMessageText].

	(messageTextStream := (String new: rawMessageText size * 2) writeStream)
		nextPutAll: rawMessageText;
		nextPutAll: ' ('.
	self hasLineNumber
		ifTrue: [
			messageTextStream
				nextPutAll: 'near line ';
				nextPutAll: self lineNumber asString.
			self hasColumnNumber
				ifTrue: [
					messageTextStream
						nextPutAll: ', column ';
						nextPutAll: self columnNumber asString]].

	self hasBaseURI
		ifTrue: [
			messageTextStream
				nextPutAll:
					(self hasLineNumber
						ifTrue: [' in ']
						ifFalse: ['in ']);
				nextPutAll: self baseURI].
			
	^ messageTextStream
		nextPut: $);
		contents.! !

!XMLParserException methodsFor: 'testing' stamp: 'monty 11/26/2014 06:03'!
shouldPassOnWhenCaught
	^ true! !

XMLParserException subclass: #XMLParsingInterruptException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLParsingInterruptException commentStamp: 'monty 11/26/2014 05:54' prior: 0!
Used to interrupt parsing from a SAXHandler. Will be silently caught.!

!XMLParsingInterruptException methodsFor: 'testing' stamp: 'monty 11/26/2014 06:03'!
shouldPassOnWhenCaught
	^ false! !

XMLParserException subclass: #XMLValidationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLValidationException commentStamp: 'monty 1/16/2014 19:41' prior: 0!
Invoked when invalid XML is detected and validation is on.!

XMLParserException subclass: #XMLWellFormednessException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Exceptions'!

!XMLWellFormednessException commentStamp: 'monty 1/16/2014 19:41' prior: 0!
Invoked when XML markup is not well-formed.!

Object subclass: #DTDAttributeDefinitionParser
	instanceVariableNames: 'element attribute type defaultValidator enumerationListParserClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDAttributeDefinitionParser commentStamp: 'monty 11/23/2016 23:46' prior: 0!
This class parses an attribute definition in an ATTLIST declaration and returns a new XMLAttributeValidator for it. It assumes the type has already been checked for well-formedness by the tokenizer and that it contains a value like "ID", "ENTITY", or an enumeration list.!

!DTDAttributeDefinitionParser class methodsFor: 'private' stamp: 'monty 11/24/2016 23:20'!
attributeDefaultValidatorClassForPragma: aDefaultPragma
	"the default pragma should have been checked for well-formedness by the
	tokenizer so it's either empty, 'FIXED', 'REQUIRED', or 'IMPLIED'"
	aDefaultPragma size > 0
		ifTrue: [
			(aDefaultPragma at: 1) == $F
				ifTrue: [^ XMLAttributeFixedValueDefaultValidator].
			(aDefaultPragma at: 1) == $I
				ifTrue: [^ XMLAttributeImpliedDefaultValidator].
			^ XMLAttributeRequiredDefaultValidator].
	^ XMLAttributeValueDefaultValidator.! !

!DTDAttributeDefinitionParser class methodsFor: 'instance creation' stamp: 'monty 11/18/2016 16:00'!
element: anElement attribute: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	^ self new
		setElement: anElement
		attribute: anAttribute
		type: aType
		defaultValidator:
			((self attributeDefaultValidatorClassForPragma: aDefaultPragma)
				attribute: anAttribute
				value: aDefaultValue)! !

!DTDAttributeDefinitionParser methodsFor: 'private' stamp: 'monty 4/15/2017 00:46'!
attributeValidatorClassForType
	"the tokenizer should have checked the type for well-formedness
	so it's only one of CDATA, ID, IDREF, IDREFS, etc"
	
	| nextChar |

	(nextChar := type at: 1) == $C
		ifTrue: [^ XMLCDataAttributeValidator].
	nextChar == $I
		ifTrue: [
			type size = 2 "'ID' size"
				ifTrue: [
					attribute = 'xml:id'
						ifTrue: [^ XMLXMLIDAttributeValidator].
					^ XMLIDAttributeValidator].
			type size = 5 "'IDREF' size"
				ifTrue: [^ XMLIDRefAttributeValidator].
			"'IDREF' size < 'IDREFS' size"
			^ XMLIDRefsAttributeValidator].
	nextChar == $E
		ifTrue: [
			type size = 6 "'ENTITY' size"
				ifTrue: [^ XMLEntityAttributeValidator].
			"'ENTITY' size < 'ENTITIES' size"
			^ XMLEntitiesAttributeValidator].
	nextChar == $N
		ifTrue: [
			type size = 7 "'NMTOKEN' size"
				ifTrue: [^ XMLNmtokenAttributeValidator].
			type size = 8 "'NMTOKENS' size"
				ifTrue: [^ XMLNmtokensAttributeValidator].
			"'NMTOKENS' size < 'NOTATION (' size"
			enumerationListParserClass := DTDNotationEnumerationListParser.
			^ XMLNotationEnumerationAttributeValidator].

	"otherwise it's a (one|two|...) enumeration attribute"
	enumerationListParserClass := DTDEnumerationListParser.
	^ XMLEnumerationAttributeValidator.! !

!DTDAttributeDefinitionParser methodsFor: 'parsing' stamp: 'monty 11/1/2016 11:12'!
parse
	| validator |
	
	validator :=
		self attributeValidatorClassForType
			element: element
			attribute: attribute
			defaultValidator: defaultValidator.

	enumerationListParserClass
		ifNotNil: [
			validator allowedValues:
				(enumerationListParserClass on: type) parse].

	^ validator.! !

!DTDAttributeDefinitionParser methodsFor: 'initialization' stamp: 'monty 2/19/2016 14:49'!
setElement: anElement attribute: anAttribute type: aType defaultValidator: aDefaultValidator
	element := anElement.
	attribute := anAttribute.
	type := aType.
	defaultValidator := aDefaultValidator.! !

DTDAttributeDefinitionParser subclass: #DTDStandaloneExternalAttributeDefinitionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD-Standalone'!

!DTDStandaloneExternalAttributeDefinitionParser commentStamp: 'monty 11/5/2016 04:05' prior: 0!
This class parses standalone externally defined ATTLIST attribute definitions and returns XMLAttributeValidators for them that disallow attributes needing further value normalization or substitution with default or fixed default values.!

!DTDStandaloneExternalAttributeDefinitionParser class methodsFor: 'private' stamp: 'monty 11/5/2016 12:09'!
attributeDefaultValidatorClassForPragma: aDefaultPragma
	^ (super attributeDefaultValidatorClassForPragma: aDefaultPragma)
		standaloneExternalClass! !

!DTDStandaloneExternalAttributeDefinitionParser methodsFor: 'private' stamp: 'monty 11/1/2016 11:12'!
attributeValidatorClassForType
	^ super attributeValidatorClassForType standaloneExternalClass! !

Object subclass: #DTDContentModelParser
	instanceVariableNames: 'element contentModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDContentModelParser commentStamp: 'monty 10/15/2016 00:20' prior: 0!
This is a base class for DTD content model parsers that turn element declarations into XMLElementValidators.!

!DTDContentModelParser class methodsFor: 'instance creation' stamp: 'monty 6/7/2015 19:43'!
element: anElement contentModel: aContentModel
	^ self new
		setElement: anElement
		contentModel: aContentModel! !

!DTDContentModelParser class methodsFor: 'accessing' stamp: 'monty 11/2/2016 02:59'!
parserClassForContentModel: aContentModel
	"the tokenizer removes all spaces from the content model
	and checks it for well-formedness"
	(aContentModel at: 1) == $(
		ifTrue: [
			(aContentModel at: 2) == $# "#PCDATA mixed content"
				ifTrue: [^ DTDMixedContentModelParser]
				ifFalse: [^ DTDElementContentModelParser]]
		ifFalse: [^ DTDLiteralContentModelParser]! !

!DTDContentModelParser class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:44'!
standaloneExternalClass
	^ self! !

!DTDContentModelParser methodsFor: 'parsing' stamp: 'monty 12/21/2013 19:57'!
parse
	self subclassResponsibility! !

!DTDContentModelParser methodsFor: 'initialization' stamp: 'monty 6/7/2015 19:43'!
setElement: anElement contentModel: aContentModel
	element := anElement.
	contentModel := aContentModel.! !

DTDContentModelParser subclass: #DTDElementContentModelParser
	instanceVariableNames: 'nfaBuilder binaryOperatorStack'
	classVariableNames: 'OperatorApplicators SpecialCharacterParsers'
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDElementContentModelParser commentStamp: 'monty 10/15/2016 00:27' prior: 0!
This class parses element content models. It uses postfix conversion and an XMLNFABuilder to build an NFA before converting it to a lazy DFA (states are built when needed and cached) and returns it as an XMLElementValidator.

It assumes all spaces have been removed from the input and that it's been checked for well-formedness, meaning no missing names or misplaced operators/parentheses.!

!DTDElementContentModelParser class methodsFor: 'class initialization' stamp: 'monty 4/1/2016 22:59'!
initialize
	"self initialize"

	self
		initializeSpecialCharacterParsers;
		initializeOperatorApplicators! !

DTDElementContentModelParser initialize!

!DTDElementContentModelParser class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 15:58'!
initializeOperatorApplicators
	"use an array instead of a dictionary for speed, and
	assign after with #yourself to avoid possible race
	conditions when reinitializing the class"
	OperatorApplicators :=
		(Array new: 255)
			at: $, asciiValue put: #applyConcatenation;
			at: $| asciiValue put: #applyBranch;
			at: $? asciiValue put: #applyOptional;
			at: $* asciiValue put: #applyStar;
			at: $+ asciiValue put: #applyPlus;
			yourself! !

!DTDElementContentModelParser class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 15:59'!
initializeSpecialCharacterParsers
	"use an array instead of a dictionary for speed, and
	assign after with #yourself to avoid possible race
	conditions when reinitializing the class"
	SpecialCharacterParsers :=
		(Array new: 255)
			at: $( asciiValue put: #parseOpeningParenthesis:;
			at: $) asciiValue put: #parseClosingParenthesis:;
			at: $, asciiValue put: #parseBinaryOperator:;
			at: $| asciiValue put: #parseBinaryOperator:;
			at: $? asciiValue put: #parseUnaryOperator:;
			at: $* asciiValue put: #parseUnaryOperator:;
			at: $+ asciiValue put: #parseUnaryOperator:;
			yourself! !

!DTDElementContentModelParser class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:44'!
standaloneExternalClass
	^ DTDStandaloneExternalElementContentModelParser! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 21:40'!
applyBinaryOperatorOnStack
	self applyOperator: binaryOperatorStack removeLast! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 23:03'!
applyOperator: aCharacter
	nfaBuilder perform: (OperatorApplicators at: aCharacter asciiValue)! !

!DTDElementContentModelParser methodsFor: 'defaults' stamp: 'monty 11/1/2016 07:51'!
elementValidatorClass
	^ XMLDFAElementContentElementValidator! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 21:44'!
hasBinaryOperatorOnStack
	^ (binaryOperatorStack isEmpty
		or: [binaryOperatorStack last == $(]) not! !

!DTDElementContentModelParser methodsFor: 'parsing' stamp: 'monty 11/1/2016 07:51'!
parse
	"the tokenizer removes all spaces from the content model and checks
	it for well-formedness (meaning no missing names or misplaced
	operators/parentheses), which simplifies parsing"
	| nameStart |

	binaryOperatorStack := OrderedCollection new.
	nfaBuilder := XMLNFABuilder new.
	1 to: contentModel size do: [:i |
		(self parserForSpecialCharacter: (contentModel at: i))
			ifNil: [
				nameStart
					ifNil: [nameStart := i]]
			ifNotNil: [:selector |
				nameStart
					ifNotNil: [
						nfaBuilder pushMatcher:
							(contentModel copyFrom: nameStart to: i - 1).
						nameStart := nil].
				self
					perform: selector
					with: (contentModel at: i)]].
	self popRemainingBinaryOperators.

	^ self elementValidatorClass
		element: element
		dfa: nfaBuilder buildAcceptingNFAFromFragments asDFAState.! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 21:39'!
parseBinaryOperator: aCharacter
	binaryOperatorStack addLast: aCharacter! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 23:02'!
parseClosingParenthesis: aCharacter
	self popRemainingBinaryOperators.
	(binaryOperatorStack notEmpty
		and: [binaryOperatorStack last == $(])
		ifTrue: [binaryOperatorStack removeLast].! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 23:02'!
parseOpeningParenthesis: aCharacter
	binaryOperatorStack addLast: $(! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 21:39'!
parseUnaryOperator: aCharacter
	self applyOperator: aCharacter! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 1/8/2016 07:08'!
parserForSpecialCharacter: aCharacter
	| asciiValue |

	"avoid at:ifAbsent: for speed"
	((asciiValue := aCharacter asciiValue) > 0
		and: [asciiValue <= SpecialCharacterParsers size])
			ifTrue: [^ SpecialCharacterParsers at: asciiValue]
			ifFalse: [^ nil]! !

!DTDElementContentModelParser methodsFor: 'private' stamp: 'monty 4/1/2016 21:44'!
popRemainingBinaryOperators
	[self hasBinaryOperatorOnStack]
		whileTrue: [self applyBinaryOperatorOnStack]! !

DTDElementContentModelParser subclass: #DTDStandaloneExternalElementContentModelParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD-Standalone'!

!DTDStandaloneExternalElementContentModelParser commentStamp: 'monty 11/5/2016 04:05' prior: 0!
This class parses standalone externally defined element content models and returns XMLElementValidators for them. Validators for content models that specify element content like "(one|two+)" won't treat whitespace as ignorable.!

!DTDStandaloneExternalElementContentModelParser methodsFor: 'defaults' stamp: 'monty 11/1/2016 07:52'!
elementValidatorClass
	^ XMLStandaloneExternalDFAElementContentElementValidator! !

DTDContentModelParser subclass: #DTDLiteralContentModelParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDLiteralContentModelParser commentStamp: 'monty 10/14/2016 20:24' prior: 0!
This class parses literal "ANY" and "EMPTY" element content models and returns XMLElementValidators accepting any content or no content (not even whitespace, comments, or PIs).!

!DTDLiteralContentModelParser methodsFor: 'parsing' stamp: 'monty 2/20/2016 10:14'!
parse
	"either ANY or EMPTY"
	(contentModel at: 1) == $A
		ifTrue: [^ XMLAnyElementValidator element: element]
		ifFalse: [^ XMLEmptyElementValidator element: element]! !

DTDContentModelParser subclass: #DTDMixedContentModelParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDMixedContentModelParser commentStamp: 'monty 10/14/2016 20:25' prior: 0!
This class parses mixed content declarations like "(#PCDATA|one|two)*" using a DTDEnumerationListParser and returns an XMLElementValidator accepting any sequence of PCDATA and the named elements in any order.!

!DTDMixedContentModelParser methodsFor: 'parsing' stamp: 'monty 11/12/2016 12:25'!
parse
	^ XMLMixedContentElementValidator
		element: element
		allowedContent:
			(DTDMixedContentEnumerationListParser on: contentModel)
				parse! !

Object subclass: #DTDDoctypeDefinition
	instanceVariableNames: 'root elementValidators attributeValidators generalEntities parameterEntities unparsedEntities notations elementIDValidator unparsedEntityValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDDoctypeDefinition commentStamp: 'monty 4/6/2015 08:06' prior: 0!
This class represents the parsed internal and external subset of a DTD taken together.!

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:48'!
addExternalGeneralEntity: aName resolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put:
			(DTDExternalGeneralParsedEntity
				name: aName
				resolver: aResolver
				publicID: aPublicID
				systemID: aSystemID
				baseURI: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:49'!
addExternalParameterEntity: aName resolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	(self parameterEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self parameterEntities
		at: aName
		put:
			(DTDExternalParameterParsedEntity
				name: aName
				resolver: aResolver
				publicID: aPublicID
				systemID: aSystemID
				baseURI: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 5/9/2015 16:50'!
addGeneralEntitiesFrom: aDoctypeDefinition
	aDoctypeDefinition generalEntities keysAndValuesDo: [:name :entity |
		self generalEntities
			at: name
			ifAbsentPut: [entity]]! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:49'!
addInternalGeneralEntity: aName replacement: aReplacement baseURI: aBaseURIString
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put:
			(DTDInternalGeneralParsedEntity 
				name: aName
				replacement: aReplacement
				uri: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:49'!
addInternalParameterEntity: aName replacement: aReplacement baseURI: aBaseURIString
	(self parameterEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self parameterEntities
		at: aName
		put:
			(DTDInternalParameterParsedEntity
				name: aName
				replacement: aReplacement
				uri: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/19/2016 13:58'!
addNotation: aName publicID: aPublicID systemID: aSystemID
	(self notations includesKey: aName)
		ifTrue: [^ nil].
	^ self notations
		at: aName
		put:
			(DTDNotation
				name: aName
				publicID: aPublicID
				systemID: aSystemID).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/17/2017 01:38'!
addStandaloneExternalExternalGeneralEntity: aName resolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put:
			(DTDStandaloneExternalExternalGeneralParsedEntity
				name: aName
				resolver: aResolver
				publicID: aPublicID
				systemID: aSystemID
				baseURI: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/17/2017 01:38'!
addStandaloneExternalInternalGeneralEntity: aName replacement: aReplacement baseURI: aBaseURIString
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put:
			(DTDStandaloneExternalInternalGeneralParsedEntity 
				name: aName
				replacement: aReplacement
				uri: aBaseURIString).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/11/2016 18:53'!
addStandaloneExternalValidatorForAttributeIn: anElement named: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	| attributes |

	attributes :=
		self attributeValidators
			at: anElement
			ifAbsentPut: [Dictionary new].
	(attributes includesKey: anAttribute)
		ifTrue: [^ nil].
	^ attributes
		at: anAttribute
		put:
			((DTDStandaloneExternalAttributeDefinitionParser
				element: anElement
				attribute: anAttribute
				type: aType
				defaultPragma: aDefaultPragma
				defaultValue: aDefaultValue) parse
					initializeWithValidatorsFrom: self).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/11/2016 18:52'!
addStandaloneExternalValidatorForElement: anElement contentModel: aContentModel
	(self elementValidators includesKey: anElement)
		ifTrue: [^ nil].
	^ self elementValidators
		at: anElement
		put:
			((DTDContentModelParser parserClassForContentModel: aContentModel)
				standaloneExternalClass
					element: anElement
					contentModel: aContentModel) parse.! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/19/2016 19:04'!
addUnparsedEntity: aName publicID: aPublicID systemID: aSystemID ndata: aNotation
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put:
			(self unparsedEntities
				at: aName
				put:
					(DTDUnparsedEntity
						name: aName
						publicID: aPublicID
						systemID: aSystemID
						ndata: aNotation)).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:49'!
addUnresolvableExternalGeneralEntity: aName
	(self generalEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self generalEntities
		at: aName
		put: (DTDUnresolvableExternalGeneralParsedEntity named: aName).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 10/16/2017 22:49'!
addUnresolvableExternalParameterEntity: aName
	(self parameterEntities includesKey: aName)
		ifTrue: [^ nil].
	^ self parameterEntities
		at: aName
		put: (DTDUnresolvableExternalParameterParsedEntity named: aName).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/11/2016 18:48'!
addValidatorForAttributeIn: anElement named: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	| attributes |

	attributes :=
		self attributeValidators
			at: anElement
			ifAbsentPut: [Dictionary new].
	(attributes includesKey: anAttribute)
		ifTrue: [^ nil].
	^ attributes
		at: anAttribute
		put:
			((DTDAttributeDefinitionParser
				element: anElement
				attribute: anAttribute
				type: aType
				defaultPragma: aDefaultPragma
				defaultValue: aDefaultValue) parse
					initializeWithValidatorsFrom: self).! !

!DTDDoctypeDefinition methodsFor: 'adding' stamp: 'monty 11/11/2016 18:46'!
addValidatorForElement: anElement contentModel: aContentModel
	(self elementValidators includesKey: anElement)
		ifTrue: [^ nil].
	^ self elementValidators
		at: anElement
		put:
			((DTDContentModelParser parserClassForContentModel: aContentModel)
				element: anElement
				contentModel: aContentModel) parse.! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/19/2013 01:01'!
attributeValidators
	^ attributeValidators ifNil: [attributeValidators := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 7/13/2016 00:21'!
attributeValidatorsAt: aName
	^ self
		attributeValidatorsAt: aName
		ifAbsent: [nil]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 7/13/2016 00:21'!
attributeValidatorsAt: aName ifAbsent: aBlock
	^ self attributeValidators
		at: aName
		ifAbsent: aBlock! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 3/21/2015 23:03'!
elementIDValidator
	^ elementIDValidator ifNil: [elementIDValidator := XMLElementIDValidator new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/18/2013 19:26'!
elementValidators
	^ elementValidators ifNil: [elementValidators := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 7/13/2016 00:21'!
elementValidatorsAt: aName
	^ self
		elementValidatorsAt: aName
		ifAbsent: [nil]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 7/13/2016 00:22'!
elementValidatorsAt: aName ifAbsent: aBlock
	^ self elementValidators
		at: aName
		ifAbsent: aBlock! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/14/2013 20:51'!
generalEntities
	^ generalEntities ifNil: [generalEntities := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 1/3/2015 03:11'!
generalEntityAt: aName
	^ self
		generalEntityAt: aName
		ifAbsent: [nil]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 1/3/2015 03:11'!
generalEntityAt: aName ifAbsent: aBlock
	^ self generalEntities
		at: aName
		ifAbsent: aBlock! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 3/23/2016 22:01'!
hasAttributeValidators
	"optimized to avoid lazy initialization"
	attributeValidators == nil
		ifTrue: [^ false].
	^ attributeValidators size > 0.! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:48'!
hasElementIDReferences
	"direct access to avoid lazy initialization"
	^ elementIDValidator notNil
		and: [elementIDValidator hasIDReferences]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:45'!
hasElementIDs
	"direct access to avoid lazy initialization"
	^ elementIDValidator notNil
		and: [elementIDValidator hasIDs]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 3/23/2016 22:01'!
hasElementValidators
	"optimized to avoid lazy initialization"
	elementValidators == nil
		ifTrue: [^ false].
	^ elementValidators size > 0.! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 3/8/2015 14:22'!
hasEntities
	^ self hasGeneralEntities
		or: [self hasParameterEntities
			or: [self hasUnparsedEntities]]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:45'!
hasGeneralEntities
	"direct access to avoid lazy initialization"
	^ generalEntities notNil
		and: [generalEntities notEmpty]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 7/13/2016 01:56'!
hasNotationAttributeValidators
	^ self hasAttributeValidators
		and: [self unparsedEntityValidator hasNotationAttributeValidators]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:46'!
hasNotations
	"direct access to avoid lazy initialization"
	^ notations notNil
		and: [notations notEmpty]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:45'!
hasParameterEntities
	"direct access to avoid lazy initialization"
	^ parameterEntities notNil
		and: [parameterEntities notEmpty]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 4/24/2015 18:28'!
hasRoot
	^ root notNil and: [root notEmpty]! !

!DTDDoctypeDefinition methodsFor: 'testing' stamp: 'monty 9/21/2016 13:45'!
hasUnparsedEntities
	"direct access to avoid lazy initialization"
	^ unparsedEntities notNil
		and: [unparsedEntities notEmpty]! !

!DTDDoctypeDefinition methodsFor: 'instance creation' stamp: 'monty 3/18/2016 01:10'!
newValidator
	^ DTDDocumentValidator doctypeDefinition: self! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/19/2016 14:05'!
notations
	^ notations ifNil: [notations := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/14/2013 20:51'!
parameterEntities
	^ parameterEntities ifNil: [parameterEntities := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 1/3/2015 03:11'!
parameterEntityAt: aName
	^ self
		parameterEntityAt: aName
		ifAbsent: [nil]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 1/3/2015 03:11'!
parameterEntityAt: aName ifAbsent: aBlock
	^ self parameterEntities
		at: aName
		ifAbsent: aBlock! !

!DTDDoctypeDefinition methodsFor: 'processing' stamp: 'monty 11/12/2016 19:40'!
processStartTag: anElement attributes: aDictionary
	self hasAttributeValidators
		ifFalse: [^ self].
	(self
		attributeValidatorsAt: anElement
		ifAbsent: [^ self])
		valuesDo: [:each | each processAttributes: aDictionary]! !

!DTDDoctypeDefinition methodsFor: 'removing' stamp: 'monty 9/21/2016 13:55'!
removeElementIDReferences
	self hasElementIDReferences
		ifTrue: [self elementIDValidator removeIDReferences]! !

!DTDDoctypeDefinition methodsFor: 'removing' stamp: 'monty 9/21/2016 13:55'!
removeElementIDs
	self hasElementIDs
		ifTrue: [self elementIDValidator removeIDs]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:56'!
root
	^ root ifNil: [root := '']! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 3/8/2015 09:42'!
root: aRootElement
	root := aRootElement! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 11/14/2013 23:50'!
unparsedEntities
	^ unparsedEntities ifNil: [unparsedEntities := Dictionary new]! !

!DTDDoctypeDefinition methodsFor: 'accessing' stamp: 'monty 1/1/2015 20:48'!
unparsedEntityValidator
	^ unparsedEntityValidator
		ifNil: [
			unparsedEntityValidator :=
				XMLUnparsedEntityValidator
					unparsedEntities: self unparsedEntities
					notations: self notations]! !

!DTDDoctypeDefinition methodsFor: 'validation' stamp: 'monty 11/19/2016 14:04'!
validateCompletedDefinition
	self hasUnparsedEntities
		ifTrue: [self unparsedEntityValidator validateUnparsedEntityDeclarations].
	self hasNotationAttributeValidators
		ifTrue: [self unparsedEntityValidator validateNotationAttributeDeclarationDefaults].! !

Object subclass: #DTDEntity
	instanceVariableNames: 'name uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDEntity commentStamp: 'monty 10/17/2017 01:56' prior: 0!
This is an abstract base class for internal and external parsed entities with replacements that can be inserted into an XML document.!

!DTDEntity class methodsFor: 'instance creation' stamp: 'monty 6/5/2017 16:35'!
name: aName
	^ self named: aName! !

!DTDEntity class methodsFor: 'instance creation' stamp: 'monty 10/15/2017 04:57'!
named: aName
	^ self new name: aName! !

!DTDEntity methodsFor: 'converting' stamp: 'monty 4/24/2015 14:25'!
asReference
	^ String streamContents: [:stream | self printReferenceOn: stream]! !

!DTDEntity methodsFor: 'testing' stamp: 'monty 11/16/2013 02:56'!
isExternal
	^ false! !

!DTDEntity methodsFor: 'testing' stamp: 'monty 4/3/2016 04:05'!
isParameter
	^ false! !

!DTDEntity methodsFor: 'testing' stamp: 'monty 11/1/2016 22:56'!
isStandaloneExternal
	^ false! !

!DTDEntity methodsFor: 'testing' stamp: 'monty 7/12/2016 23:53'!
isUnparsed
	^ false! !

!DTDEntity methodsFor: 'accessing' stamp: 'monty 11/13/2013 23:45'!
name
	^ name ifNil: [name := '']! !

!DTDEntity methodsFor: 'accessing' stamp: 'monty 4/8/2016 02:54'!
name: aName
	name := aName! !

!DTDEntity methodsFor: 'printing' stamp: 'monty 4/8/2016 06:23'!
printNameOn: aStream
	aStream nextPutAll: self name! !

!DTDEntity methodsFor: 'printing' stamp: 'monty 4/8/2016 06:23'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self printNameOn: aStream.
	aStream nextPut: $).! !

!DTDEntity methodsFor: 'printing' stamp: 'monty 4/8/2016 01:25'!
printReferenceOn: aStream
	aStream
		nextPut: self referencePrefix;
		nextPutAll: self name;
		nextPut: $;! !

!DTDEntity methodsFor: 'private ' stamp: 'monty 4/8/2016 01:21'!
referencePrefix
	^ self isParameter
		ifTrue: [$%]
		ifFalse: [$&]! !

!DTDEntity methodsFor: 'accessing' stamp: 'monty 11/16/2013 02:55'!
uri
	^ uri ifNil: [uri := '']! !

!DTDEntity methodsFor: 'accessing' stamp: 'monty 4/8/2016 02:55'!
uri: aURIString
	uri := aURIString! !

DTDEntity subclass: #DTDParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDParsedEntity commentStamp: 'monty 10/17/2017 01:55' prior: 0!
This is an abstract base class for parsed entities with replacements that can be inserted into an XML document.!

DTDParsedEntity subclass: #DTDExternalParsedEntity
	instanceVariableNames: 'unresolvedReplacement resolvedReplacement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalParsedEntity commentStamp: 'monty 10/17/2017 01:55' prior: 0!
This is an abstract base class for external parsed entities with external replacements that can be inserted into an XML document.

The external replacements are resolved lazily the first time #replacement or #replacementStream is sent.!

DTDExternalParsedEntity subclass: #DTDExternalGeneralParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalGeneralParsedEntity commentStamp: 'monty 4/8/2016 17:52' prior: 0!
This is a class for external general parsed entities with external replacements that can be inserted into an XML document.!

DTDExternalGeneralParsedEntity subclass: #DTDStandaloneExternalExternalGeneralParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD-Standalone'!

!DTDStandaloneExternalExternalGeneralParsedEntity commentStamp: 'monty 11/3/2016 12:29' prior: 0!
This is a class for standalone externally defined external general entities that cannot be referenced in documents.!

!DTDStandaloneExternalExternalGeneralParsedEntity methodsFor: 'testing' stamp: 'monty 11/2/2016 03:26'!
isStandaloneExternal
	^ true! !

DTDExternalParsedEntity subclass: #DTDExternalParameterParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalParameterParsedEntity commentStamp: 'monty 4/8/2016 17:52' prior: 0!
This is a class for external parameter parsed entities with external replacements that can be inserted into an XML document.!

!DTDExternalParameterParsedEntity methodsFor: 'testing' stamp: 'monty 4/8/2016 01:21'!
isParameter
	^ true! !

!DTDExternalParsedEntity class methodsFor: 'instance creation' stamp: 'monty 10/16/2017 23:48'!
name: aName resolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	^ self new
		setName: aName
		unresolvedReplacement:
			(DTDUnresolvedExternalParsedEntityReplacement
				resolver: aResolver
				publicID: aPublicID
				systemID: aSystemID
				baseURI: aBaseURIString)! !

!DTDExternalParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 07:07'!
hasReplacement
	^ self resolvedReplacement notEmpty! !

!DTDExternalParsedEntity methodsFor: 'testing' stamp: 'monty 4/8/2016 17:37'!
hasUnresolvedReplacement
	^ self unresolvedReplacement notNil! !

!DTDExternalParsedEntity methodsFor: 'testing' stamp: 'monty 4/8/2016 01:21'!
isExternal
	^ true! !

!DTDExternalParsedEntity methodsFor: 'printing' stamp: 'monty 4/8/2016 07:30'!
printNameOn: aStream
	aStream
		nextPut: ${;
		nextPutAll: self uri;
		nextPut: $}.
	super printNameOn: aStream.! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 07:07'!
replacement
	^ self resolvedReplacement contents! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 05:56'!
replacementStream
	^ self resolvedReplacement readStream! !

!DTDExternalParsedEntity methodsFor: 'resolving' stamp: 'monty 10/16/2017 05:55'!
resolveUnresolvedReplacement
	self hasUnresolvedReplacement
		ifTrue: [self unresolvedReplacement resolveForExternalEntity: self]! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 05:55'!
resolvedReplacement
	self resolveUnresolvedReplacement.
	^ resolvedReplacement.! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 05:54'!
resolvedReplacement: aResolvedReplacement
	resolvedReplacement := aResolvedReplacement! !

!DTDExternalParsedEntity methodsFor: 'initialization' stamp: 'monty 4/9/2016 04:08'!
setName: aName unresolvedReplacement: anUnresolvedReplacement
	name := aName.
	unresolvedReplacement := anUnresolvedReplacement.! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 4/8/2016 17:37'!
unresolvedReplacement
	^ unresolvedReplacement! !

!DTDExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 4/9/2016 04:07'!
unresolvedReplacement: anUnresolvedReplacement
	unresolvedReplacement := anUnresolvedReplacement! !

DTDParsedEntity subclass: #DTDInternalParsedEntity
	instanceVariableNames: 'replacement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDInternalParsedEntity commentStamp: 'monty 10/17/2017 01:56' prior: 0!
This is an abstract base class for internal parsed entities with replacements that can be inserted into an XML document.!

DTDInternalParsedEntity subclass: #DTDInternalGeneralParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDInternalGeneralParsedEntity commentStamp: 'monty 4/8/2016 01:27' prior: 0!
This is a class for internal general parsed entities with replacements that can be inserted into documents.!

DTDInternalGeneralParsedEntity subclass: #DTDStandaloneExternalInternalGeneralParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD-Standalone'!

!DTDStandaloneExternalInternalGeneralParsedEntity commentStamp: 'monty 11/3/2016 12:29' prior: 0!
This is a class for standalone externally defined external general entities that cannot be referenced in documents except in ATTLIST attribute declaration default values.!

!DTDStandaloneExternalInternalGeneralParsedEntity methodsFor: 'testing' stamp: 'monty 11/2/2016 03:26'!
isStandaloneExternal
	^ true! !

DTDInternalParsedEntity subclass: #DTDInternalParameterParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDInternalParameterParsedEntity commentStamp: 'monty 4/8/2016 01:27' prior: 0!
This is a class for internal parameter parsed entities with replacements that can be inserted into documents.!

!DTDInternalParameterParsedEntity methodsFor: 'testing' stamp: 'monty 4/3/2016 04:05'!
isParameter
	^ true! !

!DTDInternalParsedEntity class methodsFor: 'instance creation' stamp: 'monty 10/15/2017 04:54'!
name: aName replacement: aReplacementString
	^ self
		name: aName
		replacement: aReplacementString
		uri: ''! !

!DTDInternalParsedEntity class methodsFor: 'instance creation' stamp: 'monty 10/15/2017 04:54'!
name: aName replacement: aReplacementString uri: aURIString
	^ self new
		setName: aName
		replacement: aReplacementString
		uri: aURIString! !

!DTDInternalParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 07:07'!
hasReplacement
	^ self replacement notEmpty! !

!DTDInternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/15/2017 04:54'!
replacement
	^ replacement ifNil: [replacement := '']! !

!DTDInternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/15/2017 04:54'!
replacement: aReplacementString
	replacement := aReplacementString! !

!DTDInternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/15/2017 04:54'!
replacementStream
	^ self replacement readStream! !

!DTDInternalParsedEntity methodsFor: 'initialization' stamp: 'monty 10/15/2017 04:56'!
setName: aName replacement: aReplacementString uri: aURIString
	name := aName.
	replacement := aReplacementString.
	uri := aURIString.! !

!DTDParsedEntity methodsFor: 'converting' stamp: 'monty 10/15/2017 05:19'!
asPushedBackEntity
	^ self isParameter
		ifTrue: [XMLPushedBackParameterEntity entity: self]
		ifFalse: [XMLPushedBackGeneralEntity entity: self]! !

!DTDParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 07:21'!
hasReplacement
	self subclassResponsibility! !

!DTDParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 07:21'!
replacement
	self subclassResponsibility! !

!DTDParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 07:20'!
replacementStream
	self subclassResponsibility! !

DTDParsedEntity subclass: #DTDUnresolvableExternalParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUnresolvableExternalParsedEntity commentStamp: 'monty 10/17/2017 01:56' prior: 0!
This is an abstract base class for unresolvable external parsed entities that lazily raises an error when #replacement or #replacementStream is sent, which would normally trigger resolution.!

DTDUnresolvableExternalParsedEntity subclass: #DTDUnresolvableExternalGeneralParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUnresolvableExternalGeneralParsedEntity commentStamp: 'monty 10/17/2017 01:35' prior: 0!
This is a class for unresolvable external general parsed entities that lazily raises an error when #replacement or #replacementStream is sent, which would normally trigger resolution.!

DTDUnresolvableExternalParsedEntity subclass: #DTDUnresolvableExternalParameterParsedEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUnresolvableExternalParameterParsedEntity commentStamp: 'monty 10/17/2017 01:35' prior: 0!
This is a class for unresolvable external parameter parsed entities that lazily raises an error when #replacement or #replacementStream is sent, which would normally trigger resolution.!

!DTDUnresolvableExternalParameterParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 22:46'!
isParameter
	^ true! !

!DTDUnresolvableExternalParsedEntity methodsFor: 'private' stamp: 'monty 10/16/2017 22:45'!
errorUnresolvableExternalEntity
	XMLParserException
		formatSignal:
			'External entity {1} can''t be resolved unless resolution is ',
			'enabled; use #resolvesExternalEntityReferences: before parsing ',
			'to enable'
		with: self asReference! !

!DTDUnresolvableExternalParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 22:45'!
hasReplacement
	^ true! !

!DTDUnresolvableExternalParsedEntity methodsFor: 'testing' stamp: 'monty 10/16/2017 22:46'!
isExternal
	^ true! !

!DTDUnresolvableExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 22:45'!
replacement
	self errorUnresolvableExternalEntity! !

!DTDUnresolvableExternalParsedEntity methodsFor: 'accessing' stamp: 'monty 10/16/2017 22:44'!
replacementStream
	self errorUnresolvableExternalEntity! !

DTDEntity subclass: #DTDUnparsedEntity
	instanceVariableNames: 'ndata publicID systemID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUnparsedEntity commentStamp: 'monty 7/18/2016 03:19' prior: 0!
A class for unparsed entities. These should never be referenced with the &name; syntax but can be named in values of ENTITY and ENTITIES attributes.!

!DTDUnparsedEntity class methodsFor: 'instance creation' stamp: 'monty 11/19/2016 19:02'!
name: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	^ self new
		setName: aName
		publicID: aPublicID
		systemID: aSystemID
		ndata: aNotationName! !

!DTDUnparsedEntity methodsFor: 'testing' stamp: 'monty 7/12/2016 23:54'!
isUnparsed
	^ true! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 7/13/2016 02:15'!
ndata
	^ ndata ifNil: [ndata := '']! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 7/12/2016 23:52'!
ndata: aNotationName
	ndata := aNotationName! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 11/19/2016 19:03'!
publicID
	^ publicID ifNil: [publicID := '']! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 11/19/2016 19:03'!
publicID: aPublicID
	publicID := aPublicID! !

!DTDUnparsedEntity methodsFor: 'initialization' stamp: 'monty 11/19/2016 19:02'!
setName: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	name := aName.
	publicID := aPublicID.
	systemID := aSystemID.
	ndata := aNotationName.! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 11/19/2016 19:03'!
systemID
	^ systemID ifNil: [systemID := '']! !

!DTDUnparsedEntity methodsFor: 'accessing' stamp: 'monty 11/19/2016 19:03'!
systemID: aSystemID
	systemID := aSystemID! !

Object subclass: #DTDEntityConfiguration
	instanceVariableNames: 'replacesContentEntityReferences resolvesExternalEntities preservesUndeclaredEntityReferences externalEntityResolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDEntityConfiguration commentStamp: 'monty 1/3/2015 04:39' prior: 0!
This class contains configurations for entity replacement/retrieval. It is separate from XMLConfiguration so it is only lazy initialized when needed and saves memory.!

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 4/8/2016 03:05'!
externalEntityResolver
	"uses the caching resolver by default"
	^ externalEntityResolver
		ifNil: [externalEntityResolver := DTDExternalEntityResolver default]! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:22'!
externalEntityResolver: anExternalEntityResolver
	externalEntityResolver := anExternalEntityResolver! !

!DTDEntityConfiguration methodsFor: 'copying' stamp: 'monty 6/19/2015 20:34'!
postCopy
	super postCopy.

	externalEntityResolver
		ifNotNil: [externalEntityResolver := externalEntityResolver copy].! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 11/23/2016 23:00'!
preservesUndeclaredEntityReferences
	^ preservesUndeclaredEntityReferences
		ifNil: [preservesUndeclaredEntityReferences := false]! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/6/2015 04:13'!
preservesUndeclaredEntityReferences: aBoolean
	preservesUndeclaredEntityReferences := aBoolean! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/6/2015 09:37'!
replacesContentEntityReferences
	^ replacesContentEntityReferences ifNil: [replacesContentEntityReferences := true]! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/6/2015 09:37'!
replacesContentEntityReferences: aBoolean
	replacesContentEntityReferences := aBoolean! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:22'!
resolvesExternalEntities
	^ resolvesExternalEntities ifNil: [resolvesExternalEntities := false]! !

!DTDEntityConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:22'!
resolvesExternalEntities: aBoolean
	resolvesExternalEntities := aBoolean! !

Object subclass: #DTDEnumerationListParser
	instanceVariableNames: 'listString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDEnumerationListParser commentStamp: 'monty 11/14/2016 13:51' prior: 0!
This is a parser of lists in the form of "(one|two|...)".  It assumes there is no whitespace around the "|" separated list values.!

!DTDEnumerationListParser class methodsFor: 'instance creation' stamp: 'monty 10/30/2014 12:58'!
on: aString
	^ self new on: aString! !

!DTDEnumerationListParser methodsFor: 'private' stamp: 'monty 10/31/2014 21:20'!
errorDuplicateListValue: aValue
	XMLValidationException
		formatSignal: 'Duplicate value "{1}" in list'
		with: aValue! !

!DTDEnumerationListParser methodsFor: 'private' stamp: 'monty 11/12/2016 09:19'!
listEndOffset
	^ 1 "')' size"! !

!DTDEnumerationListParser methodsFor: 'private' stamp: 'monty 11/12/2016 09:19'!
listStartOffset
	^ 1 "'(' size"! !

!DTDEnumerationListParser methodsFor: 'initialization' stamp: 'monty 11/12/2016 09:24'!
on: aString
	listString := aString! !

!DTDEnumerationListParser methodsFor: 'parsing' stamp: 'monty 2/13/2017 22:53'!
parse
	"the tokenizer removes all spaces from lists"
	| listStartIndex listEndIndex totalListValues listValues nextListValuesIndex nextValueStartIndex |

	listStartIndex := 1 + self listStartOffset.
	listEndIndex := listString size - self listEndOffset.
	"count the values to preallocate an Array"
	totalListValues := 1.
	listStartIndex to: listEndIndex do: [:i |
		(listString at: i) == $|
			ifTrue: [totalListValues := totalListValues + 1]].

	listValues := Array new: totalListValues.
	nextListValuesIndex := 1.
	nextValueStartIndex := listStartIndex.
	listStartIndex to: listEndIndex do: [:i | 
		(listString at: i) == $|
			ifTrue: [
				listValues
					at: nextListValuesIndex
					put:
						(listString
							copyFrom: nextValueStartIndex
							to: i - 1).
				nextListValuesIndex := nextListValuesIndex + 1.
				nextValueStartIndex := i + 1]].
	listValues
		at: nextListValuesIndex
		put:
			(listString
				copyFrom: nextValueStartIndex
				to: listEndIndex).

	^ listValues.! !

DTDEnumerationListParser subclass: #DTDMixedContentEnumerationListParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDMixedContentEnumerationListParser commentStamp: 'monty 11/14/2016 13:52' prior: 0!
This is a parser of mixed content lists in the form of "(#PCDATA|one|two|...)*".  It assumes there is no whitespace around the "|" separated list values.!

!DTDMixedContentEnumerationListParser methodsFor: 'private' stamp: 'monty 11/14/2016 13:52'!
listEndOffset
	^ listString last == $*
		ifTrue: [2] "')*' size"
		ifFalse: [1] "')' size"! !

DTDEnumerationListParser subclass: #DTDNotationEnumerationListParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDNotationEnumerationListParser commentStamp: 'monty 11/14/2016 13:51' prior: 0!
This class parses notation attribute value lists in the form of "NOTATION (one|two|...)". It assumes there is no whitespace around the "|" separated list values.!

!DTDNotationEnumerationListParser methodsFor: 'private' stamp: 'monty 11/12/2016 09:20'!
listStartOffset
	^ 10 "'NOTATION (' size"! !

Object subclass: #DTDExternalEntityLimits
	instanceVariableNames: 'externalSubsetReadLimit maxExternalEntities maxExternalEntitySize resolvesLocalFromNonLocal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalEntityLimits commentStamp: 'monty 1/25/2014 04:01' prior: 0!
This class places security limits on the number and size of external parsed entities. You can set these using the configuration messages in DTDExternalEntityResolver or remove them using removeLimits.!

!DTDExternalEntityLimits class methodsFor: 'accessing' stamp: 'monty 1/27/2015 22:48'!
defaultExternalSubsetReadLimit
	^ XMLParserLimits defaultReadLimit
		ifNotNil: [:limit | (limit / 4) asInteger]! !

!DTDExternalEntityLimits class methodsFor: 'accessing' stamp: 'monty 6/21/2015 02:02'!
defaultMaxExternalEntities
	^ 20! !

!DTDExternalEntityLimits class methodsFor: 'accessing' stamp: 'monty 12/9/2014 07:57'!
defaultMaxExternalEntitySize
	^ 2500000! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 1/27/2015 22:46'!
externalSubsetReadLimit
	^ externalSubsetReadLimit! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:31'!
externalSubsetReadLimit: anInteger
	externalSubsetReadLimit := anInteger! !

!DTDExternalEntityLimits methodsFor: 'initialization' stamp: 'monty 6/21/2015 02:02'!
initialize
	super initialize.

	externalSubsetReadLimit := self class defaultExternalSubsetReadLimit.
	maxExternalEntities := self class defaultMaxExternalEntities.
	maxExternalEntitySize := self class defaultMaxExternalEntitySize.
	resolvesLocalFromNonLocal := false.! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 1/16/2014 06:14'!
maxExternalEntities
	^ maxExternalEntities! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:31'!
maxExternalEntities: anInteger
	maxExternalEntities := anInteger! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 1/16/2014 06:14'!
maxExternalEntitySize
	^ maxExternalEntitySize! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:31'!
maxExternalEntitySize: anInteger
	maxExternalEntitySize := anInteger! !

!DTDExternalEntityLimits methodsFor: 'removing' stamp: 'monty 5/25/2015 01:35'!
removeAll
	externalSubsetReadLimit := nil.
	maxExternalEntities := nil.
	maxExternalEntitySize := nil.
	resolvesLocalFromNonLocal := true.! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 1/24/2014 06:47'!
resolvesLocalFromNonLocal
	^ resolvesLocalFromNonLocal! !

!DTDExternalEntityLimits methodsFor: 'accessing' stamp: 'monty 1/24/2014 06:47'!
resolvesLocalFromNonLocal: aBoolean
	resolvesLocalFromNonLocal := aBoolean! !

Object subclass: #DTDExternalEntityResolver
	instanceVariableNames: 'externalEntityLimits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalEntityResolver commentStamp: 'monty 10/3/2016 22:52' prior: 0!
This class resolves external entity references using XMLURI, XMLHTTPRequest, and XMLFileHandle.

The #externalEntityURIFromPublicID:systemID: and #externalEntityURIFromPublicID:systemID:baseURI: convert public IDs and system IDs into resolvable XMLURI objects.

The #resolveExternalEntityURI: and #streamResolveExternalEntityURI: messages can resolve external entity XMLURIs or URI strings as either a string or a stream on the undecoded entity content. If the entity is in a file, then #streamResolveExternalEntityURI: can be used to avoid storing it in-memory, but if it's fetched over HTTP, it will just return a stream on the entire in-memory HTTP response.!

DTDExternalEntityResolver subclass: #DTDCachingExternalEntityResolver
	instanceVariableNames: ''
	classVariableNames: 'EntityCache'
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDCachingExternalEntityResolver commentStamp: 'monty 9/30/2016 00:18' prior: 0!
This class is a resolver that caches non-local entities in a global cache so they don't have to be retrieved again (like over HTTP). This is the default resolver.!

!DTDCachingExternalEntityResolver class methodsFor: 'clearing' stamp: 'monty 11/15/2014 20:59'!
clearEntityCache
	"self clearEntityCache"
	self entityCache clear! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:29'!
entityCache
	"a class variable so it's shared by all subclasses, but lazy initialized
	so it isn't initialized unless needed"
	^ EntityCache
		ifNil: [EntityCache := XMLKeyValueCache maxSize: 64]! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 1/20/2017 22:04'!
entityCacheAtURI: anXMLURIOrURIString
	^ self entityCache
		at: anXMLURIOrURIString asXMLURI
		ifAbsent: [nil]! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 3/22/2016 19:43'!
entityCacheAtURI: anXMLURIOrURIString ifAbsent: aBlock
	^ self entityCache
		at: anXMLURIOrURIString asXMLURI
		ifAbsent: aBlock! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 3/22/2016 19:43'!
entityCacheAtURI: anXMLURIOrURIString ifAbsentPut: aBlock
	^ self entityCache
		at: anXMLURIOrURIString asXMLURI
		ifAbsentPut: aBlock! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 2/13/2017 22:40'!
entityCacheAtURI: anXMLURIOrURIString put: aStringOrByteArray
	^ self entityCache
		at: anXMLURIOrURIString asXMLURI
		put: aStringOrByteArray! !

!DTDCachingExternalEntityResolver class methodsFor: 'class initialization' stamp: 'monty 10/17/2017 01:44'!
initialize
	"self initialize"

	"reset to nil instead of just clearing to force reinitialization"
	EntityCache := nil! !

DTDCachingExternalEntityResolver initialize!

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:57'!
maxCachedEntities
	^ self entityCache maxSize! !

!DTDCachingExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:56'!
maxCachedEntities: anInteger
	self entityCache maxSize: anInteger! !

!DTDCachingExternalEntityResolver methodsFor: 'clearing' stamp: 'monty 1/13/2014 03:45'!
clearEntityCache
	self class clearEntityCache! !

!DTDCachingExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 1/13/2014 17:52'!
maxCachedEntities
	^ self class maxCachedEntities! !

!DTDCachingExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 1/13/2014 17:53'!
maxCachedEntities: anInteger
	self class maxCachedEntities: anInteger! !

!DTDCachingExternalEntityResolver methodsFor: 'private' stamp: 'monty 10/16/2017 17:37'!
resolveNonLocalExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	| uri |

	uri := anXMLURIOrURIString asXMLURI.
	"avoid #entityCacheAtURI:ifAbsent: and #entityCacheAtURI:ifAbsentPut:
	so the cache isn't locked during resolution which could stall other
	processes"
	^ (self class entityCacheAtURI: uri)
		ifNil: [
			self class
				entityCacheAtURI: uri
				put:
					(super
						resolveNonLocalExternalEntityURI: uri
						upToLimit: aMaxSize)].! !

!DTDExternalEntityResolver class methodsFor: 'instance creation' stamp: 'monty 4/8/2016 03:03'!
default
	^ self defaultClass new! !

!DTDExternalEntityResolver class methodsFor: 'accessing' stamp: 'monty 4/8/2016 03:04'!
defaultClass
	^ DTDCachingExternalEntityResolver! !

!DTDExternalEntityResolver methodsFor: 'converting' stamp: 'monty 10/4/2017 20:12'!
asLimitingExternalEntityResolver
	^ DTDExternalEntityResolverLimitingDecorator externalEntityResolver: self! !

!DTDExternalEntityResolver methodsFor: 'private' stamp: 'monty 9/12/2017 05:04'!
errorLocalFromNonLocal
	XMLLimitException signal:
		'Local URI referenced from non-local URI; ',
		'use #resolvesLocalFromNonLocal: to change'! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 10/18/2017 17:30'!
externalEntityLimits
	^ externalEntityLimits
		ifNil: [externalEntityLimits := DTDExternalEntityLimits new]! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 3/22/2016 04:41'!
externalEntityLimits: anExternalEntityLimits
	externalEntityLimits := anExternalEntityLimits! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 4/3/2016 00:44'!
externalEntityURIFromPublicID: aPublicID systemID: aSystemID
	^ aSystemID asXMLURI! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 12/27/2017 06:14'!
externalEntityURIFromPublicID: aPublicID systemID: aSystemID baseURI: aBaseXMLURIOrURIString
	| baseURI externalEntityURI |

	baseURI := aBaseXMLURIOrURIString asXMLURI.
	externalEntityURI :=
		baseURI combinedWith:
			(self
				externalEntityURIFromPublicID: aPublicID
				systemID: aSystemID).
	(externalEntityURI isLocal
		and: [baseURI isLocal not
			and: [self resolvesLocalFromNonLocal not]])
		ifTrue: [self errorLocalFromNonLocal].

	^ externalEntityURI.! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 1/27/2015 22:53'!
externalSubsetReadLimit
	^ self externalEntityLimits externalSubsetReadLimit! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 4/14/2016 03:31'!
externalSubsetReadLimit: anInteger
	"change the external subset read limit or nil to disable"

	self externalEntityLimits externalSubsetReadLimit: anInteger! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 1/16/2014 06:17'!
maxExternalEntities
	^ self externalEntityLimits maxExternalEntities! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:47'!
maxExternalEntities: anInteger
	self externalEntityLimits maxExternalEntities: anInteger! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 1/16/2014 06:20'!
maxExternalEntitySize
	^ self externalEntityLimits maxExternalEntitySize! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:48'!
maxExternalEntitySize: anInteger
	self externalEntityLimits maxExternalEntitySize: anInteger! !

!DTDExternalEntityResolver methodsFor: 'copying' stamp: 'monty 9/12/2017 04:43'!
postCopy
	super postCopy.

	externalEntityLimits
		ifNotNil: [externalEntityLimits := externalEntityLimits copy].! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 1/16/2014 06:16'!
removeLimits
	self externalEntityLimits removeAll! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 10/16/2017 17:35'!
resolveExternalEntityURI: anXMLURIOrURIString
	^ self
		resolveExternalEntityURI: anXMLURIOrURIString
		upToLimit: self maxExternalEntitySize! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 12/27/2017 06:14'!
resolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	| uri |

	^ (uri := anXMLURIOrURIString asXMLURI) isLocal
		ifTrue: [
			self
				resolveLocalExternalEntityURI: uri
				upToLimit: aMaxSize]
		ifFalse: [
			self
				resolveNonLocalExternalEntityURI: uri
				upToLimit: aMaxSize]! !

!DTDExternalEntityResolver methodsFor: 'private' stamp: 'monty 1/22/2018 04:22'!
resolveLocalExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	^ DTDUndecodedResolvedExternalParsedEntityReplacement rawContents:
		(anXMLURIOrURIString asXMLFileHandle
			getUpToLimit: aMaxSize
			decoding: false)! !

!DTDExternalEntityResolver methodsFor: 'private' stamp: 'monty 1/15/2018 23:06'!
resolveNonLocalExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	| response |

	response :=
		anXMLURIOrURIString asXMLHTTPRequest
			resolveUpToLimit: aMaxSize
			decoding: false.

	"saves the undecoded replacement with its Content-Type
	charset encoding tag for later decoding (if needed)"
	^ DTDUndecodedResolvedExternalParsedEntityReplacement
		rawContents: response content
		encoding: response contentCharset.! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 1/24/2014 06:50'!
resolvesLocalFromNonLocal
	^ self externalEntityLimits resolvesLocalFromNonLocal! !

!DTDExternalEntityResolver methodsFor: 'configuring' stamp: 'monty 5/25/2015 03:54'!
resolvesLocalFromNonLocal: aBoolean
	"allow non-local (http) entities to reference local (file) entities?
	(default disabled)"

	self externalEntityLimits resolvesLocalFromNonLocal: aBoolean! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 10/16/2017 17:34'!
streamResolveExternalEntityURI: anXMLURIOrURIString
	^ self
		streamResolveExternalEntityURI: anXMLURIOrURIString
		upToLimit: self maxExternalEntitySize! !

!DTDExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 12/27/2017 06:14'!
streamResolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	| uri |

	^ (uri := anXMLURIOrURIString asXMLURI) isLocal
		ifTrue: [
			self
				streamResolveLocalExternalEntityURI: uri
				upToLimit: aMaxSize]
		ifFalse: [
			self
				streamResolveNonLocalExternalEntityURI: uri
				upToLimit: aMaxSize]! !

!DTDExternalEntityResolver methodsFor: 'private' stamp: 'monty 1/21/2018 01:30'!
streamResolveLocalExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	"return our own decoding adapter on the raw, undecoded stream
	to avoid looking for any byte-order mark until later"
	^ XMLDecodingReadStreamAdapter nonDecodingOn:
		(anXMLURIOrURIString asXMLFileHandle
			streamGetUpToLimit: aMaxSize
			decoding: false)! !

!DTDExternalEntityResolver methodsFor: 'private' stamp: 'monty 10/17/2017 01:00'!
streamResolveNonLocalExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	^ (self
		resolveNonLocalExternalEntityURI: anXMLURIOrURIString
		upToLimit: aMaxSize) readStream! !

DTDExternalEntityResolver subclass: #DTDStaticExternalEntityResolver
	instanceVariableNames: 'externalEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDStaticExternalEntityResolver commentStamp: 'monty 6/27/2016 04:13' prior: 0!
This class is a resolver that maps entity URIs to string replacements so resolution can be done without HTTP or file access. Used during testing.!

!DTDStaticExternalEntityResolver class methodsFor: 'instance creation' stamp: 'monty 4/3/2016 00:52'!
externalEntities: anAssociationCollection
	^ self new externalEntities: anAssociationCollection! !

!DTDStaticExternalEntityResolver methodsFor: 'private' stamp: 'monty 4/3/2016 00:54'!
errorMaxExternalEntitySize: aMaxSize exceededByURI: anXMLURIOrURIString
	XMLLimitException
		formatSignal: 'Entity exceeds max size of {1} bytes: {2}'
		with: aMaxSize
		with: anXMLURIOrURIString asString! !

!DTDStaticExternalEntityResolver methodsFor: 'private' stamp: 'monty 4/3/2016 00:54'!
errorUnresolvableExternalEntityURI: anXMLURIOrURIString
	XMLParserException
		formatSignal: 'Unresolvable external entity URI: {1}'
		with: anXMLURIOrURIString asString! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:54'!
externalEntities
	^ externalEntities ifNil: [externalEntities := Dictionary new]! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:56'!
externalEntities: anAssociationCollection
	self hasExternalEntities
		ifTrue: [self removeExternalEntities].
	anAssociationCollection associationsDo: [:each |
		self
			externalEntityAtURI: each key
			put: each value].! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:53'!
externalEntityAtURI: anXMLURIOrURIString
	^ self
		externalEntityAtURI: anXMLURIOrURIString asXMLURI
		ifAbsent: ['']! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:53'!
externalEntityAtURI: anXMLURIOrURIString ifAbsent: aBlock
	^ self externalEntities
		at: anXMLURIOrURIString asXMLURI
		ifAbsent: aBlock! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:53'!
externalEntityAtURI: anXMLURIOrURIString ifAbsentPut: aBlock
	^ self externalEntities
		at: anXMLURIOrURIString asXMLURI
		ifAbsentPut: aBlock! !

!DTDStaticExternalEntityResolver methodsFor: 'accessing' stamp: 'monty 4/3/2016 00:53'!
externalEntityAtURI: anXMLURIOrURIString put: aReplacement
	^ self externalEntities
		at: anXMLURIOrURIString asXMLURI
		put: aReplacement! !

!DTDStaticExternalEntityResolver methodsFor: 'testing' stamp: 'monty 4/3/2016 00:56'!
hasExternalEntities
	^ self externalEntities notEmpty! !

!DTDStaticExternalEntityResolver methodsFor: 'testing' stamp: 'monty 4/3/2016 00:56'!
includesExternalEntityURI: anXMLURIOrURIString
	^ self externalEntities includesKey: anXMLURIOrURIString asXMLURI! !

!DTDStaticExternalEntityResolver methodsFor: 'copying' stamp: 'monty 9/21/2016 09:21'!
postCopy
	super postCopy.

	externalEntities
		ifNotNil: [externalEntities := externalEntities copy].! !

!DTDStaticExternalEntityResolver methodsFor: 'removing' stamp: 'monty 4/3/2016 00:54'!
removeExternalEntities
	self externalEntities removeAll! !

!DTDStaticExternalEntityResolver methodsFor: 'removing' stamp: 'monty 4/3/2016 00:55'!
removeExternalEntityURI: anXMLURIOrURIString
	^ self externalEntities removeKey: anXMLURIOrURIString asXMLURI! !

!DTDStaticExternalEntityResolver methodsFor: 'removing' stamp: 'monty 4/3/2016 00:55'!
removeExternalEntityURI: anXMLURIOrURIString ifAbsent: aBlock
	^ self externalEntities
		removeKey: anXMLURIOrURIString asXMLURI
		ifAbsent: aBlock! !

!DTDStaticExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 10/16/2017 23:47'!
resolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	| replacement |

	replacement :=
		self
			externalEntityAtURI: anXMLURIOrURIString
			ifAbsent: [
				self errorUnresolvableExternalEntityURI: anXMLURIOrURIString].

	(aMaxSize notNil
		and: [replacement size > aMaxSize])
		ifTrue: [
			self
				errorMaxExternalEntitySize: aMaxSize
				exceededByURI: anXMLURIOrURIString].
	
	^ DTDUndecodedResolvedExternalParsedEntityReplacement rawContents: replacement.! !

!DTDStaticExternalEntityResolver methodsFor: 'resolving' stamp: 'monty 10/16/2017 17:36'!
streamResolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	^ (self
		resolveExternalEntityURI: anXMLURIOrURIString
		upToLimit: aMaxSize) readStream! !

Object subclass: #DTDExternalEntityResolverLimitingDecorator
	instanceVariableNames: 'externalEntityResolver totalResolvedExternalEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDExternalEntityResolverLimitingDecorator commentStamp: 'monty 10/4/2017 13:39' prior: 0!
This class is a decorator for DTDExternalEntityResolvers that limits the number of entities that can be resolved. This is not handled directly by resolvers to make them less stateful and more reusable.!

!DTDExternalEntityResolverLimitingDecorator class methodsFor: 'instance creation' stamp: 'monty 9/12/2017 04:39'!
externalEntityResolver: anExternalEntityResolver
	^ self new externalEntityResolver: anExternalEntityResolver! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'converting' stamp: 'monty 10/4/2017 20:11'!
asLimitingExternalEntityResolver
	^ self! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'private' stamp: 'monty 9/12/2017 04:40'!
checkExternalEntityLimit
	| maxExternalEntities |

	((maxExternalEntities := self externalEntityResolver maxExternalEntities) notNil
		and: [self totalResolvedExternalEntities >= maxExternalEntities])
		ifTrue: [self erorrExternalEntityLimitExceeded]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'private' stamp: 'monty 9/19/2017 00:49'!
erorrExternalEntityLimitExceeded
	XMLLimitException signal:
		'External entity limit exceeded; ',
		'use #maxExternalEntities: to change or disable'! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:45'!
externalEntityLimits
	^ self externalEntityResolver externalEntityLimits! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:45'!
externalEntityLimits: anExternalEntityLimits
	self externalEntityResolver externalEntityLimits: anExternalEntityLimits! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'accessing' stamp: 'monty 9/12/2017 04:21'!
externalEntityResolver
	^ externalEntityResolver! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'accessing' stamp: 'monty 9/12/2017 04:21'!
externalEntityResolver: anExternalEntityResolver
	externalEntityResolver := anExternalEntityResolver! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 9/12/2017 04:26'!
externalEntityURIFromPublicID: aPublicID systemID: aSystemID
	^ self externalEntityResolver
		externalEntityURIFromPublicID: aPublicID
		systemID: aSystemID! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 9/12/2017 04:26'!
externalEntityURIFromPublicID: aPublicID systemID: aSystemID baseURI: aBaseXMLURIOrURIString
	^ self externalEntityResolver
		externalEntityURIFromPublicID: aPublicID
		systemID: aSystemID
		baseURI: aBaseXMLURIOrURIString! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:45'!
externalSubsetReadLimit
	^ self externalEntityResolver externalSubsetReadLimit! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:46'!
externalSubsetReadLimit: anInteger
	self externalEntityResolver externalSubsetReadLimit: anInteger! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'private' stamp: 'monty 9/12/2017 04:28'!
incrementTotalResolvedExternalEntities
	totalResolvedExternalEntities :=
		totalResolvedExternalEntities
			ifNil: [1]
			ifNotNil: [totalResolvedExternalEntities + 1]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:46'!
maxExternalEntities
	^ self externalEntityResolver maxExternalEntities! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:48'!
maxExternalEntities: anInteger
	self externalEntityResolver maxExternalEntities: anInteger! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:48'!
maxExternalEntitySize
	^ self externalEntityResolver maxExternalEntitySize! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:48'!
maxExternalEntitySize: anInteger
	self externalEntityResolver maxExternalEntitySize: anInteger! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'printing' stamp: 'monty 10/19/2017 01:49'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self externalEntityResolver;
		nextPut: $).! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:48'!
removeLimits
	self externalEntityResolver removeLimits! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 10/2/2017 12:58'!
resolveExternalEntityURI: anXMLURIOrURIString
	^ self resolveExternalEntityWith: [
		self externalEntityResolver resolveExternalEntityURI:
			anXMLURIOrURIString]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 10/18/2017 17:21'!
resolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	^ self resolveExternalEntityWith: [
		self externalEntityResolver
			resolveExternalEntityURI: anXMLURIOrURIString
			upToLimit: aMaxSize]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'private' stamp: 'monty 10/2/2017 12:59'!
resolveExternalEntityWith: aBlock
	| result |

	self checkExternalEntityLimit.
	result := aBlock value.
	self incrementTotalResolvedExternalEntities.

	^ result.! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:49'!
resolvesLocalFromNonLocal
	^ self externalEntityResolver resolvesLocalFromNonLocal! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'configuring' stamp: 'monty 9/12/2017 04:49'!
resolvesLocalFromNonLocal: aBoolean
	self externalEntityResolver resolvesLocalFromNonLocal: aBoolean! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 10/2/2017 13:00'!
streamResolveExternalEntityURI: anXMLURIOrURIString
	^ self resolveExternalEntityWith: [
		self externalEntityResolver streamResolveExternalEntityURI:
			anXMLURIOrURIString]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'resolving' stamp: 'monty 10/18/2017 17:21'!
streamResolveExternalEntityURI: anXMLURIOrURIString upToLimit: aMaxSize
	^ self resolveExternalEntityWith: [
		self externalEntityResolver
			streamResolveExternalEntityURI: anXMLURIOrURIString
			upToLimit: aMaxSize]! !

!DTDExternalEntityResolverLimitingDecorator methodsFor: 'accessing' stamp: 'monty 9/12/2017 04:27'!
totalResolvedExternalEntities
	^ totalResolvedExternalEntities ifNil: [totalResolvedExternalEntities := 0]! !

Object subclass: #DTDNotation
	instanceVariableNames: 'name publicID systemID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDNotation commentStamp: 'monty 11/19/2016 13:39' prior: 0!
A class for notation declarations.!

!DTDNotation class methodsFor: 'instance creation' stamp: 'monty 11/19/2016 13:37'!
name: aName publicID: aPublicID
	^ self
		name: aName
		publicID: aPublicID
		systemID: ''! !

!DTDNotation class methodsFor: 'instance creation' stamp: 'monty 11/19/2016 13:36'!
name: aName publicID: aPublicID systemID: aSystemID
	^ self new
		setName: aName
		publicID: aPublicID
		systemID: aSystemID! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:38'!
name
	^ name ifNil: [name := '']! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:44'!
name: aName
	name := aName! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:38'!
publicID
	^ publicID ifNil: [publicID := '']! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:38'!
publicID: aPublicID
	publicID := aPublicID! !

!DTDNotation methodsFor: 'initialization' stamp: 'monty 11/19/2016 13:37'!
setName: aName publicID: aPublicID systemID: aSystemID
	name := aName.
	publicID := aPublicID.
	systemID := aSystemID.! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:38'!
systemID
	^ systemID ifNil: [systemID := '']! !

!DTDNotation methodsFor: 'accessing' stamp: 'monty 11/19/2016 13:38'!
systemID: aSystemID
	systemID := aSystemID! !

Object subclass: #DTDResolvedExternalParsedEntityReplacement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDResolvedExternalParsedEntityReplacement commentStamp: 'monty 10/16/2017 23:47' prior: 0!
This is an abstract class for resolved external entity replacements.!

DTDResolvedExternalParsedEntityReplacement subclass: #DTDDecodedResolvedExternalParsedEntityReplacement
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDDecodedResolvedExternalParsedEntityReplacement commentStamp: 'monty 10/16/2017 23:48' prior: 0!
This class stores the decoded resolved replacement of an external parsed entity.!

!DTDDecodedResolvedExternalParsedEntityReplacement class methodsFor: 'instance creation' stamp: 'monty 10/17/2017 01:37'!
contents: aString
	^ self new setContents: aString! !

!DTDDecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 23:34'!
contents
	^ contents! !

!DTDDecodedResolvedExternalParsedEntityReplacement methodsFor: 'testing' stamp: 'monty 10/16/2017 23:37'!
isEmpty
	^ self contents isEmpty! !

!DTDDecodedResolvedExternalParsedEntityReplacement methodsFor: 'printing' stamp: 'monty 10/22/2017 00:04'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self contents;
		nextPut: $).! !

!DTDDecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 23:32'!
readStream
	^ self contents readStream! !

!DTDDecodedResolvedExternalParsedEntityReplacement methodsFor: 'initialization' stamp: 'monty 10/17/2017 01:37'!
setContents: aString
	contents := aString! !

!DTDResolvedExternalParsedEntityReplacement methodsFor: 'converting' stamp: 'monty 10/21/2017 23:50'!
asString
	^ self contents! !

!DTDResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 23:35'!
contents
	self subclassResponsibility! !

!DTDResolvedExternalParsedEntityReplacement methodsFor: 'testing' stamp: 'monty 10/16/2017 23:37'!
isEmpty
	self subclassResponsibility! !

!DTDResolvedExternalParsedEntityReplacement methodsFor: 'testing' stamp: 'monty 10/16/2017 23:37'!
notEmpty
	^ self isEmpty not! !

!DTDResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 23:35'!
readStream
	self subclassResponsibility! !

DTDResolvedExternalParsedEntityReplacement subclass: #DTDUndecodedResolvedExternalParsedEntityReplacement
	instanceVariableNames: 'rawContents encoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUndecodedResolvedExternalParsedEntityReplacement commentStamp: 'monty 10/16/2017 23:48' prior: 0!
This class stores the undecoded resolved replacement of an external parsed entity as well as its likely encoding.!

!DTDUndecodedResolvedExternalParsedEntityReplacement class methodsFor: 'instance creation' stamp: 'monty 1/13/2018 22:53'!
rawContents: aString
	^ self
		rawContents: aString
		encoding: ''! !

!DTDUndecodedResolvedExternalParsedEntityReplacement class methodsFor: 'instance creation' stamp: 'monty 10/17/2017 01:37'!
rawContents: aString encoding: anEncodingName
	^ self new
		setRawContents: aString
		encoding: anEncodingName! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 23:36'!
contents
	^ self readStream upToEnd! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/11/2017 15:53'!
encoding
	^ encoding! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'testing' stamp: 'monty 10/16/2017 23:43'!
isEmpty
	^ self rawContents isEmpty! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'printing' stamp: 'monty 10/22/2017 00:04'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self encoding;
		nextPut: $).! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 07:05'!
rawContents
	^ rawContents! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 10/16/2017 17:24'!
readStream
	^ XMLDecodingReadStreamAdapter
		on: self rawContents readStream
		streamConverter: self encoding asXMLStreamConverter! !

!DTDUndecodedResolvedExternalParsedEntityReplacement methodsFor: 'initialization' stamp: 'monty 10/17/2017 01:37'!
setRawContents: aString encoding: anEncodingName
	rawContents := aString.
	encoding := anEncodingName.! !

Object subclass: #DTDUnresolvedExternalParsedEntityReplacement
	instanceVariableNames: 'resolver publicID systemID baseURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDUnresolvedExternalParsedEntityReplacement commentStamp: 'monty 4/8/2016 07:31' prior: 0!
This class stores an entity resolver and the public ID, system ID, and base URI of an external entity so its replacement can be lazily resolved only if the entity is referenced.!

!DTDUnresolvedExternalParsedEntityReplacement class methodsFor: 'instance creation' stamp: 'monty 4/8/2016 02:49'!
resolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	^ self new
		setResolver: aResolver
		publicID: aPublicID
		systemID: aSystemID
		baseURI: aBaseURIString! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 4/8/2016 02:59'!
baseURI
	^ baseURI ifNil: [baseURI := '']! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'printing' stamp: 'monty 10/22/2017 00:05'!
printOn: aStream
	super printOn: aStream.

	aStream nextPut: $(.
	self publicID isEmpty
		ifTrue: [aStream nextPutAll: 'SYSTEM']
		ifFalse: [
			aStream
				nextPutAll: 'PUBLIC "';
				nextPutAll: self publicID;
				nextPut: $"].

	aStream
		nextPutAll: ' "';
		nextPutAll: self systemID;
		nextPutAll: '")'.! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 4/8/2016 02:58'!
publicID
	^ publicID ifNil: [publicID := '']! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'resolving' stamp: 'monty 1/14/2018 17:12'!
resolveForExternalEntity: anExternalEntity
	| externalEntityURI |

	externalEntityURI :=
		self resolver
			externalEntityURIFromPublicID: self publicID
			systemID: self systemID
			baseURI: self baseURI.

	anExternalEntity
		resolvedReplacement:
			(self resolver resolveExternalEntityURI: externalEntityURI);
		uri: externalEntityURI asString;
		unresolvedReplacement: nil.! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 4/8/2016 03:05'!
resolver
	^ resolver ifNil: [resolver := DTDExternalEntityResolver default]! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'initialization' stamp: 'monty 4/8/2016 02:50'!
setResolver: aResolver publicID: aPublicID systemID: aSystemID baseURI: aBaseURIString
	resolver := aResolver.
	publicID := aPublicID.
	systemID := aSystemID.
	baseURI := aBaseURIString.! !

!DTDUnresolvedExternalParsedEntityReplacement methodsFor: 'accessing' stamp: 'monty 4/8/2016 02:58'!
systemID
	^ systemID ifNil: [systemID := '']! !

!Object methodsFor: '*XML-Parser' stamp: 'monty 2/8/2018 22:31'!
isXMLBinaryOrExternalStream
	"Not every stream or stream-like object is a subclass of Stream, so this
	must be defined here.

	At a minimum, these streams must accept binary objects (like SmallIntegers
	and ByteArrays) when writing. When reading, they can return byte values
	as SmallIntegers or Characters and collections of byte values as ByteArrays
	or ByteStrings."

	^ self isStream
		and: [(self respondsTo: #isBinary)
			and: [self isBinary]]! !

!Object methodsFor: '*XML-Parser' stamp: 'monty 4/1/2016 00:55'!
isXMLConvertingStreamAdapter
	^ false! !

Object subclass: #SAX2ContentHandler
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ContentHandler commentStamp: 'monty 8/20/2016 07:02' prior: 0!
This is a base class for SAX2 content handler classes that can be injected into SAX2Parser instances with #contentHandler: before parsing:
	(SAX2Parser on: xmlStringOrStream)
		contentHandler: MyContentHandlerClass new;
		parseDocument.

See SAX2Parser and SAXHandler for more info.!

!SAX2ContentHandler class methodsFor: 'instance creation' stamp: 'monty 8/14/2016 18:00'!
parser: aParser
	^ self new parser: aParser! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 8/21/2016 00:25'!
characters: aString
	"Handles character data in an element, such as the 'test' in
	'<characters>test</characters>' or in the CDATA section '<!![CDATA[test]]>'.
	
	It may be sent multiple times for different sections of character data
	in a single element if they're separated by other nodes or entity
	references like in '<characters>one<!!--comment-->two</characters>'.
	
	See ignorableWhitespace:"! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
endDocument
	"Handles the end of an XML document. No more handlers are invoked after this."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName: or #endElement:prefix:uri:."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName:. By default it forwards to a simpler
	handler, #endElement:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string"

	self endElement: aQualifiedName! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:06'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	"Handles the end of an element, either an end tag like '</end>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#endElement:prefix:uri:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name"

	self
		endElement: aQualifiedName
		prefix: aPrefix
		uri:  aURI! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
endPrefixMapping: aPrefix
	"Handles the end of a namespace prefix/URI mapping when namespaces are
	enabled. After, aPrefix (empty for the default namespace) will be either
	unmapped or mapped to a different URI. The 'xml' prefix is predefined
	and never unmapped."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
ignorableWhitespace: aString
	"When validation is enabled and a DTD with element declarations is
	present, this can be used to handle ignorable whitespace in elements
	with 'element content' (meaning they can only contain other elements
	and no PCDATA), such as between '<element-content>' and '<mixed-content>'
	or between '</mixed-content>' and '</element-content>' in this sample:
		'<!!DOCTYPE element-content [
			<!!--this has element content, so its whitespace is ignorable-->
			<!!ELEMENT element-content (mixed-content)>
			<!!--this has mixed content, so its whitespace is not ignorable-->
			<!!ELEMENT mixed-content (#PCDATA|any-content)*>
			<!!--this has any content, so its whitespace is not ignorable-->
			<!!ELEMENT any-content ANY>
		]>
		<element-content>
			<mixed-content>
				<any-content> any </any-content>
			</mixed-content>
		</element-content>'

	Not sent if validation is disabled or if there's no DTD with element
	declarations."! !

!SAX2ContentHandler methodsFor: 'accessing' stamp: 'monty 8/20/2016 06:44'!
parser
	"Returns the SAX2Parser this handler was injected into"

	^ parser! !

!SAX2ContentHandler methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:56'!
parser: aParser
	parser := aParser! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
processingInstruction: aTargetString data: aDataString
	"Handles processing instructions like '<?name value?>', where 'name' is
	the target and 'value' is the data.
	
	XML declarations may look like PIs but are different and are handled
	with xmlVersion:encoding:standalone: instead."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
skippedEntity: anEntityName
	"Sent when a general parsed entity reference like '&name;' is
	unreplaced in content. Only sent when validation is turned off
	or entity replacement is disabled."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
startDocument
	"Handles the start of an XML document, the first handler invoked."! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes: or
	#startElement:prefix:uri:attributes:.

	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	anAttributeDictionary - an XMLAttributeDictionary of attributes"! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes:. By default it forwards
	to a simpler handler, #startElement:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		attributes: anAttributeDictionary! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	"Handles the start of an element, either a start tag like '<start>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#startElement:prefix:uri:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		attributes: anAttributeDictionary! !

!SAX2ContentHandler methodsFor: 'handling - content' stamp: 'monty 6/23/2016 01:29'!
startPrefixMapping: aPrefix uri: aURI
	"Handles the start of a namespace prefix/URI mapping when namespaces are
	enabled. The 'xml' prefix is predefined and never remapped.

	aPrefix - the prefix of the namespace (empty for the default namesapce)
	aURI - the namespace URI"! !

Object subclass: #SAX2DeclarationHandler
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2DeclarationHandler commentStamp: 'monty 8/20/2016 07:02' prior: 0!
This is a base class for SAX2 declaration handler classes that can be injected into SAX2Parser instances with #declarationHandler: before parsing:
	(SAX2Parser on: xmlStringOrStream)
		declarationHandler: MyDeclarationHandlerClass new;
		parseDocument.

See SAX2Parser and SAXHandler for more info.!

!SAX2DeclarationHandler class methodsFor: 'instance creation' stamp: 'monty 8/14/2016 18:00'!
parser: aParser
	^ self new parser: aParser! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
elementDeclaration: anElementName contentModel: aContentModel
! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
generalEntityDeclaration: aName replacement: aReplacement! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID! !

!SAX2DeclarationHandler methodsFor: 'handling - declaration' stamp: 'monty 6/23/2016 01:29'!
parameterEntityDeclaration: aName replacement: aReplacement! !

!SAX2DeclarationHandler methodsFor: 'accessing' stamp: 'monty 8/20/2016 06:44'!
parser
	"Returns the SAX2Parser this handler was injected into"

	^ parser! !

!SAX2DeclarationHandler methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:57'!
parser: aParser
	parser := aParser! !

Object subclass: #SAX2ElementHandler
	instanceVariableNames: 'parser parent parentFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ElementHandler commentStamp: 'monty 9/22/2016 14:27' prior: 0!
This is a base class for SAX2 element handlers to be used with SAX2ElementParsers.

SAX2ElementParsers use individual SAX2ElementHandlers to handle the #startElement*, #endElement*, and #characters: events of each element in the document.

The parser can be accessed with #parser, and the parent element handler (if any) can be accessed with #parent.!

SAX2ElementHandler subclass: #SAX2ElementCharacterHandler
	instanceVariableNames: 'characters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ElementCharacterHandler commentStamp: 'monty 8/21/2016 00:11' prior: 0!
This class is a SAX2ElementHandler that handles #characters: events. Sending #characters returns the complete character data of the element as a string.!

!SAX2ElementCharacterHandler methodsFor: 'accessing' stamp: 'monty 8/16/2016 22:20'!
characters
	"This returns the combined #characters: events handled by the receiver
	as a string."

	^ characters ifNil: [characters := '']! !

!SAX2ElementCharacterHandler methodsFor: 'handling - content' stamp: 'monty 9/20/2016 21:43'!
characters: aString
	"building the string this way is simpler and performs as well in tests
	as using a write stream"
	characters :=
		characters
			ifNil: [aString]
			ifNotNil: [characters, aString]! !

!SAX2ElementHandler class methodsFor: 'parsing' stamp: 'monty 8/17/2016 23:41'!
parser: aParser
	^ self
		parser: aParser
		parent: aParser elementHandler
		parentFactory: aParser elementHandlerFactory! !

!SAX2ElementHandler class methodsFor: 'parsing' stamp: 'monty 8/18/2016 23:29'!
parser: aParser parent: anElementHandler parentFactory: anElementHandlerFactory
	^ self new
		setParser: aParser
		parent: anElementHandler
		parentFactory: anElementHandlerFactory! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 8/19/2016 23:12'!
ancestors	
	"Returns a list of all ancestor element handlers of the receiver."

	| ancestors |

	ancestors := XMLOrderedList new.
	self ancestorsDo: [:each | ancestors addLast: each].
	^ ancestors.! !

!SAX2ElementHandler methodsFor: 'enumerating' stamp: 'monty 8/19/2016 23:12'!
ancestorsDo: aBlock
	| ancestor |

	ancestor := self parent.
	[ancestor notNil]
		whileTrue: [
			aBlock value: ancestor.
			ancestor := ancestor parent].! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 8/16/2016 22:19'!
characters
	"This handler ignores #characters: events, so this always returns
	an empty string."

	^ ''! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 8/21/2016 00:24'!
characters: aString
	"Handles character data in an element, such as the 'test' in
	'<characters>test</characters>' or in the CDATA section '<!![CDATA[test]]>'.
	
	It may be sent multiple times for different sections of character data
	in a single element if they're separated by other nodes or entity
	references like in '<characters>one<!!--comment-->two</characters>'."! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 9/20/2016 21:49'!
elementHandlerFactory
	"Can be overridden to return a default factory to use by a factory
	mapper when no other factory is mapped to the receiver."

	^ nil! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName: or #endElement:prefix:uri:."! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName:. By default it forwards to a simpler
	handler, #endElement:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string"

	self endElement: aQualifiedName! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:06'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	"Handles the end of an element, either an end tag like '</end>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#endElement:prefix:uri:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name"

	self
		endElement: aQualifiedName
		prefix: aPrefix
		uri:  aURI! !

!SAX2ElementHandler methodsFor: 'testing' stamp: 'monty 9/20/2016 11:23'!
hasParent
	"Returns true if the receiver has a parent element handler (meaning it's
	not the root element handler)"

	^ parent notNil! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 8/20/2016 18:59'!
parent
	"Returns the parent element handler or nil if there isn't one (if
	the receiver is handling the root element)."

	^ parent! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 8/20/2016 18:59'!
parentFactory
	"Returns the factory that created the receiver."

	^ parentFactory! !

!SAX2ElementHandler methodsFor: 'accessing' stamp: 'monty 8/16/2016 04:16'!
parser
	"Returns the SAX2ElementParser"

	^ parser! !

!SAX2ElementHandler methodsFor: 'initialization' stamp: 'monty 8/18/2016 23:29'!
setParser: aParser parent: anElementHandler parentFactory: anElementHandlerFactory
	parser := aParser.
	parent := anElementHandler.
	parentFactory := anElementHandlerFactory.! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes: or
	#startElement:prefix:uri:attributes:.

	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	anAttributeDictionary - an XMLAttributeDictionary of attributes"! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes:. By default it forwards
	to a simpler handler, #startElement:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		attributes: anAttributeDictionary! !

!SAX2ElementHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:09'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	"Handles the start of an element, either a start tag like '<start>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#startElement:prefix:uri:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		attributes: anAttributeDictionary! !

Object subclass: #SAX2ElementHandlerFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ElementHandlerFactory commentStamp: 'monty 9/22/2016 14:36' prior: 0!
This is a base class for element handler factories used by SAX2ElementParsers to create element handlers. Instances can be injected into a SAX2ElementParser with #elementHandlerFactory: before parsing.

This factory just uses the default handler class SAX2ElementHandler for all elements.!

!SAX2ElementHandlerFactory methodsFor: 'accessing' stamp: 'monty 8/12/2016 23:21'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection
	^ self elementHandlerClass! !

!SAX2ElementHandlerFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:01'!
elementHandlerClass
	^ SAX2ElementHandler! !

SAX2ElementHandlerFactory subclass: #SAX2PluggableElementHandlerFactory
	instanceVariableNames: 'elementClassMapper elementHandlerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2PluggableElementHandlerFactory commentStamp: 'monty 9/22/2016 14:17' prior: 0!
This class is a pluggable element handler factory with an API like XMLPluggableElementFactory. Instances can be injected into a SAX2ElementParser with #elementHandlerFactory: before parsing.

You can map combinations of element name, namespace URI, and attributes to specific element handler classes using the "handling" messages, and change the default element handler class used when there's no mapping with #elementHandlerClass:.

Instances can be saved and reused for performance and safely modified after copying.!

!SAX2PluggableElementHandlerFactory methodsFor: 'accessing' stamp: 'monty 8/12/2016 23:22'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection
	^ elementClassMapper
		classForElement: aQualifiedName
		namespaceURI: aURI
		attributes: anAssociationCollection
		ifNone: [self elementHandlerClass]! !

!SAX2PluggableElementHandlerFactory methodsFor: 'private' stamp: 'monty 8/4/2016 20:00'!
elementClassMapper
	^ elementClassMapper! !

!SAX2PluggableElementHandlerFactory methodsFor: 'private' stamp: 'monty 8/4/2016 20:00'!
elementClassMapper: anElementClassMapper
	elementClassMapper := anElementClassMapper! !

!SAX2PluggableElementHandlerFactory methodsFor: 'defaults' stamp: 'monty 8/26/2016 02:16'!
elementClassMapperClass
	^ XMLBasicElementClassMapper! !

!SAX2PluggableElementHandlerFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:02'!
elementHandlerClass
	^ elementHandlerClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'accessing' stamp: 'monty 6/18/2017 18:07'!
elementHandlerClass: aClass
	"set the default element handler class"
	elementHandlerClass := aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/18/2016 23:10'!
handleElement: anElementName attributes: aCollectionOrAttributeSpec withClass: aClass
	"aCollectionOrAttributeSpec can be some kind of XMLAttributeSpec or a
	collection of associations of required attribute names and values, and the
	required values can be strings, blocks, or nil meaning the attribute is
	required but can take any value"

	elementClassMapper
		mapElement: anElementName
		attributeSpec: aCollectionOrAttributeSpec asXMLAttributeSpec
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/18/2016 23:10'!
handleElement: anElementName namespaceURI: aURI attributes: aCollectionOrAttributeSpec withClass: aClass
	"aCollectionOrAttributeSpec can be some kind of XMLAttributeSpec or a
	collection of associations of required attribute names and values, and the
	required values can be strings, blocks, or nil meaning the attribute is
	required but can take any value"

	elementClassMapper
		mapElement: anElementName
		namespaceURI: aURI
		attributeSpec: aCollectionOrAttributeSpec asXMLAttributeSpec
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/5/2016 11:03'!
handleElement: anElementName namespaceURI: aURI withClass: aClass
	elementClassMapper
		mapElement: anElementName
		namespaceURI: aURI
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/5/2016 11:03'!
handleElement: anElementName withClass: aClass
	elementClassMapper
		mapElement: anElementName
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/5/2016 11:03'!
handleElements: anElementNameCollection namespaceURI: aNamespaceURI withClass: aClass
	elementClassMapper
		mapElements: anElementNameCollection
		namespaceURI: aNamespaceURI
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/5/2016 11:03'!
handleElements: anElementNameCollection withClass: aClass
	elementClassMapper
		mapElements: anElementNameCollection
		toClass: aClass! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/26/2016 03:19'!
handleElementsMatchingClass: aClass
	"This will handle all elements matching the name of a class with that
	class, but igoring the class's prefix and any 'Element' or 'ElementHandler'
	suffix.

	For example, it will match MyUserDefinedElement to:
		<UserDefined>
		<userDefined>
		<user-defined>
		<user_defined>"

	elementClassMapper
		mapAllMatchingElementsToClass: aClass
		ignoringSuffixes: self ignorableClassNameSuffixes! !

!SAX2PluggableElementHandlerFactory methodsFor: 'handling' stamp: 'monty 8/26/2016 01:41'!
handleElementsMatchingClasses: aClassCollection
	"See the comment in #handleElementsMatchingClass:"

	elementClassMapper
		mapAllMatchingElementsToClasses: aClassCollection
		ignoringSuffixes: self ignorableClassNameSuffixes! !

!SAX2PluggableElementHandlerFactory methodsFor: 'defaults' stamp: 'monty 8/26/2016 00:48'!
ignorableClassNameSuffixes
	^ #('Element' 'ElementHandler')! !

!SAX2PluggableElementHandlerFactory methodsFor: 'initialization' stamp: 'monty 8/5/2016 11:02'!
initialize
	super initialize.

	elementClassMapper := self elementClassMapperClass new.
	elementHandlerClass := SAX2ElementHandler.! !

!SAX2PluggableElementHandlerFactory methodsFor: 'copying' stamp: 'monty 8/5/2016 11:05'!
postCopy
	super postCopy.

	elementClassMapper := elementClassMapper copy.! !

Object subclass: #SAX2ElementHandlerFactoryMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ElementHandlerFactoryMapper commentStamp: 'monty 9/20/2016 21:47' prior: 0!
This is a base class for mappers to map element handler objects to element handler factories.

Requesting the factory for an element handler checks the handler's #elementHandlerFactory message first and then the mapper's own #elementHandlerFactory message which can be (and is) overridden in subclasses to return a default factory.

When a SAX2ElementParser requests the factory for a new element handler, if none is found, it will reuse (inherit) the current factory.!

!SAX2ElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 9/20/2016 21:48'!
elementHandlerFactory
	"Can be overridden to return a default element handler factory to use
	if no other mapping is defined for it."

	^ nil! !

!SAX2ElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 8/15/2016 01:45'!
factoryForElementHandler: anElementHandler
	^ self
		factoryForElementHandler: anElementHandler
		ifNone: [nil]! !

!SAX2ElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 8/17/2016 23:53'!
factoryForElementHandler: anElementHandler ifNone: aBlock
	^ anElementHandler elementHandlerFactory
		ifNil: [
			self elementHandlerFactory
				ifNil: [aBlock value]]! !

SAX2ElementHandlerFactoryMapper subclass: #SAX2PluggableElementHandlerFactoryMapper
	instanceVariableNames: 'elementHandlerFactoryMap elementHandlerFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2PluggableElementHandlerFactoryMapper commentStamp: 'monty 9/22/2016 14:17' prior: 0!
This class is a pluggable mapper to map element handler objects to element handler factories.

Requesting the factory for an element handler checks for a mapping set with  #mapElementHandlerClass: toFactory:, then the handler's  #elementHandlerFactory message, then the mapper's own #elementHandlerFactory message, which returns a default factory (unlike in the base class) which can be changed with #elementHandlerFactory:.

When a SAX2ElementParser requests the factory for a new element handler, if none is found, it will reuse (inherit) the current factory, but this won't happen unless the default factory is cleared by setting #elementHandlerFactory: to nil.

Instances can be saved and reused for performance and safely modified after copying.!

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'defaults' stamp: 'monty 8/15/2016 23:57'!
defaultElementHandlerFactoryClass
	^ SAX2ElementHandlerFactory! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 8/15/2016 23:58'!
elementHandlerFactory
	^ elementHandlerFactory! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 6/18/2017 18:07'!
elementHandlerFactory: anElementHandlerFactory
	"set the default element handler factory"
	elementHandlerFactory := anElementHandlerFactory! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'private' stamp: 'monty 8/16/2016 00:01'!
elementHandlerFactoryMap
	^ elementHandlerFactoryMap! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'accessing' stamp: 'monty 8/16/2016 23:36'!
factoryForElementHandler: anElementHandler ifNone: aBlock
	"optimization to skip any unneeded hash lookups"
	elementHandlerFactoryMap size > 0
		ifTrue: [
			^ elementHandlerFactoryMap
				at: anElementHandler class
				ifAbsent: [
					super
						factoryForElementHandler: anElementHandler
						ifNone: aBlock]]
		ifFalse: [
			^ super
				factoryForElementHandler: anElementHandler
				ifNone: aBlock]! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'initialization' stamp: 'monty 8/15/2016 23:57'!
initialize
	super initialize.

	elementHandlerFactoryMap := IdentityDictionary new.
	elementHandlerFactory := self defaultElementHandlerFactoryClass new.! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:26'!
mapElementHandlerClass: aClass toFactory: aFactory
	elementHandlerFactoryMap
		at: aClass
		put: aFactory! !

!SAX2PluggableElementHandlerFactoryMapper methodsFor: 'copying' stamp: 'monty 8/16/2016 00:02'!
postCopy
	super postCopy.

	elementHandlerFactoryMap := elementHandlerFactoryMap copy.! !

Object subclass: #SAX2LexicalHandler
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2LexicalHandler commentStamp: 'monty 8/20/2016 07:02' prior: 0!
This is a base class for SAX2 lexical handler classes that can be injected into SAX2Parser instances with #lexicalHandler: before parsing:
	(SAX2Parser on: xmlStringOrStream)
		lexicalHandler: MyLexicalHandlerClass new;
		parseDocument.

See SAX2Parser and SAXHandler for more info.!

!SAX2LexicalHandler class methodsFor: 'instance creation' stamp: 'monty 8/14/2016 18:00'!
parser: aParser
	^ self new parser: aParser! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
comment: aString
	"Handles '<!!--comment-->' sections in documents."! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
endCData
	"Sent after the character data of a '<!![CDATA[...]]>' section."! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
endDTD
! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
endEntity: anEntityName
	"Handles the end of some general entity's replacement in content.
	Not sent if the entity is undeclared or if content entity replacement
	is disabled."! !

!SAX2LexicalHandler methodsFor: 'accessing' stamp: 'monty 8/20/2016 06:44'!
parser
	"Returns the SAX2Parser this handler was injected into"

	^ parser! !

!SAX2LexicalHandler methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:57'!
parser: aParser
	parser := aParser! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
startCData
	"Sent before the character data of a '<!![CDATA[...]]>' section."! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	"Handles the start of a '<!!DOCTYPE ...>' declaration. Any events
	after this and until endDTD is sent are part of the internal subset
	of the DTD.
	
	aRootElementName - the expected name of the document's root element
	aPublicID - the public ID of the external DTD subset or an empty string
	aSystemID - the URI where the external subset can be found or an empty string"! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
startEntity: anEntityName
	"Handles the start of some general entity's replacement in content.
	Not sent if the entity is undeclared or if content entity replacement
	is disabled."! !

!SAX2LexicalHandler methodsFor: 'handling - lexical' stamp: 'monty 6/23/2016 01:29'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	"Handles the '<?xml ...?>' declaration of a document.
	
	aVersionFloat - the version of XML the document uses, usually 1.0
	anEncoding - the name of the encoding or an empty string
	aBoolean - true if standalone='yes'"! !

Object subclass: #SAXHandler
	instanceVariableNames: 'input documentURI configuration hasParser isInContent isInCDataSection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAXHandler commentStamp: 'monty 4/11/2017 05:20' prior: 0!
This class is an event-handling XML parser. To use it, subclass it and override event handlers in the "handling" categories, such as #startDocument, #startElement:attributes:, #endElement:, and #endDocument.

By default XML namespace support and validation are enabled but not external entity resolution.

Once the subclass is ready, use the class "parsing" messages to parse XML:
	result := SAXHandlerSubclass parse: xmlStringOrStream.
	resultFromURL := SAXHandlerSubclass parseURL: xmlURLString.
	resultFromFile := SAXHandlerSubclass parseFileNamed: xmlFileName.

The class "instance creation" messages create and return new parsers on the input so they can be configured with messages in the  "configuring" category before parsing:
	result :=
		(SAXHandlerSubclass on: xmlStringOrStream)
			isValidating: true;
			resolvesExternalEntities: true;
			parseDocument.

#interruptParsing can be sent from within a handler to stop parsing, and there is also #parseDocumentWhile: and #parseDocumentUntil: 
	result :=
		(SAXHandlerSubclass on: xmlStringOrStream)
			parseDocumentWhile: [self shouldKeepParsing].

To parse incrementally, send #parser to an instance to get the underlying XMLParser object and send it #parseToken repeatedly:
	(handler := SAXHandlerSubclass on: xmlStringOrStream)
		isValidating: false; 
		preservesUndeclaredEntityReferences: true.
	parser := handler parser.

	"Only parse the first 10 tokens:"
	10 timesRepeat: [parser parseToken].

There are security limits on input you can remove with #removeLimits or change with messages like #documentReadLimit:
	result :=
		(SAXHandlerSubclass on: xmlStringOrStream)
			removeLimits;
			documentReadLimit: newReadLimit;
			maxEntityReplacementDepth: newMaxEntityDepth;
			parseDocument.
		
#optimizeForLargeDocuments can be used when parsing large documents if you don't care for validating or namespaces.!

SAXHandler subclass: #SAX2Parser
	instanceVariableNames: 'contentHandler lexicalHandler declarationHandler parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2Parser commentStamp: 'monty 8/20/2016 07:04' prior: 0!
This class is a parser with an API like SAX 2.0, with separate SAX2ContentHandler, SAX2LexicalHandler, and SAX2DeclarationHandler classes that are subclassed unlike SAX 1.0 where a single,  unified handler class is subclassed directly. Parsers can be created with #on: or other instance creation messages, and instances of the content, lexical, and declaration handlers can be injected before parsing with #contentHandler:, #lexicalHandler:, and #declarationHandler:, like this:
	(SAX2Parser on: xmlStringOrStream)
		contentHandler: MyContentHandlerClass new;
		declarationHandler: MyDeclarationHandlerClass new;
		lexicalHandler: MyLexicalHandlerClass new;
		parseDocument.

Each handler can access the SAX2Parser object with #parser and set the parsing result returned by #parseDocument with #parsingResult:.

SAXHandler is not deprecated and can still be used if you prefer the SAX 1.0 style API.!

SAX2Parser subclass: #SAX2ElementParser
	instanceVariableNames: 'elementHandler elementHandlerFactory elementHandlerFactoryMapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAX2ElementParser commentStamp: 'monty 9/22/2016 14:28' prior: 0!
This class is a SAX2Parser that uses individual SAX2ElementHandlers to handle the #startElement*, #endElement*, and #characters: events of each element in the document. All other content events are handled by a single SAX2ContentHandler as usual.

Custom subclasses of SAX2ElementHandler can be mapped to element names, namespace URIs, and attributes using a SAX2PluggableElementHandlerFactory. Factories can be injected with #elementHandlerFactory: before parsing.
See #testParsingSampleBooks for an example.

You can have multiple factories by mapping specific SAX2ElementHandlers to specific factories using a SAX2PluggableElementHandlerFactoryMapper, which can be injected with #elementHandlerFactoryMapper: before parsing. This can be used to create a finite-state machine, with the element handler instances being the states and the mapped factories being their transitions.
See #testParsingSamplePerson for an example.!

!SAX2ElementParser methodsFor: 'handling - content' stamp: 'monty 7/22/2016 13:11'!
characters: aString
	self elementHandler characters: aString! !

!SAX2ElementParser methodsFor: 'defaults' stamp: 'monty 8/15/2016 01:01'!
defaultElementHandlerFactoryClass
	^ SAX2ElementHandlerFactory! !

!SAX2ElementParser methodsFor: 'defaults' stamp: 'monty 8/15/2016 01:31'!
defaultElementHandlerFactoryMapperClass
	^ SAX2ElementHandlerFactoryMapper! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 7/23/2016 04:14'!
elementHandler
	^ elementHandler! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 8/15/2016 01:54'!
elementHandler: anElementHandler
	elementHandler := anElementHandler! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 7/22/2016 13:10'!
elementHandlerFactory
	^ elementHandlerFactory! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 7/22/2016 13:10'!
elementHandlerFactory: anElementHandlerFactory
	elementHandlerFactory := anElementHandlerFactory! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 8/15/2016 01:31'!
elementHandlerFactoryMapper
	^ elementHandlerFactoryMapper! !

!SAX2ElementParser methodsFor: 'accessing' stamp: 'monty 8/15/2016 01:31'!
elementHandlerFactoryMapper: anElementHandlerFactoryMapper
	elementHandlerFactoryMapper := anElementHandlerFactoryMapper! !

!SAX2ElementParser methodsFor: 'handling - content' stamp: 'monty 8/20/2016 02:39'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	| oldElementHandler |

	(oldElementHandler := self elementHandler)
		endElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName.
	self
		elementHandler: oldElementHandler parent;
		elementHandlerFactory: oldElementHandler parentFactory.! !

!SAX2ElementParser methodsFor: 'initialization' stamp: 'monty 8/15/2016 01:31'!
on: aStringOrStream
	super on: aStringOrStream.

	elementHandlerFactory := self defaultElementHandlerFactoryClass new.
	elementHandlerFactoryMapper := self defaultElementHandlerFactoryMapperClass new.! !

!SAX2ElementParser methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:32'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	| newElementHandler |

	newElementHandler :=
		(self elementHandlerFactory
			classForElement: aQualifiedName
			namespaceURI: aURI
			localName: aLocalName
			attributes: anAttributeDictionary)
				parser: self
				parent: self elementHandler
				parentFactory: self elementHandlerFactory.
	self
		elementHandler: newElementHandler;
		elementHandlerFactory:
			(self elementHandlerFactoryMapper
				factoryForElementHandler: newElementHandler
				ifNone: [self elementHandlerFactory]).

	newElementHandler
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName
		attributes: anAttributeDictionary.! !

!SAX2Parser class methodsFor: 'private ' stamp: 'monty 7/4/2016 06:45'!
generateHandlerForwardingMethods
	"
	self generateHandlerForwardingMethods
	"

	(Array
		with: 'contentHandler' -> #'handling - content'
		with: 'lexicalHandler' -> #'handling - lexical'
		with: 'declarationHandler' -> #'handling - declaration')
		do: [:handlerAccessorAndCategory | | handlerAccessor handlerCategory |
			handlerAccessor := handlerAccessorAndCategory key.
			handlerCategory := handlerAccessorAndCategory value.

			(SAXHandler selectorsInCategory: handlerCategory) do: [:each | | parsedMethod sourceStream |
				parsedMethod := RBParser parseMethod: (SAXHandler sourceCodeAt: each).
				(sourceStream := String new writeStream)
					nextPutAll: parsedMethod selectorAndArgumentNames;
					cr;
					nextPutAll: '	self ';
					nextPutAll: handlerAccessor.
				1 to: parsedMethod keywords size do: [:i |
					parsedMethod keywords size > 1
						ifTrue: [
							sourceStream
								cr;
								tab;
								tab]
						ifFalse: [sourceStream space].
					sourceStream nextPutAll: (parsedMethod keywords at: i).
					parsedMethod argumentNames
						ifNotEmpty: [
							sourceStream
								space;
								nextPutAll: (parsedMethod argumentNames at: i)]].

				self
					compile: sourceStream contents
					classified: handlerCategory]]! !

!SAX2Parser class methodsFor: 'private ' stamp: 'monty 7/10/2016 02:42'!
generateMethodsInHandlerClasses
	"
	self generateMethodsInHandlerClasses
	"

	(Array
		with: SAX2ContentHandler -> #'handling - content'
		with: SAX2LexicalHandler -> #'handling - lexical'
		with: SAX2DeclarationHandler -> #'handling - declaration')
		do: [:handlerClassAndCategory | | handlerClass handlerCategory |
			handlerClass := handlerClassAndCategory key.
			handlerCategory := handlerClassAndCategory value.

			(SAXHandler selectorsInCategory: handlerCategory) do: [:each |
				handlerClass
					compile: (SAXHandler sourceCodeAt: each)
					classified: handlerCategory]]! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	self declarationHandler
		attributeDeclaration: anElementName
		name: anAttributeName
		type: aType
		defaultPragma: aDefaultPragma
		defaultValue: aDefaultValue! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
characters: aString
	self contentHandler characters: aString! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
comment: aString
	self lexicalHandler comment: aString! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 6/22/2016 16:27'!
contentHandler
	^ contentHandler! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:58'!
contentHandler: aContentHandler
	(contentHandler :=
		aContentHandler ifNil: [self defaultContentHandlerClass new])
			parser: self! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 6/22/2016 16:27'!
declarationHandler
	^ declarationHandler! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:58'!
declarationHandler: aDeclarationHandler
	(declarationHandler :=
		aDeclarationHandler ifNil: [self defaultDeclarationHandlerClass new])
			parser: self! !

!SAX2Parser methodsFor: 'defaults' stamp: 'monty 7/10/2016 02:41'!
defaultContentHandlerClass
	^ SAX2ContentHandler! !

!SAX2Parser methodsFor: 'defaults' stamp: 'monty 7/10/2016 02:42'!
defaultDeclarationHandlerClass
	^ SAX2DeclarationHandler! !

!SAX2Parser methodsFor: 'defaults' stamp: 'monty 7/10/2016 02:42'!
defaultLexicalHandlerClass
	^ SAX2LexicalHandler! !

!SAX2Parser methodsFor: 'defaults' stamp: 'monty 6/16/2017 01:01'!
defaultParsingResult
	"the default parsing result of SAXHandler"
	^ self! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
elementDeclaration: anElementName contentModel: aContentModel
	self declarationHandler
		elementDeclaration: anElementName
		contentModel: aContentModel! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
endCData
	self lexicalHandler endCData! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
endDTD
	self lexicalHandler endDTD! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
endDocument
	self contentHandler endDocument! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self contentHandler
		endElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
endEntity: anEntityName
	self lexicalHandler endEntity: anEntityName! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
endPrefixMapping: aPrefix
	self contentHandler endPrefixMapping: aPrefix! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	self declarationHandler
		generalEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID
		ndata: aNotationName! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
generalEntityDeclaration: aName replacement: aReplacement
	self declarationHandler
		generalEntityDeclaration: aName
		replacement: aReplacement! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
ignorableWhitespace: aString
	self contentHandler ignorableWhitespace: aString! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 6/22/2016 16:27'!
lexicalHandler
	^ lexicalHandler! !

!SAX2Parser methodsFor: 'accessing' stamp: 'monty 8/14/2016 17:58'!
lexicalHandler: aLexicalHandler
	(lexicalHandler :=
		aLexicalHandler ifNil: [self defaultLexicalHandlerClass new])
			parser: self! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
	self declarationHandler
		notationDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID! !

!SAX2Parser methodsFor: 'initialization' stamp: 'monty 6/16/2017 01:01'!
on: aStringOrStream
	super on: aStringOrStream.

	contentHandler := self defaultContentHandlerClass parser: self.
	lexicalHandler := self defaultLexicalHandlerClass parser: self.
	declarationHandler := self defaultDeclarationHandlerClass parser: self.
	parsingResult := self defaultParsingResult.! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	self declarationHandler
		parameterEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID! !

!SAX2Parser methodsFor: 'handling - declaration' stamp: 'monty 6/24/2016 23:32'!
parameterEntityDeclaration: aName replacement: aReplacement
	self declarationHandler
		parameterEntityDeclaration: aName
		replacement: aReplacement! !

!SAX2Parser methodsFor: 'parsing' stamp: 'monty 8/14/2016 17:53'!
parsingResult
	^ parsingResult! !

!SAX2Parser methodsFor: 'parsing' stamp: 'monty 8/14/2016 17:53'!
parsingResult: anObject
	parsingResult := anObject! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
processingInstruction: aTargetString data: aDataString
	self contentHandler
		processingInstruction: aTargetString
		data: aDataString! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
skippedEntity: anEntityName
	self contentHandler skippedEntity: anEntityName! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
startCData
	self lexicalHandler startCData! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	self lexicalHandler
		startDTD: aRootElementName
		publicID: aPublicID
		systemID: aSystemID! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
startDocument
	self contentHandler startDocument! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: aDictionary
	self contentHandler
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName
		attributes: aDictionary! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
startEntity: anEntityName
	self lexicalHandler startEntity: anEntityName! !

!SAX2Parser methodsFor: 'handling - content' stamp: 'monty 6/24/2016 23:32'!
startPrefixMapping: aPrefix uri: aURI
	self contentHandler
		startPrefixMapping: aPrefix
		uri: aURI! !

!SAX2Parser methodsFor: 'handling - lexical' stamp: 'monty 6/24/2016 23:32'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	self lexicalHandler
		xmlVersion: aVersionFloat
		encoding: anEncoding
		standalone: aBoolean! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 12/9/2017 06:02'!
new
	Error signal:
		'Parsers should be created with #on: or ',
		'some other "instance creation" message'! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 2/1/2018 07:25'!
on: aStringOrStream
	"Returns a new parser on the string or stream argument but doesn't parse it.

	Can be used to configure a parser with 'configuring' messages before
	parsing with #parseDocument."

	^ self basicNew initialize on: aStringOrStream! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 2/1/2018 07:25'!
on: aStringOrStream documentURI: aURIString
	"Returns a new parser on the string or stream argument treating the
	specified URI as the base URI of the document but doesn't parse it.

	Can be used to configure a parser with 'configuring' messages before
	parsing with #parseDocument."

	^ (self on: aStringOrStream) documentURI: aURIString! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 2/1/2018 07:25'!
onFileNamed: aFileName
	"Returns a new parser on the specified file but doesn't parse it.
	If aFileName is a relative path, it will be resolved in the context of
	the current working directory.

	Can be used to configure file parsers with 'configuring' messages before
	parsing with #parseDocument."

	^ self
		on:
			"return an XMLDecodingReadStreamAdapter on the undecoded file
			stream so we can do our own decoding looking at byte order
			marks and <?xml ...?> encoding attributes"
			(XMLDecodingReadStreamAdapter nonDecodingOn:
				aFileName asXMLFileHandle rawReadStream)
		documentURI: aFileName! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 2/1/2018 07:25'!
onURL: aURLString
	"Fetches the URL and returns new parser on the response content but doesn't
	parse it. If the URL has no scheme, it will be treated as a file path.

	Can be used to configure URL parsers with 'configuring' messages before
	parsing with #parseDocument."

	^ self
		onURL: aURLString
		upToLimit: XMLParserLimits defaultDocumentReadLimit! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'monty 2/1/2018 07:25'!
onURL: aURLString upToLimit: aMaxSize
	"Fetches a URL and returns new parser on the response content up to the
	input limit (use nil to disable) but doesn't parse it. If the URL has
	no scheme, it will be treated as a file path.

	Can be used to configure limited URL parsers with 'configuring' messages
	before parsing with #parseDocument."

	^ (self
		on:
			(DTDExternalEntityResolver new
				streamResolveExternalEntityURI: aURLString
				upToLimit: aMaxSize)
		documentURI: aURLString)
			documentReadLimit: aMaxSize! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/11/2016 14:52'!
parse: aStringOrStream
	"Parses the document in the string or stream argument"

	^ (self on: aStringOrStream) parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/11/2016 14:54'!
parse: aStringOrStream documentURI: aURIString
	"Parses the document in the string or stream argument treating the specified
	URI as the base URI of the document."

	^ (self
		on: aStringOrStream
		documentURI: aURIString) parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 15:07'!
parse: aStringOrStream usingNamespaces: aBoolean
	"Parses the document in the string or stream argument possibly with namespace
	checking enabled (default)"

	^ (self on: aStringOrStream)
		usesNamespaces: aBoolean;
		parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 15:08'!
parse: aStringOrStream usingNamespaces: aNamespaceBoolean validation: aValidationBoolean
	"Parses the document in the string or stream argument possibly with namespace
	checking (default) and validation (default) enabled."

	^ (self on: aStringOrStream)
		usesNamespaces: aNamespaceBoolean;
		isValidating: aValidationBoolean;
		parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 15:10'!
parse: aStringOrStream usingNamespaces: aNamespaceBoolean validation: aValidationBoolean externalEntities: anEntityResolutionBoolean
	"Parses the document in the string or stream argument possibly with namespace
	checking (default), validation (default), or external entity resolution (not
	default) enabled."

	^ (self on: aStringOrStream)
		usesNamespaces: aNamespaceBoolean;
		isValidating: aValidationBoolean;
		resolvesExternalEntities: anEntityResolutionBoolean;
		parseDocument! !

!SAXHandler class methodsFor: 'deprecated' stamp: 'monty 4/18/2015 03:20'!
parseDocumentFrom: aStringOrStream
	self deprecated: 'Use #parse: instead'.

	^ self parse: aStringOrStream.! !

!SAXHandler class methodsFor: 'deprecated' stamp: 'monty 3/12/2016 14:51'!
parseDocumentFromFileNamed: aFileName
	self deprecated: 'Use #parseFileNamed: instead'.

	^ self parseFileNamed: aFileName.! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 14:57'!
parseFileNamed: aFileNameString
	"Parses the specified file. If aFileName is a relative path, it will be
	resolved in the context of the current working directory."

	^ (self onFileNamed: aFileNameString) parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 14:53'!
parseURL: aURLString
	"Fetches the URL and parses the response content. If the URL has no scheme,
	it will be treated as a file path."

	^ (self onURL: aURLString) parseDocument! !

!SAXHandler class methodsFor: 'parsing' stamp: 'monty 3/12/2016 22:25'!
parseURL: aURLString upToLimit: aMaxSize
	"Fetches the URL upto the input limit (nil to disable) and parses the
	response content. If the URL has no scheme, it will be treated as a file
	path."

	^ (self
		onURL: aURLString
		upToLimit: aMaxSize) parseDocument! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:38'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:04'!
characters: aString
	"Handles character data in an element, such as the 'test' in
	'<characters>test</characters>' or in the CDATA section '<!![CDATA[test]]>'.
	
	It may be sent multiple times for different sections of character data
	in a single element if they're separated by other nodes or entity
	references like in '<characters>one<!!--comment-->two</characters>'.
	
	See #isInCDataSection and #ignorableWhitespace:"! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/11/2016 14:43'!
comment: aString
	"Handles '<!!--comment-->' sections in documents."! !

!SAXHandler methodsFor: 'accessing' stamp: 'monty 10/27/2014 09:14'!
configuration
	^ configuration! !

!SAXHandler methodsFor: 'accessing' stamp: 'monty 12/3/2014 11:59'!
configuration: aConfiguration
	(configuration := aConfiguration) parserHandlerClass: self class! !

!SAXHandler methodsFor: 'defaults' stamp: 'JAAyer 11/23/2010 15:35'!
configurationClass
	^ XMLConfiguration! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 5/8/2015 19:04'!
decodesCharacters
	^ self configuration decodesCharacters! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 2/11/2018 02:03'!
decodesCharacters: aBoolean
	"When enabled, encoding detection and character decoding will be attemped if:
		1) the input stream or string is binary/external
		2) it starts with a byte-order mark (BOM) byte sequence
		3) the input is wrapped with an XMLDecodingReadStreamAdapter that has
			a null or implicit stream converter
	(Default.)"

	self configuration decodesCharacters: aBoolean! !

!SAXHandler methodsFor: 'defaults' stamp: 'monty 3/20/2016 20:38'!
defaultDocumentURI
	^ ''! !

!SAXHandler methodsFor: 'private' stamp: 'monty 3/8/2015 09:29'!
doctypeDefinition: aDoctypeDefinition! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 3/17/2015 17:32'!
documentReadLimit
	^ self configuration documentReadLimit! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 4/14/2016 03:29'!
documentReadLimit: anInteger
	"change the document read limit (maximum number of chars that can be read)
	or nil to disable"

	self configuration documentReadLimit: anInteger! !

!SAXHandler methodsFor: 'accessing' stamp: 'monty 5/26/2015 01:42'!
documentURI
	"Returns current document base URI string"
	^ documentURI ifNil: [documentURI := self defaultDocumentURI]! !

!SAXHandler methodsFor: 'accessing' stamp: 'monty 5/23/2015 03:03'!
documentURI: aURIString
	documentURI := aURIString! !

!SAXHandler methodsFor: 'defaults' stamp: 'monty 2/9/2014 02:43'!
driverClass
	^ SAXParserDriver! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:39'!
elementDeclaration: anElementName contentModel: aContentModel
! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/11/2016 14:44'!
endCData
	"Sent after the character data of a '<!![CDATA[...]]>' section."! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 11/12/2013 18:01'!
endDTD
! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 3/11/2016 23:35'!
endDocument
	"Handles the end of an XML document. No more handlers are invoked after this."! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName: or #endElement:prefix:uri:."! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	"Handles the end of an element if a subclass doesn't implement
	#endElement:prefix:uri:localName:. By default it forwards to a simpler
	handler, #endElement:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string"

	self endElement: aQualifiedName! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:05'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	"Handles the end of an element, either an end tag like '</end>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#endElement:prefix:uri:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name"

	self
		endElement: aQualifiedName
		prefix: aPrefix
		uri:  aURI! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/27/2016 02:30'!
endEntity: anEntityName
	"Handles the end of some general entity's replacement in content.
	Not sent if the entity is undeclared or if content entity replacement
	is disabled."! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 3/14/2016 00:35'!
endPrefixMapping: aPrefix
	"Handles the end of a namespace prefix/URI mapping when namespaces are
	enabled. After, aPrefix (empty for the default namespace) will be either
	unmapped or mapped to a different URI. The 'xml' prefix is predefined
	and never unmapped."! !

!SAXHandler methodsFor: 'private' stamp: 'monty 9/25/2017 12:23'!
errorInstancesCannotHaveMultipleParsers
	XMLParserException
		formatSignal: 'Instances of {1} cannot have multiple parsers'
		with: self class name! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 12/8/2013 02:33'!
externalEntityResolver
	^ self configuration externalEntityResolver! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 12/29/2013 01:55'!
externalEntityResolver: anExternalEntityResolver
	"This can be used to set a different DTDExternalEntityResolver"

	self configuration externalEntityResolver: anExternalEntityResolver! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:32'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 11/14/2013 04:02'!
generalEntityDeclaration: aName replacement: aReplacement! !

!SAXHandler methodsFor: 'testing' stamp: 'monty 9/17/2017 04:06'!
hasParser
	^ hasParser! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:06'!
ignorableWhitespace: aString
	"When validation is enabled and a DTD with ELEMENT declarations is
	present, this can be used to handle ignorable whitespace in elements
	with 'element content' (meaning they can only contain other elements
	and no PCDATA), such as between '<element-content>' and '<mixed-content>'
	or between '</mixed-content>' and '</element-content>' in this sample:
		'<!!DOCTYPE element-content [
			<!!--this has element content, so its whitespace is ignorable-->
			<!!ELEMENT element-content (mixed-content)>
			<!!--this has mixed content, so its whitespace is not ignorable-->
			<!!ELEMENT mixed-content (#PCDATA|any-content)*>
			<!!--this has any content, so its whitespace is not ignorable-->
			<!!ELEMENT any-content ANY>
		]>
		<element-content>
			<mixed-content>
				<any-content> any </any-content>
			</mixed-content>
		</element-content>'

	Not sent if validation is disabled or if there's no DTD with element
	declarations."! !

!SAXHandler methodsFor: 'initialization' stamp: 'monty 9/16/2017 23:00'!
initializeParser: aParser! !

!SAXHandler methodsFor: 'accessing' stamp: 'monty 6/18/2017 22:49'!
input
	"the input being parsed or to be parsed"
	^ input! !

!SAXHandler methodsFor: 'private' stamp: 'monty 8/21/2016 00:20'!
input: aStringOrStream
	"here for backwards compatibility; use #on: instead"

	input := aStringOrStream! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 2/11/2018 02:10'!
interruptParsing
	"Can be sent within a handler to stop parsing;
	will be silently caught within #parseDocument or other parsing methods"

	XMLParsingInterruptException signal! !

!SAXHandler methodsFor: 'testing' stamp: 'monty 3/14/2016 00:36'!
isInCDataSection
	"Can be used by characters: handlers to distinguish ordinary character
	data from characters within '<!![CDATA[...]]>' sections"

	^ isInCDataSection! !

!SAXHandler methodsFor: 'private' stamp: 'monty 3/11/2016 19:59'!
isInCDataSection: aBoolean
	isInCDataSection := aBoolean! !

!SAXHandler methodsFor: 'testing' stamp: 'monty 3/11/2016 20:08'!
isInContent
	"True if parsing has reached the first element of the document."

	^ isInContent! !

!SAXHandler methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:20'!
isValidating
	^ self configuration isValidating! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 7/18/2016 08:28'!
isValidating: aBoolean
	"If true and the document has a schema (like a DTD with ELEMENT and ATTLIST
	declarations) the document will be validated against it. Otherwise only
	entity references and xml:id attributes will be validated.
	
	(This is unlike the standard which requires validating parsers to reject
	all documents without DTDs or other schemas. To get that behavior,
	use requiresDocumentConstraints:)

	Enabling disables preservesUndeclaredEntityReferences.
	Disabling disables requiresDocumentConstraints."

	self configuration isValidating: aBoolean! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 3/17/2015 17:33'!
maxEntityReplacementDepth
	^ self configuration maxEntityReplacementDepth! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 4/14/2016 03:30'!
maxEntityReplacementDepth: anInteger
	"change the max replacement depth or nil to disable"

	self configuration maxEntityReplacementDepth: anInteger! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 3/21/2015 22:36'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
! !

!SAXHandler methodsFor: 'initialization' stamp: 'monty 9/21/2017 10:50'!
on: aStringOrStream
	input := aStringOrStream.

	"a single instance can parse multiple documents with #on:,
	so each variable must be reset"
	documentURI := nil.
	configuration
		ifNil: [self configuration: self configurationClass new]
		ifNotNil: [self configuration: configuration copy].
	hasParser := false.
	isInContent := false.
	isInCDataSection := false.! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 3/11/2016 13:59'!
optimizeForLargeDocuments
	"use this for faster parsing/less memory use with large documents"

	self
		isValidating: false;
		usesNamespaces: false;
		documentReadLimit: nil! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 3/21/2015 22:36'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID! !

!SAXHandler methodsFor: 'handling - declaration' stamp: 'monty 11/14/2013 04:05'!
parameterEntityDeclaration: aName replacement: aReplacement! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 2/11/2018 02:11'!
parseDocument
	"Parse the entire input string or stream and return the result"

	self parser parseDocument.

	^ self parsingResult.! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 2/11/2018 02:13'!
parseDocumentUntil: aBlock
	"Parse the input string or stream only until aBlock evalautes as true
	and return the result"

	self parser parseDocumentUntil: aBlock.

	^ self parsingResult.! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 2/11/2018 02:13'!
parseDocumentWhile: aBlock
	"Parse the input string or stream only as long as aBlock evalautes as true
	and return the result"

	self parser parseDocumentWhile: aBlock.

	^ self parsingResult.! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 9/29/2017 14:10'!
parser
	"returns a new XMLParser object for this handler"

	| parser |

	hasParser
		ifTrue: [self errorInstancesCannotHaveMultipleParsers].
	hasParser := true.

	parser :=
		self parserClass
			driver: (self driverClass saxHandler: self)
			on: self input.
	self initializeParser: parser.

	^ parser.! !

!SAXHandler methodsFor: 'defaults' stamp: 'monty 10/3/2014 00:18'!
parserClass
	^ XMLParser! !

!SAXHandler methodsFor: 'parsing' stamp: 'monty 12/4/2014 14:07'!
parsingResult
	"value returned by parseDocument and other parsing methods"

	^ self! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/6/2015 04:12'!
preservesUndeclaredEntityReferences
	^ self configuration preservesUndeclaredEntityReferences! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/13/2016 08:47'!
preservesUndeclaredEntityReferences: aBoolean
	"If true, references to undeclared entities in content are
	preserved (not default).
	Disables validation.
	
	(See also replacesContentEntityReferences:, which is usually more appropriate.)"

	self configuration preservesUndeclaredEntityReferences: aBoolean! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:07'!
processingInstruction: aTargetString data: aDataString
	"Handles processing instructions like '<?name value?>', where 'name' is
	the target and 'value' is the data.
	
	XML declarations may look like PIs but are different and are handled
	with #xmlVersion:encoding:standalone: instead."! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 3/17/2015 17:38'!
removeLimits
	"remove all input security limits (unsafe)"

	self configuration removeLimits! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/3/2015 23:55'!
replacesContentEntityReferences
	^ self configuration replacesContentEntityReferences! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/6/2015 22:31'!
replacesContentEntityReferences: aBoolean
	"Replace general parsed entity and character references
	in content (default)"

	self configuration replacesContentEntityReferences: aBoolean! !

!SAXHandler methodsFor: 'deprecated' stamp: 'monty 1/29/2018 08:35'!
requiresDocumentConstraints
	"will be deprecated; use #requiresSchema instead"
	^ self requiresSchema! !

!SAXHandler methodsFor: 'deprecated' stamp: 'monty 1/29/2018 08:35'!
requiresDocumentConstraints: aBoolean
	"will be deprecated; use #requiresSchema: instead"
	self requiresSchema: aBoolean! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/29/2018 08:21'!
requiresSchema
	^ self configuration requiresSchema! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/29/2018 08:28'!
requiresSchema: aBoolean
	"If true, a schema containing constraints on elements and attributes
	(like a DTD with ELEMENT and ATTLIST declarations) will be required.
	Enables validation.

	(Not default)."

	self configuration requiresSchema: aBoolean! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 11/16/2013 07:33'!
resolvesExternalEntities
	^ self configuration resolvesExternalEntities! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 1/24/2014 23:52'!
resolvesExternalEntities: aBoolean
	"When true, external DTDs and parsed entities will be
	fetched (not default)."

	self configuration resolvesExternalEntities: aBoolean! !

!SAXHandler methodsFor: 'private' stamp: 'monty 3/18/2016 01:11'!
schema
	^ nil! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 3/14/2016 00:39'!
skippedEntity: anEntityName
	"Sent when a general parsed entity reference like '&name;' is
	unreplaced in content. Only sent when validation is turned off
	or entity replacement is disabled."! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/11/2016 14:44'!
startCData
	"Sent before the character data of a '<!![CDATA[...]]>' section."! !

!SAXHandler methodsFor: 'private' stamp: 'monty 3/24/2015 20:25'!
startContent
	isInContent := true! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 2/11/2018 02:09'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	"Handles the start of a '<!!DOCTYPE ...>' declaration. Any events
	after this and until #endDTD is sent are part of the internal subset
	of the DTD.
	
	aRootElementName - the expected name of the document's root element
	aPublicID - the public ID of the external DTD subset or an empty string
	aSystemID - the URI where the external subset can be found or an empty string"! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 3/11/2016 23:33'!
startDocument
	"Handles the start of an XML document, the first handler invoked."! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes: or
	#startElement:prefix:uri:attributes:.

	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	anAttributeDictionary - an XMLAttributeDictionary of attributes"! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: anAttributeDictionary
	"Handles the start of an element if a subclass doesn't implement
	#startElement:prefix:uri:localName:attributes:. By default it forwards
	to a simpler handler, #startElement:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		attributes: anAttributeDictionary! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 2/11/2018 02:08'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	"Handles the start of an element, either a start tag like '<start>' or a
	self-closed tag like '<empty/>'. By default it forwards to a simpler handler,
	#startElement:prefix:uri:attributes:.
	
	aQualifiedName - the full name, including any prefix, such as 'prefix:name'
	aPrefix - the prefix of the qualified name or an empty string
	aURI - the namespace URI of the element or an empty string
	aLocalName - the local part of the qualified name
	anAttributeDictionary - an XMLAttributeDictionary of attributes"

	self
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		attributes: anAttributeDictionary! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/27/2016 02:30'!
startEntity: anEntityName
	"Handles the start of some general entity's replacement in content.
	Not sent if the entity is undeclared or if content entity replacement
	is disabled."! !

!SAXHandler methodsFor: 'handling - content' stamp: 'monty 3/14/2016 00:31'!
startPrefixMapping: aPrefix uri: aURI
	"Handles the start of a namespace prefix/URI mapping when namespaces are
	enabled. The 'xml' prefix is predefined and never remapped.

	aPrefix - the prefix of the namespace (empty for the default namesapce)
	aURI - the namespace URI"! !

!SAXHandler methodsFor: 'private' stamp: 'monty 9/1/2017 00:19'!
startScope: aNamespaceScope! !

!SAXHandler methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:20'!
usesNamespaces
	^ self configuration usesNamespaces! !

!SAXHandler methodsFor: 'configuring' stamp: 'monty 12/29/2013 03:03'!
usesNamespaces: aBoolean
	"Namespace checking when true (default)"

	self configuration usesNamespaces: aBoolean! !

!SAXHandler methodsFor: 'handling - lexical' stamp: 'monty 3/14/2016 00:52'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	"Handles the '<?xml ...?>' declaration of a document.
	
	aVersionFloat - the version of XML the document uses, usually 1.0
	anEncoding - the name of the encoding or an empty string
	aBoolean - true if standalone='yes'"! !

SAXHandler subclass: #XMLDOMParser
	instanceVariableNames: 'document nodeStack currentScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLDOMParser commentStamp: 'monty 2/11/2018 02:01' prior: 0!
This class is an XML parser that parses XML into a tree of nodes with an XMLDocument node as the root:
	document := XMLDOMParser parse: xmlStringOrStream.

See the XML-Parser-DOM category for info on the node classes.

By default, XML comments are ignored during parsing and "<!![CDATA[...]]>" sections are merged with adjacent character data as XMLString nodes. Use #preservesCommentNodes: or #preservesCDataNodes: before parsing to change this. You can also use #preservesIgnorableWhitespace: to preserve ignorable whitespace as XMLString nodes, but this requires a DTD with <!!ELEMENT> declarations to distinguish ignorable and unignorable whitespace.

To control what node classes the parser uses to construct the tree, inject a custom node factory with #nodeFactory: prior to parsing. See XMLNodeFactory.

See the superclass for more info.!

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:38'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	self topNode addNode:
		(self nodeFactory attributeDeclarationClass
			element: anElementName
			attribute: anAttributeName
			type: aType
			defaultPragma: aDefaultPragma
			defaultValue: aDefaultValue)! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 8/14/2016 21:26'!
characters: aString
	(self isInCDataSection
		and: [self preservesCDataNodes])
		ifTrue: [self topNode addNode: (self nodeFactory newCData: aString)]
		ifFalse: [self topNode addString: aString]! !

!XMLDOMParser methodsFor: 'handling - lexical' stamp: 'monty 3/11/2016 14:17'!
comment: aString
	self preservesCommentNodes
		ifTrue: [self topNode addNode: (self nodeFactory newComment: aString)]! !

!XMLDOMParser methodsFor: 'defaults' stamp: 'JAAyer 11/23/2010 14:37'!
configurationClass
	^ XMLDOMConfiguration! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 3/8/2015 10:12'!
doctypeDefinition: aDoctypeDefinition
	self document doctypeDefinition: aDoctypeDefinition! !

!XMLDOMParser methodsFor: 'accessing' stamp: 'JAAyer 3/9/2010 01:38'!
document
	^ document! !

!XMLDOMParser methodsFor: 'accessing' stamp: 'monty 11/6/2014 14:07'!
document: aDocument
	document := aDocument! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:39'!
elementDeclaration: anElementName contentModel: aContentModel
	self topNode addNode:
		(self nodeFactory elementDeclarationClass
			element: anElementName
			contentModel: aContentModel)! !

!XMLDOMParser methodsFor: 'handling - lexical' stamp: 'monty 11/12/2013 23:00'!
endDTD
	self popNode! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:56'!
endDocument
	"nodeStack is not popped here for efficiency because #document keeps
	a reference to the root too, and there may not be a root to pop
	anyway if it's an inner XML parser"! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 9/19/2017 06:27'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self popNode! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 6/7/2015 19:32'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	self topNode addNode:
		(self nodeFactory generalEntityDeclarationClass
			name: aName
			publicID: aPublicID
			systemID: aSystemID
			ndata: aNotationName)! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 12/21/2013 03:02'!
generalEntityDeclaration: aName replacement: aReplacement
	self topNode addNode:
		(self nodeFactory generalEntityDeclarationClass
			name: aName
			replacement: aReplacement)! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 1/3/2015 00:05'!
ignorableWhitespace: aString
	self preservesIgnorableWhitespace
		ifTrue: [self characters: aString]! !

!XMLDOMParser methodsFor: 'initialization' stamp: 'monty 10/6/2017 14:16'!
initializeInnerXMLParser: aParser
	self document
		ifNotNil: [
			aParser driver isStandalone: self document isStandalone.
			self document hasDoctypeDefinition
				ifTrue: [
					aParser driver doctypeDefinition addGeneralEntitiesFrom:
						self document doctypeDefinition]].

	self nodeStack do: [:each |
		each isElement
			ifTrue: [
				self
					startInnerXMLElement: each
					forParser: aParser]].

	aParser state: self topNode newInnerXMLState.
	aParser state isContentState
		ifTrue: [self startContent].! !

!XMLDOMParser methodsFor: 'initialization' stamp: 'monty 9/17/2017 02:06'!
initializeParser: aParser
	super initializeParser: aParser.

	self nodeStack size > 0
		ifTrue: [self initializeInnerXMLParser: aParser].! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 9/16/2017 23:38'!
innerXMLRootNode: aRootNode
	self
		configuration: aRootNode configuration;
		document: aRootNode document;
		pushNode: aRootNode! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:18'!
nodeFactory
	^ self configuration nodeFactory! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:18'!
nodeFactory: aNodeFactory
	self configuration nodeFactory: aNodeFactory! !

!XMLDOMParser methodsFor: 'deprecated' stamp: 'monty 4/17/2015 10:55'!
nodeListClass
	"will be deprecated"
	^ self configuration nodeListClass! !

!XMLDOMParser methodsFor: 'deprecated' stamp: 'monty 4/17/2015 10:55'!
nodeListClass: aClass
	"will be deprecated"
	self configuration nodeListClass: aClass! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 10/27/2014 09:12'!
nodeStack
	^ nodeStack! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 3/21/2015 22:36'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
	self topNode addNode:
		(self nodeFactory notationDeclarationClass
			name: aName
			publicID: aPublicID
			systemID: aSystemID)! !

!XMLDOMParser methodsFor: 'initialization' stamp: 'monty 9/16/2017 23:05'!
on: aStringOrStream
	super on: aStringOrStream.

	document := nil.
	nodeStack := OrderedCollection new: 10.
	currentScope := nil.! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'monty 9/6/2016 00:28'!
optimizeForLargeDocuments
	super optimizeForLargeDocuments.

	"use the non-caching attribute list class to save memory"
	self configuration attributeListClass: XMLAttributeList.! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 3/21/2015 22:36'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	self topNode addNode:
		(self nodeFactory parameterEntityDeclarationClass
			name: aName
			publicID: aPublicID
			systemID: aSystemID)! !

!XMLDOMParser methodsFor: 'handling - declaration' stamp: 'monty 12/21/2013 03:02'!
parameterEntityDeclaration: aName replacement: aReplacement
	self topNode addNode:
		(self nodeFactory parameterEntityDeclarationClass
			name: aName
			replacement: aReplacement)! !

!XMLDOMParser methodsFor: 'parsing' stamp: 'monty 12/19/2013 00:38'!
parsingResult
	^ self document! !

!XMLDOMParser methodsFor: 'private' stamp: 'JAAyer 3/16/2010 09:31'!
popNode
	^ self nodeStack removeLast! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:18'!
preservesCDataNodes
	^ self configuration preservesCDataNodes! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'monty 4/11/2015 03:13'!
preservesCDataNodes: aBoolean
	"if enabled, <!![CDATA[...]]> sections will be preserved as CDATA nodes
	and not ordinary string nodes and won't be merged with adjacent string
	nodes (not default)"
	self configuration preservesCDataNodes: aBoolean! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'JAAyer 11/23/2010 14:18'!
preservesCommentNodes
	^ self configuration preservesCommentNodes! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'monty 4/10/2015 21:54'!
preservesCommentNodes: aBoolean
	"if enabled, comments will be preserved as comment nodes (not default)"
	self configuration preservesCommentNodes: aBoolean! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'monty 1/3/2015 00:05'!
preservesIgnorableWhitespace
	^ self configuration preservesIgnorableWhitespace! !

!XMLDOMParser methodsFor: 'configuring' stamp: 'monty 4/20/2016 13:48'!
preservesIgnorableWhitespace: aBoolean
	"If enabled, ignorable whitespace (identified by DTD element declarations
	with element content) will be preserved as string nodes. Enables validation.
	(Not default)"

	self configuration preservesIgnorableWhitespace: aBoolean! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 3/21/2015 22:51'!
processingInstruction: aTargetString data: aDataString
	self topNode addNode:
		(self nodeFactory newPI
			target: aTargetString;
			data: aDataString)! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 2/4/2014 01:33'!
pushElement: anElement
	self topNode addNode: anElement.
	^ self pushNode: anElement.! !

!XMLDOMParser methodsFor: 'private' stamp: 'JAAyer 11/28/2010 13:25'!
pushNode: aNode
	^ self nodeStack addLast: aNode
! !

!XMLDOMParser methodsFor: 'handling - lexical' stamp: 'monty 3/21/2015 22:36'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	| doctypeDeclaration |

	doctypeDeclaration := 
		self nodeFactory doctypeDeclarationClass
			root: aRootElementName
			publicID: aPublicID
			systemID: aSystemID.
	self pushNode: doctypeDeclaration.
	self document doctypeDeclaration: doctypeDeclaration.! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 10/3/2017 11:39'!
startDocument
	"inner XML parsers should ignore this event"
	self nodeStack size > 0
		ifFalse: [
			self
				document: self nodeFactory newDocument;
				pushNode: self document.

			self document configuration: self configuration]! !

!XMLDOMParser methodsFor: 'handling - content' stamp: 'monty 9/1/2017 00:30'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self pushElement:
		((self nodeFactory
			classForElement: aQualifiedName
			namespaceURI: aURI
			localName: aLocalName
			attributes: anAttributeDictionary) new
				setConfiguration: self configuration
				name: aQualifiedName
				localName: aLocalName
				attributes: anAttributeDictionary
				namespaceScope: currentScope)! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 3/7/2017 12:49'!
startInnerXMLElement: anElement forParser: aParser
	aParser driver currentElement: anElement name.
	anElement hasNamespaces
		ifTrue: [aParser driver currentScope: anElement namespaceScope].! !

!XMLDOMParser methodsFor: 'private' stamp: 'monty 9/1/2017 00:30'!
startScope: aNamespaceScope
	currentScope := aNamespaceScope! !

!XMLDOMParser methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
topNode
	^ self nodeStack xmlLastOrNil! !

!XMLDOMParser methodsFor: 'handling - lexical' stamp: 'monty 11/19/2013 05:37'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	self document ifNotNil: [
		self document
			version: aVersionFloat;
			encoding: anEncoding;
			isStandalone: aBoolean]! !

Object subclass: #XMLAbstractFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

XMLAbstractFactory class
	instanceVariableNames: 'implementation'!

!XMLAbstractFactory commentStamp: 'monty 10/23/2017 04:59' prior: 0!
An abstract class for dynamically choosing a supported concrete implementation from a class hierarchy for this platform.

Each root subclass needs to override #preferredImplementation to return the preferred subclass and #noSupportedImplementationFound to signal an error if none are supported, and then each subclass of the root needs to define #isSupportedImplementation to return true if it supports this platform.!

XMLAbstractFactory class
	instanceVariableNames: 'implementation'!

!XMLAbstractFactory class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ false! !

!XMLAbstractFactory class methodsFor: 'clearing' stamp: 'monty 9/3/2017 07:35'!
clearAllImplementations
	"self clearAllImplementations"

	self
		implementation: nil;
		allSubclassesDo: [:each | each implementation: nil]! !

!XMLAbstractFactory class methodsFor: 'finding' stamp: 'monty 1/28/2018 19:39'!
findSupportedImplementation
	self canBeImplemented
		ifTrue: [
			self isSupportedImplementation
				ifTrue: [^ self].

			(self preferredImplementation notNil
				and: [self preferredImplementation isSupportedImplementation])
				ifTrue: [^ self preferredImplementation].
			self allSubclassesDo: [:each |
				each isSupportedImplementation
					ifTrue: [^ each]]].

	^ nil.! !

!XMLAbstractFactory class methodsFor: 'testing' stamp: 'monty 3/4/2016 16:30'!
hasSupportedImplementation
	^ self findSupportedImplementation notNil! !

!XMLAbstractFactory class methodsFor: 'accessing' stamp: 'monty 6/17/2017 00:34'!
implementation
	^ implementation
		ifNil: [
			"avoid assigning to the class inst var unless an implementation
			was found to minimize write conflicts on GS"
			self findSupportedImplementation
				ifNil: [self noSupportedImplementationFound]
				ifNotNil: [:supportedImplementation |
					implementation := supportedImplementation].
			implementation]! !

!XMLAbstractFactory class methodsFor: 'accessing' stamp: 'monty 10/9/2016 17:09'!
implementation: aClassOrNil
	implementation := aClassOrNil! !

!XMLAbstractFactory class methodsFor: 'instance creation' stamp: 'monty 12/30/2017 14:19'!
implementationNew
	^ self implementation basicNew initialize! !

!XMLAbstractFactory class methodsFor: 'class initialization' stamp: 'monty 9/3/2017 07:36'!
initialize
	"self initialize"

	self clearAllImplementations! !

XMLAbstractFactory initialize!

!XMLAbstractFactory class methodsFor: 'testing' stamp: 'monty 3/4/2016 16:23'!
isSupportedImplementation
	^ false! !

!XMLAbstractFactory class methodsFor: 'instance creation' stamp: 'monty 12/30/2017 14:19'!
new
	^ self implementationNew! !

!XMLAbstractFactory class methodsFor: 'finding' stamp: 'monty 1/28/2018 19:41'!
noSupportedImplementationFound
	Error signal: 'No implementation available'! !

!XMLAbstractFactory class methodsFor: 'defaults' stamp: 'monty 1/28/2018 19:32'!
preferredImplementation
	^ nil! !

XMLAbstractFactory subclass: #XMLFileHandle
	instanceVariableNames: 'path'
	classVariableNames: 'XMLDocumentFileExtensions'
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLFileHandle commentStamp: 'monty 9/30/2016 00:25' prior: 0!
This is an abstract class for file handles to read/write/delete files. Subclasses need to implement the abstract methods, and then instances of the correct concrete class for this platform can be created by sending #asXMLFileHandle to a string.

The #readStream/#writeStream messages return file streams that do decoding/encoding, while the #rawReadStream/#rawWriteStream streams don't.

These classes implement the #get/#getUpToLimit:decoding: and #streamGet/#streamGetUpToLimit:decoding: interface of XMLURI.!

XMLFileHandle subclass: #XMLFileDirectoryFileHandle
	instanceVariableNames: 'fileDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLFileDirectoryFileHandle commentStamp: 'monty 3/13/2016 23:22' prior: 0!
This class uses FileDirectory/DirectoryEntry to implement file IO. This is used on Squeak and Gemstone, which don't support the Pharo FileSystem API.!

!XMLFileDirectoryFileHandle class methodsFor: 'basic' stamp: 'monty 7/6/2016 02:35'!
basicCurrentWorkingDirectory
	^ (XMLClassFinder classNamed: #FileDirectory) default pathName! !

!XMLFileDirectoryFileHandle class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #FileDirectory! !

!XMLFileDirectoryFileHandle methodsFor: 'basic' stamp: 'monty 3/13/2016 21:33'!
basicDelete
	"FileDirectory's deleteFileNamed: is used because DirectoryEntry
	doesn't understand #delete on GS"
	self fileDirectory deleteFileNamed: self path! !

!XMLFileDirectoryFileHandle methodsFor: 'basic' stamp: 'monty 9/16/2016 15:46'!
basicFileSize
	^ self directoryEntry fileSize! !

!XMLFileDirectoryFileHandle methodsFor: 'accessing' stamp: 'monty 3/13/2016 23:11'!
directoryEntry
	"a bug on Squeak (but not GS) with the handling of dot relative paths
	like './file.xml' requires fully qualifying the path before creating
	the DirectoryEntry"
	^ self fileDirectory directoryEntryFor:
		(self fileDirectory fullPathFor: self path)! !

!XMLFileDirectoryFileHandle methodsFor: 'testing' stamp: 'monty 3/13/2016 00:31'!
exists
	^ self directoryEntry notNil! !

!XMLFileDirectoryFileHandle methodsFor: 'accessing' stamp: 'monty 7/6/2016 02:46'!
fileDirectory
	^ fileDirectory
		ifNil: [fileDirectory := (XMLClassFinder classNamed: #FileDirectory) default]! !

!XMLFileDirectoryFileHandle methodsFor: 'testing' stamp: 'monty 3/13/2016 00:32'!
isFile
	^ self exists
		and: [self directoryEntry isDirectory not]! !

!XMLFileHandle class methodsFor: 'basic' stamp: 'monty 3/13/2016 21:17'!
basicCurrentWorkingDirectory
	self subclassResponsibility! !

!XMLFileHandle class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLFileHandle class methodsFor: 'accessing' stamp: 'monty 3/13/2016 23:21'!
currentWorkingDirectory
	"returns a path string for the current working directory"

	^ self implementation basicCurrentWorkingDirectory! !

!XMLFileHandle class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	XMLFileException signal: 'File IO unsupported'! !

!XMLFileHandle class methodsFor: 'instance creation' stamp: 'monty 10/13/2017 03:47'!
path: aPathString
	^ self new setPath: aPathString! !

!XMLFileHandle class methodsFor: 'defaults' stamp: 'monty 10/25/2014 18:56'!
preferredImplementation
	^ XMLFileSystemFileHandle! !

!XMLFileHandle class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:33'!
xmlDocumentFileExtensions
	"a class variable so it's shared by all subclasses, but lazy initialized
	so it isn't initialized unless needed"
	^ XMLDocumentFileExtensions
		ifNil: [
			XMLDocumentFileExtensions :=
				#('atom' "Atom Syndication Format"
					'dbk' "DocBook XML"
					'docm' "Office Open XML Document"
					'docx' "Office Open XML Document"
					'pptm' "Office Open XML Presentation"
					'pptx' "Office Open XML Presentation"
					'rdf' "Resource Description Framework"
					'rss' "Rich Site Summary"
					'svg' "Scalable Vector Graphics"
					'xbel' "XML Bookmark Exchange Language"
					'xfd' "Extensible Forms Description Language"
					'xfdl' "Extensible Forms Description Language"
					'xhtml'
					'xlsm' "Office Open XML Workbook"
					'xlsx' "Office Open XML Workbook"
					'xml'
					'xsd' "XML Schema Definition"
					'xspf' "XML Shareable Playlist Format"
					'xul' "XML User Interface Language"
				) asSet]! !

!XMLFileHandle class methodsFor: 'accessing' stamp: 'monty 10/9/2016 17:10'!
xmlDocumentFileExtensions: aCollectionOrNil
	XMLDocumentFileExtensions :=
		aCollectionOrNil
			ifNotNil: [aCollectionOrNil asSet]! !

!XMLFileHandle methodsFor: 'converting' stamp: 'monty 2/2/2016 17:36'!
asXMLFileHandle
	^ self! !

!XMLFileHandle methodsFor: 'basic' stamp: 'monty 3/13/2016 21:33'!
basicDelete
	self subclassResponsibility! !

!XMLFileHandle methodsFor: 'basic' stamp: 'monty 9/19/2016 07:55'!
basicFileSize
	"This is named #basicFileSize instead of #basicSize to avoid conflicting
	with the Object>>#basicSize primitive"

	self subclassResponsibility! !

!XMLFileHandle methodsFor: 'accessing' stamp: 'monty 11/18/2016 18:36'!
contents
	^ self readStreamDo: [:readStream | readStream upToEnd]! !

!XMLFileHandle methodsFor: 'deleting' stamp: 'monty 3/13/2016 22:39'!
delete
	self exists
		ifFalse: [self errorFileDoesNotExist].

	[self basicDelete]
		on: Error
		do: [:error | XMLFileException signalMessageFrom: error].! !

!XMLFileHandle methodsFor: 'private' stamp: 'monty 3/13/2016 22:39'!
errorFileDoesNotExist
	XMLFileException
		formatSignal: 'File does does not exist: {1}'
		with: self path! !

!XMLFileHandle methodsFor: 'private' stamp: 'monty 3/19/2016 19:11'!
errorFileExceedsMaxSize: aMaxSize
	XMLLimitException
		formatSignal: 'File exceeds max size of {1} bytes: {2}'
		with: aMaxSize
		with: self path! !

!XMLFileHandle methodsFor: 'private' stamp: 'monty 3/12/2016 19:28'!
errorNotAFile
	XMLFileException
		formatSignal: 'Not a file: {1}'
		with: self path! !

!XMLFileHandle methodsFor: 'testing' stamp: 'monty 3/13/2016 00:31'!
exists
	"returns true if the file exists"

	self subclassResponsibility! !

!XMLFileHandle methodsFor: 'accessing' stamp: 'monty 7/6/2016 06:31'!
extension
	"Returns the file extension, everything after the first '.' of the
	last path segment:
		'one.two/three.txt' asXMLFileHandle extension = 'txt'.
		'one.two/three.tar.gz' asXMLFileHandle extension = 'tar.gz'.
		'one.two/three.four/' asXMLFileHandle extension = ''.
	"
	| i |

	^ ((i := self path lastIndexOf: $/) > 0
		ifTrue: [self path copyFrom: i + 1 to: self path size]
		ifFalse: [self path]) copyAfter: $.! !

!XMLFileHandle methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:40'!
get
	^ self
		getUpToLimit: nil
		decoding: true! !

!XMLFileHandle methodsFor: 'retrieving' stamp: 'monty 11/18/2016 18:36'!
getUpToLimit: aMaxSize decoding: aBoolean
	| stream contents |

	"can be safely implemented using streamGetUpToLimit:decoding: rather
	than the other way around like XMLHTTPRequest requires, because files
	are local and can be safely read incrementally, unlike an HTTP response
	which must be read immediately and stored entirely in memory"
	stream :=
		self
			streamGetUpToLimit: aMaxSize
			decoding: aBoolean.
	contents := stream upToEnd.
	stream close.

	^ contents.! !

!XMLFileHandle methodsFor: 'testing' stamp: 'monty 3/13/2016 00:31'!
isFile
	"returns true if the file exists and is a file (not a directory)"

	self subclassResponsibility! !

!XMLFileHandle methodsFor: 'testing' stamp: 'monty 9/28/2016 22:12'!
isXMLDocumentFile
	"Returns true if the file has a known extension of an XML document format
	such as .xml, .xhtml, .xul, but not .dtd, .ent, or other XML-related
	formats that aren't proper XML documents."

	^ self class xmlDocumentFileExtensions includes: self extension asLowercase! !

!XMLFileHandle methodsFor: 'instance creation' stamp: 'monty 3/13/2016 21:08'!
newFileReadStreamOnPath
	^ XMLFileReadStreamFactory onPath: self path! !

!XMLFileHandle methodsFor: 'instance creation' stamp: 'monty 3/13/2016 21:08'!
newFileWriteStreamOnPath
	^ XMLFileWriteStreamFactory onPath: self path! !

!XMLFileHandle methodsFor: 'accessing' stamp: 'monty 10/13/2017 03:51'!
path
	^ path ifNil: [path := '']! !

!XMLFileHandle methodsFor: 'printing' stamp: 'monty 3/12/2016 19:28'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPut: $).! !

!XMLFileHandle methodsFor: 'reading' stamp: 'monty 3/13/2016 22:39'!
rawReadStream
	"returns a raw file read stream with no decoding"

	self exists
		ifFalse: [self errorFileDoesNotExist].
	self isFile
		ifFalse: [self errorNotAFile].
	
	^ [self newFileReadStreamOnPath]
		on: Error
		do: [:error | XMLFileException signalMessageFrom: error].! !

!XMLFileHandle methodsFor: 'writing' stamp: 'monty 3/13/2016 21:08'!
rawWriteStream
	"returns a raw file write stream with no encoding; truncates existing files"

	^ [self newFileWriteStreamOnPath]
		on: Error
		do: [:error | XMLFileException signalMessageFrom: error]! !

!XMLFileHandle methodsFor: 'reading' stamp: 'monty 1/21/2018 01:30'!
readStream
	"returns a file read stream with decoding"

	^ (XMLDecodingReadStreamAdapter nonDecodingOn: self rawReadStream)
		detectEncoding! !

!XMLFileHandle methodsFor: 'reading' stamp: 'monty 10/3/2016 22:07'!
readStreamDo: aBlock
	"evaluates aBlock with a file read stream with decoding and automatically
	closes it after"

	| readStream |

	readStream := self readStream.
	^ [aBlock value: readStream]
		ensure: [readStream close].! !

!XMLFileHandle methodsFor: 'initialization' stamp: 'monty 10/13/2017 03:48'!
setPath: aPathString
	path := aPathString! !

!XMLFileHandle methodsFor: 'accessing' stamp: 'monty 9/16/2016 15:45'!
size
	self exists
		ifFalse: [self errorFileDoesNotExist].

	^ self basicFileSize.! !

!XMLFileHandle methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:40'!
streamGet
	^ self
		streamGetUpToLimit: nil
		decoding: true! !

!XMLFileHandle methodsFor: 'retrieving' stamp: 'monty 9/16/2016 15:40'!
streamGetUpToLimit: aMaxSize decoding: aBoolean
	(aMaxSize notNil
		and: [self size > aMaxSize])
		ifTrue: [self errorFileExceedsMaxSize: aMaxSize].

	^ aBoolean
		ifTrue: [self readStream]
		ifFalse: [self rawReadStream].! !

!XMLFileHandle methodsFor: 'writing' stamp: 'monty 10/3/2016 22:07'!
writeStream
	"returns a file write stream with encoding; truncates existing files"

	^ XMLEncodingWriteStreamAdapter on: self rawWriteStream! !

!XMLFileHandle methodsFor: 'writing' stamp: 'monty 10/3/2016 22:07'!
writeStreamDo: aBlock
	"evaluates aBlock with a file write stream with encoding and
	automatically closes it after; truncates existing files"

	| writeStream |

	writeStream := self writeStream.
	^ [aBlock value: writeStream]
		ensure: [writeStream close].! !

XMLFileHandle subclass: #XMLFileSystemFileHandle
	instanceVariableNames: 'fileReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLFileSystemFileHandle commentStamp: 'monty 2/2/2016 00:15' prior: 0!
This class uses the Pharo FileSystem API to implement file IO. The preferred implementation.!

!XMLFileSystemFileHandle class methodsFor: 'basic' stamp: 'monty 2/6/2018 22:26'!
basicCurrentWorkingDirectory
	"avoid the class #workingDirectory message for Pharo1x compatibility"
	^ (XMLClassFinder classNamed: #FileSystem) disk workingDirectory pathString! !

!XMLFileSystemFileHandle class methodsFor: 'instance creation' stamp: 'monty 10/18/2017 00:27'!
fileReference: aFileReference
	^ self new setFileReference: aFileReference! !

!XMLFileSystemFileHandle class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #FileSystem! !

!XMLFileSystemFileHandle methodsFor: 'basic' stamp: 'monty 3/13/2016 21:33'!
basicDelete
	self fileReference delete! !

!XMLFileSystemFileHandle methodsFor: 'basic' stamp: 'monty 9/16/2016 15:46'!
basicFileSize
	^ self fileReference size! !

!XMLFileSystemFileHandle methodsFor: 'testing' stamp: 'monty 3/13/2016 00:31'!
exists
	^ self fileReference exists! !

!XMLFileSystemFileHandle methodsFor: 'accessing' stamp: 'monty 3/12/2016 19:29'!
fileReference
	^ fileReference ifNil: [fileReference := self path asFileReference]! !

!XMLFileSystemFileHandle methodsFor: 'testing' stamp: 'monty 1/13/2014 04:37'!
isFile
	^ self fileReference isFile! !

!XMLFileSystemFileHandle methodsFor: 'instance creation' stamp: 'monty 9/12/2016 01:29'!
newFileReadStreamOnPath
	"memory file references need special handling"
	self usesMemoryStore
		ifTrue: [^ self fileReference readStream].
	^ super newFileReadStreamOnPath.! !

!XMLFileSystemFileHandle methodsFor: 'instance creation' stamp: 'monty 9/12/2016 01:28'!
newFileWriteStreamOnPath
	"memory file references need special handling"
	self usesMemoryStore
		ifTrue: [^ self fileReference writeStream].
	^ super newFileWriteStreamOnPath.! !

!XMLFileSystemFileHandle methodsFor: 'initialization' stamp: 'monty 10/18/2017 00:26'!
setFileReference: aFileReference
	fileReference := aFileReference.
	self setPath: aFileReference fullName.! !

!XMLFileSystemFileHandle methodsFor: 'testing' stamp: 'monty 9/12/2016 02:02'!
usesMemoryStore
	"Pharo 3.0 has memory stores but lacks #isMemoryFileSystem, so
	this test is used instead for backwards compatibility"
	^ self fileReference fileSystem store class ==
		(XMLClassFinder classNamed: #MemoryStore)! !

XMLAbstractFactory subclass: #XMLFileReadStreamFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLFileReadStreamFactory commentStamp: 'monty 3/14/2016 19:40' prior: 0!
An abstract factory for file read streams used by XMLFileHandles.

Subclasses should create read streams that return raw byte characters and not characters decoded from some encoding (like UTF-8), so that XMLParser can do its own decoding later looking at byte-order marks and the <?xml ...?> encoding attribute.!

!XMLFileReadStreamFactory class methodsFor: 'basic' stamp: 'monty 3/14/2016 00:07'!
basicOnPath: aPathString
	self subclassResponsibility! !

!XMLFileReadStreamFactory class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLFileReadStreamFactory class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	XMLFileException signal: 'File reading unsupported'! !

!XMLFileReadStreamFactory class methodsFor: 'instance creation' stamp: 'monty 3/14/2016 00:22'!
onPath: aPathString
	^ self implementation basicOnPath: aPathString! !

!XMLFileReadStreamFactory class methodsFor: 'defaults' stamp: 'monty 11/20/2014 02:32'!
preferredImplementation
	^ XMLStandardFileStreamReadStreamFactory! !

XMLFileReadStreamFactory subclass: #XMLStandardFileStreamReadStreamFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLStandardFileStreamReadStreamFactory commentStamp: 'monty 3/13/2016 23:23' prior: 0!
A StandardFileStream read stream factory. This stream is preferred for Squeak/Pharo because it does no decoding and returns byte characters so XMLParser can do its own decoding.!

!XMLStandardFileStreamReadStreamFactory class methodsFor: 'basic' stamp: 'monty 2/4/2018 22:17'!
basicOnPath: aPathString
	^ ((XMLClassFinder classNamed: #StandardFileStream)
		readOnlyFileNamed: aPathString)
			binary;
			yourself! !

!XMLStandardFileStreamReadStreamFactory class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #StandardFileStream! !

XMLAbstractFactory subclass: #XMLFileWriteStreamFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLFileWriteStreamFactory commentStamp: 'monty 3/14/2016 19:40' prior: 0!
An abstract factory for file write streams used by XMLFileHandles.

Subclasses should create write streams that do no automatic encoding and accept raw byte characters, so XMLParser can do its own encoding.!

!XMLFileWriteStreamFactory class methodsFor: 'basic' stamp: 'monty 3/14/2016 00:08'!
basicOnPath: aPathString
	self subclassResponsibility! !

!XMLFileWriteStreamFactory class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLFileWriteStreamFactory class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	XMLFileException signal: 'File writing unsupported'! !

!XMLFileWriteStreamFactory class methodsFor: 'instance creation' stamp: 'monty 3/14/2016 00:22'!
onPath: aPathString
	^ self implementation basicOnPath: aPathString! !

!XMLFileWriteStreamFactory class methodsFor: 'defaults' stamp: 'monty 2/2/2016 00:08'!
preferredImplementation
	^ XMLStandardFileStreamWriteStreamFactory! !

XMLFileWriteStreamFactory subclass: #XMLStandardFileStreamWriteStreamFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Files'!

!XMLStandardFileStreamWriteStreamFactory commentStamp: 'monty 3/13/2016 23:24' prior: 0!
A StandardFileStream write stream factory. This stream is preferred for Pharo/Squeak because it does no encoding and accepts byte characters so XMLParser can do its own encoding.!

!XMLStandardFileStreamWriteStreamFactory class methodsFor: 'basic' stamp: 'monty 2/4/2018 22:17'!
basicOnPath: aPathString
	"use forceNewFileNamed: to ensure truncation of existing files before writing"
	^ ((XMLClassFinder classNamed: #StandardFileStream)
		forceNewFileNamed: aPathString)
			binary;
			yourself! !

!XMLStandardFileStreamWriteStreamFactory class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #StandardFileStream! !

XMLAbstractFactory subclass: #XMLHTTPMessage
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPMessage commentStamp: 'monty 12/24/2017 09:12' prior: 0!
This is an abstract class for HTTP messages.!

!XMLHTTPMessage methodsFor: 'adding' stamp: 'monty 12/26/2017 14:54'!
addHeader: anAssociation
	self
		headerValuesAt: anAssociation key
		add: anAssociation value.
	^ anAssociation.! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 2/5/2018 01:00'!
content
	"Returns the response content as a String or ByteArray"

	"Requests with content aren't supported yet"
	^ content ifNil: [content := '']! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 2/5/2018 01:00'!
content: aStringOrByteArray
	content := aStringOrByteArray! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 1/2/2018 11:16'!
contentCharset
	| contentType charset |

	^ ((contentType := self contentType) isNil
		or: [(charset := contentType charset) isEmpty])
		ifTrue: [self defaultContentCharset]
		ifFalse: [charset]! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/30/2017 20:16'!
contentEncoding
	"Returns the non-identity content encoding compression schemes
	in the order they were applied"

	^ self encodingNamesFromHeaderValuesAt: 'Content-Encoding'! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/30/2017 20:16'!
contentEncoding: aStringOrCollection
	self
		encodingNamesFromHeaderValuesAt: 'Content-Encoding'
		put: aStringOrCollection! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/25/2017 06:58'!
contentLength
	^ XMLIntegerReader
		readFrom:
			(self
				headerAt: 'Content-Length'
				ifAbsent: [^ nil]) readStream
		withBase: 10! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/29/2017 12:19'!
contentLength: anInteger
	anInteger
		ifNil: [
			self
				removeHeaderAt: 'Content-Length'
				ifAbsent: []]
		ifNotNil: [
			self
				headerAt: 'Content-Length'
				put: anInteger asString]! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 1/22/2018 04:07'!
contentType
	"Returns an XMLMIMEType object for the Content-Type header value"

	^ XMLHTTPMIMEType fromString:
		(self
			headerAt: 'Content-Type'
			ifAbsent: [^ nil])! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/29/2017 12:20'!
contentType: aMIMETypeOrString
	aMIMETypeOrString
		ifNil: [
			self
				removeHeaderAt: 'Content-Type'
				ifAbsent: []]
		ifNotNil: [
			self
				headerAt: 'Content-Type'
				put: aMIMETypeOrString asString]! !

!XMLHTTPMessage methodsFor: 'defaults' stamp: 'monty 1/22/2018 04:07'!
defaultContentCharset
	^ XMLHTTPMIMEType defaultCharset! !

!XMLHTTPMessage methodsFor: 'private' stamp: 'monty 2/6/2018 05:30'!
encodingNamesFromHeaderValuesAt: aKey
	"Returns the non-identity encoding compression schemes
	in the order they were applied from the value(s) of the
	specified header"

	| encodingNames |

	encodingNames := OrderedCollection new.
	self
		headerValuesAt: aKey
		do: [:headerValue |
			$,
				xmlSplit: headerValue
				do: [:headerValueField | | encodingName |
					encodingName :=
						headerValueField xmlCopyWithoutWhitespace asLowercase.
					(encodingName isEmpty
						or: [encodingName = 'identity'])
						ifFalse: [encodingNames addLast: encodingName]]].
	^ encodingNames.! !

!XMLHTTPMessage methodsFor: 'private' stamp: 'monty 12/30/2017 20:16'!
encodingNamesFromHeaderValuesAt: aKey put: aStringOrCollection
	aStringOrCollection isEmpty
		ifTrue: [
			self
				removeHeaderAt: aKey
				ifAbsent: []]
		ifFalse: [
			self
				headerAt: aKey
				put:
					(aStringOrCollection isString
						ifTrue: [aStringOrCollection]
						ifFalse: [
							String streamContents: [:stream |
								aStringOrCollection
									do: [:each | stream nextPutAll: each]
									separatedBy: [stream nextPutAll: ', ']]])]! !

!XMLHTTPMessage methodsFor: 'private' stamp: 'monty 12/30/2017 20:05'!
errorRemovingAbsentHeader: aKey
	XMLHTTPException
		formatSignal: 'Cannot remove absent HTTP header "{1}" from message'
		with: aKey! !

!XMLHTTPMessage methodsFor: 'testing' stamp: 'monty 1/1/2018 18:17'!
hasContent
	^ self content notEmpty! !

!XMLHTTPMessage methodsFor: 'testing' stamp: 'monty 1/1/2018 18:28'!
hasHeaders
	self headerKeysDo: [:key | ^ true].
	^ false.! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:48'!
headerAt: aKey
	^ self
		headerAt: aKey
		ifAbsent: ['']! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:48'!
headerAt: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/30/2017 12:30'!
headerAt: aKey ifAbsentPut: aBlock
	^ self
		headerAt: aKey
		ifAbsent: [
			self
				headerAt: aKey
				put: aBlock value]! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/24/2017 06:30'!
headerAt: aKey put: aValue
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/29/2017 12:18'!
headerKeys
	| keys |

	keys := OrderedCollection new.
	self headerKeysDo: [:key |
		keys addLast: key].
	^ keys.! !

!XMLHTTPMessage methodsFor: 'enumerating' stamp: 'monty 12/24/2017 04:48'!
headerKeysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'enumerating' stamp: 'monty 12/24/2017 04:48'!
headerKeysDo: aBlock
	self headerKeysAndValuesDo: [:key :value |
		aBlock value: key]! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:48'!
headerValuesAt: aKey
	| values |

	values := OrderedCollection new.
	self
		headerValuesAt: aKey
		do: [:each | values addLast: each].
	^ values.! !

!XMLHTTPMessage methodsFor: 'adding' stamp: 'monty 12/26/2017 14:54'!
headerValuesAt: aKey add: aValue
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'enumerating' stamp: 'monty 12/24/2017 04:48'!
headerValuesAt: aKey do: aBlock
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'accessing' stamp: 'monty 12/26/2017 15:06'!
headers
	| headers |

	headers := OrderedCollection new.
	self headerKeysAndValuesDo: [:key :value |
		headers addLast: key -> value].
	^ headers.! !

!XMLHTTPMessage methodsFor: 'testing' stamp: 'monty 12/26/2017 13:18'!
includesHeaderAt: aKey
	self
		headerAt: aKey
		ifAbsent: [^ false].
	^ true.! !

!XMLHTTPMessage methodsFor: 'removing' stamp: 'monty 12/30/2017 20:04'!
removeHeaderAt: aKey
	^ self
		removeHeaderAt: aKey
		ifAbsent: [self errorRemovingAbsentHeader: aKey]! !

!XMLHTTPMessage methodsFor: 'removing' stamp: 'monty 12/29/2017 11:52'!
removeHeaderAt: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!XMLHTTPMessage methodsFor: 'removing' stamp: 'monty 1/2/2018 11:04'!
removeHeaders
	self headerKeys do: [:each |
		self
			removeHeaderAt: each
			ifAbsent: []]! !

XMLHTTPMessage subclass: #XMLHTTPRequest
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPRequest commentStamp: 'monty 1/24/2018 21:46' prior: 0!
This is an abstract base class for HTTP requests.

These classes implement the #get/#getUpToLimit:decoding: and #streamGet/#streamGetUpToLimit:decoding: interface of XMLURI.!

!XMLHTTPRequest class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLHTTPRequest class methodsFor: 'instance creation' stamp: 'monty 12/30/2017 14:20'!
new
	^ self url: ''! !

!XMLHTTPRequest class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	XMLHTTPException signal: 'HTTP unsupported; install Zinc or WebClient'! !

!XMLHTTPRequest class methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:06'!
preferredImplementation
	^ XMLHTTPZincRequest! !

!XMLHTTPRequest class methodsFor: 'instance creation' stamp: 'monty 12/30/2017 14:20'!
url: aURLString
	^ self implementationNew setURL: aURLString! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/30/2017 20:16'!
acceptEncoding
	^ self encodingNamesFromHeaderValuesAt: 'Accept-Encoding'! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/30/2017 20:16'!
acceptEncoding: aStringOrCollection
	self
		encodingNamesFromHeaderValuesAt: 'Accept-Encoding'
		put: aStringOrCollection! !

!XMLHTTPRequest methodsFor: 'converting' stamp: 'monty 2/13/2016 00:35'!
asXMLHTTPRequest
	^ self! !

!XMLHTTPRequest methodsFor: 'basic' stamp: 'monty 1/23/2018 01:44'!
basicCleanup
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'basic' stamp: 'monty 1/7/2018 19:39'!
basicSend
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'defaults' stamp: 'monty 2/7/2018 06:10'!
defaultAcceptEncoding
	^ #()! !

!XMLHTTPRequest methodsFor: 'defaults' stamp: 'monty 12/24/2017 04:46'!
defaultMethod
	^ 'GET'! !

!XMLHTTPRequest methodsFor: 'defaults' stamp: 'monty 10/26/2014 09:14'!
defaultTimeout
	^ 30! !

!XMLHTTPRequest methodsFor: 'private' stamp: 'monty 1/7/2018 19:03'!
errorBadResponse: aResponse
	XMLHTTPException
		formatSignal: '{1} ({2})'
		with: aResponse statusDescription
		with: aResponse statusCode! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:40'!
get
	^ self
		getUpToLimit: nil
		decoding: true! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 1/15/2018 17:56'!
getUpToLimit: aMaxSize decoding: aBoolean
	self method: 'GET'.
	^ (self
		resolveUpToLimit: aMaxSize
		decoding: aBoolean) content! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:45'!
method
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:29'!
method: aString
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'printing' stamp: 'monty 1/14/2018 21:13'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self method;
		space;
		nextPutAll: self url;
		nextPut: $).! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 1/15/2018 17:57'!
resolve
	"Sends and retrieves the response as an XMLHTTPResponse object."

	^ self
		resolveUpToLimit: nil
		decoding: true! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 1/23/2018 01:44'!
resolveUpToLimit: aMaxSize decoding: aBoolean
	| response |

	[
		[
			(response := self basicSend) isSuccess
				ifFalse: [self errorBadResponse: response].
			response
				readContentUpToLimit: aMaxSize
				decoding: aBoolean]
			on: Error
			do: [:error |
				error isXMLParserException
					ifTrue: [error pass]
					ifFalse: [XMLHTTPException signalMessageFrom: error]]
		] ensure: [self basicCleanup].

	^ response.! !

!XMLHTTPRequest methodsFor: 'defaults' stamp: 'monty 10/14/2017 01:29'!
responseClass
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'initialization' stamp: 'monty 2/7/2018 08:26'!
setURL: aURLString
	url := aURLString.
	self
		timeout: self defaultTimeout;
		method: self defaultMethod;
		"even if #defaultAcceptEncoding returns an empty collection,
		#acceptEncoding: must still be sent here to override any default
		setting of the underlying HTTP library that we don't support"
		acceptEncoding: self defaultAcceptEncoding.! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:40'!
streamGet
	^ self
		streamGetUpToLimit: nil
		decoding: true! !

!XMLHTTPRequest methodsFor: 'retrieving' stamp: 'monty 2/19/2016 11:09'!
streamGetUpToLimit: aMaxSize decoding: aBoolean
	"must be implemented using getUpToLimit:decoding: rather than the other
	way around like XMLFileHandle does, because HTTP responses must be read
	immediately and stored entirely in memory, unlike a file stream which
	can safely be left open and read from incrementally"
	^ (self
		getUpToLimit: aMaxSize
		decoding: aBoolean) readStream! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 11:10'!
timeout
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 11:10'!
timeout: anInteger
	self subclassResponsibility! !

!XMLHTTPRequest methodsFor: 'accessing' stamp: 'monty 10/13/2017 03:39'!
url
	^ url ifNil: [url := '']! !

XMLHTTPRequest subclass: #XMLHTTPWebClientRequest
	instanceVariableNames: 'webClientClient webClientRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPWebClientRequest commentStamp: 'monty 10/22/2017 23:23' prior: 0!
This class uses the WebClient library to implement HTTP requests. This is used on Squeak when Zinc isn't installed.!

!XMLHTTPWebClientRequest class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #WebClient! !

!XMLHTTPWebClientRequest methodsFor: 'basic' stamp: 'monty 1/23/2018 01:44'!
basicCleanup
	self webClientClient close! !

!XMLHTTPWebClientRequest methodsFor: 'basic' stamp: 'monty 1/24/2018 01:42'!
basicSend
	^ self responseClass
		request: self
		webClientResponse:
			(self webClientClient
				"#sendRequest: unfortunately requires #initializeFromUrl:
				to be sent first"
				initializeFromUrl: self url;
				sendRequest: self webClientRequest)! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:51'!
headerAt: aKey ifAbsent: aBlock
	^ self webClientRequest
		headerAt: aKey
		ifAbsent: aBlock! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 14:28'!
headerAt: aKey put: aValue
	self webClientRequest
		removeHeader: aKey;
		addHeader: aKey value: aValue.
	^ aValue.! !

!XMLHTTPWebClientRequest methodsFor: 'enumerating' stamp: 'monty 12/24/2017 04:51'!
headerKeysAndValuesDo: aTwoArgumentBlock
	self webClientRequest headersDo: aTwoArgumentBlock! !

!XMLHTTPWebClientRequest methodsFor: 'adding' stamp: 'monty 12/26/2017 14:54'!
headerValuesAt: aKey add: aValue
	self webClientRequest
		addHeader: aKey
		value: aValue.
	^ aValue.! !

!XMLHTTPWebClientRequest methodsFor: 'enumerating' stamp: 'monty 12/24/2017 04:52'!
headerValuesAt: aKey do: aBlock
	self webClientRequest
		headersAt: aKey
		do: aBlock! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:50'!
method
	^ self webClientRequest method! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:29'!
method: aString
	self webClientRequest method: aString! !

!XMLHTTPWebClientRequest methodsFor: 'removing' stamp: 'monty 1/15/2018 07:31'!
removeHeaderAt: aKey ifAbsent: aBlock
	| removedValues |

	removedValues :=
		self webClientRequest
			headersAt: aKey
			ifAbsent: [^ aBlock value].
	self webClientRequest removeHeader: aKey.
	^ removedValues asOrderedCollection.! !

!XMLHTTPWebClientRequest methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:07'!
responseClass
	^ XMLHTTPWebClientResponse! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:25'!
timeout
	^ self webClientClient timeout! !

!XMLHTTPWebClientRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:25'!
timeout: anInteger
	self webClientClient timeout: anInteger! !

!XMLHTTPWebClientRequest methodsFor: 'private' stamp: 'monty 1/24/2018 01:38'!
webClientClient
	^ webClientClient
		ifNil: [
			webClientClient := (XMLClassFinder classNamed: #WebClient) new]! !

!XMLHTTPWebClientRequest methodsFor: 'private' stamp: 'monty 1/24/2018 22:44'!
webClientRequest
	^ webClientRequest
		ifNil: [
			webClientRequest :=
				(XMLClassFinder classNamed: #WebRequest) new
					initializeFromUrl: self url;
					yourself]! !

XMLHTTPRequest subclass: #XMLHTTPZincRequest
	instanceVariableNames: 'zincRequest zincClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPZincRequest commentStamp: 'monty 10/22/2017 23:46' prior: 0!
This class uses Zinc HTTP Components to implement HTTP requests and is the preferred implementation.!

!XMLHTTPZincRequest class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #ZnClient! !

!XMLHTTPZincRequest methodsFor: 'basic' stamp: 'monty 1/23/2018 01:44'!
basicCleanup
	self zincClient close! !

!XMLHTTPZincRequest methodsFor: 'basic' stamp: 'monty 1/7/2018 19:35'!
basicSend
	^ self responseClass
		request: self
		zincResponse:
			(self zincClient
				request: self zincRequest;
				execute;
				response)! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/25/2017 13:30'!
headerAt: aKey ifAbsent: aBlock
	self zincRequest headers
		at: aKey
		ifPresent: [:value |
			^ value isArray
				ifTrue: [value first]
				ifFalse: [value]].
	^ aBlock value.! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 10:19'!
headerAt: aKey put: aValue
	self zincRequest headers
		at: aKey
		put: aValue.
	^ aValue.! !

!XMLHTTPZincRequest methodsFor: 'enumerating' stamp: 'monty 12/24/2017 10:20'!
headerKeysAndValuesDo: aTwoArgumentBlock
	self zincRequest headersDo: aTwoArgumentBlock! !

!XMLHTTPZincRequest methodsFor: 'adding' stamp: 'monty 12/26/2017 15:03'!
headerValuesAt: aKey add: aValue
	self zincRequest headers
		at: aKey
		add: aValue.
	^ aValue.! !

!XMLHTTPZincRequest methodsFor: 'enumerating' stamp: 'monty 12/24/2017 10:21'!
headerValuesAt: aKey do: aBlock
	self zincRequest headers
		at: aKey
		ifPresent: [:value |
			value isArray
				ifTrue: [value do: aBlock]
				ifFalse: [aBlock value: value]]! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 06:35'!
method
	^ self zincRequest method asString! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:29'!
method: aString
	self zincRequest method: aString asSymbol! !

!XMLHTTPZincRequest methodsFor: 'removing' stamp: 'monty 12/29/2017 12:08'!
removeHeaderAt: aKey ifAbsent: aBlock
	| removedValues |

	removedValues :=
		self zincRequest headers
			removeKey: aKey
			ifAbsent: [^ aBlock value].
	^ removedValues isString
		ifTrue: [OrderedCollection with: removedValues]
		ifFalse: [removedValues asOrderedCollection].! !

!XMLHTTPZincRequest methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:07'!
responseClass
	^ XMLHTTPZincResponse! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:34'!
timeout
	^ self zincClient timeout! !

!XMLHTTPZincRequest methodsFor: 'accessing' stamp: 'monty 12/24/2017 13:34'!
timeout: anInteger
	self zincClient timeout: anInteger! !

!XMLHTTPZincRequest methodsFor: 'private ' stamp: 'monty 12/24/2017 13:31'!
zincClient
	^ zincClient
		ifNil: [
			zincClient :=
				(XMLClassFinder classNamed: #ZnClient) new
					streaming: true;
					yourself]! !

!XMLHTTPZincRequest methodsFor: 'private ' stamp: 'monty 12/24/2017 13:35'!
zincRequest
	^ zincRequest
		ifNil: [
			zincRequest :=
				(XMLClassFinder classNamed: #ZnRequest)
					get: self url]! !

XMLHTTPMessage subclass: #XMLHTTPResponse
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPResponse commentStamp: 'monty 10/17/2017 00:18' prior: 0!
This is an abstract base class for HTTP responses.!

!XMLHTTPResponse class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLHTTPResponse class methodsFor: 'finding' stamp: 'monty 1/24/2018 22:13'!
noSupportedImplementationFound
	XMLHTTPRequest noSupportedImplementationFound! !

!XMLHTTPResponse class methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:07'!
preferredImplementation
	^ XMLHTTPZincResponse! !

!XMLHTTPResponse class methodsFor: 'instance creation' stamp: 'monty 10/14/2017 00:55'!
request: aRequest
	^ self new setRequest: aRequest! !

!XMLHTTPResponse methodsFor: 'defaults' stamp: 'monty 1/7/2018 17:59'!
contentReaderClass
	self subclassResponsibility! !

!XMLHTTPResponse methodsFor: 'defaults' stamp: 'monty 12/25/2017 13:02'!
defaultProtocol
	^ 'HTTP/1.1'! !

!XMLHTTPResponse methodsFor: 'defaults' stamp: 'monty 12/25/2017 07:00'!
defaultStatusCode
	^ 200! !

!XMLHTTPResponse methodsFor: 'testing' stamp: 'monty 1/24/2018 02:35'!
isChunked
	| transferEncoding |

	transferEncoding :=
		self
			headerAt: 'Transfer-Encoding'
			ifAbsent: [^ false].
	^ transferEncoding beginsWith: 'chunked'.! !

!XMLHTTPResponse methodsFor: 'testing' stamp: 'monty 10/14/2017 18:52'!
isSuccess
	self subclassResponsibility! !

!XMLHTTPResponse methodsFor: 'instance creation' stamp: 'monty 1/7/2018 18:03'!
newContentReader
	^ self contentReaderClass response: self! !

!XMLHTTPResponse methodsFor: 'printing' stamp: 'monty 12/20/2017 01:08'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self statusLine;
		nextPut: $).! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 10:31'!
protocol
	self subclassResponsibility! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 12:40'!
protocol: aString
	self
		setProtocol: aString
		statusCode: self statusCode! !

!XMLHTTPResponse methodsFor: 'reading' stamp: 'monty 1/11/2018 23:57'!
readContentUpToLimit: aMaxSize decoding: aBoolean
	self content:
		(self newContentReader
			readUpToLimit: aMaxSize
			decoding: aBoolean)! !

!XMLHTTPResponse methodsFor: 'converting' stamp: 'monty 1/14/2018 21:18'!
readStream
	^ self content readStream! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 10/20/2017 08:21'!
request
	"Returns the XMLHTTPRequest object that created this response"

	^ request! !

!XMLHTTPResponse methodsFor: 'initialization' stamp: 'monty 12/25/2017 12:40'!
setProtocol: aString statusCode: anInteger
	self subclassResponsibility! !

!XMLHTTPResponse methodsFor: 'initialization' stamp: 'monty 10/14/2017 00:55'!
setRequest: aRequest
	request := aRequest! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 06:50'!
statusCode
	"Returns the status code as an integer"

	self subclassResponsibility! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 12:40'!
statusCode: anInteger
	self
		setProtocol: self protocol
		statusCode: anInteger! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 2/5/2018 19:20'!
statusDescription
	| delimiter |

	delimiter := Character space.
	^ (self statusLine copyAfter: delimiter)
		copyAfter: delimiter! !

!XMLHTTPResponse methodsFor: 'accessing' stamp: 'monty 10/20/2017 08:28'!
statusLine
	"Returns the status line as a string"

	self subclassResponsibility! !

XMLHTTPResponse subclass: #XMLHTTPWebClientResponse
	instanceVariableNames: 'webClientResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPWebClientResponse commentStamp: 'monty 1/7/2018 20:07' prior: 0!
This class uses the WebClient library to implement HTTP responses. This is used on Squeak when Zinc isn't installed.!

!XMLHTTPWebClientResponse class methodsFor: 'testing' stamp: 'monty 12/24/2017 13:40'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #WebResponse! !

!XMLHTTPWebClientResponse class methodsFor: 'instance creation' stamp: 'monty 12/25/2017 07:01'!
request: aRequest webClientResponse: aWebClientResponse
	^ (self request: aRequest)
		setWebClientResponse: aWebClientResponse! !

!XMLHTTPWebClientResponse methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:08'!
contentReaderClass
	^ XMLHTTPWebClientResponseContentReader! !

!XMLHTTPWebClientResponse methodsFor: 'accessing' stamp: 'monty 10/14/2017 18:41'!
headerAt: aKey ifAbsent: aBlock
	^ self webClientResponse
		headerAt: aKey
		ifAbsent: aBlock! !

!XMLHTTPWebClientResponse methodsFor: 'accessing' stamp: 'monty 12/24/2017 14:28'!
headerAt: aKey put: aValue
	self webClientResponse
		removeHeader: aKey;
		addHeader: aKey value: aValue.
	^ aValue.! !

!XMLHTTPWebClientResponse methodsFor: 'enumerating' stamp: 'monty 10/14/2017 18:41'!
headerKeysAndValuesDo: aTwoArgumentBlock
	self webClientResponse headersDo: aTwoArgumentBlock! !

!XMLHTTPWebClientResponse methodsFor: 'adding' stamp: 'monty 12/26/2017 14:54'!
headerValuesAt: aKey add: aValue
	self webClientResponse
		addHeader: aKey
		value: aValue.
	^ aValue.! !

!XMLHTTPWebClientResponse methodsFor: 'enumerating' stamp: 'monty 10/14/2017 18:41'!
headerValuesAt: aKey do: aBlock
	self webClientResponse
		headersAt: aKey
		do: aBlock! !

!XMLHTTPWebClientResponse methodsFor: 'testing' stamp: 'monty 10/14/2017 18:41'!
isSuccess
	^ self webClientResponse isSuccess! !

!XMLHTTPWebClientResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 12:19'!
protocol
	^ self webClientResponse protocol! !

!XMLHTTPWebClientResponse methodsFor: 'removing' stamp: 'monty 1/15/2018 07:30'!
removeHeaderAt: aKey ifAbsent: aBlock
	| removedValues |

	removedValues :=
		self webClientResponse
			headersAt: aKey
			ifAbsent: [^ aBlock value].
	self webClientResponse removeHeader: aKey.
	^ removedValues asOrderedCollection.! !

!XMLHTTPWebClientResponse methodsFor: 'initialization' stamp: 'monty 12/25/2017 12:40'!
setProtocol: aString statusCode: anInteger
	self webClientResponse
		protocol: aString
		code: anInteger! !

!XMLHTTPWebClientResponse methodsFor: 'initialization' stamp: 'monty 12/25/2017 07:01'!
setWebClientResponse: aWebClientResponse
	webClientResponse := aWebClientResponse! !

!XMLHTTPWebClientResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 06:50'!
statusCode
	^ self webClientResponse code! !

!XMLHTTPWebClientResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 10:36'!
statusLine
	^ self webClientResponse status! !

!XMLHTTPWebClientResponse methodsFor: 'private' stamp: 'monty 1/15/2018 07:28'!
webClientResponse
	^ webClientResponse
		ifNil: [
			webClientResponse :=
				(XMLClassFinder classNamed: #WebResponse)
					protocol: self defaultProtocol
					code: self defaultStatusCode]! !

XMLHTTPResponse subclass: #XMLHTTPZincResponse
	instanceVariableNames: 'zincResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPZincResponse commentStamp: 'monty 1/7/2018 20:07' prior: 0!
This class uses Zinc HTTP Components to implement HTTP responses and is the preferred implementation.!

!XMLHTTPZincResponse class methodsFor: 'testing' stamp: 'monty 12/24/2017 13:41'!
isSupportedImplementation
	^ XMLClassFinder hasClassNamed: #ZnResponse! !

!XMLHTTPZincResponse class methodsFor: 'instance creation' stamp: 'monty 12/25/2017 07:02'!
request: aRequest zincResponse: aZincResponse
	^ (self request: aRequest)
		setZincResponse: aZincResponse! !

!XMLHTTPZincResponse methodsFor: 'defaults' stamp: 'monty 1/7/2018 20:08'!
contentReaderClass
	^ XMLHTTPZincResponseContentReader! !

!XMLHTTPZincResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 13:30'!
headerAt: aKey ifAbsent: aBlock
	self zincResponse headers
		at: aKey
		ifPresent: [:value |
			^ value isArray
				ifTrue: [value first]
				ifFalse: [value]].
	^ aBlock value.! !

!XMLHTTPZincResponse methodsFor: 'accessing' stamp: 'monty 12/24/2017 10:19'!
headerAt: aKey put: aValue
	self zincResponse headers
		at: aKey
		put: aValue.
	^ aValue.! !

!XMLHTTPZincResponse methodsFor: 'enumerating' stamp: 'monty 10/14/2017 01:03'!
headerKeysAndValuesDo: aTwoArgumentBlock
	self zincResponse headersDo: aTwoArgumentBlock! !

!XMLHTTPZincResponse methodsFor: 'adding' stamp: 'monty 12/26/2017 15:03'!
headerValuesAt: aKey add: aValue
	self zincResponse headers
		at: aKey
		add: aValue.
	^ aValue.! !

!XMLHTTPZincResponse methodsFor: 'enumerating' stamp: 'monty 10/17/2017 01:08'!
headerValuesAt: aKey do: aBlock
	self zincResponse headers
		at: aKey
		ifPresent: [:value |
			value isArray
				ifTrue: [value do: aBlock]
				ifFalse: [aBlock value: value]]! !

!XMLHTTPZincResponse methodsFor: 'testing' stamp: 'monty 10/14/2017 18:41'!
isSuccess
	^ self zincResponse isSuccess! !

!XMLHTTPZincResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 10:32'!
protocol
	^ self zincResponse statusLine version! !

!XMLHTTPZincResponse methodsFor: 'removing' stamp: 'monty 12/29/2017 12:08'!
removeHeaderAt: aKey ifAbsent: aBlock
	| removedValues |

	removedValues :=
		self zincResponse headers
			removeKey: aKey
			ifAbsent: [^ aBlock value].
	^ removedValues isString
		ifTrue: [OrderedCollection with: removedValues]
		ifFalse: [removedValues asOrderedCollection].! !

!XMLHTTPZincResponse methodsFor: 'initialization' stamp: 'monty 12/25/2017 12:40'!
setProtocol: aString statusCode: anInteger
	self zincResponse statusLine:
		((ZnStatusLine code: anInteger)
			version: aString;
			yourself)! !

!XMLHTTPZincResponse methodsFor: 'initialization' stamp: 'monty 12/25/2017 07:01'!
setZincResponse: aZincResponse
	zincResponse := aZincResponse! !

!XMLHTTPZincResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 06:50'!
statusCode
	^ self zincResponse status! !

!XMLHTTPZincResponse methodsFor: 'accessing' stamp: 'monty 12/25/2017 10:26'!
statusLine
	| statusLine |
	
	statusLine := self zincResponse statusLine.
	^ String streamContents: [:stream |
		stream
			nextPutAll: statusLine version;
			space.
		statusLine printCodeAndReasonOn: stream].! !

!XMLHTTPZincResponse methodsFor: 'private' stamp: 'monty 1/24/2018 22:51'!
zincResponse
	^ zincResponse
		ifNil: [
			zincResponse :=
				(XMLClassFinder classNamed: #ZnResponse) new
					statusLine:
						((ZnStatusLine code: self defaultStatusCode)
							version: self defaultProtocol;
							yourself);
					yourself]! !

XMLAbstractFactory subclass: #XMLKeyValueCache
	instanceVariableNames: 'collection maxSize mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLKeyValueCache commentStamp: 'monty 10/9/2016 05:23' prior: 0!
A simple key-value cache that automatically empties when it reaches a maximum size. Uses a reentrant mutex to ensure thread-safety.!

!XMLKeyValueCache class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLKeyValueCache class methodsFor: 'defaults' stamp: 'monty 9/26/2016 13:12'!
defaultMaxSize
	^ 32! !

!XMLKeyValueCache class methodsFor: 'instance creation' stamp: 'monty 12/30/2017 14:20'!
maxSize: anInteger
	^ self implementationNew setMaxSize: anInteger! !

!XMLKeyValueCache class methodsFor: 'instance creation' stamp: 'monty 10/9/2016 03:20'!
new
	^ self maxSize: self defaultMaxSize! !

!XMLKeyValueCache class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	Error signal: 'No supported key-value cache class available'! !

!XMLKeyValueCache class methodsFor: 'defaults' stamp: 'monty 10/9/2016 03:16'!
preferredImplementation
	^ XMLStandardKeyValueCache! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 2/16/2016 06:27'!
at: aKey
	^ self
		at: aKey
		ifAbsent: [nil]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:41'!
at: aKey ifAbsent: aBlock
	^ self critical: [
		self collection
			at: aKey
			ifAbsent: aBlock]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 9/26/2016 12:49'!
at: aKey ifAbsentPut: aBlock
	^ self
		at: aKey
		ifAbsent: [
			self
				at: aKey
				put: aBlock value]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:41'!
at: aKey ifPresent: aBlock
	^ self critical: [
		"Gemstone's at:ifAbsentPut: does not use cull:"
		aBlock cull:
			(self collection
				at: aKey
				ifAbsent: [^ nil])]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 9/28/2016 21:56'!
at: aKey ifPresent: aPresentBlock put: aValueBlock
	"Looks up the value of aKey and if present, evaluates aPresentBlock
	optionally with it, and if aPresentBlock returns true, replaces the old
	value with the result of evaluating aValueBlock."

	^ self
		at: aKey
		ifPresent: [:value |
			(aPresentBlock cull: value)
				ifTrue: [	
					self
						at: aKey
						put: aValueBlock value]
				ifFalse: [value]]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:45'!
at: aKey put: aValue
	^ self critical: [
		(self collection includesKey: aKey)
			ifFalse: [
				self collection size >= self maxSize
					ifTrue: [self collection removeAll]].
		self collection
			at: aKey
			put: aValue]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:45'!
capacity
	^ self maxSize! !

!XMLKeyValueCache methodsFor: 'clearing' stamp: 'monty 7/23/2016 10:31'!
clear
	self removeAll! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:56'!
collection
	self subclassResponsibility! !

!XMLKeyValueCache methodsFor: 'defaults' stamp: 'monty 10/9/2016 03:02'!
collectionClass
	^ Dictionary! !

!XMLKeyValueCache methodsFor: 'copying' stamp: 'monty 9/27/2016 19:43'!
copy
	^ self critical: [self shallowCopy postCopy]! !

!XMLKeyValueCache methodsFor: 'mutual exclusion' stamp: 'monty 10/9/2016 02:46'!
critical: aBlock
	"Can be used to lock the cache during one or more operations in aBlock"

	^ self mutex critical: aBlock! !

!XMLKeyValueCache methodsFor: 'testing' stamp: 'monty 10/9/2016 02:41'!
includesKey: aKey
	^ self critical: [self collection includesKey: aKey]! !

!XMLKeyValueCache methodsFor: 'testing' stamp: 'monty 9/23/2016 16:36'!
isEmpty
	^ self size = 0! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:41'!
keys
	^ self critical: [self collection keys]! !

!XMLKeyValueCache methodsFor: 'enumerating' stamp: 'monty 10/9/2016 02:41'!
keysAndValuesDo: aTwoArgumentBlock
	self critical: [self collection keysAndValuesDo: aTwoArgumentBlock]! !

!XMLKeyValueCache methodsFor: 'enumerating' stamp: 'monty 10/9/2016 02:41'!
keysDo: aBlock
	self critical: [self collection keysDo: aBlock]! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 2/12/2017 18:49'!
loadFactor
	^ (self size / self maxSize) asFraction! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:57'!
maxSize
	^ maxSize! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:42'!
maxSize: anInteger
	self critical: [| oldMaxSize |
		oldMaxSize := maxSize.
		(maxSize := anInteger) < oldMaxSize
			ifTrue: [self collection removeAll]]! !

!XMLKeyValueCache methodsFor: 'private' stamp: 'monty 9/27/2016 13:27'!
mutex
	^ mutex! !

!XMLKeyValueCache methodsFor: 'testing' stamp: 'monty 9/23/2016 16:36'!
notEmpty
	^ self size > 0! !

!XMLKeyValueCache methodsFor: 'copying' stamp: 'monty 10/9/2016 05:53'!
postCopy
	super postCopy.

	mutex := XMLReentrantMutex new.
	self setCollection: self collection copy.! !

!XMLKeyValueCache methodsFor: 'printing' stamp: 'monty 2/12/2017 18:50'!
printOn: aStream
	| loadFactor |

	loadFactor := self loadFactor.
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: loadFactor numerator;
		nextPut: $/;
		print: loadFactor denominator;
		nextPut: $).! !

!XMLKeyValueCache methodsFor: 'removing' stamp: 'monty 10/9/2016 02:42'!
removeAll
	self critical: [self collection removeAll]! !

!XMLKeyValueCache methodsFor: 'removing' stamp: 'monty 10/9/2016 02:42'!
removeKey: aKey
	"this attempts to remove a key, but to support concurrent removal, it
	does not raise errors if it was already removed"
	^ self critical: [
		self collection
			removeKey: aKey
			ifAbsent: [nil]]! !

!XMLKeyValueCache methodsFor: 'removing' stamp: 'monty 10/9/2016 02:42'!
removeKey: aKey ifAbsent: aBlock
	^ self critical: [
		self collection
			removeKey: aKey
			ifAbsent: aBlock]! !

!XMLKeyValueCache methodsFor: 'removing' stamp: 'monty 9/28/2016 22:02'!
removeKey: aKey ifPresent: aBlock
	"Looks up the value of aKey and if present, evaluates aPresentBlock
	optionally with it, and if aPresentBlock returns true, removes the
	key from the cache and returns its old value."
	^ self
		at: aKey
		ifPresent: [:value |
			(aBlock cull: value)
				ifTrue: [self removeKey: aKey]
				ifFalse: [value]]! !

!XMLKeyValueCache methodsFor: 'initialization' stamp: 'monty 10/9/2016 02:57'!
setCollection: aKeyValueCollection
	self subclassResponsibility! !

!XMLKeyValueCache methodsFor: 'initialization' stamp: 'monty 10/9/2016 03:01'!
setMaxSize: anInteger
	maxSize := anInteger.
	mutex := XMLReentrantMutex new.
	self setCollection: self collectionClass new.! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:42'!
size
	^ self collection size! !

!XMLKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:42'!
values
	^ self critical: [self collection values]! !

!XMLKeyValueCache methodsFor: 'enumerating' stamp: 'monty 10/9/2016 02:42'!
valuesDo: aBlock
	self critical: [self collection valuesDo: aBlock]! !

XMLKeyValueCache subclass: #XMLStandardKeyValueCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLStandardKeyValueCache commentStamp: 'monty 5/19/2017 16:47' prior: 0!
This class is the standard key-value cache implementation used on Pharo/Squeak.!

!XMLStandardKeyValueCache class methodsFor: 'testing' stamp: 'monty 10/20/2016 02:26'!
isSupportedImplementation
	"need some type of reentrant mutex"
	XMLReentrantMutex hasSupportedImplementation
		ifFalse: [^ false].

	"MUST use the transient class on GS to avoid persisting and causing
	write conflicts"
	XMLClassFinder
		classNamed: #XMLTransientKeyValueCache
		ifPresent: [:transientKeyValueCacheClass |
			transientKeyValueCacheClass isSupportedImplementation
				ifTrue: [^ false]].

	^ true.! !

!XMLStandardKeyValueCache methodsFor: 'accessing' stamp: 'monty 10/9/2016 02:56'!
collection
	^ collection! !

!XMLStandardKeyValueCache methodsFor: 'initialization' stamp: 'monty 10/9/2016 02:57'!
setCollection: aKeyValueCollection
	collection := aKeyValueCollection! !

XMLAbstractFactory subclass: #XMLReentrantMutex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLReentrantMutex commentStamp: 'monty 10/5/2016 22:21' prior: 0!
An abstract class for reentrant mutexes that support nested sends of #critical: by the same process without deadlocking.!

!XMLReentrantMutex class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:36'!
canBeImplemented
	^ true! !

!XMLReentrantMutex class methodsFor: 'finding' stamp: 'monty 6/17/2017 00:34'!
noSupportedImplementationFound
	Error signal: 'No supported reentrant mutex class available'! !

!XMLReentrantMutex class methodsFor: 'defaults' stamp: 'monty 10/5/2016 22:23'!
preferredImplementation
	"Prefer the Pharo/Squeak Mutex-based implementation"
	^ XMLStandardReentrantMutex! !

!XMLReentrantMutex methodsFor: 'mutual exclusion' stamp: 'monty 10/5/2016 22:15'!
critical: aBlock
	self subclassResponsibility! !

XMLReentrantMutex subclass: #XMLStandardReentrantMutex
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLStandardReentrantMutex commentStamp: 'monty 10/9/2016 05:28' prior: 0!
This class is the standard implementation that uses Pharo and Squeak's Mutex class to implement a reentrant mutex.!

!XMLStandardReentrantMutex class methodsFor: 'testing' stamp: 'monty 10/20/2016 02:26'!
isSupportedImplementation
	(XMLClassFinder hasClassNamed: #Mutex)
		ifFalse: [^ false].

	"MUST use the transient class on GS to avoid persisting and causing
	write conflicts"
	XMLClassFinder
		classNamed: #XMLTransientReentrantMutex
		ifPresent: [:transientReentrantMutexClass |
			transientReentrantMutexClass isSupportedImplementation
				ifTrue: [^ false]].

	^ true.! !

!XMLStandardReentrantMutex methodsFor: 'mutual exclusion' stamp: 'monty 10/5/2016 22:30'!
critical: aBlock
	^ mutex critical: aBlock! !

!XMLStandardReentrantMutex methodsFor: 'initialization' stamp: 'monty 10/5/2016 22:19'!
initialize
	super initialize.

	mutex := (XMLClassFinder classNamed: #Mutex) new.! !

Object subclass: #XMLAbstractReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLAbstractReadStream commentStamp: 'monty 1/11/2018 20:52' prior: 0!
An abstract class for read streams.!

!XMLAbstractReadStream class methodsFor: 'basic' stamp: 'monty 1/15/2018 02:20'!
basicOn: anObject
	^ self basicNew initialize on: anObject! !

!XMLAbstractReadStream class methodsFor: 'instance creation' stamp: 'monty 1/8/2018 00:54'!
new
	self shouldNotImplement! !

!XMLAbstractReadStream class methodsFor: 'instance creation' stamp: 'monty 1/15/2018 02:20'!
on: anObject
	^ self basicOn: anObject! !

!XMLAbstractReadStream methodsFor: 'testing' stamp: 'monty 1/8/2018 14:39'!
atEnd
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'closing' stamp: 'monty 1/8/2018 00:59'!
close! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/8/2018 14:40'!
contents
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'testing' stamp: 'monty 1/8/2018 00:52'!
isBinary
	^ false! !

!XMLAbstractReadStream methodsFor: 'testing' stamp: 'monty 1/8/2018 00:52'!
isStream
	^ true! !

!XMLAbstractReadStream methodsFor: 'testing' stamp: 'monty 2/8/2018 01:07'!
isXMLBinaryOrExternalStream
	^ self isBinary! !

!XMLAbstractReadStream methodsFor: 'instance creation' stamp: 'monty 1/13/2018 20:41'!
newWriteStream
	^ (self writeStreamCollectionClass new: 128) writeStream! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/8/2018 14:36'!
next
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/13/2018 20:42'!
next: anInteger
	| writeStream i |

	writeStream := self newWriteStream.
	i := 0.
	[self atEnd
		or: [i >= anInteger]]
		whileFalse: [
			writeStream nextPut: self next.
			i := i + 1].
	^ writeStream contents.! !

!XMLAbstractReadStream methodsFor: 'initialization' stamp: 'monty 1/8/2018 00:57'!
on: anObject
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/8/2018 14:36'!
peek
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/11/2018 18:45'!
peekFor: anObject
	(self atEnd not
		and: [self peek = anObject])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/8/2018 14:38'!
position
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/8/2018 14:38'!
position: anInteger
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/8/2018 14:39'!
reset
	self subclassResponsibility! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/13/2018 20:39'!
skip: anInteger
	"only supports skipping forwards"
	1 to: anInteger do: [:i |
		self atEnd
			ifTrue: [^ self].
		self next]! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/13/2018 20:42'!
skipSeparators
	"we use #isXMLWhitespace instead of the narrower, XML-specific
	#isXMLSeparator, because this class can be used for non-XML
	streams too"
	[self atEnd not
		and: [self peek isXMLWhitespace]]
		whileTrue: [self next]! !

!XMLAbstractReadStream methodsFor: 'positioning' stamp: 'monty 1/13/2018 20:41'!
skipTo: anObject
	[self atEnd]
		whileFalse: [
			self next = anObject
				ifTrue: [^ true]].
	^ false.! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/13/2018 20:43'!
upTo: anObject
	| writeStream next |

	writeStream := self newWriteStream.
	[self atEnd
		or: [(next := self next) = anObject]]
		whileFalse: [writeStream nextPut: next].
	^ writeStream contents.! !

!XMLAbstractReadStream methodsFor: 'accessing' stamp: 'monty 1/14/2018 17:24'!
upToEnd
	| writeStream |

	writeStream := self newWriteStream.
	[self atEnd]
		whileFalse: [writeStream nextPut: self next].
	^ writeStream contents.! !

!XMLAbstractReadStream methodsFor: 'writing' stamp: 'monty 2/9/2018 04:48'!
writeStreamCollectionClass
	self isBinary
		ifTrue: [^ ByteArray]
		ifFalse: [^ String]! !

XMLAbstractReadStream subclass: #XMLNullReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

XMLNullReadStream class
	instanceVariableNames: 'instance'!

!XMLNullReadStream commentStamp: 'monty 11/22/2016 23:50' prior: 0!
This class is a null read stream that is already #atEnd and also makes sending #atEnd after #close or sending #close more than once safe, which is needed for the XMLNestedStreamReader null stream.!

XMLNullReadStream class
	instanceVariableNames: 'instance'!

!XMLNullReadStream class methodsFor: 'class initialization' stamp: 'monty 1/15/2018 02:21'!
initialize
	"self initialize"

	instance := self basicOn: nil! !

XMLNullReadStream initialize!

!XMLNullReadStream class methodsFor: 'instance creation' stamp: 'monty 1/8/2018 13:13'!
new
	^ instance! !

!XMLNullReadStream class methodsFor: 'instance creation' stamp: 'monty 1/8/2018 14:26'!
on: anObject
	^ instance! !

!XMLNullReadStream methodsFor: 'testing' stamp: 'monty 11/22/2016 23:42'!
atEnd
	^ true! !

!XMLNullReadStream methodsFor: 'accessing' stamp: 'monty 1/14/2018 17:23'!
contents
	^ String new! !

!XMLNullReadStream methodsFor: 'accessing' stamp: 'monty 11/22/2016 23:32'!
next
	^ nil! !

!XMLNullReadStream methodsFor: 'initialization' stamp: 'monty 1/8/2018 14:27'!
on: anObject! !

!XMLNullReadStream methodsFor: 'accessing' stamp: 'monty 11/22/2016 23:32'!
peek
	^ nil! !

!XMLNullReadStream methodsFor: 'positioning' stamp: 'monty 11/22/2016 23:32'!
position
	^ 0! !

!XMLNullReadStream methodsFor: 'positioning' stamp: 'monty 11/22/2016 23:32'!
position: anInteger! !

!XMLNullReadStream methodsFor: 'positioning' stamp: 'monty 11/22/2016 23:32'!
reset! !

XMLAbstractReadStream subclass: #XMLSingleCharacterReadStream
	instanceVariableNames: 'character atEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLSingleCharacterReadStream commentStamp: 'monty 11/22/2016 23:50' prior: 0!
A read stream for single characters. This is faster and uses less memory than converting a char to a string and using a read stream on it.!

!XMLSingleCharacterReadStream methodsFor: 'testing' stamp: 'monty 11/17/2016 22:30'!
atEnd
	^ atEnd! !

!XMLSingleCharacterReadStream methodsFor: 'closing' stamp: 'monty 11/17/2016 22:30'!
close
	atEnd := true! !

!XMLSingleCharacterReadStream methodsFor: 'accessing' stamp: 'monty 1/14/2018 17:23'!
contents
	^ String with: character! !

!XMLSingleCharacterReadStream methodsFor: 'accessing' stamp: 'monty 10/2/2017 23:17'!
next
	atEnd
		ifTrue: [^ nil]
		ifFalse: [
			atEnd := true.
			^ character]! !

!XMLSingleCharacterReadStream methodsFor: 'initialization' stamp: 'monty 11/18/2016 15:38'!
on: aCharacter
	character := aCharacter.
	atEnd := false.! !

!XMLSingleCharacterReadStream methodsFor: 'accessing' stamp: 'monty 10/2/2017 23:18'!
peek
	atEnd
		ifTrue: [^ nil]
		ifFalse: [^ character]! !

!XMLSingleCharacterReadStream methodsFor: 'positioning' stamp: 'monty 11/17/2016 22:30'!
position
	^ atEnd
		ifTrue: [1]
		ifFalse: [0]! !

!XMLSingleCharacterReadStream methodsFor: 'positioning' stamp: 'monty 11/25/2016 00:15'!
position: anInteger
	atEnd := anInteger > 0! !

!XMLSingleCharacterReadStream methodsFor: 'printing' stamp: 'monty 4/24/2015 09:03'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: character;
		nextPut: $).! !

!XMLSingleCharacterReadStream methodsFor: 'positioning' stamp: 'monty 11/18/2016 15:23'!
reset
	atEnd := false! !

Object subclass: #XMLAbstractReadStreamParser
	instanceVariableNames: 'readStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLAbstractReadStreamParser commentStamp: 'monty 12/16/2017 04:23' prior: 0!
This class is a generic abstract parser class for read-stream based parsers. It wraps its input stream with an XMLReadStreamAdapter and can parse tokens using #nextDelimitedBy: and #nextDelimitedByAny: and a temp write stream buffer.!

!XMLAbstractReadStreamParser class methodsFor: 'instance creation' stamp: 'monty 1/23/2018 03:11'!
new
	self shouldNotImplement! !

!XMLAbstractReadStreamParser class methodsFor: 'instance creation' stamp: 'monty 1/23/2018 03:11'!
on: aStringOrStream
	^ self basicNew initialize on: aStringOrStream! !

!XMLAbstractReadStreamParser methodsFor: 'tokenizing' stamp: 'monty 1/20/2018 20:12'!
nextDelimitedBy: aCharacter
	writeStream reset.
	[readStream atEnd
		or: [readStream peek = aCharacter]]
		whileFalse: [writeStream nextPut: readStream next].
	^ writeStream contents.! !

!XMLAbstractReadStreamParser methodsFor: 'tokenizing' stamp: 'monty 1/20/2018 20:11'!
nextDelimitedByAny: aCharacterCollection
	writeStream reset.
	[readStream atEnd
		or: [aCharacterCollection includes: readStream peek]]
		whileFalse: [writeStream nextPut: readStream next].
	^ writeStream contents.! !

!XMLAbstractReadStreamParser methodsFor: 'initialization' stamp: 'monty 11/10/2017 14:09'!
on: aStringOrStream
	readStream :=
		XMLReadStreamAdapter on:
			(aStringOrStream isStream
				ifTrue: [aStringOrStream]
				ifFalse: [aStringOrStream readStream]).
	writeStream := (String new: 64) writeStream.! !

XMLAbstractReadStreamParser subclass: #XMLHTTPMIMETypeParser
	instanceVariableNames: ''
	classVariableNames: 'TokenDelimiters'
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPMIMETypeParser commentStamp: 'monty 1/24/2018 02:21' prior: 0!
This is a class to parse MIME types with a main type and sub type separated by a "/", like "text/plain", and optional name=value parameters separated by ";" after. Adapted from ZnMimeType.!

!XMLHTTPMIMETypeParser class methodsFor: 'class initialization' stamp: 'monty 11/12/2017 01:21'!
initialize
	"self initialize"

	self initializeTokenDelimiters! !

XMLHTTPMIMETypeParser initialize!

!XMLHTTPMIMETypeParser class methodsFor: 'class initialization' stamp: 'monty 11/12/2017 01:21'!
initializeTokenDelimiters
	"String streamContents: [:writeStream | | readStream current previous |
		readStream := self tspecialsTemplate readStream.
		[readStream atEnd]
			whileFalse: [
				previous := current.
				current := readStream next.
				(#('""' '<>') anySatisfy: [:each |
					previous = each first
						and: [readStream peek = each last]])
					ifTrue: [writeStream nextPut: current]]]"

	TokenDelimiters :=
		BitmapCharacterSet newFrom: '()<>@,;:\"/[]?.=', Character xmlWhitespace! !

!XMLHTTPMIMETypeParser class methodsFor: 'private' stamp: 'monty 11/9/2017 14:57'!
tspecialsTemplate
	^ '	tspecials :=  "(" / ")" / "<" / ">" / "@"  ; Must be in
                       /  "," / ";" / ":" / "\" / <">  ; quoted-string,
                       /  "/" / "[" / "]" / "?" / "."  ; to use within
                       /  "="                        ; parameter values'! !

!XMLHTTPMIMETypeParser methodsFor: 'private' stamp: 'monty 1/20/2018 20:04'!
nextOptionalQuotedString
	| isEscaping nextChar |

	(readStream
		skipSeparators;
		peekFor: $")
		ifFalse: [^ nil].

	writeStream
		reset;
		nextPut: $".
	isEscaping := false.
	[(nextChar := readStream next) isNil
		or: [isEscaping not
			and: [nextChar == $"]]]
		whileFalse: [
			isEscaping :=
				isEscaping not
					and: [nextChar == $\].
			writeStream nextPut: nextChar].
	^ writeStream
		nextPut: $";
		contents.! !

!XMLHTTPMIMETypeParser methodsFor: 'private' stamp: 'monty 1/20/2018 20:04'!
nextToken
	readStream skipSeparators.
	^ self nextDelimitedByAny: TokenDelimiters.
! !

!XMLHTTPMIMETypeParser methodsFor: 'private' stamp: 'monty 11/9/2017 15:37'!
nextTokenOrQuotedString
	^ self nextOptionalQuotedString
		ifNil: [self nextToken]! !

!XMLHTTPMIMETypeParser methodsFor: 'parsing' stamp: 'monty 1/22/2018 03:22'!
parseMainType
	"main types are case insensitive and are converted to
	lowercase for consistentcy"
	^ self nextToken asLowercase! !

!XMLHTTPMIMETypeParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:04'!
parseParameters
	| parameters attributes totalAttributes |

	parameters := OrderedCollection new.
	totalAttributes := 0.
	[(readStream
		skipSeparators;
		peekFor: $;)
			and: [
				(readStream
					skipSeparators;
					atEnd) not]]
		whileTrue: [| attribute value hasValue |
			"attributes are case insensitive and are converted
			to lowercase for convenience"
			attribute := self nextToken asLowercase.
			(hasValue :=
				readStream
					skipSeparators;
					peekFor: $=)
				ifTrue: [value := self nextTokenOrQuotedString]
				ifFalse: [value := ''].
			(attribute notEmpty
				or: [hasValue])
				ifTrue: [
					"only initialize if needed"
					((attributes ifNil: [attributes := Set new])
						add: attribute;
						size) > totalAttributes
						ifTrue: [
							parameters addLast: attribute -> value.
							totalAttributes := totalAttributes + 1]]].
	^ parameters.! !

!XMLHTTPMIMETypeParser methodsFor: 'parsing' stamp: 'monty 1/22/2018 03:22'!
parseSubType
	"sub types are case insensitive and are converted to
	lowercase for consistentcy"
	readStream
		skipSeparators;
		peekFor: $/.
	^ self nextToken asLowercase.! !

XMLAbstractReadStreamParser subclass: #XMLURIParser
	instanceVariableNames: ''
	classVariableNames: 'HostDelimiters PathDelimiters QueryKeyDelimiters QueryValueDelimiters SchemeDelimiters UserInfoDelimiters'
	poolDictionaries: ''
	category: 'XML-Parser-URI'!

!XMLURIParser commentStamp: 'monty 2/12/2017 16:42' prior: 0!
This class is a parser that can extract the scheme, user info, host, port, path segments, query (as an OrderedCollection of associations), and fragment of a URI. It does not handle percent decoding and raises no errors.!

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/10/2016 00:03'!
initialize
	"self initialize"

	self
		initializeSchemeDelimiters;
		initializeUserInfoDelimiters;
		initializeHostDelimiters;
		initializePathDelimiters;
		initializeQueryKeyDelimiters;
		initializeQueryValueDelimiters! !

XMLURIParser initialize!

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 02:16'!
initializeHostDelimiters
	HostDelimiters := BitmapCharacterSet newFrom: ':/?#'! !

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 02:16'!
initializePathDelimiters
	PathDelimiters := BitmapCharacterSet newFrom: '/?#'! !

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 02:17'!
initializeQueryKeyDelimiters
	QueryKeyDelimiters := BitmapCharacterSet newFrom: '=&#'! !

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 02:17'!
initializeQueryValueDelimiters
	QueryValueDelimiters := BitmapCharacterSet newFrom: '&#'! !

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 03:52'!
initializeSchemeDelimiters
	"including % disallows percent encoding in schemes"
	SchemeDelimiters := BitmapCharacterSet newFrom: ':@/?#%'! !

!XMLURIParser class methodsFor: 'class initialization' stamp: 'monty 1/11/2016 02:19'!
initializeUserInfoDelimiters
	UserInfoDelimiters := BitmapCharacterSet newFrom: '@/?#'! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:07'!
parseAuthorityPrefix
	| oldPosition |

	oldPosition := readStream position.
	((readStream peekFor: $/)
		and: [readStream peekFor: $/])
		ifTrue: [^ true]
		ifFalse: [
			readStream position: oldPosition.
			^ false].! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:08'!
parseFragment
	(readStream peekFor: $#)
		ifTrue: [^ readStream upToEnd]
		ifFalse: [^ '']! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:08'!
parseHost
	| host |

	readStream peek == $[
		ifTrue: [
			host := (self nextDelimitedBy: $]) copyWith: $].
			readStream peekFor: $]]
		ifFalse: [host := self nextDelimitedByAny: HostDelimiters].
	^ host.! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:08'!
parsePathSegments
	| pathSegments segment |

	pathSegments := OrderedCollection new.

	segment := self nextDelimitedByAny: PathDelimiters.
	[readStream peekFor: $/]
		whileTrue: [
			pathSegments addLast: segment.
			segment := self nextDelimitedByAny: PathDelimiters].
	(pathSegments isEmpty
		and: [segment isEmpty])
		ifFalse: [pathSegments addLast: segment].

	^ pathSegments.! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:08'!
parsePort
	| port |

	(readStream peekFor: $:)
		ifTrue: [
			"do not limit the number of chars read, because port
			number literals can have an arbitrary number of
			leading zeros"
			port :=
				XMLSmallIntegerReader
					readFrom: readStream
					withBase: 10.
			[readStream atEnd
				or: [PathDelimiters includes: readStream peek]]
				whileFalse: [readStream next]].
	^ port.! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:09'!
parseQuery
	"parse the query as an OrderedCollection of name=value associations
	to handle multiple values for the same key and different encoded keys
	that later percent/plus decode to the same key"

	| query key value |

	(readStream peekFor: $?)
		ifFalse: [^ OrderedCollection new: 0].

	query := OrderedCollection new.
	[readStream atEnd
		or: [(key := self nextDelimitedByAny: QueryKeyDelimiters) isEmpty
			and: [readStream peek == $#]]]
		whileFalse: [| hasValue |
			(hasValue := readStream peekFor: $=)
				ifTrue: [value := self nextDelimitedByAny: QueryValueDelimiters]
				ifFalse: [value := ''].
			(key notEmpty
				or: [hasValue])
				ifTrue: [query addLast: key -> value].
			readStream peekFor: $&].

	^ query.! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:09'!
parseScheme
	| oldPosition scheme |

	oldPosition := readStream position.
	scheme := self nextDelimitedByAny: SchemeDelimiters.
	(readStream peekFor: $:)
		ifTrue: [^ scheme asLowercase]
		ifFalse: [
			readStream position: oldPosition.
			^ ''].! !

!XMLURIParser methodsFor: 'parsing' stamp: 'monty 1/20/2018 20:09'!
parseUserInfo
	| userInfo oldPosition |

	oldPosition := readStream position.
	userInfo := self nextDelimitedByAny: UserInfoDelimiters.
	(readStream peekFor: $@)
		ifTrue: [^ userInfo]
		ifFalse: [
			readStream position: oldPosition.
			^ ''].! !

Object subclass: #XMLAttributeDefaultValidator
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeDefaultValidator commentStamp: 'monty 2/20/2016 11:10' prior: 0!
This is a base class for attribute default validators that implement constraints from the default declaration part of an ATTLIST attribute definition.!

!XMLAttributeDefaultValidator class methodsFor: 'instance creation' stamp: 'monty 11/18/2016 16:00'!
attribute: anAttribute
	^ self
		attribute: anAttribute
		value: ''! !

!XMLAttributeDefaultValidator class methodsFor: 'instance creation' stamp: 'monty 11/18/2016 16:00'!
attribute: anAttribute value: aDefaultValue
	^ self new
		setAttribute: anAttribute
		value: aDefaultValue! !

!XMLAttributeDefaultValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:45'!
standaloneExternalClass
	^ self! !

!XMLAttributeDefaultValidator methodsFor: 'accessing' stamp: 'monty 10/30/2014 12:48'!
attribute
	^ attribute! !

!XMLAttributeDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:27'!
isFixedValue
	^ false! !

!XMLAttributeDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:26'!
isImplied
	^ false! !

!XMLAttributeDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:26'!
isRequired
	^ false! !

!XMLAttributeDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:57'!
isValue
	^ false! !

!XMLAttributeDefaultValidator methodsFor: 'printing' stamp: 'monty 11/18/2016 16:03'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self attribute;
		nextPutAll: '="';
		nextPutAll: self value;
		nextPutAll: '")'.! !

!XMLAttributeDefaultValidator methodsFor: 'processing' stamp: 'monty 11/12/2016 16:53'!
processedDefaultForAbsentAttributeValue
	^ nil! !

!XMLAttributeDefaultValidator methodsFor: 'processing' stamp: 'monty 11/12/2016 16:52'!
processedDefaultForPresentAttributeValue: anAttributeValue
	^ anAttributeValue! !

!XMLAttributeDefaultValidator methodsFor: 'initialization' stamp: 'monty 11/18/2016 16:00'!
setAttribute: anAttribute value: aDefaultValue
	attribute := anAttribute! !

!XMLAttributeDefaultValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 16:19'!
validatedDefaultForAbsentAttributeValue
	^ nil! !

!XMLAttributeDefaultValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 16:25'!
validatedDefaultForPresentAttributeValue: anAttributeValue
	^ anAttributeValue! !

!XMLAttributeDefaultValidator methodsFor: 'accessing' stamp: 'monty 11/18/2016 16:02'!
value
	^ ''! !

XMLAttributeDefaultValidator subclass: #XMLAttributeImpliedDefaultValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeImpliedDefaultValidator commentStamp: 'monty 2/20/2016 05:34' prior: 0!
This class allows an attribute to be absent (the #IMPLIED constraint).!

!XMLAttributeImpliedDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:57'!
isImplied
	^ true! !

XMLAttributeDefaultValidator subclass: #XMLAttributeRequiredDefaultValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeRequiredDefaultValidator commentStamp: 'monty 2/20/2016 11:10' prior: 0!
This class makes sure an attribute is present (the #REQUIRED constrant).!

!XMLAttributeRequiredDefaultValidator methodsFor: 'private' stamp: 'monty 10/31/2014 17:11'!
errorRequiredAttributeMissing
	XMLValidationException
		formatSignal: 'Required attribute "{1}" is missing'
		with: self attribute! !

!XMLAttributeRequiredDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:58'!
isRequired
	^ true! !

!XMLAttributeRequiredDefaultValidator methodsFor: 'validating' stamp: 'monty 11/14/2016 13:48'!
validatedDefaultForAbsentAttributeValue
	self errorRequiredAttributeMissing! !

XMLAttributeDefaultValidator subclass: #XMLAttributeValueDefaultValidator
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeValueDefaultValidator commentStamp: 'monty 2/20/2016 11:15' prior: 0!
This class will put a default value for an attribute if the attribute is absent.!

XMLAttributeValueDefaultValidator subclass: #XMLAttributeFixedValueDefaultValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeFixedValueDefaultValidator commentStamp: 'monty 2/20/2016 11:16' prior: 0!
This class will put a default value for an attribute if the attribute is absent and also makes sure that any value matches the default (the #FIXED constraint).!

!XMLAttributeFixedValueDefaultValidator class methodsFor: 'defaults' stamp: 'monty 11/15/2016 12:52'!
standaloneExternalClass
	^ XMLStandaloneExternalAttributeFixedValueDefaultValidator! !

!XMLAttributeFixedValueDefaultValidator methodsFor: 'private' stamp: 'monty 11/18/2016 16:03'!
errorFixedAttributeValueCannotChange
	XMLValidationException
		formatSignal: 'Fixed attribute "{1}" can only have "{2}" as its value'
		with: self attribute
		with: self value! !

!XMLAttributeFixedValueDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:57'!
isFixedValue
	^ true! !

!XMLAttributeFixedValueDefaultValidator methodsFor: 'processing' stamp: 'monty 11/18/2016 16:03'!
processedDefaultForPresentAttributeValue: anAttributeValue
	^ self value! !

!XMLAttributeFixedValueDefaultValidator methodsFor: 'validating' stamp: 'monty 11/18/2016 16:18'!
validatedDefaultForPresentAttributeValue: anAttributeValue
	anAttributeValue = self value
		ifFalse: [self errorFixedAttributeValueCannotChange].
	^ anAttributeValue.! !

XMLAttributeFixedValueDefaultValidator subclass: #XMLStandaloneExternalAttributeFixedValueDefaultValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalAttributeFixedValueDefaultValidator commentStamp: 'monty 11/3/2016 12:42' prior: 0!
This class will make sure the value of a standalone externally defined attribute is present and that it matches a fixed default value (the #FIXED constraint).!

!XMLStandaloneExternalAttributeFixedValueDefaultValidator methodsFor: 'private' stamp: 'monty 11/14/2016 13:47'!
errorStandaloneExternalAttributeDefaultFixedValueUsed
	XMLValidationException
		formatSignal:
			'Externally defined attribute "{1}" fixed default value ',
			'cannot be used by elements when standalone="yes"'
		with: self attribute! !

!XMLStandaloneExternalAttributeFixedValueDefaultValidator methodsFor: 'validating' stamp: 'monty 11/14/2016 13:48'!
validatedDefaultForAbsentAttributeValue
	self errorStandaloneExternalAttributeDefaultFixedValueUsed! !

!XMLAttributeValueDefaultValidator class methodsFor: 'defaults' stamp: 'monty 11/15/2016 12:53'!
standaloneExternalClass
	^ XMLStandaloneExternalAttributeValueDefaultValidator! !

!XMLAttributeValueDefaultValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:57'!
isValue
	^ true! !

!XMLAttributeValueDefaultValidator methodsFor: 'processing' stamp: 'monty 11/18/2016 16:03'!
processedDefaultForAbsentAttributeValue
	^ self value! !

!XMLAttributeValueDefaultValidator methodsFor: 'initialization' stamp: 'monty 11/18/2016 16:05'!
setAttribute: anAttribute value: aDefaultValue
	attribute := anAttribute.
	value := aDefaultValue.! !

!XMLAttributeValueDefaultValidator methodsFor: 'validating' stamp: 'monty 11/18/2016 16:03'!
validatedDefaultForAbsentAttributeValue
	^ self value! !

!XMLAttributeValueDefaultValidator methodsFor: 'accessing' stamp: 'monty 11/18/2016 16:05'!
value
	^ value! !

!XMLAttributeValueDefaultValidator methodsFor: 'accessing' stamp: 'monty 11/18/2016 16:05'!
value: aDefaultValue
	value := aDefaultValue! !

XMLAttributeValueDefaultValidator subclass: #XMLStandaloneExternalAttributeValueDefaultValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalAttributeValueDefaultValidator commentStamp: 'monty 11/3/2016 12:43' prior: 0!
This class will make sure the value of a standalone externally defined attribute is present (the default value is never used).!

!XMLStandaloneExternalAttributeValueDefaultValidator methodsFor: 'private' stamp: 'monty 11/14/2016 13:47'!
errorStandaloneExternalAttributeDefaultValueUsed
	XMLValidationException
		formatSignal:
			'Externally defined attribute "{1}" default value ',
			'cannot be used by elements when standalone="yes"'
		with: self attribute! !

!XMLStandaloneExternalAttributeValueDefaultValidator methodsFor: 'validating' stamp: 'monty 11/14/2016 13:46'!
validatedDefaultForAbsentAttributeValue
	self errorStandaloneExternalAttributeDefaultValueUsed! !

Object subclass: #XMLAttributeSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLAttributeSpec commentStamp: 'monty 7/24/2016 06:57' prior: 0!
This is a base class for attribute specifications. Subclasses need to implement matchesAttributes: to return true if the argument attribute dictionary matches the spec and false otherwise.!

!XMLAttributeSpec methodsFor: 'converting' stamp: 'monty 7/24/2016 07:01'!
asXMLAttributeSpec
	^ self! !

!XMLAttributeSpec methodsFor: 'matching' stamp: 'monty 10/2/2017 13:38'!
matchesAttributes: anAttributeDictionary
	self subclassResponsibility! !

XMLAttributeSpec subclass: #XMLBasicAttributeSpec
	instanceVariableNames: 'attributeSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLBasicAttributeSpec commentStamp: 'monty 7/24/2016 07:05' prior: 0!
A simple attribute spec that checks for attributes being present and optionally having a specific value.!

!XMLBasicAttributeSpec class methodsFor: 'instance creation' stamp: 'monty 7/24/2016 09:09'!
attributes: aDictionaryOrCollectionOfAssociationsAndStrings
	^ self new setAttributes: aDictionaryOrCollectionOfAssociationsAndStrings! !

!XMLBasicAttributeSpec methodsFor: 'adding' stamp: 'monty 8/17/2016 19:56'!
addAttribute: anAttribute
	^ attributeSpec
		at: anAttribute
		ifAbsentPut: [nil]! !

!XMLBasicAttributeSpec methodsFor: 'adding' stamp: 'monty 7/24/2016 08:59'!
addAttributeAssociation: anAssociation
	^ self
		addAttributeName: anAssociation key
		value: anAssociation value! !

!XMLBasicAttributeSpec methodsFor: 'adding' stamp: 'monty 8/17/2016 19:56'!
addAttributeName: aName value: aValue
	^ attributeSpec
		at: aName
		put: aValue! !

!XMLBasicAttributeSpec methodsFor: 'initialization' stamp: 'monty 8/17/2016 19:56'!
initialize
	attributeSpec := Dictionary new! !

!XMLBasicAttributeSpec methodsFor: 'matching' stamp: 'monty 10/2/2017 13:38'!
matchesAttributes: anAttributeDictionary
	attributeSpec keysAndValuesDo: [:specName :specValue |
		specValue
			ifNil: [
				"nil values mean the attribute has to be present and can have
				any value"
				(anAttributeDictionary includesKey: specName)
					ifFalse: [^ false]]
			ifNotNil: [
				(specValue isBlock
					ifTrue: [
						specValue value:
							(anAttributeDictionary
								at: specName
								ifAbsent: [^ false])]
					ifFalse: [
						specValue =
							(anAttributeDictionary
								at: specName
								ifAbsent: [^ false])])
							ifFalse: [^ false]]].
	^ true.! !

!XMLBasicAttributeSpec methodsFor: 'initialization' stamp: 'monty 8/17/2016 19:56'!
setAttributes: aDictionaryOrCollectionOfAssociationsAndStrings
	attributeSpec removeAll.

	"associationsDo: works for dictionaries and non-dictionaries, including
	arrays, to support specs like {'one'. 'two'->'three'}"
	aDictionaryOrCollectionOfAssociationsAndStrings associationsDo: [:each |
		each isString
			ifTrue: [self addAttribute: each]
			ifFalse: [self addAttributeAssociation: each]].! !

Object subclass: #XMLAttributeValidator
	instanceVariableNames: 'element attribute defaultValidator'
	classVariableNames: 'NormalizedSpace'
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAttributeValidator commentStamp: '<historical>' prior: 0!
This is a base class for attribute validators.!

!XMLAttributeValidator class methodsFor: 'instance creation' stamp: 'monty 2/19/2016 14:47'!
element: anElement attribute: anAttribute defaultValidator: aDefaultValidator
	^ self new
		setElement: anElement
		attribute: anAttribute
		defaultValidator: aDefaultValidator! !

!XMLAttributeValidator class methodsFor: 'class initialization' stamp: 'monty 9/27/2016 14:27'!
initialize
	"self initialize"

	"stored in a class var for faster access"
	NormalizedSpace := Character space! !

XMLAttributeValidator initialize!

!XMLAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:48'!
standaloneExternalClass
	^ self! !

!XMLAttributeValidator methodsFor: 'accessing' stamp: 'monty 12/10/2013 06:17'!
attribute
	^ attribute! !

!XMLAttributeValidator methodsFor: 'accessing' stamp: 'monty 2/19/2016 14:46'!
defaultValidator
	^ defaultValidator! !

!XMLAttributeValidator methodsFor: 'accessing' stamp: 'monty 12/10/2013 06:17'!
element
	^ element! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 11/15/2016 14:14'!
errorInvalidDefaultAttributeValue: aDefaultValue
	XMLValidationException
		formatSignal:
			'Invalid default value "{1}" in declaration for ',
			'attribute "{2}" of element <3>'
		with: aDefaultValue
		with: self attribute
		with: self element! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 11/15/2016 12:23'!
errorInvalidXMLIDAttributeDeclaration
	XMLValidationException signal:
		'All "xml:id" attributes must be declared to be of ID type'! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 11/15/2016 12:23'!
errorInvalidXMLSpaceAttributeDeclaration
	XMLValidationException
		formatSignal:
			'Attribute "xml:space" of element <{1}> must be declared as ',
			'an enumeration type with "default" and/or "preserve" values'
		with: self element! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 11/12/2016 16:56'!
errorNormalizedStandaloneExternalAttribute
	XMLValidationException
		formatSignal:
			'Externally defined attribute "{1}" of element <{2}> required ',
			'further value normalizaiton in standalone="yes" document'
		with: self attribute
		with: self element! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 11/15/2016 14:19'!
furtherNormalizeAttributeValue: aSemiNormalizedAttributeValue
	"The tokenizer normalizes all non-char escaped whitespace in attribute
	values to spaces (0x20). This further normalizes them by removing leading
	and trailing spaces and turing multiple spaces to single spaces."
	| writeStream isInWhitespace |

	aSemiNormalizedAttributeValue size > 0 "optimization"
		ifFalse: [^ aSemiNormalizedAttributeValue].

	"must use #writeStream instead of 'WriteStream on:' to get a 0-based stream
	on Gemstone"
	writeStream := (String new: aSemiNormalizedAttributeValue size) writeStream.
	isInWhitespace := false.
	"to:do: for speed"
	1 to: aSemiNormalizedAttributeValue size do: [:i | | nextChar |
		(nextChar := aSemiNormalizedAttributeValue at: i) == NormalizedSpace
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream position > 0
							ifTrue: [writeStream nextPut: NormalizedSpace].
						isInWhitespace := false].
				writeStream nextPut: nextChar]].
	^ writeStream contents.! !

!XMLAttributeValidator methodsFor: 'initialization' stamp: 'monty 11/18/2016 16:02'!
initializeWithValidatorsFrom: aValidatorContainer
	(self mustFurtherNormalizeAttributeValue
		and: [self defaultValidator isValue])
		ifTrue: [
			self defaultValidator value:
				(self furtherNormalizeAttributeValue:
					self defaultValidator value)]! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isCData
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isEntities
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isEntity
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isEnumeration
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isID
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isIDRef
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isIDRefs
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isNmtoken
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isNmtokens
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isNotationEnumeration
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 1/21/2017 10:15'!
isStandaloneExternal
	"this is overridden in each standalone external subclass to return
	true instead of just returning a boolean inst var to save memory"
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isXMLID
	^ false! !

!XMLAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:25'!
mustFurtherNormalizeAttributeValue
	^ true! !

!XMLAttributeValidator methodsFor: 'printing' stamp: 'monty 4/24/2015 08:54'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(<';
		nextPutAll: self element;
		space;
		nextPutAll: self attribute;
		nextPutAll: '="">)'.! !

!XMLAttributeValidator methodsFor: 'processing' stamp: 'monty 11/26/2016 01:16'!
processAttributes: aDictionary
	| attributeAssociation normalizedValue |

	attributeAssociation :=
		aDictionary
			associationAt: self attribute
			ifAbsent: [
				self defaultValidator processedDefaultForAbsentAttributeValue
					ifNotNil: [:defaultValue |
						aDictionary
							at: self attribute
							put: defaultValue].
				^ self].

	self mustFurtherNormalizeAttributeValue
		ifTrue: [
			normalizedValue :=
				self furtherNormalizeAttributeValue:
					attributeAssociation value]
		ifFalse: [normalizedValue := attributeAssociation value].
	attributeAssociation value:
		(self defaultValidator processedDefaultForPresentAttributeValue:
			normalizedValue).! !

!XMLAttributeValidator methodsFor: 'initialization' stamp: 'monty 2/19/2016 14:48'!
setElement: anElement attribute: anAttribute defaultValidator: aDefaultValidator
	element := anElement.
	attribute := anAttribute.
	defaultValidator := aDefaultValidator.! !

!XMLAttributeValidator methodsFor: 'private' stamp: 'monty 4/7/2016 03:31'!
spaceSeparatedListValuesIn: aSpaceSeparatedList do: aBlock
	NormalizedSpace
		xmlSplit: aSpaceSeparatedList
		do: aBlock! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 11/18/2016 16:04'!
validateAttributeDeclaration
	(self attribute at: 1) == $x "optimization"
		ifTrue: [
			(self attribute = 'xml:id')
				ifTrue: [^ self validateXMLIDAttributeDeclaration].
			(self attribute = 'xml:space')
				ifTrue: [^ self validateXMLSpaceAttributeDeclaration]].

	self defaultValidator isValue
		ifTrue: [	
			self validateAttributeDefaultValue:
				self defaultValidator value].! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 12:27'!
validateAttributeDefaultValue: aDefaultValue
	"This is overridden in subclasses to check default values when validating
	the declaration, but CDATA types should not be validated, and ID types
	cannot have default values at all"! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 12:26'!
validateAttributeValue: aValue
	"This is overridden in subclasses to check attribute values"! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 1/22/2018 04:27'!
validateAttributes: aDictionary
	| attributeAssociation wasAbsent |

	wasAbsent := false.
	attributeAssociation :=
		aDictionary
			associationAt: self attribute
			ifAbsent: [
				wasAbsent := true.
				self defaultValidator validatedDefaultForAbsentAttributeValue
					ifNil: [^ self]
					ifNotNil: [:defaultValue |
						aDictionary add: self attribute -> defaultValue]].

	wasAbsent
		ifFalse: [| normalizedValue |
			self mustFurtherNormalizeAttributeValue
				ifTrue: [
					normalizedValue :=
						self furtherNormalizeAttributeValue:
							attributeAssociation value.
					self isStandaloneExternal
						ifTrue: [
							"since further normalization just condences multiple spaces
							to single spaces and removes trailing and leading spaces,
							comparing the sizes after is enough to detect if it was
							done"
							normalizedValue size = attributeAssociation value size
								ifFalse: [
									self errorNormalizedStandaloneExternalAttribute]]]
				ifFalse: [normalizedValue := attributeAssociation value].
			attributeAssociation value:
				(self defaultValidator validatedDefaultForPresentAttributeValue:
					normalizedValue)].

	self validateAttributeValue: attributeAssociation value.! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 12:23'!
validateXMLIDAttributeDeclaration
	self errorInvalidXMLIDAttributeDeclaration! !

!XMLAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 12:23'!
validateXMLSpaceAttributeDeclaration
	self errorInvalidXMLSpaceAttributeDeclaration! !

XMLAttributeValidator subclass: #XMLCDataAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLCDataAttributeValidator commentStamp: 'monty 2/20/2016 05:32' prior: 0!
This class validates CDATA attributes, which are not whitespace-normalized further.!

!XMLCDataAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalCDataAttributeValidator! !

!XMLCDataAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:59'!
isCData
	^ true! !

!XMLCDataAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 12:25'!
mustFurtherNormalizeAttributeValue
	^ false! !

XMLCDataAttributeValidator subclass: #XMLStandaloneExternalCDataAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalCDataAttributeValidator commentStamp: 'monty 11/3/2016 12:46' prior: 0!
This class validates standalone externally defined CDATA attributes. It disallows attributes that need substitution with default or fixed default values.!

!XMLStandaloneExternalCDataAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:50'!
isStandaloneExternal
	^ true! !

XMLAttributeValidator subclass: #XMLEntityAttributeValidator
	instanceVariableNames: 'unparsedEntityValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLEntityAttributeValidator commentStamp: 'monty 2/2/2014 16:44' prior: 0!
This class validates attributes that contain unparsed entity names (that must be declared).!

XMLEntityAttributeValidator subclass: #XMLEntitiesAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLEntitiesAttributeValidator commentStamp: 'monty 2/20/2016 05:27' prior: 0!
This class validates attributes with lists of unparsed entity name values (that must be declared) separated by spaces.!

!XMLEntitiesAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalEntitiesAttributeValidator! !

!XMLEntitiesAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isEntities
	^ true! !

!XMLEntitiesAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	self
		spaceSeparatedListValuesIn: aDefaultValue
		do: [:each |
			each isXMLName
				ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]]! !

!XMLEntitiesAttributeValidator methodsFor: 'validating' stamp: 'monty 4/7/2016 03:31'!
validateAttributeValue: aValue
	self
		spaceSeparatedListValuesIn: aValue
		do: [:each |
			self unparsedEntityValidator
				validateEntityReference: each
				inAttribute: self attribute]! !

XMLEntitiesAttributeValidator subclass: #XMLStandaloneExternalEntitiesAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalEntitiesAttributeValidator commentStamp: 'monty 11/23/2016 23:51' prior: 0!
This class validates standalone externally defined attributes with lists of unparsed entity name values (that must be declared) separated by spaces. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalEntitiesAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:47'!
isStandaloneExternal
	^ true! !

!XMLEntityAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalEntityAttributeValidator! !

!XMLEntityAttributeValidator methodsFor: 'initialization' stamp: 'monty 11/12/2016 17:04'!
initializeWithValidatorsFrom: aValidatorContainer
	super initializeWithValidatorsFrom: aValidatorContainer.

	unparsedEntityValidator := aValidatorContainer unparsedEntityValidator! !

!XMLEntityAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isEntity
	^ true! !

!XMLEntityAttributeValidator methodsFor: 'accessing' stamp: 'monty 1/1/2015 20:35'!
unparsedEntityValidator
	^ unparsedEntityValidator! !

!XMLEntityAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	aDefaultValue isXMLName
		ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]! !

!XMLEntityAttributeValidator methodsFor: 'validating' stamp: 'monty 1/1/2015 21:30'!
validateAttributeValue: aValue
	self unparsedEntityValidator
		validateEntityReference: aValue
		inAttribute: self attribute! !

XMLEntityAttributeValidator subclass: #XMLStandaloneExternalEntityAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalEntityAttributeValidator commentStamp: 'monty 11/3/2016 12:48' prior: 0!
This class validates standalone externally defined attributes that contain unparsed entity names (that must be declared). It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalEntityAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:47'!
isStandaloneExternal
	^ true! !

XMLAttributeValidator subclass: #XMLEnumerationAttributeValidator
	instanceVariableNames: 'allowedValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLEnumerationAttributeValidator commentStamp: 'monty 2/2/2014 08:13' prior: 0!
This class validates attributes that can have any value taken from a list like "(one|two|thee)".!

!XMLEnumerationAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalEnumerationAttributeValidator! !

!XMLEnumerationAttributeValidator methodsFor: 'accessing' stamp: 'monty 12/9/2013 02:17'!
allowedValues
	^ allowedValues ifNil: [allowedValues := Set new]! !

!XMLEnumerationAttributeValidator methodsFor: 'accessing' stamp: 'monty 11/12/2016 21:05'!
allowedValues: anAllowedValuesCollection
	allowedValues := anAllowedValuesCollection! !

!XMLEnumerationAttributeValidator methodsFor: 'private ' stamp: 'monty 11/12/2016 11:00'!
errorEnumerationContainsDuplicateValues
	XMLValidationException
		formatSignal:
			'Declaration for enumeration attribute "{1}" of element ',
			'<{2}> contains duplicate values'
		with: self attribute
		with: self element! !

!XMLEnumerationAttributeValidator methodsFor: 'private ' stamp: 'monty 4/8/2016 23:00'!
errorInvalidValue: aValue
	XMLValidationException
		formatSignal: 'Invalid value "{1}" for attribute "{2}" of element <{3}>'
		with: aValue
		with: self attribute
		with: self element! !

!XMLEnumerationAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isEnumeration
	^ true! !

!XMLEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 11:00'!
validateAttributeDeclaration
	| oldAllowedValues |

	oldAllowedValues := self allowedValues.
	self allowedValues: oldAllowedValues asSet.
	(self allowedValues size < oldAllowedValues size)
		ifTrue: [self errorEnumerationContainsDuplicateValues].

	super validateAttributeDeclaration.! !

!XMLEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	(self allowedValues includes: aDefaultValue)
		ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]! !

!XMLEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 10/31/2014 17:30'!
validateAttributeValue: aValue
	(self allowedValues includes: aValue)
		ifFalse: [self errorInvalidValue: aValue]! !

!XMLEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 11/26/2016 01:54'!
validateXMLSpaceAttributeDeclaration
	self allowedValues size > 2
		ifTrue: [self errorInvalidXMLSpaceAttributeDeclaration].
	self allowedValues do: [:each |
		(each = 'preserve'
			or: [each = 'default'])
			ifFalse: [self errorInvalidXMLSpaceAttributeDeclaration]].! !

XMLEnumerationAttributeValidator subclass: #XMLNotationEnumerationAttributeValidator
	instanceVariableNames: 'unparedEntityValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLNotationEnumerationAttributeValidator commentStamp: 'monty 2/2/2014 08:10' prior: 0!
This class validates attributes that can have NOTATION names from a list as values.!

!XMLNotationEnumerationAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalNotationEnumerationAttributeValidator! !

!XMLNotationEnumerationAttributeValidator methodsFor: 'initialization' stamp: 'monty 11/12/2016 17:04'!
initializeWithValidatorsFrom: aValidatorContainer
	super initializeWithValidatorsFrom: aValidatorContainer.

	unparedEntityValidator := aValidatorContainer unparsedEntityValidator.! !

!XMLNotationEnumerationAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isNotationEnumeration
	^ true! !

!XMLNotationEnumerationAttributeValidator methodsFor: 'accessing' stamp: 'monty 11/11/2016 06:09'!
unparsedEntityValidator
	^ unparedEntityValidator! !

!XMLNotationEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 11/16/2016 12:06'!
validateAttributeDeclaration
	self unparsedEntityValidator validateNotationAttributeDeclaration: self.

	super validateAttributeDeclaration.! !

!XMLNotationEnumerationAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 12:23'!
validateXMLSpaceAttributeDeclaration
	self errorInvalidXMLSpaceAttributeDeclaration! !

XMLNotationEnumerationAttributeValidator subclass: #XMLStandaloneExternalNotationEnumerationAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalNotationEnumerationAttributeValidator commentStamp: 'monty 11/3/2016 12:48' prior: 0!
This class validates attributes that can have NOTATION names from a list as values. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalNotationEnumerationAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:56'!
isStandaloneExternal
	^ true! !

XMLEnumerationAttributeValidator subclass: #XMLStandaloneExternalEnumerationAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalEnumerationAttributeValidator commentStamp: 'monty 11/3/2016 12:49' prior: 0!
This class validates attributes that can have any value taken from a list like "(one|two|thee)". It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalEnumerationAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:56'!
isStandaloneExternal
	^ true! !

XMLAttributeValidator subclass: #XMLIDAttributeValidator
	instanceVariableNames: 'elementIDValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLIDAttributeValidator commentStamp: 'monty 2/20/2016 11:17' prior: 0!
This class validates ID attributes that must have unique (not repeated in the same document) values.!

!XMLIDAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalIDAttributeValidator! !

!XMLIDAttributeValidator methodsFor: 'accessing' stamp: 'monty 11/14/2016 15:05'!
elementIDValidator
	^ elementIDValidator! !

!XMLIDAttributeValidator methodsFor: 'accessing' stamp: 'monty 11/14/2016 15:05'!
elementIDValidator: anElementIDValidator
	elementIDValidator := anElementIDValidator! !

!XMLIDAttributeValidator methodsFor: 'private' stamp: 'monty 4/9/2016 04:15'!
errorIDAttributeMustBeRequiredOrImplied
	XMLValidationException
		formatSignal:
			'Attribute "{1}" of element <{2}> is of ID type and must ',
			'be declared #REQUIRED or #IMPLIED'
		with: self attribute
		with: self element! !

!XMLIDAttributeValidator methodsFor: 'initialization' stamp: 'monty 11/14/2016 15:05'!
initializeWithValidatorsFrom: aValidatorContainer
	super initializeWithValidatorsFrom: aValidatorContainer.

	elementIDValidator := aValidatorContainer elementIDValidator.! !

!XMLIDAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isID
	^ true! !

!XMLIDAttributeValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 10:54'!
validateAttributeDeclaration
	self elementIDValidator
		validateIDAttribute: self attribute
		forElement: self element.

	super validateAttributeDeclaration.! !

!XMLIDAttributeValidator methodsFor: 'validating' stamp: 'monty 4/9/2016 02:36'!
validateAttributeDefaultValue: aDefaultValue
	self errorIDAttributeMustBeRequiredOrImplied! !

!XMLIDAttributeValidator methodsFor: 'validating' stamp: 'monty 1/1/2015 21:32'!
validateAttributeValue: aValue
	self elementIDValidator
		validateID: aValue
		inAttribute: self attribute! !

XMLIDAttributeValidator subclass: #XMLStandaloneExternalIDAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalIDAttributeValidator commentStamp: 'monty 11/3/2016 12:53' prior: 0!
This class validates standalone externally defined ID attributes that must have unique (not repeated in the same document) values. It disallows attributes that require further value normalization.!

!XMLStandaloneExternalIDAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:53'!
isStandaloneExternal
	^ true! !

XMLIDAttributeValidator subclass: #XMLXMLIDAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLXMLIDAttributeValidator commentStamp: 'monty 11/5/2016 11:57' prior: 0!
This class validates ID attributes for the xml:id spec.!

XMLXMLIDAttributeValidator subclass: #XMLStandaloneExternalXMLIDAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalXMLIDAttributeValidator commentStamp: 'monty 11/3/2016 12:52' prior: 0!
This class validates standalone externally defined xml:id ID attributes. It disallows attributes that require further value normalization.!

!XMLStandaloneExternalXMLIDAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:53'!
isStandaloneExternal
	^ true! !

!XMLXMLIDAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalXMLIDAttributeValidator! !

!XMLXMLIDAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:00'!
isXMLID
	^ true! !

!XMLXMLIDAttributeValidator methodsFor: 'validating' stamp: 'monty 1/1/2015 21:33'!
validateAttributeValue: aValue
	self elementIDValidator validateXMLID: aValue! !

!XMLXMLIDAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 12:22'!
validateXMLIDAttributeDeclaration
! !

XMLAttributeValidator subclass: #XMLIDRefAttributeValidator
	instanceVariableNames: 'elementIDValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLIDRefAttributeValidator commentStamp: 'monty 2/2/2014 16:44' prior: 0!
This class validates attributes that refer to an ID of another element with a ID attribute.!

!XMLIDRefAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalIDRefAttributeValidator! !

!XMLIDRefAttributeValidator methodsFor: 'accessing' stamp: 'monty 11/27/2016 05:17'!
elementIDValidator
	^ elementIDValidator! !

!XMLIDRefAttributeValidator methodsFor: 'initialization' stamp: 'monty 11/27/2016 05:17'!
initializeWithValidatorsFrom: aValidatorContainer
	super initializeWithValidatorsFrom: aValidatorContainer.

	elementIDValidator := aValidatorContainer elementIDValidator.! !

!XMLIDRefAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:01'!
isIDRef
	^ true! !

!XMLIDRefAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	aDefaultValue isXMLName
		ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]! !

!XMLIDRefAttributeValidator methodsFor: 'validating' stamp: 'monty 1/3/2015 23:24'!
validateAttributeValue: aValue
	self elementIDValidator
		validateIDReference: aValue
		inAttribute: self attribute! !

XMLIDRefAttributeValidator subclass: #XMLIDRefsAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLIDRefsAttributeValidator commentStamp: 'monty 2/2/2014 08:13' prior: 0!
This class validates attributes with lists of ID ref values separated by spaces.!

!XMLIDRefsAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalIDRefsAttributeValidator! !

!XMLIDRefsAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:01'!
isIDRefs
	^ true! !

!XMLIDRefsAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	self
		spaceSeparatedListValuesIn: aDefaultValue
		do: [:each |
			each isXMLName
				ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]]! !

!XMLIDRefsAttributeValidator methodsFor: 'validating' stamp: 'monty 4/7/2016 03:31'!
validateAttributeValue: aValue
	self
		spaceSeparatedListValuesIn: aValue
		do: [:each |
			self elementIDValidator
				validateIDReference: each
				inAttribute: self attribute]! !

XMLIDRefsAttributeValidator subclass: #XMLStandaloneExternalIDRefsAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalIDRefsAttributeValidator commentStamp: 'monty 11/3/2016 12:50' prior: 0!
This class validates standalone externally defined attributes with lists of ID ref values separated by spaces. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalIDRefsAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:53'!
isStandaloneExternal
	^ true! !

XMLIDRefAttributeValidator subclass: #XMLStandaloneExternalIDRefAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalIDRefAttributeValidator commentStamp: 'monty 11/24/2016 02:13' prior: 0!
This class validates standalone externally defined attributes that refer to an ID of another element with an ID attribute. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalIDRefAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:53'!
isStandaloneExternal
	^ true! !

XMLAttributeValidator subclass: #XMLNmtokenAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLNmtokenAttributeValidator commentStamp: 'monty 12/11/2014 04:41' prior: 0!
This class validates Nmtoken name attributes.!

!XMLNmtokenAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalNmtokenAttributeValidator! !

!XMLNmtokenAttributeValidator methodsFor: 'private' stamp: 'monty 4/8/2016 23:01'!
errorInvalidNmtoken: aName
	XMLValidationException
		formatSignal: 'Invalid Nmtoken name "{1}" in attribute "{2}" of element <{3}>'
		with: aName
		with: self attribute
		with: self element! !

!XMLNmtokenAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:01'!
isNmtoken
	^ true! !

!XMLNmtokenAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	aDefaultValue isXMLNmtoken
		ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]! !

!XMLNmtokenAttributeValidator methodsFor: 'validating' stamp: 'monty 12/11/2014 04:37'!
validateAttributeValue: aValue
	self validateNmtoken: aValue! !

!XMLNmtokenAttributeValidator methodsFor: 'validating' stamp: 'monty 3/24/2016 20:56'!
validateNmtoken: aName
	aName isXMLNmtoken
		ifFalse: [self errorInvalidNmtoken: aName]! !

XMLNmtokenAttributeValidator subclass: #XMLNmtokensAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLNmtokensAttributeValidator commentStamp: 'monty 12/11/2014 04:41' prior: 0!
This class validates attributes with lists of Nmtoken name values separated by spaces.!

!XMLNmtokensAttributeValidator class methodsFor: 'defaults' stamp: 'monty 11/1/2016 08:56'!
standaloneExternalClass
	^ XMLStandaloneExternalNmtokensAttributeValidator! !

!XMLNmtokensAttributeValidator methodsFor: 'testing' stamp: 'monty 11/15/2016 13:01'!
isNmtokens
	^ true! !

!XMLNmtokensAttributeValidator methodsFor: 'validating' stamp: 'monty 11/15/2016 14:02'!
validateAttributeDefaultValue: aDefaultValue
	self
		spaceSeparatedListValuesIn: aDefaultValue
		do: [:each |
			each isXMLNmtoken
				ifFalse: [self errorInvalidDefaultAttributeValue: aDefaultValue]]! !

!XMLNmtokensAttributeValidator methodsFor: 'validating' stamp: 'monty 4/7/2016 03:31'!
validateAttributeValue: aValue
	self
		spaceSeparatedListValuesIn: aValue
		do: [:each | self validateNmtoken: each]! !

XMLNmtokensAttributeValidator subclass: #XMLStandaloneExternalNmtokensAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalNmtokensAttributeValidator commentStamp: 'monty 11/3/2016 12:49' prior: 0!
This class validates standalone externally defined attributes with lists of Nmtoken name values separated by spaces. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalNmtokensAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:50'!
isStandaloneExternal
	^ true! !

XMLNmtokenAttributeValidator subclass: #XMLStandaloneExternalNmtokenAttributeValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalNmtokenAttributeValidator commentStamp: 'monty 11/3/2016 12:50' prior: 0!
This class validates standalone externally defined Nmtoken name attributes. It disallows attributes that require further value normalization or substitution with default or fixed default values.!

!XMLStandaloneExternalNmtokenAttributeValidator methodsFor: 'testing' stamp: 'monty 11/1/2016 02:47'!
isStandaloneExternal
	^ true! !

Object subclass: #XMLClassFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLClassFinder commentStamp: 'monty 7/6/2016 02:49' prior: 0!
A simple cross-platform interface for finding classes that may not be in the image.!

!XMLClassFinder class methodsFor: 'accessing' stamp: 'monty 7/6/2016 02:26'!
classNamed: aClassName
	^ self
		classNamed: aClassName
		ifAbsent: [nil]! !

!XMLClassFinder class methodsFor: 'accessing' stamp: 'monty 2/11/2018 01:49'!
classNamed: aClassName ifAbsent: aBlock
	"'self environment at:' is the proper way to get a class that may not
	exist, not 'Smalltalk at:', 'Smalltalk globals at:' or '#ClassName asClass'
	(assuming both this class and aClassName class are in the same environment)"
	^ self environment
		at: aClassName asSymbol
		ifAbsent: aBlock! !

!XMLClassFinder class methodsFor: 'accessing' stamp: 'monty 10/20/2016 02:23'!
classNamed: aClassName ifPresent: aBlock
	^ aBlock cull:
		(self
			classNamed: aClassName
			ifAbsent: [^ nil])! !

!XMLClassFinder class methodsFor: 'accessing' stamp: 'monty 12/19/2017 06:24'!
classNamed: aClassName ifPresent: aPresentBlock ifAbsent: anAbsentBlock
	^ aPresentBlock cull:
		(self
			classNamed: aClassName
			ifAbsent: [^ anAbsentBlock value])! !

!XMLClassFinder class methodsFor: 'testing' stamp: 'monty 7/6/2016 02:30'!
hasClassNamed: aClassName
	self
		classNamed: aClassName
		ifAbsent: [^ false].
	^ true.! !

Object subclass: #XMLConfiguration
	instanceVariableNames: 'isValidating usesNamespaces decodesCharacters requiresSchema parserHandlerClass parserLimits entityConfiguration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLConfiguration commentStamp: 'monty 7/14/2015 14:40' prior: 0!
This class stores the settings and components of a parser. For performance it uses separate inst vars instead of a dictionary and lazy initializes some components.!

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 5/8/2015 19:04'!
decodesCharacters
	^ decodesCharacters! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 5/8/2015 19:04'!
decodesCharacters: aBoolean
	decodesCharacters := aBoolean! !

!XMLConfiguration methodsFor: 'defaults' stamp: 'monty 3/17/2015 16:52'!
defaultParserHandlerClass
	^ SAXHandler! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/17/2015 17:31'!
documentReadLimit
	^ self parserLimits documentReadLimit! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:29'!
documentReadLimit: anInteger
	self parserLimits documentReadLimit: anInteger! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:31'!
entityConfiguration
	^ entityConfiguration ifNil: [entityConfiguration := DTDEntityConfiguration new]! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/17/2015 16:54'!
entityConfiguration: anEntityConfiguration
	entityConfiguration := anEntityConfiguration! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:24'!
externalEntityResolver
	^ self entityConfiguration externalEntityResolver! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:23'!
externalEntityResolver: anExternalEntityResolver
	self entityConfiguration externalEntityResolver: anExternalEntityResolver! !

!XMLConfiguration methodsFor: 'initialization' stamp: 'monty 1/29/2018 08:22'!
initialize
	super initialize.

	"always used, so explicitly initialized"
	isValidating := true.
	usesNamespaces := true.
	decodesCharacters := true.
	requiresSchema := false.
	parserLimits := XMLParserLimits new.! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:39'!
isValidating
	^ isValidating! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/29/2018 08:22'!
isValidating: aBoolean
	(isValidating := aBoolean)
		ifTrue: [self preservesUndeclaredEntityReferences: false]
		ifFalse: [self requiresSchema: false]! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/17/2015 17:34'!
maxEntityReplacementDepth
	^ self parserLimits maxEntityReplacementDepth! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:30'!
maxEntityReplacementDepth: anInteger
	self parserLimits maxEntityReplacementDepth: anInteger! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/17/2015 16:54'!
parserHandlerClass
	^ parserHandlerClass ifNil: [parserHandlerClass := self defaultParserHandlerClass]! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 11/16/2013 03:10'!
parserHandlerClass: aClass
	parserHandlerClass := aClass! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:39'!
parserLimits
	^ parserLimits! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/17/2015 16:53'!
parserLimits: aParserLimits
	parserLimits := aParserLimits! !

!XMLConfiguration methodsFor: 'copying' stamp: 'monty 6/19/2015 20:31'!
postCopy
	super postCopy.

	parserLimits := parserLimits copy.
	entityConfiguration
		ifNotNil: [entityConfiguration := entityConfiguration copy].! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/6/2015 04:12'!
preservesUndeclaredEntityReferences
	^ self entityConfiguration preservesUndeclaredEntityReferences! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/6/2015 06:12'!
preservesUndeclaredEntityReferences: aBoolean
	self entityConfiguration preservesUndeclaredEntityReferences: aBoolean.
	aBoolean
		ifTrue: [self isValidating: false].! !

!XMLConfiguration methodsFor: 'removing' stamp: 'monty 3/17/2015 17:39'!
removeLimits
	self parserLimits removeAll.
	self externalEntityResolver removeLimits.! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 23:55'!
replacesContentEntityReferences
	^ self entityConfiguration replacesContentEntityReferences! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 23:55'!
replacesContentEntityReferences: aBoolean
	self entityConfiguration replacesContentEntityReferences: aBoolean! !

!XMLConfiguration methodsFor: 'deprecated' stamp: 'monty 1/29/2018 08:27'!
requiresDocumentConstraints
	^ self requiresSchema! !

!XMLConfiguration methodsFor: 'deprecated' stamp: 'monty 2/6/2018 05:28'!
requiresDocumentConstraints: aBoolean
	"will be deprecated; use #requiresSchema: instead"
	self requiresSchema: aBoolean! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/29/2018 08:22'!
requiresSchema
	^ requiresSchema! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/29/2018 08:22'!
requiresSchema: aBoolean
	(requiresSchema := aBoolean)
		ifTrue: [self isValidating: true]! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:27'!
resolvesExternalEntities
	^ self entityConfiguration resolvesExternalEntities! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 1/3/2015 00:27'!
resolvesExternalEntities: aBoolean
	self entityConfiguration resolvesExternalEntities: aBoolean! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:39'!
usesNamespaces
	^ usesNamespaces! !

!XMLConfiguration methodsFor: 'accessing' stamp: 'JAAyer 11/23/2010 14:06'!
usesNamespaces: aBoolean
	usesNamespaces := aBoolean! !

XMLConfiguration subclass: #XMLDOMConfiguration
	instanceVariableNames: 'preservesCDataNodes preservesCommentNodes preservesIgnorableWhitespace nodeFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLDOMConfiguration commentStamp: '<historical>' prior: 0!
This class stores additional settings and components relevant to the DOM parser and DOM nodes.!

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 9/2/2016 14:00'!
attributeListClass
	^ self nodeFactory attributeListClass! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 9/2/2016 14:01'!
attributeListClass: aClass
	self nodeFactory:
		(self nodeFactory asPluggableNodeFactory attributeListClass: aClass)! !

!XMLDOMConfiguration methodsFor: 'defaults' stamp: 'monty 7/13/2015 13:10'!
defaultNodeFactoryClass
	^ XMLNodeFactory! !

!XMLDOMConfiguration methodsFor: 'defaults' stamp: 'monty 3/17/2015 16:54'!
defaultParserHandlerClass
	^ XMLDOMParser! !

!XMLDOMConfiguration methodsFor: 'initialization' stamp: 'monty 7/13/2015 13:10'!
initialize
	super initialize.

	"always used, so explicitly initialized"
	preservesCDataNodes := false.
	preservesCommentNodes := false.
	preservesIgnorableWhitespace := false.
	nodeFactory := self defaultNodeFactoryClass new.! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 4/20/2016 13:32'!
isValidating: aBoolean
	aBoolean
		ifFalse: [self preservesIgnorableWhitespace: false].
	super isValidating: aBoolean.! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:50'!
nodeFactory
	^ nodeFactory! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'JAAyer 11/23/2010 14:10'!
nodeFactory: aFactory
	nodeFactory := aFactory! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 4/17/2015 10:42'!
nodeListClass
	^ self nodeFactory nodeListClass! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 4/17/2015 10:53'!
nodeListClass: aClass
	self nodeFactory:
		(self nodeFactory asPluggableNodeFactory nodeListClass: aClass)! !

!XMLDOMConfiguration methodsFor: 'copying' stamp: 'monty 6/19/2015 20:31'!
postCopy
	super postCopy.

	nodeFactory := nodeFactory copy.! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:45'!
preservesCDataNodes
	^ preservesCDataNodes! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'JAAyer 11/23/2010 14:08'!
preservesCDataNodes: aBoolean
	preservesCDataNodes := aBoolean! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:45'!
preservesCommentNodes
	^ preservesCommentNodes! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'JAAyer 11/23/2010 14:08'!
preservesCommentNodes: aBoolean
	preservesCommentNodes := aBoolean! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 3/12/2015 13:45'!
preservesIgnorableWhitespace
	^ preservesIgnorableWhitespace! !

!XMLDOMConfiguration methodsFor: 'accessing' stamp: 'monty 4/21/2016 07:36'!
preservesIgnorableWhitespace: aBoolean
	(preservesIgnorableWhitespace := aBoolean)
		ifTrue: [self isValidating: true]! !

Object subclass: #XMLDFAState
	instanceVariableNames: 'nfaStates dfaStateCache dfaStateTransitions hasNonDeterminism'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLDFAState commentStamp: 'monty 12/28/2013 22:34' prior: 0!
This class is a DFA state made by grouping one or more NFA states.!

!XMLDFAState class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 23:18'!
nfaStates: anNFAStateSet
	^ self
		nfaStates: anNFAStateSet
		dfaStateCache: nil! !

!XMLDFAState class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 23:18'!
nfaStates: anNFAStateSet dfaStateCache: aDFAStateCache
	^ self new
		setNFAStates: anNFAStateSet
		dfaStateCache: aDFAStateCache! !

!XMLDFAState methodsFor: 'private' stamp: 'monty 2/19/2016 11:17'!
addDFAStateTransitionMatching: aMatcher
	| matchingNFAStates totalMatched matchingDFAState |

	self dfaStateTransitions size >= self maxDFAStateTransitions
		ifTrue: [self removeDFAStateTransitions].

	matchingNFAStates := XMLNFAStateSet new.
	totalMatched := 0.
	self nfaStatesDo: [:state |
		(state matches: aMatcher)
			ifTrue: [
				state nextState addTo: matchingNFAStates.
				totalMatched := totalMatched + 1]].

	matchingNFAStates size > 0
		ifTrue: [
			matchingDFAState :=
				dfaStateCache dfaStateForNFAStates: matchingNFAStates.
			totalMatched > 1
				ifTrue: [matchingDFAState hasNonDeterminism: true]].

	^ self dfaStateTransitions
		at: aMatcher
		put: matchingDFAState. "nil if no match"! !

!XMLDFAState methodsFor: 'private' stamp: 'monty 4/22/2015 09:27'!
dfaStateCache
	^ dfaStateCache! !

!XMLDFAState methodsFor: 'private' stamp: 'monty 4/22/2015 14:52'!
dfaStateTransitions
	^ dfaStateTransitions ifNil: [dfaStateTransitions := Dictionary new]! !

!XMLDFAState methodsFor: 'testing' stamp: 'monty 10/31/2015 19:21'!
hasNonDeterminism
	^ hasNonDeterminism! !

!XMLDFAState methodsFor: 'accessing' stamp: 'monty 10/31/2015 19:21'!
hasNonDeterminism: aBoolean
	hasNonDeterminism := aBoolean! !

!XMLDFAState methodsFor: 'testing' stamp: 'monty 12/28/2013 18:54'!
isAccepting
	^ nfaStates isAccepting! !

!XMLDFAState methodsFor: 'private' stamp: 'monty 4/22/2015 14:51'!
maxDFAStateTransitions
	^ 64! !

!XMLDFAState methodsFor: 'matching' stamp: 'monty 11/13/2015 04:17'!
nextDFAStateMatching: aMatcher
	^ self
		nextDFAStateMatching: aMatcher
		ifNone: [nil]! !

!XMLDFAState methodsFor: 'matching' stamp: 'monty 2/19/2016 11:03'!
nextDFAStateMatching: aMatcher ifNone: aBlock
	^ (self dfaStateTransitions
		at: aMatcher
		ifAbsent: [self addDFAStateTransitionMatching: aMatcher])
			ifNil: [aBlock value]! !

!XMLDFAState methodsFor: 'accessing' stamp: 'monty 12/29/2013 01:10'!
nfaStates
	^ nfaStates! !

!XMLDFAState methodsFor: 'enumerating' stamp: 'monty 11/10/2015 22:36'!
nfaStatesDo: aBlock
	nfaStates do: aBlock! !

!XMLDFAState methodsFor: 'printing' stamp: 'monty 4/22/2015 11:17'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self nfaStates;
		nextPut: $).! !

!XMLDFAState methodsFor: 'private' stamp: 'monty 4/22/2015 14:52'!
removeDFAStateTransitions
	dfaStateTransitions := nil! !

!XMLDFAState methodsFor: 'initialization' stamp: 'monty 10/31/2015 19:21'!
setNFAStates: anNFAStateSet dfaStateCache: aDFAStateCache
	nfaStates := anNFAStateSet.
	dfaStateCache := (aDFAStateCache ifNil: [XMLDFAStateCache firstDFAState: self]).
	hasNonDeterminism := false.! !

Object subclass: #XMLDFAStateCache
	instanceVariableNames: 'firstDFAState cachedDFAStates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLDFAStateCache commentStamp: 'monty 12/27/2014 03:19' prior: 0!
This class uses a dictionary with NFAStateSet keys to cache DFA states. (Does not use the regular XML key/value  cache for performance)!

!XMLDFAStateCache class methodsFor: 'instance creation' stamp: 'monty 4/17/2015 16:00'!
firstDFAState: aDFAState
	^ self new setFirstDFAState: aDFAState! !

!XMLDFAStateCache methodsFor: 'private' stamp: 'monty 9/26/2016 13:50'!
addDFAStateForNFAStates: anNFAStateSet
	cachedDFAStates size >= self maxCachedDFAStates
		ifTrue: [self removeDFAStates].
	^ cachedDFAStates
		at: anNFAStateSet
		put: (anNFAStateSet asDFAStateWithStateCache: self).! !

!XMLDFAStateCache methodsFor: 'private' stamp: 'monty 4/22/2015 09:27'!
cachedDFAStates
	^ cachedDFAStates! !

!XMLDFAStateCache methodsFor: 'accessing' stamp: 'monty 8/8/2016 21:50'!
dfaStateForNFAStates: anNFAStateSet
	^ cachedDFAStates
		at: anNFAStateSet
		ifAbsent: [self addDFAStateForNFAStates: anNFAStateSet]! !

!XMLDFAStateCache methodsFor: 'accessing' stamp: 'monty 4/17/2015 15:57'!
firstDFAState
	^ firstDFAState! !

!XMLDFAStateCache methodsFor: 'private' stamp: 'monty 4/22/2015 10:43'!
maxCachedDFAStates
	^ 64! !

!XMLDFAStateCache methodsFor: 'private' stamp: 'monty 9/26/2016 13:50'!
removeDFAStates
	cachedDFAStates
		valuesDo: [:each | each removeDFAStateTransitions];
		removeAll.
	cachedDFAStates
		at: firstDFAState nfaStates
		put: firstDFAState.! !

!XMLDFAStateCache methodsFor: 'initialization' stamp: 'monty 4/17/2015 16:01'!
setFirstDFAState: aDFAState
	firstDFAState := aDFAState.
	(cachedDFAStates := Dictionary new: 5)
		at: firstDFAState nfaStates
		put: firstDFAState.! !

Object subclass: #XMLDocumentValidator
	instanceVariableNames: 'elementValidatorStack defaultXMLIDValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLDocumentValidator commentStamp: '<historical>' prior: 0!
This is a base class for XML document validators.!

XMLDocumentValidator subclass: #DTDDocumentValidator
	instanceVariableNames: 'doctypeDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DTD'!

!DTDDocumentValidator commentStamp: '<historical>' prior: 0!
This class validates documents using a DTD.!

!DTDDocumentValidator class methodsFor: 'instance creation' stamp: 'monty 3/2/2015 11:13'!
doctypeDefinition: aDoctypeDefinition
	^ self new doctypeDefinition: aDoctypeDefinition! !

!DTDDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:39'!
attributeValidatorsFor: anElement ifNone: aBlock
	^ self doctypeDefinition
		attributeValidatorsAt: anElement
		ifAbsent: aBlock! !

!DTDDocumentValidator methodsFor: 'accessing' stamp: 'monty 3/2/2015 11:15'!
doctypeDefinition
	^ doctypeDefinition! !

!DTDDocumentValidator methodsFor: 'accessing' stamp: 'monty 3/2/2015 11:15'!
doctypeDefinition: aDoctypeDefinition
	doctypeDefinition := aDoctypeDefinition! !

!DTDDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:35'!
elementValidatorFor: anElement ifNone: aBlock
	^ self doctypeDefinition
		elementValidatorsAt: anElement
		ifAbsent: aBlock! !

!DTDDocumentValidator methodsFor: 'private' stamp: 'monty 8/20/2016 15:44'!
errorInvalidRootElement: anElement
	XMLValidationException
		formatSignal:
			'Root element must be <{1}> according to DOCTYPE declaration, not <{2}>'
		with: self doctypeDefinition root
		with: anElement! !

!DTDDocumentValidator methodsFor: 'testing' stamp: 'monty 3/2/2015 11:14'!
hasAttributeValidators
	^ self doctypeDefinition hasAttributeValidators! !

!DTDDocumentValidator methodsFor: 'testing' stamp: 'monty 3/2/2015 11:14'!
hasElementValidators
	^ self doctypeDefinition hasElementValidators! !

!DTDDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 09:07'!
unvalidatedAttributes: anAttributeCollection inElement: anElement
	XMLValidationException
		formatSignal: 'Undeclared attribute "{1}" in element <{2}>'
		with: anAttributeCollection anyOne
		with: anElement! !

!DTDDocumentValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 09:20'!
unvalidatedElement: anElement
	XMLValidationException
		formatSignal: 'Undeclared element <{1}>'
		with: anElement! !

!DTDDocumentValidator methodsFor: 'validating' stamp: 'monty 9/21/2016 13:48'!
validateIDReferences
	self doctypeDefinition hasElementIDReferences
		ifTrue: [self doctypeDefinition elementIDValidator validateIDReferences]! !

!DTDDocumentValidator methodsFor: 'validating' stamp: 'monty 8/6/2016 19:47'!
validateRootElement: anElement
	(self doctypeDefinition hasRoot
		and: [self doctypeDefinition root ~= anElement])
		ifTrue: [self errorInvalidRootElement: anElement]! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:40'!
attributeValidatorsFor: anElement
	^ self
		attributeValidatorsFor: anElement
		ifNone: [nil]! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:39'!
attributeValidatorsFor: anElement ifNone: aBlock
	self subclassResponsibility! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
currentElementValidator
	^ self elementValidatorStack xmlLastOrNil! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/7/2013 20:07'!
defaultElementValidatorFor: aName
	^ XMLAnyElementValidator element: aName! !

!XMLDocumentValidator methodsFor: 'private' stamp: 'monty 11/15/2016 12:51'!
defaultXMLIDValidator
	"used to validate xml:id attributes if there's no DTD or other validators"
	^ defaultXMLIDValidator
		ifNil: [
			defaultXMLIDValidator :=
				XMLXMLIDAttributeValidator
					element: ''
					attribute: 'xml:id'
					defaultValidator:
						(XMLAttributeImpliedDefaultValidator attribute: 'xml:id').
			defaultXMLIDValidator
				elementIDValidator: XMLElementIDValidator new;
				yourself]! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:36'!
elementValidatorFor: anElement
	^ self
		elementValidatorFor: anElement
		ifNone: [nil]! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 12/6/2016 02:35'!
elementValidatorFor: anElement ifNone: aBlock
	self subclassResponsibility! !

!XMLDocumentValidator methodsFor: 'accessing' stamp: 'monty 11/18/2013 03:46'!
elementValidatorStack
	^ elementValidatorStack ifNil: [elementValidatorStack := OrderedCollection new]! !

!XMLDocumentValidator methodsFor: 'private' stamp: 'monty 4/13/2016 10:20'!
errorUnexpectEndOfElement: anElement
	XMLValidationException
		formatSignal: 'Element <{1}> terminated prematurely'
		with: anElement! !

!XMLDocumentValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 03:31'!
hasAttributeValidators
	self subclassResponsibility! !

!XMLDocumentValidator methodsFor: 'testing' stamp: 'monty 12/6/2016 03:38'!
hasCurrentElementValidator
	"optimized to avoid lazy initialization"
	elementValidatorStack == nil
		ifTrue: [^ false].
	^ elementValidatorStack size > 0.! !

!XMLDocumentValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 03:32'!
hasElementValidators
	self subclassResponsibility! !

!XMLDocumentValidator methodsFor: 'testing' stamp: 'monty 12/6/2016 07:58'!
isCurrentElementWhitespaceIgnorable
	^ self hasCurrentElementValidator
		and: [self currentElementValidator ignoresWhitespace]! !

!XMLDocumentValidator methodsFor: 'printing' stamp: 'monty 4/24/2015 15:30'!
printOn: aStream
	super printOn: aStream.
	self hasCurrentElementValidator
		ifTrue: [
			aStream
				nextPut: $(;
				print: self currentElementValidator;
				nextPut: $)].! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 09:28'!
unvalidatedAttributes: anAttributeCollection inElement: anElement
	"sent when at least one attribute of an element wasn't validated by an
	attribute validator and there are element or attribute validators defined"! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 09:28'!
unvalidatedElement: anElement
	"sent when an element was not validated by an element validator
	and there are element or attribute validators defined"! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 09:10'!
validateAttributes: aDictionary withAttributeValidatorsFor: anElement
	| totalUnvalidatedAttributes validatedAttributes |

	totalUnvalidatedAttributes := aDictionary size.
	(self attributeValidatorsFor: anElement)
		ifNotNil: [:attributeValidators |
			attributeValidators keysAndValuesDo: [:attribute :validator |
				(aDictionary includesKey: attribute)
					ifTrue: [
						"only initialize if needed, and as an OrderedCollection that
						is only converted to a Set later if needed, for permformance"
						(validatedAttributes
							ifNil: [
								validatedAttributes :=
									OrderedCollection new: totalUnvalidatedAttributes])
							addLast: attribute.
						totalUnvalidatedAttributes := totalUnvalidatedAttributes - 1].
				validator validateAttributes: aDictionary]].

	totalUnvalidatedAttributes > 0
		ifTrue: [
			self
				unvalidatedAttributes:
					(validatedAttributes
						ifNil: [aDictionary keys]
						ifNotNil: [| validatedAttributesSet |
							validatedAttributesSet := validatedAttributes asSet.
							aDictionary keys reject: [:each |
								validatedAttributesSet includes: each]])
				inElement: anElement].! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 03:39'!
validateComment: aString
	self hasCurrentElementValidator
		ifTrue: [self currentElementValidator validateComment: aString]! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 1/1/2015 21:28'!
validateEndDocument
	self validateIDReferences! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 03:40'!
validateEndTag: anElement
	self hasCurrentElementValidator
		ifTrue: [
			self currentElementValidator atEnd
				ifFalse: [self errorUnexpectEndOfElement: anElement].
			self elementValidatorStack removeLast]! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 1/1/2015 21:24'!
validateIDReferences
	self subclassResponsibility! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 03:39'!
validatePCData: aString
	self hasCurrentElementValidator
		ifTrue: [self currentElementValidator validatePCData: aString]! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 03:39'!
validatePI: aTargetString data: aDataString
	self hasCurrentElementValidator
		ifTrue: [
			self currentElementValidator
				validatePI: aTargetString
				data: aDataString]! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 09:21'!
validateRootElement: anElement! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 07:57'!
validateStartTag: anElement
	self currentElementValidator
		ifNotNil: [:elementValidator |
			elementValidator validateStartTag: anElement].

	self elementValidatorStack addLast:
		(self
			elementValidatorFor: anElement
			ifNone: [
				self
					unvalidatedElement: anElement;
					defaultElementValidatorFor: anElement]) asReadyElementValidator.! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 12/6/2016 08:43'!
validateStartTag: anElement attributes: aDictionary
	(self hasElementValidators
		or: [self hasAttributeValidators])
		ifTrue: [
			self validateStartTag: anElement.
			self
				validateAttributes: aDictionary
				withAttributeValidatorsFor: anElement]! !

!XMLDocumentValidator methodsFor: 'validating' stamp: 'monty 8/6/2016 20:07'!
validateXMLIDAttributeIn: aDictionary
	self hasAttributeValidators
		ifFalse: [self defaultXMLIDValidator validateAttributes: aDictionary]! !

Object subclass: #XMLElementClassMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLElementClassMapper commentStamp: 'monty 7/31/2016 12:18' prior: 0!
This is a base class for element class mappers. Subclasses need to implement the abstract methods to register and lookup classes mapped to element names, namespace URIs, and attributes.!

XMLElementClassMapper subclass: #XMLBasicElementClassMapper
	instanceVariableNames: 'elementClassMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLBasicElementClassMapper commentStamp: 'monty 8/12/2016 20:51' prior: 0!
This class can match elements to classes based on their names, namespace URIs, and attributes.

The precedence of mapping goes:
-Qualified name, namespace URI, and attributes
-Qualified name and namespace URI
-Qualified name and attributes
-Qualified name
-Non-qualified name, namespace URI, and attributes
-Non-qualified name and namespace URI
-Non-qualified name and attributes
-Non-qualified name!

!XMLBasicElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:50'!
classForElement: aQualifiedName attributes: anAssociationCollection ifNone: aBlock
	^ self
		classForElement: aQualifiedName
		namespaceURI: ''
		attributes: anAssociationCollection
		ifNone: aBlock! !

!XMLBasicElementClassMapper methodsFor: 'accessing' stamp: 'monty 7/13/2017 02:49'!
classForElement: aQualifiedName ifNone: aBlock
	^ self
		classForElement: aQualifiedName
		namespaceURI: ''
		attributes: XMLLazyAttributeDictionary  new
		ifNone: aBlock! !

!XMLBasicElementClassMapper methodsFor: 'accessing' stamp: 'monty 9/22/2017 10:09'!
classForElement: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection ifNone: aBlock
	| localName attributeDictionary |

	attributeDictionary := anAssociationCollection asXMLAttributeDictionary.
	aURI size > 0 "optimization"
		ifTrue: [
			(self
				elementClassMapAt: aQualifiedName -> aURI
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			(self
				elementClassMapAt: aQualifiedName
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			(localName := aQualifiedName xmlLocalNameAfterPrefix) size <
				aQualifiedName size
				ifTrue: [
					(self
						elementClassMapAt: localName -> aURI
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class].
					(self
						elementClassMapAt: localName
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class]]]
		ifFalse: [
			(self
				elementClassMapAt: aQualifiedName
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			(localName := aQualifiedName xmlLocalNameAfterPrefix) size <
				aQualifiedName size
				ifTrue: [
					(self
						elementClassMapAt: localName
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class]]].

	^ aBlock value.! !

!XMLBasicElementClassMapper methodsFor: 'accessing' stamp: 'monty 7/13/2017 02:49'!
classForElement: aQualifiedName namespaceURI: aURI ifNone: aBlock
	^ self
		classForElement: aQualifiedName
		namespaceURI: aURI
		attributes: XMLLazyAttributeDictionary new
		ifNone: aBlock! !

!XMLBasicElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:52'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection ifNone: aBlock
	| attributeDictionary |

	attributeDictionary := anAssociationCollection.
	aURI size > 0 "optimization"
		ifTrue: [
			(self
				elementClassMapAt: aQualifiedName -> aURI
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			(self
				elementClassMapAt: aQualifiedName
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			aLocalName size < aQualifiedName size
				ifTrue: [
					(self
						elementClassMapAt: aLocalName -> aURI
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class].
					(self
						elementClassMapAt: aLocalName
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class]]]
		ifFalse: [
			(self
				elementClassMapAt: aQualifiedName
				attributes: attributeDictionary)
				ifNotNil: [:class | ^ class].
			aLocalName size < aQualifiedName size
				ifTrue: [
					(self
						elementClassMapAt: aLocalName
						attributes: attributeDictionary)
						ifNotNil: [:class | ^ class]]].

	^ aBlock value.! !

!XMLBasicElementClassMapper methodsFor: 'private' stamp: 'monty 7/26/2016 07:21'!
elementClassMap
	^ elementClassMap! !

!XMLBasicElementClassMapper methodsFor: 'private' stamp: 'monty 6/30/2017 06:44'!
elementClassMapAt: aKey attributes: anAttributeDictionary
	| classOrCollection |

	classOrCollection :=
		elementClassMap
			at: aKey
			ifAbsent: [^ nil].

	classOrCollection isCollection
		ifTrue: [
			"to:do: for speed"
			1 to: classOrCollection size - 1 do: [:i |
				((classOrCollection at: i) key
					matchesAttributes: anAttributeDictionary)
					ifTrue: [^ (classOrCollection at: i) value]].
			^ classOrCollection last]
		ifFalse: [^ classOrCollection].! !

!XMLBasicElementClassMapper methodsFor: 'initialization' stamp: 'monty 7/26/2016 07:21'!
initialize
	super initialize.

	elementClassMap := Dictionary new.! !

!XMLBasicElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:25'!
mapElement: anElement attributeSpec: anAttributeSpec toClass: aClass
	| classOrCollection |

	classOrCollection :=
		elementClassMap
			at: anElement
			ifAbsent: [nil].

	classOrCollection isCollection
		ifTrue: [
			"new mappings have precedence over old"
			classOrCollection addFirst: anAttributeSpec -> aClass]
		ifFalse: [
			elementClassMap
				at: anElement
				put:
					(OrderedCollection
						with: anAttributeSpec -> aClass
						with: classOrCollection)].! !

!XMLBasicElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:25'!
mapElement: anElement namespaceURI: aURI attributeSpec: anAttributeSpec toClass: aClass
	self
		mapElement:
			(aURI size > 0
				ifTrue: [anElement -> aURI]
				ifFalse: [anElement])
		attributeSpec: anAttributeSpec
		toClass: aClass! !

!XMLBasicElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:25'!
mapElement: anElement namespaceURI: aURI toClass: aClass
	self
		mapElement:
			(aURI size > 0
				ifTrue: [anElement -> aURI]
				ifFalse: [anElement])
		toClass: aClass! !

!XMLBasicElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:26'!
mapElement: anElement toClass: aClass
	| classOrCollection |

	classOrCollection :=
		elementClassMap
			at: anElement
			ifAbsent: [nil].

	classOrCollection isCollection
		ifTrue: [
			classOrCollection
				at: classOrCollection size
				put: aClass]
		ifFalse: [
			elementClassMap
				at: anElement
				put: aClass].! !

!XMLBasicElementClassMapper methodsFor: 'copying' stamp: 'monty 8/14/2016 17:25'!
postCopy
	super postCopy.

	elementClassMap := elementClassMap copy.

	"each val is either a class or an OrderedCollection, which needs
	to be copied so new mappings in either the copy or original don't
	effect the other"
	elementClassMap associationsDo: [:each |
		each value isCollection
			ifTrue: [each value: each value copy]].! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 7/24/2016 12:28'!
camelCasedNameFromClassNameSegments: aNameSegmentCollection
	^ String streamContents: [:stream |
		aNameSegmentCollection withIndexDo: [:each :i |
			stream nextPutAll:
				(i > 1
					ifTrue: [each]
					ifFalse: [each asLowercase])]]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:32'!
classForElement: aQualifiedName
	^ self
		classForElement: aQualifiedName
		ifNone: [nil]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:48'!
classForElement: aQualifiedName attributes: anAssociationCollection
	^ self
		classForElement: aQualifiedName
		attributes: anAssociationCollection
		ifNone: [nil]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:47'!
classForElement: aQualifiedName attributes: anAssociationCollection ifNone: aBlock
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:32'!
classForElement: aQualifiedName ifNone: aBlock
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:32'!
classForElement: aQualifiedName namespaceURI: aURI
	^ self
		classForElement: aQualifiedName
		namespaceURI: aURI
		ifNone: [nil]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:48'!
classForElement: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection
	^ self
		classForElement: aQualifiedName
		namespaceURI: aURI
		attributes: anAssociationCollection
		ifNone: [nil]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:48'!
classForElement: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection ifNone: aBlock
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:32'!
classForElement: aQualifiedName namespaceURI: aURI ifNone: aBlock
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:48'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection
	^ self
		classForElement: aQualifiedName
		namespaceURI: aURI
		localName: aLocalName
		attributes: anAssociationCollection
		ifNone: [nil]! !

!XMLElementClassMapper methodsFor: 'accessing' stamp: 'monty 6/30/2017 22:48'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection ifNone: aBlock
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 8/26/2016 00:44'!
classNameFrom: aClass withoutIgnorableSuffixes: aSuffixCollection
	| className |

	className := aClass name asString.
	aSuffixCollection do: [:each |
		(className endsWith: each)
			ifTrue: [^ className allButLast: each size]].
	^ className.! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 7/27/2016 08:17'!
classNameSegmentsFrom: aString
	| nameSegments startIndex |

	nameSegments := OrderedCollection new.
	startIndex := 1.
	1 to: aString size do: [:i |
		(((aString at: i) isLowercase
			and: [aString size >= (i + 1)
				and: [(aString at: i + 1) isLowercase not]])
			or: [
				((aString at: i) isUppercase
					and: [aString size >= (i + 2)
						and: [(aString at: i + 1) isUppercase
							and: [(aString at: i + 2) isUppercase not]]])])
			ifTrue: [
				nameSegments addLast:
					(aString
						copyFrom: startIndex
						to: i).
				startIndex := i + 1]].

	startIndex <= aString size
		ifTrue: [
			nameSegments addLast:
				(aString
					copyFrom: startIndex
					to: aString size)].

	^ nameSegments.! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 7/24/2016 12:28'!
hyphenatedNameFromClassNameSegments: aNameSegmentCollection
	^ String streamContents: [:stream |
		aNameSegmentCollection
			do: [:each | stream nextPutAll: each asLowercase]
			separatedBy: [stream nextPut: $-]]! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/26/2016 02:19'!
mapAllMatchingElementsToClass: aClass ignoringSuffixes: aSuffixCollection
	| classNameWithoutSuffixes classNameSegments totalClassNameSegments |

	classNameWithoutSuffixes :=
		self
			classNameFrom: aClass
			withoutIgnorableSuffixes: aSuffixCollection.
	classNameSegments := self classNameSegmentsFrom: classNameWithoutSuffixes.
	(totalClassNameSegments := classNameSegments size) > 0
		ifFalse: [^ self].

	"remove the class prefix if any"
	totalClassNameSegments > 1
		ifTrue: [classNameSegments removeFirst].
	self
		mapElement:
			(self nameFromClassNameSegments: classNameSegments)
		toClass: aClass.
	self
		mapElement:
			(self camelCasedNameFromClassNameSegments: classNameSegments)
		toClass: aClass.
	self
		mapElement:
			(self hyphenatedNameFromClassNameSegments: classNameSegments)
		toClass: aClass.
	self
		mapElement:
			(self underscoredNameFromClassNameSegments: classNameSegments)
		toClass: aClass.! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/26/2016 00:46'!
mapAllMatchingElementsToClasses: aClassCollection ignoringSuffixes: aSuffixCollection
	aClassCollection do: [:each |
		self
			mapAllMatchingElementsToClass: each
			ignoringSuffixes: aSuffixCollection]! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 7/26/2016 08:30'!
mapElement: anElement attributeSpec: anAttributeSpec toClass: aClass
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 7/26/2016 08:30'!
mapElement: anElement namespaceURI: aURI attributeSpec: anAttributeSpec toClass: aClass
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 7/26/2016 06:20'!
mapElement: anElement namespaceURI: aURI toClass: aClass
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 7/26/2016 06:21'!
mapElement: anElement toClass: aClass
	self subclassResponsibility! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:25'!
mapElements: anElementCollection namespaceURI: aNamespaceURI toClass: aClass
	anElementCollection do: [:each |
		self
			mapElement: each
			namespaceURI: aNamespaceURI
			toClass: aClass]! !

!XMLElementClassMapper methodsFor: 'mapping' stamp: 'monty 8/15/2016 04:25'!
mapElements: anElementCollection toClass: aClass
	anElementCollection do: [:each |
		self
			mapElement: each
			toClass: aClass]! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 7/27/2016 08:10'!
nameFromClassNameSegments: aNameSegmentCollection
	"avoid join: for Squeak/GS portability"
	^ String streamContents: [:stream |
		aNameSegmentCollection do: [:each | stream nextPutAll: each]]! !

!XMLElementClassMapper methodsFor: 'private' stamp: 'monty 7/28/2016 06:40'!
underscoredNameFromClassNameSegments: aNameSegmentCollection
	^ String streamContents: [:stream |
		aNameSegmentCollection
			do: [:each | stream nextPutAll: each asLowercase]
			separatedBy: [stream nextPut: $_]]! !

Object subclass: #XMLElementIDValidator
	instanceVariableNames: 'elementsAndIdAttributes idReferences ids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLElementIDValidator commentStamp: 'monty 1/3/2015 04:41' prior: 0!
This class is shared by attribute validators to validate element IDs and ID references, including xml:id IDs.!

!XMLElementIDValidator methodsFor: 'accessing' stamp: 'monty 3/2/2015 12:53'!
elementsAndIDAttributes
	^ elementsAndIdAttributes ifNil: [elementsAndIdAttributes := Dictionary new]! !

!XMLElementIDValidator methodsFor: 'private' stamp: 'monty 3/22/2015 03:50'!
errorDuplicateID: anID inAttribute: anAttribute
	XMLValidationException
		formatSignal: 'Duplicate element ID "{1}" used in attribute "{2}"'
		with: anID
		with: anAttribute! !

!XMLElementIDValidator methodsFor: 'private' stamp: 'monty 3/22/2015 03:50'!
errorInvalidID: anID inAttribute: anAttribute
	XMLValidationException
		formatSignal: 'Invalid element ID value "{1}" in attribute "{2}"'
		with: anID
		with: anAttribute! !

!XMLElementIDValidator methodsFor: 'private' stamp: 'monty 1/1/2015 19:00'!
errorMultipleIDAttributesForElement: anElement
	XMLValidationException
		formatSignal: 'Element <{1}> has multiple ID attributes'
		with: anElement! !

!XMLElementIDValidator methodsFor: 'private' stamp: 'monty 3/22/2015 03:50'!
errorUnknownIDReference: anID
	XMLValidationException
		formatSignal: 'Reference to unknown element ID "{1}"'
		with: anID! !

!XMLElementIDValidator methodsFor: 'testing' stamp: 'monty 9/21/2016 13:48'!
hasIDReferences
	^ idReferences notNil
		and: [idReferences notEmpty]! !

!XMLElementIDValidator methodsFor: 'testing' stamp: 'monty 9/21/2016 13:47'!
hasIDs
	^ ids notNil
		and: [ids notEmpty]! !

!XMLElementIDValidator methodsFor: 'accessing' stamp: 'monty 1/3/2015 23:25'!
idReferences
	^ idReferences ifNil: [idReferences := Set new]! !

!XMLElementIDValidator methodsFor: 'accessing' stamp: 'monty 1/1/2015 18:54'!
ids
	^ ids ifNil: [ids := Set new]! !

!XMLElementIDValidator methodsFor: 'removing' stamp: 'monty 9/21/2016 13:54'!
removeIDReferences
	"Gemstone's Set does not understand removeAll, so nil reassignment
	is used instead (will be lazy initialized by accessors)"
	idReferences := nil! !

!XMLElementIDValidator methodsFor: 'removing' stamp: 'monty 9/21/2016 13:54'!
removeIDs
	"Gemstone's Set does not understand removeAll, so nil reassignment
	is used instead (will be lazy initialized by accessors)"
	ids := nil! !

!XMLElementIDValidator methodsFor: 'validating' stamp: 'monty 3/24/2016 20:55'!
validateID: anID inAttribute: anAttribute
	anID isXMLName
		ifFalse: [
			self
				errorInvalidID: anID
				inAttribute: anAttribute].
	self
		validateUniquenessOfID: anID
		inAttribute: anAttribute.! !

!XMLElementIDValidator methodsFor: 'validating' stamp: 'monty 3/2/2015 12:53'!
validateIDAttribute: anAttribute forElement: anElement
	| oldSize |

	"checking size after is faster than includes test"
	oldSize := self elementsAndIDAttributes size.
	(self elementsAndIDAttributes
		at: anElement
		put: anAttribute;
		size) > oldSize
		ifFalse: [self errorMultipleIDAttributesForElement: anElement].! !

!XMLElementIDValidator methodsFor: 'validating' stamp: 'monty 3/24/2016 20:55'!
validateIDReference: anID inAttribute: anAttribute
	anID isXMLName
		ifFalse: [
			self
				errorInvalidID: anID
				inAttribute: anAttribute].
	self idReferences add: anID.! !

!XMLElementIDValidator methodsFor: 'validating' stamp: 'monty 1/3/2015 23:24'!
validateIDReferences
	self idReferences do: [:each |
		(self ids includes: each)
			ifFalse: [self errorUnknownIDReference: each]]! !

!XMLElementIDValidator methodsFor: 'private' stamp: 'monty 3/22/2015 03:50'!
validateUniquenessOfID: anID inAttribute: anAttribute
	| oldSize |

	"checking size after is faster than includes test"
	oldSize := self ids size.
	(self ids
		add: anID;
		size) > oldSize
		ifFalse: [
			self
				errorDuplicateID: anID
				inAttribute: anAttribute].! !

!XMLElementIDValidator methodsFor: 'validating' stamp: 'monty 3/24/2016 20:56'!
validateXMLID: anID
	anID isXMLNCName
		ifFalse: [
			self
				errorInvalidID: anID
				inAttribute: 'xml:id'].
	self
		validateUniquenessOfID: anID
		inAttribute: 'xml:id'.! !

Object subclass: #XMLElementNester
	instanceVariableNames: 'openElements rootElement scopedAttributes hasExternalRootElement wasRootElementEnded isInElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLElementNester commentStamp: 'monty 10/31/2016 03:38' prior: 0!
This is a base class for element nesters that are used by parser tokenizers and drivers to keep track of which elements are open while parsing and ensure they are properly nested.!

!XMLElementNester methodsFor: 'private' stamp: 'monty 1/25/2014 21:08'!
copiedScopedAttributes
	| copiedAttributes |

	copiedAttributes :=
		self hasScopedAttributes
			ifTrue: [self scopedAttributes removeLast copy]
			ifFalse: [Dictionary new].
	self scopedAttributes addLast: copiedAttributes.

	^ copiedAttributes.! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
currentElement
	^ self openElements xmlLastOrNil! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 3/6/2017 11:13'!
currentElement: anElement
	self hasOpenElements
		ifTrue: [
			self openElements
				at: self totalOpenElements
				put: anElement]
		ifFalse: [self setExternalRootElement: anElement]! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
currentScopedAttributes
	^ self scopedAttributes xmlLastOrNil! !

!XMLElementNester methodsFor: 'private' stamp: 'monty 4/25/2015 15:07'!
elementPrintLimit
	^ 5! !

!XMLElementNester methodsFor: 'nesting' stamp: 'monty 4/17/2017 09:46'!
endCurrentElement
	(self openElements
		removeLast;
		size) > 0
		ifFalse: [
			isInElement := hasExternalRootElement.
			wasRootElementEnded := hasExternalRootElement not].
	self hasScopedAttributes
		ifTrue: [self endScopedAttributes].! !

!XMLElementNester methodsFor: 'private' stamp: 'monty 4/16/2015 01:07'!
endScopedAttributes
	scopedAttributes removeLast! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 11/3/2014 13:20'!
hasExternalRootElement
	^ hasExternalRootElement! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 8/6/2016 19:42'!
hasOpenElement: anElement
	^ self openElements includes: anElement! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 11/3/2014 13:18'!
hasOpenElements
	^ self openElements size > 0! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 3/23/2016 22:00'!
hasScopedAttributes
	"optimized to avoid lazy initialization"
	scopedAttributes == nil
		ifTrue: [^ false].
	^ scopedAttributes size > 0.! !

!XMLElementNester methodsFor: 'initialization' stamp: 'monty 12/5/2016 05:31'!
initialize
	super initialize.

	openElements := OrderedCollection new: 10.
	hasExternalRootElement := false.
	wasRootElementEnded := false.
	isInElement := false.! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 12/5/2016 05:32'!
isInElement
	^ isInElement! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 10/27/2014 09:07'!
openElements
	^ openElements! !

!XMLElementNester methodsFor: 'enumerating' stamp: 'monty 11/14/2015 19:53'!
openElementsDo: aBlock
	self openElements do: aBlock! !

!XMLElementNester methodsFor: 'enumerating' stamp: 'monty 5/20/2017 03:27'!
openElementsReverseDo: aBlock
	"implemented for XMLParserHTML so it's always safe to remove at
	the end while scanning backwards"
	self openElements size to: 1 by: -1 do: [:i |
			aBlock value: (self openElements at: i)]! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 8/6/2016 20:32'!
printElementsOn: aStream
	self
		printElementsStartingAt: 1
		on: aStream! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 8/6/2016 20:34'!
printElementsStartingAt: aStart on: aStream
	self
		printElementsStartingAt: aStart
		stoppingAt: aStart + self elementPrintLimit - 1
		on: aStream! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 8/6/2016 20:34'!
printElementsStartingAt: aStart stoppingAt: aStop on: aStream
	aStart
		to: (aStop min: self openElements size)
		do: [:i |
			i > aStart
				ifTrue: [aStream nextPutAll: ', '].

			aStream
				nextPut: $<;
				nextPutAll: (self openElements at: i);
				nextPut: $>].

	(aStop < self openElements size)
		ifTrue: [aStream nextPutAll: '...'].! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 8/6/2016 20:32'!
printOn: aStream
	super printOn: aStream.
	self hasOpenElements
		ifTrue: [
			aStream nextPut: $(.
			self
				printElementsStartingAt: 1
				on: aStream.
			aStream nextPut: $)].! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 4/22/2015 11:38'!
printedElements
	^ String streamContents: [:stream | self printElementsOn: stream]! !

!XMLElementNester methodsFor: 'printing' stamp: 'monty 8/6/2016 20:32'!
printedElementsEnclosedBy: anElement
	^ String streamContents: [:stream |
		self
			printElementsStartingAt: (self openElements lastIndexOf: anElement) + 1
			on: stream]! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 10/26/2016 19:13'!
rootElement
	^ rootElement! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 8/6/2016 19:42'!
scopedAttributeAt: anAttribute
	^ self
		scopedAttributeAt: anAttribute
		ifAbsent: ['']! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 8/6/2016 19:42'!
scopedAttributeAt: anAttribute ifAbsent: aBlock
	^ self currentScopedAttributes
		ifNil: [aBlock value]
		ifNotNil: [:attributes |
			attributes
				at: anAttribute
				ifAbsent: aBlock]! !

!XMLElementNester methodsFor: 'private' stamp: 'monty 1/20/2014 19:33'!
scopedAttributes
	^ scopedAttributes ifNil: [scopedAttributes := OrderedCollection new]! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 12/5/2016 05:33'!
setExternalRootElement: anElement
	rootElement := anElement.
	hasExternalRootElement := true.
	isInElement := true.! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 8/6/2016 19:43'!
setScopedAttributesNamed: anAttributeCollection from: aDictionary
	| attributes |

	anAttributeCollection do: [:each |
		aDictionary
			at: each
			ifPresent: [:value |
				"used to copy only once if needed"
				(attributes ifNil: [attributes := self copiedScopedAttributes])
					at: each
					put: value]]! !

!XMLElementNester methodsFor: 'nesting' stamp: 'monty 4/28/2017 21:23'!
startElement: anElement
	self openElements addLast: anElement.
	isInElement
		ifFalse: [
			isInElement := true.
			rootElement
				ifNil: [rootElement := anElement]].
	self hasScopedAttributes
		ifTrue: [self startScopedAttributes].! !

!XMLElementNester methodsFor: 'private' stamp: 'monty 4/16/2015 01:06'!
startScopedAttributes
	scopedAttributes addLast: self currentScopedAttributes! !

!XMLElementNester methodsFor: 'accessing' stamp: 'monty 10/25/2016 04:20'!
totalOpenElements
	^ self openElements size! !

!XMLElementNester methodsFor: 'testing' stamp: 'monty 12/5/2016 05:25'!
wasRootElementEnded
	^ wasRootElementEnded! !

Object subclass: #XMLElementValidator
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLElementValidator commentStamp: 'monty 4/21/2016 08:08' prior: 0!
This is a base class for element validators.!

XMLElementValidator subclass: #XMLAnyElementValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLAnyElementValidator commentStamp: '<historical>' prior: 0!
This class validates elements that can contain any content.!

!XMLAnyElementValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 04:42'!
atEnd
	^ true! !

!XMLAnyElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:35'!
isAny
	^ true! !

!XMLAnyElementValidator methodsFor: 'defaults' stamp: 'monty 11/28/2016 01:32'!
typeName
	^ 'ANY'! !

XMLElementValidator subclass: #XMLDFAElementValidator
	instanceVariableNames: 'dfa currentState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLDFAElementValidator commentStamp: 'monty 4/21/2016 08:11' prior: 0!
This class validates elements using a regular expression converted to a DFA. It ignores PCDATA, comments, and PIs.!

XMLDFAElementValidator subclass: #XMLDFAElementContentElementValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLDFAElementContentElementValidator commentStamp: 'monty 11/3/2016 06:13' prior: 0!
This class validates elements that can only contain element content (no PCDATA) using a regular expression converted to a DFA. It ignores comments, PIs, and whitespace.!

!XMLDFAElementContentElementValidator methodsFor: 'testing' stamp: 'monty 11/3/2016 06:09'!
ignoresWhitespace
	^ true! !

!XMLDFAElementContentElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:35'!
isElementContent
	^ true! !

!XMLDFAElementContentElementValidator methodsFor: 'defaults' stamp: 'monty 11/28/2016 01:32'!
typeName
	^ 'element content'! !

!XMLDFAElementContentElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:24'!
validatePCData: aString
	self errorUnexpectedPCData! !

XMLDFAElementContentElementValidator subclass: #XMLStandaloneExternalDFAElementContentElementValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-Standalone'!

!XMLStandaloneExternalDFAElementContentElementValidator commentStamp: 'monty 11/3/2016 12:30' prior: 0!
This class validates standalone externally defined elements with element content that cannot have whitespace between elements unlike the superclass.!

!XMLStandaloneExternalDFAElementContentElementValidator methodsFor: 'testing' stamp: 'monty 11/3/2016 06:09'!
ignoresWhitespace
	^ false! !

!XMLDFAElementValidator class methodsFor: 'instance creation' stamp: 'monty 4/13/2016 06:02'!
element: anElement dfa: aDFA
	^ self new
		setElement: anElement
		dfa: aDFA! !

!XMLDFAElementValidator methodsFor: 'converting' stamp: 'monty 12/6/2016 07:57'!
asReadyElementValidator
	^ self copy! !

!XMLDFAElementValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 05:43'!
atEnd
	^ currentState isAccepting! !

!XMLDFAElementValidator methodsFor: 'accessing' stamp: 'monty 4/22/2015 09:04'!
currentState
	^ currentState! !

!XMLDFAElementValidator methodsFor: 'accessing' stamp: 'monty 4/22/2015 09:04'!
dfa
	^ dfa! !

!XMLDFAElementValidator methodsFor: 'private' stamp: 'monty 4/13/2016 06:19'!
errorNonDeterminismInContentModelAfter: anElement
	XMLValidationException
		formatSignal:
			'Content model for <{1}> becomes non-deterministic after <{2}>. ',
			'Rewrite it deterministically; for example "{3}" instead ',
			'of "{4}"'
		with: self element
		with: anElement
		with: '(a,(b|c))'
		with: '((a,b)|(a,c))'! !

!XMLDFAElementValidator methodsFor: 'copying' stamp: 'monty 12/6/2016 02:57'!
postCopy
	currentState := dfa! !

!XMLDFAElementValidator methodsFor: 'initialization' stamp: 'monty 4/13/2016 06:02'!
setElement: anElement dfa: aDFA
	element := anElement.
	dfa := aDFA.
	currentState := aDFA.! !

!XMLDFAElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:02'!
validateStartTag: anElement
	currentState :=
		currentState
			nextDFAStateMatching: anElement
			ifNone: [self errorUnexpectedElement: anElement].
	currentState hasNonDeterminism
		ifTrue: [self errorNonDeterminismInContentModelAfter: anElement].! !

!XMLElementValidator class methodsFor: 'instance creation' stamp: 'monty 4/13/2016 05:59'!
element: anElement
	^ self new element: anElement! !

!XMLElementValidator methodsFor: 'converting' stamp: 'monty 12/6/2016 07:57'!
asReadyElementValidator
	^ self! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 04:41'!
atEnd
	self subclassResponsibility! !

!XMLElementValidator methodsFor: 'accessing' stamp: 'monty 12/7/2013 19:48'!
element
	^ element! !

!XMLElementValidator methodsFor: 'accessing' stamp: 'monty 4/13/2016 06:00'!
element: anElement
	element := anElement! !

!XMLElementValidator methodsFor: 'private' stamp: 'monty 11/28/2016 01:33'!
errorUnexpected: aDescription
	XMLValidationException
		formatSignal: 'Unexpected {1} in {2} type element <{3}>'
		with: aDescription
		with: self typeName
		with: self element! !

!XMLElementValidator methodsFor: 'private' stamp: 'monty 4/13/2016 06:23'!
errorUnexpectedComment
	^ self errorUnexpected: 'comment'! !

!XMLElementValidator methodsFor: 'private' stamp: 'monty 11/28/2016 01:33'!
errorUnexpectedElement: anElement
	XMLValidationException
		formatSignal: 'Unexpected <{1}> element in {2} type element <{3}>'
		with: anElement
		with: self typeName
		with: self element! !

!XMLElementValidator methodsFor: 'private' stamp: 'monty 4/13/2016 06:23'!
errorUnexpectedPCData
	^ self errorUnexpected: 'PCDATA'! !

!XMLElementValidator methodsFor: 'private' stamp: 'monty 4/13/2016 06:24'!
errorUnexpectedPI
	^ self errorUnexpected: 'processing instruction'! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/3/2016 06:09'!
ignoresWhitespace
	^ false! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:34'!
isAny
	^ false! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:34'!
isElementContent
	^ false! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:34'!
isEmpty
	^ false! !

!XMLElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:34'!
isMixedContent
	^ false! !

!XMLElementValidator methodsFor: 'printing' stamp: 'monty 4/24/2015 08:54'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(<';
		nextPutAll: self element;
		nextPutAll: '>)'.! !

!XMLElementValidator methodsFor: 'defaults' stamp: 'monty 11/28/2016 01:32'!
typeName
	self subclassResponsibility! !

!XMLElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 05:51'!
validateComment: aString! !

!XMLElementValidator methodsFor: 'validating' stamp: 'monty 11/11/2016 20:28'!
validateElementDeclaration! !

!XMLElementValidator methodsFor: 'validating' stamp: 'monty 11/18/2013 05:24'!
validatePCData: aString! !

!XMLElementValidator methodsFor: 'validating' stamp: 'monty 4/16/2016 13:44'!
validatePI: aTargetString data: aDataString! !

!XMLElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:00'!
validateStartTag: anElement! !

XMLElementValidator subclass: #XMLEmptyElementValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLEmptyElementValidator commentStamp: 'monty 4/13/2016 06:48' prior: 0!
This class validates EMPTY elements, which can't contain elements, PCDATA, or even comments or PIs.!

!XMLEmptyElementValidator methodsFor: 'testing' stamp: 'monty 11/18/2013 04:41'!
atEnd
	^ true! !

!XMLEmptyElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:35'!
isEmpty
	^ true! !

!XMLEmptyElementValidator methodsFor: 'defaults' stamp: 'monty 11/28/2016 01:32'!
typeName
	^ 'EMPTY'! !

!XMLEmptyElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:24'!
validateComment: aString
	self errorUnexpectedComment! !

!XMLEmptyElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:24'!
validatePCData: aString
	self errorUnexpectedPCData! !

!XMLEmptyElementValidator methodsFor: 'validating' stamp: 'monty 4/16/2016 13:44'!
validatePI: aTargetString data: aDataString
	self errorUnexpectedPI! !

!XMLEmptyElementValidator methodsFor: 'validating' stamp: 'monty 4/13/2016 06:25'!
validateStartTag: anElement
	self errorUnexpectedElement: anElement! !

XMLElementValidator subclass: #XMLMixedContentElementValidator
	instanceVariableNames: 'allowedContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLMixedContentElementValidator commentStamp: '<historical>' prior: 0!
This class validates elements that can contain a mix of PCDATA and certain elements.!

!XMLMixedContentElementValidator class methodsFor: 'instance creation' stamp: 'monty 11/12/2016 10:59'!
element: anElement allowedContent: anAllowedContentCollection
	^ self new
		setElement: anElement
		allowedContent: anAllowedContentCollection! !

!XMLMixedContentElementValidator methodsFor: 'accessing' stamp: 'monty 11/12/2016 10:59'!
allowedContent
	^ allowedContent! !

!XMLMixedContentElementValidator methodsFor: 'accessing' stamp: 'monty 11/12/2016 10:59'!
allowedContent: anAllowedContentCollection
	allowedContent := anAllowedContentCollection! !

!XMLMixedContentElementValidator methodsFor: 'testing' stamp: 'monty 11/19/2013 01:14'!
atEnd
	^ true! !

!XMLMixedContentElementValidator methodsFor: 'private' stamp: 'monty 11/12/2016 21:06'!
errorContentContainsDuplicates
	XMLValidationException
		formatSignal:
			'Declaration for mixed content element <{1}> contains duplicate names'
		with: self element! !

!XMLMixedContentElementValidator methodsFor: 'testing' stamp: 'monty 11/28/2016 01:35'!
isMixedContent
	^ true! !

!XMLMixedContentElementValidator methodsFor: 'initialization' stamp: 'monty 11/12/2016 21:05'!
setElement: anElement allowedContent: anAllowedContentCollection
	element := anElement.
	allowedContent := anAllowedContentCollection.! !

!XMLMixedContentElementValidator methodsFor: 'defaults' stamp: 'monty 11/28/2016 01:32'!
typeName
	^ 'mixed content'! !

!XMLMixedContentElementValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 11:04'!
validateElementDeclaration
	| oldAllowedContentCollection |

	oldAllowedContentCollection := self allowedContent.
	self allowedContent: oldAllowedContentCollection asSet.
	(self allowedContent size < oldAllowedContentCollection size)
		ifTrue: [self errorContentContainsDuplicates].! !

!XMLMixedContentElementValidator methodsFor: 'validating' stamp: 'monty 11/12/2016 10:59'!
validateStartTag: anElement
	(self allowedContent includes: anElement)
		ifFalse: [self errorUnexpectedElement: anElement]
	! !

Object subclass: #XMLEncodingDetector
	instanceVariableNames: 'stream startPosition'
	classVariableNames: 'UTF16BigEndianBOMBytes UTF32BigEndianBOMBytes UTF32LittleEndianBOMBytes UTF8BOMBytes'
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLEncodingDetector commentStamp: 'monty 11/3/2017 05:52' prior: 0!
This is a class for automatic encoding detection of streams that infers encodings from byte order marks (BOM).!

!XMLEncodingDetector class methodsFor: 'class initialization' stamp: 'monty 2/4/2018 05:39'!
initialize
	"self initialize"

	"stored in class vars for faster access"
	UTF8BOMBytes :=
		XMLUTF8StreamConverter byteOrderMarkBytes.
	UTF16BigEndianBOMBytes :=
		XMLUTF16BigEndianStreamConverter byteOrderMarkBytes.
	UTF32BigEndianBOMBytes :=
		XMLUTF32BigEndianStreamConverter byteOrderMarkBytes.
	UTF32LittleEndianBOMBytes :=
		XMLUTF32LittleEndianStreamConverter byteOrderMarkBytes.! !

XMLEncodingDetector initialize!

!XMLEncodingDetector class methodsFor: 'instance creation' stamp: 'monty 3/8/2016 13:11'!
on: aStream
	^ self new on: aStream! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/9/2016 06:20'!
atEnd
	^ stream atEnd! !

!XMLEncodingDetector methodsFor: 'testing' stamp: 'monty 11/2/2017 12:34'!
detectsImplicitEncodings
	^ false! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 1/23/2018 07:04'!
handleImplicitLittleEndianEncoding
	| implicitConverterClass |

	self detectsImplicitEncodings
		ifTrue: [
			implicitConverterClass :=
				self peekForNull
					ifTrue: [		
						(self peekForNull
							and: [self peekForNull])
							ifTrue: [
								"a leading ASCII char followed by three nulls;
								implicit little endian UTF-32"
								XMLImplicitUTF32LittleEndianStreamConverter]
							ifFalse: [
								"a leading ASCII char followed by just one null;
								implicit little endian UTF-16"
								XMLImplicitUTF16LittleEndianStreamConverter]]
					ifFalse: [
						"an ASCII char; assume it's UTF-8"
						XMLImplicitUTF8StreamConverter]].

	self resetStreamToStartPosition.
	^ implicitConverterClass
		ifNotNil: [implicitConverterClass new].! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:59'!
handleUTF16BigEndianBOM
	2 to: UTF16BigEndianBOMBytes size do: [:i |
		self next == (UTF16BigEndianBOMBytes at: i)
			ifFalse: [
				self resetStreamToStartPosition.
				"no legal UTF-8 byte sequence begins with 16rFE, and:
					UTF16BigEndianBOMBytes first = 16rFE
				so it can't be implicit UTF-8"
				^ nil]].
	^ XMLUTF16BigEndianStreamConverter new.! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:48'!
handleUTF32BigEndianBOMOrImplicitEncoding
	2 to: UTF32BigEndianBOMBytes size do: [:i |
		self peek == (UTF32BigEndianBOMBytes at: i)
			ifTrue: [self next]
			ifFalse: [| implicitConverterClass |
				self detectsImplicitEncodings
					ifTrue: [
						i = 2
							ifTrue: [
								"(UTF32BigEndianBOMBytes at: 1) isZero"
								self peekForASCII
									ifTrue: [
										"null char followed by an ASCII char;
										implicit UTF-16 BE"
										implicitConverterClass :=
											XMLImplicitUTF16BigEndianStreamConverter]]
							ifFalse: [
								i = 3
									ifTrue: [
										"(UTF32BigEndianBOMBytes at: 2) isZero"
										(self peekForNull
											and: [self peekForASCII]) 
											ifTrue: [
												"three null chars followed by an ASCII char;
												implicit UTF-32 BE"
												implicitConverterClass :=
													XMLImplicitUTF32BigEndianStreamConverter]]].
						(implicitConverterClass isNil
							and: [self peekForUTF8LeadingByte])
							ifTrue: [
								"any number of null chars followed by a leading UTF-8
								byte char; implicit UTF-8"
								implicitConverterClass :=
									XMLImplicitUTF8StreamConverter]].
				self resetStreamToStartPosition.
				^ implicitConverterClass
					ifNotNil: [implicitConverterClass new]]].
	^ XMLUTF32BigEndianStreamConverter new.! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/7/2018 06:04'!
handleUTF32OrUTF16LittleEndianBOM
	2 to: UTF32LittleEndianBOMBytes size do: [:i |
		self peek == (UTF32LittleEndianBOMBytes at: i)
			ifTrue: [self next]
			ifFalse: [
				i > 2
					ifTrue: [
						"the 2 byte UTF-16 BOM begins the 4 byte UTF-32 BOM:
							UTF32LittleEndianBOMBytes beginsWith:
								XMLUTF16LittleEndianStreamConverter byteOrderMarkBytes"
						stream position: startPosition + 2.
						^ XMLUTF16LittleEndianStreamConverter new]
					ifFalse: [
						self resetStreamToStartPosition.
						"no legal UTF-8 byte sequence begins with 16rFF, and:
							UTF32LittleEndianBOMBytes first = 16rFF
						so it can't be implicit UTF-8"
						^ nil]]].
	^ XMLUTF32LittleEndianStreamConverter new.! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:56'!
handleUTF8BOM
	2 to: UTF8BOMBytes size do: [:i |
		self peek == (UTF8BOMBytes at: i)
			ifTrue: [self next]
			ifFalse: [| implicitConverter |
				(self detectsImplicitEncodings
					and: [self peekForUTF8NonLeadingByte])
					ifTrue: [implicitConverter := XMLImplicitUTF8StreamConverter new].
				self resetStreamToStartPosition.
				^ implicitConverter]].
	^ XMLUTF8StreamConverter new.! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:51'!
isUTF8LeadingByte: aByte
	^ aByte < 16r80
		or: [aByte < 16rF8
			and: [(aByte bitAnd: 16rE0) = 16rC0
				or: [(aByte bitAnd: 16rF0) = 16rE0
					or: [(aByte bitAnd: 16rF8) = 16rF0]]]]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:54'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next asInteger]! !

!XMLEncodingDetector methodsFor: 'initialization' stamp: 'monty 2/2/2018 23:01'!
on: aStream
	stream := aStream.
	startPosition := aStream position.! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:54'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek asInteger]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/6/2018 05:40'!
peekForASCII
	| byte |

	((byte := self peek) notNil
		and: [byte < 128])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/2/2018 22:49'!
peekForNull
	self peek == 0
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/6/2018 05:40'!
peekForUTF8LeadingByte
	| byte |

	((byte := self peek) notNil
		and: [self isUTF8LeadingByte: byte])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 2/6/2018 05:40'!
peekForUTF8NonLeadingByte
	| byte |

	((byte := self peek) notNil
		and: [byte < 16rC0
			and: [byte > 16r80]])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLEncodingDetector methodsFor: 'private' stamp: 'monty 11/17/2016 20:52'!
resetStreamToStartPosition
	stream position: startPosition! !

!XMLEncodingDetector methodsFor: 'detecting' stamp: 'monty 2/7/2018 06:06'!
streamConverterForEncoding
	| byte |

	(byte := self next)
		ifNil: [^ nil].

	byte == 0
		ifTrue: [^ self handleUTF32BigEndianBOMOrImplicitEncoding].

	byte < 128
		ifTrue: [^ self handleImplicitLittleEndianEncoding].

	"(UTF8BOMBytes at: 1) >= 128"
	byte == (UTF8BOMBytes at: 1)
		ifTrue: [^ self handleUTF8BOM].

	"(UTF16BigEndianBOMBytes at: 1) >= 128"
	byte == (UTF16BigEndianBOMBytes at: 1)
		ifTrue: [^ self handleUTF16BigEndianBOM].

	"(UTF32LittleEndianBOMBytes at: 1) >= 128"
	byte == (UTF32LittleEndianBOMBytes at: 1)
		ifTrue: [^ self handleUTF32OrUTF16LittleEndianBOM].

	self resetStreamToStartPosition.
	^ (self detectsImplicitEncodings
		and: [self isUTF8LeadingByte: byte])
		ifTrue: [XMLImplicitUTF8StreamConverter new]
		ifFalse: [nil].! !

XMLEncodingDetector subclass: #XMLImplicitEncodingDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitEncodingDetector commentStamp: 'monty 2/10/2018 22:53' prior: 0!
This is a class for automatic encoding detection of streams that infers encodings from byte order marks (BOM) or implicit encodings from a sequence of one or more null bytes before or after the first ASCII character.

(It actually implements the YAML implicit encoding detection algorithm, looking for any leading ASCII char, not just '<', before or after a null byte sequence. This algorithm is more general than the XML one, supporting non-XML text, and since the XML one is in a "(Non-Normative)" section of the spec, we don't actually have to implement it.)!

!XMLImplicitEncodingDetector methodsFor: 'testing' stamp: 'monty 11/3/2017 05:52'!
detectsImplicitEncodings
	^ true! !

Object subclass: #XMLHTTPDecompressingReadStreamAdapterFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPDecompressingReadStreamAdapterFactory commentStamp: 'monty 1/24/2018 02:20' prior: 0!
This class is a read stream adapter factory for decoding content compressed with compression schemes like GZip and DEFLATE.!

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'basic' stamp: 'monty 1/14/2018 20:58'!
basicCanDecompressCompression: aCompressionScheme
	^ self compressionScheme = aCompressionScheme
		and: [self isSupportedImplementation]! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'testing' stamp: 'monty 1/14/2018 20:58'!
canDecompressCompression: aCompressionScheme
	^ self basicCanDecompressCompression: aCompressionScheme asLowercase! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 2/5/2018 23:39'!
classForCompression: aCompressionScheme
	| lowercaseCompressionScheme |

	lowercaseCompressionScheme := aCompressionScheme asLowercase.
	self allSubclassesDo: [:each |
		(each basicCanDecompressCompression: lowercaseCompressionScheme)
			ifTrue: [^ each]].
	^ nil.! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:22'!
compressionScheme
	self subclassResponsibility! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 2/6/2018 03:43'!
decompressingReadStreamAdapterClass
	self subclassResponsibility! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'private ' stamp: 'monty 12/19/2017 11:50'!
errorUnsupportedCompression: aCompressionScheme
	XMLHTTPException
		formatSignal: 'Unsupported compression scheme "{1}" for HTTP content'
		with: aCompressionScheme! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'testing' stamp: 'monty 2/6/2018 03:43'!
isSupportedImplementation
	^ self decompressingReadStreamAdapterClass notNil! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'instance creation' stamp: 'monty 2/6/2018 03:43'!
on: aReadStream
	^ self decompressingReadStreamAdapterClass on: aReadStream! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'instance creation' stamp: 'monty 2/5/2018 23:41'!
on: aReadStream compression: aCompressionScheme
	^ (self classForCompression: aCompressionScheme)
		ifNil: [self errorUnsupportedCompression: aCompressionScheme]
		ifNotNil: [:classForCompression |
			classForCompression on: aReadStream]! !

!XMLHTTPDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 12/24/2017 09:06'!
supportedCompressionSchemes
	| supportedCompressionSchemes |

	supportedCompressionSchemes := OrderedCollection new.
	self allSubclassesDo: [:each |
		each isSupportedImplementation
			ifTrue: [supportedCompressionSchemes addLast: each compressionScheme]].
	^ supportedCompressionSchemes.! !

XMLHTTPDecompressingReadStreamAdapterFactory subclass: #XMLHTTPGZipDecompressingReadStreamAdapterFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPGZipDecompressingReadStreamAdapterFactory commentStamp: 'monty 2/5/2018 23:40' prior: 0!
A read stram adapter factory for the GZip compression scheme. Uses GZipReadStream if available.!

!XMLHTTPGZipDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 12/24/2017 04:21'!
compressionScheme
	^ 'gzip'! !

!XMLHTTPGZipDecompressingReadStreamAdapterFactory class methodsFor: 'accessing' stamp: 'monty 2/6/2018 03:43'!
decompressingReadStreamAdapterClass
	^ XMLClassFinder classNamed: #GZipReadStream! !

Object subclass: #XMLHTTPMIMEType
	instanceVariableNames: 'mainType subType parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPMIMEType commentStamp: 'monty 11/13/2017 13:03' prior: 0!
This is an immutable class for HTTP MIME types. Adapted from ZnMimeType.!

!XMLHTTPMIMEType class methodsFor: 'defaults' stamp: 'monty 12/30/2017 14:31'!
defaultCharset
	^ 'ISO-8859-1'! !

!XMLHTTPMIMEType class methodsFor: 'instance creation' stamp: 'monty 1/22/2018 04:07'!
fromString: aString
	| parser mainType subType parameters |

	parser := XMLHTTPMIMETypeParser on: aString.
	mainType := parser parseMainType.
	subType := parser parseSubType.
	parameters := parser parseParameters.
	^ self new
		setMainType: mainType
		subType: subType
		parameters: parameters.! !

!XMLHTTPMIMEType class methodsFor: 'instance creation' stamp: 'monty 11/9/2017 14:04'!
mainType: aMainType subType: aSubType
	^ self
		mainType: aMainType
		subType: aSubType
		parameters: #()! !

!XMLHTTPMIMEType class methodsFor: 'instance creation' stamp: 'monty 1/23/2018 19:42'!
mainType: aMainType subType: aSubType parameters: anAssociationCollection
	| parameters attributes totalAttributes |

	"convert the parameters to an OrderedCollection of attribute=value
	associations, ignoring duplicate attributes"
	parameters := OrderedCollection new: anAssociationCollection size.
	totalAttributes := 0.
	anAssociationCollection associationsDo: [:each | | attribute |
		attribute := each key asLowercase.
		"only initialize if needed"
		((attributes ifNil: [attributes := Set new])
			add: attribute;
			size) > totalAttributes
			ifTrue: [
				parameters addLast: attribute -> each value.
				totalAttributes := totalAttributes + 1]].

	^ self new
		setMainType: aMainType asLowercase
		subType: aSubType asLowercase
		parameters: parameters.! !

!XMLHTTPMIMEType methodsFor: 'comparing' stamp: 'monty 2/5/2018 19:16'!
= anObject
	self == anObject
		ifTrue: [^ true].

	self species == anObject species
		ifFalse: [^ false].

	^ self mainType = anObject mainType
		and: [self subType = anObject subType
			and: [self parameters size = anObject parameters size
				and: [
					"order is irrelevant according to the spec"
					self parameters asSet = anObject parameters asSet]]].! !

!XMLHTTPMIMEType methodsFor: 'converting' stamp: 'monty 12/25/2017 06:59'!
asString
	"for compatibility with GS where Object>>#asString isn't defined"
	^ self printString! !

!XMLHTTPMIMEType methodsFor: 'accessing' stamp: 'monty 12/30/2017 14:31'!
charset
	^ self
		parameterAt: 'charset'
		ifAbsent: [self defaultCharset]! !

!XMLHTTPMIMEType methodsFor: 'defaults' stamp: 'monty 12/30/2017 14:31'!
defaultCharset
	^ self class defaultCharset! !

!XMLHTTPMIMEType methodsFor: 'comparing' stamp: 'monty 1/24/2018 02:02'!
hash
	^ self species hash bitXor:
		(self mainType hash bitXor:
			(self subType hash bitXor:
				"OrderedCollection>>#hash depends on order (and even if it
				didn't, assuming it wouldn't in the future is too risky),
				so instead the size is hashed"
				self parameters size hash))! !

!XMLHTTPMIMEType methodsFor: 'accessing' stamp: 'monty 11/13/2017 00:17'!
mainType
	^ mainType! !

!XMLHTTPMIMEType methodsFor: 'accessing' stamp: 'monty 11/9/2017 16:01'!
parameterAt: aKey
	^ self
		parameterAt: aKey
		ifAbsent: ['']! !

!XMLHTTPMIMEType methodsFor: 'accessing' stamp: 'monty 11/9/2017 16:02'!
parameterAt: aKey ifAbsent: aBlock
	self parameterKeysAndValuesDo: [:key :value |
		key = aKey
			ifTrue: [^ value]].
	^ aBlock value.! !

!XMLHTTPMIMEType methodsFor: 'enumerating' stamp: 'monty 11/13/2017 00:17'!
parameterKeysAndValuesDo: aTwoArgumentBlock
	self parameters do: [:each |
		aTwoArgumentBlock
			value: each key
			value: each value]! !

!XMLHTTPMIMEType methodsFor: 'enumerating' stamp: 'monty 11/13/2017 00:17'!
parameterKeysDo: aBlock
	self parameters do: [:each |
		aBlock value: each key]! !

!XMLHTTPMIMEType methodsFor: 'private' stamp: 'monty 11/13/2017 00:17'!
parameters
	^ parameters! !

!XMLHTTPMIMEType methodsFor: 'printing' stamp: 'monty 1/23/2018 17:51'!
printOn: aStream
	aStream
		nextPutAll: self mainType;
		nextPut: $/;
		nextPutAll: self subType.

	self parameterKeysAndValuesDo: [:key :value |
		aStream
			nextPutAll: '; ';
			nextPutAll: key;
			nextPut: $=;
			nextPutAll: value].! !

!XMLHTTPMIMEType methodsFor: 'initialization' stamp: 'monty 1/23/2018 19:43'!
setMainType: aMainType subType: aSubType parameters: aParameterCollection
	mainType := aMainType.
	subType := aSubType.
	parameters := aParameterCollection.! !

!XMLHTTPMIMEType methodsFor: 'accessing' stamp: 'monty 11/13/2017 00:17'!
subType
	^ subType! !

Object subclass: #XMLHTTPResponseContentReader
	instanceVariableNames: 'response rawContent contentReadStream limitedContentReadStream isDecompressing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPResponseContentReader commentStamp: 'monty 1/24/2018 23:57' prior: 0!
This is an abstract base class for response content readers. The #readUpToLimit:decoding: message returns the entire  decoded (if enabled) response content, raising an XMLLimitException if it exceeds the specified limit.

Subclasses need to implement #rawReadWithLength:upToLimit: to read and return the raw response content and signal an error if it exceeds the limit.!

!XMLHTTPResponseContentReader class methodsFor: 'accessing' stamp: 'monty 1/4/2018 18:28'!
response: aResponse
	^ self new setResponse: aResponse! !

!XMLHTTPResponseContentReader methodsFor: 'private' stamp: 'monty 1/12/2018 12:12'!
contentReadStreamUpToEnd
	| contentWriteStream |

	contentWriteStream := self newContentWriteStream.
	[contentReadStream atEnd]
		whileFalse: [contentWriteStream nextPut: contentReadStream next].
	^ contentWriteStream contents.! !

!XMLHTTPResponseContentReader methodsFor: 'private' stamp: 'monty 1/12/2018 19:12'!
decodedContentReadStreamUpToEndWithCharset: aCharset
	| streamConverter |

	(streamConverter := aCharset asXMLStreamConverter) isNull
		ifTrue: [self errorUnrecognizedContentTypeCharset: aCharset].

	contentReadStream :=
		XMLDecodingReadStreamAdapter
			on: contentReadStream
			streamConverter: streamConverter.

	[^ self contentReadStreamUpToEnd]
		on: XMLEncodingException
		do: [:error |
			"might actually be a limit exception"
			self ensureContentReadStreamWasNotLimited.

			error pass].! !

!XMLHTTPResponseContentReader methodsFor: 'private' stamp: 'monty 1/12/2018 19:12'!
ensureContentReadStreamWasNotLimited
	(limitedContentReadStream notNil
		and: [limitedContentReadStream atLimitedEnd])
		ifTrue: [self errorContentLimitExceeded]! !

!XMLHTTPResponseContentReader methodsFor: 'private' stamp: 'monty 1/7/2018 19:52'!
errorContentLimitExceeded
	XMLLimitException signal: 'HTTP reponse content limit exceeded'! !

!XMLHTTPResponseContentReader methodsFor: 'private' stamp: 'monty 1/6/2018 17:15'!
errorUnrecognizedContentTypeCharset: aCharset
	XMLEncodingException
		formatSignal:
			'Unrecognized Content-Type charset "{1}" encoding for HTTP content'
		with: aCharset! !

!XMLHTTPResponseContentReader methodsFor: 'testing' stamp: 'monty 2/5/2018 23:31'!
handlesDecompression
	^ false! !

!XMLHTTPResponseContentReader methodsFor: 'initialization' stamp: 'monty 2/7/2018 06:11'!
initializeDecompressionWithSchemes: aCompressionSchemeSequence upToLimit: aMaxSize
	isDecompressing := true.
	aCompressionSchemeSequence reverseDo: [:each |
		contentReadStream :=
			XMLHTTPDecompressingReadStreamAdapterFactory
				on: contentReadStream
				compression: each].
	aMaxSize
		ifNotNil: [self limitContentReadStreamUpToLimit: aMaxSize].! !

!XMLHTTPResponseContentReader methodsFor: 'accessing' stamp: 'monty 1/24/2018 01:45'!
limitContentReadStreamUpToLimit: aMaxSize
	limitedContentReadStream :=
		XMLLimitedReadStreamAdapter
			on: contentReadStream
			limit: aMaxSize.
	contentReadStream := limitedContentReadStream.! !

!XMLHTTPResponseContentReader methodsFor: 'instance creation' stamp: 'monty 1/11/2018 21:15'!
newContentWriteStream
	^ (String new: rawContent size) writeStream! !

!XMLHTTPResponseContentReader methodsFor: 'reading' stamp: 'monty 1/11/2018 23:58'!
rawReadWithLength: aContentLength upToLimit: aMaxSize
	self subclassResponsibility! !

!XMLHTTPResponseContentReader methodsFor: 'reading' stamp: 'monty 2/5/2018 23:33'!
readUpToLimit: aMaxSize decoding: aBoolean
	| contentLength contentType compressionSchemes charset content |

	contentLength := response contentLength.
	(response isChunked
		or: [contentLength isNil])
		ifTrue: [contentLength := nil]
		ifFalse: [
			contentLength > 0
				ifFalse: [^ ''].
			(aMaxSize notNil
				and: [contentLength > aMaxSize])
				ifTrue: [self errorContentLimitExceeded]].
	rawContent :=
		self
			rawReadWithLength: contentLength
			upToLimit: aMaxSize.
	contentReadStream := rawContent readStream.

	(self handlesDecompression
		and: [(compressionSchemes := response contentEncoding) notEmpty])
		ifTrue: [
			self
				initializeDecompressionWithSchemes: compressionSchemes
				upToLimit: aMaxSize].

	(aBoolean
		and: [(contentType := response contentType) notNil
			and: [(charset := contentType charset) ~= contentType defaultCharset]])
		ifTrue: [
			content := self decodedContentReadStreamUpToEndWithCharset: charset]
		ifFalse: [
			content := self undecodedContentReadStreamUpToEnd].

	self ensureContentReadStreamWasNotLimited.
	^ content.! !

!XMLHTTPResponseContentReader methodsFor: 'initialization' stamp: 'monty 1/12/2018 19:11'!
setResponse: aResponse
	response := aResponse.
	isDecompressing := false.! !

!XMLHTTPResponseContentReader methodsFor: 'streaming' stamp: 'monty 1/12/2018 12:12'!
undecodedContentReadStreamUpToEnd
	^ (isDecompressing
		or: [limitedContentReadStream notNil])
		ifTrue: [self contentReadStreamUpToEnd]
		ifFalse: [rawContent]! !

XMLHTTPResponseContentReader subclass: #XMLHTTPWebClientResponseContentReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPWebClientResponseContentReader commentStamp: 'monty 1/12/2018 19:19' prior: 0!
A WebClient content reader.!

!XMLHTTPWebClientResponseContentReader methodsFor: 'testing' stamp: 'monty 2/5/2018 23:31'!
handlesDecompression
	^ true! !

!XMLHTTPWebClientResponseContentReader methodsFor: 'reading' stamp: 'monty 2/5/2018 00:38'!
rawReadWithLength: aContentLength upToLimit: aMaxSize
	| socketStream rawContentWriteStream |

	(socketStream := response webClientResponse stream) binary.
	rawContentWriteStream :=
		(ByteArray new:
			(aContentLength
				ifNil: [aMaxSize
					ifNil: [1024]])) writeStream.
	response webClientResponse
		streamFrom: socketStream
		to: rawContentWriteStream
		size: aContentLength
		progress:
			((aContentLength isNil
				and: [aMaxSize notNil])
				ifTrue: [
					[:ignored :total |
						total > aMaxSize
							ifTrue: [self errorContentLimitExceeded]]]
				ifFalse: [nil]).
	^ rawContentWriteStream contents.! !

XMLHTTPResponseContentReader subclass: #XMLHTTPZincResponseContentReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-HTTP'!

!XMLHTTPZincResponseContentReader commentStamp: 'monty 1/24/2018 02:22' prior: 0!
A Zinc content reader. Zinc handles decompression automatically, so this class doesn't.!

!XMLHTTPZincResponseContentReader methodsFor: 'reading' stamp: 'monty 2/5/2018 00:38'!
rawReadWithLength: aContentLength upToLimit: aMaxSize
	^ [| entityStream |
		entityStream := response zincResponse entity stream.
		(entityStream respondsTo: #binary)
			ifTrue: [entityStream binary].
		(ZnUtils
			readUpToEnd: entityStream
			limit: aMaxSize) asByteArray]
		on: ZnEntityTooLarge
		do: [:error | self errorContentLimitExceeded]! !

Object subclass: #XMLIntegerReader
	instanceVariableNames: 'readStream printStream'
	classVariableNames: 'CharacterDigitValues'
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLIntegerReader commentStamp: 'monty 12/16/2017 10:12' prior: 0!
This class reads positive hex or decimal integers from minimal streams supporting #next, #peek, and #atEnd. It returns nil instead of raising errors for invalid integers.!

!XMLIntegerReader class methodsFor: 'class initialization' stamp: 'monty 12/16/2017 09:59'!
initialize
	"self initialize"

	self initializeCharacterDigitValues! !

XMLIntegerReader initialize!

!XMLIntegerReader class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 16:03'!
initializeCharacterDigitValues
	| temp |

	"use an array instead of a dictionary for speed, and use a temp
	to fully initialize it before assignment to avoid possible race
	conditions during class reinitialization"
	temp := Array new: 255.
	#(#($0 $9 0) #($a $f 10) #($A $Z 10)) do: [:each |
		| firstDigitValue lastDigitValue baseValue |
		firstDigitValue := each first asciiValue.
		lastDigitValue := each second asciiValue.
		baseValue := each third.
		firstDigitValue
			to: lastDigitValue
			do: [:i |
				temp
					at: i
					put: i - firstDigitValue + baseValue]].
	CharacterDigitValues := temp.! !

!XMLIntegerReader class methodsFor: 'defaults' stamp: 'monty 10/24/2014 20:28'!
maxBase
	^ 16! !

!XMLIntegerReader class methodsFor: 'defaults' stamp: 'monty 12/16/2017 09:59'!
maxIntegerValue
	^ nil! !

!XMLIntegerReader class methodsFor: 'instance creation' stamp: 'monty 1/6/2016 07:49'!
on: aStringOrStream
	^ self new on: aStringOrStream! !

!XMLIntegerReader class methodsFor: 'instance creation' stamp: 'monty 10/27/2014 08:36'!
readFrom: aStream
	^ (self on: aStream) nextInteger! !

!XMLIntegerReader class methodsFor: 'reading' stamp: 'monty 10/27/2014 08:37'!
readFrom: aStream withBase: aBase
	^ (self on: aStream) nextIntegerWithBase: aBase! !

!XMLIntegerReader class methodsFor: 'reading' stamp: 'monty 9/29/2017 17:37'!
readFrom: aStream withBase: aFirstBase andPrefixes: aCharacterCollection orBase: aSecondBase
	^ (self on: aStream)
		nextIntegerWithBase: aFirstBase
		andPrefixes: aCharacterCollection
		orBase: aSecondBase! !

!XMLIntegerReader class methodsFor: 'reading' stamp: 'monty 1/15/2018 01:01'!
readFrom: aStream withBase: aFirstBase andPrefixes: aCharacterCollection orBase: aSecondBase upToLimit: aReadLimit
	^ (self on: aStream)
		nextIntegerWithBase: aFirstBase
		andPrefixes: aCharacterCollection
		orBase: aSecondBase
		upToLimit: aReadLimit! !

!XMLIntegerReader class methodsFor: 'reading' stamp: 'monty 1/15/2018 01:01'!
readFrom: aStream withBase: aBase upToLimit: aReadLimit
	^ (self on: aStream)
		nextIntegerWithBase: aBase
		upToLimit: aReadLimit! !

!XMLIntegerReader methodsFor: 'testing' stamp: 'monty 12/2/2015 20:03'!
atEnd
	^ readStream atEnd! !

!XMLIntegerReader methodsFor: 'private' stamp: 'monty 9/23/2016 23:06'!
errorUnsupportedBase: aBase
	Error signal: 'Unsupported base ', aBase printString! !

!XMLIntegerReader methodsFor: 'private' stamp: 'monty 1/15/2018 02:26'!
integerOverflow: aMaxValue
	^ aMaxValue! !

!XMLIntegerReader methodsFor: 'private' stamp: 'monty 1/3/2016 21:13'!
next
	| nextChar |

	self atEnd
		ifFalse: [
			nextChar := readStream next.
			printStream
				ifNotNil: [printStream nextPut: nextChar]].
	^ nextChar.! !

!XMLIntegerReader methodsFor: 'private' stamp: 'monty 3/16/2016 21:21'!
nextDigitWithBase: aBase
	| asciiValue digit |

	((asciiValue := self peek asciiValue) > 0
		and: [asciiValue <= CharacterDigitValues size
			and: [(digit := CharacterDigitValues at: asciiValue) notNil
				and: [digit < aBase]]])
				ifTrue: [
					self next.
					^ digit]
				ifFalse: [^ nil]! !

!XMLIntegerReader methodsFor: 'reading' stamp: 'monty 10/27/2014 08:37'!
nextInteger
	^ self nextIntegerWithBase: 10! !

!XMLIntegerReader methodsFor: 'reading' stamp: 'monty 1/15/2018 01:00'!
nextIntegerWithBase: aBase
	^ self
		nextIntegerWithBase: aBase
		upToLimit: nil! !

!XMLIntegerReader methodsFor: 'reading' stamp: 'monty 1/15/2018 01:00'!
nextIntegerWithBase: aFirstBase andPrefixes: aCharacterCollection orBase: aSecondBase
	^ self
		nextIntegerWithBase: aFirstBase
		andPrefixes: aCharacterCollection
		orBase: aSecondBase
		upToLimit: nil! !

!XMLIntegerReader methodsFor: 'reading' stamp: 'monty 1/15/2018 01:00'!
nextIntegerWithBase: aFirstBase andPrefixes: aCharacterCollection orBase: aSecondBase upToLimit: aReadLimit
	^ self
		nextIntegerWithBase:
			((self atEnd not
				and: [aCharacterCollection includes: self peek])
				ifTrue: [
					self next.
					aFirstBase]
				ifFalse: [aSecondBase])
		upToLimit: aReadLimit! !

!XMLIntegerReader methodsFor: 'reading' stamp: 'monty 1/15/2018 02:26'!
nextIntegerWithBase: aBase upToLimit: aReadLimit
	| integer maxValue maxBaseValue digitValue readLimit |

	(aBase > 1
		and: [aBase <= self class maxBase])
		ifFalse: [self errorUnsupportedBase: aBase].

	self class maxIntegerValue
		ifNotNil: [:maxIntegerValue |
			maxValue := maxIntegerValue.
			maxBaseValue := (maxValue / aBase) floor].
	readLimit := aReadLimit.
	[self atEnd
		or: [(readLimit notNil and: [readLimit <= 0])
			or: [(digitValue := self nextDigitWithBase: aBase) isNil]]]
		whileFalse: [
			integer
				ifNil: [integer := 0].
	
			maxBaseValue
				ifNotNil: [
					integer > maxBaseValue
						ifTrue: [^ self integerOverflow: maxValue]].
			integer := integer * aBase.

			maxValue
				ifNotNil: [
					integer > (maxValue - digitValue)
						ifTrue: [^ self integerOverflow: maxValue]].
			integer := integer + digitValue.
			readLimit
				ifNotNil: [readLimit := readLimit - 1]].
	^ integer.! !

!XMLIntegerReader methodsFor: 'initialization' stamp: 'monty 1/6/2016 07:49'!
on: aStringOrStream
	readStream :=
		aStringOrStream isStream
			ifTrue: [aStringOrStream]
			ifFalse: [aStringOrStream readStream]! !

!XMLIntegerReader methodsFor: 'private' stamp: 'monty 1/3/2016 21:16'!
peek
	self atEnd
		ifTrue: [^ nil]
		ifFalse: [^ readStream peek]! !

!XMLIntegerReader methodsFor: 'accessing' stamp: 'monty 12/2/2015 20:04'!
printStream: aStream
	printStream := aStream! !

XMLIntegerReader subclass: #XMLSmallIntegerReader
	instanceVariableNames: ''
	classVariableNames: 'SmallIntegerMaxValue'
	poolDictionaries: ''
	category: 'XML-Parser-Utils'!

!XMLSmallIntegerReader commentStamp: 'monty 12/16/2017 10:12' prior: 0!
This class reads positive hex or decimal integers up to the maximum a SmallInteger can hold from minimal streams supporting #next, #peek, and #atEnd. It returns nil instead of raising errors for invalid integers.!

!XMLSmallIntegerReader class methodsFor: 'class initialization' stamp: 'monty 12/16/2017 09:59'!
initialize
	"self initialize"

	SmallIntegerMaxValue := SmallInteger maxVal! !

XMLSmallIntegerReader initialize!

!XMLSmallIntegerReader class methodsFor: 'defaults' stamp: 'monty 12/16/2017 09:59'!
maxIntegerValue
	^ SmallIntegerMaxValue! !

Object subclass: #XMLNFABuilder
	instanceVariableNames: 'fragmentStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFABuilder commentStamp: 'monty 1/7/2014 19:39' prior: 0!
This class builds an NFA using a stack of NFAFragments.!

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 12/28/2013 01:26'!
applyBranch
	| branchState leftFragment  rightFragment |

	leftFragment := self popFragment.
	rightFragment := self popFragment.
	branchState :=
		XMLNFABranchingState
			leftBranch: leftFragment firstState
			rightBranch: rightFragment firstState.

	self pushFragment:
		(XMLNFAFragment
			firstState: branchState
			terminalStates: (leftFragment combinedTerminalStatesFrom: rightFragment)).! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 10/24/2014 12:44'!
applyConcatenation
	| firstFragment secondFragment |

	secondFragment := self popFragment.
	firstFragment := self popFragment.

	firstFragment connectToFragment: secondFragment.

	self pushFragment: firstFragment.! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 4/25/2015 09:11'!
applyOptional
	| optionalFragment branchingState |

	optionalFragment := self popFragment.
	branchingState :=
		XMLNFABranchingState branch: optionalFragment firstState.

	self pushFragment:
		(XMLNFAFragment
			firstState: branchingState
			terminalStates:
				(optionalFragment combinedTerminalStatesWith: branchingState))! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 12/28/2013 01:19'!
applyPlus
	| plusFragment branchState |

	plusFragment := self topFragment.
	branchState := XMLNFABranchingState branch: plusFragment firstState.
	plusFragment
		connectToState: branchState;
		terminalState: branchState.! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 12/27/2013 23:55'!
applyStar
	| branchState starFragment |

	starFragment := self popFragment.
	branchState := XMLNFABranchingState branch: starFragment firstState.
	starFragment connectToState: branchState.

	self pushFragment:
		(XMLNFAFragment
			firstState: branchState
			terminalState: branchState)! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 11/10/2015 17:11'!
buildAcceptingNFAFromFragments
	[self totalFragments > 1]
		whileTrue: [self applyConcatenation].
	^ self popFragment
		connectToState: XMLNFAAcceptingState new;
		firstState.! !

!XMLNFABuilder methodsFor: 'private' stamp: 'monty 6/17/2015 23:17'!
fragmentStack
	^ fragmentStack! !

!XMLNFABuilder methodsFor: 'testing' stamp: 'monty 6/17/2015 23:18'!
hasFragments
	^ self totalFragments > 0! !

!XMLNFABuilder methodsFor: 'initialization' stamp: 'monty 6/17/2015 23:17'!
initialize
	super initialize.
	fragmentStack := OrderedCollection new.! !

!XMLNFABuilder methodsFor: 'accessing' stamp: 'monty 11/17/2013 08:01'!
popFragment
	^ self fragmentStack removeLast! !

!XMLNFABuilder methodsFor: 'accessing' stamp: 'monty 11/17/2013 08:01'!
pushFragment: aFragment
	self fragmentStack addLast: aFragment! !

!XMLNFABuilder methodsFor: 'building' stamp: 'monty 12/27/2013 21:41'!
pushMatcher: aMatcher
	| firstState |

	firstState := XMLNFAMatchingState matcher: aMatcher.
	self pushFragment:
		(XMLNFAFragment
			firstState: firstState
			terminalState: firstState).! !

!XMLNFABuilder methodsFor: 'accessing' stamp: 'monty 11/17/2013 12:01'!
topFragment
	^ self fragmentStack last! !

!XMLNFABuilder methodsFor: 'accessing' stamp: 'monty 11/17/2013 15:04'!
totalFragments
	^ self fragmentStack size! !

Object subclass: #XMLNFAFragment
	instanceVariableNames: 'firstState terminalStates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFAFragment commentStamp: 'monty 12/28/2013 21:51' prior: 0!
This is a fragment used to build an NFA by the NFABuilder.!

!XMLNFAFragment class methodsFor: 'instance creation' stamp: 'monty 12/27/2013 23:50'!
firstState: aFirstState terminalState: aTerminalState
	^ self new
		firstState: aFirstState;
		terminalState: aTerminalState! !

!XMLNFAFragment class methodsFor: 'instance creation' stamp: 'monty 12/27/2013 23:50'!
firstState: aFirstState terminalStates: aTerminalStateCollection
	^ self new
		firstState: aFirstState;
		terminalStates: aTerminalStateCollection! !

!XMLNFAFragment methodsFor: 'converting' stamp: 'monty 10/24/2014 13:21'!
combinedTerminalStatesFrom: aFragment
	^ terminalStates isCollection
		ifTrue: [aFragment terminalStatesAddedTo: terminalStates]
		ifFalse: [
			aFragment terminalStates isCollection
				ifTrue: [self terminalStatesAddedTo: aFragment terminalStates]
				ifFalse: [
					self
						terminalStateCollectionWith: terminalStates
						and: aFragment terminalStates]]! !

!XMLNFAFragment methodsFor: 'converting' stamp: 'monty 10/24/2014 13:07'!
combinedTerminalStatesWith: aState
	^ terminalStates isCollection
		ifTrue: [
			terminalStates
				addLast: aState;
				yourself]
		ifFalse: [self terminalStateCollectionWith: terminalStates and: aState]! !

!XMLNFAFragment methodsFor: 'connecting' stamp: 'monty 10/24/2014 12:45'!
connectToFragment: aFragment
	self connectToState: aFragment firstState.
	terminalStates := aFragment terminalStates.! !

!XMLNFAFragment methodsFor: 'connecting' stamp: 'monty 10/24/2014 13:06'!
connectToState: aState
	terminalStates isCollection
		ifTrue: [terminalStates do: [:each | each connectToState: aState]]
		ifFalse: [terminalStates connectToState: aState]! !

!XMLNFAFragment methodsFor: 'accessing' stamp: 'monty 11/17/2013 10:48'!
firstState
	^ firstState! !

!XMLNFAFragment methodsFor: 'accessing' stamp: 'monty 11/17/2013 11:51'!
firstState: aState
	firstState := aState! !

!XMLNFAFragment methodsFor: 'accessing' stamp: 'monty 10/24/2014 12:35'!
terminalState: aTerminalState
	terminalStates := aTerminalState! !

!XMLNFAFragment methodsFor: 'private' stamp: 'monty 10/24/2014 12:52'!
terminalStateCollectionWith: aFirstState and: aSecondState
	^ (OrderedCollection new: 4)
		addLast: aFirstState;
		addLast: aSecondState;
		yourself! !

!XMLNFAFragment methodsFor: 'private' stamp: 'monty 10/24/2014 12:40'!
terminalStates
	^ terminalStates! !

!XMLNFAFragment methodsFor: 'accessing' stamp: 'monty 12/27/2013 23:50'!
terminalStates: aTerminalStateCollection
	terminalStates := aTerminalStateCollection! !

!XMLNFAFragment methodsFor: 'private' stamp: 'monty 10/24/2014 13:21'!
terminalStatesAddedTo: aCollection
	terminalStates isCollection
		ifTrue: [aCollection addAll: terminalStates]
		ifFalse: [aCollection addLast: terminalStates].
	^ aCollection.! !

Object subclass: #XMLNFAState
	instanceVariableNames: 'lastAddedTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFAState commentStamp: 'monty 12/28/2013 22:34' prior: 0!
This is a base class for NFA states.!

XMLNFAState subclass: #XMLNFAAcceptingState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFAAcceptingState commentStamp: 'monty 10/7/2014 01:27' prior: 0!
An NFA in this state is considered to accept the input.!

!XMLNFAAcceptingState methodsFor: 'testing' stamp: 'monty 12/27/2013 21:23'!
isAccepting
	^ true! !

!XMLNFAAcceptingState methodsFor: 'printing' stamp: 'monty 4/25/2015 23:08'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self identityHash; "only print ids to avoid loops"
		nextPut: $).! !

XMLNFAState subclass: #XMLNFABranchingState
	instanceVariableNames: 'leftBranch rightBranch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFABranchingState commentStamp: 'monty 10/7/2014 01:27' prior: 0!
This state can branch off into two different states without matching against anything.!

!XMLNFABranchingState class methodsFor: 'instance creation' stamp: 'monty 12/27/2013 23:43'!
branch: aLeftBranch
	^ self new
		setLeftBranch: aLeftBranch
		rightBranch: nil! !

!XMLNFABranchingState class methodsFor: 'instance creation' stamp: 'monty 12/27/2013 22:04'!
leftBranch: aLeftBranch rightBranch: aRightBranch
	^ self new
		setLeftBranch: aLeftBranch
		rightBranch: aRightBranch! !

!XMLNFABranchingState methodsFor: 'adding' stamp: 'monty 12/29/2013 01:10'!
addTo: aStateSet
	lastAddedTo == aStateSet
		ifFalse: [
			"This avoids getting caught in a loop"
			lastAddedTo := aStateSet.

			leftBranch addTo: aStateSet.
			rightBranch addTo: aStateSet]! !

!XMLNFABranchingState methodsFor: 'connecting' stamp: 'monty 12/27/2013 23:45'!
connectToState: aState
	leftBranch ifNil: [leftBranch := aState].
	rightBranch ifNil: [rightBranch := aState].! !

!XMLNFABranchingState methodsFor: 'printing' stamp: 'monty 4/25/2015 23:09'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self identityHash; "only print ids to avoid loops"
		nextPutAll: ': ';
		print: leftBranch identityHash;
		nextPutAll: ' | ';
		print: rightBranch identityHash;
		nextPut: $).! !

!XMLNFABranchingState methodsFor: 'initialization' stamp: 'monty 12/28/2013 00:45'!
setLeftBranch: aLeftBranch rightBranch: aRightBranch
	leftBranch := aLeftBranch.
	rightBranch := aRightBranch.! !

XMLNFAState subclass: #XMLNFAMatchingState
	instanceVariableNames: 'matcher nextState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation-DFA'!

!XMLNFAMatchingState commentStamp: 'monty 10/9/2014 20:58' prior: 0!
This state can pass to a next state if the input matches against an object.!

!XMLNFAMatchingState class methodsFor: 'instance creation' stamp: 'monty 12/27/2013 21:15'!
matcher: aMatcher
	^ self new matcher: aMatcher! !

!XMLNFAMatchingState methodsFor: 'connecting' stamp: 'monty 12/28/2013 21:52'!
connectToState: aState
	nextState := aState! !

!XMLNFAMatchingState methodsFor: 'accessing' stamp: 'monty 12/27/2013 21:16'!
matcher: aMatcher
	matcher := aMatcher! !

!XMLNFAMatchingState methodsFor: 'testing' stamp: 'monty 12/27/2013 21:15'!
matches: anObject
	^ matcher = anObject! !

!XMLNFAMatchingState methodsFor: 'accessing' stamp: 'monty 12/27/2013 21:13'!
nextState
	^ nextState! !

!XMLNFAMatchingState methodsFor: 'printing' stamp: 'monty 4/25/2015 23:09'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self identityHash; "only print ids to avoid loops"
		nextPutAll: ': ';
		print: matcher;
		nextPutAll: ' -> ';
		print: nextState identityHash;
		nextPut: $).! !

!XMLNFAState methodsFor: 'adding' stamp: 'monty 12/29/2013 01:10'!
addTo: aStateSet
	lastAddedTo == aStateSet
		ifFalse: [
			"This avoids getting caught in a loop"
			lastAddedTo := aStateSet.

			aStateSet add: self]! !

!XMLNFAState methodsFor: 'converting' stamp: 'monty 4/25/2015 15:15'!
asDFAState
	| nfaStates |

	nfaStates := XMLNFAStateSet new.
	self addTo: nfaStates.
	^ nfaStates asDFAState.! !

!XMLNFAState methodsFor: 'connecting' stamp: 'monty 12/27/2013 23:45'!
connectToState: aState! !

!XMLNFAState methodsFor: 'testing' stamp: 'monty 1/7/2014 19:37'!
isAccepting
	^ false! !

!XMLNFAState methodsFor: 'testing' stamp: 'monty 12/27/2013 21:10'!
matches: anObject
	^ false! !

Object subclass: #XMLNamespaceScope
	instanceVariableNames: 'prefixMappings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Namespaces'!

!XMLNamespaceScope commentStamp: 'monty 12/29/2014 01:12' prior: 0!
A namespace scope is a possibly empty set of mappings from namespace prefixes to URIs and an optional default namespace URI to be used for unprefixed elements. Scopes can be created from other scopes by copying. (Uses copy-on-write to reduce memory use.)!

!XMLNamespaceScope class methodsFor: 'defaults' stamp: 'monty 10/8/2014 23:27'!
xmlNamespaceURI
	^ 'http://www.w3.org/XML/1998/namespace'! !

!XMLNamespaceScope class methodsFor: 'defaults' stamp: 'monty 10/8/2014 23:27'!
xmlnsNamespaceURI
	^ 'http://www.w3.org/2000/xmlns/'! !

!XMLNamespaceScope methodsFor: 'comparing' stamp: 'monty 3/29/2016 06:50'!
= anObject
	self == anObject
		ifTrue: [^ true].

	self species == anObject species
		ifFalse: [^ false].

	self hasNamespaces
		ifFalse: [^ anObject hasNamespaces not].

	"use hasNamespaces first to avoid initializing anObject's prefixMappings"
	^ anObject hasNamespaces
		and: [prefixMappings = anObject prefixMappings].! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 12/29/2014 01:15'!
copiedPrefixMappings
	"replaces current mappings with copy for copy-on-write"
	prefixMappings
		ifNil: [^ self prefixMappings]
		ifNotNil: [^ prefixMappings := prefixMappings copy]! !

!XMLNamespaceScope methodsFor: 'copying' stamp: 'monty 3/26/2016 23:55'!
copy
	"copy-on-write allows copies to share state so no postCopy is needed"
	^ self shallowCopy! !

!XMLNamespaceScope methodsFor: 'mapping' stamp: 'monty 10/21/2017 22:46'!
defaultNamespace
	^ prefixMappings
		ifNil: ['']
		ifNotNil: [
			prefixMappings
				at: ''
				ifAbsent: ['']]! !

!XMLNamespaceScope methodsFor: 'mapping' stamp: 'monty 3/2/2016 19:07'!
defaultNamespace: aURI
	self
		validatePrefix: ''
		beforeMappingTo: aURI.

	"copy-on-write"
	self copiedPrefixMappings
		at: ''
		put: aURI.! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 8/25/2017 01:00'!
errorAttribute: anAttribute aliasesURI: aURI
	XMLNamespaceException
		formatSignal: 'Attribute "{1}" has alias for namespace URI "{2}"'
		with: anAttribute
		with: aURI! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 2/21/2017 01:08'!
errorCannotAliasXMLOrXMLNSWithPrefix: aPrefix
	aPrefix isEmpty
		ifTrue: [
			XMLNamespaceException signal:
				'Cannot use "xml" or  "xmlns" namespace URI as default namespace']
		ifFalse: [
			XMLNamespaceException
				formatSignal:
					'Cannot alias the "xml" or "xmlns" namespace URIs ',
					'with prefix "{1}"'
				with: aPrefix]! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 11/6/2014 12:18'!
errorCannotMapPrefixToEmptyURI
	XMLNamespaceException signal: 'Cannot map namespace prefixes to empty URIs'! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 3/24/2015 19:59'!
errorCannotMapXMLNSPrefix
	XMLNamespaceException signal:
		'Cannot map "xmlns" prefix to any namespace, even the current "xmlns" namespace'! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 3/24/2015 20:00'!
errorCannotRemapXMLPrefix
	XMLNamespaceException signal: 'Cannot map the "xml" prefix to a new namespace URI'! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 2/26/2016 05:48'!
errorCannotUnmapPrefix: aPrefix
	XMLNamespaceException
		formatSignal: 'Prefix "{1}" was not mapped and cannot be unmapped'
		with: aPrefix! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 10/31/2014 16:42'!
errorInvalidPrefix: aPrefix	
	XMLNamespaceException
		formatSignal: 'Prefix "{1}" contains ":" character'
		with: aPrefix! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 8/24/2017 06:25'!
errorInvalidUnprefixedAttribute: anAttribute
	XMLNamespaceException
		formatSignal: 'Unprefixed attribute "{1}" contains ":" character'
		with: anAttribute! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 8/24/2017 06:25'!
errorInvalidUnprefixedElement: anElement
	XMLNamespaceException
		formatSignal: 'Unprefixed element <{1}> contains ":" character'
		with: anElement! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 8/25/2017 01:01'!
errorUnmappedPrefix: aPrefix inAttribute: anAttribute
	XMLNamespaceException
		formatSignal: 'Unmapped namespace prefix "{1}" in "{2}" attribute'
		with: aPrefix
		with: anAttribute! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 8/25/2017 01:01'!
errorUnmappedPrefix: aPrefix inElement: anElement
	XMLNamespaceException
		formatSignal: 'Unmapped namespace prefix "{1}" in <{2}> element'
		with: aPrefix
		with: anElement! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 9/3/2017 07:56'!
errorXMLNSPrefixInAttribute: anAttribute
	XMLNamespaceException
		formatSignal: 'Attribute "{1}" uses reserved "xmlns" namespace prefix'
		with: anAttribute! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 9/3/2017 07:55'!
errorXMLNSPrefixInElement: anElement
	XMLNamespaceException
		formatSignal: 'Element <{1}> uses reserved "xmlns" namespace prefix'
		with: anElement! !

!XMLNamespaceScope methodsFor: 'testing' stamp: 'monty 10/12/2014 03:21'!
hasDefaultNamespace
	^ self includesPrefix: ''! !

!XMLNamespaceScope methodsFor: 'testing' stamp: 'monty 3/23/2016 22:01'!
hasNamespaces
	"optimized to avoid lazy initialization"
	prefixMappings == nil
		ifTrue: [^ false].
	^ prefixMappings size > 0.! !

!XMLNamespaceScope methodsFor: 'comparing' stamp: 'monty 9/19/2016 07:11'!
hash
	self hasNamespaces
		ifTrue: [^ self species hash bitXor: self prefixMappings hash]
		ifFalse: [^ self species hash]! !

!XMLNamespaceScope methodsFor: 'testing' stamp: 'monty 10/21/2017 22:48'!
includesPrefix: aPrefix
	self
		prefixMappingAt: aPrefix
		ifAbsent: [^ false].
	^ true.! !

!XMLNamespaceScope methodsFor: 'testing' stamp: 'monty 3/11/2016 15:41'!
includesPrefix: aPrefix mappedTo: aURI
	^ (self
		prefixMappingAt: aPrefix
		ifAbsent: [^ false]) = aURI! !

!XMLNamespaceScope methodsFor: 'mapping' stamp: 'monty 2/26/2016 03:31'!
inheritMappingsFrom: anEnclosingScope
	anEnclosingScope hasNamespaces
		ifFalse: [^ self].
	self hasNamespaces
		ifTrue: [| copiedPrefixMappings |
			anEnclosingScope prefixesAndURIsDo: [:prefix :uri |
				(self includesPrefix: prefix)
					ifFalse: [
						"nil test ensures we only copy the first time when needed"
						(copiedPrefixMappings
							ifNil: [copiedPrefixMappings := self copiedPrefixMappings])
							at: prefix
							put: uri]]]
		ifFalse: [
			"can safely share anEnclosingScope's prefixMappings because of
			copy-on-write behavior"
			prefixMappings := anEnclosingScope prefixMappings].! !

!XMLNamespaceScope methodsFor: 'mapping' stamp: 'monty 3/21/2015 22:37'!
mapPrefix: aPrefix to: aURI
	self
		validatePrefix: aPrefix
		beforeMappingTo: aURI.

	"copy-on-write"
	self copiedPrefixMappings
		at: aPrefix
		put: aURI.! !

!XMLNamespaceScope methodsFor: 'mapping' stamp: 'monty 2/26/2016 16:16'!
mapPrefixesAndURIs: anAssociationCollection
	| copiedPrefixMappings |

	anAssociationCollection associationsDo: [:each |
		self
			validatePrefix: each key
			beforeMappingTo: each value.
		"nil test ensures we only copy the first time when needed"
		(copiedPrefixMappings
			ifNil: [copiedPrefixMappings := self copiedPrefixMappings])
			at: each key
			put: each value]! !

!XMLNamespaceScope methodsFor: 'accessing' stamp: 'monty 5/1/2017 13:27'!
mappedPrefixes
	^ prefixMappings
		ifNil: [#()]
		ifNotNil: [prefixMappings keys]! !

!XMLNamespaceScope methodsFor: 'accessing' stamp: 'monty 3/12/2015 14:15'!
prefixMappingAt: aPrefix
	^ self
		prefixMappingAt: aPrefix
		ifAbsent: ['']! !

!XMLNamespaceScope methodsFor: 'accessing' stamp: 'monty 3/11/2016 15:41'!
prefixMappingAt: aPrefix ifAbsent: aBlock
	^ prefixMappings
		ifNil: [aBlock value]
		ifNotNil: [
			prefixMappings
				at: aPrefix
				ifAbsent: aBlock]! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 4/10/2017 22:48'!
prefixMappings
	^ prefixMappings
		ifNil: [prefixMappings := OrderPreservingStringDictionary new: 5]! !

!XMLNamespaceScope methodsFor: 'enumerating' stamp: 'monty 11/23/2014 23:20'!
prefixesAndURIsDo: aTwoArgumentBlock
	prefixMappings
		ifNotNil: [prefixMappings keysAndValuesDo: aTwoArgumentBlock]! !

!XMLNamespaceScope methodsFor: 'printing' stamp: 'monty 4/22/2015 11:23'!
printDeclarationsOn: aStream
	| isFirst |

	isFirst := true.
	self prefixesAndURIsDo: [:prefix :uri |
		isFirst 
			ifTrue: [isFirst := false]
			ifFalse: [aStream space].
		aStream nextPutAll: 'xmlns'.
		prefix
			ifNotEmpty: [
				aStream
					nextPut: $:;
					nextPutAll: prefix].
		aStream
			nextPut: $=;
			nextPut: $";
			nextPutAll: uri;
			nextPut: $"].! !

!XMLNamespaceScope methodsFor: 'printing' stamp: 'monty 4/22/2015 11:22'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self printDeclarationsOn: aStream.
	aStream nextPut: $).! !

!XMLNamespaceScope methodsFor: 'resolving' stamp: 'monty 3/20/2016 23:55'!
resolvePrefix: aPrefix
	"Resolves the namespace URI of aPrefix (the defualt namespace URI if aPrefix
	is empty), including the predefined 'xml' and 'xmlns' prefixes. Returns an
	empty string if aPrefix is unresolvable."

	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: ''! !

!XMLNamespaceScope methodsFor: 'resolving' stamp: 'monty 3/20/2016 23:58'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	"Resolves the namespace URI of aPrefix (the defualt namespace URI if aPrefix
	is empty), including the predefined 'xml' and 'xmlns' prefixes. Returns the
	value of aBlock if aPrefix is unresolvable."

	(aPrefix size > 0 "optimization"
		and: [(aPrefix at: 1) == $x]) "optimization"
		ifTrue: [
			aPrefix = 'xml'
				ifTrue: [^ self xmlNamespaceURI].
			aPrefix = 'xmlns'
				ifTrue: [^ self xmlnsNamespaceURI]].

	^ self
		prefixMappingAt: aPrefix
		ifAbsent: aBlock.! !

!XMLNamespaceScope methodsFor: 'resolving' stamp: 'monty 4/2/2016 21:49'!
resolvePrefixesOfNamespaceURI: aURI
	| prefixes |

	"the xml and xmlns namespaces URIs can't be aliased"
	aURI = self xmlNamespaceURI
		ifTrue: [^ Set with: 'xml'].
	aURI = self xmlnsNamespaceURI
		ifTrue: [^ Set with: 'xmlns'].

	prefixes := Set new.
	self prefixesAndURIsDo: [:prefix :uri |
		uri = aURI
			ifTrue: [prefixes add: prefix]].
	^ prefixes.! !

!XMLNamespaceScope methodsFor: 'accessing' stamp: 'monty 12/26/2014 23:54'!
size
	^ prefixMappings
		ifNil: [0]
		ifNotNil: [prefixMappings size]! !

!XMLNamespaceScope methodsFor: 'unmapping' stamp: 'monty 2/26/2016 05:49'!
unmapPrefix: aPrefix
	^ self
		unmapPrefix: aPrefix
		ifAbsent: [self errorCannotUnmapPrefix: aPrefix]! !

!XMLNamespaceScope methodsFor: 'unmapping' stamp: 'monty 2/24/2016 09:03'!
unmapPrefix: aPrefix ifAbsent: aBlock
	prefixMappings
		ifNil: [^ aBlock value]
		ifNotNil: [
			"copy-on-write"
			^ self copiedPrefixMappings 
				removeKey: aPrefix
				ifAbsent: aBlock]! !

!XMLNamespaceScope methodsFor: 'unmapping' stamp: 'monty 2/26/2016 18:30'!
unmapPrefixes
	self hasNamespaces
		ifTrue: [
			"copy-on-write"
			self copiedPrefixMappings removeAll]! !

!XMLNamespaceScope methodsFor: 'validating' stamp: 'monty 9/3/2017 07:53'!
validateAndResolvePrefix: aPrefix ofElement: anElement
	aPrefix size > 0 "optimization"
		ifTrue: [
			^ self
				prefixMappingAt: aPrefix
				ifAbsent: [
					aPrefix = 'xml'
						ifTrue: [self xmlNamespaceURI]
						ifFalse: [					
							aPrefix = 'xmlns'
								ifTrue: [self errorXMLNSPrefixInElement: anElement]
								ifFalse: [
									self
										errorUnmappedPrefix: aPrefix
										inElement: anElement]]]]
		ifFalse: [
			"catch names like ':name' with an empty prefix"
			(anElement size > 0
				and: [(anElement at: 1) == $:])
				ifTrue: [self errorInvalidUnprefixedElement: anElement].
			^ self defaultNamespace]! !

!XMLNamespaceScope methodsFor: 'private' stamp: 'monty 3/2/2016 19:19'!
validatePrefix: aPrefix beforeMappingTo: aURI
	aPrefix size > 0 "optimization"
		ifTrue: ["non-default namespace"
			aPrefix = 'xml' "cannot be remapped"
				ifTrue: [
					aURI = self xmlNamespaceURI
						ifFalse: [self errorCannotRemapXMLPrefix].
					^ self].
			aPrefix = 'xmlns' "cannot be mapped, even to the same URI"
				ifTrue: [self errorCannotMapXMLNSPrefix].
			(aPrefix indexOf: $:) > 0 
				ifTrue: [self errorInvalidPrefix: aPrefix].
			"non-default namespaces cannot be mapped to empty uris, even
			to shadow an inherited namesapce"
			aURI size > 0
				ifFalse: [self errorCannotMapPrefixToEmptyURI]].

	"these URIs cannot be aliased, even by the default namespace"
	(aURI = self xmlNamespaceURI
		or: [aURI = self xmlnsNamespaceURI])
		ifTrue: [self errorCannotAliasXMLOrXMLNSWithPrefix: aPrefix].! !

!XMLNamespaceScope methodsFor: 'validating' stamp: 'monty 9/20/2017 07:32'!
validatePrefixesAttribute: anAttribute hasNoAliasIn: anAssociationSetOrNil
	"performance critical method"
	| prefix |

	(prefix := anAttribute xmlPrefixBeforeLocalName) size > 0 "optimization"
		ifTrue: [| attributeLocalNamesAndURIs uri oldSize |
			"not initialized unless needed"
			attributeLocalNamesAndURIs :=
				anAssociationSetOrNil
					ifNil: [attributeLocalNamesAndURIs := Set new].

			uri :=
				self
					prefixMappingAt: prefix
					ifAbsent: [
						prefix = 'xml'
							ifTrue: [self xmlNamespaceURI]
							ifFalse: [					
								prefix = 'xmlns'
									ifTrue: [
										"this can't happen during parsing, because
										'xmlns' attributes are treated as namespace
										declarations, but it can happen through DOM tree
										manipulation, for example:
											attributeNode prefix: 'xmlns'
										"
										self errorXMLNSPrefixInAttribute: anAttribute]
									ifFalse: [
										self
											errorUnmappedPrefix: prefix
											inAttribute: anAttribute]]].

			"a #size check after is faster than #includes:"
			oldSize := attributeLocalNamesAndURIs size.
			(attributeLocalNamesAndURIs
				add: (anAttribute xmlLocalNameAfterPrefix: prefix) -> uri;
				size) > oldSize
				ifFalse: [
					self
						errorAttribute: anAttribute
						aliasesURI: uri].
			^ attributeLocalNamesAndURIs]
		ifFalse: [
			"catch names like ':name' with an empty prefix"
			(anAttribute size > 0
				and: [(anAttribute at: 1) == $:])
				ifTrue: [self errorInvalidUnprefixedAttribute: anAttribute].
			^ anAssociationSetOrNil].! !

!XMLNamespaceScope methodsFor: 'validating' stamp: 'monty 8/26/2016 03:43'!
validatePrefixesOfAttributes: anAttributeCollection
	^ self
		validatePrefixesOfAttributes: anAttributeCollection asArray
		from: 1
		to: anAttributeCollection size! !

!XMLNamespaceScope methodsFor: 'validating' stamp: 'monty 10/2/2017 17:15'!
validatePrefixesOfAttributes: anAttributeCollection from: aStart to: aStop
	"performance critical method"
	| attributeLocalNamesAndURIs |

	"#to:do: for speed"
	aStart to: aStop do: [:i |
		attributeLocalNamesAndURIs :=
			self
				validatePrefixesAttribute: (anAttributeCollection at: i)
				hasNoAliasIn: attributeLocalNamesAndURIs]! !

!XMLNamespaceScope methodsFor: 'defaults' stamp: 'monty 2/17/2016 00:10'!
xmlNamespaceURI
	^ self class xmlNamespaceURI! !

!XMLNamespaceScope methodsFor: 'defaults' stamp: 'monty 2/17/2016 00:10'!
xmlnsNamespaceURI
	^ self class xmlnsNamespaceURI! !

Object subclass: #XMLNamespaceScopeAllocator
	instanceVariableNames: 'scopes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Namespaces'!

!XMLNamespaceScopeAllocator commentStamp: 'monty 6/15/2015 16:48' prior: 0!
This class allocates namespace scopes with a stack. Sending #enterScope pushes a new scope onto the stack that inherits all mappings from the previous (enclosing) scope, and #exitScop pops it off.!

!XMLNamespaceScopeAllocator methodsFor: 'accessing' stamp: 'monty 6/19/2017 00:16'!
currentScope
	| totalScopes |

	^ (totalScopes := scopes size) > 0
		ifTrue: [scopes at: totalScopes]
		ifFalse: [self newEmptyScope]! !

!XMLNamespaceScopeAllocator methodsFor: 'accessing' stamp: 'monty 4/17/2017 10:14'!
currentScope: aScope
	scopes size > 0
		ifTrue: [
			scopes
				at: scopes size
				put: aScope]
		ifFalse: [scopes addLast: aScope]! !

!XMLNamespaceScopeAllocator methodsFor: 'allocating' stamp: 'monty 12/6/2016 03:52'!
enterScope
	^ scopes addLast: self currentScope copy! !

!XMLNamespaceScopeAllocator methodsFor: 'allocating' stamp: 'monty 12/6/2016 03:52'!
exitScope
	^ scopes removeLast! !

!XMLNamespaceScopeAllocator methodsFor: 'testing' stamp: 'monty 4/24/2015 15:29'!
hasCurentScope
	^ scopes notEmpty! !

!XMLNamespaceScopeAllocator methodsFor: 'initialization' stamp: 'monty 12/6/2016 03:53'!
initialize
	super initialize.

	scopes := OrderedCollection new: 10.! !

!XMLNamespaceScopeAllocator methodsFor: 'instance creation' stamp: 'monty 12/6/2016 04:05'!
newEmptyScope
	^ XMLNamespaceScope new! !

!XMLNamespaceScopeAllocator methodsFor: 'printing' stamp: 'monty 4/25/2015 15:22'!
printOn: aStream
	super printOn: aStream.
	self hasCurentScope
		ifTrue: [
			aStream
				nextPut: $(;
				print: self currentScope;
				nextPut: $)].! !

!XMLNamespaceScopeAllocator methodsFor: 'accessing' stamp: 'monty 10/30/2014 12:26'!
scopes
	^ scopes! !

Object subclass: #XMLNestedStreamReader
	instanceVariableNames: 'stream whenPoppedDo isExternal currentPosition currentLineNumber currentLineStartPosition peekChar nestedStreams normalizedLineEndingChar readLimit'
	classVariableNames: 'CRCharacter LFCharacter NullReadStream'
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLNestedStreamReader commentStamp: 'monty 2/14/2016 02:20' prior: 0!
This class represents a stream reader that implements pushBack: using nested streams. This enables subsitution/replacement to be performed without modifying the underlying collections streamed-over or having to copy them. It also performs line-ending normalization, transforming a CR or a CRLF sequence into a single LF character.

(The code in this class is optimized; refactor with care.)!

!XMLNestedStreamReader class methodsFor: 'class initialization' stamp: 'monty 11/24/2016 02:54'!
initialize
	"self initialize"

	"stored in class vars for faster access"
	CRCharacter := Character cr.
	LFCharacter := Character lf.

	"a null stream that is already #atEnd and can safely be sent
	#close repeatedly and #atEnd after"
	NullReadStream := XMLNullReadStream new.! !

XMLNestedStreamReader initialize!

!XMLNestedStreamReader class methodsFor: 'instance creation' stamp: 'monty 11/12/2014 21:36'!
on: aStream
	^ self
		on: aStream
		readLimit: nil! !

!XMLNestedStreamReader class methodsFor: 'instance creation' stamp: 'monty 9/29/2017 12:15'!
on: aStream readLimit: anInteger
	^ self new
		setStream: aStream
		readLimit: anInteger! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 5/13/2017 01:40'!
atEnd
	peekChar
		ifNotNil: [^ false].
	stream atEnd
		ifFalse: [^ false].
	"use #to:do: for speed"
	1 to: nestedStreams size do: [:i |
		(nestedStreams at: i) stream atEnd
			ifFalse: [^ false]].
	^ true.! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 2/6/2014 01:01'!
atQuote
	^ self peek == $"
		or: [peekChar == $']! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 10/25/2016 17:35'!
closeStream: aStream
	"must use respondsTo: to support streams only implementing the basic protocol"
	(aStream respondsTo: #close)
		ifTrue: [aStream close].! !

!XMLNestedStreamReader methodsFor: 'closing' stamp: 'monty 11/26/2016 01:51'!
closeStreams
	"close the streams but do not evaluate their callbacks and
	set the current stream to the null stream sending #closeStreams
	again won't raise an error"
	self
		closeStream: stream;
		setStreamToNull.
	[nestedStreams size > 0]
		whileTrue: [self closeStream: nestedStreams removeLast stream].! !

!XMLNestedStreamReader methodsFor: 'decoding' stamp: 'monty 1/23/2018 01:12'!
convertFromEncoding: anEncodingName
	"Encoding attributes are ignored unless the stream is a converting adapter
	that has a null/implicit converter.
	
	This is the safest approach, because the encoding of a file can be easily
	changed by a text editor or utility without automatically updating the
	<?xml ...?> encoding attribute.
	
	The BOM and out-of-band info (like HTTP headers) should be given precedence."

	(stream isXMLConvertingStreamAdapter
		and: [stream hasNullStreamConverter
			or: [stream hasImplicitStreamConverter]])
		ifTrue: [| streamConverter |
			(streamConverter := anEncodingName asXMLStreamConverter) isNull
				ifTrue: [self errorUnsupportedEncoding: anEncodingName].
			self decodeStreamWithConverter: streamConverter]! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 3/27/2016 01:55'!
currentColumnNumber
	"recording the start pos. of the line and subtracting it from the current
	pos. is faster than an explicit column var that would need to be incremented
	each time through #next/#skipSeparators"
	^ currentLineStartPosition
		ifNotNil: [currentPosition - currentLineStartPosition]! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'JAAyer 7/14/2010 00:39'!
currentLineNumber
	^ currentLineNumber! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 11/23/2016 16:59'!
currentPosition
	^ currentPosition! !

!XMLNestedStreamReader methodsFor: 'decoding' stamp: 'monty 4/1/2016 00:55'!
decodeStreamWithConverter: aStreamConverter
	stream isXMLConvertingStreamAdapter
		ifTrue: [stream streamConverter: aStreamConverter]
		ifFalse: [
			stream :=
				XMLDecodingReadStreamAdapter
					on: stream
					streamConverter: aStreamConverter]! !

!XMLNestedStreamReader methodsFor: 'decoding' stamp: 'monty 1/21/2018 22:31'!
detectEncoding
	stream isXMLConvertingStreamAdapter
		ifTrue: [stream detectEncoding]
		ifFalse: [
			"if it's not already an XMLDecodingReadStreamAdapter, just look
			for an obvious leading byte-order mark and convert it if found,
			and otherwise just leave it alone"
			(XMLEncodingDetector on: stream) streamConverterForEncoding
				ifNotNil: [:converter |
					self decodeStreamWithConverter: converter]]! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 10/31/2014 21:21'!
errorNestingLimitExceeded
	XMLLimitException signal: 'Cannot further nest input streams'! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 6/23/2016 20:39'!
errorReadLimitExceeded
	XMLLimitException signal:
		'Security input read limit exceeded; ',
		'use #documentReadLimit: and #externalSubsetReadLimit: ',
		'to change/disable it, or #defaultReadLimit: ',
		'to persistently change/disable it'! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 11/1/2017 02:17'!
errorUnsupportedEncoding: anEncodingName
	XMLEncodingException
		formatSignal: 'Encoding "{1}" is unsupported'
		with: anEncodingName! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 5/14/2017 17:10'!
hasNextAfterPoppingStreamsAtEnd
	"always pop at least one stream, which makes the new current stream
	the null stream if there aren't any nested streams"
	self popCurrentStream.
	[stream atEnd]
		whileTrue: [
			nestedStreams size > 0
				ifFalse: [^ false].
			self popCurrentStream].
	^ true.! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 11/4/2016 14:21'!
hasPushedBackStreams
	^ nestedStreams size > 0! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 3/18/2016 20:50'!
isBinary
	^ false! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 1/6/2016 08:02'!
isStream
	^ true! !

!XMLNestedStreamReader methodsFor: 'testing' stamp: 'monty 2/8/2018 01:07'!
isXMLBinaryOrExternalStream
	^ self isBinary! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 11/18/2014 05:43'!
maxNestedStreams
	^ 32! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 11/14/2016 09:11'!
nestedStreamsAddLast: aPushedBackStream
	nestedStreams size >= self maxNestedStreams
		ifTrue: [self errorNestingLimitExceeded].
	nestedStreams addLast: aPushedBackStream.! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 4/5/2016 03:19'!
newWriteStream
	^ (self writeStreamCollectionClass new: 128) writeStream! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 5/14/2017 16:36'!
next
	| nextChar |

	peekChar
		ifNil: [
			stream atEnd
				ifTrue: [
					self hasNextAfterPoppingStreamsAtEnd
						ifFalse: [^ nil]].
			nextChar := stream next.
			isExternal
				ifTrue: [
					currentPosition := currentPosition + 1.
					nextChar == LFCharacter
						ifTrue: [
							nextChar := normalizedLineEndingChar.
							currentLineNumber := currentLineNumber + 1.
							currentLineStartPosition := currentPosition]
						ifFalse: [
							nextChar == CRCharacter
								ifTrue: [
									stream atEnd
										ifFalse: [
											stream peek == LFCharacter
												ifTrue: [stream next]].
									nextChar := normalizedLineEndingChar.
									currentLineNumber := currentLineNumber + 1.
									currentLineStartPosition := currentPosition]]]]
		ifNotNil: [
			nextChar := peekChar.
			peekChar := nil.
			isExternal
				ifTrue: [
					currentPosition := currentPosition + 1.
					nextChar == normalizedLineEndingChar
						ifTrue: [
							currentLineNumber := currentLineNumber + 1.
							currentLineStartPosition := currentPosition]]].

	readLimit
		ifNotNil: [
			(readLimit := readLimit - 1) >= 0
				ifFalse: [self errorReadLimitExceeded]].

	^ nextChar.! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 4/5/2016 03:09'!
next: anInteger
	| writeStream i |

	writeStream := self newWriteStream.
	i := 0.
	[self atEnd
		or: [i >= anInteger]]
		whileFalse: [
			writeStream nextPut: self next.
			i := i + 1].
	^ writeStream contents.! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 1/16/2014 09:08'!
normalizedLineEndingChar
	^ normalizedLineEndingChar! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 12/18/2013 17:25'!
normalizedLineEndingChar: aCharacter
	normalizedLineEndingChar := aCharacter! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 5/14/2017 16:36'!
peek
	peekChar
		ifNotNil: [^ peekChar].

	stream atEnd
		ifTrue: [
			self hasNextAfterPoppingStreamsAtEnd
				ifFalse: [^ nil]].
	peekChar := stream next.
	isExternal
		ifTrue: [
			peekChar == LFCharacter
				ifTrue: [^ peekChar := normalizedLineEndingChar].
			peekChar == CRCharacter
				ifTrue: [
					stream atEnd
						ifFalse: [
							stream peek == LFCharacter
								ifTrue: [stream next]].
					^ peekChar := normalizedLineEndingChar]].
	^ peekChar.! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 9/26/2017 07:21'!
peekFor: aCharacter
	(self atEnd not
		and: [self peek = aCharacter])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 2/8/2018 01:37'!
popCurrentStream
	| callbackOfPoppedStream |

	"close the stream first and pop it before evaluating the callback so any
	exception it raises won't cause us to leak file streams or double close a
	stream when XMLParser>>#handleParserError: sends #closeStreams"
	self closeStream: stream.
	callbackOfPoppedStream := whenPoppedDo.
	nestedStreams size > 0
		ifTrue: [| pushedBackStream |
			pushedBackStream := nestedStreams removeLast.
			stream := pushedBackStream stream.
			whenPoppedDo := pushedBackStream whenPoppedDo.
			isExternal := pushedBackStream isExternal.
			currentPosition := pushedBackStream currentPosition.
			currentLineNumber := pushedBackStream currentLineNumber.
			currentLineStartPosition := pushedBackStream currentLineStartPosition]
		ifFalse: [self setStreamToNull].

	"now it's safe to evaluate the callback"
	callbackOfPoppedStream
		ifNotNil: [callbackOfPoppedStream value].! !

!XMLNestedStreamReader methodsFor: 'printing' stamp: 'monty 3/19/2016 15:09'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(';
		print: peekChar;
		nextPutAll: '; ';
		print: stream;
		space;
		print: nestedStreams;
		nextPut: $).! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 12/13/2014 20:15'!
pushBack: aString
	aString size > 1
		ifTrue: [^ self pushBackStream: aString readStream].
	aString size = 1
		ifTrue: [self pushBackCharacter: (aString at: 1)]! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 11/14/2016 09:43'!
pushBackCharacter: aCharacter
	self
		pushBackStream: (XMLSingleCharacterReadStream on: aCharacter)
		whenPoppedDo: nil
		isExternal: false! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 11/14/2016 09:43'!
pushBackStream: aStream
	self
		pushBackStream: aStream
		whenPoppedDo: nil
		isExternal: false! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 4/11/2017 05:24'!
pushBackStream: aStream whenPoppedDo: aBlock isExternal: aBoolean
	self nestedStreamsAddLast:
		((isExternal
			ifTrue: [XMLPushedBackExternalStream]
			ifFalse: [XMLPushedBackInternalStream])
				stream: stream
				whenPoppedDo: whenPoppedDo
				currentPosition: currentPosition
				currentLineNumber: currentLineNumber
				currentLineStartPosition: currentLineStartPosition).

	peekChar
		ifNotNil: [
			self nestedStreamsAddLast:
				(XMLPushedBackInternalStream
					stream: (XMLSingleCharacterReadStream on: peekChar)
					whenPoppedDo: nil
					currentPosition: currentPosition
					currentLineNumber: currentLineNumber
					currentLineStartPosition: currentLineStartPosition).
			peekChar := nil].

	self stream: aStream.
	whenPoppedDo := aBlock.
	(isExternal := aBoolean)
		ifTrue: [
			currentPosition := 0.
			currentLineNumber := 1.
			currentLineStartPosition := 0].! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 4/3/2015 02:01'!
readLimit
	^ readLimit! !

!XMLNestedStreamReader methodsFor: 'initialization' stamp: 'monty 9/29/2017 12:15'!
setStream: aStream readLimit: anInteger
	self stream: aStream.
	isExternal := true.
	currentPosition := 0.
	currentLineNumber := 1.
	currentLineStartPosition := 0.
	nestedStreams := OrderedCollection new: 5.
	readLimit := anInteger.
	normalizedLineEndingChar := LFCharacter.! !

!XMLNestedStreamReader methodsFor: 'private' stamp: 'monty 12/3/2016 01:17'!
setStreamToNull
	stream := NullReadStream.
	whenPoppedDo := nil.
	"do not reset the other stream properties, including position
	and line number, so error messages will be accurate"! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 2/9/2016 23:21'!
skip: anInteger
	1 to: anInteger do: [:i |
		self atEnd
			ifTrue: [^ self].
		self next]! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 9/28/2017 14:20'!
skipSeparators
	"This code is heavily optimized."

	| isExternalNormalizedLineEnding |

	[peekChar
		ifNil: [
			stream atEnd
				ifTrue: [
					self hasNextAfterPoppingStreamsAtEnd
						ifFalse: [^ self]].
			peekChar := stream next.
			isExternal
				ifTrue: [
					peekChar == LFCharacter
						ifTrue: [isExternalNormalizedLineEnding := true]
						ifFalse: [
							peekChar == CRCharacter
								ifTrue: [
									stream atEnd
										ifFalse: [
											stream peek == LFCharacter
												ifTrue: [stream next]].
									isExternalNormalizedLineEnding := true]
								ifFalse: [
									isExternalNormalizedLineEnding := false.
									"nil understands #isXMLSeparator, so it
									isn't tested for first"
									peekChar isXMLSeparator]]]
				ifFalse: [
					"nil understands #isXMLSeparator, so it isn't tested for first"
					peekChar isXMLSeparator]]
			ifNotNil: [
				isExternal
					ifTrue: [
						isExternalNormalizedLineEnding :=
							peekChar == normalizedLineEndingChar].
				peekChar isXMLSeparator]]
		whileTrue: [
			"inlined from #next"
			peekChar := nil.
			isExternal
				ifTrue: [
					currentPosition := currentPosition + 1.
					isExternalNormalizedLineEnding
						ifTrue: [
							currentLineNumber := currentLineNumber + 1.
							currentLineStartPosition := currentPosition].
			readLimit
				ifNotNil: [
					(readLimit := readLimit - 1) >= 0
						ifFalse: [self errorReadLimitExceeded]]]]! !

!XMLNestedStreamReader methodsFor: 'positioning' stamp: 'monty 4/5/2016 03:08'!
skipTo: aCharacter
	[self atEnd]
		whileFalse: [
			self next = aCharacter
				ifTrue: [^ true]].
	^ false.! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'JAAyer 3/11/2010 08:01'!
stream
	^ stream! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 2/8/2018 01:54'!
stream: aStream
	"if the stream is not already a decoding adapter,
	then only assume it needs one if it's binary"
	stream := 
		aStream isXMLConvertingStreamAdapter
			ifTrue: [aStream]
			ifFalse: [
				(XMLDecodingReadStreamAdapter nonDecodingOnIfBinaryOrExternal: aStream)
					ifNil: [aStream]]! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 4/5/2016 03:08'!
upTo: aCharacter
	| writeStream nextChar |

	writeStream := self newWriteStream.
	[self atEnd
		or: [(nextChar := self next) = aCharacter]]
		whileFalse: [writeStream nextPut: nextChar].
	^ writeStream contents.! !

!XMLNestedStreamReader methodsFor: 'accessing' stamp: 'monty 2/9/2016 23:21'!
upToEnd
	| writeStream |

	writeStream := self newWriteStream.
	[self atEnd]
		whileFalse: [writeStream nextPut: self next].
	^ writeStream contents.! !

!XMLNestedStreamReader methodsFor: 'defaults' stamp: 'monty 4/5/2016 03:19'!
writeStreamCollectionClass
	^ String! !

Object subclass: #XMLNode
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNode commentStamp: 'monty 6/15/2015 16:52' prior: 0!
This is a base class for XML nodes. It has testing messages, messages to access the parent, sibling, and ancestor nodes, and messages to control printing.!

XMLNode subclass: #XMLAttribute
	instanceVariableNames: 'name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLAttribute commentStamp: 'monty 8/28/2016 00:23' prior: 0!
The class represents an attribute node stored in an attribute node list. The name of an attribute node can be namespaced using prefixes, but the prefix must be mapped to a namespace URI in the containing element node. Unprefixed attributes have no namespace, not even a default if one is in scope, per the XML namespace standard.

The element of an attribute can be accessed with #element, but also with #parent, because attributes are modeled so their element is their parent (to simplify the implementation of the XPath library).!

!XMLAttribute class methodsFor: 'instance creation' stamp: 'monty 6/5/2017 16:36'!
name: aName
	^ self named: aName! !

!XMLAttribute class methodsFor: 'instance creation' stamp: 'monty 10/18/2014 04:03'!
name: aName value: aValue
	^ self new	
		setName: aName
		value: aValue
		element: nil! !

!XMLAttribute class methodsFor: 'instance creation' stamp: 'monty 8/26/2016 00:23'!
named: aName
	^ self
		name: aName
		value: ''! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 8/28/2016 00:17'!
element
	"reuse an inst var to save memory"
	^ parent! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 8/28/2016 00:17'!
element: anElement
	"reuse an inst var to save memory"
	parent := anElement! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 2/26/2017 08:55'!
expandedName
	"Returns the expanded name of the attribute as a string in the form of
	'{namespaceURI}localName' if there's a namespace URI or 'localName' if there
	isn't"

	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 12/23/2014 16:06'!
hasLanguage: aLanguage
	| language xmlLang |

	language := aLanguage asLowercase.
	^ (xmlLang := self value asLowercase) = language
		or: [(xmlLang copyUpTo: $-) = language].! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 2/13/2015 22:20'!
hasNamespaceURI
	^ self namespaceURI notEmpty! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 3/28/2016 23:16'!
hasPrefix
	^ (self name
		indexOf: $:
		startingAt: 2) > 0! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 1/29/2015 00:30'!
isAttribute
	^ true! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 4/21/2016 07:40'!
isInLanguage: aLanguage
	"Returns true if the receiver is an xml:lang attribute or if its element
	or an ancestor element has an xml:lang attribute, and if the value is an IETF
	language tag that matches aLanguage or if its first ('-' separated) subtag
	matches aLanguage."

	self name = 'xml:lang'
		ifTrue: [^ self hasLanguage: aLanguage]
		ifFalse: [^ super isInLanguage: aLanguage]! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 4/20/2016 02:55'!
isNamed: aName
	"Does the receiver's qualified or local name match the argument?"

	^ self name isXMLQualifiedOrLocalName: aName! !

!XMLAttribute methodsFor: 'testing' stamp: 'monty 4/20/2016 02:55'!
isNamedAny: aNameCollection
	"Does the receiver's qualified or local name match any of the names
	in aNameCollection?"

	^ aNameCollection includesXMLName: self name! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 9/5/2016 07:10'!
localName
	"Returns the local name of the receiver, the name minus any leading
	prefix and colon like 'local' in 'prefix:local'"

	"this is recomputed from the name to save memory instead of
	being stored in an inst var like it is for XMLElement"
	^ self name xmlLocalNameAfterPrefix! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 11/16/2014 17:36'!
name
	^ name ifNil: [name := '']! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 11/16/2014 18:01'!
name: aName
	self renameWith: [name := aName]! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 2/23/2017 04:18'!
namespaceURI
	^ self resolvePrefix: self prefix! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 9/5/2016 02:03'!
prefix
	"Returns the prefix of the receiver's name or an empty string if there
	isn't one."

	"this is recomputed from the qualified name instead of being stored
	in an inst var to save memory."
	^ self name xmlPrefixBeforeLocalName! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:57'!
prefix: aPrefix
	self renameWith: [name := self localName qualifyWithXMLPrefix:  aPrefix]! !

!XMLAttribute methodsFor: 'private' stamp: 'monty 4/18/2016 07:37'!
renameWith: aBlock
	| oldName |

	oldName := self name.
	aBlock value.
	(self name ~= oldName
		and: [self hasParent])
			ifTrue: [
				self parent
					renamedAttribute: self
					from: oldName
					to: self name].! !

!XMLAttribute methodsFor: 'namespacing' stamp: 'monty 2/26/2017 08:52'!
resolvePrefix: aPrefix
	"This resolves the attribute prefix aPrefix or returns an empty string
	if aPrefix is empty (attributes must be prefixed to have a namespace) or
	undeclared"

	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: ''! !

!XMLAttribute methodsFor: 'namespacing' stamp: 'monty 2/26/2017 08:53'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	"This resolves the attribute prefix aPrefix or returns the result of
	evaluated aBlock if aPrefix is empty (attributes must be prefixed to have
	a namespace) or undeclared"

	^ (self hasParent
		and: [aPrefix size > 0]) "no default namespace for attributes"
		ifTrue: [
			self parent
				resolvePrefix: aPrefix
				ifUnresolvable: aBlock]
		ifFalse: [aBlock value]! !

!XMLAttribute methodsFor: 'initialization' stamp: 'monty 11/16/2014 17:35'!
setName: aName value: aValue element: anElement
	name := aName.
	value := aValue.
	parent := anElement.! !

!XMLAttribute methodsFor: 'accessing' stamp: 'monty 12/2/2014 22:56'!
sortKey
	^ self name! !

!XMLAttribute methodsFor: 'accessing' stamp: 'JAAyer 7/22/2010 03:02'!
value
	^ value ifNil: [value := '']! !

!XMLAttribute methodsFor: 'accessing' stamp: 'JAAyer 3/5/2010 08:18'!
value: aString
	value := aString! !

!XMLAttribute methodsFor: 'printing' stamp: 'monty 4/12/2017 23:23'!
writeXMLOn: aWriter
	aWriter
		writeStringName: self name;
		nextPut: $=;
		writeEscapedContentString: self value! !

XMLNode subclass: #XMLComment
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLComment commentStamp: 'monty 5/16/2017 20:42' prior: 0!
This class represents a comment node. Comments are ignored during parsing by default. If you want them preserved as comment nodes, use #preservesCommentNodes: with the DOM parser before parsing.!

!XMLComment class methodsFor: 'instance creation' stamp: 'JAAyer 8/11/2010 22:14'!
string: aString
	^ self new string: aString! !

!XMLComment methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitComment: self! !

!XMLComment methodsFor: 'testing' stamp: 'JAAyer 8/11/2010 22:15'!
isComment
	^ true! !

!XMLComment methodsFor: 'accessing' stamp: 'monty 12/3/2014 01:08'!
sortKey
	^ self string! !

!XMLComment methodsFor: 'accessing' stamp: 'JAAyer 8/11/2010 22:14'!
string
	^ string ifNil: [string := '']! !

!XMLComment methodsFor: 'accessing' stamp: 'JAAyer 8/11/2010 22:14'!
string: aString
	string := aString! !

!XMLComment methodsFor: 'printing' stamp: 'JAA 3/22/2011 15:15'!
writeXMLOn: aWriter
	aWriter comment: self string! !

XMLNode subclass: #XMLDeclarationNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLDeclarationNode commentStamp: 'monty 6/15/2015 16:54' prior: 0!
This is an abstract class for markup declaration nodes in the internal subset.!

XMLDeclarationNode subclass: #XMLAttributeDeclaration
	instanceVariableNames: 'element attribute type defaultPragma defaultValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLAttributeDeclaration commentStamp: 'monty 2/2/2014 16:47' prior: 0!
This is a class for <!!ATTLIST> declarations with definitions for single attributes. (An ATTLIST with multiple attribute defs is the same as a series of separate ATTLISTs for each def)!

!XMLAttributeDeclaration class methodsFor: 'instance creation' stamp: 'monty 10/26/2014 06:11'!
element: anElementName attribute: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	^ self new
		element: anElementName;
		attribute: anAttributeName;
		type: aType;
		defaultPragma: aDefaultPragma;
		defaultValue: aDefaultValue! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:53'!
attribute
	^ attribute ifNil: [attribute := '']! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:07'!
attribute: anAttributeName
	attribute := anAttributeName! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 12/31/2013 00:14'!
defaultPragma
	^ defaultPragma ifNil: [defaultPragma := '']! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:10'!
defaultPragma: aDefaultPragma
	defaultPragma := aDefaultPragma! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 12/31/2013 00:11'!
defaultValue
	^ defaultValue ifNil: [defaultValue := '']! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:10'!
defaultValue: aDefaultValue
	defaultValue := aDefaultValue! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 12/21/2013 03:21'!
element
	^ element ifNil: [element := '']! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:10'!
element: anElementName
	element := anElementName! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'JAAyer 10/30/2010 19:42'!
type
	^ type ifNil: [type := '']! !

!XMLAttributeDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:09'!
type: aType 
	type := aType! !

!XMLAttributeDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:51'!
writeXMLOn: aWriter
	aWriter attributeDeclaration
		element: self element;
		attribute: self attribute;
		type: self type;
		defaultPragma: self defaultPragma;
		defaultValue: self defaultValue;
		write! !

!XMLDeclarationNode methodsFor: 'testing' stamp: 'monty 12/22/2013 06:10'!
isDeclaration
	^ true! !

XMLDeclarationNode subclass: #XMLElementDeclaration
	instanceVariableNames: 'element contentModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLElementDeclaration commentStamp: 'monty 2/2/2014 16:46' prior: 0!
This is a class for <!!ELEMENT> declarations.!

!XMLElementDeclaration class methodsFor: 'instance creation' stamp: 'monty 6/7/2015 19:39'!
element: anElementName contentModel: aContentModel
	^ self new
		element: anElementName;
		contentModel: aContentModel! !

!XMLElementDeclaration methodsFor: 'accessing' stamp: 'JAAyer 10/30/2010 19:43'!
contentModel
	^ contentModel ifNil: [contentModel := '']! !

!XMLElementDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:03'!
contentModel: aContentModel
	contentModel := aContentModel! !

!XMLElementDeclaration methodsFor: 'accessing' stamp: 'monty 12/21/2013 03:21'!
element
	^ element ifNil: [element := '']! !

!XMLElementDeclaration methodsFor: 'accessing' stamp: 'monty 6/7/2015 19:43'!
element: anElementName
	element := anElementName! !

!XMLElementDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:51'!
writeXMLOn: aWriter
	aWriter elementDeclaration
		element: self element;
		contentModel: self contentModel;
		write! !

XMLDeclarationNode subclass: #XMLEntityDeclaration
	instanceVariableNames: 'name replacement publicID systemID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLEntityDeclaration commentStamp: 'monty 2/2/2014 16:46' prior: 0!
This is an abstract class for general and parameter <!!ENTITY> declarations.!

!XMLEntityDeclaration class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 22:37'!
name: aName publicID: aPublicID systemID: aSystemID
	^ self new
		name: aName;
		publicID: aPublicID;
		systemID: aSystemID! !

!XMLEntityDeclaration class methodsFor: 'instance creation' stamp: 'monty 10/26/2014 06:06'!
name: aName replacement: aReplacement
	^ self new
		name: aName;
		replacement: aReplacement! !

!XMLEntityDeclaration methodsFor: 'testing' stamp: 'monty 9/28/2017 09:56'!
isExternal
	^ self systemID notEmpty
		or: [self publicID notEmpty]! !

!XMLEntityDeclaration methodsFor: 'testing' stamp: 'monty 11/30/2013 21:53'!
isParameter
	^ false! !

!XMLEntityDeclaration methodsFor: 'testing' stamp: 'monty 11/21/2016 00:53'!
isUnparsed
	^ false! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 12/21/2013 03:22'!
name
	^ name ifNil: [name := '']! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:01'!
name: aName
	name := aName! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
publicID
	^ publicID ifNil: [publicID := '']! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
publicID: aPublicID
	publicID := aPublicID! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'JAAyer 10/30/2010 19:43'!
replacement
	^ replacement ifNil: [replacement := '']! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 06:05'!
replacement: aReplacement
	replacement := aReplacement! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
systemID
	^ systemID ifNil: [systemID := '']! !

!XMLEntityDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
systemID: aSystemID
	systemID := aSystemID! !

XMLEntityDeclaration subclass: #XMLGeneralEntityDeclaration
	instanceVariableNames: 'ndata'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLGeneralEntityDeclaration commentStamp: 'monty 9/28/2017 10:02' prior: 0!
This is a class for general <!!ENTITY> declarations.!

!XMLGeneralEntityDeclaration class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 22:37'!
name: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	^ self new
		name: aName;
		publicID: aPublicID;
		systemID: aSystemID;
		ndata: aNotationName! !

!XMLGeneralEntityDeclaration methodsFor: 'testing' stamp: 'monty 11/21/2016 00:53'!
isUnparsed
	^ self ndata notEmpty! !

!XMLGeneralEntityDeclaration methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:54'!
ndata
	^ ndata ifNil: [ndata := '']! !

!XMLGeneralEntityDeclaration methodsFor: 'accessing' stamp: 'monty 6/7/2015 19:32'!
ndata: aNotationName
	ndata := aNotationName! !

!XMLGeneralEntityDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:51'!
writeXMLOn: aWriter
	aWriter entityDeclaration
		name: self name;
		isParameter: false;
		replacement: self replacement;
		publicID: self publicID;
		systemID: self systemID;
		ndata: self ndata;
		write! !

XMLEntityDeclaration subclass: #XMLParameterEntityDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLParameterEntityDeclaration commentStamp: 'monty 9/28/2017 10:02' prior: 0!
This is a class for parameter <!!ENTITY> declarations.!

!XMLParameterEntityDeclaration methodsFor: 'testing' stamp: 'monty 11/13/2013 19:34'!
isParameter
	^ true! !

!XMLParameterEntityDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:52'!
writeXMLOn: aWriter
	aWriter entityDeclaration
		name: self name;
		isParameter: true;
		replacement: self replacement;
		publicID: self publicID;
		systemID: self systemID;
		write! !

XMLDeclarationNode subclass: #XMLNotationDeclaration
	instanceVariableNames: 'name publicID systemID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNotationDeclaration commentStamp: 'monty 2/2/2014 16:46' prior: 0!
This is class for <!!NOTATION> declarations.
!

!XMLNotationDeclaration class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 22:37'!
name: aName publicID: aPublicID systemID: aSystemID
	^ self new
		name: aName;
		publicID: aPublicID;
		systemID: aSystemID! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 12/21/2013 03:22'!
name
	^ name ifNil: [name := '']! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 10/26/2014 10:35'!
name: aName
	name := aName! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
publicID
	^ publicID ifNil: [publicID := '']! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
publicID: aPublicID
	publicID := aPublicID! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
systemID
	^ systemID ifNil: [systemID := '']! !

!XMLNotationDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 19:20'!
systemID: aSystemID
	systemID := aSystemID! !

!XMLNotationDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:52'!
writeXMLOn: aWriter
	aWriter notationDeclaration
		name: self name;
		publicID: self publicID;
		systemID: self systemID;
		write! !

!XMLNode methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:04'!
acceptNodeVisitor: aNodeVisitor
	^ self! !

!XMLNode methodsFor: 'deprecated' stamp: 'monty 8/23/2016 05:50'!
addContent: aStringOrStringNode
	"will be deprecated"

	XMLDOMException signal: 'Node cannot contain string content'! !

!XMLNode methodsFor: 'enumerating' stamp: 'monty 4/19/2016 09:08'!
allNodesDo: aBlock
	"evaluates aBlock for the receiver and all of its descendant nodes"

	aBlock value: self! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:01'!
ancestorElements
	"returns a node list with all ancestor elements of the receiver"
	| ancestorElements |

	ancestorElements := self newListForSelect.
	self ancestorElementsDo: [:each | ancestorElements addLast: each].
	^ ancestorElements.! !

!XMLNode methodsFor: 'enumerating' stamp: 'monty 3/8/2015 09:19'!
ancestorElementsDo: aBlock
	| ancestor |

	ancestor := self parent.
	[ancestor notNil
		and: [ancestor isElement]]
		whileTrue: [
			aBlock value: ancestor.
			ancestor := ancestor parent].! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:02'!
ancestorNodes
	"returns a node list with all ancestor nodes of the receiver"
	| ancestors |

	ancestors := self newListForSelect.
	self ancestorNodesDo: [:each | ancestors addLast: each].
	^ ancestors.! !

!XMLNode methodsFor: 'enumerating' stamp: 'monty 3/8/2015 09:18'!
ancestorNodesDo: aBlock
	| ancestor |

	ancestor := self parent.
	[ancestor notNil]
		whileTrue: [
			aBlock value: ancestor.
			ancestor := ancestor parent].! !

!XMLNode methodsFor: 'converting' stamp: 'monty 2/11/2017 22:05'!
asString
	"for compatibility with GS where Object>>#asString isn't defined"
	^ self printString! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:21'!
canHaveChildren
	"returns true if the receiver is a type of node that can have child nodes"

	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/21/2016 07:50'!
canonicallyEquals: aNode
	"returns true if the receiver and aNode have the same canonical
	representation (http://www.w3.org/TR/xml-c14n)"

	^ self canonicallyPrinted = aNode canonicallyPrinted! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/19/2016 09:16'!
canonicallyPrintOn: aStream
 	"Prints on aStream as canonical XML (http://www.w3.org/TR/xml-c14n)"

	self
		printOn: aStream
		beforeWritingDo: [:writer | writer isCanonical: true]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:11'!
canonicallyPrintToFileNamed: aFileName
 	"Prints to the file aFileName as canonical XML (http://www.w3.org/TR/xml-c14n)"

	self
		printToFileNamed: aFileName
		beforeWritingDo: [:writer | writer isCanonical: true]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/19/2016 09:11'!
canonicallyPrinted
 	"Prints as canonical XML (http://www.w3.org/TR/xml-c14n)"

	^ String streamContents: [:stream | self canonicallyPrintOn: stream]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/1/2015 19:09'!
configuration
	^ self parent ifNotNil: [:node | node configuration]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 2/11/2018 01:55'!
contentString
 	"Returns a combined string of all descendant string values with spaces inserted
	for readability when one string has no trailing space and the next has no
	leading space.

	See also #rawContentString."

	^ String streamContents: [:stream | self printContentOn: stream]! !

!XMLNode methodsFor: 'copying' stamp: 'monty 8/15/2016 03:28'!
copy
	"returns a deep copy of the receiver, including copies of any descendant nodes,
	and copies the config"

	^ self shallowCopy postCopy postCopyConfiguration! !

!XMLNode methodsFor: 'copying' stamp: 'monty 8/15/2016 03:28'!
copySharingConfiguration	
	"returns a deep copy of the receiver, including copies of any descendant nodes,
	but does not copy the config"

	^ self shallowCopy postCopy! !

!XMLNode methodsFor: 'enumerating' stamp: 'monty 2/27/2016 13:38'!
descendantNodesDo: aBlock! !

!XMLNode methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodesDo: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantNodesDo: instead"

	^ self descendantNodesDo: aBlock! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:15'!
document
	"returns the document node that the receiver belongs to (the receiver if it's a
	document) or nil if there isn't one"

	^ self parent ifNotNil: [:node | node document]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 3/25/2015 18:54'!
documentRoot
	"returns the root of the DOM tree, a document node if there is one or the
	last ancestor or self otherwise"
	| documentRoot |

	documentRoot := self.
	self ancestorNodesDo: [:each | documentRoot := each].
	^ documentRoot.! !

!XMLNode methodsFor: 'private' stamp: 'monty 10/31/2014 20:56'!
errorXMLWritingUnsupported
	XMLDOMException signal: 'The XMLWriter package is required for writng DOM objects'! !

!XMLNode methodsFor: 'private' stamp: 'monty 1/7/2015 02:16'!
escapesContentEntitiesWhenWriting
	self hasParent
		ifTrue: [^ self parent escapesContentEntitiesWhenWriting]
		ifFalse: [^ true] "default to escaping"! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:20'!
hasChildren
	"returns true if the receiver has child nodes"

	^ false! !

!XMLNode methodsFor: 'private' stamp: 'monty 9/6/2016 00:38'!
hasNodeList: aNodeList
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:20'!
hasParent
	"returns true if the receiver has a parent node"

	^ parent notNil! !

!XMLNode methodsFor: 'private' stamp: 'monty 9/6/2016 00:37'!
hasParentWithNodeList: aNodeList
	"optimized"
	parent == nil
		ifTrue: [^ false].
	^ parent hasNodeList: aNodeList.! !

!XMLNode methodsFor: 'private' stamp: 'monty 8/16/2016 23:52'!
initializeFileWriteStream: aWriteStream
	"This sets a stream converter on aWriteStream based on the document's encoding
	attribute and writes the encoding's byte order mark."

	| document |

	aWriteStream
		streamConverter:
			(((document := self document) notNil
				and: [document hasEncoding])
				ifTrue: [document encoding asXMLStreamConverter]
				ifFalse: [XMLStreamConverter default]);
		nextPutByteOrderMark! !

!XMLNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:30'!
isAttribute
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'JAAyer 8/11/2010 22:16'!
isCData
	^ false! !

!XMLNode methodsFor: 'private' stamp: 'monty 8/6/2016 17:54'!
isCoalescingStringNode
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'JAAyer 8/11/2010 22:15'!
isComment
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:20'!
isContentNode
	"returns true if the receiver is a content node (an element or string node)"

	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 12/22/2013 06:10'!
isDeclaration
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'JAAyer 2/19/2010 23:50'!
isDocument
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'JAAyer 4/11/2010 22:59'!
isElement
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:24'!
isElementNamed: aName
	"returns true if the receiver is an element whose qualified name or local
	name matches aName"

	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:24'!
isElementNamedAny: aNameCollection
	"returns true if the receiver is an element whose qualified name or local
	name matches any name in aNameCollection"

	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/20/2016 10:59'!
isInLanguage: aLanguage
	"Returns true if one of the ancestor elements of the receiver has an xml:lang
	attribute, and if the value is an IETF language tag that matches aLanguage
	or if its first ('-' separated) subtag matches aLanguage."

	^ self hasParent
		and: [self parent isInLanguage: aLanguage]! !

!XMLNode methodsFor: 'testing' stamp: 'monty 4/19/2016 09:18'!
isPI
	"returns true if the receiver is a processing instruction node"

	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'JAAyer 4/12/2010 22:33'!
isStringNode
	^ false! !

!XMLNode methodsFor: 'testing' stamp: 'monty 11/5/2014 12:09'!
isStringNode: aStringOrStringNode
	^ false! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newCData: aString
	^ self nodeFactory newCData: aString! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newComment: aString
	^ self nodeFactory newComment: aString! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newDocument
	^ self nodeFactory newDocument
		configuration: self configuration! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newElement
	^ self nodeFactory newElement
		configuration: self configuration! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 9/8/2016 07:29'!
newElementNamed: aName
	^ (self nodeFactory classForElement: aName) new
		configuration: self configuration;
		name: aName! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 9/8/2016 07:28'!
newElementNamed: aName attributes: anAssociationCollection
	^ (self nodeFactory
		classForElement: aName
		attributes: anAssociationCollection) new
			configuration: self configuration;
			name: aName;
			setAttributes: anAssociationCollection! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 9/8/2016 07:30'!
newElementNamed: aName namespaceURI: aURI
	^ (self nodeFactory
		classForElement: aName
		namespaceURI: aURI) new
			configuration: self configuration;
			name: aName namespaceURI: aURI! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 9/8/2016 07:27'!
newElementNamed: aName namespaceURI: aURI attributes: anAssociationCollection
	^ (self nodeFactory
		classForElement: aName
		namespaceURI: aURI
		attributes: anAssociationCollection) new
			configuration: self configuration;
			name: aName namespaceURI: aURI;
			setAttributes: anAssociationCollection! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 3/8/2015 09:20'!
newListForCollect
	"collect can return non-nodes, so a basic ordered list is used"
	^ XMLOrderedList new: 10! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 3/8/2015 09:20'!
newListForSelect
	"select returns only nodes, so a node list is used"
	^ XMLNodeList new: 10! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newPI
	^ self nodeFactory newPI! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newPITarget: aTargetString data: aDataString
	^ self nodeFactory
		newPITarget: aTargetString
		data: aDataString! !

!XMLNode methodsFor: 'instance creation' stamp: 'monty 8/9/2016 21:01'!
newStringNode: aString
	^ self nodeFactory newStringNode: aString! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:06'!
nextNode
	"returns the first node after this one that is a child of the same parent (the next
	sibling) or nil if there isn't one"

	^ self parent ifNotNil: [:node | node nodeAfter: self]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 8/9/2016 21:01'!
nodeFactory
	^ self configuration
		ifNil: [XMLNodeFactory new]
		ifNotNil: [:config | config nodeFactory]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:06'!
parent
	"returns the parent node of this node or nil if there isn't one"

	^ parent! !

!XMLNode methodsFor: 'private' stamp: 'monty 4/19/2016 09:07'!
parent: aNode
	parent := aNode! !

!XMLNode methodsFor: 'defaults' stamp: 'monty 3/7/2017 10:04'!
parserHandlerClass
	^ self configuration
		ifNil: [XMLDOMParser]
		ifNotNil: [:config | config parserHandlerClass]! !

!XMLNode methodsFor: 'copying' stamp: 'monty 1/2/2016 23:56'!
postCopy
	super postCopy.

	parent := nil.! !

!XMLNode methodsFor: 'copying' stamp: 'monty 3/2/2016 05:48'!
postCopyConfiguration! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/19/2016 09:10'!
prettyPrintOn: aStream
 	"Prints XML on aStream with whitespace formatting for readability"

	self
		printOn: aStream
		beforeWritingDo: [:writer | writer enablePrettyPrinting]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:08'!
prettyPrintToFileNamed: aFileName
 	"Prints XML to the file aFileName with whitespace formatting for readability"

	self
		printToFileNamed: aFileName
		beforeWritingDo: [:writer | writer enablePrettyPrinting]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/19/2016 09:10'!
prettyPrinted
 	"Prints XML with whitespace formatting for readability"

	^ String streamContents: [:stream | self prettyPrintOn: stream]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 4/19/2016 09:06'!
previousNode
	"returns the first node before this one that is a child of the same parent
	(the preivous sibling) or nil if there isn't one"

	^ self parent ifNotNil: [:node | node nodeBefore: self]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:07'!
printContentOn: aStream
 	"Prints on aStream the combined content strings of all descendants with
	space inserted when one string has no trailing space and the next has
	no leading space.

	See also #printRawContentOn:"

	self printRawContentOn: (XMLNodeContentWriteStreamAdapter on: aStream)! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/19/2016 09:10'!
printOn: aStream
	"Uses XMLWriter if supported to print XML on aStream, uses the
	basic Object>>printOn: otherwise"

	self
		withNewXMLWriterOn: aStream
		do: [:writer |
			self writeXMLOn: writer.
			writer write]
		whenAbsent: [super printOn: aStream]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 7/8/2016 00:57'!
printOn: aStream beforeWritingDo: aBlock
	"Prints XML on aStream using an XMLWriter object it creates but first
	evaluates aBlock with the XMLWriter so it can be configured before writing.

	Raises an error without XMLWriter support."

	self
		withNewXMLWriterOn: aStream
		do: [:writer |
			aBlock value: writer.
			self writeXMLOn: writer.
			writer write]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:05'!
printRawContentOn: aStream 
 	"Prints on aStream the content strings of all descendants
	without spaces inserted.

	See also #printContentOn:"! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:09'!
printToFileNamed: aFileName
	"Prints XML to the file aFileName. Uses the encoding specified in the
	document's encoding attribute if supported or UTF-8 otherwise."

	self
		withNewWriteStreamOnFileNamed: aFileName
		do: [:writeStream |
			self
				printOn: writeStream
				beforeWritingDo: [:writer |
					"use the platform's line break because we're writing to a file"
					writer enablePlatformSpecificLineBreak]]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:09'!
printToFileNamed: aFileName beforeWritingDo: aBlock
	"Prints XML to the file aFileName after evaluating aBlock with the XMLWriter.
	Uses the encoding specified in the document's encoding attribute if
	supported or UTF-8 otherwise."

	self
		withNewWriteStreamOnFileNamed: aFileName
		do: [:writeStream |
			self
				printOn: writeStream
				beforeWritingDo: [:writer |
					"use the platform's line break because we're writing to a file"
					writer enablePlatformSpecificLineBreak.
					aBlock value: writer]]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:17'!
printWithoutSelfClosingTagsOn: aStream
	"Prints XML on aStream with empty elements rendered as '<empty></empty>'
	instead of self-closing '<empty />' tags"

	self
		printOn: aStream
		beforeWritingDo: [:writer | writer outputsSelfClosingTags: false]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:16'!
printWithoutSelfClosingTagsToFileNamed: aFileName
	"Prints XML to the file aFileName with empty elements rendered
	as '<empty></empty>' instead of self-closing '<empty />' tags"

	self
		printToFileNamed: aFileName
		beforeWritingDo: [:writer | writer outputsSelfClosingTags: false]! !

!XMLNode methodsFor: 'printing' stamp: 'monty 4/17/2017 04:17'!
printedWithoutSelfClosingTags
	"Prints XML with empty elements rendered as '<empty></empty>' instead
	of self-closing '<empty />' tags"

	^ String streamContents: [:stream | self printWithoutSelfClosingTagsOn: stream]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 2/11/2018 01:55'!
rawContentString
 	"Returns a combined string of all descendant string values without any spaces
	inserted for readability.
	
	See also #contentString"

	^ String streamContents: [:stream | self printRawContentOn: stream]! !

!XMLNode methodsFor: 'accessing' stamp: 'monty 12/4/2014 14:00'!
sortKey
	"used to compare nodes when sorting"

	^ self class name asString! !

!XMLNode methodsFor: 'validating' stamp: 'monty 8/23/2016 05:53'!
validate
	"revalidate against the DTD it was parsed with (if any)"

	self document ifNotNil: [:document | document validate]! !

!XMLNode methodsFor: 'validating' stamp: 'monty 8/23/2016 05:53'!
validateWith: aValidator
	"revalidate against a custom DTD or other validator"

	self document ifNotNil: [:document | document validateWith: aValidator]! !

!XMLNode methodsFor: 'private' stamp: 'monty 3/4/2016 08:53'!
withNewWriteStreamOnFileNamed: aFileName do: aBlock
	aFileName asXMLFileHandle writeStreamDo: [:writeStream |
		self initializeFileWriteStream: writeStream.
		aBlock value: writeStream]! !

!XMLNode methodsFor: 'private' stamp: 'monty 10/31/2014 20:56'!
withNewXMLWriterOn: aStream do: aOneArgBlock
	^ self
		withNewXMLWriterOn: aStream
		do: aOneArgBlock
		whenAbsent: [self errorXMLWritingUnsupported]! !

!XMLNode methodsFor: 'private' stamp: 'monty 5/10/2015 00:22'!
withNewXMLWriterOn: aStream do: aOneArgBlock whenAbsent: aZeroArgBlock
	| writer |

	writer :=
		(self xmlWriterClassOrNil
			ifNil: [^ aZeroArgBlock value]) on: aStream.
	self escapesContentEntitiesWhenWriting
		ifFalse: [writer escapesContentEntityReferences: false].
	^ aOneArgBlock value: writer.! !

!XMLNode methodsFor: 'printing' stamp: 'monty 7/5/2016 21:24'!
writeXMLOn: aWriter
	"Template method used by nodes to write themselves on XMLWriters.

	Sending with a customized XMLWriter instance as the argument can be used
	to customize printing, but #printOn:beforeWritingDo: should be preferred."! !

!XMLNode methodsFor: 'defaults' stamp: 'monty 9/20/2016 21:50'!
xmlWriterClassOrNil
	"can be overridden to return a custom XMLWriter subclass"

	^ XMLClassFinder classNamed: #XMLWriter! !

XMLNode subclass: #XMLNodeWithChildren
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNodeWithChildren commentStamp: 'monty 2/27/2016 13:48' prior: 0!
This is an abstract class for nodes that can contain child nodes.

It has messages to access, add and remove child nodes. The nodes are stored in a kind of XMLObservableList returned by #nodes, which can be modified directly to add or remove nodes from the owner of #nodes (copy it first if that isn't what you want).

There are three types of "enumerating" messages: the #nodes* messages enumerate child nodes of the receiver, the #allNode* forms enumerate (using depth-first traversal) the receiver and all descendant nodes, and the #descendantNode* forms  enumerate only descendant nodes.!

XMLNodeWithChildren subclass: #XMLDoctypeDeclaration
	instanceVariableNames: 'root publicID systemID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLDoctypeDeclaration commentStamp: 'monty 6/15/2015 01:39' prior: 0!
This class represents a <!!DOCTYPE ...> declaration. It stores the root element name, public/system ID, and its nodes are the internal subset.!

!XMLDoctypeDeclaration class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 22:36'!
root: aRootElementName publicID: aPublicID systemID: aSystemID
	^ self new
		root: aRootElementName;
		publicID: aPublicID;
		systemID: aSystemID! !

!XMLDoctypeDeclaration methodsFor: 'instance creation' stamp: 'monty 3/8/2015 09:17'!
newListForSelect
	^ XMLInternalSubsetList new: 10! !

!XMLDoctypeDeclaration methodsFor: 'defaults' stamp: 'monty 11/26/2013 21:51'!
nodeListClass
	^ XMLInternalSubsetList! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 20:01'!
publicID
	^ publicID ifNil: [publicID := '']! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 20:01'!
publicID: aPublicID
	publicID := aPublicID! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 10/10/2014 07:12'!
root
	^ root ifNil: [root := '']! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 11/23/2014 04:42'!
root: aRootElementName
	root := aRootElementName! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 20:01'!
systemID
	^ systemID ifNil: [systemID := '']! !

!XMLDoctypeDeclaration methodsFor: 'accessing' stamp: 'monty 3/24/2015 20:01'!
systemID: aSystemID
	systemID := aSystemID! !

!XMLDoctypeDeclaration methodsFor: 'printing' stamp: 'monty 5/7/2015 18:51'!
writeXMLOn: aWriter
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID;
		with: [self writeInnerXMLOn: aWriter]! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 8/9/2016 21:20'!
addComment: aString
	^ self addNode: (self newComment: aString)! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 4/20/2016 12:54'!
addNode: aNode
	"Adds aNode to the end of the receiver's node list. Can be used for elements,
	comments, and other types of nodes."

	^ self nodes addLast: aNode! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 4/20/2016 12:56'!
addNode: aNode after: aPreviousNode
	"Adds aNode to the receiver's node list after aPreviousNode raising an
	error if aPreviousNode is absent"

	^ self nodes
		add: aNode
		after: aPreviousNode! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 4/20/2016 12:56'!
addNode: aNode before: aNextNode
	"Adds aNode to the receiver's node list before aNextNode raising an
	error if aNextNode is absent"

	^ self nodes
		add: aNode
		before: aNextNode! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 4/20/2016 12:54'!
addNodeFirst: aNode
	"Adds aNode to the begining of the receiver's node list. Can be used for
	elements, comments, and other types of nodes."

	^ self nodes addFirst: aNode! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'JAAyer 7/22/2010 05:12'!
addNodes: aNodeCollection
	^ self nodes addAll: aNodeCollection! !

!XMLNodeWithChildren methodsFor: 'adding' stamp: 'monty 8/9/2016 21:21'!
addPITarget: aTargetString data: aDataString
	^ self addNode:
		(self
			newPITarget: aTargetString
			data: aDataString)! !

!XMLNodeWithChildren methodsFor: 'notifying' stamp: 'monty 8/30/2016 06:59'!
addedNode: aNode
	aNode parent
		ifNotNil: [:nodeParent |
			nodeParent == self
				ifFalse: [nodeParent removeNode: aNode]].
	aNode parent: self.! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:14'!
allNodes
	"returns a node list with the receiver and all of its descendant nodes"
	| allNodes |

	allNodes := self newListForSelect.
	self allNodesDo: [:each | allNodes addLast: each].
	^ allNodes.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:29'!
allNodesCollect: aBlock
	"returns an ordered list of the receiver and all of its descendant nodes
	evaluated with aBlock"
	| collectedObjects |

	collectedObjects := self newListForCollect.
	self allNodesDo: [:each | collectedObjects addLast: (aBlock value: each)].
	^ collectedObjects.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'JAAyer 11/28/2010 12:17'!
allNodesDetect: aBlock
	^ self allNodesDetect: aBlock ifNone: [nil]! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 11/6/2014 21:40'!
allNodesDetect: aBlock ifNone: anExceptionBlock
	self allNodesDo: [:each |
		(aBlock value: each)
			ifTrue: [^ each]].
	^ anExceptionBlock value.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/19/2016 09:08'!
allNodesDo: aBlock
	"evaluates aBlock for the receiver and all of its descendant nodes"

	aBlock value: self.
	self hasChildren
		ifTrue: [self nodesDo: [:each | each allNodesDo: aBlock]]! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 3/8/2015 09:17'!
allNodesSelect: aBlock
	| selectedNodes |

	selectedNodes := self newListForSelect.
	self allNodesDo: [:each |
		(aBlock value: each)
			ifTrue: [selectedNodes addLast: each]].
	^ selectedNodes.! !

!XMLNodeWithChildren methodsFor: 'testing' stamp: 'monty 11/23/2014 20:53'!
canHaveChildren
	^ true! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:15'!
descendantNodes
	"returns a node list with all descendant nodes of the receiver"
	| descendentNodes |

	descendentNodes := self newListForSelect.
	self descendantNodesDo: [:each | descendentNodes addLast: each].
	^ descendentNodes.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 13:16'!
descendantNodesCollect: aBlock
	"returns an ordered list of the values of all descendant nodes of the
	receiver evaluated with aBlock"
	| collectedObjects |

	collectedObjects := self newListForCollect.
	self descendantNodesDo: [:each |
		collectedObjects addLast: (aBlock value: each)].
	^ collectedObjects.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:33'!
descendantNodesDetect: aBlock
	"returns the first descendant node of the receiver that aBlock evaluates
	true for or nil if there isn't one"

	^ self
		descendantNodesDetect: aBlock
		ifNone: [nil]! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:33'!
descendantNodesDetect: aBlock ifNone: anExceptionBlock
	"returns the first descendant node of the receiver that aBlock evaluates
	true for or the value of anExceptionBlock if there isn't one"

	self descendantNodesDo: [:each |
		(aBlock value: each)
			ifTrue: [^ each]].
	^ anExceptionBlock value.! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:28'!
descendantNodesDo: aBlock
	"evaluates aBlock for all descendant nodes of the receiver"

	self hasChildren
		ifTrue: [self nodesDo: [:each | each allNodesDo: aBlock]]! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:33'!
descendantNodesSelect: aBlock
	"returns a node list of all descendant nodes of the receiver that aBlock
	evaluates true for"
	| selectedNodes |

	selectedNodes := self newListForSelect.
	self descendantNodesDo: [:each |
		(aBlock value: each)
			ifTrue: [selectedNodes addLast: each]].
	^ selectedNodes.! !

!XMLNodeWithChildren methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodes
	"less common alternate spelling, will be deprecated;
	use #descendantNodes instead"

	^ self descendantNodes! !

!XMLNodeWithChildren methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodesCollect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantNodesCollect: instead"

	^ self descendantNodesCollect: aBlock! !

!XMLNodeWithChildren methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodesDetect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantNodesDetect: instead"

	^ self descendantNodesDetect: aBlock! !

!XMLNodeWithChildren methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodesDetect: aBlock ifNone: anExceptionBlock
	"less common alternate spelling, will be deprecated;
	use #descendantNodesDetect:ifNone: instead"

	^ self
		descendantNodesDetect: aBlock
		ifNone: anExceptionBlock! !

!XMLNodeWithChildren methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentNodesSelect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantNodesSelect: instead"

	^ self descendantNodesSelect: aBlock! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:25'!
firstNode
	"returns the first child node of the receiver if it has one, nil otherwise"

	^ self nodes first! !

!XMLNodeWithChildren methodsFor: 'testing' stamp: 'monty 7/15/2016 01:58'!
hasChildren
	"optimized with nil test and size check to avoid lazy initializing"
	nodes == nil
		ifTrue: [^ false].
	^ nodes size > 0.! !

!XMLNodeWithChildren methodsFor: 'private' stamp: 'monty 9/6/2016 00:38'!
hasNodeList: aNodeList
	^ nodes == aNodeList! !

!XMLNodeWithChildren methodsFor: 'testing' stamp: 'JAAyer 7/20/2010 10:23'!
includesNode: aNode
	^ self nodes includes: aNode! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:38'!
innerXML
	"Returns a string containing the XML source of all descendent nodes.
	
	See #innerXML:"

	^ String streamContents: [:stream | self printInnerXMLOn: stream]! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:38'!
innerXMLPrettyPrinted
	"Pretty print version of #innerXML.
	
	See #innerXML:"

	^ String streamContents: [:stream |
		self
			printInnerXMLOn: stream
			beforeWritingDo: [:writer | writer enablePrettyPrinting]]! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:25'!
lastNode
	"returns the last child node of the receiver if it has one, nil otherwise"

	^ self nodes last! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:16'!
nodeAfter: aNode
	"returns the first child node of the receiver after aNode or nil if there
	isn't one"

	^ self nodes after: aNode! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:44'!
nodeAt: anIndex
	"returns the child node at position anIndex or nil if there isn't one"

	^ self nodes at: anIndex! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:27'!
nodeAt: anIndex ifAbsent: aBlock
	"returns the child node at position anIndex or the value of aBlock
	if there isn't one"

	^ self nodes
		at: anIndex
		ifAbsent: aBlock! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/21/2016 07:54'!
nodeAt: anIndex put: aNode
	"replaces the child node at anIndex with aNode, raising an error if
	anIndex is outside the current range of the node list"

	^ self nodes
		at: anIndex
		put: aNode! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:16'!
nodeBefore: aNode
	"returns the first child node of the receiver before aNode or nil if there
	isn't one"

	^ self nodes before: aNode! !

!XMLNodeWithChildren methodsFor: 'defaults' stamp: 'monty 11/4/2014 19:04'!
nodeListClass
	^ XMLNodeList! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:18'!
nodes
	"returns the internal node list; safe to modify, but adding or removing nodes
	from it will have the effect of adding or removing them from the receiver"

	^ nodes ifNil: [nodes := self nodeListClass observer: self]! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:35'!
nodesCollect: aBlock
	"returns an ordered list of the values of all node children of the
	receiver evaluated with aBlock"

	^ self nodes collect: aBlock! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 10/28/2014 19:46'!
nodesDetect: aBlock
	^ self nodes detect: aBlock! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'JAAyer 11/28/2010 12:14'!
nodesDetect: aBlock ifNone: anExceptionBlock
	^ self nodes detect: aBlock ifNone: anExceptionBlock! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:32'!
nodesDo: aBlock
	"evaluates aBlock for all child nodes of the receiver"

	self nodes do: aBlock! !

!XMLNodeWithChildren methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:34'!
nodesSelect: aBlock
	"returns a node list of all node children of the receiver that aBlock
	evaluates true for"

	^ self nodes select: aBlock! !

!XMLNodeWithChildren methodsFor: 'copying' stamp: 'monty 3/2/2016 12:21'!
postCopy
	super postCopy.

	nodes
		ifNotNil: [| copiedNodes |
			copiedNodes := nodes copyEmpty observer: self.
			nodes do: [:each |
				"copySharingConfiguration is used so the config is only ever copied
				once when an element or doc is sent #copy and is done after all of the
				descendants have been copied"
				copiedNodes addLast: each copySharingConfiguration].
			nodes := copiedNodes].! !

!XMLNodeWithChildren methodsFor: 'printing' stamp: 'monty 4/16/2016 13:05'!
printInnerXMLOn: aStream
	self hasChildren
		ifTrue: [
			self
				withNewXMLWriterOn: aStream
				do: [:writer |
					self writeInnerXMLOn: writer]]! !

!XMLNodeWithChildren methodsFor: 'printing' stamp: 'monty 5/10/2015 06:19'!
printInnerXMLOn: aStream beforeWritingDo: aBlock
	self hasChildren
		ifTrue: [
			self
				withNewXMLWriterOn: aStream
				do: [:writer |
					aBlock value: writer.
					self writeInnerXMLOn: writer.
					writer write]]! !

!XMLNodeWithChildren methodsFor: 'removing' stamp: 'JAAyer 7/20/2010 10:27'!
removeNode: aNode
	^ self nodes remove: aNode! !

!XMLNodeWithChildren methodsFor: 'removing' stamp: 'monty 11/19/2014 20:24'!
removeNode: aNode ifAbsent: aBlock
	^ self nodes remove: aNode ifAbsent: aBlock! !

!XMLNodeWithChildren methodsFor: 'removing' stamp: 'JAAyer 7/20/2010 10:27'!
removeNodes
	self nodes removeAll! !

!XMLNodeWithChildren methodsFor: 'removing' stamp: 'JAAyer 7/20/2010 10:27'!
removeNodes: aNodeCollection
	^ self nodes removeAll: aNodeCollection! !

!XMLNodeWithChildren methodsFor: 'notifying' stamp: 'monty 2/2/2014 02:38'!
removedNode: aNode
	aNode parent: nil! !

!XMLNodeWithChildren methodsFor: 'accessing' stamp: 'monty 8/20/2017 20:33'!
replaceNode: aNode with: aReplacementNode
	"replaces aNode in the receiver with aReplacementNode, or if aReplacementNode
	is already a child of the receiver, just swaps their locations"

	| firstIndex secondIndex |

	firstIndex := self nodes indexOf: aNode.
	(secondIndex := self nodes indexOf: aReplacementNode) > 0
		ifTrue: [
			self nodes
				swap: firstIndex
				with: secondIndex]
		ifFalse: [
			self nodes
				at: firstIndex
				put: aReplacementNode].
	^ aReplacementNode.! !

!XMLNodeWithChildren methodsFor: 'printing' stamp: 'JAA 3/23/2011 09:42'!
writeInnerXMLOn: aWriter
	self nodesDo: [:each | each writeXMLOn: aWriter]! !

!XMLNodeWithChildren methodsFor: 'printing' stamp: 'JAA 3/23/2011 09:42'!
writeXMLOn: aWriter
	self writeInnerXMLOn: aWriter! !

XMLNodeWithChildren subclass: #XMLNodeWithElements
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNodeWithElements commentStamp: 'monty 2/27/2016 13:48' prior: 0!
This is an abstract class for nodes with elements.

Instances provide "accessing" messages to retrieve child elements by their name and namespace information. The #elementAt: forms return the first matching element, while the #elementsAt: forms return all matching child elements.

There are three different modes of enumeration: the #elements* enumerating messages enumerate child elements, the #allElements* forms enumerate the receiver (if it's an element) and all descendant elements, and the #descendantElement* forms enumerate descendant elements only.

The #findElementNamed:* forms search the receicer (if it's an element) and descendants for a specific element.

Element name matching is done the qualified and local name, so 'prefix:element-name' will only match 'prefix:element-name' while 'element-name' will match 'element-name', 'prefix:element-name' or 'different-prefix:element-name' and so on.

The inner XML can be accessed as a string using #innerXML and set (reparsed) using #innerXML:.!

XMLNodeWithElements subclass: #XMLDocument
	instanceVariableNames: 'version encoding isStandalone doctypeDeclaration doctypeDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLDocument commentStamp: 'monty 6/16/2015 01:46' prior: 0!
This class represents a document node, which is often the root of a DOM tree. Nodes can access their document ancestor with #document.!

!XMLDocument class methodsFor: 'instance creation' stamp: 'monty 3/24/2015 18:26'!
root: aRoot
	^ self new root: aRoot! !

!XMLDocument methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitDocument: self! !

!XMLDocument methodsFor: 'accessing' stamp: 'JAAyer 7/10/2010 05:16'!
doctypeDeclaration
	^ doctypeDeclaration! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 9/6/2016 00:33'!
doctypeDeclaration: aDoctypeDeclaration
	doctypeDeclaration
		ifNotNil: [doctypeDeclaration parent: nil].

	aDoctypeDeclaration
		ifNotNil: [
			aDoctypeDeclaration hasParent
				ifTrue: [
					"remove it from its current parent"
					aDoctypeDeclaration parent doctypeDeclaration: nil].
			aDoctypeDeclaration parent: self].

	doctypeDeclaration := aDoctypeDeclaration.! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 3/8/2015 10:09'!
doctypeDefinition
	^ doctypeDefinition! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 3/8/2015 10:09'!
doctypeDefinition: aDoctypeDefinition
	doctypeDefinition := aDoctypeDefinition! !

!XMLDocument methodsFor: 'accessing' stamp: 'JAAyer 11/24/2010 13:34'!
document
	^ self! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 3/25/2015 18:55'!
documentRoot
	"returns the root of the DOM tree"
	^ self! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 3/24/2015 18:28'!
encoding	
	^ encoding ifNil: [encoding := '']! !

!XMLDocument methodsFor: 'accessing' stamp: 'mir 1/17/2002 12:57'!
encoding: aString	
	encoding := aString! !

!XMLDocument methodsFor: 'private' stamp: 'monty 3/6/2016 09:24'!
errorCannotHaveNonElementRoot
	XMLDOMException signal: 'Cannot have non-element root'! !

!XMLDocument methodsFor: 'testing' stamp: 'monty 5/9/2015 03:10'!
hasDoctypeDeclaration
	^ self doctypeDeclaration notNil! !

!XMLDocument methodsFor: 'testing' stamp: 'monty 5/9/2015 03:11'!
hasDoctypeDefinition
	^ self doctypeDefinition notNil! !

!XMLDocument methodsFor: 'testing' stamp: 'monty 3/6/2016 09:12'!
hasEncoding
	^ self encoding notEmpty! !

!XMLDocument methodsFor: 'testing' stamp: 'monty 3/6/2016 09:35'!
hasRoot
	^ self root notNil! !

!XMLDocument methodsFor: 'private' stamp: 'monty 10/6/2017 14:12'!
innerXMLStateClass
	^ XMLPostDoctypeDeclarationState! !

!XMLDocument methodsFor: 'testing' stamp: 'JAAyer 2/19/2010 23:51'!
isDocument
	^ true! !

!XMLDocument methodsFor: 'testing' stamp: 'monty 11/19/2013 05:38'!
isStandalone
	^ isStandalone ifNil: [isStandalone := false]! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 11/19/2013 05:40'!
isStandalone: aBoolean
	isStandalone := aBoolean! !

!XMLDocument methodsFor: 'copying' stamp: 'monty 11/22/2014 08:20'!
postCopy
	super postCopy.

	doctypeDeclaration
		ifNotNil: [doctypeDeclaration := doctypeDeclaration copy].! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 10/2/2017 13:44'!
root
	"Returns the current root element or nil if there isn't one"

	^ self firstElement! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 10/2/2017 13:43'!
root: anElement
	"Replaces the current root element (if any) with anElement,
	leaving all other nodes in place"

	anElement isElement
		ifFalse: [self errorCannotHaveNonElementRoot].

	self firstElement
		ifNil: [self addNode: anElement]
		ifNotNil: [:firstElement |
			self
				replaceNode: firstElement
				with: anElement].! !

!XMLDocument methodsFor: 'validating' stamp: 'monty 9/21/2016 13:56'!
validate
	"revalidate against the DTD it was parsed with (if any)"

	self hasDoctypeDefinition
		ifTrue: [
			self doctypeDefinition
				removeElementIDReferences;
				removeElementIDs.
			self validateWith: self doctypeDefinition newValidator]! !

!XMLDocument methodsFor: 'validating' stamp: 'monty 7/27/2016 07:51'!
validateWith: aValidator
	"revalidate against a custom DTD or other validator"

	(XMLValidatingNodeVisitor validator: aValidator) visitDocument: self! !

!XMLDocument methodsFor: 'accessing' stamp: 'JAAyer 2/25/2010 01:48'!
version	
	^ version! !

!XMLDocument methodsFor: 'accessing' stamp: 'monty 6/15/2015 04:17'!
version: aVersionFloat
	version := aVersionFloat! !

!XMLDocument methodsFor: 'printing' stamp: 'monty 5/9/2015 03:11'!
writeDoctypeDeclarationOn: aWriter
	self hasDoctypeDeclaration
		ifTrue: [self doctypeDeclaration writeXMLOn: aWriter]! !

!XMLDocument methodsFor: 'printing' stamp: 'monty 5/7/2015 18:53'!
writeXMLDeclarationOn: aWriter
	self version
		ifNotNil: [
			aWriter xml
				version: self version;
				encoding: self encoding;
				standalone: self isStandalone;
				write]! !

!XMLDocument methodsFor: 'printing' stamp: 'monty 5/7/2015 18:53'!
writeXMLOn: aWriter
	self
		writeXMLDeclarationOn: aWriter;
		writeDoctypeDeclarationOn: aWriter;
		writeInnerXMLOn: aWriter! !

XMLNodeWithElements subclass: #XMLElement
	instanceVariableNames: 'name localName attributes namespaceScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLElement commentStamp: 'monty 4/6/2016 22:20' prior: 0!
The class represents an element node, which has a qualified or unqualified name and optionally attributes, namespace declarations and child nodes.

Element names can be tested using #isNamed: and #isNamedAny:, which test both the qualified and local name.

If the name is qualified and namespace support is enabled (the default), then the prefix must be mapped to a namespace URI in the element or an ancestor. The class-side instance creation #name:namespaceURI:* and #name:namespaces:* messages and the instance-side #name:namespaceURI: message can set both simultaneously. If namespace support is disabled, prefixes are not checked.

The #attribute* messages provide a Dictionary-like protocol for manipulating attribute nodes. Unlike the #elementAt:* messages, they match qualified names only, and attribute value accessors return empty strings if the attribute is absent. The underlying attribute node list can be accessed using #attributeNodes (copy before modifying if you don't want to change the element's attributes), and the names/values can be obtained as an (order-preserving) dictionary using #attributes.

See the superclasses for more info.!

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 6/5/2017 16:36'!
name: aLocalName
	^ self named: aLocalName! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/20/2016 19:42'!
name: aLocalName attributes: anAssociationCollection
	"Returns a new element with the specified name and attributes.

	Both aLocalName and the attributes must not be prefixed or a namespace
	exception will be thrown.

	The anAssociationCollection argument can be a dictionary or any collection
	of associations."

	^ (self named: aLocalName)
		setAttributes: anAssociationCollection! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/20/2016 19:44'!
name: aQualifiedName namespaceURI: aURI
	"Returns a new element with the specified name and namespace URI.

	If aQualifiedName has a prefix, then aURI must be non-empty and the prefix
	will be bound to it. Otherwise aURI will be declared as the default namespace."

	^ self new
		name: aQualifiedName
		namespaceURI: aURI! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/20/2016 19:45'!
name: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection
	"Returns a new element with the specified name, namespace URI, and attributes.

	If aQualifiedName has a prefix, then aURI must be non-empty and the prefix
	will be bound to it. Otherwise aURI will be declared as the default namespace.
	If the attributes are prefixed, then aQualifiedName must have the same prefix
	or a namespace exception will be thrown.

	The anAssociationCollection argument can be a dictionary or any collection
	of associations."

	^ (self
		name: aQualifiedName
		namespaceURI: aURI)
			setAttributes: anAssociationCollection! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/26/2016 03:12'!
name: aQualifiedName namespaces: anAssociationCollection
	"Returns a new element with the specified name and namespaces.

	If aQualifiedName has a prefix, then anAssociationCollection must contain
	an association for it or a namespace exception will be thrown.

	The anAssociationCollection argument can be a dictionary or any collection
	of associations. An association with an empty string key sets the default
	namespace."

	^ self new
		declareNamespaces: anAssociationCollection;
		name: aQualifiedName! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/26/2016 03:13'!
name: aQualifiedName namespaces: aNamespaceAssociationCollection attributes: anAttributeAssociationCollection
	"Returns a new element with the specified name, namespaces, and attributes.

	If aQualifiedName or one of the attributes has a prefix, then
	aNamespaceAssociationCollection must contain an association for it or a
	namespace exception will be thrown.

	The aNamespaceAssociationCollection and anAttributeAssociationCollection
	arguments can be dictionaries or any collection of associations. An
	association with an empty string key sets the default namespace."

	^ (self
		name: aQualifiedName
		namespaces: aNamespaceAssociationCollection)
			setAttributes: anAttributeAssociationCollection! !

!XMLElement class methodsFor: 'instance creation' stamp: 'monty 8/26/2016 00:24'!
named: aLocalName
	"Returns a new element with the specified name.

	The argument must not be prefixed or a namespace exception will be thrown."

	^ self new name: aLocalName! !

!XMLElement methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElement: self! !

!XMLElement methodsFor: 'notifying' stamp: 'monty 8/28/2016 06:53'!
addedAttribute: anAttribute
	anAttribute element
		ifNotNil: [:element |
			element == self
				ifFalse: [element removeAttributeNode: anAttribute]].
	anAttribute element: self.
	self validateAttributeNamespacePrefixes.! !

!XMLElement methodsFor: 'private' stamp: 'monty 9/8/2016 07:44'!
addedElement: anElement
	(self hasNamespaces
		and: [self namespaceScope ~= anElement namespaceScope])
		ifTrue: [
			anElement allNamespaceScopesDo: [:each |
				each inheritMappingsFrom: self namespaceScope]]! !

!XMLElement methodsFor: 'enumerating' stamp: 'monty 4/19/2016 08:57'!
allElementsDo: aBlock
	"evaluates aBlock for the receiver and all descendant elements"

	aBlock value: self.
	self hasChildren
		ifTrue: [self elementsDo: [:each | each allElementsDo: aBlock]].! !

!XMLElement methodsFor: 'private' stamp: 'monty 3/2/2016 13:51'!
allNamespaceScopesDo: aBlock
	self allElementsDo: [:each |
		aBlock value: each namespaceScope]! !

!XMLElement methodsFor: 'private' stamp: 'monty 2/26/2016 08:05'!
allNamespaceScopesDo: aBlock whileTrue: aConditionalBlock
	"Updates the receiver's scope and the scopes of all descendants with aBlock
	where aConditional is true but does not validate the namespaces after"

	(aConditionalBlock value: self namespaceScope)
		ifTrue: [
			aBlock value: self namespaceScope.
			self elementsDo: [:each |
				each
					allNamespaceScopesDo: aBlock
					whileTrue: aConditionalBlock]]! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/26/2016 05:32'!
allNamespaceScopesWithValidationDo: aBlock whileTrue: aConditionalBlock
	"Updates the receiver's scope and the scopes of all descendants with aBlock
	where aConditional is true and validates the namespaces after"

	(aConditionalBlock value: self namespaceScope)
		ifTrue: [
			aBlock value: self namespaceScope.
			self
				validateNamespacePrefix;
				validateAttributeNamespacePrefixes.
			self elementsDo: [:each |
				each
					allNamespaceScopesWithValidationDo: aBlock
					whileTrue: aConditionalBlock]]! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 03:52'!
attributeAssociations
	"returns attribute name->value associations"

	^ self attributeNodes attributeAssociations! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:20'!
attributeAt: aName
	"returns the value of the attribute whose full name matches aName or an
	empty string if there isn't any"

	^ self attributeNodes attributeValueAt: aName! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:21'!
attributeAt: aName ifAbsent: aBlock
	"returns the value of the attribute whose full name matches aName or the
	value of aBlock if there isn't any"

	^ self attributeNodes
		attributeValueAt: aName
		ifAbsent: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:22'!
attributeAt: aName ifAbsentPut: aBlock
	"sets the value of the attribute whose full name matches aName to the value
	of aBlock if there isn't one already"

	^ self attributeNodes
		attributeValueAt: aName
		ifAbsentPut: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:22'!
attributeAt: aName put: aValue
	"sets the value of the attribute whose full name matches aName to the value
	aValue"

	^ self attributeNodes
		attributeValueAt: aName
		put: aValue! !

!XMLElement methodsFor: 'defaults' stamp: 'monty 9/2/2016 05:46'!
attributeListClass
	^ self configuration nodeFactory attributeListClass! !

!XMLElement methodsFor: 'accessing' stamp: 'JAAyer 6/25/2010 22:08'!
attributeNames
	^ self attributeNodes attributeNames! !

!XMLElement methodsFor: 'enumerating' stamp: 'JAAyer 6/25/2010 22:14'!
attributeNamesAndValuesDo: aTwoArgumentBlock
	self attributeNodes attributeNamesAndValuesDo: aTwoArgumentBlock! !

!XMLElement methodsFor: 'enumerating' stamp: 'JAAyer 6/25/2010 22:09'!
attributeNamesDo: aBlock
	self attributeNodes attributeNamesDo: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:24'!
attributeNodeAt: aName
	"returns the attribute node whose qualified or local name matches aName
	(unlike attributeAt:, which matches the full name exactly), or nil if there
	isn't any"

	^ self attributeNodes attributeNodeAt: aName! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:24'!
attributeNodeAt: aName ifAbsent: aBlock
	"returns the attribute node whose qualified or local name matches aName
	(unlike attributeAt:ifAbsent:, which matches the full name exactly), or
	the value of aBlock if there isn't any"

	^ self attributeNodes
		attributeNodeAt: aName
		ifAbsent: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/21/2016 07:38'!
attributeNodeAt: aName namespaceURI: aURI
	"returns the attribute node whose qualified or local name matches aName
	(unlike attributeAt:, which matches the full name exactly) and whose
	namespace URI matches aURI, or nil if there isn't any"

	^ self attributeNodes
		attributeNodeAt: aName
		namespaceURI: aURI! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/21/2016 07:39'!
attributeNodeAt: aName namespaceURI: aURI ifAbsent: aBlock
	"returns the attribute node whose qualified or local name matches aName
	(unlike attributeAt:ifAbsent:, which matches the full name exactly) and
	whose namespace URI matches aURI, or the value of aBlock if there isn't any"

	^ self attributeNodes
		attributeNodeAt: aName
		namespaceURI: aURI
		ifAbsent: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:29'!
attributeNodes
	"Returns the attribute node list. Can be modified, but adding or removing
	attributes also adds or removes them from the element. Copy before
	modifying if you don't want that."

	^ attributes ifNil: [attributes := self attributeListClass observer: self]! !

!XMLElement methodsFor: 'enumerating' stamp: 'monty 11/26/2014 19:13'!
attributeNodesDo: aBlock
	self attributeNodes do: aBlock! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:29'!
attributes
	"returns a new order preserving dictionary of attribute names and values"

	^ self attributeNodes attributes! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/23/2017 01:29'!
declareNamespaces: anAssociationCollection
	self ensureUsesNamespaces.
	anAssociationCollection associationsDo: [:each |
		self
			declarePrefix: each key
			uri: each value]! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/22/2017 06:49'!
declarePrefix: aPrefix uri: aURI
	| oldMapping |

	self ensureUsesNamespaces.
	oldMapping :=
		self namespaceScope
			prefixMappingAt: aPrefix
			ifAbsent: [nil].
	(oldMapping notNil
		and: [oldMapping = aURI])
		ifFalse: [
			self
				allNamespaceScopesDo: [:scope |
					scope
						mapPrefix: aPrefix
						to: aURI]
				whileTrue: [:scope |
					(scope includesPrefix: aPrefix) not
						or: [
							scope
								includesPrefix: aPrefix
								mappedTo: oldMapping]]].! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/21/2017 02:54'!
declaredPrefixes
	^ self usesNamespaces "avoid lazy initializing the scope"
		ifTrue: [self namespaceScope mappedPrefixes]
		ifFalse: [#()]! !

!XMLElement methodsFor: 'testing' stamp: 'monty 7/20/2015 21:18'!
declaresDefaultNamespace
	"Did the receiver declare a new default namespace rather than inheriting one?"

	^ self namespaceScope hasDefaultNamespace
		and: [self isRoot
			or: [self defaultNamespace ~= self parent defaultNamespace]]! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/17/2017 03:36'!
declaresPrefix: aPrefix uri: aURI
	"Did the receiver declare a new prefix/uri pair rather than inheriting it?"

	^ (self isDeclaredPrefix: aPrefix uri: aURI)
		and: [self isRoot
			or: [(self parent isDeclaredPrefix: aPrefix uri: aURI) not]]! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/21/2017 02:54'!
defaultNamespace
	^ self usesNamespaces "avoid lazy initializing the scope"
		ifTrue: [self namespaceScope defaultNamespace]
		ifFalse: ['']! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/21/2017 03:03'!
defaultNamespace: aURI
	"unlike non-default namespaces, the uri can be empty to shadow an
	inherited default namesapce"
	| oldNamespace |

	self ensureUsesNamespaces.
	oldNamespace := self defaultNamespace.
	self
		allNamespaceScopesDo: [:scope |
			scope defaultNamespace: aURI]
		whileTrue: [:scope |
			scope defaultNamespace = oldNamespace].! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 2/26/2017 08:55'!
expandedName
	"Returns the expanded name of the element as a string in the form of
	'{namespaceURI}localName' if there's a namespace URI or 'localName' if there
	isn't"

	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/20/2016 10:55'!
hasAttributes
	"returns true if this element has attribute"

	"optimized to avoid lazy initialization"
	attributes == nil
		ifTrue: [^ false].
	^ attributes size > 0.! !

!XMLElement methodsFor: 'testing' stamp: 'monty 3/20/2017 22:36'!
hasID: anID
	| document doctypeDefinition attributeValidators |

	self hasAttributes
		ifFalse: [^ false].

	((document := self document) notNil
		and: [(doctypeDefinition := document doctypeDefinition) notNil
			and: [doctypeDefinition hasAttributeValidators
				and: [
					(attributeValidators :=
						doctypeDefinition attributeValidatorsAt: self name) notNil]]])
		ifTrue: [
			^ self
				hasUndeclaredOrDeclaredID: anID
				declaredWith: attributeValidators]
		ifFalse: [^ self hasUndeclaredID: anID].! !

!XMLElement methodsFor: 'testing' stamp: 'monty 2/13/2015 22:20'!
hasNamespaceURI
	^ self namespaceURI notEmpty! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/20/2016 10:56'!
hasNamespaces
	"returns true if the receiver declared or inherited namespace declarations"

	"optimized to avoid lazy initialization"
	namespaceScope == nil
		ifTrue: [^ false].
	^ namespaceScope hasNamespaces.! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 09:25'!
hasPrefix
	"returns true if the receiver's name is a qualified name with a prefix"

	^ self name size > self localName size! !

!XMLElement methodsFor: 'private' stamp: 'monty 3/20/2017 22:45'!
hasUndeclaredID: anID
	"just look for an 'xml:id' attribute if there were no declarations"
	^ (self
		attributeAt: 'xml:id'
		ifAbsent: [^ false]) = anID! !

!XMLElement methodsFor: 'private' stamp: 'monty 3/20/2017 23:20'!
hasUndeclaredOrDeclaredID: anID declaredWith: anAttributeValidatorDictionary
	self attributeNamesAndValuesDo: [:attributeName :attributeValue |
		"only check its value if it's been declared as an ID attribute
		or if it's named 'xml:id'"
		((anAttributeValidatorDictionary
			at: attributeName
			ifAbsent: [nil])
				ifNil: [attributeName = 'xml:id']
				ifNotNil: [:attributeValidator | attributeValidator isID])
			ifTrue: [
				attributeValue = anID
					ifTrue: [^ true]]].
	^ false.! !

!XMLElement methodsFor: 'testing' stamp: 'monty 3/20/2017 22:46'!
includesAttribute: aName
	^ self attributeNodes includesAttribute: aName! !

!XMLElement methodsFor: 'testing' stamp: 'monty 3/20/2017 22:46'!
includesAttributeNode: aName
	^ self attributeNodes includesAttributeNode: aName! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 10:35'!
includesAttributeNode: aName namespaceURI: aURI
	^ self attributeNodes
		includesAttributeNode: aName
		namespaceURI: aURI! !

!XMLElement methodsFor: 'testing' stamp: 'monty 8/21/2017 02:56'!
isDeclaredPrefix: aPrefix
	"is the namespace prefix aPrefix declared for the receiver and its descendants?"

	^ self usesNamespaces
		and: [self namespaceScope includesPrefix: aPrefix]! !

!XMLElement methodsFor: 'testing' stamp: 'monty 8/21/2017 02:56'!
isDeclaredPrefix: aPrefix uri: aURI
	"is the namespace prefix aPrefix mapped to aURI for the receiver and
	its descendants?"

	^ self usesNamespaces
		and: [
			self namespaceScope
				includesPrefix: aPrefix
				mappedTo: aURI]! !

!XMLElement methodsFor: 'testing' stamp: 'JAAyer 4/11/2010 22:59'!
isElement
	^ true! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 09:24'!
isElementNamed: aName
	"returns true if the receiver's qualified name or local name matches aName"

	^ self isNamed: aName! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 09:24'!
isElementNamedAny: aNameCollection
	"returns true if the receiver's qualified name or local name matches any
	name in aNameCollection"

	^ self isNamedAny: aNameCollection! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/20/2016 10:57'!
isInLanguage: aLanguage
	"Returns true if the receiver or one of its ancestors has an xml:lang
	attribute, and if the value is an IETF language tag that matches aLanguage
	or if its first ('-' separated) subtag matches aLanguage."

	^ (self
		attributeNodeAt: 'xml:lang'
		ifAbsent: [
			^ self hasParent
				and: [self parent isInLanguage: aLanguage]])
			hasLanguage: aLanguage! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/17/2017 03:37'!
isNamed: aName
	"Does the receiver's qualified or local name match aName?"

	^ self name isXMLQualifiedOrLocalName: aName! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 09:25'!
isNamedAny: aNameCollection
	"Does the receiver's qualified or local name match any of the names
	in aNameCollection?"

	^ aNameCollection includesXMLName: self name! !

!XMLElement methodsFor: 'testing' stamp: 'monty 4/19/2016 03:57'!
isRoot
	"Is the receiver the root element of a DOM tree?"

	^ (self hasParent and: [self parent isElement]) not! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 9/5/2016 07:11'!
localName
	"Returns the local name of the receiver, the name minus any leading
	prefix and colon like 'local' in 'prefix:local'"

	^ localName ifNil: [localName := self name xmlLocalNameAfterPrefix]! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:32'!
name
	"returns the full name of the element, either a qualified name if it has a
	prefix or just a local name if it doesn't"

	^ name ifNil: [name := '']! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:33'!
name: aName
	"Renames the element. If aName is a qualified name and namespace checking is
	enabled (default), then the prefix must already have been declared. This can
	be done while renaming using name:namespaceURI."

	self renameWith: [
		name := aName.
		localName := aName xmlLocalNameAfterPrefix]! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:34'!
name: aName namespaceURI: aURI
	"Renames the element and also declares a namespace URI in one step. If aName
	is qualified, then it declares the prefix to be mapped to aURI. If aName has
	no prefix, then aURI is declared as the default namespace URI."

	self
		declarePrefix: (aName xmlPrefixBeforeLocalName) uri: aURI;
		name: aName! !

!XMLElement methodsFor: 'private' stamp: 'JAAyer 6/20/2010 23:10'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XMLElement methodsFor: 'accessing' stamp: 'JAAyer 3/14/2010 12:52'!
namespaceURI
	^ self resolvePrefix: self prefix! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/17/2017 07:38'!
newNamespaceScopeForAddedElement
	^ self usesNamespaces
		ifTrue: [self namespaceScope copy]
		ifFalse: [nil]! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:36'!
nextElement
	"returns the first element after the receiver that is a child of the same
	parent if there is one, nil otherwise"

	^ self parent ifNotNil: [:node | node elementAfter: self]! !

!XMLElement methodsFor: 'copying' stamp: 'monty 3/1/2016 14:00'!
postCopy
	super postCopy.

	namespaceScope
		ifNotNil: [namespaceScope := namespaceScope copy].
	attributes
		ifNotNil: [| copiedAttributes |
			copiedAttributes := attributes copyEmpty observer: self.
			attributes do: [:each | copiedAttributes addLast: each copy].
			attributes := copiedAttributes].! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 8/27/2016 17:39'!
prefix
	"Returns the prefix of the receiver's name or an empty string if there
	isn't one."

	"this is recomputed from the qualified and local name instead of being
	stored in an inst var to save memory."
	^ self name xmlPrefixBeforeLocalName: self localName! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:39'!
prefix: aPrefix
	"Changes the prefix of the name of the receiver to aPrefix. If namespace
	checking is enabled (default) and aPrefix is non-empty, then aPrefix must
	have been declared."

	self renameWith: [name := self localName qualifyWithXMLPrefix:  aPrefix]! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 4/19/2016 08:36'!
previousElement
	"returns the first element before the receiver that is a child of the same
	parent if there is one, nil otherwise"

	^ self parent ifNotNil: [:node | node elementBefore: self]! !

!XMLElement methodsFor: 'removing' stamp: 'monty 8/27/2016 21:51'!
removeAttribute: aName
	"Removes and returns the value of the attribute whose full name matches
	aName or raises an error if it's absent."

	^ (self attributeNodes removeAttribute: aName) value.! !

!XMLElement methodsFor: 'removing' stamp: 'monty 8/27/2016 21:51'!
removeAttribute: aName ifAbsent: aBlock
	"Removes and returns the value of the attribute whose full name matches
	aName or returns the value of aBlock if it's absent."

	^ self attributeNodes
		removeAttribute: aName
		ifAbsent: aBlock! !

!XMLElement methodsFor: 'removing' stamp: 'monty 8/27/2016 21:53'!
removeAttributeNode: aNode
	"Removes and returns the attribute node aNode or raises an error if
	it's absent."

	^ self attributeNodes remove: aNode! !

!XMLElement methodsFor: 'removing' stamp: 'monty 9/20/2016 21:57'!
removeAttributeNode: aNode ifAbsent: aBlock
	"Removes and returns the attribute node aNode or returns the value
	of aBlock if it's absent."

	^ self attributeNodes
		remove: aNode
		ifAbsent: aBlock! !

!XMLElement methodsFor: 'removing' stamp: 'monty 11/23/2014 00:29'!
removeAttributes
	self attributeNodes removeAll! !

!XMLElement methodsFor: 'notifying' stamp: 'monty 10/18/2014 00:43'!
removedAttribute: anAttribute
	anAttribute element: nil! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/26/2016 05:32'!
renameWith: aBlock
	| oldName |

	oldName := self name.
	aBlock value.
	self name = oldName
		ifFalse: [
			self validateNamespacePrefix.
			self hasParent
				ifTrue: [
					self parent
						renamedElement: self
						from: oldName
						to: self name]].! !

!XMLElement methodsFor: 'notifying' stamp: 'monty 8/26/2016 05:32'!
renamedAttribute: anAttribute from: anOldName to: aNewName
	self attributeNodes	
		renamedAttribute: anAttribute
		from: anOldName
		to: aNewName.
	self validateAttributeNamespacePrefixes.! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 3/20/2016 23:55'!
resolvePrefix: aPrefix
	"Resolves the namespace URI of aPrefix (the defualt namespace URI if aPrefix
	is empty), including the predefined 'xml' and 'xmlns' prefixes. Returns an
	empty string if aPrefix is unresolvable."

	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: ''! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/22/2017 06:50'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	"Resolves the namespace URI of aPrefix (the defualt namespace URI if aPrefix
	is empty), including the predefined 'xml' and 'xmlns' prefixes. Returns the
	value of aBlock if aPrefix is unresolvable."

	^ self hasNamespaces "avoid lazy initializing the scope"
		ifTrue: [
			self namespaceScope
				resolvePrefix: aPrefix
				ifUnresolvable: aBlock]
		ifFalse: [aBlock value]! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/21/2017 03:04'!
resolvePrefixesOfNamespaceURI: aURI
	"returns a set of all the namespace prefixes of aURI"
	^ self usesNamespaces
		ifTrue: [self namespaceScope resolvePrefixesOfNamespaceURI: aURI]
		ifFalse: [Set new]! !

!XMLElement methodsFor: 'initialization' stamp: 'monty 4/11/2016 03:25'!
setAttributes: anAssociationCollection
	self attributeNodes setAttributes: anAssociationCollection! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/10/2017 00:29'!
setConfiguration: aConfiguration name: aName localName: aLocalName attributes: anAttributeDictionary namespaceScope: aNamespaceScope
	"This should only be sent by DOM parsers/builders, not public API users"

	configuration := aConfiguration.
	name := aName.
	localName := aLocalName.
	anAttributeDictionary size > 0 "optimization"
		ifTrue: [
			"This consumes anAttributeDictionary, so it can never be used
			again safely"
			(attributes :=
				self attributeListClass new: anAttributeDictionary size)
				observer: self;
				setAttributesFromOrderPreservingDictionary: 
					anAttributeDictionary].
	namespaceScope := aNamespaceScope.! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/10/2017 00:28'!
setNamespaceScope: aNamespaceScope
	namespaceScope := aNamespaceScope! !

!XMLElement methodsFor: 'accessing' stamp: 'monty 12/2/2014 22:57'!
sortKey
	^ self name! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 11/24/2014 06:54'!
undeclareDefaultNamespace
	self undeclarePrefix: ''! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 8/21/2017 03:04'!
undeclarePrefix: aPrefix
	| currentNamespaceURI |

	self ensureUsesNamespaces.
	currentNamespaceURI :=
		self namespaceScope
			prefixMappingAt: aPrefix
			ifAbsent: [^ self].
	self
		allNamespaceScopesWithValidationDo: [:scope |
			scope unmapPrefix: aPrefix]
		whileTrue: [:scope |
			scope
				includesPrefix: aPrefix
				mappedTo: currentNamespaceURI].! !

!XMLElement methodsFor: 'namespacing' stamp: 'monty 9/3/2017 07:46'!
undeclarePrefixes
	self ensureUsesNamespaces.
	self declaredPrefixes do: [:each |
		self undeclarePrefix: each].! !

!XMLElement methodsFor: 'private' stamp: 'monty 10/2/2017 13:46'!
validateAttributeNamespacePrefixes
	"This is similar to #validatePrefixesOfAttributes:from:to:, but for
	a collection of XMLAttributes instead of attribute names.

	Not performance critical because it's only used after parsing when
	an attribute is added or renamed in a parsed DOM tree."

	self usesNamespaces
		ifTrue: [| attributeLocalNamesAndURIs |
			self attributeNodesDo: [:attribute |
				attributeLocalNamesAndURIs := 
					self namespaceScope
						validatePrefixesAttribute: attribute name
						hasNoAliasIn: attributeLocalNamesAndURIs]]! !

!XMLElement methodsFor: 'private' stamp: 'monty 8/26/2016 05:33'!
validateNamespacePrefix
	(self usesNamespaces
		and: [self hasPrefix])
		ifTrue: [
			self namespaceScope
				validateAndResolvePrefix: self prefix
				ofElement: self name]! !

!XMLElement methodsFor: 'printing' stamp: 'monty 3/2/2016 12:18'!
writeXMLOn: aWriter
	| tagWriter |

	tagWriter := aWriter tag: self name.
	self hasNamespaces
		ifTrue: [
			"non-standard setXMLNSDeclarations: use for performance"
			tagWriter setXMLNSDeclarations: self namespaceScope prefixMappings].
	self hasAttributes
		ifTrue: [
			"non-standard setAttributes: use for performance"
			tagWriter setAttributes: self attributeNodes].
	self hasChildren
		ifTrue: [tagWriter with: [self writeInnerXMLOn: aWriter]]
		ifFalse: [tagWriter write].! !

!XMLNodeWithElements methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNodeWithElements: self! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/17/2016 00:10'!
addCData: aString
	^ self addNode: (self newCData: aString)! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/17/2016 00:09'!
addContent: aStringOrStringNode
	"will be deprecated; use #addString: instead"

	(self hasChildren
		and: [self lastNode isCoalescingStringNode])
		ifTrue: [self lastNode append: aStringOrStringNode]
		ifFalse: [self addNode:
			(aStringOrStringNode isString
				ifTrue: [self nodeFactory newStringNode: aStringOrStringNode]
				ifFalse: [aStringOrStringNode])].
	"returns self for backwards compatibility"! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/14/2016 17:13'!
addElement: anElement
	self deprecated:
		'Use #addNode: with an element argument or #addElementNamed: instead'.

	self addNode: anElement.
	"returns self for backwards compatibility"! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/17/2017 07:39'!
addElementNamed: aName
	"adds and returns a new element with the specified name"

	| addedElementNamespaceScope addedElementNamespaceURI addedElement |

	addedElementNamespaceScope := self newNamespaceScopeForAddedElement.
	addedElementNamespaceURI :=
		self
			namespaceURIOfAddedElementNamed: aName
			withScope: addedElementNamespaceScope.
	"added first to inherit the config before setting the name"
	addedElement :=
		self addNode:
			((self nodeFactory
				classForElement: aName
				namespaceURI: addedElementNamespaceURI) new
				setNamespaceScope: addedElementNamespaceScope).
	^ addedElement name: aName.! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/17/2017 07:41'!
addElementNamed: aName attributes: anAssociationCollection
	"adds and returns a new element with the specified name and attributes"

	| addedElementNamespaceScope addedElementNamespaceURI addedElementAttributeDictionary addedElement |

	addedElementNamespaceScope := self newNamespaceScopeForAddedElement.
	addedElementNamespaceURI :=
		self
			namespaceURIOfAddedElementNamed: aName
			withScope: addedElementNamespaceScope.
	addedElementAttributeDictionary :=
		self
			newAttributeDictionaryFrom: anAssociationCollection
			forAddedElementWithScope: addedElementNamespaceScope.
	"added first to inherit the config before setting the name and attributes"
	addedElement :=
		self addNode:
			((self nodeFactory
				classForElement: aName
				namespaceURI: addedElementNamespaceURI
				attributes: addedElementAttributeDictionary) new
				setNamespaceScope: addedElementNamespaceScope).
	^ addedElement
		name: aName;
		setAttributes: addedElementAttributeDictionary.! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/17/2017 07:44'!
addElementNamed: aName namespaceURI: aURI
	"adds and returns a new element with the specified name and namespace
	URI"

	| addedElementNamespaceScope addedElement |

	addedElementNamespaceScope :=
		self
			newNamespaceScopeForAddedElementNamed: aName
			namespaceURI: aURI.
	"added first to inherit the config before setting the name"
	addedElement :=
		self addNode:
			((self nodeFactory
				classForElement: aName
				namespaceURI: aURI) new
				setNamespaceScope: addedElementNamespaceScope).
	^ addedElement name: aName.! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/17/2017 07:41'!
addElementNamed: aName namespaceURI: aURI attributes: anAssociationCollection
	"adds and returns a new element with the specified name, namespace URI,
	and attributes"

	| addedElementNamespaceScope addedElementAttributeDictionary addedElement |

	addedElementNamespaceScope :=
		self
			newNamespaceScopeForAddedElementNamed: aName
			namespaceURI: aURI.
	addedElementAttributeDictionary :=
		self
			newAttributeDictionaryFrom: anAssociationCollection
			forAddedElementWithScope: addedElementNamespaceScope.
	"added first to inherit the config before setting the name and attributes"
	addedElement :=
		self addNode:
			((self nodeFactory
				classForElement: aName
				namespaceURI: aURI
				attributes: addedElementAttributeDictionary) new
				setNamespaceScope: addedElementNamespaceScope).
	^ addedElement
		name: aName;
		setAttributes: addedElementAttributeDictionary.! !

!XMLNodeWithElements methodsFor: 'adding' stamp: 'monty 8/14/2016 21:46'!
addString: aString
	"Adds a new string node for aString or just appends aString to the
	last node if it's a coalescing string node (not CDATA).

	Returns the new string node or the string node appeneded to."

	| lastNode |

	(self hasChildren
		and: [(lastNode := self lastNode) isCoalescingStringNode])
		ifTrue: [^ lastNode append: aString]
		ifFalse: [^ self addNode: (self nodeFactory newStringNode: aString)]! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 9/8/2016 07:43'!
addedElement: anElement! !

!XMLNodeWithElements methodsFor: 'notifying' stamp: 'monty 9/8/2016 07:44'!
addedNode: aNode
	super addedNode: aNode.
	aNode isElement
		ifTrue: [
			aNode configuration: self configuration.
			self addedElement: aNode].! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:06'!
allElements
	"returns a node list with all descendant elements (and the receiver if
	it's an element)"
	| allElements |

	allElements := self newListForSelect.
	self allElementsDo: [:each | allElements addLast: each].
	^ allElements.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 12:07'!
allElementsCollect: aBlock
	"returns an ordered list of the values of evaluating all descendant
	elements (and the receiver if it's an element) with aBlock"
	| collectedObjects |

	collectedObjects := self newListForCollect.
	self allElementsDo: [:each | collectedObjects addLast: (aBlock value: each)].
	^ collectedObjects.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'JAAyer 11/25/2010 10:47'!
allElementsDetect: aBlock
	"Descend depth-first visiting each element with aBlock until one such evaluation
	of aBlock with an element is true, then return that element. If no evaluation is
	true, then return nil."

	^ self allElementsDetect: aBlock ifNone: [nil]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:15'!
allElementsDetect: aBlock ifNone: anExceptionBlock
	"Descend depth-first visiting each element with aBlock until one such evaluation
	of aBlock with an element is true, then return that element. If no evaluation is
	true, then return the value of anExceptionBlock."

	self allElementsDo: [:each |
		(aBlock value: each)
			ifTrue: [^ each]].
	^ anExceptionBlock value.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 12:08'!
allElementsDo: aBlock
	"evaluates all descendant elements (and the receiver if it's an
	element) with aBlock"

	self hasChildren
		ifTrue: [self elementsDo: [:each | each allElementsDo: aBlock]]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:06'!
allElementsNamed: aName
	"returns a node list with all descendant elements (and the receiver if
	it's an element) whose qualified or local names match aName"

	^ self allElementsSelect: [:each | each isNamed: aName]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 12:08'!
allElementsNamed: aName do: aBlock
	"evaluates all descendant elements (and the receiver if it's an
	element) whose qualified or local names match aName with aBlock"

	self allElementsDo: [:each |
		(each isNamed: aName)
			ifTrue: [aBlock value: each]]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:12'!
allElementsNamed: aName namespaceURI: aURI
	"returns a node list with all descendant elements (and the receiver if
	it's an element) whose qualified or local names match aName and whose
	namespace URIs matches aURI"

	^ self allElementsSelect: [:each |
		(each isNamed: aName)
			and: [each namespaceURI = aURI]]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 12:09'!
allElementsSelect: aBlock
	"returns a new node list with all descendant elements (and the receiver
	if it's an element) that aBlock evaluates true for"

	| selectedElements |

	selectedElements := self newListForSelect.
	self allElementsDo: [:each |
		(aBlock value: each)
			ifTrue: [selectedElements addLast: each]].
	^ selectedElements.! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 11/1/2014 11:42'!
configuration
	^ configuration ifNil: [
		self configuration: self configurationClass new.
		configuration]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 9/8/2016 10:56'!
configuration: aConfiguration
	configuration := aConfiguration.
	self hasChildren
		ifTrue: [
			self elementsDo: [:each |
				each configuration: aConfiguration]].! !

!XMLNodeWithElements methodsFor: 'defaults' stamp: 'monty 11/2/2014 18:52'!
configurationClass
	^ XMLDOMConfiguration! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:40'!
contentNodes
	"returns a node list of the receiver's element and string node children"

	^ self nodes contentNodes! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 12:41'!
contentNodesDo: aBlock
	"evaluates aBlock for all element and string node children of the receiver"

	self nodes contentNodesDo: aBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/20/2016 01:09'!
contentString: aString
	"will be deprecated; use #removeNodes and #addString: instead"

	self
		removeNodes;
		addString: aString! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 8/7/2016 12:51'!
contentStringAt: aName
	"Returns the content string of the first element child of the receiver
	whose qualified or local name matches aName or an empty string if there
	isn't one.

	See also #rawContentStringAt:"

	^ self nodes contentStringAt: aName! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/19/2016 03:47'!
descendantElements
	"returns a node list of all descendant elements"
	| descendentElements |

	descendentElements := self newListForSelect.
	self descendantElementsDo: [:each | descendentElements addLast: each].
	^ descendentElements.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:18'!
descendantElementsCollect: aBlock
	"returns an ordered list of the values of evaluating all descendant
	elements with aBlock"
	| collectedObjects |

	collectedObjects := self newListForCollect.
	self descendantElementsDo: [:each |
		collectedObjects addLast: (aBlock value: each)].
	^ collectedObjects.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:36'!
descendantElementsDetect: aBlock
	"returns the first descendant element that aBlock evaluates true for or
	nil if there isn't one"

	^ self
		descendantElementsDetect: aBlock
		ifNone: [nil]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:36'!
descendantElementsDetect: aBlock ifNone: anExceptionBlock
	"returns the first descendant element that aBlock evaluates true for or
	the value of anExceptionBlock if there isn't one"

	self descendantElementsDo: [:each |
		(aBlock value: each)
			ifTrue: [^ each]].
	^ anExceptionBlock value.! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:18'!
descendantElementsDo: aBlock
	"evaluates all descendant elements with aBlock"

	self hasChildren
		ifTrue: [self elementsDo: [:each | each allElementsDo: aBlock]]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:11'!
descendantElementsNamed: aName
	"returns a node list of all descendant elements whose qualified
	or local names match aName"

	^ self descendantElementsSelect: [:each | each isNamed: aName]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:18'!
descendantElementsNamed: aName do: aBlock
	"evaluates all descendant elements whose qualified or local names
	match aName with aBlock"

	self descendantElementsDo: [:each |
		(each isNamed: aName)
			ifTrue: [aBlock value: each]]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:12'!
descendantElementsNamed: aName namespaceURI: aURI
	"returns a node list of all descendant elements whose qualified
	or local names match aName and whose namespace URIs match aURI"

	^ self descendantElementsSelect: [:each |
		(each isNamed: aName)
			and: [each namespaceURI = aURI]]! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:19'!
descendantElementsSelect: aBlock
	"returns a new node list with all descendant elements that aBlock
	evaluates true for"
	| selectedElements |

	selectedElements := self newListForSelect.
	self descendantElementsDo: [:each |
		(aBlock value: each)
			ifTrue: [selectedElements addLast: each]].
	^ selectedElements.! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElements
	"less common alternate spelling, will be deprecated;
	use #descendantElements instead"

	^ self descendantElements! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsCollect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsCollect: instead"

	^ self descendantElementsCollect: aBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsDetect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsDetect: instead"

	^ self descendantElementsDetect: aBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsDetect: aBlock ifNone: anExceptionBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsDetect:ifNone: instead"

	^ self
		descendantElementsDetect: aBlock
		ifNone: anExceptionBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsDo: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsDo: instead"

	^ self descendantElementsDo: aBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsNamed: aName
	"less common alternate spelling, will be deprecated;
	use #descendantElementsNamed: instead"

	^ self descendantElementsNamed: aName! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsNamed: aName do: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsNamed:do: instead"

	^ self
		descendantElementsNamed: aName
		do: aBlock! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsNamed: aName namespaceURI: aURI
	"less common alternate spelling, will be deprecated;
	use #descendantElementsNamed:namespaceURI: instead"

	^ self
		descendantElementsNamed: aName
		namespaceURI: aURI! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/6/2016 20:56'!
descendentElementsSelect: aBlock
	"less common alternate spelling, will be deprecated;
	use #descendantElementsSelect: instead"

	^ self descendantElementsSelect: aBlock! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:01'!
elementAfter: anElement
	"returns the first element child of the receiver after anElement or nil if
	there isn't one"

	^ self nodes elementAfter: anElement! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:07'!
elementAt: aName
	"returns the first element child of the receiver whose qualified or
	local name matches aName or nil if there isn't one"

	^ self nodes elementAt: aName! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:07'!
elementAt: aName ifAbsent: aBlock
	"returns the first element child of the receiver whose qualified or
	local name matches aName or the value of aBlock if there isn't one"

	^ self nodes
		elementAt: aName
		ifAbsent: aBlock! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:08'!
elementAt: aName namespaceURI: aURI
	"returns the first element child of the receiver whose qualified or
	local name matches aName and whose namespace URI matches aURI or nil
	if there isn't one"

	^ self nodes
		elementAt: aName
		namespaceURI: aURI! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:08'!
elementAt: aName namespaceURI: aURI ifAbsent: aBlock
	"returns the first element child of the receiver whose qualified or
	local name matches aName and whose namespace URI matches aURI or the
	value of aBlock if there isn't one"

	^ self nodes
		elementAt: aName
		namespaceURI: aURI
		ifAbsent: aBlock! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 12:01'!
elementBefore: anElement
	"returns the first element child of the receiver before anElement or
	nil if there isn't one"

	^ self nodes elementBefore: anElement! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 10/26/2014 08:18'!
elementNames
	^ self nodes elementNames! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:06'!
elements
	"returns a new node list of all of the receiver's elements"

	^ self nodes elements! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:13'!
elementsAt: aName
	"returns a node list of all the receiver's elements whose qualified
	or local names match aName"

	^ self nodes elementsAt: aName! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:20'!
elementsAt: aName do: aBlock
	"evaluates aBlock for all element children of the receiver whose
	qualified or local names match aName"

	self nodes
		elementsAt: aName
		do: aBlock! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:13'!
elementsAt: aName namespaceURI: aURI
	"returns a node list of all the receiver's elements whose qualified
	or local names match aName and whose namespace URIs match aURI"

	^ self nodes
		elementsAt: aName
		namespaceURI: aURI! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:23'!
elementsCollect: aBlock
	"returns an ordered list of the values of evaluating the element
	children of the receiver with aBlock"

	^ self nodes elementsCollect: aBlock! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:24'!
elementsDetect: aBlock
	"returns the first element child of the receiver that aBlock evaluates
	true for or nil if there isn't one"

	^ self nodes elementsDetect: aBlock! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:24'!
elementsDetect: aBlock ifNone: anExceptionBlock
	"returns the first element child of the receiver that aBlock evaluates
	true for or the value of anExceptionBlock if there isn't one"

	^ self nodes
		elementsDetect: aBlock
		ifNone: anExceptionBlock! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:21'!
elementsDo: aBlock
	"evaluates aBlock for all element children of the receiver"

	self nodes elementsDo: aBlock! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:21'!
elementsSelect: aBlock
	"returns a node list of all element children of the receiver that
	aBlock evaluates true for"

	^ self nodes elementsSelect: aBlock! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 8/21/2017 03:03'!
ensureUsesNamespaces
	self usesNamespaces: true! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 3/6/2017 11:20'!
errorOuterXMLForAbsentNode
	XMLDOMException signal: 'Cannot change outer XML for absent node'! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 1/5/2015 09:12'!
escapesContentEntitiesWhenWriting
	"avoid initializing config; defualt to true"
	^ configuration isNil
		or: [configuration replacesContentEntityReferences]! !

!XMLNodeWithElements methodsFor: 'searching' stamp: 'monty 4/20/2016 11:48'!
findElementNamed: aName
	"searches the receiver and all descendants for the first element whose
	qualified or local name matches aName"

	^ self allElementsDetect: [:each | each isNamed: aName]! !

!XMLNodeWithElements methodsFor: 'searching' stamp: 'monty 4/20/2016 11:48'!
findElementNamed: aName namespaceURI: aURI
	"searches the receiver and all descendants for the first element whose
	qualified or local name matches aName and whose namespace URI matches aURI"

	^ self allElementsDetect: [:each |
		(each isNamed: aName)
			and: [each namespaceURI = aURI]]! !

!XMLNodeWithElements methodsFor: 'searching' stamp: 'monty 4/20/2016 11:48'!
findElementNamed: aName namespaceURI: aURI with: aBlock
	"searches the receiver and all descendants for the first element whose
	qualified or local name matches aName and whose namespace URI matches
	aURI and that aBlock evaluates true for"

	^ self allElementsDetect: [:each |
		(each isNamed: aName)
			and: [each namespaceURI = aURI
				and: [aBlock value: each]]]! !

!XMLNodeWithElements methodsFor: 'searching' stamp: 'monty 4/20/2016 11:49'!
findElementNamed: aName with: aBlock
	"searches the receiver and all descendants for the first element whose
	qualified or local name matches aName and aBlock evaluates true for"

	^ self allElementsDetect: [:each |
		(each isNamed: aName)
			and: [aBlock value: each]]! !

!XMLNodeWithElements methodsFor: 'searching' stamp: 'monty 3/20/2017 22:44'!
findElementWithID: anID
	"Works like XML DOM Level 2's getElementByID(). It will scan attributes
	identified as IDs by a DTD with '<!!ATTLIST ...>' declarations or any
	attribute named 'xml:id'."

	| document doctypeDefinition |
	
	((document := self document) notNil
		and: [(doctypeDefinition := document doctypeDefinition) notNil
			and: [doctypeDefinition hasAttributeValidators]])
		ifTrue: [
			self allElementsDo: [:each |
				each hasAttributes
					ifTrue: [
						(doctypeDefinition attributeValidatorsAt: each name)
							ifNil: [
								(each hasUndeclaredID: anID)
									ifTrue: [^ each]]
							ifNotNil: [:attributeValidators |
								(each
									hasUndeclaredOrDeclaredID: anID
									declaredWith: attributeValidators)
									ifTrue: [^ each]]]]]
		ifFalse: [
			self allElementsDo: [:each |
				(each hasAttributes
					and: [each hasUndeclaredID: anID])
					ifTrue: [^ each]]].
	^ nil.! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:12'!
firstElement
	"returns the first child element of the receiver or nil if there
	isn't one"

	^ self nodes firstElement! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 10/25/2014 21:02'!
hasContentNodes
	^ self nodes hasContentNodes! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 4/19/2016 10:42'!
hasElements
	"returns true if the receiver has element children"

	"optimized with a nil test to avoid lazy initializing nodes"
	nodes == nil
		ifTrue: [^ false].
	^ nodes hasElements.! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 10/25/2014 21:01'!
hasStringNodes
	^ self nodes hasStringNodes! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 4/19/2016 10:41'!
includesElement: aName
	"returns true if the receiver has a child element whose qualified or local name
	matches aName"

	^ self nodes includesElement: aName! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 4/19/2016 10:41'!
includesElement: aName namespaceURI: aURI
	"returns true if the receiver has a child element whose qualified or local name
	matches aName and whose namespace URI matches aURI"

	^ self nodes
		includesElement: aName
		namespaceURI: aURI! !

!XMLNodeWithElements methodsFor: 'parsing' stamp: 'monty 8/7/2016 14:45'!
innerXML: aStringOrStream
	"Replaces the node children by parsing new inner XML from a string or stream
	argument. By default the same parser configuration will be used to parse the
	new inner XML."

	self innerXMLParsedWith: (self parserHandlerClass on: aStringOrStream)! !

!XMLNodeWithElements methodsFor: 'parsing' stamp: 'monty 9/16/2017 23:38'!
innerXMLParsedWith: aParser
	| removedNodes |

	removedNodes := self nodes asArray.
	self removeNodes.
	[aParser
		innerXMLRootNode: self;
		parseDocument]
		on: Error
		do: [:error |
			self
				removeNodes;
				addNodes: removedNodes.
			error pass].! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 10/6/2017 14:12'!
innerXMLStateClass
	^ XMLContentState! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'JAAyer 7/20/2010 10:15'!
isContentNode
	^ true! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:12'!
lastElement
	"returns the last child element of the receiver or nil if there
	isn't one"

	^ self nodes lastElement! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 8/17/2017 07:39'!
namespaceURIOfAddedElementNamed: aName withScope: aNamespaceScope
	^ self usesNamespaces
		ifTrue: [aNamespaceScope resolvePrefix: aName xmlPrefixBeforeLocalName]
		ifFalse: ['']! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 9/20/2017 07:59'!
newAttributeDictionaryFrom: anAssociationCollection forAddedElementWithScope: aNamespaceScope
	^ self usesNamespaces
		ifTrue: [
			(XMLNamespacedAttributeDictionary newFrom: anAssociationCollection)
				setNamespaceScope: aNamespaceScope]
		ifFalse: [XMLAttributeDictionary newFrom: anAssociationCollection]! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 10/6/2017 14:12'!
newInnerXMLState
	^ self innerXMLStateClass new! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 8/17/2017 07:38'!
newNamespaceScopeForAddedElement
	^ self usesNamespaces
		ifTrue: [XMLNamespaceScope new]
		ifFalse: [nil]! !

!XMLNodeWithElements methodsFor: 'private' stamp: 'monty 8/25/2017 19:57'!
newNamespaceScopeForAddedElementNamed: aName namespaceURI: aURI
	self ensureUsesNamespaces.

	^ self newNamespaceScopeForAddedElement
		mapPrefix: aName xmlPrefixBeforeLocalName to: aURI;
		yourself.! !

!XMLNodeWithElements methodsFor: 'deprecated' stamp: 'monty 8/5/2016 22:22'!
newString: aString
	"will be deprecated; use #newStringNode: instead"

	^ self newStringNode: aString! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 11/1/2014 11:02'!
nodeFactory
	^ self configuration nodeFactory! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 11/1/2014 11:37'!
nodeFactory: aNodeFactory
	self configuration nodeFactory: aNodeFactory! !

!XMLNodeWithElements methodsFor: 'defaults' stamp: 'monty 4/17/2015 10:43'!
nodeListClass
	^ self configuration nodeFactory nodeListClass! !

!XMLNodeWithElements methodsFor: 'parsing' stamp: 'monty 5/8/2015 03:25'!
outerXML: aStringOrStream forNode: aNode
	self
		outerXMLForNode: aNode
		parsedWith: (self parserHandlerClass on: aStringOrStream)! !

!XMLNodeWithElements methodsFor: 'parsing' stamp: 'monty 9/16/2017 23:38'!
outerXMLForNode: aNode parsedWith: aParser
	| indexOfNode removedNodes |

	indexOfNode :=
		self nodes
			indexOf: aNode
			ifAbsent: [self errorOuterXMLForAbsentNode].
	removedNodes :=
		self nodes
			copyFrom: indexOfNode
			to: self nodes size.
	self removeNodes: removedNodes.
	[aParser
		innerXMLRootNode: self;
		parseDocument]
		on: Error
		do: [:error |
			[self nodes size >= indexOfNode]
				whileTrue: [self nodes removeLast].
			self addNodes: removedNodes.
			error pass].
	2 to: removedNodes size do: [:i |
		self addNode: (removedNodes at: i)].! !

!XMLNodeWithElements methodsFor: 'defaults' stamp: 'monty 3/7/2017 10:06'!
parserHandlerClass
	^ self configuration parserHandlerClass! !

!XMLNodeWithElements methodsFor: 'copying' stamp: 'monty 3/2/2016 05:44'!
postCopyConfiguration
	configuration
		ifNotNil: [self configuration: configuration copy]! !

!XMLNodeWithElements methodsFor: 'printing' stamp: 'monty 11/19/2014 23:44'!
printRawContentOn: aStream
	self contentNodesDo: [:each | each printRawContentOn: aStream]! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/17/2017 02:14'!
rawContentStringAt: aName
	"Returns the raw content string (without space inserted) of the first
	element child of the receiver whose qualified or local name matches aName
	or an empty string if there isn't one.

	See also #contentStringAt:"

	^ self nodes rawContentStringAt: aName! !

!XMLNodeWithElements methodsFor: 'removing' stamp: 'monty 1/24/2018 21:32'!
removeAllFormattingNodes
	"This is a convenience method to remove formatting string nodes from the
	receiver and descendant elements. Empty/whitespace string nodes with
	element siblings are assumed to be formatting, unless they have at least
	one non-empty/non-whitespace sibling string node.

	WARNING: documents with 'mixed content' elements that have string and element
	children intersperesed, like this:
		<row>one<sep/>two<sep/>three</row>
	arent recognized when all of the string nodes are whitespace, so this:
		<row> <sep/> <sep/> </row>
	will become:
		<row><sep/><sep/></row>
	which might not be correct."

	| hasFormattingStringNodes hasElements |

	hasFormattingStringNodes := false.
	hasElements := false.
	self nodesDo: [:each |
		each isStringNode
			ifTrue: [
				(hasFormattingStringNodes :=
					each isWhitespace
						or: [each isEmpty])
					ifFalse: [^ self]]
			ifFalse: [
				hasElements
					ifFalse: [hasElements := each isElement]]].

	(hasFormattingStringNodes
		and: [hasElements])
		ifTrue: [| nodeList |
			nodeList := self nodes.
			nodeList size to: 1 by: -1 do: [:i | | node |
				((node := nodeList at: i) isStringNode
					and: [node isWhitespace
						or: [node isEmpty]])
					ifTrue: [nodeList removeAt: i]]].
	hasElements
		ifTrue: [
			self elementsDo: [:each |
				each removeAllFormattingNodes]].! !

!XMLNodeWithElements methodsFor: 'notifying' stamp: 'monty 10/18/2014 01:08'!
renamedElement: anElement from: anOldName to: aNewName
	self nodes
		renamedElement: anElement
		from: anOldName
		to: aNewName! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:53'!
stringNodes
	"returns a new node list of all string node children of the receiver"

	^ self nodes stringNodes! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:37'!
stringNodesDo: aBlock
	"evaluates each string node child of the receiver with aBlock"

	self nodes stringNodesDo: aBlock! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/20/2016 11:53'!
strings
	"returns an ordered list of the strings of the string nodes of the receiver"

	^ self nodes strings! !

!XMLNodeWithElements methodsFor: 'enumerating' stamp: 'monty 4/20/2016 11:37'!
stringsDo: aBlock
	"evaluates each string of each string node child of the receiver with
	aBlock"

	self nodes stringsDo: aBlock! !

!XMLNodeWithElements methodsFor: 'testing' stamp: 'monty 4/20/2016 11:03'!
usesNamespaces
	"returns true if namespace checking is enabled (default)"

	"optimized to avoid lazy initializing the config"
	configuration == nil
		ifTrue: [^ true].
	^ configuration usesNamespaces.! !

!XMLNodeWithElements methodsFor: 'accessing' stamp: 'monty 4/19/2016 03:50'!
usesNamespaces: aBoolean
	"can be used to disable namespace checking, which is enabled by default"

	self configuration usesNamespaces: aBoolean! !

XMLNode subclass: #XMLPI
	instanceVariableNames: 'target data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLPI commentStamp: 'monty 5/16/2017 20:41' prior: 0!
This class represents a processing instruction node.!

!XMLPI class methodsFor: 'instance creation' stamp: 'monty 3/21/2015 22:52'!
target: aTargetString data: aDataString
	^ self new
		target: aTargetString;
		data: aDataString! !

!XMLPI methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPI: self! !

!XMLPI methodsFor: 'accessing' stamp: 'JAAyer 7/22/2010 03:02'!
data
	^ data ifNil: [data := '']! !

!XMLPI methodsFor: 'accessing' stamp: 'mir 1/17/2002 13:02'!
data: aString
	data := aString! !

!XMLPI methodsFor: 'testing' stamp: 'monty 11/8/2016 10:34'!
hasData
	^ self data notEmpty! !

!XMLPI methodsFor: 'testing' stamp: 'JAAyer 4/13/2010 21:43'!
isPI
	^ true! !

!XMLPI methodsFor: 'accessing' stamp: 'monty 12/3/2014 01:08'!
sortKey
	^ self target! !

!XMLPI methodsFor: 'accessing' stamp: 'JAAyer 7/21/2010 12:42'!
target
	^ target ifNil: [target := '']! !

!XMLPI methodsFor: 'accessing' stamp: 'mir 1/17/2002 13:02'!
target: aString
	target := aString! !

!XMLPI methodsFor: 'printing' stamp: 'monty 5/7/2015 18:52'!
writeXMLOn: aWriter
	aWriter pi
		target: self target;
		data: self data;
		write! !

XMLNode subclass: #XMLString
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLString commentStamp: 'monty 5/16/2017 20:42' prior: 0!
This class represents a string (character data) node. Instances are mutable, but the string is treated as immutable. String nodes can be created using the class-side #string: message or by sending a String #asXMLStringNode. 

When printing, XML-escaping of special characters is done.!

XMLString subclass: #XMLCData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLCData commentStamp: 'monty 6/15/2015 22:05' prior: 0!
This class represents a preserved <!![CDATA[...]]> section. By default these are handled as XMLString nodes and merged with adjacent string nodes during parsing.  To preserve CDATA nodes, use #preservesCDataNodes: with the DOM parser before parsing.!

!XMLCData methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitCData: self! !

!XMLCData methodsFor: 'testing' stamp: 'JAAyer 8/11/2010 22:16'!
isCData
	^ true! !

!XMLCData methodsFor: 'private' stamp: 'monty 8/6/2016 21:02'!
isCoalescingStringNode
	"this returns false to stop preserved CDATA nodes from coalescing
	together or with ordinary string nodes"

	^ false! !

!XMLCData methodsFor: 'printing' stamp: 'JAA 3/22/2011 15:15'!
writeXMLOn: aWriter
	aWriter cdata: self string! !

!XMLString class methodsFor: 'instance creation' stamp: 'JAAyer 2/25/2010 01:48'!
string: aString
	^ self new string: aString! !

!XMLString methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:05'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitStringNode: self! !

!XMLString methodsFor: 'deprecated' stamp: 'monty 8/14/2016 03:10'!
addContent: aStringOrStringNode
	"will be deprecated"

	self append: aStringOrStringNode! !

!XMLString methodsFor: 'appending/prepending' stamp: 'monty 8/14/2016 03:10'!
append: aStringOrStringNode
	string :=
		string
			ifNil: [aStringOrStringNode asString]
			ifNotNil: [string, aStringOrStringNode asString]! !

!XMLString methodsFor: 'converting' stamp: 'monty 1/1/2014 07:14'!
asString
	^ self string! !

!XMLString methodsFor: 'converting' stamp: 'monty 11/4/2014 14:51'!
asXMLEscapedString
	^ self string asXMLEscapedString! !

!XMLString methodsFor: 'deprecated' stamp: 'monty 8/16/2016 21:57'!
asXMLString
	"will be deprecated; use #asXMLStringNode instead"

	^ self asXMLStringNode! !

!XMLString methodsFor: 'converting' stamp: 'monty 8/5/2016 16:39'!
asXMLStringNode
	^ self! !

!XMLString methodsFor: 'testing' stamp: 'monty 11/3/2014 21:43'!
beginsWith: aStringOrStringNode
	^ self string beginsWith: aStringOrStringNode asString! !

!XMLString methodsFor: 'deprecated' stamp: 'monty 8/20/2016 01:09'!
contentString: aString
	"will be deprecated; use #string: instead"

	self string: aString! !

!XMLString methodsFor: 'replacing' stamp: 'monty 11/4/2014 12:38'!
deleteFrom: aStart to: anEnd
	self replaceFrom: aStart to: anEnd with: ''! !

!XMLString methodsFor: 'testing' stamp: 'monty 11/3/2014 21:43'!
endsWith: aStringOrStringNode
	^ self string endsWith: aStringOrStringNode asString! !

!XMLString methodsFor: 'testing' stamp: 'monty 12/9/2015 10:55'!
includesSubstring: aStringOrStringNode
	"avoid String>>includesSubstring: for backwards compatibility"
	^ aStringOrStringNode isEmpty
		or: [(self indexOfSubstring: aStringOrStringNode) > 0]! !

!XMLString methodsFor: 'accessing' stamp: 'monty 2/2/2015 17:29'!
indexOfSubstring: aStringOrStringNode
	^ self string
		findString: aStringOrStringNode asString
		startingAt: 1! !

!XMLString methodsFor: 'private' stamp: 'monty 8/6/2016 17:52'!
isCoalescingStringNode
	^ true! !

!XMLString methodsFor: 'testing' stamp: 'JAAyer 7/20/2010 10:26'!
isContentNode
	^ true! !

!XMLString methodsFor: 'testing' stamp: 'monty 11/3/2014 22:28'!
isEmpty
	^ self string isEmpty! !

!XMLString methodsFor: 'deprecated' stamp: 'monty 5/16/2017 23:01'!
isString: aStringOrStringNode
	"will be deprecated; use #isStringNode: instead"

	^ self isStringNode: aStringOrStringNode! !

!XMLString methodsFor: 'testing' stamp: 'JAAyer 4/12/2010 22:35'!
isStringNode
	^ true! !

!XMLString methodsFor: 'testing' stamp: 'monty 5/16/2017 19:49'!
isStringNode: aStringOrStringNode
	^ self string = aStringOrStringNode asString! !

!XMLString methodsFor: 'testing' stamp: 'monty 4/13/2016 11:35'!
isWhitespace
	^ self string isXMLWhitespace! !

!XMLString methodsFor: 'splitting/merging' stamp: 'monty 2/2/2015 17:30'!
mergeAdjacent
	"merges a string node with adjacent string nodes in parent"
	| siblingNodes selfIndex adjacentNode |

	self hasParent
		ifFalse: [^ self].

	siblingNodes := self parent nodes.
	selfIndex := siblingNodes indexOf: self.
	[(adjacentNode := siblingNodes at: selfIndex + 1) notNil
		and: [adjacentNode isStringNode]]
		whileTrue: [
			self append: adjacentNode.
			siblingNodes removeAt: selfIndex + 1].

	[(adjacentNode := siblingNodes at: selfIndex - 1) notNil
		and: [adjacentNode isStringNode]]
		whileTrue: [
			self prepend: adjacentNode.
			siblingNodes removeAt: selfIndex - 1.
			selfIndex := selfIndex - 1].! !

!XMLString methodsFor: 'testing' stamp: 'monty 11/14/2015 20:06'!
notEmpty
	^ self string notEmpty! !

!XMLString methodsFor: 'appending/prepending' stamp: 'monty 8/14/2016 03:10'!
prepend: aStringOrStringNode
	string :=
		string
			ifNil: [aStringOrStringNode asString]
			ifNotNil: [aStringOrStringNode asString, string]! !

!XMLString methodsFor: 'printing' stamp: 'monty 11/19/2014 23:44'!
printRawContentOn: aStream
	aStream nextPutAll: self string! !

!XMLString methodsFor: 'replacing' stamp: 'monty 11/4/2014 18:51'!
replaceAll: aSource with: aReplacement
	"works like copyReplaceAll:with:"
	self string:
		(self string
			copyReplaceAll: aSource asString
			with: aReplacement asString)! !

!XMLString methodsFor: 'replacing' stamp: 'monty 11/4/2014 18:54'!
replaceFrom: aStart to: aStop with: aReplacement
	"works like copyReplaceFrom:to:with: and
	can be used to insert, delete, and replace"
	| start stop |

	start := (aStart max: 1) min: self size + 1.
	stop := (aStop max: start - 1) min: self size.
	self string:
		(self string
			copyReplaceFrom: start
			to: stop
			with: aReplacement asString)! !

!XMLString methodsFor: 'accessing' stamp: 'monty 11/3/2014 23:41'!
size
	^ self string size! !

!XMLString methodsFor: 'accessing' stamp: 'monty 12/2/2014 22:56'!
sortKey
	^ self string! !

!XMLString methodsFor: 'splitting/merging' stamp: 'monty 11/3/2014 22:02'!
splitAt: anOffset
	| newNode |

	newNode := self copy.
	self replaceFrom: anOffset to: self size with: ''.
	newNode replaceFrom: 1 to: anOffset - 1 with: ''.

	self hasParent
		ifTrue: [self parent addNode: newNode after: self].

	^ newNode.! !

!XMLString methodsFor: 'accessing' stamp: 'JAAyer 7/22/2010 05:19'!
string
	^ string ifNil: [string := '']! !

!XMLString methodsFor: 'accessing' stamp: 'monty 1/1/2014 07:23'!
string: aString
	string := aString asString! !

!XMLString methodsFor: 'printing' stamp: 'JAA 3/22/2011 15:15'!
writeXMLOn: aWriter
	aWriter string: self string! !

Object subclass: #XMLNodeFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNodeFactory commentStamp: 'monty 6/16/2015 02:41' prior: 0!
This class is the default node factory. Its accessor messages return the classes used by the DOM parser to build a node tree. You can override these messages to return different classes and inject an instance with the DOM parser's #nodeFactory: message before parsing.!

!XMLNodeFactory methodsFor: 'converting' stamp: 'monty 4/17/2015 10:36'!
asPluggableNodeFactory
	^ XMLPluggableNodeFactory new! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:58'!
attributeDeclarationClass
	^ XMLAttributeDeclaration! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/2/2016 13:56'!
attributeListClass
	^ XMLCachingAttributeList! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:20'!
cdataClass
	"Can be overridden to return a custom XMLCData subclass."

	^ XMLCData! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 7/26/2016 13:57'!
classForElement: aQualifiedName
	^ self elementClass! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 20:01'!
classForElement: aQualifiedName attributes: anAssociationCollection
	^ self elementClass! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 7/26/2016 13:58'!
classForElement: aQualifiedName namespaceURI: aURI
	^ self elementClass! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 20:01'!
classForElement: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection
	^ self elementClass! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:48'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection
	^ self elementClass! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:20'!
commentClass
	"Can be overridden to return a custom XMLComment subclass."

	^ XMLComment! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'JAAyer 11/10/2010 03:19'!
doctypeDeclarationClass
	^ XMLDoctypeDeclaration! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:19'!
documentClass
	"Can be overridden to return a custom XMLDocument subclass."

	^ XMLDocument! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:19'!
elementClass
	"Can be overridden to return a custom XMLElement subclass."

	^ XMLElement! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:59'!
elementDeclarationClass
	^ XMLElementDeclaration! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:59'!
generalEntityDeclarationClass
	^ XMLGeneralEntityDeclaration! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/1/2014 22:57'!
newCData: aString
	^ self cdataClass string: aString! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/1/2014 22:57'!
newComment: aString
	^ self commentClass string: aString! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/6/2014 22:00'!
newDocument
	^ self documentClass new! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/6/2014 22:00'!
newElement
	^ self elementClass new! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/6/2014 22:01'!
newElementNamed: aName
	^ (self classForElement: aName)
		named: aName! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 8/15/2016 23:53'!
newElementNamed: aName attributes: anAssociationCollection
	^ (self
		classForElement: aName
		attributes: anAssociationCollection)
			name: aName
			attributes: anAssociationCollection! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 8/15/2016 23:53'!
newElementNamed: aName namespaceURI: aURI
	^ (self
		classForElement: aName
		namespaceURI: aURI)
			name: aName
			namespaceURI: aURI! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 8/15/2016 23:53'!
newElementNamed: aName namespaceURI: aURI attributes: anAssociationCollection
	^ (self
		classForElement: aName
		namespaceURI: aURI
		attributes: anAssociationCollection)
			name: aName
			namespaceURI: aURI
			attributes: anAssociationCollection! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 11/1/2014 22:55'!
newPI
	^ self piClass new! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 8/9/2016 17:16'!
newPITarget: aTargetString data: aDataString
	^ self newPI
		target: aTargetString;
		data: aDataString! !

!XMLNodeFactory methodsFor: 'deprecated' stamp: 'monty 8/5/2016 22:22'!
newString: aString
	"will be deprecated; use #newStringNode: instead"

	^ self newStringNode: aString! !

!XMLNodeFactory methodsFor: 'instance creation' stamp: 'monty 8/6/2016 12:56'!
newStringNode: aString
	^ self stringNodeClass new string: aString! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 4/17/2015 10:32'!
nodeListClass
	^ XMLNodeList! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:59'!
notationDeclarationClass
	^ XMLNotationDeclaration! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 12/21/2013 02:59'!
parameterEntityDeclarationClass
	^ XMLParameterEntityDeclaration! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:19'!
piClass
	"Can be overridden to return a custom XMLPI subclass."

	^ XMLPI! !

!XMLNodeFactory methodsFor: 'deprecated' stamp: 'monty 8/5/2016 22:24'!
stringClass
	"will be deprecated; use #stringNodeClass instead"

	^ XMLString! !

!XMLNodeFactory methodsFor: 'accessing' stamp: 'monty 9/30/2016 00:19'!
stringNodeClass
	"Can be overridden to return a custom XMLString subclass."

	"for now this delegates to the soft-deprecated #stringClass to not
	break custom subclasses that override it expecting it to be sent"
	^ self stringClass! !

XMLNodeFactory subclass: #XMLPluggableNodeFactory
	instanceVariableNames: 'documentClass elementClass stringNodeClass cdataClass commentClass piClass nodeListClass attributeListClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLPluggableNodeFactory commentStamp: 'monty 9/22/2016 14:25' prior: 0!
This is a pluggable node factory that can be used to change which classes the DOM parser uses to build the DOM tree. Here is an example:

	(XMLDOMParser on: anXMLStringOrStream)
		nodeFactory:
			(XMLPluggableNodeFactory new
				documentClass: MyDocumentClass;
				elementClass: MyElementClass;
				stringNodeClass: MyStringNodeClass);
		parseDocument.

Instances can be saved and reused for performance and safely modified after copying.!

XMLPluggableNodeFactory subclass: #XMLPluggableElementFactory
	instanceVariableNames: 'elementClassMapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLPluggableElementFactory commentStamp: 'monty 9/22/2016 14:25' prior: 0!
This class is a pluggable node factory that can also map elements to different XMLElement subclasses based on the name, namespace information, and attributes of those elements. You have to create an instance, configure it to handle certain elements with certain classes, and then inject your instance into a DOM parser using #nodeFactory: before parsing. Here is an example:

	(XMLDOMParser on: anXMLStringOrStream)
		nodeFactory:
			(XMLPluggableElementFactory new
				elementClass: GenericElement;
				handleElement: 'user' withClass: UserElement;
				handleElement: 'report' withClass: ReportElement;
				handleElement: 'report' namespaceURI: 'urn:specialreprot' withClass: SpecialReportElement);
		parseDocument.

Instances can be saved and reused for performance and safely modified after copying.!

!XMLPluggableElementFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:45'!
classForElement: aQualifiedName
	^ elementClassMapper
		classForElement: aQualifiedName
		ifNone: [self elementClass]! !

!XMLPluggableElementFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:45'!
classForElement: aQualifiedName attributes: anAssociationCollection
	^ elementClassMapper
		classForElement: aQualifiedName
		attributes: anAssociationCollection
		ifNone: [self elementClass]! !

!XMLPluggableElementFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:45'!
classForElement: aQualifiedName namespaceURI: aURI
	^ elementClassMapper
		classForElement: aQualifiedName
		namespaceURI: aURI
		ifNone: [self elementClass]! !

!XMLPluggableElementFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:45'!
classForElement: aQualifiedName namespaceURI: aURI attributes: anAssociationCollection
	^ elementClassMapper
		classForElement: aQualifiedName
		namespaceURI: aURI
		attributes: anAssociationCollection
		ifNone: [self elementClass]! !

!XMLPluggableElementFactory methodsFor: 'accessing' stamp: 'monty 8/10/2016 23:44'!
classForElement: aQualifiedName namespaceURI: aURI localName: aLocalName attributes: anAssociationCollection
	^ elementClassMapper
		classForElement: aQualifiedName
		namespaceURI: aURI
		localName: aLocalName
		attributes: anAssociationCollection
		ifNone: [self elementClass]! !

!XMLPluggableElementFactory methodsFor: 'private' stamp: 'monty 7/23/2016 05:24'!
elementClassMapper
	^ elementClassMapper! !

!XMLPluggableElementFactory methodsFor: 'private' stamp: 'monty 7/24/2016 09:18'!
elementClassMapper: anElementClassMapper
	elementClassMapper := anElementClassMapper! !

!XMLPluggableElementFactory methodsFor: 'defaults' stamp: 'monty 8/26/2016 02:16'!
elementClassMapperClass
	^ XMLBasicElementClassMapper! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 8/18/2016 23:10'!
handleElement: anElementName attributes: aCollectionOrAttributeSpec withClass: aClass
	"aCollectionOrAttributeSpec can be some kind of XMLAttributeSpec or a
	collection of associations of required attribute names and values, and the
	required values can be strings, blocks, or nil meaning the attribute is
	required but can take any value"

	elementClassMapper
		mapElement: anElementName
		attributeSpec: aCollectionOrAttributeSpec asXMLAttributeSpec
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 8/18/2016 23:10'!
handleElement: anElementName namespaceURI: aURI attributes: aCollectionOrAttributeSpec withClass: aClass
	"aCollectionOrAttributeSpec can be some kind of XMLAttributeSpec or a
	collection of associations of required attribute names and values, and the
	required values can be strings, blocks, or nil meaning the attribute is
	required but can take any value"

	elementClassMapper
		mapElement: anElementName
		namespaceURI: aURI
		attributeSpec: aCollectionOrAttributeSpec asXMLAttributeSpec
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 7/26/2016 06:20'!
handleElement: anElementName namespaceURI: aURI withClass: aClass
	elementClassMapper
		mapElement: anElementName
		namespaceURI: aURI
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 7/26/2016 06:21'!
handleElement: anElementName withClass: aClass
	elementClassMapper
		mapElement: anElementName
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 7/26/2016 06:25'!
handleElements: anElementNameCollection namespaceURI: aNamespaceURI withClass: aClass
	elementClassMapper
		mapElements: anElementNameCollection
		namespaceURI: aNamespaceURI
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 7/26/2016 06:24'!
handleElements: anElementNameCollection withClass: aClass
	elementClassMapper
		mapElements: anElementNameCollection
		toClass: aClass! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 8/26/2016 01:41'!
handleElementsMatchingClass: aClass
	"This will handle all elements matching the name of a class with that
	class, but igoring the class's prefix and any 'Element' suffix.

	For example, it will match MyUserDefinedElement to:
		<UserDefined>
		<userDefined>
		<user-defined>
		<user_defined>"

	elementClassMapper
		mapAllMatchingElementsToClass: aClass
		ignoringSuffixes: self ignorableClassNameSuffixes! !

!XMLPluggableElementFactory methodsFor: 'handling' stamp: 'monty 8/26/2016 01:41'!
handleElementsMatchingClasses: aClassCollection
	"See the comment in #handleElementsMatchingClass:"

	elementClassMapper
		mapAllMatchingElementsToClasses: aClassCollection
		ignoringSuffixes: self ignorableClassNameSuffixes! !

!XMLPluggableElementFactory methodsFor: 'defaults' stamp: 'monty 8/26/2016 00:47'!
ignorableClassNameSuffixes
	^ #('Element')! !

!XMLPluggableElementFactory methodsFor: 'initialization' stamp: 'monty 8/2/2016 12:38'!
initialize
	super initialize.

	elementClassMapper := self elementClassMapperClass new.! !

!XMLPluggableElementFactory methodsFor: 'copying' stamp: 'monty 7/23/2016 04:50'!
postCopy
	super postCopy.

	elementClassMapper := elementClassMapper copy.! !

!XMLPluggableNodeFactory methodsFor: 'converting' stamp: 'monty 4/17/2015 10:37'!
asPluggableNodeFactory
	^ self! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 9/2/2016 05:44'!
attributeListClass
	^ attributeListClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 9/2/2016 05:44'!
attributeListClass: aClass
	attributeListClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:08'!
cdataClass
	^ cdataClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 11/1/2014 10:44'!
cdataClass: aClass
	cdataClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:08'!
commentClass
	^ commentClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 11/1/2014 10:45'!
commentClass: aClass
	commentClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:08'!
documentClass
	^ documentClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 11/1/2014 10:42'!
documentClass: aClass
	documentClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:08'!
elementClass
	^ elementClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 11/1/2014 10:42'!
elementClass: aClass
	elementClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'initialization' stamp: 'monty 9/2/2016 13:56'!
initialize
	super initialize.

	documentClass := XMLDocument.
	elementClass := XMLElement.
	stringNodeClass := XMLString.
	cdataClass := XMLCData.
	commentClass := XMLComment.
	piClass := XMLPI.
	nodeListClass := XMLNodeList.
	attributeListClass := XMLCachingAttributeList.! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:08'!
nodeListClass
	^ nodeListClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 4/17/2015 10:33'!
nodeListClass: aClass
	nodeListClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:09'!
piClass
	^ piClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 11/1/2014 10:44'!
piClass: aClass
	piClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'deprecated' stamp: 'monty 8/5/2016 22:24'!
stringClass
	"will be deprecated; use #stringNodeClass instead"

	^ stringNodeClass! !

!XMLPluggableNodeFactory methodsFor: 'deprecated' stamp: 'monty 8/5/2016 22:24'!
stringClass: aClass
	"will be deprecated; use #stringNodeClass: instead"

	stringNodeClass := aClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/5/2016 16:48'!
stringNodeClass
	^ stringNodeClass! !

!XMLPluggableNodeFactory methodsFor: 'accessing' stamp: 'monty 8/5/2016 16:47'!
stringNodeClass: aClass
	stringNodeClass := aClass! !

Object subclass: #XMLNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLNodeVisitor commentStamp: 'monty 8/16/2016 23:04' prior: 0!
This is a base class for DOM node tree visitors. Subclasses can implement any of the "visiting" messages, and instances can be used by sending a node #acceptNodeVisitor: with it as the argument.!

XMLNodeVisitor subclass: #XMLMutatingNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLMutatingNodeVisitor commentStamp: 'monty 1/3/2018 17:26' prior: 0!
This is a mutating node visitor that can remove nodes during enumeration by returning nil from a #visit* method, or replace a node by returning a new node other than the argument.!

!XMLMutatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 12/11/2017 02:13'!
visitNodeWithElements: aNodeWithElements
	aNodeWithElements hasChildren
		ifTrue: [| oldNodes nodeIndexesToRemove |
			oldNodes := aNodeWithElements nodes.
			1 to: oldNodes size do: [:i | | oldNode newNode |
				oldNode := oldNodes at: i.
				(newNode := oldNode acceptNodeVisitor: self) = oldNode
					ifFalse: [
						newNode
							ifNil: [
								"only initialize if needed"
								(nodeIndexesToRemove
									ifNil: [nodeIndexesToRemove := OrderedCollection new])
									addLast: i]
							ifNotNil: [
								"replace it"
								oldNodes
									at: i
									put: newNode]]].
			nodeIndexesToRemove
				ifNotNil: [
					nodeIndexesToRemove reverseDo: [:i |
						oldNodes removeAt: i]]].
	^ aNodeWithElements.! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitCData: aCData
	^ self visitStringNode: aCData! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitComment: aComment
	^ aComment! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitDocument: aDocument
	^ self visitNodeWithElements: aDocument! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitElement: anElement
	^ self visitNodeWithElements: anElement! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitNode: aNode
	^ aNode acceptNodeVisitor: self! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:02'!
visitNodeWithElements: aNodeWithElements
	aNodeWithElements hasChildren
		ifTrue: [
			aNodeWithElements nodesDo: [:each |
				each acceptNodeVisitor: self]].
	^ aNodeWithElements.! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:02'!
visitPI: aPI
	^ aPI! !

!XMLNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:02'!
visitStringNode: aStringNode
	^ aStringNode! !

XMLNodeVisitor subclass: #XMLValidatingNodeVisitor
	instanceVariableNames: 'validator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-DOM'!

!XMLValidatingNodeVisitor commentStamp: 'monty 8/16/2016 23:03' prior: 0!
A validating node visitor that can validate DOM node trees using XMLDocumentValidators.!

!XMLValidatingNodeVisitor class methodsFor: 'instance creation' stamp: 'monty 7/27/2016 06:21'!
validator: aValidator
	^ self new validator: aValidator! !

!XMLValidatingNodeVisitor methodsFor: 'accessing' stamp: 'monty 7/27/2016 06:21'!
validator
	^ validator! !

!XMLValidatingNodeVisitor methodsFor: 'accessing' stamp: 'monty 7/27/2016 06:21'!
validator: aValidator
	validator := aValidator! !

!XMLValidatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitComment: aComment
	self validator validateComment: aComment.
	^ aComment.! !

!XMLValidatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitDocument: aDocument
	aDocument root
		ifNotNil: [:rootElement |
			self validator validateRootElement: rootElement name].
	super visitDocument: aDocument.
	self validator validateEndDocument.
	^ aDocument.! !

!XMLValidatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitElement: anElement
	| attributeDictionary |

	attributeDictionary := 
		anElement hasAttributes
			ifTrue: [anElement attributeNodes asDictionary]
			ifFalse: [Dictionary new].

	self validator
		validateStartTag: anElement name
		attributes: attributeDictionary.
	"validation can change/add attribute values"
	anElement setAttributes: attributeDictionary.

	super visitElement: anElement.

	self validator validateEndTag: anElement name.
	^ anElement.! !

!XMLValidatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:03'!
visitPI: aPI
	self validator
		validatePI: aPI target
		data: aPI data.
	^ aPI.! !

!XMLValidatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:04'!
visitStringNode: aStringNode
	self validator validatePCData: aStringNode string.
	^ aStringNode.! !

Object subclass: #XMLParser
	instanceVariableNames: 'tokenizer driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLParser commentStamp: '<historical>' prior: 0!
This class is a facade that parses XML using a driver and tokenizer. See SAXHandler and XMLDOMParser for ready-made front ends to it.!

!XMLParser class methodsFor: 'instance creation' stamp: 'monty 3/26/2016 23:49'!
driver: aDriver on: aStringOrStream
	^ self new
		setDriver: aDriver
		tokenizer: (aDriver newTokenizerOn: aStringOrStream)! !

!XMLParser methodsFor: 'testing' stamp: 'JAAyer 11/27/2010 07:17'!
atEnd
	^ self tokenizer atEnd! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 11/23/2016 17:07'!
baseURI
	^ self driver baseURI! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 3/18/2016 01:47'!
currentColumnNumber
	^ self tokenizer currentColumnNumber! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 11/14/2013 23:34'!
currentLineNumber
	^ self tokenizer currentLineNumber! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 3/18/2016 02:20'!
currentPosition
	^ self tokenizer currentPosition! !

!XMLParser methodsFor: 'accessing' stamp: 'JAAyer 11/28/2010 07:07'!
driver
	^ driver! !

!XMLParser methodsFor: 'private' stamp: 'monty 11/23/2016 17:08'!
handleParserError: anError
	self tokenizer closeStreams.

	anError isXMLParserException
		ifFalse: [anError pass].

	(anError hasLineNumber
		or: [self currentLineNumber isNil])
		ifFalse: [anError lineNumber: self currentLineNumber].
	(anError hasColumnNumber
		or: [self currentColumnNumber isNil])
		ifFalse: [anError columnNumber: self currentColumnNumber].
	(anError hasBaseURI
		or: [self baseURI isEmpty])
		ifFalse: [anError baseURI: self baseURI].

	anError shouldPassOnWhenCaught
		ifTrue: [anError pass].! !

!XMLParser methodsFor: 'parsing' stamp: 'monty 11/24/2014 19:31'!
parseDocument
	[[self tokenizer atEnd]
		whileFalse: [self tokenizer nextToken]]
		on: Error
		do: [:error | self handleParserError: error]! !

!XMLParser methodsFor: 'parsing' stamp: 'monty 11/26/2014 21:27'!
parseDocumentUntil: aBlock
	[[self tokenizer atEnd or: [aBlock value]]
		whileFalse: [self tokenizer nextToken]]
		on: Error
		do: [:error | self handleParserError: error]! !

!XMLParser methodsFor: 'parsing' stamp: 'monty 11/24/2014 19:31'!
parseDocumentWhile: aBlock
	[[self tokenizer atEnd not and: [aBlock value]]
		whileTrue: [self tokenizer nextToken]]
		on: Error
		do: [:error | self handleParserError: error]! !

!XMLParser methodsFor: 'parsing' stamp: 'monty 11/24/2014 19:31'!
parseToken
	^ [self tokenizer nextToken]
		on: Error
		do: [:error | self handleParserError: error]! !

!XMLParser methodsFor: 'initialization' stamp: 'JAAyer 11/28/2010 07:09'!
setDriver: aDriver tokenizer: aTokenizer
	driver := aDriver.
	tokenizer := aTokenizer.! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 10/6/2017 14:17'!
state
	^ self tokenizer state! !

!XMLParser methodsFor: 'accessing' stamp: 'monty 10/6/2017 14:15'!
state: aTokenState
	self tokenizer state: aTokenState! !

!XMLParser methodsFor: 'accessing' stamp: 'JAAyer 11/27/2010 07:16'!
tokenizer
	^ tokenizer! !

Object subclass: #XMLParserDriver
	instanceVariableNames: 'baseURI currentEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLParserDriver commentStamp: 'monty 7/15/2015 10:29' prior: 0!
This is a base class for parser drivers. Subclasses should override any of the "handling" or "handling - dtd" messages sent by tokenizers to parse tokens.!

XMLParserDriver subclass: #DTDSubsetParserDriver
	instanceVariableNames: 'doctypeDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!DTDSubsetParserDriver commentStamp: 'monty 11/21/2016 15:42' prior: 0!
An abstract class for handling internal and external DTD subset events.!

DTDSubsetParserDriver subclass: #DTDExternalSubsetParserDriver
	instanceVariableNames: 'saxDriver documentURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!DTDExternalSubsetParserDriver commentStamp: 'monty 7/15/2015 10:32' prior: 0!
This class is used by SAXParserDriver for parsing the external subset of a DTD.!

!DTDExternalSubsetParserDriver class methodsFor: 'instance creation' stamp: 'monty 11/23/2016 22:40'!
saxDriver: aSAXDriver documentURI: anExternalSubsetURIString
	^ self new
		setSAXDriver: aSAXDriver
		documentURI: anExternalSubsetURIString! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:43'!
decodesCharacters
	^ self saxDriver decodesCharacters! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 3/21/2015 23:23'!
documentURI
	^ documentURI! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:39'!
externalEntityResolver
	^ self saxDriver externalEntityResolver! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/24/2016 02:31'!
hasExternalSubset
	^ true! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:46'!
hasParameterEntityReferences
	^ self saxDriver hasParameterEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:51'!
hasSkippedParameterEntityReferences
	^ self saxDriver hasSkippedParameterEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:53'!
haveParameterEntityReferences
	self saxDriver haveParameterEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:55'!
haveSkippedParameterEntityReferences
	self saxDriver haveSkippedParameterEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'defaults' stamp: 'monty 10/6/2017 14:11'!
initialStateClass
	^ XMLExternalSubsetTextDeclarationState! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 10/21/2017 22:49'!
isExternal
	"Definition: An external markup declaration is defined as a markup
	declaration occurring in the external subset or in a parameter entity
	(external or internal, the latter being included because non-validating
	processors are not required to read them)"

	^ true! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:42'!
isStandalone
	^ self saxDriver isStandalone! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:43'!
isValidating
	^ self saxDriver isValidating! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:39'!
maxEntityReplacementDepth
	^ self saxDriver maxEntityReplacementDepth! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:41'!
preservesUndeclaredEntityReferences
	^ self saxDriver preservesUndeclaredEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 1/27/2015 22:51'!
readLimit
	^ self externalEntityResolver externalSubsetReadLimit! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:41'!
replacesContentEntityReferences
	^ self saxDriver replacesContentEntityReferences! !

!DTDExternalSubsetParserDriver methodsFor: 'testing' stamp: 'monty 10/31/2016 03:36'!
resolvesExternalEntities
	^ true! !

!DTDExternalSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:39'!
saxDriver
	^ saxDriver! !

!DTDExternalSubsetParserDriver methodsFor: 'initialization' stamp: 'monty 11/23/2016 22:41'!
setSAXDriver: aSAXDriver documentURI: anExternalSubsetURIString
	saxDriver := aSAXDriver.
	documentURI := anExternalSubsetURIString.
	doctypeDefinition := aSAXDriver doctypeDefinition.! !

!DTDSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/19/2016 16:52'!
doctypeDefinition
	^ doctypeDefinition! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorImproperParameterEntityNesting
	XMLValidationException signal:
		'Improper nesting of parameter entity replacement within DTD subset'! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorInvalidUndeclaredGeneralEntityReference: aName
	XMLValidationException
		formatSignal: 'Undeclared general entity reference &{1};'
		with: aName! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorInvalidUndeclaredParameterEntityReference: aName
	XMLValidationException
		formatSignal: 'Undeclared parameter entity reference %{1};'
		with: aName! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorMultipleDeclarationsForElement: aName
	XMLValidationException
		formatSignal: 'Multiple declarations for <{1}> element'
		with: aName! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorMultipleDeclarationsForNotation: aName
	"Unlike redundant entity declarations which are just ignored,
	redundant notation declarations are invalid"
	XMLValidationException
		formatSignal: 'Multiple declarations for notation "{1}"'
		with: aName! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 5/20/2017 03:19'!
errorReferenceToStandaloneExternalEntity: anEntity
	XMLValidationException
		formatSignal:
			'Internal reference to externally defined ',
			'entity {1} in standalone="yes" document'
		with: anEntity asReference! !

!DTDSubsetParserDriver methodsFor: 'private' stamp: 'monty 11/19/2016 17:04'!
errorUndeclaredGeneralEntityReference: aName
	XMLWellFormednessException
		formatSignal: 'Undeclared general entity reference &{1};'
		with: aName! !

!DTDSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/19/2016 16:53'!
externalEntityResolver
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 10/22/2017 00:13'!
handleAttributeDeclaration: anElement name: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	| newAttributeValidator |

	self mustSkipEntityAndAttributeDeclarations
		ifTrue: [^ self].

	newAttributeValidator :=
		self isStandaloneExternal
			ifTrue: [
				self doctypeDefinition
					addStandaloneExternalValidatorForAttributeIn: anElement
					named: anAttribute
					type: aType
					defaultPragma: aDefaultPragma
					defaultValue: aDefaultValue]
			ifFalse: [
				self doctypeDefinition
					addValidatorForAttributeIn: anElement
					named: anAttribute
					type: aType
					defaultPragma: aDefaultPragma
					defaultValue: aDefaultValue].

	(self isValidating
		and: [newAttributeValidator notNil])
		ifTrue: [newAttributeValidator validateAttributeDeclaration].! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:34'!
handleElementDeclaration: aName contentModel: aContentModel
	| newElementValidator |

	newElementValidator :=
		self isStandaloneExternal
			ifTrue: [
				self doctypeDefinition
					addStandaloneExternalValidatorForElement: aName
					contentModel: aContentModel]
			ifFalse: [
				self doctypeDefinition
					addValidatorForElement: aName
					contentModel: aContentModel].

	self isValidating
		ifTrue: [
			newElementValidator
				ifNil: [self errorMultipleDeclarationsForElement: aName].
			newElementValidator validateElementDeclaration].! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 10/22/2017 00:13'!
handleGeneralEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotation
	self mustSkipEntityAndAttributeDeclarations
		ifTrue: [^ self].

	aNotation isEmpty
		ifTrue: [
			self resolvesExternalEntities
				ifTrue: [
					self isStandaloneExternal
						ifTrue: [
							self doctypeDefinition
								addStandaloneExternalExternalGeneralEntity: aName
								resolver: self externalEntityResolver
								publicID: aPublicID
								systemID: aSystemID
								baseURI: self baseURI]
						ifFalse: [
							self doctypeDefinition
								addExternalGeneralEntity: aName
								resolver: self externalEntityResolver
								publicID: aPublicID
								systemID: aSystemID
								baseURI: self baseURI]]
				ifFalse: [
					self isValidating
						ifTrue: [
							self doctypeDefinition
								addUnresolvableExternalGeneralEntity: aName]]]
		ifFalse: [
			self doctypeDefinition
				addUnparsedEntity: aName
				publicID: aPublicID
				systemID: aSystemID
				ndata: aNotation].! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 10/22/2017 00:13'!
handleGeneralEntityDeclaration: aName replacement: aReplacement
	self mustSkipEntityAndAttributeDeclarations
		ifTrue: [^ self].

	self isStandaloneExternal
		ifTrue: [
			self doctypeDefinition
				addStandaloneExternalInternalGeneralEntity: aName
				replacement: aReplacement
				baseURI: self baseURI]
		ifFalse: [
			self doctypeDefinition
				addInternalGeneralEntity: aName
				replacement: aReplacement
				baseURI: self baseURI].! !

!DTDSubsetParserDriver methodsFor: 'handling' stamp: 'monty 5/20/2017 03:21'!
handleGeneralEntityReference: aName
	| entity |

	entity :=
		self doctypeDefinition
			generalEntityAt: aName
			ifAbsent: [
				"WFC: In a document without any DTD, a document with only an
				internal DTD subset which contains no parameter entity references,
				or a document with ''standalone='yes''', for an entity reference
				(general) that does not occur within the external subset or a
				parameter entity (meaning DTD 'external')"
				self isExternal
					ifFalse: [
						((self hasExternalSubset not
							and: [self hasParameterEntityReferences not])
								or: [self isStandalone])
							ifTrue: [self errorUndeclaredGeneralEntityReference: aName]].
				"all general entity refs must be declared when validating"
				self isValidating
					ifTrue: [self errorInvalidUndeclaredGeneralEntityReference: aName].
				^ nil].

	"'VC: Standalone Document Declaration
		The standalone document declaration MUST have the value 'no' if any
		external markup declarations contain declarations of:
			...
		entities ... if references to those entities appear in the document'
	LibXML2 doesn't flag these at all, and Xerces only does for references
	in the content, but the specification says in the 'document', so we
	consider all non-external references, even inside the DTD internal subset"
	(entity isStandaloneExternal
		and: [self isValidating
			and: [self isExternal not]])
		ifTrue: [self errorReferenceToStandaloneExternalEntity: entity].

	^ entity.! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:03'!
handleImproperParameterEntityNesting
	"this is a validity constraint and is only checked when validating"
	self isValidating
		ifTrue: [self errorImproperParameterEntityNesting]! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:26'!
handleNotationDeclaration: aName publicID: aPublicID systemID: aSystemID
	(self doctypeDefinition
		addNotation: aName
		publicID: aPublicID
		systemID: aSystemID)
		ifNil: [
			self isValidating
				ifTrue: [self errorMultipleDeclarationsForNotation: aName]]! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 10/22/2017 00:13'!
handleParameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	self mustSkipEntityAndAttributeDeclarations
		ifFalse: [
			self resolvesExternalEntities
				ifTrue: [
					self doctypeDefinition
						addExternalParameterEntity: aName
						resolver: self externalEntityResolver
						publicID: aPublicID
						systemID: aSystemID
						baseURI: self baseURI]
				ifFalse: [
					self isValidating
						ifTrue: [
							self doctypeDefinition
								addUnresolvableExternalParameterEntity: aName]]]! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 10/22/2017 00:13'!
handleParameterEntityDeclaration: aName replacement: aReplacement
	self mustSkipEntityAndAttributeDeclarations
		ifFalse: [
			self doctypeDefinition
				addInternalParameterEntity: aName
				replacement:aReplacement
				baseURI: self baseURI]! !

!DTDSubsetParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/23/2016 22:55'!
handleParameterEntityReference: aName
	self haveParameterEntityReferences.
	^ self doctypeDefinition
		parameterEntityAt: aName
		ifAbsent: [
			self isValidating
				ifTrue: [self errorInvalidUndeclaredParameterEntityReference: aName].
			self haveSkippedParameterEntityReferences.
			nil]! !

!DTDSubsetParserDriver methodsFor: 'handling' stamp: 'monty 11/19/2016 17:21'!
handleParseError: aString
	XMLWellFormednessException signal: aString! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/24/2016 02:31'!
hasExternalSubset
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:46'!
hasParameterEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:51'!
hasSkippedParameterEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:54'!
haveParameterEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:55'!
haveSkippedParameterEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 10/21/2017 22:49'!
isExternal
	"Definition: An external markup declaration is defined as a markup
	declaration occurring in the external subset or in a parameter entity
	(external or internal, the latter being included because non-validating
	processors are not required to read them)"

	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:42'!
isStandalone
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 5/19/2017 18:11'!
isStandaloneExternal
	^ self isStandalone
		and: [self isExternal]! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/19/2016 16:53'!
isValidating
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'accessing' stamp: 'monty 11/19/2016 17:25'!
maxEntityReplacementDepth
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 10/22/2017 00:13'!
mustSkipEntityAndAttributeDeclarations
	"'Except when standalone=''yes'', they (non-validating parsers) MUST NOT
	process entity declarations or attribute-list declarations encountered
	after a reference to a parameter entity that is not read...'"
	^ self isValidating not
		and: [self isStandalone not
			and: [self hasSkippedParameterEntityReferences]]! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/19/2016 16:54'!
preservesUndeclaredEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/19/2016 16:53'!
replacesContentEntityReferences
	self subclassResponsibility! !

!DTDSubsetParserDriver methodsFor: 'testing' stamp: 'monty 11/19/2016 16:53'!
resolvesExternalEntities
	self subclassResponsibility! !

DTDSubsetParserDriver subclass: #SAXParserDriver
	instanceVariableNames: 'saxHandler elementNester scopeAllocator validator externalSubsetSystemID externalSubsetPublicID isValidating usesNamespaces isStandalone hasParameterEntityReferences hasSkippedParameterEntityReferences hasUnhandledReservedAttributes externalEntityResolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!SAXParserDriver commentStamp: 'monty 6/16/2015 00:07' prior: 0!
SAXParserDriver together with SAXHandler provides a SAX-like API for XML parsing. The driver processes XML tokens and signals SAX events to a SAXHandler. See SAXHandler for more info.!

!SAXParserDriver class methodsFor: 'instance creation' stamp: 'monty 11/26/2016 18:40'!
saxHandler: aSAXHandler
	^ self new setSAXHandler: aSAXHandler! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 10/26/2016 17:45'!
baseURI
	"returns a string with the current base URI at this stage of parsing"
	self elementNester hasScopedAttributes
		ifTrue: [
			^ self elementNester
				scopedAttributeAt: 'xml:base'
				ifAbsent: [super baseURI]]
		ifFalse: [^ super baseURI]! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 8/6/2016 20:02'!
checkForReservedAttributesIn: anOrderPreservingDictionary afterIndex: anIndex
	"validation may add attributes, so this is used to check if reserved
	attributes were added that need handling when there weren't any before"

	self hasUnhandledReservedAttributes
		ifTrue: [^ self].
	anIndex + 1
		to: anOrderPreservingDictionary size
		do: [:i |
			(anOrderPreservingDictionary keyAtIndex: i) isXMLReservedAttributeName
				ifTrue: [^ self haveUnhandledReservedAttributes]].! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 12/27/2013 04:13'!
currentElement
	^ self elementNester currentElement! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/6/2017 11:12'!
currentElement: anElement
	self elementNester currentElement: anElement! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/6/2017 10:58'!
currentScope
	^ self scopeAllocator currentScope! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/6/2017 10:58'!
currentScope: aNamespaceScope
	self scopeAllocator currentScope: aNamespaceScope! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 4/13/2016 04:04'!
declareNamespaces: aSequenceableCollection inScope: aScope
	1 to: aSequenceableCollection size do: [:i | | association |
		association := aSequenceableCollection at: i.
		(aScope resolvePrefix: association key) = association value
			ifFalse: [
				self saxHandler
					startPrefixMapping: association key
					uri: association value]].
	aScope mapPrefixesAndURIs: aSequenceableCollection.! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 5/8/2015 19:05'!
decodesCharacters
	^ self saxHandler decodesCharacters! !

!SAXParserDriver methodsFor: 'defaults' stamp: 'monty 11/24/2016 02:29'!
doctypeDefinitionClass
	^ DTDDoctypeDefinition! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 1/19/2014 04:44'!
documentReadLimit
	^ self saxHandler documentReadLimit! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 11/16/2013 04:35'!
documentURI
	^ self saxHandler documentURI! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 6/26/2017 04:22'!
elementNester
	^ elementNester! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 10/31/2014 17:23'!
errorDocumentConstraintsRequired
	XMLValidationException signal: 'Document validation constraints required'! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 10/5/2017 12:14'!
externalEntityResolver
	^ externalEntityResolver
		ifNil: [
			externalEntityResolver :=
				self saxHandler externalEntityResolver
					asLimitingExternalEntityResolver]! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 11/28/2016 01:31'!
externalSubsetParserOn: aStringOrStream documentURI: aURIString
	^ self saxHandler parserClass
		driver:
			(DTDExternalSubsetParserDriver
				saxDriver: self
				documentURI: aURIString)
		on: aStringOrStream! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/31/2016 01:32'!
externalSubsetPublicID
	^ externalSubsetPublicID! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/31/2016 01:32'!
externalSubsetSystemID
	^ externalSubsetSystemID! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 8/6/2016 20:01'!
extractNamespacesFromAttributes: anOrderPreservingDictionary
	"returns an ordered collection of namespace prefix/uri associations
	removed from the attribute dictionary or nil if there aren't any"
	| namespaces keysToRemove |

	self haveNoUnhandledReservedAttributes.
	anOrderPreservingDictionary keysDo: [:name |
		"optimized comparison ordering"
		(name at: 1) == $x
			ifTrue: [
				name isXMLNSAttributeName
					ifTrue: [
						"only initialize when needed"
						(namespaces ifNil: [namespaces := OrderedCollection new: 5])
							addLast:
								(name size > 6 "'xmlns:' size"
									ifTrue: [name copyFrom: 7 to: name size]
									ifFalse: ['']) ->
										(anOrderPreservingDictionary at: name).
						"only initialize when needed"
						(keysToRemove ifNil: [keysToRemove := OrderedCollection new: 5])
							addLast: name]
					ifFalse: [
						name isXMLReservedAttributeName
							ifTrue: [
								"at least one xml attr is not an xmlns attr, so there
								will still be reserved attrs to handle after extracting
								the namespaces"
								self haveUnhandledReservedAttributes]]]].

	keysToRemove
		ifNotNil: [
			"use removeKeys: for speed"
			anOrderPreservingDictionary removeKeys: keysToRemove].

	^ namespaces.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:06'!
handleAttributeDeclaration: anElement name: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	super
		handleAttributeDeclaration: anElement
		name: anAttribute
		type: aType
		defaultPragma: aDefaultPragma
		defaultValue: aDefaultValue.

	self saxHandler
		attributeDeclaration: anElement
		name: anAttribute
		type: aType
		defaultPragma: aDefaultPragma
		defaultValue: aDefaultValue.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 10/26/2016 18:32'!
handleCData: aString
	self isValidating
		ifTrue: [self validator validatePCData: aString].

	self saxHandler
		isInCDataSection: true;
		startCData;
		characters: aString;
		endCData;
		isInCDataSection: false.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 4/13/2016 08:53'!
handleComment: aString
	(self elementNester isInElement
		and: [self isValidating])
		ifTrue: [self validator validateComment: aString].

	self saxHandler comment: aString.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:06'!
handleElementDeclaration: aName contentModel: aContentModel
	super
		handleElementDeclaration: aName
		contentModel: aContentModel.

	self saxHandler
		elementDeclaration: aName
		contentModel: aContentModel.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 11/16/2013 05:10'!
handleEndContentEntityReplacement: aName
	self saxHandler endEntity: aName! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 5/19/2017 18:12'!
handleEndDTD
	(self resolvesExternalEntities
		and: [self hasExternalSubset
			and: [self isValidating
				or: [self isStandalone not]]])
		ifTrue: [self parseExternalSubset].
	self isValidating
		ifTrue: [self doctypeDefinition validateCompletedDefinition].

	self saxHandler
		doctypeDefinition: self doctypeDefinition;
		endDTD.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 10/26/2016 18:33'!
handleEndDocument
	self isValidating
		ifTrue: [self validator validateEndDocument].

	self saxHandler endDocument.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 9/25/2017 10:50'!
handleEndTag: anElement
	"performance critical method"
	| prefix currentScope |

	prefix := anElement xmlPrefixBeforeLocalName.
	self saxHandler 
		endElement: anElement
		prefix: prefix
		uri:
			(self usesNamespaces
				ifTrue: [
					(currentScope := self scopeAllocator exitScope)
						resolvePrefix: prefix]
				ifFalse: [''])
		localName: (anElement xmlLocalNameAfterPrefix: prefix).

	self usesNamespaces
		ifTrue: [
			currentScope hasNamespaces
				ifTrue: [self undeclareNamespacesInScope: currentScope]].
	self isValidating
		ifTrue: [self validator validateEndTag: anElement].! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:05'!
handleGeneralEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotation
	super
		handleGeneralEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID
		ndata: aNotation.

	self saxHandler
		generalEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID
		ndata: aNotation.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:05'!
handleGeneralEntityDeclaration: aName replacement: aReplacement
	super
		handleGeneralEntityDeclaration: aName
		replacement: aReplacement.

	self saxHandler
		generalEntityDeclaration: aName
		replacement: aReplacement.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:03'!
handleNotationDeclaration: aName publicID: aPublicID systemID: aSystemID
	super
		handleNotationDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.

	self saxHandler
		notationDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 10/26/2016 19:45'!
handlePCData: aString
	self isValidating
		ifTrue: [self validator validatePCData: aString].

	self saxHandler characters: aString.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 4/16/2016 13:44'!
handlePI: aTargetString data: aDataString
	(self elementNester isInElement
		and: [self isValidating])
		ifTrue: [
			self validator
				validatePI: aTargetString
				data: aDataString].

	self saxHandler 
		processingInstruction: aTargetString
		data: aDataString.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:03'!
handleParameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	super
		handleParameterEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.

	self saxHandler
		parameterEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/19/2016 17:02'!
handleParameterEntityDeclaration: aName replacement: aReplacement
	super
		handleParameterEntityDeclaration: aName
		replacement: aReplacement.

	self saxHandler
		parameterEntityDeclaration: aName
		replacement: aReplacement.! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 8/6/2016 20:03'!
handleReservedAttributes: aDictionary
	aDictionary
		at: 'xml:base'
		ifPresent: [:uri |
			"expand the new base URI using the current"
			aDictionary
				at: 'xml:base'
				put: (self baseURI asXMLURI / uri) asString].
	self isValidating
		ifTrue: [self validator validateXMLIDAttributeIn: aDictionary].

	self elementNester
		setScopedAttributesNamed: self scopedAttributeNames
		from: aDictionary.

	self haveNoUnhandledReservedAttributes.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 3/24/2015 20:28'!
handleStartContent
	self saxHandler startContent! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 12/18/2013 22:08'!
handleStartContentEntityReplacement: aName
	self saxHandler startEntity: aName! !

!SAXParserDriver methodsFor: 'handling - dtd' stamp: 'monty 5/19/2017 18:12'!
handleStartDTD: aRoot publicID: aPublicID systemID: aSystemID
	externalSubsetPublicID := aPublicID.
	externalSubsetSystemID := aSystemID.

	self doctypeDefinition root: aRoot.
	self saxHandler
		startDTD: aRoot
		publicID: aPublicID
		systemID: aSystemID.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'mir 8/14/2000 18:29'!
handleStartDocument
	self saxHandler startDocument! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 9/25/2017 10:03'!
handleStartTag: anElement attributes: anAttributeDictionary
	"performance critical method"
	| prefix totalAttributes namespaceURI currentScope |

	prefix := anElement xmlPrefixBeforeLocalName.
	totalAttributes := anAttributeDictionary size.
	self isValidating
		ifTrue: [
			self elementNester totalOpenElements > 1
				ifFalse: [self validateRootElement: anElement].
			self validator
				validateStartTag: anElement
				attributes: anAttributeDictionary]
		ifFalse: [
			self doctypeDefinition
				processStartTag: anElement
				attributes: anAttributeDictionary].
	"validation and processing can add attributes"
	anAttributeDictionary size > totalAttributes
		ifTrue: [
			self
				checkForReservedAttributesIn: anAttributeDictionary
				afterIndex: totalAttributes.
			totalAttributes := anAttributeDictionary size].
	self usesNamespaces
		ifTrue: [
			anAttributeDictionary setNamespaceScope:
				(currentScope := self scopeAllocator enterScope).
			self hasUnhandledReservedAttributes
				ifTrue: [
					(self extractNamespacesFromAttributes: anAttributeDictionary)
						ifNotNil: [:namespaces |
							self
								declareNamespaces: namespaces
								inScope: currentScope.
							totalAttributes := anAttributeDictionary size]].
			self saxHandler startScope: currentScope.
			namespaceURI :=
				currentScope
					validateAndResolvePrefix: prefix
					ofElement: anElement.
			totalAttributes > 0
				ifTrue: [
					"anAttributeDictionary is an XMLAttributeDictionary, which
					is an OrderPreservingStringDictionary, so use its internal
					#orderedKeys over #keys for speed"
					currentScope
						validatePrefixesOfAttributes: anAttributeDictionary orderedKeys
						from: 1
						to: totalAttributes]].
	self hasUnhandledReservedAttributes
		ifTrue: [self handleReservedAttributes: anAttributeDictionary].

	self saxHandler
		startElement: anElement
		prefix: prefix
		uri: (namespaceURI ifNil: [''])
		localName: (anElement xmlLocalNameAfterPrefix: prefix)
		attributes: anAttributeDictionary.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 1/4/2015 00:01'!
handleUnreplacedGeneralEntityReference: aName
	self saxHandler skippedEntity: aName! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 12/6/2016 09:23'!
handleWhitespace: aString
	self isValidating
		ifTrue: [
			self validator isCurrentElementWhitespaceIgnorable
				ifTrue: [
					(self elementNester hasScopedAttributes
						and: [
							(self elementNester scopedAttributeAt: 'xml:space') =
								'preserve'])
						ifTrue: [self saxHandler characters: aString]
						ifFalse: [self saxHandler ignorableWhitespace: aString].
					^ self]
				ifFalse: [
					"only validate if it's not ignorable"
					self validator validatePCData: aString]].
	self saxHandler characters: aString.! !

!SAXParserDriver methodsFor: 'handling' stamp: 'monty 3/9/2015 13:59'!
handleXMLVersion: aVersion encoding: anEncoding standalone: aYesOrNo
	isStandalone := aYesOrNo = 'yes'.

	self saxHandler
		xmlVersion: (Float readFrom: aVersion readStream)
		encoding: anEncoding
		standalone: isStandalone.! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 11/24/2016 02:31'!
hasExternalSubset
	^ self externalSubsetPublicID notEmpty
		or: [self externalSubsetSystemID notEmpty]! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:52'!
hasParameterEntityReferences
	^ hasParameterEntityReferences! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:51'!
hasSkippedParameterEntityReferences
	^ hasSkippedParameterEntityReferences! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 11/3/2014 11:19'!
hasUnhandledReservedAttributes
	^ hasUnhandledReservedAttributes! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 7/9/2016 00:15'!
haveNoUnhandledReservedAttributes
	hasUnhandledReservedAttributes := false! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:54'!
haveParameterEntityReferences
	hasParameterEntityReferences := true! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 11/23/2016 22:55'!
haveSkippedParameterEntityReferences
	hasSkippedParameterEntityReferences := true! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 11/3/2014 16:16'!
haveUnhandledReservedAttributes
	hasUnhandledReservedAttributes := true! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 5/20/2017 03:24'!
isExternal
	"Definition: An external markup declaration is defined as a markup
	declaration occurring in the external subset or in a parameter entity
	(external or internal, the latter being included because non-validating
	processors are not required to read them)"

	"returning #isParameter instead of 'self currentEntity notNil'
	ensures the correct result when parsing content"
	^ self currentEntity
		ifNil: [false]
		ifNotNil: [:entity | entity isParameter]! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 11/23/2016 22:59'!
isStandalone
	^ isStandalone! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/6/2017 10:58'!
isStandalone: aBoolean
	isStandalone := aBoolean! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 7/12/2017 11:07'!
isValidating
	^ isValidating! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 1/19/2014 04:45'!
maxEntityReplacementDepth
	^ self saxHandler maxEntityReplacementDepth! !

!SAXParserDriver methodsFor: 'instance creation' stamp: 'monty 9/21/2017 10:52'!
newAttributeDictionary
	^ (self usesNamespaces
		ifTrue: [XMLNamespacedAttributeDictionary]
		ifFalse: [XMLAttributeDictionary]) new! !

!SAXParserDriver methodsFor: 'instance creation' stamp: 'monty 9/21/2017 10:52'!
newEmptyAttributeDictionary
	^ (self usesNamespaces
		ifTrue: [XMLLazyNamespacedAttributeDictionary]
		ifFalse: [XMLLazyAttributeDictionary]) new! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 10/16/2017 17:31'!
parseExternalSubset
	| externalSubsetURI |

	externalSubsetURI :=
		self externalEntityResolver
			externalEntityURIFromPublicID: self externalSubsetPublicID
			systemID: self externalSubsetSystemID
			baseURI: self baseURI.

	"External subsets are stream-resolved so if they are local (stored on disk),
	they aren't kept entirely in memory during parsing. HTTP entities will be
	kept in memory regardless and this will just return a read stream on them."
	(self
		externalSubsetParserOn:
			(self externalEntityResolver streamResolveExternalEntityURI:
				externalSubsetURI)
		documentURI: externalSubsetURI asString)
		parseDocument.! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 1/6/2015 04:12'!
preservesUndeclaredEntityReferences
	^ self saxHandler preservesUndeclaredEntityReferences! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 1/19/2014 04:45'!
readLimit
	^ self documentReadLimit! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 1/4/2015 00:14'!
replacesContentEntityReferences
	^ self saxHandler replacesContentEntityReferences! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 2/9/2014 02:28'!
resolvesExternalEntities
	^ self saxHandler resolvesExternalEntities! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'JAAyer 11/27/2010 08:00'!
saxHandler
	^ saxHandler! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 12/27/2013 03:40'!
scopeAllocator
	^ scopeAllocator ifNil: [scopeAllocator := XMLNamespaceScopeAllocator new]! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 7/1/2016 05:22'!
scopedAttributeNames
	"the scoped attributes tracked by this driver"
	^ #('xml:space' 'xml:base')! !

!SAXParserDriver methodsFor: 'initialization' stamp: 'monty 9/7/2017 08:43'!
setSAXHandler: aSAXHandler
	saxHandler := aSAXHandler.
	doctypeDefinition := self doctypeDefinitionClass new.
	validator := (aSAXHandler schema ifNil: [doctypeDefinition]) newValidator.
	elementNester := self newElementNester.
	externalSubsetPublicID := ''.
	externalSubsetSystemID := ''.
	"these are copied to inst vars for faster access"
	isValidating := aSAXHandler isValidating.
	usesNamespaces := aSAXHandler usesNamespaces.
	isStandalone := false.
	hasParameterEntityReferences := false.
	hasSkippedParameterEntityReferences := false.
	hasUnhandledReservedAttributes := false.! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 3/13/2016 19:42'!
undeclareNamespacesInScope: anExitedScope
	| currentScope |

	currentScope := self scopeAllocator currentScope.
	anExitedScope prefixesAndURIsDo: [:prefix :uri |
		(currentScope resolvePrefix: prefix) = uri
			ifFalse: [self saxHandler endPrefixMapping: prefix]].! !

!SAXParserDriver methodsFor: 'testing' stamp: 'monty 7/12/2017 11:07'!
usesNamespaces
	^ usesNamespaces! !

!SAXParserDriver methodsFor: 'private' stamp: 'monty 1/29/2018 08:21'!
validateRootElement: anElement
	self saxHandler requiresSchema
		ifTrue: [
			(self validator hasElementValidators
				or: [self validator hasAttributeValidators])
				ifFalse: [self errorDocumentConstraintsRequired]].

	self validator validateRootElement: anElement.! !

!SAXParserDriver methodsFor: 'accessing' stamp: 'monty 3/18/2016 00:52'!
validator
	^ validator! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 10/24/2016 16:39'!
baseURI
	"returns a string with the current base URI at this stage of parsing"
	^ baseURI ifNil: [baseURI := self documentURI]! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 10/24/2016 16:39'!
baseURI: aURI
	baseURI := aURI! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 11/1/2016 03:47'!
currentEntity
	^ currentEntity! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 11/1/2016 03:47'!
currentEntity: anEntity
	currentEntity := anEntity! !

!XMLParserDriver methodsFor: 'testing' stamp: 'monty 3/30/2016 07:43'!
decodesCharacters
	^ true! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 11/16/2013 04:35'!
documentURI
	^ nil! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 6/26/2017 04:21'!
elementNester
	^ self newElementNester! !

!XMLParserDriver methodsFor: 'defaults' stamp: 'monty 10/29/2016 00:07'!
elementNesterClass
	^ XMLElementNester! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 6/7/2015 20:05'!
handleAttributeDeclaration: anElement name: anAttribute type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleCData: aString! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleComment: aString! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/14/2013 03:46'!
handleElementDeclaration: aName contentModel: aContentModel! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 11/16/2013 05:10'!
handleEndContentEntityReplacement: aName
! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/12/2013 17:36'!
handleEndDTD! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleEndDocument! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 8/6/2016 19:55'!
handleEndTag: anElement! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 3/21/2015 22:37'!
handleGeneralEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotation! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/14/2013 03:10'!
handleGeneralEntityDeclaration: aName replacement: aReplacement! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 11/14/2013 20:44'!
handleGeneralEntityReference: aName
	^ nil! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 3/21/2015 22:37'!
handleNotationDeclaration: aName publicID: aPublicID systemID: aSystemID! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handlePCData: aString! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 3/21/2015 23:27'!
handlePI: aTargetString data: aDataString! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 3/21/2015 22:37'!
handleParameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/14/2013 03:10'!
handleParameterEntityDeclaration: aName replacement: aReplacement! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 11/14/2013 20:44'!
handleParameterEntityReference: aName
	^ nil! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 3/25/2016 05:11'!
handleParseError: aString! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 3/24/2015 20:27'!
handleStartContent! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 11/16/2013 05:10'!
handleStartContentEntityReplacement: aName! !

!XMLParserDriver methodsFor: 'handling - dtd' stamp: 'monty 3/21/2015 22:37'!
handleStartDTD: aRoot publicID: aPublicID systemID: aSystemID! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleStartDocument! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 8/9/2017 00:26'!
handleStartTag: anElement attributes: anAttributeDictionary! !

!XMLParserDriver methodsFor: 'handling' stamp: 'monty 1/4/2015 00:01'!
handleUnreplacedGeneralEntityReference: aName! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleWhitespace: aString! !

!XMLParserDriver methodsFor: 'handling' stamp: 'JAAyer 11/27/2010 07:23'!
handleXMLVersion: aVersion encoding: anEncoding standalone: aYesOrNo! !

!XMLParserDriver methodsFor: 'defaults' stamp: 'monty 10/6/2017 14:11'!
initialStateClass
	^ XMLXMLDeclarationState! !

!XMLParserDriver methodsFor: 'instance creation' stamp: 'monty 6/26/2017 04:21'!
newElementNester
	^ self elementNesterClass new! !

!XMLParserDriver methodsFor: 'instance creation' stamp: 'monty 10/6/2017 14:11'!
newInitialState
	^ self initialStateClass new! !

!XMLParserDriver methodsFor: 'instance creation' stamp: 'monty 3/26/2016 23:49'!
newTokenizerOn: aStringOrStream
	^ self tokenizerClass
		driver: self
		on: aStringOrStream
		readLimit: self readLimit! !

!XMLParserDriver methodsFor: 'accessing' stamp: 'monty 1/16/2014 19:45'!
readLimit
	^ nil! !

!XMLParserDriver methodsFor: 'defaults' stamp: 'monty 2/10/2014 02:43'!
tokenizerClass
	^ XMLWellFormedParserTokenizer! !

Object subclass: #XMLParserLimits
	instanceVariableNames: 'documentReadLimit maxEntityReplacementDepth'
	classVariableNames: 'DefaultReadLimit'
	poolDictionaries: ''
	category: 'XML-Parser'!

!XMLParserLimits commentStamp: 'monty 7/13/2015 13:17' prior: 0!
This class places security limits on input. Setting a limit to nil disables it, and removeAll disables all.!

!XMLParserLimits class methodsFor: 'defaults' stamp: 'monty 12/9/2014 07:41'!
defaultDocumentReadLimit
	^ self defaultReadLimit! !

!XMLParserLimits class methodsFor: 'defaults' stamp: 'monty 7/13/2015 13:14'!
defaultMaxEntityReplacementDepth
	^ 10! !

!XMLParserLimits class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:34'!
defaultReadLimit
	^ DefaultReadLimit
		ifNil: [DefaultReadLimit := 10000000]! !

!XMLParserLimits class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:36'!
defaultReadLimit: aDefaultLimit
	"can be used to change the default read limit instances start with"
	DefaultReadLimit := aDefaultLimit! !

!XMLParserLimits methodsFor: 'accessing' stamp: 'monty 1/16/2014 18:43'!
documentReadLimit
	^ documentReadLimit! !

!XMLParserLimits methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:29'!
documentReadLimit: anInteger
	documentReadLimit := anInteger! !

!XMLParserLimits methodsFor: 'initialization' stamp: 'monty 7/13/2015 13:12'!
initialize
	super initialize.

	documentReadLimit := self class defaultDocumentReadLimit.
	maxEntityReplacementDepth := self class defaultMaxEntityReplacementDepth.! !

!XMLParserLimits methodsFor: 'accessing' stamp: 'monty 1/16/2014 18:45'!
maxEntityReplacementDepth
	^ maxEntityReplacementDepth! !

!XMLParserLimits methodsFor: 'accessing' stamp: 'monty 4/14/2016 03:30'!
maxEntityReplacementDepth: anInteger
	maxEntityReplacementDepth := anInteger! !

!XMLParserLimits methodsFor: 'removing' stamp: 'monty 1/27/2015 22:46'!
removeAll
	documentReadLimit := nil.
	maxEntityReplacementDepth := nil.! !

Object subclass: #XMLParserTokenizer
	instanceVariableNames: 'state driver elementNester streamReader nameStream xmlDeclarationStream characterStream'
	classVariableNames: 'PredefinedEntities'
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLParserTokenizer commentStamp: 'monty 10/6/2017 14:27' prior: 0!
This is a base class for parser tokenizers that read tokens from a stream using an XMLNestedStreamReader and state objects. Sending #nextToken causes a token to be read and handler messages to be sent to a driver.

Be careful changing the code in this class or subclasses because it's optimized.!

!XMLParserTokenizer class methodsFor: 'instance creation' stamp: 'monty 1/17/2014 01:27'!
driver: aDriver on: aStringOrStream
	^self
		driver: aDriver
		on: aStringOrStream
		readLimit: nil! !

!XMLParserTokenizer class methodsFor: 'instance creation' stamp: 'monty 9/29/2017 12:14'!
driver: aDriver on: aStringOrStream readLimit: anInteger
	^self new
		setDriver: aDriver
		stream:
			(aStringOrStream isStream
				ifTrue: [aStringOrStream]
				ifFalse: [aStringOrStream readStream])
		readLimit: anInteger! !

!XMLParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 9/28/2016 22:29'!
initialize
	"self initialize"

	"assign after with #yourself to avoid possible race
	conditions when reinitializing the class"
	PredefinedEntities :=
		Dictionary new
			at: 'lt' put: $<;
			at: 'gt' put: $>;
			at: 'amp' put: $&;
			at: 'apos' put: $';
			at: 'quot' put: $";
			yourself! !

XMLParserTokenizer initialize!

!XMLParserTokenizer class methodsFor: 'accessing' stamp: 'monty 11/18/2014 07:11'!
predefinedEntities
	^ PredefinedEntities! !

!XMLParserTokenizer methodsFor: 'testing' stamp: 'monty 10/6/2017 14:10'!
atEnd
	^ state isTerminatedState! !

!XMLParserTokenizer methodsFor: 'decoding' stamp: 'monty 3/24/2016 21:01'!
characterFromCodePoint: aCodePoint
	(aCodePoint notNil
		and: [aCodePoint > 0
			and: [aCodePoint <= 16r10FFFF]])
		ifTrue: [
			^ [Character value: aCodePoint]
				on: Error
				do: [:error | nil]]
		ifFalse: [^ nil]! !

!XMLParserTokenizer methodsFor: 'closing' stamp: 'monty 11/24/2014 19:27'!
closeStreams
	streamReader closeStreams! !

!XMLParserTokenizer methodsFor: 'decoding' stamp: 'monty 3/5/2016 06:45'!
convertFromEncoding: anEncodingName
	driver decodesCharacters
		ifTrue: [streamReader convertFromEncoding: anEncodingName]! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 3/18/2016 01:46'!
currentColumnNumber
	^ streamReader currentColumnNumber! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 12/7/2013 00:35'!
currentLineNumber
	^ streamReader currentLineNumber! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 3/18/2016 02:19'!
currentPosition
	^ streamReader currentPosition! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 12/7/2013 00:35'!
driver
	^ driver! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/27/2016 00:36'!
elementNester
	^ elementNester! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:50'!
errorExpected: aDescription
	self parseError: 'Expected ', aDescription! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:50'!
errorExpected: aDescription butGot: aCharacter
	self
		formatParseError: 'Expected {1} but got "{2}"'
		with: aDescription
		with: (aCharacter ifNil: [''])! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:50'!
errorExpectedLiteral: aCharacterOrString
	self
		errorExpectedLiteral: aCharacterOrString
		butGot: nil! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 09:14'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	self
		formatParseError: 'Expected "{1}" but got "{2}"' 
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XMLParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 12/8/2013 04:35'!
expectNext: aCharacter
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 12/8/2013 04:37'!
expectNextAll: aString
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 4/3/2015 17:50'!
expectSeparators
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 4/3/2015 01:32'!
expectTerminator
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/3/2016 18:38'!
formatParseError: aString with: aFirstValue
	self
		formatParseError: aString
		withArguments: (Array with: aFirstValue)! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/3/2016 18:38'!
formatParseError: aString with: aFirstValue with: aSecondValue
	self
		formatParseError: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue)! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/3/2016 18:38'!
formatParseError: aString with: aFirstValue with: aSecondValue with: aThirdValue
	self
		formatParseError: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue
				with: aThirdValue)! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/3/2016 18:38'!
formatParseError: aString with: aFirstValue with: aSecondValue with: aThirdValue with: aFourthValue
	self
		formatParseError: aString
		withArguments:
			(Array
				with: aFirstValue
				with: aSecondValue
				with: aThirdValue
				with: aFourthValue)! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 7/3/2016 18:38'!
formatParseError: aString withArguments: aValueCollection
	self parseError: (aString format: aValueCollection)! !

!XMLParserTokenizer methodsFor: 'defaults' stamp: 'monty 1/24/2018 02:53'!
hexCharacterValueLiteralPrefixes
	^ 'x'! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/25/2016 05:20'!
nextCDataSection
	self subclassResponsibility
! !

!XMLParserTokenizer methodsFor: 'decoding' stamp: 'monty 1/24/2018 02:52'!
nextCharacterValueLiteral
	^ self nextCharacterValueLiteralPrintedOn: nil! !

!XMLParserTokenizer methodsFor: 'decoding' stamp: 'monty 1/24/2018 02:53'!
nextCharacterValueLiteralPrintedOn: aStream
	"do not limit the number of chars read, because char values can
	have an arbitrary number of leading zeros"
	^ (XMLSmallIntegerReader on: streamReader)
		printStream: aStream;
		nextIntegerWithBase: 16
			andPrefixes: self hexCharacterValueLiteralPrefixes
			orBase: 10! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 12/12/2014 06:52'!
nextContentMarkupToken
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/30/2016 04:01'!
nextContentToken
	streamReader peek == $<
		ifTrue: [
			streamReader next.
			^ self nextContentMarkupToken].
	elementNester isInElement
		ifTrue: [^ self nextPCDataToken].
	self nextNonElementWhitespace.! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/6/2017 14:20'!
nextDoctypeDeclaration
	| root publicID systemID |

	state := state doctypeDeclarationState.
	self
		expectNextAll: 'DOCTYPE';
		expectSeparators.

	root := self nextElementName.
	(streamReader peek == $[
		or: [streamReader peek == $>])
		ifFalse: [
			self expectSeparators.
			streamReader peek == $P
				ifTrue: [
					publicID := self nextPublicID.
					self expectSeparators.
					systemID := self nextSystemIDLiteral]
				ifFalse: [
					streamReader peek == $S
						ifTrue: [systemID := self nextSystemID]]].
	driver
		handleStartDTD: root
		publicID: (publicID ifNil: [''])
		systemID: (systemID ifNil: ['']).

	streamReader skipSeparators.
	streamReader peek == $[
		ifTrue: [self nextStartInternalSubset]
		ifFalse: [self nextEndDoctypeDeclaration].! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/5/2017 03:35'!
nextElementName
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/6/2017 14:20'!
nextEndDoctypeDeclaration
	self expectTerminator.
	state := state postDoctypeDeclarationState.

	driver handleEndDTD.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:21'!
nextEndDocument
	state isTerminatedState
		ifFalse: [
			self closeStreams.
			state := state terminatedState.
			driver handleEndDocument]! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/23/2016 00:20'!
nextEndInternalSubset
	"skip ]"
	streamReader
		next;
		skipSeparators.
	self nextEndDoctypeDeclaration.! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/23/2016 00:20'!
nextInternalSubsetToken
	streamReader skipSeparators.
	streamReader peek == $%
		ifTrue: [
			streamReader next.
			^ self nextParameterEntityReference].
	streamReader peek == $]
		ifTrue: [^ self nextEndInternalSubset].
	self nextSubsetMarkupToken.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/28/2016 17:05'!
nextNonElementWhitespace
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 15:38'!
nextNonPIPrologOrContentMarkupToken
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 12/12/2014 06:49'!
nextPCDataToken
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/6/2015 07:16'!
nextPI
	"skip ?"
	streamReader next.
	self nextPIWithTarget: self nextPITarget.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 02:30'!
nextPIData
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 15:27'!
nextPITarget
	"should return a PI target string or nil if it's the start of
	an '<?xml ...?>' declaration"
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 02:30'!
nextPIWithTarget: aTarget
	streamReader peek == $?
		ifTrue: [
			streamReader next.
			self expectTerminator.
			driver
				handlePI: aTarget
				data: '']
		ifFalse: [
			self expectSeparators.
			driver
				handlePI: aTarget
				data: self nextPIData].! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 1/7/2015 02:28'!
nextParameterEntityReference
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 12/7/2013 03:19'!
nextPrologToken
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 03:42'!
nextPublicID
	^ self
		expectNextAll: 'PUBLIC';
		expectSeparators;
		nextPublicIDLiteral! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/10/2015 10:20'!
nextPublicIDLiteral
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:20'!
nextStartContent
	state := state contentState.
	elementNester := driver elementNester.
	driver handleStartContent.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:16'!
nextStartDocument
	self state: driver newInitialState.
	driver handleStartDocument.! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/6/2017 14:20'!
nextStartInternalSubset
	"skip ["
	streamReader next.
	state := state internalSubsetState.! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 12/10/2013 07:21'!
nextSubsetMarkupToken
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 03:41'!
nextSystemID
	^ self
		expectNextAll: 'SYSTEM';
		expectSeparators;
		nextSystemIDLiteral! !

!XMLParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 03:41'!
nextSystemIDLiteral
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:10'!
nextToken
	(streamReader atEnd
		and: [state isInitializedState])
		ifTrue: [^ self nextEndDocument].
	state nextTokenFrom: self.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 1/4/2014 06:33'!
nextXMLAttributeName: aName
	self expectNextAll: aName.
	streamReader skipSeparators.
	self expectNext: $=.
	streamReader skipSeparators.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:21'!
nextXMLDeclaration
	| version encoding |

	self expectSeparators.
	version := self nextXMLVersionAttributeRequired: true.
	streamReader peek == $?
		ifFalse: [self expectSeparators].
	(encoding := self nextXMLEncodingAttributeRequired: false) isEmpty
		ifFalse: [
			self convertFromEncoding: encoding.
			streamReader peek == $?
				ifFalse: [self expectSeparators]].
	driver
		handleXMLVersion: version
		encoding: encoding
		standalone: self nextXMLStandaloneAttribute.
	streamReader skipSeparators.
	self
		expectNext: $?;
		expectTerminator.

	state := state prologState.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:21'!
nextXMLDeclarationOrPrologToken
	streamReader peek == $<
		ifTrue: [
			streamReader next.
			streamReader peek == $?
				ifTrue: [
					streamReader next.
					self nextPITarget
						ifNil: [^ self nextXMLDeclaration]
						ifNotNil: [:target |
							state := state prologState.
							^ self nextPIWithTarget: target]].
			state := state prologState.
			^ self nextNonPIPrologOrContentMarkupToken].

	"other prolog tokens can have whitespace before them, so the doc
	does not need to start with an '<' for them"
	state := state prologState.
	self nextPrologToken.! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/3/2015 18:12'!
nextXMLEncodingAttributeRequired: aBoolean
	(aBoolean or: [streamReader peek == $e])
		ifTrue: [	
			^ self
				nextXMLAttributeName: 'encoding';
				nextXMLEncodingAttributeValue]
		ifFalse: [^ '']! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 1/4/2014 06:47'!
nextXMLEncodingAttributeValue
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/3/2015 18:13'!
nextXMLStandaloneAttribute
	"always optional"
	(streamReader peek == $s)
		ifTrue: [
			^ self
				nextXMLAttributeName: 'standalone';
				nextXMLStandaloneAttributeValue]
		ifFalse: [^ '']! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 1/4/2014 06:44'!
nextXMLStandaloneAttributeValue
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/3/2015 18:13'!
nextXMLVersionAttributeRequired: aBoolean
	(aBoolean or: [streamReader peek == $v])
		ifTrue: [
			^ self
				nextXMLAttributeName: 'version';
				nextXMLVersionAttributeValue]
		ifFalse: [^ '']! !

!XMLParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 1/4/2014 06:34'!
nextXMLVersionAttributeValue
	self subclassResponsibility! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 1/16/2014 09:08'!
normalizedLineEndingChar
	^ streamReader normalizedLineEndingChar! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 12/18/2013 17:26'!
normalizedLineEndingChar: aCharacter
	streamReader normalizedLineEndingChar: aCharacter! !

!XMLParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:38'!
parseError: aString
	driver handleParseError: aString! !

!XMLParserTokenizer methodsFor: 'printing' stamp: 'monty 10/6/2017 14:10'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: state;
		nextPutAll: '; ';
		print: streamReader;
		nextPut: $).! !

!XMLParserTokenizer methodsFor: 'initialization' stamp: 'monty 10/6/2017 14:10'!
setDriver: aDriver stream: aStream readLimit: anInteger
	state := XMLUninitializedState new.
	driver := aDriver.
	streamReader :=
		self streamReaderClass
			on: aStream
			readLimit: anInteger.

	"must use #writeStream instead of 'WriteStream on:' to get 0-based
	streams on Gemstone"
	nameStream := (String new: 16) writeStream.
	"this separate stream is needed because XML text delcarations can occur
	in the replacement of external general entity references in PCDATA and
	external parameter entity references within declarations in the external
	subset or external entities, and characterStream would already be in use
	in both cases"
	xmlDeclarationStream := (String new: 8) writeStream.
	characterStream := (String new: 128) writeStream.! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/6/2017 14:17'!
state
	^ state! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 11/2/2017 11:45'!
state: aTokenState
	(state := aTokenState) isContentState
		ifTrue: [elementNester := driver elementNester].
	(driver decodesCharacters
		and: [state supportsEncodingDetection])
		ifTrue: [streamReader detectEncoding].! !

!XMLParserTokenizer methodsFor: 'accessing' stamp: 'monty 12/7/2013 00:35'!
streamReader
	^ streamReader! !

!XMLParserTokenizer methodsFor: 'defaults' stamp: 'monty 9/28/2017 14:16'!
streamReaderClass
	^ XMLNestedStreamReader! !

XMLParserTokenizer subclass: #XMLWellFormedParserTokenizer
	instanceVariableNames: 'pushedBackEntities totalOpenIncludeSections isInLiteralValue isIgnoringLiteralValueTerminator'
	classVariableNames: 'EncodingNameChars EncodingNameStartChars NormalizedSpace PublicIDChars VersionDigitChars'
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLWellFormedParserTokenizer commentStamp: 'monty 6/15/2015 23:55' prior: 0!
This is a tokenizer for well-formed XML documents that supports DTD subsets and entity replacement.!

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 4/1/2016 06:45'!
initialize
	"self initialize"

	self
		initializeNormalizedSpace;
		initializePublicIDChars;
		initializeEncodingNameStartChars;
		initializeEncodingNameChars;
		initializeVersionDigitChars! !

XMLWellFormedParserTokenizer initialize!

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 12:45'!
initializeEncodingNameChars
	"EncName ::= [A-Za-z] ([A-Za-z0-9._] | '-')*"

	"assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class"
	EncodingNameChars :=
		BitmapCharacterSet new
			addRangeFrom: $a to: $z;
			addRangeFrom: $A to: $Z;
			addRangeFrom: $0 to: $9;
			addAll: '-_.';
			yourself! !

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 12:45'!
initializeEncodingNameStartChars
	"Character>>isLetter is not used because it may return true for non-ASCII
	letters depending on the locale.
	
	EncName ::= [A-Za-z] ([A-Za-z0-9._] | '-')*"

	"assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class"
	EncodingNameStartChars :=
		BitmapCharacterSet new
			addRangeFrom: $a to: $z;
			addRangeFrom: $A to: $Z;
			yourself! !

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 10/6/2016 02:09'!
initializeNormalizedSpace
	"stored in a class var for faster access"
	NormalizedSpace := Character space! !

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 10/6/2016 02:09'!
initializePublicIDChars
	"PubidChar ::= #x20 | #xD | #xA | [a-zA-Z0-9] | [-'()+,./:=?;!!*#@$_%]"

	"assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class"
	PublicIDChars :=
		BitmapCharacterSet new
			add: 16r20 asCharacter;
			add: 16rD asCharacter;
			add: 16rA asCharacter;
			addRangeFrom: $a to: $z;
			addRangeFrom: $A to: $Z;
			addRangeFrom: $0 to: $9;
			addAll: '-''()+,./:=?;!!*#@$_%';
			yourself! !

!XMLWellFormedParserTokenizer class methodsFor: 'class initialization' stamp: 'monty 9/23/2016 12:45'!
initializeVersionDigitChars
	"Character>>#isDigit is not used because it may return true for non-ASCII
	digits depending on the locale.
	
	VersionNum ::= '1.' [0-9]+"

	"assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class"
	VersionDigitChars :=
		BitmapCharacterSet new
			addRangeFrom: $0 to: $9;
			yourself! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 5/2/2017 22:36'!
addPushedBackEntity: aPushedBackEntity
	(self hasPushedBackEntity: aPushedBackEntity)
		ifTrue: [self errorSelfReferentialEntity: aPushedBackEntity].

	self maxEntityReplacementDepth
		ifNotNil: [:maxDepth |
			self pushedBackEntities size >= maxDepth
				ifTrue: [self errorEntityDepthLimitExceeded]].
	
	self pushedBackEntities addLast: aPushedBackEntity.
	driver currentEntity: aPushedBackEntity entity.
	aPushedBackEntity isExternal
		ifTrue: [driver baseURI: aPushedBackEntity uri].

	^ aPushedBackEntity.! !

!XMLWellFormedParserTokenizer methodsFor: 'decoding' stamp: 'monty 3/24/2016 21:02'!
characterFromCodePoint: aCodePoint
	| character |

	"nil understands isXMLChar so it does not need to be tested for"
	(character := super characterFromCodePoint: aCodePoint) isXMLChar
		ifTrue: [^ character]
		ifFalse: [^ nil].! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 10/6/2017 14:31'!
constructLiteralReplacementForEntity: anEntity
	| wasIgnoringLiteralValueTerminator |

	wasIgnoringLiteralValueTerminator := isIgnoringLiteralValueTerminator.
	isIgnoringLiteralValueTerminator := true.
	self
		pushBackEntity: anEntity
		whenPoppedDo: [
			isIgnoringLiteralValueTerminator := wasIgnoringLiteralValueTerminator].! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 10/6/2017 14:38'!
constructReplacementForGeneralEntity: anEntity
	isInLiteralValue
		ifTrue: [
			anEntity isExternal
				ifTrue: [self errorLiteralReferenceToExternalGeneralEntity: anEntity].
			self constructLiteralReplacementForEntity: anEntity]
		ifFalse: [
			driver handleStartContentEntityReplacement: anEntity name.
			self
				pushBackEntity: anEntity
				whenPoppedDo: [driver handleEndContentEntityReplacement: anEntity name]]! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 10/6/2017 14:31'!
constructReplacementForParameterEntity: anEntity
	isInLiteralValue
		ifTrue: [self constructLiteralReplacementForEntity: anEntity]
		ifFalse: [
			"the trailing space"
			streamReader pushBackCharacter: NormalizedSpace.
			self
				pushBackEntity: anEntity
				whenPoppedDo: nil.
			"the leading space"
			streamReader pushBackCharacter: NormalizedSpace]! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 8/6/2016 19:57'!
errorDuplicateAttribute: anAttribute
	self
		formatParseError: 'Duplicate attribute "{1}" in start tag'
		with: anAttribute! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 11/1/2014 15:40'!
errorEntityDepthLimitExceeded
	XMLLimitException signal: 
		'Cannot further nest entity replacements; ',
		'use #maxEntityReplacementDepth: to change or disable'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/5/2017 00:28'!
errorExpectedAttributeName
	self errorExpected: 'attribute name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 08:20'!
errorExpectedAttributeNameValueSeparatorButGot: aCharacter
	self
		errorExpected: 'attribute name-value "=" separator'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedAttributeValueEnd: aQuote butGot: aCharacter
	aCharacter == $<
		ifTrue: [self parseError: 'Attribute value contains illegal "<" character']
		ifFalse: [
			self
				errorExpectedQuote: aQuote
				ending: 'attribute value'
				butGot: aCharacter]! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 08:18'!
errorExpectedAttributeValueStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: 'attribute value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/23/2016 22:57'!
errorExpectedCDataSectionTerminator
	self errorExpected: 'end of CDATA section "]]>" terminator'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/5/2017 00:27'!
errorExpectedElementName
	self errorExpected: 'element name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/1/2016 06:40'!
errorExpectedEncodingName
	self errorExpected: 'encoding name in <?xml ...?> encoding attribute'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/14/2017 10:06'!
errorExpectedEndTag: anExpectedEndTag butGot: aCharacter at: aCharacterPosition
	| receivedEndTag |

	"try to get the entire unexpected name"
	nameStream reset.
	1 to: aCharacterPosition - 1 do: [:i |
		nameStream nextPut: (anExpectedEndTag at: i)].
	"nil understands isXMLNameChar so it is not tested for"
	aCharacter isXMLNameChar
		ifTrue: [
			nameStream nextPut: aCharacter.
			[streamReader peek isXMLNameChar]
				whileTrue: [nameStream nextPut: streamReader next]].

	(receivedEndTag := nameStream contents) size > 0
		ifTrue: [
			(elementNester hasOpenElement: receivedEndTag)
				ifTrue: [self errorUnterminatedElementsInElement: receivedEndTag]
				ifFalse: [self errorTerminatingUnstartedElement: receivedEndTag]]
		ifFalse: [self errorExpectedElementName].! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/5/2017 00:31'!
errorExpectedEntityName
	self errorExpected: 'entity name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedEntityValueEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: 'entity value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/11/2016 12:00'!
errorExpectedIntegerCharacterReference
	self errorExpected:
		'decimal or hex integer after "&#" character reference start'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 11/24/2016 02:49'!
errorExpectedLiteral: aString butGot: aCharacter at: aStringPosition
	| receivedString |

	receivedString :=
		(aString
			copyReplaceFrom: aStringPosition
			to: aString size
			with:
				(aCharacter ifNil: ['']) asString,
				(streamReader next: aString size - aStringPosition)).

	self
		errorExpectedLiteral: aString
		butGot: receivedString.! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:46'!
errorExpectedName
	self errorExpected: 'an XML name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:46'!
errorExpectedNmtoken
	self errorExpected: 'an XML Nmtoken name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/5/2017 03:06'!
errorExpectedNotationName
	self errorExpected: 'notation name'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/6/2017 14:10'!
errorExpectedPITarget
	self errorExpected:
		(state isXMLDeclarationState
			ifTrue: ['xml declaration name or processing instruction target']
			ifFalse: ['processing instruction target'])! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedPublicIDLiteralEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: 'public ID literal'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 09:08'!
errorExpectedPublicIDLiteralStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: 'public ID literal'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedQuote: aQuote ending: aDescription butGot: aCharacter
	self
		formatParseError: 'Expected end of {1} ({2}) quoted {3} but got "{4}"'
		with:
			(aQuote == $"
				ifTrue: ['double']
				ifFalse: ['single'])
		with: aQuote
		with: aDescription
		with: (aCharacter ifNil: [''])! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/30/2016 21:44'!
errorExpectedQuoteStarting: aDescription butGot: aCharacter
	self
		formatParseError:
			'Expected start of double (") or single ('') quoted {1} but got "{2}"'
		with: aDescription
		with: (aCharacter ifNil: [''])! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/3/2015 17:50'!
errorExpectedSeparators
	self errorExpected: 'one or more whitespace characters'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/30/2016 09:17'!
errorExpectedSubsetDeclaration
	self errorExpected:
		'DTD subset ELEMENT, ATTLIST, ENTITY, or NOTATION declaration'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedSystemIDLiteralEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: 'system ID literal'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 09:11'!
errorExpectedSystemIDLiteralStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: 'system ID literal'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/25/2015 20:25'!
errorExpectedTerminatorButGot: aCharacter
	self
		errorExpected: '">" terminator'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/15/2016 07:38'!
errorExpectedVersionDigitButGot: aCharacter
	self
		errorExpected: 'XML version digit'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedXMLEncodingValueEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: '<?xml ...?> encoding value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 08:33'!
errorExpectedXMLEncodingValueStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: '<?xml ...?> encoding value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedXMLStandaloneValueEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: '<?xml ...?> standalone value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 08:33'!
errorExpectedXMLStandaloneValueStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: '<?xml ...?> standalone value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 21:47'!
errorExpectedXMLVersionValueEnd: aQuote butGot: aCharacter
	self
		errorExpectedQuote: aQuote
		ending: '<?xml ...?> version value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 7/16/2016 08:42'!
errorExpectedXMLVersionValueStartButGot: aCharacter
	self
		errorExpectedQuoteStarting: '<?xml ...?> version value'
		butGot: aCharacter! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/6/2016 08:02'!
errorImproperGeneralEntityNesting
	self parseError:
		'Markup tokens must start and end in the same general entity replacement'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/31/2016 03:43'!
errorInputTerminatedPrematurely
	self parseError: 'Input terminated prematurely'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/10/2016 02:53'!
errorInternalDeclarationParameterEntityReference
	self parseError: 'Parameter entity reference within internal subset declaration'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/23/2015 23:21'!
errorInternalSubsetConditionalSection
	self parseError:
		'Cannot have <!![INCLUDE[...]> or <!![IGNORE[...]> sections in internal subset'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:47'!
errorInvalidCharacterReferenceCodePoint: aCodePoint
	self
		formatParseError: 'Invalid character reference to U+{1} code point'
		with: aCodePoint printStringHex! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/6/2017 14:39'!
errorLiteralReferenceToExternalGeneralEntity: anEntity
	self
		formatParseError:
			'External general entity reference {1} in attribute value'
		with: anEntity asReference! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/6/2015 04:38'!
errorMultipleDoctypeDeclarations
	self parseError: 'Multiple <!!DOCTYPE ...> declarations'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/26/2016 19:22'!
errorMultipleDocumentRootElements
	self parseError: 'Document cannot have multiple root elements'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/26/2016 21:57'!
errorNonChar: aCharacter in: aDescription
	self
		formatParseError: 'Invalid character U+{1} in {2}'
		with: aCharacter asciiValue printStringHex
		with: aDescription! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/23/2016 22:41'!
errorNonCharInAttributeValue: aCharacter
	self
		errorNonChar: aCharacter
		in: 'attribute value'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/26/2016 21:58'!
errorNonCharInCDataSection: aCharacter
	self
		errorNonChar: aCharacter
		in: '<!![CDATA[...]]> section'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/23/2016 22:42'!
errorNonCharInComment: aCharacter
	self
		errorNonChar: aCharacter
		in: 'comment'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 6/27/2016 23:03'!
errorNonCharInEntityValue: aCharacter
	self
		errorNonChar: aCharacter
		in: 'entity value'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/23/2016 22:38'!
errorNonCharInPCData: aCharacter
	self
		errorNonChar: aCharacter
		in: 'PCDATA'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/23/2016 23:04'!
errorNonCharInPIValue: aCharacter
	self
		errorNonChar: aCharacter
		in: 'processing instruction value'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 02:56'!
errorNonCharInSystemID: aCharacter
	self
		errorNonChar: aCharacter
		in: 'system ID'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/29/2016 00:42'!
errorNonElementGeneralEntityOrCharacterReference
	self parseError:
		'Unexpected "&" starting general entity or character reference after content'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/29/2016 08:34'!
errorNonElementPCDataCharacter: aCharacter
	aCharacter == $&
		ifTrue: [self errorNonElementGeneralEntityOrCharacterReference]
		ifFalse: [
			self
				formatParseError: 'Character data "{1}" outside of element'
				with: aCharacter]! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/31/2014 20:43'!
errorParameterEntityTerminatingSubset
	self parseError: 'Parameter entity replacement cannot terminate internal subset'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/29/2016 22:12'!
errorReferenceToUnparsedGeneralEntity: anEntity
	self
		formatParseError: 'Illegal unparsed general entity reference {1}'
		with: anEntity asReference! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:49'!
errorReservedPITarget: aTarget
	self
		formatParseError: 'Processing instruction target "{1}" is reserved'
		with: aTarget! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/25/2016 03:49'!
errorSelfReferentialEntity: anEntity
	self
		formatParseError: 'Illegal self-referential {1} entity'
		with: anEntity asReference! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/14/2017 01:37'!
errorTerminatingUnstartedElement: anElement
	self
		formatParseError: 'End tag </{1}> with no corresponding <{1}> start tag'
		with: anElement! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/30/2016 04:12'!
errorURIFragmentInSystemID
	self parseError: 'Illegal "#" URI fragment in system ID'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/4/2016 00:17'!
errorUnexpectedCDataTerminator
	self parseError: 'Unexpected CDATA "]]>" terminator in PCDATA'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/3/2016 23:51'!
errorUnexpectedEndConditionalSection
	self parseError: 'Unexpected "]" end of conditional section in external entity'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/30/2016 09:16'!
errorUnexpectedEndTag: anElement
	self
		formatParseError: 'Unexpected end tag </{1}> before any start tag'
		with: anElement! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/28/2016 17:01'!
errorUnexpectedMarkupDeclarationInContent
	self parseError: 'Unexpected "<!!" markup declaration in content'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/26/2016 18:36'!
errorUnterminatedElements
	self
		formatParseError: 'Unterminated elements: {1}'
		with: elementNester printedElements! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 10/30/2016 09:19'!
errorUnterminatedElementsInElement: anElement
	self
		formatParseError: '<{1}> element ended before enclosed element(s) {2}'
		with: anElement
		with: (elementNester printedElementsEnclosedBy: anElement)! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/23/2015 23:22'!
errorUnterminatedIgnoreSections
	self parseError: 'Unterminated <!![IGNORE[...]]> section(s) in external entity'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 4/23/2015 20:33'!
errorUnterminatedIncludeSections
	self parseError: 'Unterminated <!![INCLUDE[...]]> section(s) in external entity'! !

!XMLWellFormedParserTokenizer methodsFor: 'errors' stamp: 'monty 3/30/2016 19:52'!
errorXMLDeclarationNotAtStart
	self parseError: 'XML declaration can only occur at the start of a document'! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 12/6/2016 05:14'!
expectNext: aCharacter
	| nextChar |

	"use #= for pre-SpurVM compatibility where wide chars aren't #=="
	(nextChar := streamReader next) = aCharacter
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ nextChar.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 12/6/2016 05:14'!
expectNextAll: aString
	"uses to:do: and not implemented in terms of #expectNextAll:startingAt:
	for speed"
	1 to: aString size do: [:i | | nextChar |
		"use #= for pre-SpurVM compatibility where wide chars aren't #=="
		(nextChar := streamReader next) = (aString at: i)
			ifFalse: [
				self
					errorExpectedLiteral: aString
					butGot: nextChar
					at: i]].
	^ aString.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 12/6/2016 05:15'!
expectNextAll: aString startingAt: aPosition
	"to:do: for speed"
	aPosition to: aString size do: [:i | | nextChar |
		"use #= for pre-SpurVM compatibility where wide chars aren't #=="
		(nextChar := streamReader next) = (aString at: i)
			ifFalse: [
				self
					errorExpectedLiteral: aString
					butGot: nextChar
					at: i]].
	^ aString.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 10/28/2016 06:23'!
expectNextVersionDigit
	| nextChar |

	((nextChar := streamReader next) == nil
		or: [(VersionDigitChars includes: nextChar) not])
		ifTrue: [self errorExpectedVersionDigitButGot: nextChar].
	^ nextChar.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 4/1/2016 06:57'!
expectSeparators
	"nil understands isXMLSeparator so no nil test is needed"
	streamReader next isXMLSeparator
		ifTrue: [streamReader skipSeparators]
		ifFalse: [self errorExpectedSeparators]! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 4/1/2016 06:54'!
expectSeparatorsInDeclaration
	"this can be used to replace entity references within declarations"

	[streamReader peek == $%]
		whileTrue: [
			streamReader next.
			self nextParameterEntityReferenceInDeclaration].
	self expectSeparators.
	[streamReader peek == $%]
		whileTrue: [
			streamReader next.
			self nextParameterEntityReferenceInDeclaration.
			streamReader skipSeparators].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - expecting' stamp: 'monty 10/28/2016 06:22'!
expectTerminator
	| nextChar |

	(nextChar := streamReader next) == $>
		ifFalse: [self errorExpectedTerminatorButGot: nextChar]! !

!XMLWellFormedParserTokenizer methodsFor: 'testing' stamp: 'monty 10/25/2016 06:57'!
hasOpenIncludeSections
	totalOpenIncludeSections == nil
		ifTrue: [^ false].
	^ totalOpenIncludeSections > 0.! !

!XMLWellFormedParserTokenizer methodsFor: 'testing' stamp: 'monty 3/30/2016 20:26'!
hasPushedBackEntities
	pushedBackEntities == nil
		ifTrue: [^ false].
	^ pushedBackEntities size > 0.! !

!XMLWellFormedParserTokenizer methodsFor: 'testing' stamp: 'monty 5/2/2017 22:35'!
hasPushedBackEntity: aPushedBackEntity
	self hasPushedBackEntities
		ifFalse: [^ false].
	self pushedBackEntities do: [:each |
		each entity = aPushedBackEntity entity
			ifTrue: [^ true]].
	^ false.! !

!XMLWellFormedParserTokenizer methodsFor: 'testing' stamp: 'monty 10/6/2017 14:10'!
isInExternalSubsetOrExternalEntity
	"This is used to check for conditional sections and parameter entity
	refs within declarations in the internal subset, which is disallowed.
	
	The way the spec is written and the way Xerces behaves, internal
	entities defined in external entities DO NOT count as 'external'
	for this purpose, even though they were defined externally to
	the document."

	^ state isExternalSubsetState
		or: [self topPushedBackExternalEntity notNil]! !

!XMLWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 1/17/2014 05:28'!
maxEntityReplacementDepth
	^ driver maxEntityReplacementDepth! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/10/2017 01:22'!
nextAttlistDeclaration
	| element defaultPragma |

	self
		expectNextAll: 'ATTLIST';
		expectSeparatorsInDeclaration.

	element := self nextElementName.
	[streamReader peek == $>
		or: [
			self expectSeparatorsInDeclaration.
			streamReader peek == $>]]
		whileFalse: [
			driver
				handleAttributeDeclaration: element
				name: self nextAttributeName
				type: self nextAttributeType
				defaultPragma:
					(defaultPragma := self nextAttributeDefaultPragma)
				defaultValue:
					(self nextAttributeDefaultValueForPragma: defaultPragma)].

	self expectTerminator.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 21:23'!
nextAttributeDefaultPragma
	self expectSeparatorsInDeclaration.
	streamReader peek == $#
		ifFalse: [^ ''].
	streamReader next.

	streamReader peek == $R
		ifTrue: [^ self expectNextAll: 'REQUIRED'].
	streamReader peek == $I
		ifTrue: [^ self expectNextAll: 'IMPLIED'].
	^ self expectNextAll: 'FIXED'.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/6/2017 14:24'!
nextAttributeDefaultValueForPragma: aPragma
	| previousState attributeValue |

	aPragma isEmpty
		ifFalse: [
			(aPragma first == $F) "FIXED"
				ifFalse: [^ ''].
			self expectSeparatorsInDeclaration].
	previousState := state.
	state := state contentState.
	attributeValue := self nextAttributeValue.
	state := previousState.
	^ attributeValue.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/27/2016 00:56'!
nextAttributeEntityType
	self expectNextAll: 'ENTIT'.
	streamReader peek == $Y
		ifFalse: [
			^ self
				expectNextAll: 'ENTITIES'
				startingAt: 6 "'ENTITIES' indexOfSubCollection: 'IES'"].
	streamReader next.
	^ 'ENTITY'.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextAttributeEnumerationType
	characterStream
		reset;
		nextPut: (self expectNext: $().

	"must have at least one value in the enumeration"
	self
		skipSeparatorsInDeclaration;
		nextNmtokenOnCharacterStream.
	[self skipSeparatorsInDeclaration.
		streamReader peek == $)]
		whileFalse: [
			characterStream nextPut: (self expectNext: $|).
			self
				skipSeparatorsInDeclaration;
				nextNmtokenOnCharacterStream].

	^ characterStream
		nextPut: streamReader next;
		contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/27/2016 00:42'!
nextAttributeIDOrIDRefType
	self expectNextAll: 'ID'.
	streamReader peek == $R
		ifFalse: [^ 'ID'].	
	self
		expectNextAll: 'IDREF'
		startingAt: 3.
	streamReader peek == $S
		ifFalse: [^ 'IDREF'].
	streamReader next.
	^ 'IDREFS'.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/4/2017 14:46'!
nextAttributeName
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedAttributeName].
	nameStream
		reset;
		nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [nameStream nextPut: streamReader next].
	^ nameStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/27/2016 00:48'!
nextAttributeNotationEnumerationOrNmtokenType
	"skip the N"
	streamReader next.
	streamReader peek == $O
		ifTrue: [^ self nextAttributeNotationEnumerationType].
	self
		expectNextAll: 'NMTOKEN'
		startingAt: 2.
	streamReader peek == $S
		ifFalse: [^ 'NMTOKEN'].
	streamReader next.
	^ 'NMTOKENS'.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextAttributeNotationEnumerationType
	characterStream
		reset;
		nextPutAll:
			(self
				expectNextAll: 'NOTATION'
				startingAt: 2). "the 'N' was already read"
	self
		expectSeparatorsInDeclaration;
		expectNext: $(.
	characterStream nextPutAll: ' ('.

	"must have at least one declaration name in the enumeration"
	self
		skipSeparatorsInDeclaration;
		nextNotationNameOnCharacterStream.
	[self skipSeparatorsInDeclaration.
		streamReader peek == $)]
		whileFalse: [
			characterStream nextPut: (self expectNext: $|).
			self
				skipSeparatorsInDeclaration;
				nextNotationNameOnCharacterStream].
	
	^ characterStream
		nextPut: streamReader next;
		contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 21:23'!
nextAttributeType
	| nextChar |

	self expectSeparatorsInDeclaration.
	(nextChar := streamReader peek) == $C
		ifTrue: [^ self expectNextAll: 'CDATA'].
	nextChar == $I
		ifTrue: [^ self nextAttributeIDOrIDRefType].
	nextChar == $E
		ifTrue: [^ self nextAttributeEntityType].
	nextChar == $N
		ifTrue: [^ self nextAttributeNotationEnumerationOrNmtokenType].
	^ self nextAttributeEnumerationType.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:11'!
nextAttributeValue
	| quote nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedAttributeValueStartButGot: quote].
	
	isInLiteralValue := true.
	characterStream reset.
	[((nextChar := streamReader next) == quote
		and: [isIgnoringLiteralValueTerminator not])
			or: [nextChar == $<
				or: [nextChar == nil]]]
		whileFalse: [
			nextChar == $&
				ifTrue: [
					"char refs should be ignored by whitespace normalization"
					self nextGeneralEntityOrCharacterReferenceOnCharacterStream]
				ifFalse: [
					nextChar isXMLSeparator
						ifTrue: [nextChar := NormalizedSpace]
						ifFalse: [
							nextChar isXMLChar
								ifFalse: [self errorNonCharInAttributeValue: nextChar]].
					characterStream nextPut: nextChar]].
	isInLiteralValue := false.

	nextChar == quote
		ifFalse: [
			self
				errorExpectedAttributeValueEnd: quote
				butGot: nextChar].

	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/28/2017 17:02'!
nextCDataSection
	| closingBracketsRead nextChar |

	self expectNextAll: '[CDATA['.
	characterStream reset.
	closingBracketsRead := 0.
	[(nextChar := streamReader next) == nil
		or: [closingBracketsRead == 2
			and: [nextChar == $>]]]
		whileFalse: [
			nextChar == $]
				ifTrue: [
					closingBracketsRead == 2
						ifTrue: [characterStream nextPut: $]]
						ifFalse: [closingBracketsRead := closingBracketsRead + 1]]
				ifFalse: [
					closingBracketsRead == 0
						ifFalse: [
							characterStream nextPut: $].
							closingBracketsRead == 2
								ifTrue: [characterStream nextPut: $]].
							closingBracketsRead := 0].
					nextChar isXMLChar
						ifFalse: [self errorNonCharInCDataSection: nextChar].
					characterStream nextPut: nextChar]].
	nextChar
		ifNil: [self errorExpectedCDataSectionTerminator].
	driver handleCData: characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 1/24/2018 02:55'!
nextCharacterReferenceOnCharacterStream
	"returns the character written to 'characterStream' or $& if
	it wasn't replaced"
	| codePoint |

	"skip #"
	streamReader next.
	(state isContentState
		and: [driver replacesContentEntityReferences not])
		ifTrue: [
			nameStream reset.
			(codePoint := self nextCharacterValueLiteralPrintedOn: nameStream)
				ifNil: [self errorExpectedIntegerCharacterReference].
			(self characterFromCodePoint: codePoint)
				ifNil: [self errorInvalidCharacterReferenceCodePoint: codePoint].
			self expectNext: $;.
			characterStream
				nextPutAll: '&#';
				nextPutAll: nameStream contents;
				nextPut: $;.
			^ $&]
		ifFalse: [| character |
			(codePoint := self nextCharacterValueLiteral)
				ifNil: [self errorExpectedIntegerCharacterReference].
			(character := self characterFromCodePoint: codePoint)
				ifNil: [self errorInvalidCharacterReferenceCodePoint: codePoint].
			self expectNext: $;.
			characterStream nextPut: character.
			^ character].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:10'!
nextComment
	| nextChar |

	"Skip first -"
	streamReader next.
	self expectNext: $-.

	"xml comments can't have '--' in them and must be followed
	by the terminating '>'"
	characterStream reset.
	[(nextChar := streamReader next) == nil
		or: [nextChar == $-
			and: [streamReader peek == $-]]]
		whileFalse: [
			nextChar isXMLChar
				ifFalse: [self errorNonCharInComment: nextChar].
			characterStream nextPut: nextChar].
	self
		expectNext: $-;
		expectTerminator.

	driver handleComment: characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:28'!
nextConditionalSectionFromEntity: aPushedBackParameterEntity
	"skip ["
	streamReader next.
	self
		skipSeparatorsInDeclaration;
		expectNext: $I.
	streamReader peek == $N
		ifTrue: [self nextStartIncludeSectionFromEntity: aPushedBackParameterEntity]
		ifFalse: [self nextIgnoreSectionFromEntity: aPushedBackParameterEntity].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/18/2017 06:12'!
nextContentMarkupToken
	self topPushedBackEntity
		ifNil: [
			streamReader peek == $?
				ifTrue: [^ self nextPI].
			streamReader peek == $!!
				ifTrue: [
					streamReader next.
					streamReader peek == $-
						ifTrue: [^ self nextComment].
					elementNester isInElement
						ifTrue: [^ self nextCDataSection].
					self errorUnexpectedMarkupDeclarationInContent].
			self nextTag]
		ifNotNil: [:pushedBackGeneralEntity |
			self nextContentMarkupTokenFromEntity: pushedBackGeneralEntity]! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/30/2016 04:20'!
nextContentMarkupTokenFromEntity: aPushedBackGeneralEntity
	streamReader peek == $?
		ifTrue: [self nextPI]
		ifFalse: [
			streamReader peek == $!!
				ifTrue: [
					streamReader next.
					streamReader peek == $-
						ifTrue: [self nextComment]
						ifFalse: [
							elementNester isInElement
								ifTrue: [self nextCDataSection]
								ifFalse: [
									self errorUnexpectedMarkupDeclarationInContent]]]
				ifFalse: [| oldTotalOpenElements newTotalOpenElements |
					oldTotalOpenElements := elementNester totalOpenElements.
					self nextTag.
					newTotalOpenElements := elementNester totalOpenElements.
					newTotalOpenElements < oldTotalOpenElements
						ifTrue: [
							aPushedBackGeneralEntity endElement.
							aPushedBackGeneralEntity totalOpenElements >= 0
								ifFalse: [self errorImproperGeneralEntityNesting]]
						ifFalse: [
							newTotalOpenElements > oldTotalOpenElements
								ifTrue: [aPushedBackGeneralEntity startElement]]]].

	self topPushedBackEntity == aPushedBackGeneralEntity
		ifFalse: [self errorImproperGeneralEntityNesting].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextContentModel
	| pushedBackParameterEntity |

	self expectSeparatorsInDeclaration.
	streamReader peek == $A
		ifTrue: [^ self expectNextAll: 'ANY'].
	streamReader peek == $E
		ifTrue: [^ self expectNextAll: 'EMPTY'].
	
	characterStream
		reset;
		nextPut: (self expectNext: $().
	pushedBackParameterEntity := self topPushedBackEntity.
	self skipSeparatorsInDeclaration.
	streamReader peek == $#
		ifTrue: [
			self nextMixedContentListOnCharacterStreamFromEntity:
				pushedBackParameterEntity]
		ifFalse: [
			self nextContentModelChoiceOrSequenceOnCharacterStreamFromEntity:
				pushedBackParameterEntity].

	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextContentModelChoiceOrSequenceOnCharacterStreamFromEntity: aPushedBackParameterEntity
	self
		nextContentModelParticleOnCharacterStream;
		skipSeparatorsInDeclaration.
	streamReader peek == $|
		ifTrue: [
			characterStream nextPut: streamReader next.
			self nextContentModelParticleOnCharacterStream.
			[self skipSeparatorsInDeclaration.
				streamReader peek == $)]
				whileFalse: [
					characterStream nextPut: (self expectNext: $|).
					self nextContentModelParticleOnCharacterStream].
			characterStream nextPut: streamReader next]
		ifFalse: [
			streamReader peek == $,
				ifTrue: [
					characterStream nextPut: streamReader next.
					self nextContentModelParticleOnCharacterStream.
					[self skipSeparatorsInDeclaration.
						streamReader peek == $)]
						whileFalse: [
							characterStream nextPut: (self expectNext: $,).
							self nextContentModelParticleOnCharacterStream].
					characterStream nextPut: streamReader next]
				ifFalse: [characterStream nextPut: (self expectNext: $))]].

	self topPushedBackEntity == aPushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].
	self nextContentModelUnaryOperatorOnCharacterStream.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextContentModelParticleOnCharacterStream
	self skipSeparatorsInDeclaration.
	streamReader peek == $(
		ifTrue: [
			characterStream nextPut: streamReader next.
			self nextContentModelChoiceOrSequenceOnCharacterStreamFromEntity:
				self topPushedBackEntity]
		ifFalse: [
			self
				nextElementNameOnCharacterStream;
				nextContentModelUnaryOperatorOnCharacterStream]! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextContentModelUnaryOperatorOnCharacterStream
	| nextChar |

	((nextChar := streamReader peek) == $?
		or: [nextChar == $*
			or: [nextChar == $+]])
		ifTrue: [characterStream nextPut: streamReader next]! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:10'!
nextDoctypeDeclarationOrComment
	"skip !!"
	streamReader next.
	streamReader peek == $-
		ifTrue: [^ self nextComment].
	state isPostDoctypeDeclarationState
		ifTrue: [self errorMultipleDoctypeDeclarations].
	self nextDoctypeDeclaration.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 00:29'!
nextElementDeclaration
	self
		expectNextAll: 'ELEMENT'
		startingAt: 2. "the 'E' was already read"

	self expectSeparatorsInDeclaration.
	driver
		handleElementDeclaration: self nextElementName
		contentModel: self nextContentModel.
	self
		skipSeparatorsInDeclaration;
		expectTerminator.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/4/2017 14:47'!
nextElementName
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedElementName].
	nameStream
		reset;
		nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [nameStream nextPut: streamReader next].
	^ nameStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/4/2017 14:43'!
nextElementNameOnCharacterStream
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedElementName].
	characterStream nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [characterStream nextPut: streamReader next].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:10'!
nextEndDocument
	state canTerminateInput
		ifFalse: [self errorInputTerminatedPrematurely].
	state isContentState
		ifTrue: [
			elementNester hasOpenElements
				ifTrue: [self errorUnterminatedElements]]
		ifFalse: [
			self hasOpenIncludeSections
				ifTrue: [self errorUnterminatedIncludeSections]].
	super nextEndDocument.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:22'!
nextEndIncludeSection
	"skip ]"
	streamReader next.
	self
		expectNext: $];
		expectTerminator.

	totalOpenIncludeSections := self totalOpenIncludeSections - 1.
	self topPushedBackEntity
		ifNotNil: [:pushedBackParameterEntity |
			pushedBackParameterEntity endIncludeSection.
			pushedBackParameterEntity totalOpenIncludeSections >= 0
				ifFalse: [driver handleImproperParameterEntityNesting]].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2016 00:30'!
nextEndInternalSubset
	self hasOpenIncludeSections
		ifTrue: [^ self nextEndIncludeSection].
	"skip ]"
	streamReader next.
	self hasPushedBackEntities
		ifTrue: [self errorParameterEntityTerminatingSubset].
	streamReader skipSeparators.
	self nextEndDoctypeDeclaration.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/28/2017 17:09'!
nextEndTag
	| tagName |
	"Skip /"
	streamReader next.
	(tagName := elementNester currentElement)
		ifNil: [self errorUnexpectedEndTag: self nextElementName].
	1 to: tagName size do: [:i | | nextChar |
		"can't use #== here because wide chars aren't an immediate type
		in pre-Spur VMs"
		(nextChar := streamReader next) = (tagName at: i)
			ifFalse: [
				self
					errorExpectedEndTag: tagName
					butGot: nextChar
					at: i]].
	elementNester endCurrentElement.
	driver handleEndTag: tagName.
	streamReader skipSeparators.
	self expectTerminator.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 00:31'!
nextEntityDeclaration
	| isParameterEntity name |

	self
		expectNextAll: 'ENTITY'
		startingAt: 2. "the 'E' was already read"

	self isInExternalSubsetOrExternalEntity
		ifTrue: [
			"this is to distinguish a parameter reference from declaration"
			[isParameterEntity isNil]
				whileTrue: [
					streamReader skipSeparators.
					streamReader peek == $%
						ifTrue: [
							streamReader next.
							"nil understands isXMLSeparator so no nil test is needed"
							streamReader peek isXMLSeparator
								ifTrue: [
									isParameterEntity := true.
									self expectSeparatorsInDeclaration]
								ifFalse: [self nextParameterEntityReference]]
						ifFalse: [isParameterEntity := false]]]
		ifFalse: [
			self expectSeparators.
			(isParameterEntity := (streamReader peek == $%))
				ifTrue: [
					streamReader next.
					self expectSeparators]].

	name := self nextEntityName.
	self expectSeparatorsInDeclaration.
	streamReader atQuote
		ifTrue: [
			self
				nextInternalEntityDeclaration: name
				isParameterEntity: isParameterEntity]
		ifFalse: [
			self
				nextExternalEntityDeclaration: name
				isParameterEntity: isParameterEntity].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/4/2017 14:51'!
nextEntityName
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedEntityName].
	nameStream
		reset;
		nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [nameStream nextPut: streamReader next].
	^ nameStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/4/2017 14:43'!
nextEntityNameOnCharacterStream
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedEntityName].
	characterStream nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [characterStream nextPut: streamReader next].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextEntityValue
	| quote nextChar |

	quote := streamReader next.

	isInLiteralValue := true.
	characterStream reset.
	[((nextChar := streamReader next) == quote
		and: [isIgnoringLiteralValueTerminator not])
			or: [nextChar == nil]]
		whileFalse: [
			nextChar == $&
				ifTrue: [
					streamReader peek == $#
						ifTrue: [
							"character refs are replaced in entity values"
							self nextCharacterReferenceOnCharacterStream]
						ifFalse: [
							"general entity refs aren't replaced but must be complete"
							characterStream nextPut: $&.
							self nextEntityNameOnCharacterStream.
							characterStream nextPut: (self expectNext: $;)]]
				ifFalse: [
					nextChar == $%
						ifTrue: [
							self isInExternalSubsetOrExternalEntity
								ifFalse: [
									self
										errorInternalDeclarationParameterEntityReference].
							self nextParameterEntityReferenceOnCharacterStream]
						ifFalse: [
							nextChar isXMLChar
								ifFalse: [self errorNonCharInEntityValue: nextChar].
							characterStream nextPut: nextChar]]].
	isInLiteralValue := false.

	nextChar == quote
		ifFalse: [
			self
				errorExpectedEntityValueEnd: quote
				butGot: nextChar].

	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 03:06'!
nextExternalEntityDeclaration: aName isParameterEntity: aBoolean
	| publicID systemID notation |

	streamReader peek == $P
		ifTrue: [
			publicID := self nextPublicIDInDeclaration.
			self expectSeparatorsInDeclaration.
			systemID := self nextSystemIDLiteralWithoutURIFragment]
		ifFalse: [
			publicID := ''.
			systemID := self nextSystemIDInDeclarationWithoutURIFragment].
	aBoolean
		ifTrue: [
			self
				skipSeparatorsInDeclaration;
				expectTerminator.
			driver
				handleParameterEntityDeclaration: aName
				publicID: publicID
				systemID: systemID]
		ifFalse: [
			(streamReader peek == $>
				or: [
					self expectSeparatorsInDeclaration.
					streamReader peek == $>])
				ifTrue: [	
					streamReader next.
					notation := '']
				ifFalse: [
					self
						expectNextAll: 'NDATA';
						expectSeparatorsInDeclaration.
					notation := self nextNotationName.
					self
						skipSeparatorsInDeclaration;
						expectTerminator].
			driver
				handleGeneralEntityDeclaration: aName
				publicID: publicID
				systemID: systemID
				ndata: notation].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/3/2016 23:51'!
nextExternalSubsetToken
	streamReader skipSeparators.
	streamReader atEnd
		ifTrue: [^ self].
	streamReader peek == $%
		ifTrue: [
			streamReader next.
			^ self nextParameterEntityReference].
	streamReader peek == $]
		ifTrue: [
			self hasOpenIncludeSections
				ifFalse: [self errorUnexpectedEndConditionalSection].
			^ self nextEndIncludeSection].
	self nextSubsetMarkupToken.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 05:41'!
nextGeneralEntityOrCharacterReferenceOnCharacterStream
	"returns the character written to 'characterStream' if any, nil otherwise"
	| pushedBackGeneralEntity result |

	pushedBackGeneralEntity := self topPushedBackEntity.
	result :=
		streamReader peek == $#
			ifTrue: [self nextCharacterReferenceOnCharacterStream]
			ifFalse: [self nextGeneralEntityReferenceOnCharacterStream].
	pushedBackGeneralEntity
		ifNotNil: [
			(self pushedBackEntities includes: pushedBackGeneralEntity)
				ifFalse: [self errorImproperGeneralEntityNesting]].

	^ result.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 05:41'!
nextGeneralEntityReferenceOnCharacterStream
	"returns the (first) character written to 'characterStream' if any,
	nil otherwise"
	| name |

	name := self nextEntityName.
	self expectNext: $;.
	PredefinedEntities
		at: name
		ifPresent: [:character |
			driver replacesContentEntityReferences
				ifFalse: [^ self nextUnreplacedGeneralEntityOnCharacterStreamNamed: name].
			characterStream nextPut: character.
			^ character].

	(driver handleGeneralEntityReference: name)
		ifNil: [
			(driver replacesContentEntityReferences not
				or: [driver preservesUndeclaredEntityReferences])
				ifTrue: [^ self nextUnreplacedGeneralEntityOnCharacterStreamNamed: name].
			driver handleUnreplacedGeneralEntityReference: name]
		ifNotNil: [:entity |
			entity isUnparsed
				ifTrue: [self errorReferenceToUnparsedGeneralEntity: entity].
			driver replacesContentEntityReferences
				ifFalse: [^ self nextUnreplacedGeneralEntityOnCharacterStreamNamed: name].
			self constructReplacementForGeneralEntity: entity].
	^ nil.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/28/2017 17:07'!
nextIgnoreSectionFromEntity: aPushedBackParameterEntity
	| openSections firstChar secondChar nextChar |

	self
		expectNextAll: 'IGNORE'
		startingAt: 2. "the 'I' was already read"
	streamReader skipSeparators.
	self expectNext: $[.

	"the 'IGNORE' can be in the replacement of an entity, like
	in '<!![%entity[...]]>', but after it the entity that started
	the declaration must be current"
	self topPushedBackEntity == aPushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].

	"From the spec:
	The contents of an ignored conditional section MUST be parsed by
	ignoring all characters after the '[' following the keyword, except
	conditional section starts '<!![' and ends ']]>', until the matching
	conditional section end is found. Parameter entity references MUST
	NOT be recognized in this process."
	openSections := 1.
	[openSections == 0
		or: [(nextChar := streamReader next) == nil]]
		whileFalse: [
			nextChar == $>
				ifTrue: [
					(secondChar == $]
						and: [firstChar == $]])
						ifTrue: [openSections := openSections - 1]]
				ifFalse: [
					nextChar == $[
						ifTrue: [
							(secondChar == $!!
								and: [firstChar == $<])
								ifTrue: [openSections := openSections + 1]]].
			firstChar := secondChar.
			secondChar := nextChar].

	openSections == 0
		ifFalse: [self errorUnterminatedIgnoreSections].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 11/28/2016 00:40'!
nextInternalEntityDeclaration: aName isParameterEntity: aBoolean
	| value |

	value := self nextEntityValue.
	self
		skipSeparatorsInDeclaration;
		expectTerminator.

	aBoolean
		ifTrue: [
			driver
				handleParameterEntityDeclaration: aName
				replacement: value]
		ifFalse: [
			driver
				handleGeneralEntityDeclaration: aName
				replacement: value].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextMixedContentListOnCharacterStreamFromEntity: aPushedBackParameterEntity
	| hasElements |

	hasElements := false.
	characterStream nextPutAll: (self expectNextAll: '#PCDATA').

	[self skipSeparatorsInDeclaration.
		streamReader peek == $)]
		whileFalse: [
			characterStream nextPut: (self expectNext: $|).
			hasElements := true.
			self
				skipSeparatorsInDeclaration;
				nextElementNameOnCharacterStream].
	characterStream nextPut: streamReader next.
	self topPushedBackEntity == aPushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].

	streamReader peek == $*
		ifTrue: [characterStream nextPut: streamReader next]
		ifFalse: [
			hasElements
				ifTrue: [self errorExpectedLiteral: $*]].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/4/2017 14:52'!
nextNmtokenOnCharacterStream
	"matches the Nmtoken production"
	| nextChar |

	"nil understands #isXMLNameChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameChar
		ifFalse: [self errorExpectedNmtoken].
	characterStream nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [characterStream nextPut: streamReader next].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/18/2017 04:12'!
nextNonElementWhitespace
	| nextChar |

	"nil understands isXMLSeparator so it is not tested for first"
	[(nextChar := streamReader peek) isXMLSeparator]
		whileTrue: [streamReader next].
	(nextChar == $<
		or: [nextChar == nil])
		ifFalse: [self errorNonElementPCDataCharacter: streamReader next].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 15:38'!
nextNonPIPrologOrContentMarkupToken
	streamReader peek == $!!
		ifTrue: [^ self nextDoctypeDeclarationOrComment].
	self
		nextStartContent;
		nextTag.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 03:06'!
nextNotationDeclaration
	| name publicID systemID |

	self
		expectNextAll: 'NOTATION';
		expectSeparatorsInDeclaration.

	name := self nextNotationName.
	self expectSeparatorsInDeclaration.
	streamReader peek == $P
		ifTrue: [
			publicID := self nextPublicIDInDeclaration.
			(streamReader peek == $>
				or: [
					self expectSeparatorsInDeclaration.
					streamReader peek == $>])
				ifFalse: [systemID := self nextSystemIDLiteral]]
		ifFalse: [systemID := self nextSystemIDInDeclaration].
	self
		skipSeparatorsInDeclaration;
		expectTerminator.

	driver
		handleNotationDeclaration: name
		publicID: (publicID ifNil: [''])
		systemID: (systemID ifNil: ['']).! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/4/2017 14:44'!
nextNotationName
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedNotationName].
	nameStream
		reset;
		nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [nameStream nextPut: streamReader next].
	^ nameStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/4/2017 14:44'!
nextNotationNameOnCharacterStream
	| nextChar |

	"nil understands #isXMLNameStartChar so it does not need to be tested for"
	(nextChar := streamReader next) isXMLNameStartChar
		ifFalse: [self errorExpectedNotationName].
	characterStream nextPut: nextChar.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [characterStream nextPut: streamReader next].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/28/2017 16:20'!
nextPCDataToken
	| isWhitespace nextChar closingBracketsRead |

	isWhitespace := true.
	characterStream reset.
	closingBracketsRead := 0.
	[(nextChar := streamReader peek) == $<
		or: [nextChar == nil]]
		whileFalse: [
			streamReader next == $&
				ifTrue: [
					self nextGeneralEntityOrCharacterReferenceOnCharacterStream
						ifNotNil: [:writtenChar |
							isWhitespace
								ifTrue: [isWhitespace := writtenChar isXMLSeparator]]]
				ifFalse: [
					(isWhitespace
						and: [isWhitespace := nextChar isXMLSeparator])
						ifFalse: [
							nextChar == $]
								ifTrue: [
									isWhitespace := false.
									closingBracketsRead := closingBracketsRead + 1]
								ifFalse: [
									closingBracketsRead == 0
										ifFalse: [
											(closingBracketsRead >= 2
												and: [nextChar == $>])
												ifTrue: [
													self errorUnexpectedCDataTerminator].
											closingBracketsRead := 0].
									nextChar isXMLChar
										ifFalse: [self errorNonCharInPCData: nextChar]]].
					characterStream nextPut: nextChar]].
	isWhitespace
		ifTrue: [
			characterStream position == 0
				ifFalse: [driver handleWhitespace: characterStream contents]]
		ifFalse: [driver handlePCData: characterStream contents].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:10'!
nextPIData
	| nextChar |

	characterStream reset.
	[(nextChar := streamReader next) == nil
		or: [nextChar == $?
			and: [streamReader peek == $>]]]
		whileFalse: [
			nextChar isXMLChar
				ifFalse: [self errorNonCharInPIValue: nextChar].
			characterStream nextPut: nextChar].
	self expectTerminator.
	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/6/2017 14:10'!
nextPITarget
	"PITarget	   ::=   	Name - (('X' | 'x') ('M' | 'm') ('L' | 'l'))"
	| nextChar isReservedTarget isLowercaseReservedTarget length |

	nameStream reset.
	(nextChar := streamReader next) == $x
		ifTrue: [
			isReservedTarget := true.
			isLowercaseReservedTarget := true]
		ifFalse:[
			nextChar == $X
				ifTrue: [isReservedTarget := true]
				ifFalse: [
					"nil understands #isXMLNameStartChar so it does
					not need to be tested for"
					nextChar isXMLNameStartChar
						ifFalse: [self errorExpectedPITarget].
					isReservedTarget := false].
			isLowercaseReservedTarget := false].
	nameStream nextPut: nextChar.
	length := 1.

	"nil understands #isXMLNameChar so it does not need to be tested for"
	[streamReader peek isXMLNameChar]
		whileTrue: [
			nextChar := streamReader next.
			length := length + 1.
			isReservedTarget
				ifTrue: [
					(length <= 3
						and: [
							nextChar == ('xml' at: length)
								or: [
									isLowercaseReservedTarget := false.
									nextChar == ('XML' at: length)]])
						ifFalse: [
							isReservedTarget := false.
							isLowercaseReservedTarget := false]].
			nameStream nextPut: nextChar].
	
	(isReservedTarget
		and: [length = 3])
		ifTrue: [
			isLowercaseReservedTarget
				ifTrue: [
					state isXMLDeclarationState
						ifFalse: [self errorXMLDeclarationNotAtStart].
					"return nil to indicate it's an XML declaration, not a PI"
					^ nil].
			"a reserved target other than lowercase 'xml' for XML declarations
			is never allowed"
			self errorReservedPITarget: nameStream contents].
	^ nameStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 00:32'!
nextParameterEntityReference
	| pushedBackParameterEntity name |

	pushedBackParameterEntity := self topPushedBackEntity.
	name := self nextEntityName.
	self expectNext: $;.
	self topPushedBackEntity == pushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].

	(driver handleParameterEntityReference: name)
		ifNotNil: [:entity | self constructReplacementForParameterEntity: entity].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 12/3/2016 00:23'!
nextParameterEntityReferenceInDeclaration
	self isInExternalSubsetOrExternalEntity
		ifFalse: [self errorInternalDeclarationParameterEntityReference].
	self nextParameterEntityReference.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextParameterEntityReferenceOnCharacterStream
	| pushedBackParameterEntity name |

	pushedBackParameterEntity := self topPushedBackEntity.
	name := self nextEntityName.
	self expectNext: $;.
	self topPushedBackEntity == pushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].
	
	(driver handleParameterEntityReference: name)
		ifNil: [
			driver preservesUndeclaredEntityReferences
				ifTrue: [
					characterStream
						nextPut: $%;
						nextPutAll: name;
						nextPut: $;.
					^ $%]]
		ifNotNil: [:entity |
			self constructReplacementForParameterEntity: entity].
	^ nil.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/25/2016 15:38'!
nextPrologToken
	streamReader skipSeparators.
	self expectNext: $<.
	streamReader peek == $?
		ifTrue: [^ self nextPI].
	self nextNonPIPrologOrContentMarkupToken.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/4/2015 22:14'!
nextPublicIDInDeclaration
	^ self
		expectNextAll: 'PUBLIC';
		expectSeparatorsInDeclaration;
		nextPublicIDLiteral! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:10'!
nextPublicIDLiteral
	"this returns the pubid with leading and trailing whitespace removed
	and all other whitespace sequences converted to single spaces"
	| quote isInWhitespace nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedPublicIDLiteralStartButGot: quote].

	characterStream reset.
	isInWhitespace := false.
	"it's not enough to test for nil and PublicIDChars inclusion because
	(PublicIDChars includes: $') = true (double quoted pubids can contain
	single quotes), so the terminating quote must be tested for first to
	handle single quoted pubids correctly"
	[(nextChar := streamReader next) == nil
		or: [nextChar == quote
			or: [(PublicIDChars includes: nextChar) not]]]
		whileFalse: [
			nextChar isXMLSeparator
				ifTrue: [
					isInWhitespace
						ifFalse: [isInWhitespace := true]]
				ifFalse: [
					isInWhitespace
						ifTrue: [
							characterStream position > 0
								ifTrue: [characterStream nextPut: NormalizedSpace].
							isInWhitespace := false].
					characterStream nextPut: nextChar]].

	nextChar == quote
		ifFalse: [
			self
				errorExpectedPublicIDLiteralEnd: quote
				butGot: nextChar].

	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/2/2017 11:47'!
nextStartExternalEntity
	driver decodesCharacters
		ifTrue: [streamReader detectEncoding].
	self nextXMLTextDeclaration.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/6/2017 14:20'!
nextStartExternalSubset
	self nextXMLTextDeclaration.
	state := state externalSubsetState.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:20'!
nextStartIncludeSectionFromEntity: aPushedBackParameterEntity
	self
		expectNextAll: 'INCLUDE'
		startingAt: 2. "the 'I' was already read"
	streamReader skipSeparators.
	self expectNext: $[.

	"the 'INCLUDE' can be in the replacement of an entity, like
	in '<!![%entity[...]]>', but after it the entity that started
	the declaration must be current"
	self topPushedBackEntity == aPushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].

	totalOpenIncludeSections := self totalOpenIncludeSections + 1.
	aPushedBackParameterEntity
		ifNotNil: [aPushedBackParameterEntity startIncludeSection].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/11/2016 12:03'!
nextSubsetDeclaration
	streamReader peek == $E
		ifTrue: [
			streamReader next.
			streamReader peek == $N
				ifTrue: [^ self nextEntityDeclaration]
				ifFalse: [^ self nextElementDeclaration]].
	streamReader peek == $A
		ifTrue: [^ self nextAttlistDeclaration].
	streamReader peek == $N
		ifTrue: [^ self nextNotationDeclaration].

	self errorExpectedSubsetDeclaration.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 12/3/2016 00:23'!
nextSubsetMarkupToken
	| pushedBackParameterEntity |

	self expectNext: $<.
	pushedBackParameterEntity := self topPushedBackEntity.

	streamReader peek == $?
		ifTrue: [self nextPI]
		ifFalse: [
			self expectNext: $!!.
			streamReader peek == $-
				ifTrue: [self nextComment]
				ifFalse: [
					streamReader peek == $[
						ifTrue: [
							self isInExternalSubsetOrExternalEntity
								ifFalse: [self errorInternalSubsetConditionalSection].
							self nextConditionalSectionFromEntity:
								pushedBackParameterEntity]
						ifFalse: [self nextSubsetDeclaration]]].

	self topPushedBackEntity == pushedBackParameterEntity
		ifFalse: [driver handleImproperParameterEntityNesting].! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/26/2016 07:28'!
nextSystemIDInDeclaration
	^ self
		expectNextAll: 'SYSTEM';
		expectSeparatorsInDeclaration;
		nextSystemIDLiteral! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:11'!
nextSystemIDInDeclarationWithoutURIFragment
	^ self
		expectNextAll: 'SYSTEM';
		expectSeparatorsInDeclaration;
		nextSystemIDLiteralWithoutURIFragment! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:12'!
nextSystemIDLiteral
	^ self nextSystemIDLiteralWithoutURIFragment: false! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:12'!
nextSystemIDLiteralWithoutURIFragment
	^ self nextSystemIDLiteralWithoutURIFragment: true! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:10'!
nextSystemIDLiteralWithoutURIFragment: aBoolean
	"Returns the system ID literal.
	If aBoolean is true, it disallows '#' URI fragments."

	| quote nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedSystemIDLiteralStartButGot: quote].

	characterStream reset.
	[(nextChar := streamReader next) == nil
		or: [nextChar == quote]]
		whileFalse: [
			nextChar isXMLChar
				ifFalse: [self errorNonCharInSystemID: nextChar].
			aBoolean
				ifTrue: [
					nextChar == $#
						ifTrue: [self errorURIFragmentInSystemID]].
			characterStream nextPut: nextChar].

	nextChar == quote
		ifFalse: [
			self
				errorExpectedSystemIDLiteralEnd: quote
				butGot: nextChar].

	^ characterStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 9/21/2017 13:15'!
nextTag
	"performance critical method"
	| tagName attributes nextChar |

	(streamReader peek == $/)
		ifTrue: [^ self nextEndTag].
	tagName := self nextElementName.

	"nil understands isXMLSeparator so is not tested for"
	[(nextChar := streamReader peek) isXMLSeparator
		and: [
			streamReader
				next;
				skipSeparators.
			((nextChar := streamReader peek) == $>
				or: [nextChar == $/]) not]]
		whileTrue: [| attributeName |
			attributeName := self nextAttributeName.
			streamReader skipSeparators.
			(nextChar := streamReader next) == $=
				ifFalse: [
					self errorExpectedAttributeNameValueSeparatorButGot: nextChar].
			streamReader skipSeparators.

			"delay initializing 'attributes' until now to know for sure if it
			needs a non-zero capacity, otherwise use the lazy version"
			((attributes
				ifNil: [attributes := driver newAttributeDictionary])
				at: attributeName
				newPut: self nextAttributeValue)
				ifFalse: [self errorDuplicateAttribute: attributeName].

			"the ordering of these tests is optimized"
			(attributeName at: 1) == $x
				ifTrue: [
					driver hasUnhandledReservedAttributes
						ifFalse: [
							attributeName isXMLReservedAttributeName
								ifTrue: [driver haveUnhandledReservedAttributes]]]].

	elementNester wasRootElementEnded
		ifTrue: [self errorMultipleDocumentRootElements].
	elementNester startElement: tagName.
	driver
		handleStartTag: tagName
		attributes:
			(attributes
				ifNil: [driver newEmptyAttributeDictionary]).

	nextChar == $/
		ifTrue: [
			streamReader next.
			elementNester endCurrentElement.
			driver handleEndTag: tagName].

	self expectTerminator.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:12'!
nextUnreplacedGeneralEntityOnCharacterStreamNamed: aName
	driver handleUnreplacedGeneralEntityReference: aName.
	characterStream
		nextPut: $&;
		nextPutAll: aName;
		nextPut: $;.
	^ $&.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:25'!
nextXMLEncodingAttributeValue
	| quote nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedXMLEncodingValueStartButGot: quote].

	((nextChar := streamReader next) notNil
		and: [EncodingNameStartChars includes: nextChar])
		ifFalse: [self errorExpectedEncodingName].

	xmlDeclarationStream
		reset;
		nextPut: nextChar.
	[(nextChar := streamReader next) == nil
		or: [(EncodingNameChars includes: nextChar) not]]
		whileFalse: [xmlDeclarationStream nextPut: nextChar].

	nextChar == quote
		ifFalse: [
			self
				errorExpectedXMLEncodingValueEnd: quote
				butGot: nextChar].

	^ xmlDeclarationStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 7/16/2016 08:39'!
nextXMLStandaloneAttributeValue
	| quote yesOrNo nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedXMLStandaloneValueStartButGot: quote].

	yesOrNo := 
		streamReader peek == $y
			ifTrue: [self expectNextAll: 'yes']
			ifFalse: [self expectNextAll: 'no'].

	(nextChar := streamReader next) == quote
		ifFalse: [
			self
				errorExpectedXMLStandaloneValueEnd: quote
				butGot: nextChar].

	^ yesOrNo.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/28/2016 02:01'!
nextXMLTextDeclaration
	| encoding |
	
	1 to: 5 "'<?xml' size" do: [:i |
		streamReader peek == ('<?xml' at: i)
			ifFalse: [
				i > 1
					ifTrue: [
						streamReader pushBack:
							('<?xml'
								copyFrom: 1
								to: i - 1)].
				^ self].
		streamReader next].

	self expectSeparators.
	(self nextXMLVersionAttributeRequired: false) isEmpty
		ifFalse: [self expectSeparators].
	(encoding := self nextXMLEncodingAttributeRequired: true) isEmpty
		ifFalse: [self convertFromEncoding: encoding].

	streamReader skipSeparators.
	self
		expectNext: $?;
		expectTerminator.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:25'!
nextXMLVersionAttributeValue
	| quote nextChar |

	((quote := streamReader next) == $"
		or: [quote == $'])
		ifFalse: [self errorExpectedXMLVersionValueStartButGot: quote].

	xmlDeclarationStream
		reset;
		nextPut: self expectNextVersionDigit;
		nextPut: (self expectNext: $.);
		nextPut: self expectNextVersionDigit.

	[(nextChar := streamReader next) == nil
		or: [(VersionDigitChars includes: nextChar) not]]
		whileFalse: [xmlDeclarationStream nextPut: nextChar].

	nextChar == quote
		ifFalse: [
			self
				errorExpectedXMLVersionValueEnd: quote
				butGot: nextChar].

	^ xmlDeclarationStream contents.! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 11/14/2016 09:42'!
pushBackEntity: anEntity whenPoppedDo: aBlock
	anEntity hasReplacement
		ifTrue: [| pushedBackEntity |
			pushedBackEntity :=
				self addPushedBackEntity: anEntity asPushedBackEntity.
			streamReader
				pushBackStream: pushedBackEntity replacementStream
				whenPoppedDo: [
					self removePushedBackEntity: pushedBackEntity.
					aBlock
						ifNotNil: [aBlock value]]
				isExternal: pushedBackEntity isExternal.
			pushedBackEntity isExternal
				ifTrue: [self nextStartExternalEntity]]
		ifFalse: [
			aBlock
				ifNotNil: [aBlock value]]! !

!XMLWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/24/2016 18:26'!
pushedBackEntities
	^ pushedBackEntities
		ifNil: [pushedBackEntities := OrderedCollection new: 5]! !

!XMLWellFormedParserTokenizer methodsFor: 'entity replacing' stamp: 'monty 11/1/2016 03:48'!
removePushedBackEntity: aPushedBackEntity
	self pushedBackEntities remove: aPushedBackEntity.
	driver currentEntity: self topPushedBackEntity.
	aPushedBackEntity isExternal
		ifTrue: [
			self topPushedBackExternalEntity
				ifNil: [
					driver baseURI: nil]
				ifNotNil: [:pushedBackExternalEntity |
					driver baseURI: pushedBackExternalEntity uri]].
	^ aPushedBackEntity poppedByTokenizer: self.! !

!XMLWellFormedParserTokenizer methodsFor: 'initialization' stamp: 'monty 9/29/2017 12:16'!
setDriver: aDriver stream: aStream readLimit: anInteger
	super
		setDriver: aDriver
		stream: aStream
		readLimit: anInteger.

	isInLiteralValue := false.
	isIgnoringLiteralValueTerminator := false.! !

!XMLWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:02'!
skipSeparatorsInDeclaration
	"this can be used to replace references within declarations"

	streamReader skipSeparators.
	[streamReader peek == $%]
		whileTrue: [
			streamReader next.
			self nextParameterEntityReferenceInDeclaration.
			streamReader skipSeparators].! !

!XMLWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 4/6/2016 05:45'!
topPushedBackEntity
	"heavily optimized"
	pushedBackEntities == nil
		ifTrue: [^ nil].
	pushedBackEntities size > 0
		ifFalse: [^ nil].
	^ pushedBackEntities at: pushedBackEntities size.! !

!XMLWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/24/2016 16:41'!
topPushedBackExternalEntity
	self pushedBackEntities reverseDo: [:each |
		each isExternal
			ifTrue: [^ each]].
	^ nil.! !

!XMLWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/25/2016 06:58'!
totalOpenIncludeSections
	^ totalOpenIncludeSections ifNil: [totalOpenIncludeSections := 0]! !

Object subclass: #XMLPushedBackEntity
	instanceVariableNames: 'entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackEntity commentStamp: 'monty 10/23/2017 06:08' prior: 0!
An abstract base class for decorating pushed-back entities to keep track of the nesting of markup within entity replacements.!

!XMLPushedBackEntity class methodsFor: 'instance creation' stamp: 'monty 10/26/2016 03:03'!
entity: anEntity
	^ self new entity: anEntity! !

!XMLPushedBackEntity methodsFor: 'converting' stamp: 'monty 10/26/2016 03:03'!
asPushedBackEntity
	^ self! !

!XMLPushedBackEntity methodsFor: 'converting' stamp: 'monty 10/25/2016 06:55'!
asReference
	^ entity asReference! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/29/2016 03:52'!
entity
	^ entity! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/26/2016 03:03'!
entity: anEntity
	entity := anEntity! !

!XMLPushedBackEntity methodsFor: 'testing' stamp: 'monty 10/25/2016 06:39'!
hasReplacement
	^ entity hasReplacement! !

!XMLPushedBackEntity methodsFor: 'testing' stamp: 'monty 10/25/2016 06:38'!
isExternal
	^ entity isExternal! !

!XMLPushedBackEntity methodsFor: 'testing' stamp: 'monty 10/23/2017 00:27'!
isParameter
	^ entity isParameter! !

!XMLPushedBackEntity methodsFor: 'testing' stamp: 'monty 11/1/2016 22:56'!
isStandaloneExternal
	^ entity isStandaloneExternal! !

!XMLPushedBackEntity methodsFor: 'testing' stamp: 'monty 10/25/2016 06:39'!
isUnparsed
	^ entity isUnparsed! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 04:21'!
name
	^ entity name! !

!XMLPushedBackEntity methodsFor: 'nesting' stamp: 'monty 10/26/2016 03:02'!
poppedByTokenizer: aTokenizer
	self subclassResponsibility! !

!XMLPushedBackEntity methodsFor: 'printing' stamp: 'monty 11/4/2016 08:03'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: aStream;
		nextPut: $).! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 06:39'!
replacement
	^ entity replacement! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 06:39'!
replacementStream
	^ entity replacementStream! !

!XMLPushedBackEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 04:21'!
uri
	^ entity uri! !

XMLPushedBackEntity subclass: #XMLPushedBackGeneralEntity
	instanceVariableNames: 'totalOpenElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackGeneralEntity commentStamp: 'monty 10/23/2017 06:12' prior: 0!
A class to decorate pushed-back general entities to keep track of the nesting of elements within entity replacements.

Each time a start tag is parsed from the entity's replacement, the count is incremented, and each time an end tag is parsed, it's decremented. If it goes negative, then an end tag terminated an element not started by the entity. When the entity is popped, the count should be zero. (This is more efficient than having the element nester also keep track of which entity replacement an element began in.)!

!XMLPushedBackGeneralEntity methodsFor: 'nesting' stamp: 'monty 10/29/2016 03:53'!
endElement
	totalOpenElements := self totalOpenElements - 1! !

!XMLPushedBackGeneralEntity methodsFor: 'nesting' stamp: 'monty 10/26/2016 03:02'!
poppedByTokenizer: aTokenizer
	totalOpenElements
		ifNotNil: [
			totalOpenElements = 0
				ifFalse: [aTokenizer errorImproperGeneralEntityNesting]]! !

!XMLPushedBackGeneralEntity methodsFor: 'nesting' stamp: 'monty 10/29/2016 03:53'!
startElement
	totalOpenElements := self totalOpenElements + 1! !

!XMLPushedBackGeneralEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 06:52'!
totalOpenElements
	^ totalOpenElements ifNil: [totalOpenElements := 0]! !

XMLPushedBackEntity subclass: #XMLPushedBackParameterEntity
	instanceVariableNames: 'totalOpenIncludeSections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackParameterEntity commentStamp: 'monty 10/23/2017 06:09' prior: 0!
A class to decorate pushed-back parameter entities to keep track of the nesting of include sections within entity replacements.!

!XMLPushedBackParameterEntity methodsFor: 'nesting' stamp: 'monty 10/29/2016 03:53'!
endIncludeSection
	totalOpenIncludeSections := self totalOpenIncludeSections - 1! !

!XMLPushedBackParameterEntity methodsFor: 'nesting' stamp: 'monty 10/26/2016 03:02'!
poppedByTokenizer: aTokenizer
	totalOpenIncludeSections
		ifNotNil: [
			totalOpenIncludeSections = 0
				ifFalse: [aTokenizer driver handleImproperParameterEntityNesting]]! !

!XMLPushedBackParameterEntity methodsFor: 'nesting' stamp: 'monty 10/29/2016 03:53'!
startIncludeSection
	totalOpenIncludeSections := self totalOpenIncludeSections + 1! !

!XMLPushedBackParameterEntity methodsFor: 'accessing' stamp: 'monty 10/25/2016 06:57'!
totalOpenIncludeSections
	^ totalOpenIncludeSections ifNil: [totalOpenIncludeSections := 0]! !

Object subclass: #XMLPushedBackStream
	instanceVariableNames: 'stream whenPoppedDo currentPosition currentLineNumber currentLineStartPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackStream commentStamp: 'monty 10/23/2017 06:15' prior: 0!
A base class to store a nested stream for XMLNestedStreamReader, along with its callback and the current position, line number, and line start position of the current external stream.!

XMLPushedBackStream subclass: #XMLPushedBackExternalStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackExternalStream commentStamp: 'monty 10/23/2017 06:13' prior: 0!
A class to store a nested external stream for XMLNestedStreamReader.!

!XMLPushedBackExternalStream methodsFor: 'testing' stamp: 'monty 11/7/2016 18:48'!
isExternal
	^ true! !

XMLPushedBackStream subclass: #XMLPushedBackInternalStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPushedBackInternalStream commentStamp: 'monty 10/23/2017 06:13' prior: 0!
A class to store a nested internal stream for XMLNestedStreamReader. It reports the current position, line number, and line start position of its enclosing external stream.!

!XMLPushedBackStream class methodsFor: 'instance creation' stamp: 'monty 11/23/2016 16:57'!
stream: aStream whenPoppedDo: aBlock currentPosition: aPosition currentLineNumber: aLineNumber currentLineStartPosition: aStartPosition
	^ self new
		setStream: aStream
		whenPoppedDo: aBlock
		currentPosition: aPosition
		currentLineNumber: aLineNumber
		currentLineStartPosition: aStartPosition! !

!XMLPushedBackStream methodsFor: 'accessing' stamp: 'monty 11/18/2016 13:28'!
currentLineNumber
	^ currentLineNumber! !

!XMLPushedBackStream methodsFor: 'accessing' stamp: 'monty 11/18/2016 13:28'!
currentLineStartPosition
	^ currentLineStartPosition! !

!XMLPushedBackStream methodsFor: 'accessing' stamp: 'monty 11/23/2016 16:57'!
currentPosition
	^ currentPosition! !

!XMLPushedBackStream methodsFor: 'testing' stamp: 'monty 11/7/2016 18:48'!
isExternal
	^ false! !

!XMLPushedBackStream methodsFor: 'printing' stamp: 'monty 4/11/2017 05:23'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self stream;
		nextPut: $).! !

!XMLPushedBackStream methodsFor: 'initialization' stamp: 'monty 11/23/2016 16:57'!
setStream: aStream whenPoppedDo: aBlock currentPosition: aPosition currentLineNumber: aLineNumber currentLineStartPosition: aStartPosition
	stream := aStream.
	whenPoppedDo := aBlock.
	currentPosition := aPosition.
	currentLineNumber := aLineNumber.
	currentLineStartPosition := aStartPosition.! !

!XMLPushedBackStream methodsFor: 'accessing' stamp: 'monty 11/7/2016 18:49'!
stream
	^ stream! !

!XMLPushedBackStream methodsFor: 'accessing' stamp: 'monty 11/7/2016 18:49'!
whenPoppedDo
	^ whenPoppedDo! !

Object subclass: #XMLStreamAdapter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLStreamAdapter commentStamp: 'monty 1/26/2016 22:58' prior: 0!
An abstract class for read and write stream adapters.!

XMLStreamAdapter subclass: #XMLReadStreamAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLReadStreamAdapter commentStamp: 'monty 11/25/2016 00:12' prior: 0!
A base class for read stream adapters for basic streams that support #next, #peek, #atEnd, #position, #position:, and #reset. It adds support for skipping and reading upto a character or the end of the stream.!

XMLReadStreamAdapter subclass: #XMLDecodingReadStreamAdapter
	instanceVariableNames: 'peekChar prePeekStreamPosition streamConverter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLDecodingReadStreamAdapter commentStamp: 'monty 7/30/2016 13:07' prior: 0!
A read stream adapter that decodes stream contents using a stream converter. Used to handle encoded external streams.

The class  #on: and #on:streamConverter: instance creation messages accept character and binary streams.!

!XMLDecodingReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/21/2018 01:30'!
nonDecodingOn: aStream
	^ self
		on: aStream
		streamConverter: XMLStreamConverter null! !

!XMLDecodingReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 2/8/2018 01:54'!
nonDecodingOnIfBinaryOrExternal: aStream
	^ aStream isXMLBinaryOrExternalStream
		ifTrue: [
			self
				on: aStream
				streamConverter: XMLStreamConverter null]
		ifFalse: [nil]! !

!XMLDecodingReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/25/2016 22:39'!
on: aStream
	^ self
		on: aStream
		streamConverter: XMLStreamConverter default! !

!XMLDecodingReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 2/2/2018 10:30'!
on: aStream streamConverter: aStreamConverter
	^ (self basicOn: aStream)
		streamConverter: aStreamConverter! !

!XMLDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 11/22/2016 18:03'!
atEnd
	^ peekChar == nil
		and: [stream atEnd]! !

!XMLDecodingReadStreamAdapter methodsFor: 'decoding' stamp: 'monty 1/23/2018 01:56'!
detectEncoding
	prePeekStreamPosition := nil.
	peekChar := nil.
	stream reset.

	(((self hasNullStreamConverter
		or: [self hasImplicitStreamConverter])
		ifTrue: [XMLImplicitEncodingDetector]
		ifFalse: [XMLEncodingDetector])
			on: stream) streamConverterForEncoding
				ifNotNil: [:converter |
					self streamConverter: converter].! !

!XMLDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/31/2016 22:49'!
hasDefaultStreamConverter
	^ streamConverter isDefault! !

!XMLDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/18/2018 02:23'!
hasImplicitStreamConverter
	^ streamConverter isImplicit! !

!XMLDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 3/5/2016 12:26'!
hasNullStreamConverter
	^ streamConverter isNull! !

!XMLDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 4/1/2016 00:55'!
isXMLConvertingStreamAdapter
	^ true! !

!XMLDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/2/2018 07:57'!
next
	peekChar
		ifNil: [^ streamConverter nextFromStream: stream]
		ifNotNil: [:nextChar |
			prePeekStreamPosition := nil.
			peekChar := nil.
			^ nextChar]! !

!XMLDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/2/2018 07:58'!
peek
	^ peekChar
		ifNil: [
			prePeekStreamPosition := stream position.
			peekChar := streamConverter nextFromStream: stream]! !

!XMLDecodingReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/22/2016 23:08'!
position
	^ prePeekStreamPosition ifNil: [stream position]! !

!XMLDecodingReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/22/2016 23:08'!
position: anInteger
	prePeekStreamPosition := nil.
	peekChar := nil.
	stream position: anInteger.! !

!XMLDecodingReadStreamAdapter methodsFor: 'printing' stamp: 'monty 1/23/2016 16:49'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: streamConverter;
		nextPut: $).! !

!XMLDecodingReadStreamAdapter methodsFor: 'printing' stamp: 'monty 2/2/2018 06:17'!
printStreamOn: aStream
	super printStreamOn: aStream.
	aStream
		nextPutAll: ', ';
		print: streamConverter.! !

!XMLDecodingReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 4/30/2017 00:14'!
reset
	prePeekStreamPosition := nil.
	peekChar := nil.
	stream reset.! !

!XMLDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/23/2016 16:49'!
streamConverter
	^ streamConverter! !

!XMLDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:11'!
streamConverter: aStreamConverter
	streamConverter :=
		aStreamConverter ifNil: [XMLStreamConverter null].
	peekChar
		ifNotNil: [
			stream position: prePeekStreamPosition.
			prePeekStreamPosition := nil.
			peekChar := nil].! !

XMLReadStreamAdapter subclass: #XMLLimitedReadStreamAdapter
	instanceVariableNames: 'limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLLimitedReadStreamAdapter commentStamp: 'monty 12/20/2017 10:56' prior: 0!
This class is a limited read stream adapter that will not read beyond a limit. Position changes are limited so you can only move forward as many positions as the limit allows, and moving backwards increases the number of objects that can be read.!

!XMLLimitedReadStreamAdapter class methodsFor: 'accessing' stamp: 'monty 12/20/2017 10:20'!
defaultLimit
	^ 1014! !

!XMLLimitedReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 12/20/2017 10:21'!
on: aStream
	^ self
		on: aStream
		limit: self defaultLimit! !

!XMLLimitedReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/11/2018 19:55'!
on: aStream limit: aLimit
	^ (self basicOn: aStream)
		limit: aLimit! !

!XMLLimitedReadStreamAdapter methodsFor: 'testing' stamp: 'monty 12/20/2017 10:45'!
atEnd
	^ stream atEnd
		or: [limit <= 0]! !

!XMLLimitedReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/7/2018 13:48'!
atLimitedEnd
	^ limit <= 0
		and: [stream atEnd not]! !

!XMLLimitedReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/11/2018 19:53'!
limit
	^ limit! !

!XMLLimitedReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/11/2018 19:53'!
limit: anInteger
	limit := anInteger! !

!XMLLimitedReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 12/20/2017 10:47'!
next
	(stream atEnd
		or: [limit <= 0])
		ifTrue: [^ nil]
		ifFalse: [
			limit := limit - 1.
			^ stream next]! !

!XMLLimitedReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 12/21/2017 04:40'!
peek
	(stream atEnd
		or: [limit <= 0])
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XMLLimitedReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 12/20/2017 10:45'!
position: anInteger
	| netPosition |

	(netPosition := anInteger - stream position) > limit
		ifTrue: [
			"skip as far ahead as allowed"
			self skip: limit]
		ifFalse: [
			limit := (limit - netPosition) max: 0.
			stream position: anInteger]! !

!XMLLimitedReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 12/20/2017 10:57'!
reset
	| oldPosition |

	oldPosition := stream position.
	stream reset.
	limit := limit + (oldPosition - stream position).! !

XMLReadStreamAdapter subclass: #XMLPercentDecodingReadStreamAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLPercentDecodingReadStreamAdapter commentStamp: 'monty 2/5/2018 19:03' prior: 0!
This class percent decodes octets for URIs.!

!XMLPercentDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 2/2/2018 20:59'!
atEnd
	^ stream atEnd
		or: [stream peek ~~ $%]! !

!XMLPercentDecodingReadStreamAdapter methodsFor: 'testing' stamp: 'monty 2/9/2018 09:09'!
isBinary
	"this stream is binary, because it reads percent-encoded octets
	character sequences like '%HH' and returns the octet values as
	SmallIntegers"
	^ true! !

!XMLPercentDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/6/2018 05:38'!
next
	| byte |

	(stream atEnd not
		and: [stream peek == $%])
		ifTrue: [
			stream next.
			byte :=
				(XMLSmallIntegerReader
					readFrom: stream
					withBase: 16
					upToLimit: 2)
						ifNil: [37] "$% asciiValue"].
	^ byte.! !

!XMLPercentDecodingReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/6/2018 05:39'!
peek
	| byte |

	stream atEnd
		ifFalse: [| oldPosition |
			oldPosition := stream position.
			byte := self next.
			stream position: oldPosition].
	^ byte.! !

!XMLReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 2/8/2018 00:27'!
onIfBinaryOrExternal: aStream
	^ aStream isXMLBinaryOrExternalStream
		ifTrue: [self on: aStream]
		ifFalse: [nil]! !

!XMLReadStreamAdapter methodsFor: 'testing' stamp: 'monty 2/11/2016 03:22'!
atEnd
	^ stream atEnd! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 11/17/2016 15:45'!
contents
	| oldPosition contents |

	oldPosition := self position.
	self reset.
	contents := self upToEnd.
	self position: oldPosition.
	^ contents.! !

!XMLReadStreamAdapter methodsFor: 'private' stamp: 'monty 2/10/2016 20:04'!
newWriteStream
	^ (self writeStreamCollectionClass new: 128) writeStream! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/11/2016 03:24'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next]! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 4/5/2016 03:10'!
next: anInteger
	| writeStream i |

	writeStream := self newWriteStream.
	i := 0.
	[self atEnd
		or: [i >= anInteger]]
		whileFalse: [
			writeStream nextPut: self next.
			i := i + 1].
	^ writeStream contents.! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/11/2016 03:25'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 9/25/2017 12:54'!
peekFor: anObject
	(self atEnd not
		and: [self peek = anObject])
		ifTrue: [
			self next.
			^ true]
		ifFalse: [^ false]! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/17/2016 15:23'!
position
	^ stream position! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/17/2016 15:24'!
position: anInteger
	stream position: anInteger! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/17/2016 15:24'!
reset
	stream reset! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 2/14/2016 02:06'!
skip: anInteger
	"only supports skipping forwards"
	1 to: anInteger do: [:i |
		self atEnd
			ifTrue: [^ self].
		self next]! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/22/2018 04:26'!
skipSeparators
	"we use #isXMLWhitespace instead of the narrower, XML-specific
	#isXMLSeparator, because this class supports non-XML input too"
	[self atEnd not
		and: [self peek isXMLWhitespace]]
		whileTrue: [self next]! !

!XMLReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 2/10/2016 19:01'!
skipTo: anObject
	[self atEnd]
		whileFalse: [
			self next = anObject
				ifTrue: [^ true]].
	^ false.! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 3/18/2016 23:08'!
upTo: anObject
	| writeStream next |

	writeStream := self newWriteStream.
	[self atEnd
		or: [(next := self next) = anObject]]
		whileFalse: [writeStream nextPut: next].
	^ writeStream contents.! !

!XMLReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/9/2016 20:49'!
upToEnd
	| writeStream |

	writeStream := self newWriteStream.
	[self atEnd]
		whileFalse: [writeStream nextPut: self next].
	^ writeStream contents.! !

!XMLReadStreamAdapter methodsFor: 'defaults' stamp: 'monty 2/9/2018 04:48'!
writeStreamCollectionClass
	self isBinary
		ifTrue: [^ ByteArray]
		ifFalse: [^ String]! !

XMLReadStreamAdapter subclass: #XMLStringReadStreamAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLStringReadStreamAdapter commentStamp: 'monty 2/10/2018 04:20' prior: 0!
A read stream adapter for string read streams that accepts character input and converts it to binary output.!

!XMLStringReadStreamAdapter methodsFor: 'testing' stamp: 'monty 2/9/2018 09:09'!
isBinary
	"this stream is binary, because it converts characters to integers"
	^ true! !

!XMLStringReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/9/2018 04:48'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next asInteger]! !

!XMLStringReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/9/2018 04:48'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek asInteger]! !

!XMLStreamAdapter class methodsFor: 'basic' stamp: 'monty 1/23/2018 19:48'!
basicOn: aStream
	^ self basicNew initialize on: aStream! !

!XMLStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/8/2018 14:35'!
new
	self shouldNotImplement! !

!XMLStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/23/2018 19:48'!
on: aStream
	^ self basicOn: aStream! !

!XMLStreamAdapter methodsFor: 'closing' stamp: 'monty 9/6/2016 00:04'!
close
	"must use respondsTo: to support streams only implementing the basic protocol"
	(stream respondsTo: #close)
		ifTrue: [stream close]! !

!XMLStreamAdapter methodsFor: 'accessing' stamp: 'monty 11/18/2016 18:35'!
contents
	self subclassResponsibility! !

!XMLStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2018 14:34'!
isBinary
	^ false! !

!XMLStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2018 14:34'!
isStream
	^ true! !

!XMLStreamAdapter methodsFor: 'testing' stamp: 'monty 2/8/2018 01:07'!
isXMLBinaryOrExternalStream
	^ self isBinary! !

!XMLStreamAdapter methodsFor: 'initialization' stamp: 'monty 1/22/2016 23:47'!
on: aStream
	stream := aStream! !

!XMLStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/18/2016 18:35'!
position
	self subclassResponsibility! !

!XMLStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/18/2016 18:35'!
position: anInteger
	self subclassResponsibility! !

!XMLStreamAdapter methodsFor: 'printing' stamp: 'monty 2/2/2018 06:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self printStreamOn: aStream.
	aStream nextPut: $).! !

!XMLStreamAdapter methodsFor: 'printing' stamp: 'monty 2/2/2018 06:15'!
printStreamOn: aStream
	aStream print: stream! !

!XMLStreamAdapter methodsFor: 'positioning' stamp: 'monty 11/18/2016 18:36'!
reset
	self subclassResponsibility! !

!XMLStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/22/2016 23:46'!
stream
	^ stream! !

XMLStreamAdapter subclass: #XMLWriteStreamAdapter
	instanceVariableNames: ''
	classVariableNames: 'CRCharacter LFCharacter SpaceCharacter TabCharacter'
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLWriteStreamAdapter commentStamp: 'monty 11/25/2016 00:13' prior: 0!
A base class for write stream adapters for basic streams that support #nextPut:, #nextPutAll:, #contents, #position, #position:, and #reset. It adds support for writing characters like tabs, spaces, and line endings.!

XMLWriteStreamAdapter subclass: #XMLEncodingWriteStreamAdapter
	instanceVariableNames: 'streamConverter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLEncodingWriteStreamAdapter commentStamp: 'monty 1/26/2016 23:31' prior: 0!
A write stream adapter that encodes stream contents using a stream converter.!

!XMLEncodingWriteStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/25/2016 22:39'!
on: aStream
	^ self
		on: aStream
		streamConverter: XMLStreamConverter default! !

!XMLEncodingWriteStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 2/8/2018 00:26'!
on: aStream streamConverter: aStreamConverter
	^ (self basicOn:
		(aStream isXMLBinaryOrExternalStream
			ifTrue: [aStream]
			ifFalse: [XMLStringWriteStreamAdapter on: aStream]))
		streamConverter: aStreamConverter! !

!XMLEncodingWriteStreamAdapter methodsFor: 'testing' stamp: 'monty 2/3/2016 02:54'!
hasDefaultStreamConverter
	^ streamConverter isDefault! !

!XMLEncodingWriteStreamAdapter methodsFor: 'testing' stamp: 'monty 1/18/2018 02:23'!
hasImplicitStreamConverter
	^ streamConverter isImplicit! !

!XMLEncodingWriteStreamAdapter methodsFor: 'testing' stamp: 'monty 3/5/2016 12:26'!
hasNullStreamConverter
	^ streamConverter isNull! !

!XMLEncodingWriteStreamAdapter methodsFor: 'testing' stamp: 'monty 4/1/2016 00:55'!
isXMLConvertingStreamAdapter
	^ true! !

!XMLEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/3/2018 03:09'!
nextPut: aCharacter
	streamConverter
		nextPut: aCharacter
		toStream: stream.
	^ aCharacter.! !

!XMLEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/3/2018 03:09'!
nextPutAll: aCollection
	"can't use #to:do: here because other #nextPutAll: implementations
	support non-sequenceable collection arguments wtih #do:"
	aCollection do: [:each |
		streamConverter
			nextPut: each
			toStream: stream].
	^ aCollection.! !

!XMLEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/4/2018 22:20'!
nextPutByteOrderMark
	streamConverter nextPutByteOrderMarkToStream: stream! !

!XMLEncodingWriteStreamAdapter methodsFor: 'printing' stamp: 'monty 2/2/2018 06:58'!
printStreamOn: aStream
	super printStreamOn: aStream.
	aStream
		nextPutAll: ', ';
		print: streamConverter.! !

!XMLEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/23/2016 22:21'!
streamConverter
	^ streamConverter! !

!XMLEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 3/6/2016 09:09'!
streamConverter: aStreamConverter
	streamConverter :=
		aStreamConverter ifNil: [XMLStreamConverter null]! !

XMLWriteStreamAdapter subclass: #XMLNodeContentWriteStreamAdapter
	instanceVariableNames: 'lastChar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLNodeContentWriteStreamAdapter commentStamp: 'monty 2/14/2016 02:09' prior: 0!
A write stream adapter for writing node content with whitespace insertion if needed between writes.!

!XMLNodeContentWriteStreamAdapter methodsFor: 'private' stamp: 'monty 3/12/2016 19:09'!
insertSpaceBefore: aCharacter
	(lastChar == nil
		or: [lastChar isXMLWhitespace
			or: [aCharacter isXMLWhitespace]])
		ifFalse: [stream nextPut: SpaceCharacter]! !

!XMLNodeContentWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 12/11/2014 10:13'!
nextPut: aCharacter
	self insertSpaceBefore: aCharacter.
	stream nextPut: aCharacter.
	^ lastChar := aCharacter.! !

!XMLNodeContentWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/5/2016 02:25'!
nextPutAll: aString
	aString size > 0 "optimization"
		ifTrue: [
			self insertSpaceBefore: aString first.
			stream nextPutAll: aString.
			lastChar := aString last].
	^ aString.! !

XMLWriteStreamAdapter subclass: #XMLPercentEncodingWriteStreamAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLPercentEncodingWriteStreamAdapter commentStamp: 'monty 2/5/2018 22:56' prior: 0!
A write stream adapter for percent encoding octets for URIs.!

!XMLPercentEncodingWriteStreamAdapter methodsFor: 'testing' stamp: 'monty 2/9/2018 09:09'!
isBinary
	"this stream is binary, because it accepts binary octet values
	and percent-encodes them as '%HH' character sequences"
	^ true! !

!XMLPercentEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/8/2018 01:22'!
nextPut: anObject
	| byte |

	stream nextPut: $%.

	"pad it if needed"
	(byte := anObject asInteger) < 16r10
		ifTrue: [stream nextPut: $0].

	"On GS, #printOn:base: shows the radix, so #printOn:base:showRadix:
	is used instead"
	byte
		printOn: stream
		base: 16
		showRadix: false.
	^ anObject.! !

!XMLPercentEncodingWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/4/2018 02:04'!
nextPutAll: aCollection
	aCollection do: [:each |
		self nextPut: each].
	^ aCollection.! !

XMLWriteStreamAdapter subclass: #XMLStringWriteStreamAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLStringWriteStreamAdapter commentStamp: 'monty 2/9/2018 10:20' prior: 0!
A write stream adapter that accepts binary input and converts it to character output for string write streams.!

!XMLStringWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/4/2018 01:59'!
nextPut: anObject
	stream nextPut: anObject asCharacter! !

!XMLStringWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/4/2018 02:05'!
nextPutAll: aCollection
	aCollection do: [:each |
		stream nextPut: each asCharacter].
	^ aCollection.! !

!XMLWriteStreamAdapter class methodsFor: 'class initialization' stamp: 'monty 2/10/2016 20:54'!
initialize
	"self initialize"

	"stored in class vars for faster access"
	SpaceCharacter := Character space.
	TabCharacter := Character tab.
	CRCharacter := Character cr.
	LFCharacter := Character lf.! !

XMLWriteStreamAdapter initialize!

!XMLWriteStreamAdapter methodsFor: 'basic' stamp: 'monty 2/3/2018 03:06'!
basicNextPut: anObject 
	^ self nextPut: anObject! !

!XMLWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/22/2016 23:57'!
contents
	^ stream contents! !

!XMLWriteStreamAdapter methodsFor: 'character writing' stamp: 'monty 2/10/2016 20:54'!
cr
	^ self nextPut: CRCharacter! !

!XMLWriteStreamAdapter methodsFor: 'character writing' stamp: 'monty 2/10/2016 20:54'!
lf
	^ self nextPut: LFCharacter! !

!XMLWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:23'!
nextPut: anObject
	stream nextPut: anObject.
	^ anObject.! !

!XMLWriteStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:23'!
nextPutAll: aCollection
	stream nextPutAll: aCollection.
	^ aCollection.! !

!XMLWriteStreamAdapter methodsFor: 'positioning' stamp: 'monty 2/7/2016 00:25'!
position
	^ stream position! !

!XMLWriteStreamAdapter methodsFor: 'positioning' stamp: 'monty 2/7/2016 00:25'!
position: anInteger
	stream position: anInteger! !

!XMLWriteStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/22/2016 23:57'!
reset
	stream reset! !

!XMLWriteStreamAdapter methodsFor: 'character writing' stamp: 'monty 2/5/2016 01:57'!
space
	^ self nextPut: SpaceCharacter! !

!XMLWriteStreamAdapter methodsFor: 'character writing' stamp: 'monty 2/10/2016 20:48'!
tab
	^ self nextPut: TabCharacter! !

Object subclass: #XMLStreamConverter
	instanceVariableNames: ''
	classVariableNames: 'EncodingNamesAndClassesCache PreferredClasses'
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

XMLStreamConverter class
	instanceVariableNames: 'encodingNames'!

!XMLStreamConverter commentStamp: 'monty 10/21/2017 22:45' prior: 0!
An abstract class for stream converters.

Subclasses need to implement #nextFromStream: to use #basicNext on the argument to read byte characters and decode them, and implement #nextPut:toStream: to use #basicNextPut:/#basicNextPutByte: on the second argument to encode the first.

The class #basicEncodingNames method should return a basic list of names for the encoding handled by the class, and #byteOrderMarkBytes can return the bytes of a BOM if the encoding has one.!

XMLStreamConverter class
	instanceVariableNames: 'encodingNames'!

XMLStreamConverter subclass: #XMLStatelessStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

XMLStatelessStreamConverter class
	instanceVariableNames: 'instance'!

!XMLStatelessStreamConverter commentStamp: 'monty 4/30/2017 21:45' prior: 0!
This is a base class for stateless, immutable stream converter classes. Each subclass has a single instance that is shared.!

XMLStatelessStreamConverter class
	instanceVariableNames: 'instance'!

XMLStatelessStreamConverter subclass: #XMLASCIIStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLASCIIStreamConverter commentStamp: 'monty 2/5/2018 19:04' prior: 0!
A stream converter for ASCII.!

!XMLASCIIStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 06:26'!
basicEncodingNames
	^ #('ASCII' 'US-ASCII' 'USASCII')! !

!XMLASCIIStreamConverter methodsFor: 'decoding' stamp: 'monty 2/5/2018 06:27'!
nextFromStream: aStream
	| byte |

	aStream atEnd
		ifTrue: [^ nil].
	(byte := aStream next asInteger) > 127
		ifTrue: [self errorBadCharacterValue: byte].

	^ byte asCharacter.! !

!XMLASCIIStreamConverter methodsFor: 'encoding' stamp: 'monty 2/5/2018 06:27'!
nextPut: aCharacter toStream: aStream
	| codePoint |

	(codePoint := aCharacter asInteger) > 127
		ifTrue: [self errorBadCharacterValue: aCharacter asciiValue].

	aStream nextPut: codePoint.! !

XMLStatelessStreamConverter subclass: #XMLLatin1StreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLLatin1StreamConverter commentStamp: 'monty 2/5/2018 19:04' prior: 0!
A stream converter for ISO Latin-1.!

!XMLLatin1StreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 06:25'!
basicEncodingNames
	^ #('Latin-1' 'Latin1'
			'CP-819' 'CP819'
			'IBM-819' 'IBM819'
			'ISO-8859-1' 'ISO8859-1' 'ISO-88591' 'ISO88591'
			'ISO-IR-100' 'ISOIR-100' 'ISO-IR100' 'ISOIR100'
			'L1'
			'csISOLatin1')! !

!XMLLatin1StreamConverter methodsFor: 'decoding' stamp: 'monty 2/2/2018 07:58'!
nextFromStream: aStream
	| byte |

	aStream atEnd
		ifTrue: [^ nil].
	(byte := aStream next asInteger) > 255
		ifTrue: [self errorBadCharacterValue: byte].

	^ byte asCharacter.! !

!XMLLatin1StreamConverter methodsFor: 'encoding' stamp: 'monty 2/3/2018 03:03'!
nextPut: aCharacter toStream: aStream
	| codePoint |

	(codePoint := aCharacter asInteger) > 255
		ifTrue: [self errorBadCharacterValue: aCharacter asciiValue].

	aStream nextPut: codePoint.! !

XMLStatelessStreamConverter subclass: #XMLNullStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLNullStreamConverter commentStamp: 'monty 2/14/2016 02:29' prior: 0!
A stream converter that does no encoding or decoding.!

!XMLNullStreamConverter methodsFor: 'testing' stamp: 'monty 3/5/2016 06:37'!
isNull
	^ true! !

!XMLNullStreamConverter methodsFor: 'decoding' stamp: 'monty 2/4/2018 22:12'!
nextFromStream: aStream
	aStream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ aStream next asCharacter]! !

!XMLNullStreamConverter methodsFor: 'encoding' stamp: 'monty 2/3/2018 03:03'!
nextPut: aCharacter toStream: aStream
	aStream nextPut: aCharacter asInteger! !

!XMLStatelessStreamConverter class methodsFor: 'defaults' stamp: 'monty 1/28/2018 18:54'!
abstractClass
	^ XMLStatelessStreamConverter! !

!XMLStatelessStreamConverter class methodsFor: 'accessing' stamp: 'monty 4/30/2017 21:36'!
instance
	^ instance ifNil: [instance := self basicNew initialize]! !

!XMLStatelessStreamConverter class methodsFor: 'instance creation' stamp: 'monty 4/30/2017 21:48'!
new
	"all subclasses are stateless and have a single, immutable, shared instance"
	^ self instance! !

XMLStatelessStreamConverter subclass: #XMLUTFStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTFStreamConverter commentStamp: 'monty 2/14/2016 02:13' prior: 0!
An abstract class for Unicode stream converters.!

XMLUTFStreamConverter subclass: #XMLUTF16StreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF16StreamConverter commentStamp: 'monty 2/14/2016 02:13' prior: 0!
An abstract class for UTF-16 stream converters.!

XMLUTF16StreamConverter subclass: #XMLUTF16BigEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF16BigEndianStreamConverter commentStamp: 'monty 6/22/2016 22:12' prior: 0!
A stream converter for big endian UTF-16 streams, and the default converter class used when a UTF-16 stream converter is created with newForEncoding: or asXMLStreamConverter and no endian is specified by the encoding name.!

XMLUTF16BigEndianStreamConverter subclass: #XMLImplicitUTF16BigEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitUTF16BigEndianStreamConverter commentStamp: 'monty 1/18/2018 02:22' prior: 0!
A stream converter for implicit big endian UTF-16 streams.!

!XMLImplicitUTF16BigEndianStreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ true! !

!XMLUTF16BigEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[16rFE 16rFF]! !

!XMLUTF16BigEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 10/2/2017 17:03'!
basicEncodingNames
	^ #('UTF-16' 'UTF16'
			'UTF-16-BE' 'UTF16-BE' 'UTF-16BE' 'UTF16BE')! !

!XMLUTF16BigEndianStreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:47'!
isBigEndian
	^ true! !

!XMLUTF16BigEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/3/2018 03:04'!
nextPutTwoBytes: anInteger toStream: aStream
	aStream
		nextPut: ((anInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: (anInteger bitAnd: 16rFF)! !

!XMLUTF16BigEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:04'!
nextTwoBytesFromStream: aStream
	| firstByte |

	firstByte := aStream next asInteger bitShift: 8.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	^ firstByte + aStream next asInteger.! !

XMLUTF16StreamConverter subclass: #XMLUTF16LittleEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF16LittleEndianStreamConverter commentStamp: 'monty 2/14/2016 02:14' prior: 0!
A stream converter for little endian UTF-16 streams.!

XMLUTF16LittleEndianStreamConverter subclass: #XMLImplicitUTF16LittleEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitUTF16LittleEndianStreamConverter commentStamp: 'monty 1/18/2018 02:22' prior: 0!
A stream converter for implicit little endian UTF-16 streams.!

!XMLImplicitUTF16LittleEndianStreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ true! !

!XMLUTF16LittleEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[16rFF 16rFE]! !

!XMLUTF16LittleEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 10/2/2017 17:03'!
basicEncodingNames
	^ #('UTF-16-LE' 'UTF16-LE' 'UTF-16LE' 'UTF16LE')! !

!XMLUTF16LittleEndianStreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:47'!
isBigEndian
	^ false! !

!XMLUTF16LittleEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/3/2018 03:04'!
nextPutTwoBytes: anInteger toStream: aStream
	aStream
		nextPut: (anInteger bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -8) bitAnd: 16rFF)! !

!XMLUTF16LittleEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:03'!
nextTwoBytesFromStream: aStream
	| firstByte |

	firstByte := aStream next asInteger.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	^ firstByte + (aStream next asInteger bitShift: 8).! !

!XMLUTF16StreamConverter class methodsFor: 'defaults' stamp: 'monty 1/28/2018 18:55'!
abstractClass
	^ XMLUTF16StreamConverter! !

!XMLUTF16StreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:46'!
isBigEndian
	self subclassResponsibility! !

!XMLUTF16StreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:05'!
nextCodePointFromStream: aStream
	| codePoint lowSurrogate |

	aStream atEnd
		ifTrue: [^ nil].

	"code points U+10000 to U+10FFFF are encoded with surrogate pairs,
	while those < U+10000 are encoded directly"
	((codePoint := self nextTwoBytesFromStream: aStream) < 16rD800
		or: [codePoint > 16rDFFF])
		ifTrue: [
			codePoint > 16r10FFFF
				ifTrue: [self errorBadCharacterValue: codePoint].
			^ codePoint].

	codePoint > 16rDBFF "max high surrogate"
		ifTrue: [self errorBadCharacterEncoding].

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	(lowSurrogate := self nextTwoBytesFromStream: aStream)
		ifNil: [self errorBadCharacterEncoding].
	(lowSurrogate < 16rDC00 "min low surrogate"
		or: [lowSurrogate > 16rDFFF]) "max low surrogate"
		ifTrue: [self errorBadCharacterEncoding].

	"A code point > U+10FFFF isn't checked for here because it can't
	be encoded with UTF-16. The maximum surrogate pairs can encode is:
		(16r10000 + (16r3FF bitShift: 10) + 16r3FF) = 16r10FFFF"
	^ ((codePoint bitAnd: 16r3FF) bitShift: 10) +
		(lowSurrogate bitAnd: 16r3FF) +
		16r10000.! !

!XMLUTF16StreamConverter methodsFor: 'encoding' stamp: 'monty 2/4/2018 02:02'!
nextPut: aCharacter toStream: aStream
	| codePoint |

	(codePoint := aCharacter asInteger) < 16r10000
		ifTrue: [
			"check for the reserved surrogate pair code points"
			(codePoint >= 16rD800
				and: [codePoint <= 16rDFFF])
				ifTrue: [self errorBadCharacterValue: codePoint].
			self
				nextPutTwoBytes: codePoint
				toStream: aStream]
		ifFalse: [
			codePoint > 16r10FFFF "max code point"
				ifTrue: [self errorBadCharacterValue: codePoint].
			codePoint := codePoint - 16r10000.
			"the 10 high-order bits"
			self
				nextPutTwoBytes: 16rD800 + ((codePoint bitShift: -10) bitAnd: 16r3FF)
				toStream: aStream.
			"the 10 low-order bits"
			self
				nextPutTwoBytes: 16rDC00 + (codePoint bitAnd: 16r3FF)
				toStream: aStream]! !

!XMLUTF16StreamConverter methodsFor: 'basic' stamp: 'monty 4/27/2017 15:14'!
nextPutTwoBytes: anInteger toStream: aStream
	self subclassResponsibility! !

!XMLUTF16StreamConverter methodsFor: 'basic' stamp: 'monty 4/27/2017 14:34'!
nextTwoBytesFromStream: aStream
	self subclassResponsibility! !

XMLUTFStreamConverter subclass: #XMLUTF32StreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF32StreamConverter commentStamp: 'monty 2/14/2016 02:13' prior: 0!
An abstract class for UTF-32 stream converters.!

XMLUTF32StreamConverter subclass: #XMLUTF32BigEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF32BigEndianStreamConverter commentStamp: 'monty 6/22/2016 22:12' prior: 0!
A stream converter for big endian UTF-32 streams, and the default converter class used when a UTF-32 stream converter is created with newForEncoding: or asXMLStreamConverter and no endian is specified by the encoding name.!

XMLUTF32BigEndianStreamConverter subclass: #XMLImplicitUTF32BigEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitUTF32BigEndianStreamConverter commentStamp: 'monty 1/18/2018 02:22' prior: 0!
A stream converter for implicit big endian UTF-32 streams.!

!XMLImplicitUTF32BigEndianStreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ true! !

!XMLUTF32BigEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[16r00 16r00 16rFE 16rFF]! !

!XMLUTF32BigEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 10/2/2017 17:04'!
basicEncodingNames
	^ #('UTF-32' 'UTF32'
			'UTF-32-BE' 'UTF32-BE' 'UTF-32BE' 'UTF32BE')! !

!XMLUTF32BigEndianStreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:49'!
isBigEndian
	^ true! !

!XMLUTF32BigEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:08'!
nextFourBytesFromStream: aStream
	| firstByte secondByte thirdByte |

	firstByte := aStream next asInteger bitShift: 24.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	secondByte := aStream next asInteger bitShift: 16.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	thirdByte := aStream next asInteger bitShift: 8.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	^ firstByte + secondByte + thirdByte + aStream next asInteger.! !

!XMLUTF32BigEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/3/2018 03:04'!
nextPutFourBytes: anInteger toStream: aStream
	aStream
		nextPut: ((anInteger bitShift: -24) bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -16) bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: (anInteger bitAnd: 16rFF)! !

XMLUTF32StreamConverter subclass: #XMLUTF32LittleEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF32LittleEndianStreamConverter commentStamp: 'monty 2/14/2016 02:14' prior: 0!
A stream converter for little endian UTF-32 streams.!

XMLUTF32LittleEndianStreamConverter subclass: #XMLImplicitUTF32LittleEndianStreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitUTF32LittleEndianStreamConverter commentStamp: 'monty 1/18/2018 02:22' prior: 0!
A stream converter for implicit little endian UTF-32 streams.!

!XMLImplicitUTF32LittleEndianStreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ true! !

!XMLUTF32LittleEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[16rFF 16rFE 16r00 16r00]! !

!XMLUTF32LittleEndianStreamConverter class methodsFor: 'basic' stamp: 'monty 10/2/2017 17:04'!
basicEncodingNames
	^ #('UTF-32-LE' 'UTF32-LE' 'UTF-32LE' 'UTF32LE')! !

!XMLUTF32LittleEndianStreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:50'!
isBigEndian
	^ false! !

!XMLUTF32LittleEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:07'!
nextFourBytesFromStream: aStream
	| firstByte secondByte thirdByte |

	firstByte := aStream next asInteger.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	secondByte := aStream next asInteger bitShift: 8.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	thirdByte := aStream next asInteger bitShift: 16.

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	^ firstByte + secondByte + thirdByte + (aStream next asInteger bitShift: 24).! !

!XMLUTF32LittleEndianStreamConverter methodsFor: 'basic' stamp: 'monty 2/3/2018 03:04'!
nextPutFourBytes: anInteger toStream: aStream
	aStream
		nextPut: (anInteger bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -16) bitAnd: 16rFF);
		nextPut: ((anInteger bitShift: -24) bitAnd: 16rFF)! !

!XMLUTF32StreamConverter class methodsFor: 'defaults' stamp: 'monty 1/28/2018 18:55'!
abstractClass
	^ XMLUTF32StreamConverter! !

!XMLUTF32StreamConverter methodsFor: 'testing' stamp: 'monty 11/11/2014 14:49'!
isBigEndian
	self subclassResponsibility! !

!XMLUTF32StreamConverter methodsFor: 'basic' stamp: 'monty 2/2/2018 08:01'!
nextCodePointFromStream: aStream
	| codePoint |

	aStream atEnd
		ifTrue: [^ nil].

	"check for the reserved surrogate pair code points and code points
	greater than the max code point"
	(codePoint := self nextFourBytesFromStream: aStream) >= 16rD800
		ifTrue: [
			(codePoint <= 16rDFFF
				or: [codePoint > 16r10FFFF])
				ifTrue: [self errorBadCharacterValue: codePoint]].

	^ codePoint.! !

!XMLUTF32StreamConverter methodsFor: 'basic' stamp: 'monty 4/27/2017 14:37'!
nextFourBytesFromStream: aStream
	self subclassResponsibility! !

!XMLUTF32StreamConverter methodsFor: 'encoding' stamp: 'monty 2/4/2018 02:01'!
nextPut: aCharacter toStream: aStream
	| codePoint |

	codePoint := aCharacter asInteger.
	"check for the reserved surrogate pair code points and code points
	greater than the max code point"
	(codePoint >= 16rD800
		and: [codePoint <= 16rDFFF
			or: [codePoint > 16r10FFFF]])
		ifTrue: [self errorBadCharacterValue: codePoint].
	self
		nextPutFourBytes: codePoint
		toStream: aStream.! !

!XMLUTF32StreamConverter methodsFor: 'basic' stamp: 'monty 4/27/2017 15:01'!
nextPutFourBytes: anInteger toStream: aStream
	self subclassResponsibility! !

XMLUTFStreamConverter subclass: #XMLUTF8StreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLUTF8StreamConverter commentStamp: 'monty 4/27/2017 18:01' prior: 0!
A stream converter for UTF-8 streams. (Rejects overlong encodings.)!

XMLUTF8StreamConverter subclass: #XMLImplicitUTF8StreamConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLImplicitUTF8StreamConverter commentStamp: 'monty 1/18/2018 02:22' prior: 0!
A stream converter for implicit UTF-8 streams.!

!XMLImplicitUTF8StreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ true! !

!XMLUTF8StreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[16rEF 16rBB 16rBF]! !

!XMLUTF8StreamConverter class methodsFor: 'basic' stamp: 'monty 4/24/2015 11:12'!
basicEncodingNames
	^ #('UTF-8' 'UTF8')! !

!XMLUTF8StreamConverter methodsFor: 'private' stamp: 'monty 4/27/2017 18:00'!
errorOverlongCodePoint: aCodePoint
	XMLEncodingException
		formatSignal: 'Illegal overlong UTF-8 encoding for U+{1} code point'
		with: aCodePoint printStringHex! !

!XMLUTF8StreamConverter methodsFor: 'basic' stamp: 'monty 4/30/2017 21:28'!
nextCodePointFromStream: aStream
	self shouldNotImplement! !

!XMLUTF8StreamConverter methodsFor: 'decoding' stamp: 'monty 2/2/2018 08:06'!
nextFromStream: aStream
	"an attempt was made at porting Bjoern Hoehrmann's DFA-based decoder
	(with transitions pre-multiplied by 16), but it was slightly slower
	than this implementation and needed significant modification to report
	errors the same way, so it was scrapped"

	| firstByte codePoint |

	aStream atEnd
		ifTrue: [^ nil].
	(firstByte := aStream next asInteger) < 16r80 "single byte character"
		ifTrue: [^ firstByte asCharacter].

	codePoint :=
		self
			nextMultiByteCodePointStartingWith: firstByte
			fromStream: aStream.
	[codePoint == 16rFEFF] "the BOM code point"
		whileTrue: [
			aStream atEnd
				ifTrue: [^ nil].
			(firstByte := aStream next asInteger) < 16r80 "single byte character"
				ifTrue: [^ firstByte asCharacter].
			codePoint :=
				self
					nextMultiByteCodePointStartingWith: firstByte
					fromStream: aStream].

	^ codePoint asCharacter.! !

!XMLUTF8StreamConverter methodsFor: 'basic' stamp: 'monty 2/1/2018 08:44'!
nextMultiByteCodePointStartingWith: aFirstByte fromStream: aStream
	| secondByte thirdByte codePoint |

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	secondByte := aStream next asInteger.
	(secondByte bitAnd: 16rC0) == 16r80
		ifFalse: [self errorBadCharacterEncoding].
	(aFirstByte bitAnd: 16rE0) == 16rC0 "two bytes"
		ifTrue: [
			codePoint :=
				((aFirstByte bitAnd: 16r1F) bitShift: 6) +
				(secondByte bitAnd: 16r3F).
			codePoint >= 16r80
				ifFalse: [self errorOverlongCodePoint: codePoint].
			^ codePoint].

	aStream atEnd
		ifTrue: [self errorBadCharacterEncoding].
	thirdByte := aStream next asInteger.
	(thirdByte bitAnd: 16rC0) == 16r80
		ifFalse: [self errorBadCharacterEncoding].
	(aFirstByte bitAnd: 16rF0) == 16rE0 "three bytes"
		ifTrue: [
			codePoint :=
				((aFirstByte bitAnd: 16r0F) bitShift: 12) +
				((secondByte bitAnd: 16r3F) bitShift: 6) +
				(thirdByte bitAnd: 16r3F).
			"check for the reserved surrogate pair code points"
			codePoint >= 16rD800
				ifTrue: [
					codePoint <= 16rDFFF
						ifTrue: [self errorBadCharacterValue: codePoint]]
				ifFalse: [
					codePoint >= 16r800
						ifFalse: [self errorOverlongCodePoint: codePoint]].
			^ codePoint].

	(aFirstByte bitAnd: 16rF8) == 16rF0
		ifTrue: [| fourthByte |
			aStream atEnd
				ifTrue: [self errorBadCharacterEncoding].
			fourthByte := aStream next asInteger.
			(fourthByte bitAnd: 16rC0) == 16r80
				ifFalse: [self errorBadCharacterEncoding].
			codePoint :=
				((aFirstByte bitAnd: 16r07) bitShift: 18) +
				((secondByte bitAnd: 16r3F) bitShift: 12) +
				((thirdByte bitAnd: 16r3F) bitShift: 6) +
				(fourthByte bitAnd: 16r3F).
			codePoint > 16r10FFFF "max code point"
				ifTrue: [self errorBadCharacterValue: codePoint].
			codePoint >= 16r10000
				ifFalse: [self errorOverlongCodePoint: codePoint].
			^ codePoint].

	"the first byte is malformed"
	self errorBadCharacterEncoding.! !

!XMLUTF8StreamConverter methodsFor: 'encoding' stamp: 'monty 2/3/2018 03:04'!
nextPut: aCharacter toStream: aStream
	| codePoint |

	(codePoint := aCharacter asInteger) < 16r80
		ifTrue: [
			aStream nextPut: codePoint.
			^ self].

	codePoint < 16r800
		ifTrue: [
			aStream
				nextPut: 16rC0 + (codePoint bitShift: -6);
				nextPut: 16r80 + (codePoint bitAnd: 16r003F).
			^ self].

	codePoint < 16r10000
		ifTrue: [
			"check for the reserved surrogate pair code points"
			(codePoint >= 16rD800
				and: [codePoint <= 16rDFFF])
				ifTrue: [self errorBadCharacterValue: codePoint].
			aStream
				nextPut: 16rE0 + (codePoint bitShift: -12);
				nextPut: 16r80 + ((codePoint bitShift: -6) bitAnd: 16r3F);
				nextPut: 16r80 + (codePoint bitAnd: 16r3F).
			^ self].

	codePoint <= 16r10FFFF  "max code point"
		ifTrue: [
			aStream
				nextPut: 16rF0 + (codePoint bitShift: -18);
				nextPut: 16r80 + ((codePoint bitShift: -12) bitAnd: 16r3F);
				nextPut: 16r80 + ((codePoint bitShift: -6) bitAnd: 16r3F);
				nextPut: 16r80 + (codePoint bitAnd: 16r3F).
			^ self].

	self errorBadCharacterValue: codePoint.! !

!XMLUTFStreamConverter class methodsFor: 'defaults' stamp: 'monty 1/28/2018 18:54'!
abstractClass
	^ XMLUTFStreamConverter! !

!XMLUTFStreamConverter methodsFor: 'private' stamp: 'monty 4/30/2017 21:27'!
errorBadCharacterValue: aValue
	XMLEncodingException
		formatSignal: 'Invalid {1} code point U+{1}'
		with: self encoding
		with: aValue printStringHex! !

!XMLUTFStreamConverter methodsFor: 'basic' stamp: 'monty 4/29/2017 23:49'!
nextCodePointFromStream: aStream
	self subclassResponsibility! !

!XMLUTFStreamConverter methodsFor: 'decoding' stamp: 'monty 2/5/2018 01:04'!
nextFromStream: aStream
	| codePoint |

	codePoint := self nextCodePointFromStream: aStream.
	[codePoint == 16rFEFF] "the BOM code point"
		whileTrue: [
			aStream atEnd
				ifTrue: [^ nil].
			codePoint := self nextCodePointFromStream: aStream].
	^ codePoint
		ifNotNil: [codePoint asCharacter].! !

!XMLStreamConverter class methodsFor: 'defaults' stamp: 'monty 1/28/2018 18:53'!
abstractClass
	^ XMLStreamConverter! !

!XMLStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 04:23'!
basicByteOrderMarkBytes
	^ #[]! !

!XMLStreamConverter class methodsFor: 'basic' stamp: 'monty 9/20/2017 09:27'!
basicCanConvertEncoding: anEncodingName
	^ self encodingNames includes: anEncodingName! !

!XMLStreamConverter class methodsFor: 'basic' stamp: 'monty 4/26/2015 23:57'!
basicEncodingNames
	"encodingNames will have these names + upper/lowercase versions"
	^ #()! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 2/5/2018 06:10'!
byteOrderMark
	"avoid #asString and #newFrom: for GS portability"
	^ String streamContents: [:stream |
		self byteOrderMarkBytes do: [:each |
			stream nextPut: each asCharacter]]! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 2/5/2018 04:22'!
byteOrderMarkBytes
	^ self basicByteOrderMarkBytes asByteArray! !

!XMLStreamConverter class methodsFor: 'testing' stamp: 'monty 1/28/2018 19:05'!
canConvertEncoding: anEncodingName
	"Returns true if the receiver can decode the encoding anEncodingName.
	Lookup is case-insensitive."

	"we could remove whitespace from anEncodingName too, but the
	production rule for <?xml ...?> 'encoding' attributes disallows
	whitespace, and the HTML parser removes it from <meta> charset
	attributes before converting, so we just convert it to lowercase"
	^ self isAbstractClass not
		and: [self basicCanConvertEncoding: anEncodingName asLowercase]! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 1/21/2017 13:39'!
classForEncoding: anEncodingName
	"avoid #at:ifAbsent: and #at:ifAbsentPut: so the cache isn't locked
	during the class lookup, which could stall other processes"
	self encodingNamesAndClassesCache
		at: anEncodingName
		ifPresent: [:classForEncoding | ^ classForEncoding].

	"this will store the class as nil if it wasn't found to prevent future lookup"
	^ self encodingNamesAndClassesCache
		at: anEncodingName
		put: (self findClassForEncoding: anEncodingName).! !

!XMLStreamConverter class methodsFor: 'convenience' stamp: ''!
decode: aStringOrByteArray
	^ self new decode: aStringOrByteArray! !

!XMLStreamConverter class methodsFor: 'instance creation' stamp: 'monty 1/25/2016 22:39'!
default
	^ self defaultClass new! !

!XMLStreamConverter class methodsFor: 'defaults' stamp: 'monty 1/20/2018 07:16'!
defaultClass
	^ XMLImplicitUTF8StreamConverter! !

!XMLStreamConverter class methodsFor: 'defaults' stamp: 'monty 10/24/2017 02:12'!
defaultEncoding
	^ self defaultClass primaryEncodingName! !

!XMLStreamConverter class methodsFor: 'convenience' stamp: 'monty 2/9/2018 04:20'!
encode: aString
	^ self new encode: aString! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 10/9/2016 17:07'!
encodingNames
	^ encodingNames
		ifNil: [
			"assign the fully initialized object with #yourself to avoid
			possible race conditions when reinitialization the class"
			encodingNames :=
				Set new
					addAll: self basicEncodingNames;
					addAll:
						(self basicEncodingNames collect: [:each | each asLowercase]);
					addAll:
						(self basicEncodingNames collect: [:each | each asUppercase]);
					yourself]! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 10/9/2016 17:10'!
encodingNames: aCollectionOrNil
	encodingNames :=
		aCollectionOrNil
			ifNotNil: [aCollectionOrNil asSet]! !

!XMLStreamConverter class methodsFor: 'private' stamp: 'monty 10/9/2016 03:34'!
encodingNamesAndClassesCache
	"a class variable so it's shared by all subclasses, but lazy initialized
	so it isn't initialized unless needed"
	^ EncodingNamesAndClassesCache
		ifNil: [EncodingNamesAndClassesCache := XMLKeyValueCache maxSize: 128]! !

!XMLStreamConverter class methodsFor: 'private' stamp: 'monty 10/3/2016 17:05'!
findClassForEncoding: anEncodingName
	"check preferred classes first"
	self preferredClasses do: [:each |
		(each canConvertEncoding: anEncodingName)
			ifTrue: [^ each]].

	"avoid #withAllSubclassesDo: because it does not enumerate the receiver first"
	(self isNonPreferredClassForEncoding: anEncodingName)
		ifTrue: [^ self].
	self allSubclassesDo: [:each |
		(each isNonPreferredClassForEncoding: anEncodingName)
			ifTrue: [^ each]].

	^ nil.! !

!XMLStreamConverter class methodsFor: 'class initialization' stamp: 'monty 5/15/2017 21:00'!
initialize
	"self initialize"

	PreferredClasses := nil.
	"reset to nil instead of just clearing to get full reinitialization"
	EncodingNamesAndClassesCache := nil.! !

XMLStreamConverter initialize!

!XMLStreamConverter class methodsFor: 'testing' stamp: 'monty 1/28/2018 18:54'!
isAbstractClass
	^ self == self abstractClass! !

!XMLStreamConverter class methodsFor: 'testing' stamp: 'monty 1/25/2016 22:39'!
isDefaultClass
	^ self == self defaultClass! !

!XMLStreamConverter class methodsFor: 'testing' stamp: 'monty 3/4/2016 12:48'!
isNonPreferredClassForEncoding: anEncoding
	^ self isPreferredClass not
		and: [self canConvertEncoding: anEncoding]! !

!XMLStreamConverter class methodsFor: 'testing' stamp: 'monty 3/4/2016 12:48'!
isPreferredClass
	^ self preferredClasses includes: self! !

!XMLStreamConverter class methodsFor: 'instance creation' stamp: 'monty 4/30/2017 21:31'!
newForEncoding: anEncodingName
	(self classForEncoding: anEncodingName)
		ifNil: [^ self null]
		ifNotNil: [:converterClass |
			^ converterClass new initializeForEncoding: anEncodingName]! !

!XMLStreamConverter class methodsFor: 'instance creation' stamp: 'monty 6/17/2017 00:54'!
null
	^ self nullClass new! !

!XMLStreamConverter class methodsFor: 'defaults' stamp: 'monty 6/17/2017 00:54'!
nullClass
	^ XMLNullStreamConverter! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 2/7/2018 06:16'!
preferredClasses
	"A class var because it should be shared by all subclasses.
	Assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class."
	^ PreferredClasses
		ifNil: [
			PreferredClasses :=
				IdentitySet new
					addAll:
						(XMLUTFStreamConverter allSubclasses reject: [:each |
							each isAbstractClass]);
					add: XMLLatin1StreamConverter;
					add: XMLASCIIStreamConverter;
					yourself]! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 10/9/2016 17:10'!
preferredClasses: aCollectionOrNil
	PreferredClasses :=
		aCollectionOrNil
			ifNotNil: [aCollectionOrNil asSet]! !

!XMLStreamConverter class methodsFor: 'accessing' stamp: 'monty 4/30/2017 21:41'!
primaryEncodingName
	^ self basicEncodingNames
		at: 1
		ifAbsent: ['']! !

!XMLStreamConverter methodsFor: 'converting' stamp: 'monty 3/3/2016 21:00'!
asXMLStreamConverter
	^ self! !

!XMLStreamConverter methodsFor: 'convenience' stamp: 'monty 2/9/2018 04:19'!
decode: aStringOrByteArray
	^ (XMLDecodingReadStreamAdapter
		on: aStringOrByteArray readStream
		streamConverter: self)
			contents! !

!XMLStreamConverter methodsFor: 'convenience' stamp: 'monty 2/9/2018 04:20'!
encode: aString
	^ (XMLEncodingWriteStreamAdapter
		on: (ByteArray new: aString size) writeStream
		streamConverter: self)
			nextPutByteOrderMark;
			nextPutAll: aString;
			contents! !

!XMLStreamConverter methodsFor: 'accessing' stamp: 'monty 4/30/2017 21:41'!
encoding
	^ self class primaryEncodingName! !

!XMLStreamConverter methodsFor: 'private' stamp: 'monty 4/30/2017 21:29'!
errorBadCharacterEncoding
	XMLEncodingException
		formatSignal: 'Invalid {1} encoding for character'
		with: self encoding! !

!XMLStreamConverter methodsFor: 'private' stamp: 'monty 3/25/2016 01:55'!
errorBadCharacterValue: aValue
	XMLEncodingException
		formatSignal: 'Invalid character 0x{1} for {2} encoding'
		with: aValue printStringHex
		with: self encoding! !

!XMLStreamConverter methodsFor: 'initialization' stamp: 'monty 4/30/2017 21:33'!
initializeForEncoding: anEncodingName! !

!XMLStreamConverter methodsFor: 'testing' stamp: 'monty 1/25/2016 22:39'!
isDefault
	^ self class isDefaultClass! !

!XMLStreamConverter methodsFor: 'testing' stamp: 'monty 1/17/2018 01:59'!
isImplicit
	^ false! !

!XMLStreamConverter methodsFor: 'testing' stamp: 'monty 3/5/2016 06:37'!
isNull
	^ false! !

!XMLStreamConverter methodsFor: 'decoding' stamp: 'monty 11/17/2014 21:14'!
nextFromStream: aStream
	self subclassResponsibility! !

!XMLStreamConverter methodsFor: 'encoding' stamp: 'monty 1/26/2016 01:48'!
nextPut: aCharacter toStream: aStream
	self subclassResponsibility! !

!XMLStreamConverter methodsFor: 'encoding' stamp: 'monty 2/4/2018 05:39'!
nextPutByteOrderMarkToStream: aStream
	self class byteOrderMarkBytes do: [:each |
		aStream nextPut: each]! !

!XMLStreamConverter methodsFor: 'printing' stamp: 'monty 3/4/2016 07:42'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self encoding;
		nextPut: $).! !

XMLStreamConverter subclass: #XMLZincByteEncoderStreamConverter
	instanceVariableNames: 'zincByteEncoder stringReadStreamAdapter nullStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Streams'!

!XMLZincByteEncoderStreamConverter commentStamp: 'monty 2/7/2018 07:36' prior: 0!
A stream converter that wraps the ZnByteEncoder legacy byte encoder class. (Requires Zinc.)!

!XMLZincByteEncoderStreamConverter class methodsFor: 'basic' stamp: 'monty 2/5/2018 10:57'!
basicCanConvertEncoding: anEncodingName
	^ XMLClassFinder
		classNamed: #ZnByteEncoder
		ifPresent: [:zincByteEncoderClass |
			zincByteEncoderClass handlesEncoding: anEncodingName]
		ifAbsent: [false]! !

!XMLZincByteEncoderStreamConverter methodsFor: 'initialization' stamp: 'monty 2/10/2018 04:24'!
initializeForEncoding: anEncodingName
	zincByteEncoder :=
		(XMLClassFinder classNamed: #ZnByteEncoder) newForEncoding: anEncodingName.

	"we use an XMLStringReadStreamAdapter to transparently handle non-binary
	character streams for ZnByteEncoder, which exepcts binary streams, and
	since it's only ever set to a non-null stream during #nextFromStream:,
	instances can still be shared by multiple streams, just not re-entrently,
	which is OK since this class is explicitly stateful and doesn't promise
	thread-safety."
	nullStream := XMLNullReadStream new.
	stringReadStreamAdapter :=
		XMLStringReadStreamAdapter on: nullStream.! !

!XMLZincByteEncoderStreamConverter methodsFor: 'decoding' stamp: 'monty 2/9/2018 06:11'!
nextFromStream: aStream
	"ZnByteEncoder does not check for #atEnd before sending #next"
	aStream atEnd
		ifTrue: [^ nil]
		ifFalse: [| nextChar |
			nextChar :=
				zincByteEncoder nextFromStream:
					(stringReadStreamAdapter on: aStream).
			stringReadStreamAdapter on: nullStream.
			^ nextChar]! !

!XMLZincByteEncoderStreamConverter methodsFor: 'encoding' stamp: 'monty 2/5/2018 10:55'!
nextPut: aCharacter toStream: aStream
	zincByteEncoder
		nextPut: aCharacter
		toStream: aStream! !

Object subclass: #XMLTokenizerState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

XMLTokenizerState class
	instanceVariableNames: 'instance'!

!XMLTokenizerState commentStamp: 'monty 10/7/2017 15:00' prior: 0!
This is an abstract class for states to control tokenization. Subclasses must implement #nextTokenFrom: to send a tokenizing message to the argument tokenizer.!

XMLTokenizerState class
	instanceVariableNames: 'instance'!

XMLTokenizerState subclass: #XMLContentState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLContentState commentStamp: '<historical>' prior: 0!
A state for content tokens, everything from the first stat tag to the end of the document.!

!XMLContentState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isContentState
	^ true! !

!XMLContentState methodsFor: 'tokenizing' stamp: 'monty 11/9/2014 15:41'!
nextTokenFrom: aTokenizer
	aTokenizer nextContentToken! !

XMLTokenizerState subclass: #XMLExternalSubsetState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLExternalSubsetState commentStamp: '<historical>' prior: 0!
A state for external subset tokens.!

!XMLExternalSubsetState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isExternalSubsetState
	^ true! !

!XMLExternalSubsetState methodsFor: 'tokenizing' stamp: 'monty 3/11/2016 10:50'!
nextTokenFrom: aTokenizer
	aTokenizer nextExternalSubsetToken! !

XMLExternalSubsetState subclass: #XMLExternalSubsetTextDeclarationState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLExternalSubsetTextDeclarationState commentStamp: '<historical>' prior: 0!
A state for <?xml ...?> text declaration tokens at the start of the external DTD subset.

This state #canTerminateInput unlike XMLXMLDeclarationState because external subsets and parsed entities can be empty, but documents must have at least one element.!

!XMLExternalSubsetTextDeclarationState methodsFor: 'tokenizing' stamp: 'monty 11/15/2016 15:08'!
nextTokenFrom: aTokenizer
	aTokenizer nextStartExternalSubset! !

!XMLExternalSubsetTextDeclarationState methodsFor: 'testing' stamp: 'monty 5/3/2015 17:02'!
supportsEncodingDetection
	^ true! !

XMLTokenizerState subclass: #XMLPrologState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPrologState commentStamp: '<historical>' prior: 0!
A state for prolog tokens.!

XMLPrologState subclass: #XMLDoctypeDeclarationState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLDoctypeDeclarationState commentStamp: '<historical>' prior: 0!
A state for <!!DOCTYPE ...> and internal subset tokens.!

!XMLDoctypeDeclarationState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isDoctypeDeclarationState
	^ true! !

XMLDoctypeDeclarationState subclass: #XMLInternalSubsetState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLInternalSubsetState commentStamp: '<historical>' prior: 0!
A state for internal subset tokens.!

!XMLInternalSubsetState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isInternalSubsetState
	^ true! !

!XMLInternalSubsetState methodsFor: 'tokenizing' stamp: 'monty 3/11/2016 10:50'!
nextTokenFrom: aTokenizer
	aTokenizer nextInternalSubsetToken! !

XMLPrologState subclass: #XMLPostDoctypeDeclarationState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLPostDoctypeDeclarationState commentStamp: '<historical>' prior: 0!
A state for parsing prolog tokens after <!!DOCTYPE ...> declarations.!

!XMLPostDoctypeDeclarationState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isPostDoctypeDeclarationState
	^ true! !

!XMLPrologState methodsFor: 'testing' stamp: 'monty 10/31/2016 03:42'!
canTerminateInput
	^ false! !

!XMLPrologState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isPrologState
	^ true! !

!XMLPrologState methodsFor: 'tokenizing' stamp: 'monty 11/9/2014 15:41'!
nextTokenFrom: aTokenizer
	aTokenizer nextPrologToken! !

XMLPrologState subclass: #XMLXMLDeclarationState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLXMLDeclarationState commentStamp: '<historical>' prior: 0!
A state for parsing the <?xml ...?> token.!

!XMLXMLDeclarationState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isXMLDeclarationState
	^ true! !

!XMLXMLDeclarationState methodsFor: 'tokenizing' stamp: 'monty 3/10/2016 22:10'!
nextTokenFrom: aTokenizer
	aTokenizer nextXMLDeclarationOrPrologToken! !

!XMLXMLDeclarationState methodsFor: 'testing' stamp: 'monty 5/3/2015 17:02'!
supportsEncodingDetection
	^ true! !

XMLTokenizerState subclass: #XMLTerminatedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLTerminatedState commentStamp: '<historical>' prior: 0!
A state for when tokenizing has stopped.!

!XMLTerminatedState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isTerminatedState
	^ true! !

!XMLTerminatedState methodsFor: 'tokenizing' stamp: 'monty 11/9/2014 16:27'!
nextTokenFrom: aTokenizer
	aTokenizer nextEndDocument! !

!XMLTokenizerState class methodsFor: 'accessing' stamp: 'monty 11/15/2016 15:27'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XMLTokenizerState class methodsFor: 'instance creation' stamp: 'monty 4/30/2017 21:48'!
new
	"all subclasses are stateless and have a single, immutable, shared instance"
	^ self instance! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/31/2016 03:42'!
canTerminateInput
	^ true! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:20'!
contentState
	^ XMLContentState new! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:20'!
doctypeDeclarationState
	^ XMLDoctypeDeclarationState new! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:20'!
externalSubsetState
	^ XMLExternalSubsetState new! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:20'!
internalSubsetState
	^ XMLInternalSubsetState new! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isContentState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isDoctypeDeclarationState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isExternalSubsetState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isInitializedState
	^ true! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isInternalSubsetState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isPostDoctypeDeclarationState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isPrologState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isTerminatedState
	^ false! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:06'!
isXMLDeclarationState
	^ false! !

!XMLTokenizerState methodsFor: 'tokenizing' stamp: 'monty 11/9/2014 16:40'!
nextTokenFrom: aTokenizer
	self subclassResponsibility! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:20'!
postDoctypeDeclarationState
	^ XMLPostDoctypeDeclarationState new! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:21'!
prologState
	^ XMLPrologState new! !

!XMLTokenizerState methodsFor: 'testing' stamp: 'monty 5/3/2015 17:02'!
supportsEncodingDetection
	^ false! !

!XMLTokenizerState methodsFor: 'changing' stamp: 'monty 10/6/2017 14:21'!
terminatedState
	^ XMLTerminatedState new! !

XMLTokenizerState subclass: #XMLUninitializedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Drivers'!

!XMLUninitializedState commentStamp: '<historical>' prior: 0!
A state for before tokenizing has started.!

!XMLUninitializedState methodsFor: 'testing' stamp: 'monty 10/6/2017 14:05'!
isInitializedState
	^ false! !

!XMLUninitializedState methodsFor: 'tokenizing' stamp: 'monty 11/9/2014 16:27'!
nextTokenFrom: aTokenizer
	aTokenizer nextStartDocument! !

Object subclass: #XMLURI
	instanceVariableNames: 'uriString scheme hasAuthorityPrefix rawUserInfo rawHost port rawPathSegments rawQuery rawFragment'
	classVariableNames: 'UnreservedCharacters'
	poolDictionaries: ''
	category: 'XML-Parser-URI'!

!XMLURI commentStamp: 'monty 2/12/2017 22:24' prior: 0!
A class for XML URIs. Instances are immutable and support combining with other XMLURIs or URI strings using / (to resolve relative URIs in the context of the receiver), accessing URI components, creating copies with replaced components, and retrieving the contents of http:// and file:// URLs using XMLHTTPRequest and XMLFileHandle.

Uses XMLURIParser to parse URIs lazily (for example, when a URI compoenent is accessed with an "accessing" message) when created from a string and eagerly when created from a stream.

URI components are stored internally in encoded form and decoded only when needed, because the XML standard requires delaying decoding for as long as possible.!

!XMLURI class methodsFor: 'instance creation' stamp: 'monty 3/17/2016 22:48'!
fromStream: aStream
	"streams must be parsed eagerly (because the stream might be read from
	or closed after), unlike strings"
	^ self basicNew initialize parseURIStream: aStream! !

!XMLURI class methodsFor: 'instance creation' stamp: 'monty 1/3/2016 20:55'!
fromString: aString
	^ self basicNew initialize uriString: aString! !

!XMLURI class methodsFor: 'class initialization' stamp: 'monty 9/28/2016 22:27'!
initialize
	"self initialize"

	"Assign the fully initialized object with #yourself to avoid
	possible race conditions when reinitialization the class."
	UnreservedCharacters :=
		BitmapCharacterSet new
			addRangeFrom: $a to: $z;
			addRangeFrom: $A to: $Z;
			addRangeFrom: $0 to: $9;
			addAll: '-._~';
			yourself! !

XMLURI initialize!

!XMLURI class methodsFor: 'instance creation' stamp: 'monty 2/9/2015 06:40'!
new
	^ self fromString: ''! !

!XMLURI class methodsFor: 'instance creation' stamp: 'monty 1/5/2016 09:07'!
readFrom: aStringOrStream
	aStringOrStream isStream
		ifTrue: [^ self fromStream: aStringOrStream]
		ifFalse: [^ self fromString: aStringOrStream]! !

!XMLURI methodsFor: 'combining' stamp: 'monty 3/31/2016 04:18'!
/ aURIOrURIString
	"Returns the argument URI if it is absolute or the argument resolved in the
	context of the receiver if it is relative, to do relative path resolution
	or replace hosts, query strings, and other components."

	^ self combinedWith: aURIOrURIString! !

!XMLURI methodsFor: 'comparing' stamp: 'monty 4/14/2017 09:49'!
= anObject
	self == anObject
		ifTrue: [^ true].

	self species == anObject species
		ifFalse: [^ false].

	self scheme = anObject scheme
		ifFalse: [^ false].

	"#has* tests are used as an optimization to skip direclty comparing
	components unless needed when doing so would require additional
	decoding of the raw components"
	self hasUserInfo
		ifTrue: [
			(anObject hasUserInfo
				and: [self userInfo = anObject userInfo])
				ifFalse: [^ false]]
		ifFalse: [
			anObject hasUserInfo
				ifTrue: [^ false]].

	self hasHost
		ifTrue: [
			(anObject hasHost
				and: [self host = anObject host])
				ifFalse: [^ false]]
		ifFalse: [
			anObject hasHost
				ifTrue: [^ false]].

	self port = anObject port
		ifFalse: [^ false].

	self hasPath
		ifTrue: [
			(anObject hasPath
				and: [self pathSegments = anObject pathSegments])
				ifFalse: [^ false]]
		ifFalse: [
			anObject hasPath
				ifTrue: [^ false]].

	self hasQuery
		ifTrue: [
			(anObject hasQuery
				and: [self query = anObject query])
				ifFalse: [^ false]]
		ifFalse: [
			anObject hasQuery
				ifTrue: [^ false]].

	self hasFragment
		ifTrue: [
			(anObject hasFragment
				and: [self fragment = anObject fragment])
				ifFalse: [^ false]]
		ifFalse: [
			anObject hasFragment
				ifTrue: [^ false]].

	^ true.! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 05:50'!
addRawDotPathSegment
	self hasNonDirectoryPath
		ifTrue: [self haveDirectoryPath]! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 05:50'!
addRawDoubleDotPathSegment
	self hasPath
		ifFalse: [^ self].

	self hasRootPath
		ifTrue: [self removeRawPathSegments]
		ifFalse: [| hadAbsolutePath |
			hadAbsolutePath := self hasAbsolutePath.
			self hasDirectoryPath
				ifTrue: [self removeLastRawPathSegment].
			self hasPath
				ifTrue: [
					self removeLastRawPathSegment.
					(self hasPath
						or: [hadAbsolutePath])
						ifTrue: [self haveDirectoryPath]]].! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 05:50'!
addRawPathSegment: aString
	aString = '.'
		ifTrue: [^ self addRawDotPathSegment].
	aString = '..'
		ifTrue: [^ self addRawDoubleDotPathSegment].

	self hasPath
		ifTrue: [
			(self hasDirectoryPath
				and: [self rawPathSegments size > 1])
				ifTrue: [self removeLastRawPathSegment]]
		ifFalse: [
			self hasHost
				ifTrue: [self rawPathSegments addLast: '']].

	self rawPathSegments addLast: aString.! !

!XMLURI methodsFor: 'private' stamp: 'monty 4/2/2016 01:15'!
addRawPathSegmentsFrom: aURI
	"copy before modifying"
	self rawPathSegments: self rawPathSegments copy.

	aURI hasAbsolutePath
		ifTrue: [self removeRawPathSegments]
		ifFalse: [
			self hasNonDirectoryPath
				ifTrue: [
					self removeLastRawPathSegment.
					self hasPath
						ifTrue: [self haveDirectoryPath]]].

	aURI rawPathSegments do: [:each | self addRawPathSegment: each].! !

!XMLURI methodsFor: 'converting' stamp: 'monty 12/27/2017 06:14'!
asRetrievableResource
	^ self isLocal
		ifTrue: [self asXMLFileHandle]
		ifFalse: [self asXMLHTTPRequest]! !

!XMLURI methodsFor: 'converting' stamp: 'monty 4/14/2017 10:05'!
asString
	"Returns the full, untruncated URI string, unlike #printString, which
	may truncate"

	^ self uriString
		ifNil: [| writeStream |
			writeStream := (String new: 64) writeStream.
			self
				printSchemeOn: writeStream;
				printAuthorityPrefixOn: writeStream;
				printAuthorityOn: writeStream;
				printPathPrefixOn: writeStream;
				printPathOn: writeStream;
				printQueryOn: writeStream;
				printFragmentOn: writeStream;
				uriString: writeStream contents;
				uriString]! !

!XMLURI methodsFor: 'converting' stamp: 'monty 12/27/2017 06:14'!
asXMLFileHandle
	self isLocal
		ifFalse: [self errorCannotConvertURIToFileHandle].
	^ self path asXMLFileHandle.! !

!XMLURI methodsFor: 'converting' stamp: 'monty 1/23/2018 19:46'!
asXMLHTTPRequest
	(self isHTTP
		or: [self isHTTPS
			or: [self isRelative]])
		ifFalse: [self errorCannotConvertURIToHTTPRequest].
	^ self asString asXMLHTTPRequest.! !

!XMLURI methodsFor: 'converting' stamp: 'monty 1/10/2014 00:56'!
asXMLURI
	^ self! !

!XMLURI methodsFor: 'combining' stamp: 'monty 3/31/2016 04:18'!
combinedWith: aURIOrURIString
	"Returns the argument URI if it is absolute or the argument resolved in the
	context of the receiver if it is relative, to do relative path resolution
	or replace hosts, query strings, and other components."

	| uriToCombineWith |

	(uriToCombineWith := aURIOrURIString asXMLURI) isEmpty
		ifFalse: [
			(uriToCombineWith isRelative)
				ifTrue: [^ self combinedWithRelativeURI: uriToCombineWith]
				ifFalse: [^ uriToCombineWith]]! !

!XMLURI methodsFor: 'private' stamp: 'monty 4/2/2016 01:14'!
combinedWithRelativeURI: aRelativeURI
	| copy |

	copy := self copy.
	aRelativeURI hasUserInfo
		ifTrue: [
			^ copy
				rawUserInfo: aRelativeURI rawUserInfo;
				rawHost: aRelativeURI rawHost;
				port: aRelativeURI port;
				rawPathSegments: aRelativeURI rawPathSegments;
				rawQuery: aRelativeURI rawQuery;
				rawFragment: aRelativeURI rawFragment].
	aRelativeURI hasHost
		ifTrue: [
			^ copy
				rawHost: aRelativeURI rawHost;
				port: aRelativeURI port;
				rawPathSegments: aRelativeURI rawPathSegments;
				rawQuery: aRelativeURI rawQuery;
				rawFragment: aRelativeURI rawFragment].
	aRelativeURI hasPort
		ifTrue: [
			^ copy
				port: aRelativeURI port;
				rawPathSegments: aRelativeURI rawPathSegments;
				rawQuery: aRelativeURI rawQuery;
				rawFragment: aRelativeURI rawFragment].
	aRelativeURI hasPath
		ifTrue: [
			^ copy
				addRawPathSegmentsFrom: aRelativeURI;
				rawQuery: aRelativeURI rawQuery;
				rawFragment: aRelativeURI rawFragment].
	aRelativeURI hasQuery
		ifTrue: [
			^ copy
				rawQuery: aRelativeURI rawQuery;
				rawFragment: aRelativeURI rawFragment].
	aRelativeURI hasFragment
		ifTrue: [^ copy rawFragment: aRelativeURI rawFragment].! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 01:11'!
copyWithFragment: aString
	^ self copy rawFragment: (self percentEncode: aString)! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 01:11'!
copyWithHost: aString
	| copy |

	copy := self copy.
	(aString size > 0
		and: [aString first == $[
			and: [aString last == $]]])
		ifTrue: [copy rawHost: aString]
		ifFalse: [copy rawHost: (self percentEncode: aString)].
	^ copy.! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 02:23'!
copyWithPath: aString
	| newRawPathSegments |

	newRawPathSegments := self rawPathSegments copyEmpty.
	$/
		xmlSplit: aString
		do: [:each |
			newRawPathSegments addLast: (self percentEncode: each)].
	^ self copy rawPathSegments: newRawPathSegments.! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 01:11'!
copyWithPathSegments: aCollection
	| newRawPathSegments |

	newRawPathSegments := self rawPathSegments copyEmpty.
	aCollection do: [:each |
		newRawPathSegments addLast: (self percentEncode: each)].
	^ self copy rawPathSegments: newRawPathSegments.! !

!XMLURI methodsFor: 'copying' stamp: 'monty 1/3/2016 20:57'!
copyWithPort: anInteger
	^ self copy port: anInteger! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 06:12'!
copyWithQuery: anAssociationCollection
	| newRawQuery |

	newRawQuery := OrderedCollection new: anAssociationCollection size.
	anAssociationCollection associationsDo: [:each |
		newRawQuery addLast:
			(self percentAndPlusEncode: each key) ->
				(self percentAndPlusEncode: each value)].
	^ self copy rawQuery: newRawQuery.! !

!XMLURI methodsFor: 'copying' stamp: 'monty 1/13/2016 10:48'!
copyWithScheme: aString
	^ self copy
		scheme: aString;
		hasAuthorityPrefix:
			(self hasAuthorityPrefix
				or: [self hasScheme not])! !

!XMLURI methodsFor: 'copying' stamp: 'monty 2/12/2017 01:11'!
copyWithUserInfo: aString
	^ self copy rawUserInfo: (self percentEncode: aString)! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/14/2018 00:09'!
errorCannotConvertURIToFileHandle
	XMLFileException
		formatSignal: 'Cannot convert non-local URI to file handle: {1}'
		with: self asString! !

!XMLURI methodsFor: 'private' stamp: 'monty 12/27/2017 06:11'!
errorCannotConvertURIToHTTPRequest
	XMLHTTPException
		formatSignal: 'Cannot convert URI to HTTP request: {1}'
		with: self asString! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 01:11'!
fragment
	"Returns the percent-decoded URI fragment (everything after the '#') or
	an empty string if there isn't one"

	^ self percentDecode: self rawFragment! !

!XMLURI methodsFor: 'retrieving' stamp: 'monty 5/17/2015 00:05'!
get
	^ self asRetrievableResource get! !

!XMLURI methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:39'!
getUpToLimit: aMaxSize decoding: aBoolean
	^ self asRetrievableResource
		getUpToLimit: aMaxSize
		decoding: aBoolean! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/28/2016 01:07'!
hasAbsolutePath
	^ self hasPath
		and: [self rawPathSegments first isEmpty]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 2/9/2015 01:43'!
hasAuthority
	^ self hasUserInfo
		or: [self hasHost
			or: [self hasPort]]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/2/2016 20:45'!
hasAuthorityPrefix
	self parseURIStringIfUnparsed.
	^ hasAuthorityPrefix.! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/3/2016 20:56'!
hasAuthorityPrefix: aBoolean
	hasAuthorityPrefix := aBoolean! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/28/2016 01:07'!
hasDirectoryPath
	^ self hasPath
		and: [self rawPathSegments last isEmpty]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:08'!
hasFragment
	^ self rawFragment notEmpty! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:08'!
hasHost
	^ self rawHost notEmpty! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:34'!
hasIPv6Host
	^ self hasHost
		and: [self rawHost first == $[
			and: [self rawHost last == $]]]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/1/2016 07:24'!
hasNonDirectoryPath
	^ self hasPath
		and: [self hasDirectoryPath not]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/28/2016 01:05'!
hasPath
	^ self rawPathSegments notEmpty! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/1/2016 07:24'!
hasPort
	^ self port notNil! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:08'!
hasQuery
	^ self rawQuery notEmpty! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/28/2016 01:05'!
hasRootPath
	^ self rawPathSegments size = 2
		and: [self rawPathSegments allSatisfy: [:each | each isEmpty]]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/1/2016 07:24'!
hasScheme
	^ self scheme notEmpty! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:09'!
hasUserInfo
	^ self rawUserInfo notEmpty! !

!XMLURI methodsFor: 'comparing' stamp: 'monty 4/15/2017 03:48'!
hash
	"ignores user-info and ports"
	^ ((((self species hash bitXor:
		self scheme hash) bitXor:
			self host hash) bitXor:
				self pathSegments hash) bitXor:
					self query hash) bitXor:
						self fragment hash! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/28/2016 01:06'!
haveDirectoryPath
	self hasPath
		ifFalse: [self rawPathSegments addLast: ''].
	self rawPathSegments addLast: ''.! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 01:11'!
host
	"Returns the percent-decoded host or IPv6-style host or an empty string
	if there isn't one"

	self hasIPv6Host
		ifTrue: [^ self rawHost]
		ifFalse: [^ (self percentDecode: self rawHost) asLowercase]! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/19/2016 13:24'!
isEmpty
	self hasScheme
		ifTrue: [^ false].
	self hasAuthority
		ifTrue: [^ false].
	self hasPath
		ifTrue: [^ false].
	self hasQuery
		ifTrue: [^ false].
	self hasFragment
		ifTrue: [^ false].

	^ true.! !

!XMLURI methodsFor: 'testing' stamp: 'monty 12/27/2017 06:14'!
isFile
	^ self scheme = 'file'! !

!XMLURI methodsFor: 'deprecated' stamp: 'monty 12/27/2017 06:35'!
isFileURI
	"will be deprecated; use #isFile instead"

	^ self isFile! !

!XMLURI methodsFor: 'testing' stamp: 'monty 12/27/2017 06:13'!
isHTTP
	^ self scheme = 'http'! !

!XMLURI methodsFor: 'testing' stamp: 'monty 12/27/2017 06:13'!
isHTTPS
	^ self scheme = 'https'! !

!XMLURI methodsFor: 'testing' stamp: 'monty 12/27/2017 06:20'!
isLocal
	^ self isFile
		or: [self isRelative
			and: [self hasHost not]]! !

!XMLURI methodsFor: 'deprecated' stamp: 'monty 12/27/2017 06:35'!
isLocalURI
	"will be deprecated; use #isLocal instead"

	^ self isLocal! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/6/2016 05:19'!
isRelative
	^ self hasScheme not! !

!XMLURI methodsFor: 'testing' stamp: 'monty 1/7/2016 02:24'!
notEmpty
	^ self isEmpty not! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/28/2016 00:06'!
parseURIStream: aStream
	| parser |

	parser := XMLURIParser on: aStream.
	self
		scheme: parser parseScheme;
		hasAuthorityPrefix: parser parseAuthorityPrefix.
	(self hasScheme
		or: [self hasAuthorityPrefix])
		ifTrue: [
			self
				rawUserInfo: parser parseUserInfo;
				rawHost: parser parseHost;
				port: parser parsePort]
		ifFalse: [
			self
				rawUserInfo: '';
				rawHost: ''].
	self
		rawPathSegments: parser parsePathSegments;
		rawQuery: parser parseQuery;
		rawFragment: parser parseFragment.! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/5/2016 09:05'!
parseURIStringIfUnparsed
	scheme
		ifNil: [self parseURIStream: self uriString readStream]! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 01:11'!
path
	"Returns the percent-decoded path as a string"

	self hasPath
		ifTrue: [| writeStream |
			writeStream := (String new: self rawPathSegments size * 10) writeStream.
			self rawPathSegments
				do: [:each | writeStream nextPutAll: (self percentDecode: each)]
				separatedBy: [writeStream nextPut: $/].
			^ writeStream contents]
		ifFalse: [^ '']! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 01:06'!
pathSegments
	"Returns a temporary OrderedCollection of percent-decoded path segments"

	^ self rawPathSegments collect: [:each | self percentDecode: each]! !

!XMLURI methodsFor: 'enumerating' stamp: 'monty 2/12/2017 01:11'!
pathSegmentsDo: aBlock
	self rawPathSegments do: [:each |
		aBlock value: (self percentDecode: each)]! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/12/2017 01:11'!
percentAndPlusDecode: aString
	| readStream writeStream |

	((aString includes: $%)
		or: [aString includes: $+])
		ifFalse: [^ aString].

	readStream := aString readStream.
	writeStream := (String new: aString size) writeStream.
	[readStream atEnd]
		whileFalse: [
			readStream peek == $%
				ifTrue: [
					self
						percentDecodeNextFrom: readStream
						on: writeStream]
				ifFalse: [| nextChar |
					(nextChar := readStream next) == $+
						ifTrue: [writeStream nextPut: Character space]
						ifFalse: [writeStream nextPut: nextChar]]].
	^ writeStream contents.! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/8/2018 01:21'!
percentAndPlusEncode: aString
	| writeStream |

	writeStream := (String new: aString size) writeStream.
	"to:do: for speed"
	1 to: aString size do: [:i | | nextChar |
		(UnreservedCharacters includes: (nextChar := aString at: i))
			ifTrue: [	
				nextChar asciiValue = 32 "Character space asciiValue"
					ifTrue: [writeStream nextPut: $+]
					ifFalse: [writeStream nextPut: nextChar]]
			ifFalse: [
				(XMLEncodingWriteStreamAdapter on:
					(XMLPercentEncodingWriteStreamAdapter on: writeStream))
						nextPut: nextChar]].
	^ writeStream contents.! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/12/2017 01:11'!
percentDecode: aString
	| readStream writeStream |

	(aString includes: $%)
		ifFalse: [^ aString].

	readStream := aString readStream.
	writeStream := (String new: aString size) writeStream.
	[readStream atEnd]
		whileFalse: [
			readStream peek == $%
				ifTrue: [
					self
						percentDecodeNextFrom: readStream
						on: writeStream]
				ifFalse: [writeStream nextPut: readStream next]].
	^ writeStream contents.! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/8/2018 01:21'!
percentDecodeNextFrom: aReadStream on: aWriteStream
	| readStreamAdapter |

	readStreamAdapter :=
		XMLDecodingReadStreamAdapter
			on: (XMLPercentDecodingReadStreamAdapter on: aReadStream).
	[readStreamAdapter atEnd]
		whileFalse: [aWriteStream nextPut: readStreamAdapter next].! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/8/2018 01:21'!
percentEncode: aString
	| writeStream |

	writeStream := (String new: aString size) writeStream.
	"to:do: for speed"
	1 to: aString size do: [:i | | nextChar |
		(UnreservedCharacters includes: (nextChar := aString at: i))
			ifTrue: [writeStream nextPut: nextChar]
			ifFalse: [
				(XMLEncodingWriteStreamAdapter on:
					(XMLPercentEncodingWriteStreamAdapter on: writeStream))
					nextPut: nextChar]].
	^ writeStream contents.! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 8/20/2016 23:54'!
port
	"Returns the integer port or nil if there isn't one"

	self parseURIStringIfUnparsed.
	^ port.! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/3/2016 20:57'!
port: anInteger
	port := anInteger! !

!XMLURI methodsFor: 'copying' stamp: 'monty 1/15/2016 13:41'!
postCopy
	"the copyWith* methods modify copies, so any URI string of a copy must be parsed
	if it hasn't been already and then cleared because it will be obsolete after a
	URI component is changed"
	self
		parseURIStringIfUnparsed;
		uriString: nil! !

!XMLURI methodsFor: 'printing' stamp: 'monty 1/12/2016 07:29'!
printAuthorityOn: aStream
	self hasAuthority
		ifTrue: [
			self
				printUserInfoOn: aStream;
				printHostOn: aStream;
				printPortOn: aStream]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 1/12/2016 07:50'!
printAuthorityPrefixOn: aStream
	(self hasAuthorityPrefix
		or: [self hasScheme not and: [self hasAuthority]])
		ifTrue: [aStream nextPutAll: '//']! !

!XMLURI methodsFor: 'printing' stamp: 'monty 3/28/2016 00:27'!
printFragmentOn: aStream
	self hasFragment
		ifTrue: [
			aStream
				nextPut: $#;
				nextPutAll: self rawFragment]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 3/28/2016 00:34'!
printHostOn: aStream
	self hasHost
		ifTrue: [aStream nextPutAll: self rawHost]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 4/14/2017 09:56'!
printOn: aStream
	aStream nextPutAll: self asString! !

!XMLURI methodsFor: 'printing' stamp: 'monty 3/28/2016 00:29'!
printPathOn: aStream
	self rawPathSegments
		do: [:each | aStream nextPutAll: each]
		separatedBy: [aStream nextPut: $/]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 1/12/2016 11:22'!
printPathPrefixOn: aStream
	(self hasPath
		and: [self hasAbsolutePath not
			and: [self hasScheme or: [self hasAuthority]]])
		ifTrue: [aStream nextPut: $/]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 1/1/2016 23:53'!
printPortOn: aStream
	self hasPort
		ifTrue: [
			aStream nextPut: $:.
			port printOn: aStream]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 2/12/2017 00:42'!
printQueryOn: aStream
	| atBeginning |

	self hasQuery
		ifFalse: [^ self].
	
	aStream nextPut: $?.
	atBeginning := true.
	self rawQuery do: [:each |
		atBeginning
			ifTrue: [atBeginning := false]
			ifFalse: [aStream nextPut: $&].
		aStream
			nextPutAll: each key;
			nextPut: $=;
			nextPutAll: each value].! !

!XMLURI methodsFor: 'printing' stamp: 'monty 4/17/2017 03:52'!
printSchemeOn: aStream
	self hasScheme
		ifTrue: [
			aStream
				nextPutAll: self scheme;
				nextPut: $:]! !

!XMLURI methodsFor: 'printing' stamp: 'monty 3/28/2016 00:27'!
printUserInfoOn: aStream
	self hasUserInfo
		ifTrue: [
			aStream
				nextPutAll: self rawUserInfo;
				nextPut: $@]! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 01:06'!
query
	"Returns a temporary OrderedCollection of percent/plus-decoded
	query string key=value pairs"

	^ self rawQuery collect: [:each |
		(self percentAndPlusDecode: each key) ->
			(self percentAndPlusDecode: each value)]! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 08:09'!
queryAt: aKey
	"Returns the last percent/plus-decoded value of the query string
	parameter aKey or an empty string if there isn't one"

	^ self
		queryAt: aKey
		ifAbsent: ['']! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 11/12/2017 01:29'!
queryAt: aKey ifAbsent: aBlock
	"Returns the first percent/plus-decoded value of the query string
	parameter aKey or the value of aBlock if there isn't one"

	self rawQuery do: [:each |
		(self percentAndPlusDecode: each key) = aKey
			ifTrue: [^ self percentAndPlusDecode: each value]].
	^ aBlock value.! !

!XMLURI methodsFor: 'testing' stamp: 'monty 3/30/2016 02:09'!
queryIncludesKey: aKey
	self
		queryAt: aKey
		ifAbsent: [^ false].
	^ true.! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 07:38'!
queryKeys
	"Returns a SequenceableCollection of the unique percent/plus-decoded
	query string parameter keys"

	| keys |

	keys := OrderedCollection new: self rawQuery size.
	self queryKeysDo: [:each |
		keys addLast: each].
	^ keys.! !

!XMLURI methodsFor: 'enumerating' stamp: 'monty 2/12/2017 01:11'!
queryKeysAndValuesDo: aTwoArgumentBlock
	self rawQuery do: [:each |
		aTwoArgumentBlock
			value: (self percentAndPlusDecode: each key)
			value: (self percentAndPlusDecode: each value)]! !

!XMLURI methodsFor: 'enumerating' stamp: 'monty 1/22/2018 19:51'!
queryKeysDo: aBlock
	self rawQuery do: [:each |
		aBlock value: (self percentAndPlusDecode: each key)]! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 07:48'!
queryValuesAt: aKey
	"Returns the percent/plus-decoded values of the query string parameter
	aKey or an empty collection if there aren't any"

	^ self
		queryValuesAt: aKey
		ifAbsent: [OrderedCollection new]! !

!XMLURI methodsFor: 'enumerating' stamp: 'monty 2/11/2017 23:56'!
queryValuesAt: aKey do: aBlock
	self queryKeysAndValuesDo: [:key :value |
		key = aKey
			ifTrue: [aBlock value: value]]! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/13/2017 22:28'!
queryValuesAt: aKey ifAbsent: aBlock
	"Returns the percent/plus-decoded values of the query string parameter
	aKey or the value of aBlock if there aren't any"

	| values |

	self
		queryValuesAt: aKey
		do: [:each |
			"only initialize if needed"
			(values ifNil: [values := OrderedCollection new])
				addLast: each].
	^ values ifNil: [aBlock value].! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 01:04'!
rawFragment
	"Returns the raw URI fragment (everything after the '#') without
	percent-decoding or an empty string if there isn't one"

	self parseURIStringIfUnparsed.
	^ rawFragment.! !

!XMLURI methodsFor: 'private' stamp: 'monty 4/2/2016 01:58'!
rawFragment: aString
	rawFragment := aString! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 03:49'!
rawHost
	"Returns the raw host without percent-decoding or the IPv6-style host
	or an empty string if there isn't one"

	self parseURIStringIfUnparsed.
	^ rawHost.! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 01:45'!
rawHost: aString
	rawHost := aString! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 01:05'!
rawPathSegments
	"Returns an OrderedCollection of raw path segments without
	percent-decoding"

	self parseURIStringIfUnparsed.
	^ rawPathSegments.! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 01:45'!
rawPathSegments: aPathSegmentCollection
	rawPathSegments := aPathSegmentCollection! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/15/2017 01:07'!
rawQuery
	"Returns an OrderedCollection of raw query string key=value pairs
	without percent/plus-decoding"

	self parseURIStringIfUnparsed.
	^ rawQuery.! !

!XMLURI methodsFor: 'private' stamp: 'monty 2/12/2017 00:03'!
rawQuery: anOrderedCollection
	rawQuery := anOrderedCollection! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:45'!
rawUserInfo
	self parseURIStringIfUnparsed.
	^ rawUserInfo.! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 01:45'!
rawUserInfo: aString
	rawUserInfo := aString! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 05:48'!
removeLastRawPathSegment
	^ self rawPathSegments removeLast! !

!XMLURI methodsFor: 'private' stamp: 'monty 3/30/2016 05:48'!
removeRawPathSegments
	self rawPathSegments removeAll! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 4/17/2017 03:53'!
scheme
	"Returns the URI scheme or an empty string if there isn't one"

	self parseURIStringIfUnparsed.
	^ scheme.! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/3/2016 20:56'!
scheme: aString
	scheme := aString! !

!XMLURI methodsFor: 'retrieving' stamp: 'monty 5/17/2015 00:05'!
streamGet
	^ self asRetrievableResource streamGet! !

!XMLURI methodsFor: 'retrieving' stamp: 'monty 11/29/2015 22:38'!
streamGetUpToLimit: aMaxSize decoding: aBoolean
	^ self asRetrievableResource
		streamGetUpToLimit: aMaxSize
		decoding: aBoolean! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/3/2016 20:58'!
uriString
	^ uriString! !

!XMLURI methodsFor: 'private' stamp: 'monty 1/3/2016 20:55'!
uriString: aString
	uriString := aString! !

!XMLURI methodsFor: 'accessing' stamp: 'monty 2/12/2017 01:11'!
userInfo
	^ self percentDecode: self rawUserInfo! !

Object subclass: #XMLUnparsedEntityValidator
	instanceVariableNames: 'unparsedEntities notations notationAttributeValidators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-Validation'!

!XMLUnparsedEntityValidator commentStamp: 'monty 1/1/2015 21:00' prior: 0!
Used by attribute validators to validate attribute references to unparsed entities and notations.!

!XMLUnparsedEntityValidator class methodsFor: 'instance creation' stamp: 'monty 11/19/2016 14:07'!
unparsedEntities: anUnparsedEntityDictionary notations: aNotationDictionary
	^ self new
		setUnparsedEntities: anUnparsedEntityDictionary
		notations: aNotationDictionary! !

!XMLUnparsedEntityValidator methodsFor: 'private' stamp: 'monty 4/10/2016 05:24'!
errorMultipleDeclarationsForNotation: aNotation
	XMLValidationException
		formatSignal: 'Multiple declarations for notation "{1}"'
		with: aNotation! !

!XMLUnparsedEntityValidator methodsFor: 'private' stamp: 'monty 1/1/2015 20:45'!
errorMultipleNotationAttributesForElement: anElement
	XMLValidationException
		formatSignal: 'Element <{1}> has multiple NOTATION list attributes'
		with: anElement! !

!XMLUnparsedEntityValidator methodsFor: 'private' stamp: 'monty 7/13/2016 03:05'!
errorUndeclaredNotation: aNotation inAttribute: anAttribute
	XMLValidationException
		formatSignal: 'Undeclared notation "{1}" in NOTATION (...) attribute "{2}"'
		with: aNotation
		with: anAttribute! !

!XMLUnparsedEntityValidator methodsFor: 'private' stamp: 'monty 7/13/2016 03:05'!
errorUndeclaredNotation: aNotation inEntity: anEntity
	XMLValidationException
		formatSignal: 'Undeclared notation "{1}" referenced by <!!ENTITY {2} ...> declaration'
		with: aNotation
		with: anEntity! !

!XMLUnparsedEntityValidator methodsFor: 'private' stamp: 'monty 4/13/2016 06:01'!
errorUndeclaredUnparsedEntityReference: anEntity inAttribute: anAttriubute
	XMLValidationException
		formatSignal: 'Undeclared unparsed entity "{1}" in "{2}" attribute'
		with: anEntity
		with: anAttriubute! !

!XMLUnparsedEntityValidator methodsFor: 'testing' stamp: 'monty 7/13/2016 01:58'!
hasNotationAttributeValidators
	"direct access to avoid lazy initialization"
	^ notationAttributeValidators notNil
		and: [notationAttributeValidators notEmpty]! !

!XMLUnparsedEntityValidator methodsFor: 'accessing' stamp: 'monty 7/13/2016 01:18'!
notationAttributeValidators
	^ notationAttributeValidators ifNil: [notationAttributeValidators := Dictionary new]! !

!XMLUnparsedEntityValidator methodsFor: 'accessing' stamp: 'monty 11/19/2016 14:06'!
notations
	^ notations ifNil: [notations := Dictionary new]! !

!XMLUnparsedEntityValidator methodsFor: 'initialization' stamp: 'monty 11/19/2016 14:07'!
setUnparsedEntities: anUnparsedEntityDictionary notations: aNotationDictionary
	unparsedEntities := anUnparsedEntityDictionary.
	notations := aNotationDictionary.! !

!XMLUnparsedEntityValidator methodsFor: 'accessing' stamp: 'monty 11/19/2016 14:07'!
unparsedEntities
	^ unparsedEntities ifNil: [unparsedEntities := Dictionary new]! !

!XMLUnparsedEntityValidator methodsFor: 'validating' stamp: 'monty 7/13/2016 00:27'!
validateEntityReference: anEntity inAttribute: anAttribute
	(self unparsedEntities includesKey: anEntity)
		ifFalse: [
			self
				errorUndeclaredUnparsedEntityReference: anEntity
				inAttribute: anAttribute]! !

!XMLUnparsedEntityValidator methodsFor: 'validating' stamp: 'monty 11/16/2016 12:06'!
validateNotationAttributeDeclaration: aNotationAttributeValidator
	| oldSize |

	"checking size after is faster than includes:"
	oldSize := self notationAttributeValidators size.
	(self notationAttributeValidators
		at: aNotationAttributeValidator element
		put: aNotationAttributeValidator;
		size) > oldSize
		ifFalse: [
			self errorMultipleNotationAttributesForElement:
				aNotationAttributeValidator element].! !

!XMLUnparsedEntityValidator methodsFor: 'validating' stamp: 'monty 11/19/2016 14:03'!
validateNotationAttributeDeclarationDefaults
	"this validation has to be delayed until the entire DTD
	is processed so notation attributes can be declared before
	the notations referenced in their enumeration list are"
	self notationAttributeValidators valuesDo: [:validator |
		validator allowedValues do: [:each |
			(self notations includesKey: each)
				ifFalse: [
					self
						errorUndeclaredNotation: each
						inAttribute: validator attribute]]]! !

!XMLUnparsedEntityValidator methodsFor: 'validating' stamp: 'monty 11/19/2016 14:06'!
validateUnparsedEntityDeclarations
	"this validation has to be delayed until the entire DTD
	is processed so unparsed entities can be declared before
	the notation they reference are"
	self unparsedEntities valuesDo: [:each |
		(self notations includesKey: each ndata)
			ifFalse: [
				self
					errorUndeclaredNotation: each ndata
					inEntity: each name]]! !

!Stream methodsFor: '*XML-Parser' stamp: 'monty 2/8/2018 00:28'!
isXMLBinaryOrExternalStream
	^ self isBinary! !

!Stream methodsFor: '*XML-Parser' stamp: 'monty 12/11/2014 06:32'!
parseXML
	^ XMLDOMParser parse: self! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/24/2016 20:03'!
isXMLChar
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/25/2016 17:35'!
isXMLNCNameChar
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/25/2016 17:35'!
isXMLNCNameStartChar
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/24/2016 20:03'!
isXMLNameChar
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/24/2016 20:03'!
isXMLNameStartChar
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/12/2016 19:09'!
isXMLSeparator
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!UndefinedObject methodsFor: '*XML-Parser' stamp: 'monty 3/12/2016 19:09'!
isXMLWhitespace
	"hack optimization to avoid testing for nil before sending
	this to objects from streams in XMLParser"
	^ false! !

!Character class methodsFor: '*XML-Parser' stamp: 'monty 3/12/2016 19:10'!
xmlSeparators
	^ String
		with: 32 asCharacter "space"
		with: 10 asCharacter "lf"
		with: 9 asCharacter "tab"
		with: 13 asCharacter "cr"! !

!Character class methodsFor: '*XML-Parser' stamp: 'monty 3/12/2016 19:10'!
xmlWhitespace
	^ self xmlSeparators copyWith: 12 asCharacter "form feed"! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 5/3/2017 20:32'!
isXMLChar
	"Range tests are faster and use less memory than a BitmapCharacterSet, and
	a temp is used because Character in newer SpurVM images has no 'value'
	inst var.
	
	Char ::=
		#x9 | #xA | #xD | [#x20-#xD7FF] | [#xE000-#xFFFD] | [#x10000-#x10FFFF]"

	| tempValue |

	(tempValue := self asciiValue) >= 16r20
		ifTrue: [
			"most chars should be in the range 16r20-16rD7FF"
			tempValue <= 16rD7FF
				ifTrue: [^ true].
	
			tempValue <= 16rFFFD
				ifTrue: [^ tempValue >= 16rE000].
			tempValue >= 16r10000
				ifFalse: [^ false].
			^ tempValue <= 16r10FFFF].

	tempValue == 16r9
		ifTrue: [^ true].
	tempValue == 16rA
		ifTrue: [^ true].
	^ tempValue == 16rD.! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 5/8/2017 16:14'!
isXMLNCNameChar
	"should be the same as isXMLNameChar except without a test for $:"

	| tempValue |

	(tempValue := self asciiValue) <= 16r7A "$z asciiValue hex"
		ifTrue: [
			tempValue >= 16r61 "$a asciiValue hex"
				ifTrue: [^ true].

			tempValue >= 16r41 "$A asciiValue hex"
				ifTrue: [
					tempValue <= 16r5A "$Z asciiValue hex"
						ifTrue: [^ true].
					^ tempValue == 16r5F]. "$_ asciiValue hex"

			tempValue >= 16r30 "$0 asciiValue hex"
				ifTrue: [^ tempValue <= 16r39]. "$9 asciiValue hex; no $: test"

			tempValue == 16r2D "$- asciiValue hex"
				ifTrue: [^ true].
			^ tempValue == 16r2E]. "$. asciiValue hex"

	tempValue <= 16r2040
		ifTrue: [
			tempValue <= 16r36F
				ifTrue: [	
					tempValue <= 16rF6
						ifTrue: [
							tempValue <= 16rD6
								ifFalse: [^ tempValue >= 16rD8].
							tempValue >= 16rC0
								ifTrue: [^ true].
							^ tempValue == 16rB7]
						ifFalse: [
							tempValue <= 16r2FF
								ifTrue: [^ tempValue >= 16rF8].
							^ tempValue >= 16r300]]
				ifFalse: [
					tempValue <= 16r1FFF
						ifTrue: [	
							tempValue <= 16r37D
								ifFalse: [^ tempValue >= 16r37F].
							^ tempValue >= 16r370]
						ifFalse: [
							tempValue <= 16r200D
								ifTrue: [^ tempValue >= 16r200C].
							^ tempValue >= 16r203F]]]
	ifFalse: [
		tempValue <= 16rD7FF
			ifTrue: [
				tempValue >= 16r2C00
					ifTrue: [
						tempValue >= 16r3001
							ifTrue: [^ true].
						^ tempValue <= 16r2FEF]
					ifFalse: [
						tempValue <= 16r218F
							ifFalse: [^ false].
						^ tempValue >= 16r2070]]
			ifFalse: [
				tempValue <= 16rFFFD
					ifTrue: [
						tempValue <= 16rFDCF
							ifTrue: [^ tempValue >= 16rF900].
						^ tempValue >= 16rFDF0]
					ifFalse: [
						tempValue >= 16r10000
							ifFalse: [^ false].
						^ tempValue <= 16rEFFFF]]].! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 5/5/2017 21:12'!
isXMLNCNameStartChar
	"should be the same as isXMLNameStartChar except without a test for $:"

	| tempValue |

	(tempValue := self asciiValue) <= 16r7A "$z asciiValue hex"
		ifTrue: [
			tempValue >= 16r61 "$a asciiValue hex"
				ifTrue: [^ true].

			tempValue <= 16r5A "$Z asciiValue hex"
				ifTrue: [^ tempValue >= 16r41]. "$A asciiValue hex"

			^ tempValue == 16r5F]. "$_ asciiValue hex; no $: test"

	tempValue <= 16r200D
		ifTrue: [
			tempValue <= 16r2FF
				ifTrue: [
					tempValue >= 16rD8
						ifTrue: [
							tempValue >= 16rF8
								ifTrue: [^ true].
							^ tempValue <= 16rF6]
						ifFalse: [
							tempValue >= 16rC0
								ifFalse: [^ false].
							^ tempValue <= 16rD6]]
				ifFalse: [
					tempValue >= 16r37F
						ifTrue: [
							tempValue >= 16r200C
								ifTrue: [^ true].
							^ tempValue <= 16r1FFF]
						ifFalse: [
							tempValue <= 16r37D
								ifFalse: [^ false].
							^ tempValue >= 16r370]]]
	ifFalse: [
		tempValue <= 16rD7FF
			ifTrue: [
				tempValue >= 16r2C00
					ifTrue: [
						tempValue >= 16r3001
							ifTrue: [^ true].
						^ tempValue <= 16r2FEF]
					ifFalse: [
						tempValue <= 16r218F
							ifFalse: [^ false].
						^ tempValue >= 16r2070]]
			ifFalse: [
				tempValue >= 16rFDF0
					ifTrue: [
						tempValue >= 16r10000
							ifTrue: [^ tempValue <= 16rEFFFF].
						^ tempValue <= 16rFFFD]
					ifFalse: [
						tempValue <= 16rFDCF
							ifFalse: [^ false].
						^ tempValue >= 16rF900]]].! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 5/8/2017 16:13'!
isXMLNameChar
	"Range tests are faster and use less memory than a BitmapCharacterSet, and
	a temp is used because Character in newer SpurVM images has no 'value'
	inst var.
	
	NameStartChar ::=
		':' | [A-Z] | '_' | [a-z] | [#xC0-#xD6] | [#xD8-#xF6] | [#xF8-#x2FF] |
		[#x370-#x37D] | [#x37F-#x1FFF] | [#x200C-#x200D] | [#x2070-#x218F] |
		[#x2C00-#x2FEF] | [#x3001-#xD7FF] | [#xF900-#xFDCF] | [#xFDF0-#xFFFD] |
		[#x10000-#xEFFFF]
	NameChar ::=
		NameStartChar | '-' | '.' | [0-9] | #xB7 | [#x0300-#x036F] |
		[#x203F-#x2040]"

	| tempValue |

	(tempValue := self asciiValue) <= 16r7A "$z asciiValue hex"
		ifTrue: [
			tempValue >= 16r61 "$a asciiValue hex"
				ifTrue: [^ true].

			tempValue >= 16r41 "$A asciiValue hex"
				ifTrue: [
					tempValue <= 16r5A "$Z asciiValue hex"
						ifTrue: [^ true].
					^ tempValue == 16r5F]. "$_ asciiValue hex"

			tempValue >= 16r30 "$0 asciiValue hex"
				ifTrue: [
					tempValue <= 16r39 "$9 asciiValue hex"
						ifTrue: [^ true].
					^ tempValue == 16r3A]. "$: asciiValue hex"

			tempValue == 16r2D "$- asciiValue hex"
				ifTrue: [^ true].
			^ tempValue == 16r2E]. "$. asciiValue hex"

	tempValue <= 16r2040
		ifTrue: [
			tempValue <= 16r36F
				ifTrue: [	
					tempValue <= 16rF6
						ifTrue: [
							tempValue <= 16rD6
								ifFalse: [^ tempValue >= 16rD8].
							tempValue >= 16rC0
								ifTrue: [^ true].
							^ tempValue == 16rB7]
						ifFalse: [
							tempValue <= 16r2FF
								ifTrue: [^ tempValue >= 16rF8].
							^ tempValue >= 16r300]]
				ifFalse: [
					tempValue <= 16r1FFF
						ifTrue: [	
							tempValue <= 16r37D
								ifFalse: [^ tempValue >= 16r37F].
							^ tempValue >= 16r370]
						ifFalse: [
							tempValue <= 16r200D
								ifTrue: [^ tempValue >= 16r200C].
							^ tempValue >= 16r203F]]]
	ifFalse: [
		tempValue <= 16rD7FF
			ifTrue: [
				tempValue >= 16r2C00
					ifTrue: [
						tempValue >= 16r3001
							ifTrue: [^ true].
						^ tempValue <= 16r2FEF]
					ifFalse: [
						tempValue <= 16r218F
							ifFalse: [^ false].
						^ tempValue >= 16r2070]]
			ifFalse: [
				tempValue <= 16rFFFD
					ifTrue: [
						tempValue <= 16rFDCF
							ifTrue: [^ tempValue >= 16rF900].
						^ tempValue >= 16rFDF0]
					ifFalse: [
						tempValue >= 16r10000
							ifFalse: [^ false].
						^ tempValue <= 16rEFFFF]]].! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 5/5/2017 17:15'!
isXMLNameStartChar
	"Range tests are faster and use less memory than a BitmapCharacterSet, and
	a temp is used because Character in newer SpurVM images has no 'value'
	inst var.
	
	NameStartChar ::=
		':' | [A-Z] | '_' | [a-z] | [#xC0-#xD6] | [#xD8-#xF6] | [#xF8-#x2FF] |
		[#x370-#x37D] | [#x37F-#x1FFF] | [#x200C-#x200D] | [#x2070-#x218F] |
		[#x2C00-#x2FEF] | [#x3001-#xD7FF] | [#xF900-#xFDCF] | [#xFDF0-#xFFFD] |
		[#x10000-#xEFFFF]"

	| tempValue |

	(tempValue := self asciiValue) <= 16r7A "$z asciiValue hex"
		ifTrue: [
			tempValue >= 16r61 "$a asciiValue hex"
				ifTrue: [^ true].

			tempValue >= 16r41 "$A asciiValue hex"
				ifTrue: [
					tempValue <= 16r5A "$Z asciiValue hex"
						ifTrue: [^ true].
					^ tempValue == 16r5F]. "$_ asciiValue hex"
	
			^ tempValue == 16r3A]. "$: asciiValue hex"

	tempValue <= 16r200D
		ifTrue: [
			tempValue <= 16r2FF
				ifTrue: [
					tempValue >= 16rD8
						ifTrue: [
							tempValue >= 16rF8
								ifTrue: [^ true].
							^ tempValue <= 16rF6]
						ifFalse: [
							tempValue >= 16rC0
								ifFalse: [^ false].
							^ tempValue <= 16rD6]]
				ifFalse: [
					tempValue >= 16r37F
						ifTrue: [
							tempValue >= 16r200C
								ifTrue: [^ true].
							^ tempValue <= 16r1FFF]
						ifFalse: [
							tempValue <= 16r37D
								ifFalse: [^ false].
							^ tempValue >= 16r370]]]
	ifFalse: [
		tempValue <= 16rD7FF
			ifTrue: [
				tempValue >= 16r2C00
					ifTrue: [
						tempValue >= 16r3001
							ifTrue: [^ true].
						^ tempValue <= 16r2FEF]
					ifFalse: [
						tempValue <= 16r218F
							ifFalse: [^ false].
						^ tempValue >= 16r2070]]
			ifFalse: [
				tempValue >= 16rFDF0
					ifTrue: [
						tempValue >= 16r10000
							ifTrue: [^ tempValue <= 16rEFFFF].
						^ tempValue <= 16rFFFD]
					ifFalse: [
						tempValue <= 16rFDCF
							ifFalse: [^ false].
						^ tempValue >= 16rF900]]].! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 10:56'!
isXMLSeparator
	"a temp is used because Character in newer SpurVM images
	has no 'value' inst var"
	| tempValue |

	(tempValue := self asciiValue) == 32 "space"
		ifTrue: [^ true].
	tempValue == 10 "line feed"
		ifTrue: [^ true].
	tempValue == 9 "tab"
		ifTrue: [^ true].
	^ tempValue == 13. "carriage return; no form feeds"! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 10:56'!
isXMLWhitespace
	"a temp is used because Character in newer SpurVM images
	has no 'value' inst var"
	| tempValue |

	(tempValue := self asciiValue) == 32 "space"
		ifTrue: [^ true].
	tempValue == 10 "line feed"
		ifTrue: [^ true].
	tempValue == 9 "tab"
		ifTrue: [^ true].
	tempValue == 13 "carriage return"
		ifTrue: [^ true].
	^ tempValue == 12. "form feed"! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 3/25/2016 02:03'!
xmlSplit: aString
	"faster, portable version"
	| parts |

	parts := OrderedCollection new.
	self
		xmlSplit: aString
		do: [:each | parts addLast: each].
	^ parts.! !

!Character methodsFor: '*XML-Parser' stamp: 'monty 4/28/2017 10:58'!
xmlSplit: aString do: aBlock
	"faster, portable version"
	| start |

	start := 1.
	1 to: aString size do: [:end |
		"avoid #== for compatibility with pre-Spur VMs where wide chars
		aren't an immediate type"
		(aString at: end) = self
			ifTrue: [
				aBlock value: (aString copyFrom: start to: end - 1).
				start := end + 1]].
	start > aString size
		ifTrue: [
			"either aString is empty or it ends with self"
			aBlock value: '']
		ifFalse: [aBlock value: (aString copyFrom: start to: aString size)].! !

XMLURI initialize!

XMLAttributeValidator initialize!

XMLWriteStreamAdapter initialize!

XMLAbstractFactory initialize!

XMLNullReadStream initialize!

XMLNestedStreamReader initialize!

DTDCachingExternalEntityResolver initialize!

DTDElementContentModelParser initialize!

XMLStreamConverter initialize!

XMLLazyAttributeDictionary initialize!

XMLLazyNamespacedAttributeDictionary initialize!

XMLIntegerReader initialize!

XMLSmallIntegerReader initialize!

XMLHTTPMIMETypeParser initialize!

XMLURIParser initialize!

XMLParserTokenizer initialize!

XMLWellFormedParserTokenizer initialize!

XMLEncodingDetector initialize!
